#include "assignpage.h"
#include "myglcanvas.h"
#include "mynotebook.h"

BEGIN_EVENT_TABLE(myAssign, wxComboBox)
	EVT_COMBOBOX(ON_MY_ASSIGN_ID, myAssign::OnSelect)
END_EVENT_TABLE()

myAssign::myAssign(wxWindow* parent) : wxComboBox(parent, ON_MY_ASSIGN_ID, wxT(""), wxDefaultPosition, wxSize(80, -1), 0, NULL, wxCB_READONLY) {
	apage = (AssignPage*) parent;
	select = 0;
	SetProperties();
}

void myAssign::SetProperties() {
//	SetSize(80, -1);
}

void myAssign::SetSelect(int cselect) {
	SetSelection(cselect);	
	select = cselect;
}

void myAssign::OnSelect(wxCommandEvent& event) {
	if(GetSelection() == -1) {
		SetSelection(select);	
	} else {
		select = GetSelection();	
	}
	apage->MakeDeadlyLists();
}

AssignPage::AssignPage(wxWindow* parent, MotionPage *cpage)
	 : wxScrolledWindow(parent, -1) {
	page = cpage;
	max_assigns = 38;
	SetProperties();
	DoLayout();
}

void AssignPage::SetProperties() {
	SetScrollRate(10,10);
	int i;
	for (i = 0; i < max_assigns; i++) {
		myAssign *assign = new myAssign(this);
		assigns.Add(assign);
		MakeComboList(i);
	}

	for (i = 0; i < max_assigns; i++) {
		myLabel *label = new myLabel(this, 60);
		labels.Add(label);
	}

	labels[0]->SetLabel(wxT(" : "));
	labels[1]->SetLabel(wxT("ꥺ : "));
	labels[2]->SetLabel(wxT("ư : "));
	labels[3]->SetLabel(wxT("ư : "));
	labels[4]->SetLabel(wxT("ư : "));
	labels[5]->SetLabel(wxT("ư : "));
	labels[6]->SetLabel(wxT("ʢ : "));
	labels[7]->SetLabel(wxT("ƴ : "));
	labels[8]->SetLabel(wxT("ʢ : "));
	labels[9]->SetLabel(wxT(" : "));
	labels[10]->SetLabel(wxT("+̵ : "));
	labels[11]->SetLabel(wxT("+ : "));
	labels[12]->SetLabel(wxT("+ : "));
	labels[13]->SetLabel(wxT("+ : "));
	labels[14]->SetLabel(wxT("+ : "));
	labels[15]->SetLabel(wxT("+ : "));
	labels[16]->SetLabel(wxT("+ : "));
	labels[17]->SetLabel(wxT("+ : "));
	labels[18]->SetLabel(wxT("+ : "));
	labels[19]->SetLabel(wxT("+̵ : "));
	labels[20]->SetLabel(wxT("+ : "));
	labels[21]->SetLabel(wxT("+ : "));
	labels[22]->SetLabel(wxT("+ : "));
	labels[23]->SetLabel(wxT("+ : "));
	labels[24]->SetLabel(wxT("+ : "));
	labels[25]->SetLabel(wxT("+ : "));
	labels[26]->SetLabel(wxT("+ : "));
	labels[27]->SetLabel(wxT("+ : "));
	labels[28]->SetLabel(wxT("ɸ+̵ : "));
	labels[29]->SetLabel(wxT("ɸ+ : "));
	labels[30]->SetLabel(wxT("ɸ+ : "));
	labels[31]->SetLabel(wxT("ɸ+ : "));
	labels[32]->SetLabel(wxT("ɸ+ : "));
	labels[33]->SetLabel(wxT("ɸ+ : "));
	labels[34]->SetLabel(wxT("ɸ+ : "));
	labels[35]->SetLabel(wxT("ɸ+ : "));
	labels[36]->SetLabel(wxT("ɸ+ : "));
	labels[37]->SetLabel(wxT(" : "));

	deadly1 = new wxComboBox(this, -1, wxT(""), wxDefaultPosition, wxSize(80, -1), 0, NULL, wxCB_READONLY);
	deadly2 = new wxComboBox(this, -1, wxT(""), wxDefaultPosition, wxSize(80, -1), 0, NULL, wxCB_READONLY);
	deadly3 = new wxComboBox(this, -1, wxT(""), wxDefaultPosition, wxSize(80, -1), 0, NULL, wxCB_READONLY);
	deadly4 = new wxComboBox(this, -1, wxT(""), wxDefaultPosition, wxSize(80, -1), 0, NULL, wxCB_READONLY);
	deadly1->SetSelection(0);
	deadly2->SetSelection(0);
	deadly3->SetSelection(0);
	deadly4->SetSelection(0);
}

void AssignPage::DoLayout() {
	int i;
    wxBoxSizer *tsizer = new wxBoxSizer(wxVERTICAL);

    wxStaticBoxSizer *bsizer1 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ܤȥꥺ")), wxVERTICAL);
    wxStaticBoxSizer *bsizer2 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ư")), wxVERTICAL);
    wxStaticBoxSizer *bsizer3 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("᡼")), wxVERTICAL);
    wxStaticBoxSizer *bsizer4 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("")), wxVERTICAL);
	wxStaticBoxSizer *bsizer5 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("")), wxVERTICAL);
    wxStaticBoxSizer *bsizer6 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ɸ")), wxVERTICAL);
    wxStaticBoxSizer *bsizer7 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("")), wxVERTICAL);
    wxStaticBoxSizer *bsizer8 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ɬӥ͡")), wxVERTICAL);

    wxGridSizer *gsizer1 = new wxGridSizer(1, 4, 0, 0);
    wxGridSizer *gsizer2 = new wxGridSizer(2, 4, 0, 0);
    wxGridSizer *gsizer3 = new wxGridSizer(2, 4, 0, 0);
    wxGridSizer *gsizer4 = new wxGridSizer(5, 4, 0, 0);
    wxGridSizer *gsizer5 = new wxGridSizer(5, 4, 0, 0);
    wxGridSizer *gsizer6 = new wxGridSizer(5, 4, 0, 0);
    wxGridSizer *gsizer7 = new wxGridSizer(1, 4, 0, 0);
    wxGridSizer *gsizer8 = new wxGridSizer(1, 4, 0, 0);
 
	bsizer1->Add(gsizer1, 0, wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 0);
	bsizer2->Add(gsizer2, 0, wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 0);
	bsizer3->Add(gsizer3, 0, wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 0);
	bsizer4->Add(gsizer4, 0, wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 0);
	bsizer5->Add(gsizer5, 0, wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 0);
	bsizer6->Add(gsizer6, 0, wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 0);
	bsizer7->Add(gsizer7, 0, wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 0);
	bsizer8->Add(gsizer8, 0, wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 0);

	tsizer->Add(bsizer1, 0, wxALL, 5);
	tsizer->Add(bsizer2, 0, wxALL, 5);
	tsizer->Add(bsizer3, 0, wxALL, 5);
	tsizer->Add(bsizer4, 0, wxALL, 5);
	tsizer->Add(bsizer5, 0, wxALL, 5);
	tsizer->Add(bsizer6, 0, wxALL, 5);
	tsizer->Add(bsizer7, 0, wxALL, 5);
	tsizer->Add(bsizer8, 0, wxALL, 5);

	for (i = 0; i < 2; i++) {
		gsizer1->Add(labels[i], 0, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxLEFT, 3);
		gsizer1->Add(assigns[i], 0, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxRIGHT, 3);
	}
	for (i = 2; i < 6; i++) {
		gsizer2->Add(labels[i], 0, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxLEFT, 3);
		gsizer2->Add(assigns[i], 0, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxRIGHT, 3);
	}
	for (i = 6; i < 10; i++) {
		gsizer3->Add(labels[i], 0, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxLEFT, 3);
		gsizer3->Add(assigns[i], 0, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxRIGHT, 3);
	}

	gsizer4->Add(labels[10], 0, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxLEFT, 3);
	gsizer4->Add(assigns[10], 0, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxRIGHT, 3);
	gsizer4->Add(50, 20, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxRIGHT, 3);
	gsizer4->Add(50, 20, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxRIGHT, 3);
	for (i = 11; i < 19; i++) {
		gsizer4->Add(labels[i], 0, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxLEFT, 3);
		gsizer4->Add(assigns[i], 0, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxRIGHT, 3);
	}

	gsizer5->Add(labels[19], 0, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxLEFT, 3);
	gsizer5->Add(assigns[19], 0, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxRIGHT, 3);
	gsizer5->Add(50, 20, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxRIGHT, 3);
	gsizer5->Add(50, 20, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxRIGHT, 3);
	for (i = 20; i < 28; i++) {
		gsizer5->Add(labels[i], 0, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxLEFT, 3);
		gsizer5->Add(assigns[i], 0, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxRIGHT, 3);
	}

	gsizer6->Add(labels[28], 0, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxLEFT, 3);
	gsizer6->Add(assigns[28], 0, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxRIGHT, 3);
	gsizer6->Add(50, 20, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxRIGHT, 3);
	gsizer6->Add(50, 20, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxRIGHT, 3);
	for (i = 29; i < 37; i++) {
		gsizer6->Add(labels[i], 0, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxLEFT, 3);
		gsizer6->Add(assigns[i], 0, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxRIGHT, 3);
	}

	gsizer7->Add(labels[37], 0, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxLEFT, 3);
	gsizer7->Add(assigns[37], 0, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxRIGHT, 3);

	gsizer8->Add(deadly1, 0, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxRIGHT, 3);
	gsizer8->Add(deadly2, 0, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxRIGHT, 3);
	gsizer8->Add(deadly3, 0, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxRIGHT, 3);
	gsizer8->Add(deadly4, 0, wxGROW | wxALIGN_CENTRE_VERTICAL | wxTOP | wxBOTTOM | wxRIGHT, 3);

  	SetSizer(tsizer);
 	tsizer->SetVirtualSizeHints(this);
	FitInside();
	Layout();
}


void AssignPage::MakeComboList(int number) {
	int j;
	myAssign *q = assigns[number];
	q->Clear();
	for (j = 0; j < (int)page->infos.GetCount(); j++) {
		q->Append(page->infos[j].name);
	}
	if (q->GetCount() > q->select) {
		q->SetSelection(q->select);		
	} else {
		q->select = 0;
		q->SetSelection(0);		
	}
}

void AssignPage::MakeComboLists() {
	int i;
	for (i = 0; i < MaxAssign(); i++) {
		MakeComboList(i);
	}
	MakeDeadlyLists();  
}

void AssignPage::MakeDeadlyLists() {
	int i, save_select1, save_select2, save_select3, save_select4;
	save_select1 = deadly1->GetSelection();
	save_select2 = deadly2->GetSelection();
	save_select3 = deadly3->GetSelection();
	save_select4 = deadly4->GetSelection();	 
	deadly1->Clear();
	deadly2->Clear();
	deadly3->Clear();
	deadly4->Clear();
	deadly1->Append(wxT("̵"));
	deadly2->Append(wxT("̵"));
	deadly3->Append(wxT("̵"));
	deadly4->Append(wxT("̵"));
 	for (i = 10; i < MaxAssign(); i++) {
		 deadly1->Append(assigns[i]->GetStringSelection());
		 deadly2->Append(assigns[i]->GetStringSelection());
		 deadly3->Append(assigns[i]->GetStringSelection());
		 deadly4->Append(assigns[i]->GetStringSelection());
	}  
	deadly1->SetSelection(save_select1);
	deadly2->SetSelection(save_select2);
	deadly3->SetSelection(save_select3);
	deadly4->SetSelection(save_select4);
}


bool AssignPage::Save(wxTextOutputStream &out) {
	int i;
	wxString str;
	out << wxT("#Assign Data") << endl;
	out << wxT("#Max Assign") << endl;
	out << MaxAssign() << endl;;
	for (i = 0; i < MaxAssign(); i++) {
		myAssign *q = assigns[i];
		str.Printf("#Assign No.%d", i);
		out << str << endl;
		out << q->select << endl;
	}

	out << wxT("#Assign Deadly 1")  << endl;
	out << deadly1->GetSelection() << endl;
	out << wxT("#Assign Deadly 2")  << endl;
	out << deadly2->GetSelection() << endl;
	out << wxT("#Assign Deadly 3")  << endl;
	out << deadly3->GetSelection() << endl;
	out << wxT("#Assign Deadly 4")  << endl;
	out << deadly4->GetSelection() << endl;

	return true;
}
/*
bool AssignPage::LoadOld(wxTextInputStream &in) {
	int i, num, max;
	wxString str;

	str = in.ReadLine();
	str = in.ReadLine();
	in >> max;

	if (max != 37) {
		wxLogError("Ƥο۾Ǥ");
		return false;
	}

	for (i = 0; i < max; i++) {
		myAssign *q = assigns[i];
		str = in.ReadLine();
		in >> num;
		q->SetSelect(num);
	}
	
	str = in.ReadLine();
	in >> num;
	deadly1->SetSelection(num);
	str = in.ReadLine();
	in >> num;
	deadly2->SetSelection(num);
	str = in.ReadLine();
	in >> num;
	deadly3->SetSelection(num);
	str = in.ReadLine();
	in >> num;
	deadly4->SetSelection(num);

	return true;
}
*/
bool AssignPage::Load(wxTextInputStream &in) {
	int i, num, max;
	wxString str;

	str = in.ReadLine();
	str = in.ReadLine();
	in >> max;

	if (max != 38) {
		wxLogError("Ƥο۾Ǥ");
		return false;
	}

	for (i = 0; i < max; i++) {
		myAssign *q = assigns[i];
		str = in.ReadLine();
		in >> num;
		q->SetSelect(num);
	}
	
	str = in.ReadLine();
	in >> num;
	deadly1->SetSelection(num);
	str = in.ReadLine();
	in >> num;
	deadly2->SetSelection(num);
	str = in.ReadLine();
	in >> num;
	deadly3->SetSelection(num);
	str = in.ReadLine();
	in >> num;
	deadly4->SetSelection(num);

	return true;
}
