#ifndef	ASSIGNPAGE_H
#define ASSIGNPAGE_H

#include <wx/wx.h>
#include <wx/tglbtn.h>
#include <wx/textctrl.h>
#include <wx/combobox.h>
#include <wx/wfstream.h>
#include <wx/txtstrm.h>
#include <wx/slider.h>

#include "motionpage.h"
#include "mylabel.h"

class AssignPage;
class ThinkPage;

class myAssign : public wxComboBox {
public:
	myAssign(wxWindow* parent);
    void SetSelect(int cselect);
private:
    void SetProperties();
    void OnSelect(wxCommandEvent& event);

	int select;
	AssignPage *apage;
	friend class AssignPage; 
	DECLARE_EVENT_TABLE()
};

WX_DEFINE_ARRAY(myAssign*, myAssigns);

enum {
	ON_MY_ASSIGN_ID
};

class AssignPage : public wxScrolledWindow {
public:
	AssignPage(wxWindow* parent, MotionPage *cpage);
	int MaxAssign() const {return max_assigns;}
	void MakeComboList(int number);
	void MakeComboLists();
	void MakeDeadlyLists();
	bool Save(wxTextOutputStream &out);
	bool Load(wxTextInputStream &in);
//	bool LoadOld(wxTextInputStream &in);
private:
    void SetProperties();
    void DoLayout();
 
 	int max_assigns;
	myAssigns assigns;
	wxComboBox *deadly1, *deadly2, *deadly3, *deadly4; 
	myLabels labels;
	MotionPage* page;
	friend class ThinkPage;
};

#endif // ASSIGNPAGE_H
