#include "camerapage.h"
#include "myglcanvas.h"
#include "boxer.h"

myCamera::myCamera(wxWindow *parent,int cnumber) : wxToggleButton(parent, -1, wxT("test")) {
	wxString name;
	name.Printf("CAMERA %d", cnumber);
	SetLabel(name);
	SetProperties();
	DoLayout();
}

void myCamera::SetProperties() {
}

void myCamera::DoLayout() {
}

BEGIN_EVENT_TABLE(CameraPage, wxScrolledWindow)
	EVT_BUTTON(ON_ADD_CAMERA_ID, CameraPage::OnAdd) 
	EVT_BUTTON(ON_DEL_CAMERA_ID, CameraPage::OnDel)
	EVT_TEXT(ON_CAMERA_NAME_ID, CameraPage::OnCameraName)  
	EVT_TOGGLEBUTTON(-1, CameraPage::OnToggle) 
	EVT_BUTTON(ON_SET_ORIGIN_ID, CameraPage::OnSetOrigin)
	EVT_BUTTON(ON_ZOOM_IN_ID, CameraPage::OnZoomIn)
	EVT_BUTTON(ON_ZOOM_OUT_ID, CameraPage::OnZoomOut)
	EVT_SLIDER(ON_ZOOM_BAR_ID, CameraPage::OnZoomBar)
END_EVENT_TABLE()

CameraPage::CameraPage(wxWindow* parent, myGLCanvas *ccanvas) : wxScrolledWindow(parent, -1) {
	canvas = ccanvas;
	max_cameras = 1;
	select_camera = 0;
	SetProperties();
	DoLayout();

}

void CameraPage::SetProperties() {
	int i;

	SetScrollRate(10,10);
	for (i = 0; i < max_cameras; i++) {
		myCamera *camera = new myCamera(this, i);			
		cameras.Add(camera);
	}
	cameras[0]->SetValue(true); 
 
	angle = new mySlider(this, canvas, wxT("Angle : "), 0, 180);
	znear = new mySlider(this, canvas, wxT("Near : "), 10, 10000);
	zfar = new mySlider(this, canvas, wxT("Far : "), 1000, 30000);
	angle->SetValue(60);
	znear->SetValue(10);
	zfar->SetValue(20000);

	add_camera = new wxButton(this, ON_ADD_CAMERA_ID, wxT(""));
	del_camera = new wxButton(this, ON_DEL_CAMERA_ID, wxT(""));	
	name_text = new wxTextCtrl(this, ON_CAMERA_NAME_ID, wxT(""));//, wxDefaultPosition, wxDefaultSize, wxTE_RICH);
	name_text->SetValue(GetCamera()->GetLabel());

	pos_x = new mySlider(this, canvas, wxT("X : "), -10000, 10000);
	pos_y = new mySlider(this, canvas, wxT("Y : "), -10000, 10000);
	pos_z = new mySlider(this, canvas, wxT("Z : "), -10000, 10000);
	pos_x->SetValue(-1000);
	pos_y->SetValue(1000);
	pos_z->SetValue(1000);
	dir_x = new mySlider(this, canvas, wxT("X : "), -10000, 10000);
	dir_y = new mySlider(this, canvas, wxT("Y : "), -10000, 10000);
	dir_z = new mySlider(this, canvas, wxT("Z : "), -10000, 10000);
	dir_x->SetValue(0);
	dir_y->SetValue(0);
	dir_z->SetValue(0);
	rot = new mySlider(this, canvas, wxT(" : "), 0, 359);	
	rot->SetValue(0);

	set_origin = new wxButton(this, ON_SET_ORIGIN_ID, wxT("˥å"));
	back_view = new wxToggleButton(this, ON_BACK_VIEW_ID, wxT("ܥظ"));
	boxer_view = new wxToggleButton(this, ON_BOXER_VIEW_ID, wxT("ܥ"));
	zoom_in = new wxButton(this, ON_ZOOM_IN_ID, wxT("।"));
	zoom_out = new wxButton(this, ON_ZOOM_OUT_ID, wxT("ॢ"));
	zoom_bar = new wxSlider(this, ON_ZOOM_BAR_ID, 1, 1000, 10000);
	zoom_bar->SetSize(150, 20);	
	SaveCamera();
}

void CameraPage::DoLayout() {
	int i;
    tsizer = new wxBoxSizer(wxVERTICAL);
	gsizer = new wxGridSizer(max_cameras/3, 3, 0, 0);

    wxStaticBoxSizer *sizer1 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("Ʃ")), wxVERTICAL);
	wxStaticBoxSizer *sizer2 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("")), wxVERTICAL);
    wxStaticBoxSizer *hsizer = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ɲäȺ")), wxHORIZONTAL);
 
	wxStaticBoxSizer *sizer1c = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("")), wxVERTICAL);
  	wxStaticBoxSizer *sizer2c = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("")), wxVERTICAL);
  	wxStaticBoxSizer *sizer3c = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ž")), wxVERTICAL);
  	wxStaticBoxSizer *sizer4c = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("")), wxHORIZONTAL);
  	wxStaticBoxSizer *sizer5c = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("")), wxHORIZONTAL);

	tsizer->Add(sizer1, 0, wxALIGN_CENTRE_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 5);
	tsizer->Add(sizer2, 0, wxALIGN_CENTRE_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 5);

	tsizer->Add(sizer1c, 0, wxALIGN_CENTRE_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 5);
	tsizer->Add(sizer2c, 0, wxALIGN_CENTRE_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 5);
	tsizer->Add(sizer3c, 0, wxALIGN_CENTRE_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 5);
	tsizer->Add(sizer4c, 0, wxALIGN_CENTRE_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 5);
   	tsizer->Add(sizer5c, 0, wxALIGN_CENTRE_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 5);

	sizer1->Add(angle, 0, wxGROW | wxALIGN_CENTER_VERTICAL);
	sizer1->Add(znear, 0, wxGROW | wxALIGN_CENTER_VERTICAL);
	sizer1->Add(zfar,  0, wxGROW | wxALIGN_CENTER_VERTICAL);

	sizer2->Add(gsizer, 0, wxALIGN_CENTRE_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 5);
	sizer2->Add(hsizer, 0, wxALIGN_CENTRE_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 5);

	for (i = 0; i < max_cameras; i++) {
		gsizer->Add(cameras[i],  0, wxGROW | wxALIGN_CENTRE_VERTICAL | wxALL, 5);
	}
	hsizer->Add(name_text,  0, wxALIGN_CENTRE_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 5);
	hsizer->Add(add_camera, 0, wxALIGN_CENTRE_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 5);
	hsizer->Add(del_camera, 0, wxALIGN_CENTRE_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 5);

	sizer1c->Add(pos_x, 0, wxGROW | wxALIGN_CENTER_VERTICAL);
	sizer1c->Add(pos_y, 0, wxGROW | wxALIGN_CENTER_VERTICAL);
	sizer1c->Add(pos_z, 0, wxGROW | wxALIGN_CENTER_VERTICAL);

	sizer2c->Add(dir_x, 0, wxGROW | wxALIGN_CENTER_VERTICAL);
	sizer2c->Add(dir_y, 0, wxGROW | wxALIGN_CENTER_VERTICAL);
	sizer2c->Add(dir_z, 0, wxGROW | wxALIGN_CENTER_VERTICAL);

	sizer3c->Add(rot, 0, wxGROW | wxALIGN_CENTER_VERTICAL);

	sizer4c->Add(set_origin, 0, wxGROW | wxALIGN_CENTER_VERTICAL);
	sizer4c->Add(back_view,  0, wxGROW | wxALIGN_CENTER_VERTICAL);
	sizer4c->Add(boxer_view, 0, wxGROW | wxALIGN_CENTER_VERTICAL);

	sizer5c->Add(zoom_in,  0, wxGROW | wxALIGN_CENTER_VERTICAL);
	sizer5c->Add(zoom_out, 0, wxGROW | wxALIGN_CENTER_VERTICAL);
	sizer5c->Add(zoom_bar, 0, wxGROW | wxALIGN_CENTER_VERTICAL);

  	SetSizer(tsizer);
    ReLayout();
}

void CameraPage::ReLayout() {
 	tsizer->SetVirtualSizeHints(this);
//	FitInside();
	Layout();
}

void CameraPage::Add() {
	int i;
	for (i = 0; i < MaxCamera(); i++) {
		gsizer->Remove(cameras[i]);	
	}
	SaveCamera();
	myCamera *camera = new myCamera(this, max_cameras);
	camera->cam = GetCamera()->cam;
	camera->boxer_view = GetCamera()->boxer_view;
	camera->back_view = GetCamera()->back_view;

	cameras.Insert(camera, SelectCamera());
	select_camera++;
	max_cameras++;
	gsizer->SetRows(max_cameras/3);
	for (i = 0; i < MaxCamera(); i++) {
		gsizer->Add(cameras[i],  0, wxGROW |wxALIGN_CENTRE_VERTICAL | wxALL, 5);
	}    
	LoadCamera();
}

void CameraPage::OnAdd(wxCommandEvent &event) {
	Add();
	ReLayout();
}		

void CameraPage::Del() {
	if (max_cameras < 2) {
		return;	
	}
	myCamera *camera = GetCamera();
	max_cameras--;
	gsizer->Remove(camera);
	cameras.Remove(camera);
	delete camera;	
	gsizer->SetRows(max_cameras/3);
	if (select_camera >= MaxCamera() && MaxCamera()) {
		select_camera--;	
	}
	GetCamera()->SetValue(true);
	name_text->SetValue(GetCamera()->GetLabel());
	LoadCamera();	 
}

void CameraPage::OnDel(wxCommandEvent &event) {
	Del();
	ReLayout();
	Refresh();
	canvas->Refresh();
}

void CameraPage::OnCameraName(wxCommandEvent &event) {
	GetCamera()->SetLabel(name_text->GetValue());	
}		

void CameraPage::SetSelectCamera(int new_select) {
	cameras[new_select]->SetValue(true);

	if (new_select != SelectCamera()){
		SaveCamera();
		GetCamera()->SetValue(false);

		select_camera = new_select;
		LoadCamera();
		name_text->SetValue(GetCamera()->GetLabel());	
	}	
	ReLayout();
	canvas->Refresh();
}

void CameraPage::OnToggle(wxCommandEvent &event){
	int i, new_select = 0;
	wxObject *obj = event.GetEventObject();

	for (i = 0; i < max_cameras; i++) {
		if(obj == (wxObject*) cameras[i]) {
			new_select = i;
			SetSelectCamera(new_select);
			break;
		}
	}
	if (obj == (wxObject*) boxer_view) {
		OnBoxerView();		
	}
	if (obj == (wxObject*) back_view) {
		OnBackView();		
	}
}

void CameraPage::SetOrigin(Boxer &boxer){
	pos_x->SetValueF(boxer.X() + 1.2, 1000); 
	pos_y->SetValueF(boxer.Y() + 1.2, 1000); 
	pos_z->SetValueF(boxer.OffSetZ() - 0.3, 1000);
	dir_x->SetValueF(boxer.X(), 1000);
	dir_y->SetValueF(boxer.Y(), 1000);
	dir_z->SetValueF(boxer.OffSetZ(), 1000);
	rot->SetValue(0);
}

void CameraPage::SetCamera(GLCamera &glcamera, int i){
    glcamera.DefPosition(
		pos_x->GetValueF(1000), 
		pos_y->GetValueF(1000), 
		pos_z->GetValueF(1000));
    glcamera.DefDirection(
		dir_x->GetValueF(1000), 
		dir_y->GetValueF(1000), 
		dir_z->GetValueF(1000));
	glcamera.DefRotation(rot->GetValue());
}


void CameraPage::OnZoomIn(wxCommandEvent& event) {
	int px, py, pz, dx, dy, dz;
	px = pos_x->GetValue();
	py = pos_y->GetValue();
	pz = pos_z->GetValue();
	dx = dir_x->GetValue();
	dy = dir_y->GetValue();
	dz = dir_z->GetValue();
	px = px - (px - dx) /2;
	py = py - (py - dy) /2;
	pz = pz - (pz - dz) /2;
	pos_x->SetValue(px);
	pos_y->SetValue(py);
	pos_z->SetValue(pz);	
	canvas->Refresh();
}

void CameraPage::OnZoomOut(wxCommandEvent& event) {
	int px, py, pz, dx, dy, dz;
	px = pos_x->GetValue();
	py = pos_y->GetValue();
	pz = pos_z->GetValue();
	dx = dir_x->GetValue();
	dy = dir_y->GetValue();
	dz = dir_z->GetValue();
	px = px + (px - dx);
	py = py + (py - dy);
	pz = pz + (pz - dz);
	pos_x->SetValue(px);
	pos_y->SetValue(py);
	pos_z->SetValue(pz);	
	canvas->Refresh();
}

void CameraPage::OnZoomBar(wxCommandEvent& event) {
	float dx, dy, dz, r;
	dx = pos_x->GetValue() - dir_x->GetValue();
	dy = pos_y->GetValue() - dir_y->GetValue();
	dz = pos_z->GetValue() - dir_z->GetValue();
	r = dx*dx + dy* dy + dz*dz;
	if (r > 0.0) {
		r = sqrt(r);
		dx /= r;
		dy /= r;
		dz /= r;	
	}
	pos_x->SetValue(dir_x->GetValue() + (float)zoom_bar->GetValue()*dx);
	pos_y->SetValue(dir_y->GetValue() + (float)zoom_bar->GetValue()*dy);
	pos_z->SetValue(dir_z->GetValue() + (float)zoom_bar->GetValue()*dz);	

	canvas->Refresh();
}

void CameraPage::OnSetOrigin(wxCommandEvent& event) {
	canvas->SetOrigin();
}

void CameraPage::OnBoxerView() {
	back_view->SetValue(false);
	canvas->Refresh();
}

void CameraPage::OnBackView() {
	boxer_view->SetValue(false);
	canvas->Refresh();
}

void CameraPage::SaveCamera() {
	GetCamera()->cam.DefPosition(
		pos_x->GetValueF(1000),
		pos_y->GetValueF(1000),
		pos_z->GetValueF(1000));
	GetCamera()->cam.DefDirection(
		dir_x->GetValueF(1000),
		dir_y->GetValueF(1000),
		dir_z->GetValueF(1000));
	GetCamera()->cam.DefRotation((float)rot->GetValue());
	GetCamera()->boxer_view = (int)boxer_view->GetValue();
	GetCamera()->back_view = (int)back_view->GetValue();
}

void CameraPage::LoadCamera() {
	pos_x->SetValue((int)(GetCamera()->cam.PosX()*1000));
	pos_y->SetValue((int)(GetCamera()->cam.PosY()*1000));
	pos_z->SetValue((int)(GetCamera()->cam.PosZ()*1000));
	dir_x->SetValue((int)(GetCamera()->cam.DirX()*1000));
	dir_y->SetValue((int)(GetCamera()->cam.DirY()*1000));
	dir_z->SetValue((int)(GetCamera()->cam.DirZ()*1000));
	rot->SetValue((int)GetCamera()->cam.Rot());	
	boxer_view->SetValue((bool)GetCamera()->boxer_view);
	back_view->SetValue((bool)GetCamera()->back_view);
}

bool CameraPage::Save(wxTextOutputStream &out) {
	int i;
	wxString str;

	SaveCamera();
	out << wxT("#Camera Data") << endl;
	out << wxT("#Select Camera") << endl;
	out << SelectCamera() << endl;
	out << wxT("#Camera Perspective") << endl;
	out << znear->GetValue() << endl;
	out << zfar->GetValue() << endl;
	out << angle->GetValue() << endl;
	out << wxT("#Camera Number") << endl;
	out << MaxCamera() << endl;
	for (i = 0; i < MaxCamera(); i++) {
		myCamera *cam = cameras[i];
		str.Printf("#Camera No.%d", i);
		out << str << endl;
		out << ("#Camera Name") << endl;
		out << cam->GetLabel() << endl;
		out << ("#Camera Coords") << endl;
		out << (int)(cam->cam.PosX()*1000) << endl;
		out << (int)(cam->cam.PosY()*1000) << endl;
		out << (int)(cam->cam.PosZ()*1000) << endl;
		out << (int)(cam->cam.DirX()*1000) << endl;
		out << (int)(cam->cam.DirY()*1000) << endl;
		out << (int)(cam->cam.DirZ()*1000) << endl;
		out << (int)cam->cam.Rot() << endl;
		out << ("#Camera State") << endl;
		out << cam->boxer_view << endl;
		out << cam->back_view << endl;
	}
	return true;
}

bool CameraPage::Load(wxTextInputStream &in) {
	int i, num, sel, max, x, y, z;
	wxString str;
  
	str = in.ReadLine();
	str = in.ReadLine();
	in >> sel;
	str = in.ReadLine();
	in >> num;
	znear->SetValue(num);
	in >> num;
	zfar->SetValue(num);
	in >> num;
	angle->SetValue(num);
	str = in.ReadLine();
	in >> max;
	if (max > 100 || max < 1) {
		wxLogError("ο۾Ǥ");
		return false;
	}

	while(MaxCamera() > max) {
		Del();	
	}
	while(MaxCamera() < max) {
		Add();	
	}

	if (sel >= MaxCamera()) {
		wxLogError("ǡ۾Ǥ");
		return false;
	}
	SetSelectCamera(sel);
	for (i = 0; i < max; i++) {
		myCamera *cam = cameras[i];
		str = in.ReadLine();
		str = in.ReadLine();
		str = in.ReadLine();
		cam->SetLabel(str);
		str = in.ReadLine();
		in >> x;
		in >> y;
		in >> z;
		cam->cam.DefPosition((float)x/1000.0, (float)y/1000.0, (float)z/1000.0);
		in >> x;
		in >> y;
		in >> z;
		cam->cam.DefDirection((float)x/1000.0, (float)y/1000.0, (float)z/1000.0);
		in >> num;
		cam->cam.DefRotation((float)num);		
		str = in.ReadLine();
		in >> num;
		cam->boxer_view = num;
		in >> num;
		cam->back_view = num;
	}           
	LoadCamera();
	ReLayout();
	return true;
}
