#ifndef	COMBOPAGE_H
#define COMBOPAGE_H

#include <wx/wx.h>
#include <wx/tglbtn.h>
#include <wx/textctrl.h>
#include <wx/combobox.h>
#include <wx/wfstream.h>
#include <wx/txtstrm.h>
#include <wx/slider.h>

#include "motionpage.h"

class myGLCanvas;
class myNotebook;
class ComboPage;

class myCombo : public wxPanel {
public:
	myCombo(wxWindow* parent, myGLCanvas *ccanvas, int cnumber);
	wxString GetName() const {return tbutton->GetLabel();}
    void SetName(const wxString& name) {tbutton->SetLabel(name);}
    void SetSelect1(int select);
    void SetSelect2(int select);
private:
    void SetProperties();
    void DoLayout();
    void OnSelect1(wxCommandEvent& event);
    void OnSelect2(wxCommandEvent& event);

	wxToggleButton *tbutton;	
	wxComboBox *first, *second;	
	int select_first, select_second;
	myGLCanvas *canvas;
	friend class ComboPage; 
	DECLARE_EVENT_TABLE()
};

WX_DEFINE_ARRAY(myCombo*, myCombos);

enum {
	ON_MY_COMBO1_ID,
	ON_MY_COMBO2_ID
};

class ComboPage : public wxScrolledWindow {
public:
	ComboPage(wxWindow* parent, myGLCanvas *ccanvas, MotionPage *cpage);
	myCombo* GetCombo() const {return combos[select_combo];}
	wxString GetName() const {return name;}
    void SetName(const wxString& cname) {name = cname;}

	int MaxCombo() const {return max_combos;}
	int SelectCombo() const {return select_combo;}
	void Add();		
	void Del();		
	bool IsDoingCombo() const {return do_combo->GetValue();}
	void ComboOn();
	void ComboOff();	
	void ReLayout();
	void MakeComboList(int number);
	void MakeComboLists();
	bool Save(wxTextOutputStream &out);
	bool Load(wxTextInputStream &in);
private:
    void SetProperties();
    void DoLayout();
  	void OnChangeName(wxCommandEvent &event);		
	void OnSpeed(wxCommandEvent &event);		
	void OnAdd(wxCommandEvent &event);		
	void OnDel(wxCommandEvent &event);		
	void OnDoCombo(wxCommandEvent &event);		
	void OnToggle(wxCommandEvent &event);		
	void SetSelectCombo(int new_select);
 	void OnComboTimer(wxTimerEvent& event); 
	void TimerOn();	
	void TimerOff();

	wxSlider *speed;
	wxString name;
	int max_combos;
	int select_combo;
	myCombos combos;
	wxTextCtrl *comboname;
	wxTextCtrl *fps;
	wxButton *add_combo;
	wxButton *del_combo;
	wxToggleButton *do_combo;
	int current_frame, current_cut, cut_number;
	wxTimer combo_timer;
	wxBoxSizer *tsizer ,*vsizer;
	FrameInfos frames;
	MotionPage *page;
	myNotebook *note;
	myGLCanvas *canvas;
	DECLARE_EVENT_TABLE()
};

enum {
 	ON_COMBO_SPEED_ID,
	ON_COMBO_NAME_ID,
	ON_ADD_COMBO_ID,
	ON_DEL_COMBO_ID,
	ON_DO_COMBO_ID,
 	ON_COMBO_TIMER_ID
};

#endif // COMBOPAGE_H
