#ifndef FRAMESLIDER_H
#define FRAMESLIDER_H

#include <wx/wx.h>
#include <wx/spinctrl.h>
#include <wx/tglbtn.h>

class myGLCanvas;
class MotionPage;

class FrameSlider : public wxPanel {
public:
    FrameSlider(wxWindow* parent, int cnumber);
	int GetValue() {return spin->GetValue();}
	void SetValue(int value);
	int GetNumber() {return slider->GetValue();}
	void SetNumber(int value) {SetValue(value);}
	wxString GetName() const {return tbutton->GetLabel();}
    void SetName(const wxString& name) {tbutton->SetLabel(name);}
	bool IsOn(){return tbutton->GetValue();}
	void On() {tbutton->SetValue(true);}
	void Off() {tbutton->SetValue(false);}
	wxObject* Object() {return (wxObject*)tbutton;}
	void SetToggle(bool value) {tbutton->SetValue(value);}
private:
    void SetProperties();
    void DoLayout();
	void OnSlider(wxCommandEvent &event);
	void OnText(wxCommandEvent &event);
	void OnSpin(wxSpinEvent &event);
	void SetSlider();

	wxToggleButton *tbutton;
	wxSlider *slider;
	wxSpinCtrl *spin;
	MotionPage *motionpage;
	DECLARE_EVENT_TABLE()
};

class ToggleSlider : public wxPanel {
public:
    ToggleSlider(wxWindow* parent, myGLCanvas *ccanvas, const wxString& name, int min_value, int max_value);
	int GetValue() const {return spin->GetValue();}
	float GetValueF(int base);
	void SetValue(int value);
	void SetValueF(float value, int base);
	bool IsOn() const {return tbutton->GetValue();}
	void On() {tbutton->SetValue(true);}
	void Off() {tbutton->SetValue(false);}
	bool GetToggle() {return tbutton->GetValue();}
	void SetToggle(bool value) {tbutton->SetValue(value);}

private:
    void SetProperties(const wxString& name, int min_value, int max_value);
    void DoLayout();
	void OnToggle(wxCommandEvent &event);
	void OnSlider(wxCommandEvent &event);
	void OnText(wxCommandEvent &event);
	void OnSpin(wxSpinEvent &event);
	void SetSlider();
	void OnSpinCtrlUp(wxSpinEvent &event);
	void OnSpinCtrlDown(wxSpinEvent &event);

	wxToggleButton *tbutton;
	wxSlider *slider;
	wxSpinCtrl *spin;
	myGLCanvas *canvas;
	DECLARE_EVENT_TABLE()
};

enum {
	ON_TOGGLE_SLIDER_ID,
	ON_TOGGLE_SPINCTRL_ID
};

#endif // FRAMESLIDER_H
