#include "glmatrix.h"

GLMatrix::GLMatrix(GLenum cmode) : mode(cmode) {
}

GLMatrix::~GLMatrix() {
}

void GLMatrix::Calc(float cx, float cy, float cz) {
	x = cx * matrix[0] + cy * matrix[4] + cz *  matrix[8] + matrix[12];
	y = cx * matrix[1] + cy * matrix[5] + cz *  matrix[9] + matrix[13];
	z = cx * matrix[2] + cy * matrix[6] + cz * matrix[10] + matrix[14];
}

void GLMatrix::CalcUnit(float cx, float cy, float cz) {
	x = cx * matrix[0] + cy * matrix[4] + cz *  matrix[8];
	y = cx * matrix[1] + cy * matrix[5] + cz *  matrix[9];
	z = cx * matrix[2] + cy * matrix[6] + cz * matrix[10];
}


void GLMatrix::Print() {
	fprintf(stdout, "--- Matrix Properties ---\n");
	fprintf(stdout, "M11 = %f M12 = %f M13 = %f M14 = %f\n", matrix[0], matrix[4],  matrix[8], matrix[12]);
	fprintf(stdout, "M21 = %f M22 = %f M23 = %f M24 = %f\n", matrix[1], matrix[5],  matrix[9], matrix[13]);
	fprintf(stdout, "M31 = %f M32 = %f M33 = %f M34 = %f\n", matrix[2], matrix[6], matrix[10], matrix[14]);
	fprintf(stdout, "M41 = %f M42 = %f M43 = %f M44 = %f\n", matrix[3], matrix[7], matrix[11], matrix[15]);
}

void GLMatrix::PrintCoord() {
	fprintf(stdout, "--- Coordinate ---\n");
	fprintf(stdout, "X = %f Y = %f Z = %f\n", x, y, z);
}
