#include "glshapes.h"

void fan_poly(GLdouble z1, GLdouble z2, GLdouble r1, GLdouble r2, GLdouble nz1, GLdouble nz2, GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLint p, GLint nn, GLint s, GLint e) {
	static GLint i, ii, is_edge;
	static GLdouble o, o1;
	static GLdouble x1, x4;
	static GLdouble y1, y4;
	static GLdouble nx1, nx4;
	static GLdouble ny1, ny4;
	static GLdouble a, b, aa, bb;	

	o = DPI / (double)p;

	if (fabs(r1) <= VERY_SMALL) {
		glBegin(GL_TRIANGLE_FAN);
		glNormal3f(0.0, 0.0, nz1);
		glVertex3f(0.0, 0.0, z1);
		is_edge = 1;
	} else if (fabs(r2) <= VERY_SMALL) {
		glBegin(GL_TRIANGLE_FAN);
		glNormal3f(0.0, 0.0, nz2);
		glVertex3f(0.0, 0.0, z2);
		is_edge = 2;
	} else {
		glBegin(GL_TRIANGLE_STRIP);
		is_edge = 0;
	}	

	for (i = p*s / 36; i <= p*e / 36; i++) {
		if (is_edge == 1) {
			ii = p*(e + s) / 36 - i;		
		} else {
		 	ii = i;
		}
     
		if (ii< p/2) {
			b = b1;
		} else {
			b = b2;
		}
		bb = b*b;

		if (ii< p/4 || ii >= p*3/4) {
			a = a1;
		} else {
			a = a2;
		}
		aa = a*a;

		o1 = o * (double)ii;
		x1 = a * r1 * cos(o1);  
		y1 = b * r1 * sin(o1);  
		x4 = a * r2 * cos(o1);  
		y4 = b * r2 * sin(o1);  

		if (nn) {
			nx1 = x1 / aa;
			nx4 = x4 / aa;
			ny1 = y1 / bb;
			ny4 = y4 / bb;

			if (is_edge == 1) {
				glNormal3f(nx4, ny4, nz2);
				glVertex3f(x4, y4, z2);
			} else if (is_edge == 2) {
				glNormal3f(nx1, ny1, nz1);
				glVertex3f(x1, y1, z1);
			} else { 
				glNormal3f(nx4, ny4, nz2);
				glVertex3f(x4, y4, z2);
				glNormal3f(nx1, ny1, nz1);
				glVertex3f(x1, y1, z1);
			}
    	} else {
			if (is_edge == 1) {
				glVertex3f(x4, y4, z2);
			} else if (is_edge == 2) {
				glVertex3f(x1, y1, z1);
			} else { 
				glVertex3f(x4, y4, z2);
				glVertex3f(x1, y1, z1);
			}
		}
	}
	glEnd();
}

void elipse2_polywt(GLdouble z1, GLdouble z2, GLdouble r1, GLdouble r2, GLdouble nz1, GLdouble nz2, GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLint p, GLint nn, int j, int q) {
	static GLint i, ii, ti, is_edge;
	static GLdouble o, o1;
	static GLdouble x1, x4;
	static GLdouble y1, y4;
	static GLdouble nx1, nx4;
	static GLdouble ny1, ny4;
	static GLdouble a, b, aa, bb;	
	static GLfloat u1, u2, v1, v2;	

	o = DPI / (double)p;

	if (fabs(r1) <= VERY_SMALL) {
		glBegin(GL_TRIANGLE_FAN);
		glNormal3f(0.0, 0.0, nz1);
		glTexCoord2f(0.5, 1.0);
		glVertex3f(0.0, 0.0, z1);
		is_edge = 1;
	} else if (fabs(r2) <= VERY_SMALL) {
		glBegin(GL_TRIANGLE_FAN);
		glNormal3f(0.0, 0.0, nz2);
		glTexCoord2f(0.5, 0.0);
		glVertex3f(0.0, 0.0, z2);
		is_edge = 2;
	} else {
		glBegin(GL_TRIANGLE_STRIP);
		is_edge = 0;
	}	

	for (i = 0; i <= p; i++) {
		if (is_edge == 1) {
			ii = p - i;		
		} else {
		 	ii = i;
		}
		if (ii< p/2) {
			b = b1;
		} else {
			b = b2;
		}
		bb = b*b;

		if (ii< p/4 || ii >= p*3/4) {
			a = a1;
		} else {
			a = a2;
		}
		aa = a*a;

		o1 = o * (double)ii;
		x1 = a * r1 * cos(o1);  
		y1 = b * r1 * sin(o1);  
		x4 = a * r2 * cos(o1);  
		y4 = b * r2 * sin(o1);  

		if (nn) {
			nx1 = x1 / aa;
			nx4 = x4 / aa;
			ny1 = y1 / bb;
			ny4 = y4 / bb;

			ti = ii + p / 4;
			u1 = (float)ti/(float)p;
			u2 = (float)(ti + 1)/(float)p;
			v1 = (float)(q - j)/(float)q;
			v2 = (float)(q - j - 1)/(float)q;

			if (is_edge == 1) {
				glNormal3f(nx4, ny4, nz2);
				glTexCoord2f(u1, v2);
				glVertex3f(x4, y4, z2);
			} else if (is_edge == 2) {
				glNormal3f(nx1, ny1, nz1);
				glTexCoord2f(u1, v1);
	 			glVertex3f(x1, y1, z1);
			} else {
				glNormal3f(nx4, ny4, nz2);
				glTexCoord2f(u1, v2);
				glVertex3f(x4, y4, z2);
				glNormal3f(nx1, ny1, nz1);
				glTexCoord2f(u1, v1);
	 			glVertex3f(x1, y1, z1);
			} 			
    	} else {
			if (is_edge == 1) {
				glVertex3f(x4, y4, z2);			
			} else if (is_edge == 2) {
				glVertex3f(x1, y1, z1);						
			} else {
				glVertex3f(x4, y4, z2);
				glVertex3f(x1, y1, z1);			
			} 			
		}
	}
	glEnd();
}

void elipse2_poly_otherside(GLdouble z1, GLdouble z2, GLdouble r1, GLdouble r2, GLdouble nz1, GLdouble nz2, GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLint p, GLint nn) {
	static GLint i, ii, is_edge;
	static GLdouble o, o1;
	static GLdouble x1, x4;
	static GLdouble y1, y4;
	static GLdouble nx1, nx4;
	static GLdouble ny1, ny4;
	static GLdouble a, b, aa, bb;	

	o = DPI / (double)p;

	if (fabs(r1) <= VERY_SMALL) {
		glBegin(GL_TRIANGLE_FAN);
		glNormal3f(0.0, 0.0, nz1);
		glVertex3f(0.0, 0.0, z1);
		is_edge = 1;
	} else if (fabs(r2) <= VERY_SMALL) {
		glBegin(GL_TRIANGLE_FAN);
		glNormal3f(0.0, 0.0, nz2);
		glVertex3f(0.0, 0.0, z2);
		is_edge = 2;
	} else {
		glBegin(GL_TRIANGLE_STRIP);
		is_edge = 0;
	}	
	for (i = 0; i <= p; i++) {
		if (is_edge == 2) {
			ii = p - i;		
		} else {
		 	ii = i;
		} 
		if (ii< p/2) {
			b = b1;
		} else {
			b = b2;
		}
		bb = b*b;

		if (ii< p/4 || ii >= p*3/4) {
			a = a1;
		} else {
			a = a2;
		}
		aa = a*a;

		o1 = o * (double)ii;
		x1 = a * r1 * cos(o1);  
		y1 = b * r1 * sin(o1);  
		x4 = a * r2 * cos(o1);  
		y4 = b * r2 * sin(o1);  

		if (nn) {
			nx1 = -x1 / aa;
			nx4 = -x4 / aa;
			ny1 = -y1 / bb;
			ny4 = -y4 / bb;
	
    		if (is_edge == 1) {			
				glNormal3f(nx4, ny4, nz2);
				glVertex3f(x4, y4, z2);
			} else if(is_edge == 2) {
				glNormal3f(nx1, ny1, nz1);
				glVertex3f(x1, y1, z1);
			} else {			
				glNormal3f(nx1, ny1, nz1);
				glVertex3f(x1, y1, z1);
				glNormal3f(nx4, ny4, nz2);
				glVertex3f(x4, y4, z2);
			}
    	} else {
    		if (is_edge == 1) {			
				glVertex3f(x4, y4, z2);
			} else if(is_edge == 2) {
				glVertex3f(x1, y1, z1);
			} else {			
				glVertex3f(x1, y1, z1);
				glVertex3f(x4, y4, z2);
			}
		}
	}
	glEnd();
}

void elipse2_poly_othersidewt(GLdouble z1, GLdouble z2, GLdouble r1, GLdouble r2, GLdouble nz1, GLdouble nz2, GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLint p, GLint nn, GLint j, GLint q) {
	static GLint i, ii, is_edge;
	static GLdouble o, o1;
	static GLdouble x1, x4;
	static GLdouble y1, y4;
	static GLdouble nx1, nx4;
	static GLdouble ny1, ny4;
	static GLdouble a, b, aa, bb;	
	static GLfloat u1, u2, v1, v2;	

	o = DPI / (double)p;

	if (fabs(r1) <= VERY_SMALL) {
		glBegin(GL_TRIANGLE_FAN);
		glNormal3f(0.0, 0.0, nz1);
		glTexCoord2f(0.5, 1.0);
		glVertex3f(0.0, 0.0, z1);
		is_edge = 1;
	} else if (fabs(r2) <= VERY_SMALL) {
		glBegin(GL_TRIANGLE_FAN);
		glNormal3f(0.0, 0.0, nz2);
		glTexCoord2f(0.5, 0.0);
		glVertex3f(0.0, 0.0, z2);
		is_edge = 2;
	} else {
		glBegin(GL_TRIANGLE_STRIP);
		is_edge = 0;
	}	

	for (i = 0; i <= p; i++) {
		if (is_edge == 2) {
			ii = p - i;		
		} else {
		 	ii = i;
		}
		if (ii< p/2) {
			b = b1;
		} else {
			b = b2;
		}
		bb = b*b;

		if (ii< p/4 || ii >= p*3/4) {
			a = a1;
		} else {
			a = a2;
		}
		aa = a*a;

		o1 = o * (double)ii;
		x1 = a * r1 * cos(o1);  
		y1 = b * r1 * sin(o1);  
		x4 = a * r2 * cos(o1);  
		y4 = b * r2 * sin(o1);  

		if (nn) {
			nx1 = -x1 / aa;
			nx4 = -x4 / aa;
			ny1 = -y1 / bb;
			ny4 = -y4 / bb;

			u1 = (float)i/(float)p;
			u2 = (float)(i+1)/(float)p;
			v1 = (float)j/(float)q;
			v2 = (float)(j+1)/(float)q;
			
    		if (is_edge == 1) {			
				glNormal3f(nx4, ny4, nz2);
				glTexCoord2f(u1, v2);
				glVertex3f(x4, y4, z2);
			} else if(is_edge == 2) {
				glNormal3f(nx1, ny1, nz1);
				glTexCoord2f(u1, v1);
	 			glVertex3f(x1, y1, z1);
			} else {			
				glNormal3f(nx1, ny1, nz1);
				glTexCoord2f(u1, v1);
	 			glVertex3f(x1, y1, z1);
				glNormal3f(nx4, ny4, nz2);
				glTexCoord2f(u1, v2);
				glVertex3f(x4, y4, z2);
			}
    	} else {
    		if (is_edge == 1) {			
				glVertex3f(x4, y4, z2);
			} else if(is_edge == 2) {
				glVertex3f(x1, y1, z1);
			} else {			
				glVertex3f(x1, y1, z1);
				glVertex3f(x4, y4, z2);
			}
		}
	}
	glEnd();
}

void elipse2_poly(GLdouble z1, GLdouble z2, GLdouble r1, GLdouble r2, GLdouble nz1, GLdouble nz2, GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLint p, GLint nn) {
	fan_poly(z1, z2, r1, r2, nz1, nz2, a1, a2, b1, b2, p, nn, 0, 36);
}

void elipse_poly(GLdouble z1, GLdouble z2, GLdouble r1, GLdouble r2, GLdouble nz1, GLdouble nz2, GLdouble a, GLdouble b, GLint p, GLint nn) {
	elipse2_poly(z1, z2, r1, r2, nz1, nz2, a, a, b, b, p, 1);
}

void circle_poly(GLdouble z1, GLdouble z2, GLdouble r1, GLdouble r2, GLdouble nz1, GLdouble nz2, GLint p) {
	elipse_poly(z1, z2, r1, r2, nz1, nz2, 1.0, 1.0, p, 1);
}

void circle_polyn(GLdouble z1, GLdouble z2, GLdouble r1, GLdouble r2, GLint p) {
	elipse_poly(z1, z2, r1, r2, 0.0, 0.0, 1.0, 1.0, p, 0);
}

void elipse2(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c1, GLdouble c2, GLint q) {
	GLint i, p = q/2;
	GLdouble r1, r2;
	GLdouble z1, z2;
	GLdouble nz1 ,nz2;
	GLdouble ts, t, c;

	ts = - PI2;
	t = PI / (double)p;

	for (i = 0; i < p; i++) {
		if (i< p/2) {
			c = c1;
		} else {
			c = c2;
		}

		z1 =  sin (ts + t * (double)i);
		z2 =  sin (ts + t * (double)(i+1));

		if (i == 0) {
			r1 = 0.0;
		} else {
			r1 = sqrt(1.0 - z1 * z1);
		}	
		if (i == p - 1) {
			r2 = 0.0;
 		} else {
			r2 = sqrt(1.0 - z2 * z2);		
		}
		
		nz1 = z1 / c;
		nz2 = z2 / c;
		z1 *= c;
		z2 *= c;
		elipse2_poly(z1, z2, r1, r2, nz1, nz2, a1, a2, b1, b2, q, 1);
	}
}

void elipse2wt(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c1, GLdouble c2, GLint q) {
	GLint i, p = q/2;
	GLdouble r1, r2;
	GLdouble z1, z2;
	GLdouble nz1 ,nz2;
	GLdouble ts, t, c;

	ts = - PI2;
	t = PI / (double)p;

	glEnable(GL_TEXTURE_2D);
	for (i = 0; i < p; i++) {
		if (i< p/2) {
			c = c1;
		} else {
			c = c2;
		}

		z1 =  sin (ts + t * (double)i);
		z2 =  sin (ts + t * (double)(i+1));

		if (i == 0) {
			r1 = 0.0;
		} else {
			r1 = sqrt(1.0 - z1 * z1);
		}	
		if (i == p - 1) {
			r2 = 0.0;
 		} else {
			r2 = sqrt(1.0 - z2 * z2);		
		}
		
		nz1 = z1 / c;
		nz2 = z2 / c;
		z1 *= c;
		z2 *= c;
		elipse2_polywt(z1, z2, r1, r2, nz1, nz2, a1, a2, b1, b2, q, 1, i, p);
	}
	glDisable(GL_TEXTURE_2D);
}

void elipse2c(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c1, GLdouble c2, int cs, int ce, GLint q) {
	GLint i, p = q/2;
	GLdouble r1, r2;
	GLdouble z1, z2;
	GLdouble nz1 ,nz2;
	GLdouble ts, t, c;

	ts = - PI2;
	t = PI / (double)p;

	for (i = cs; i < ce; i++) {
		if (i< p/2) {
			c = c1;
		} else {
			c = c2;
		}

		z1 =  sin (ts + t * (double)i);
		z2 =  sin (ts + t * (double)(i+1));

		if (i == 0) {
			r1 = 0.0;
		} else {
			r1 = sqrt(1.0 - z1 * z1);
		}	
		if (i == p - 1) {
			r2 = 0.0;
 		} else {
			r2 = sqrt(1.0 - z2 * z2);		
		}
		
		nz1 = z1 / c;
		nz2 = z2 / c;
		z1 *= c;
		z2 *= c;
		elipse2_poly(z1, z2, r1, r2, nz1, nz2, a1, a2, b1, b2, q, 1);
	}
}

void elipse(GLdouble a, GLdouble b, GLdouble c, GLint q) {
	elipse2(a, a, b, b, c, c, q);
}

void sphere(GLdouble r, GLint q) {
	elipse(r, r, r, q);
}

void fan_elipse2(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c, GLint q, GLint s, GLint e) {
	GLint i, p = q/4;
	GLdouble r1, r2;
	GLdouble z1, z2;
	GLdouble nz1 ,nz2;
	GLdouble ts, t;

	ts = - PI2;
	t = PI2 / (double)p;

	for (i = 0; i <= p; i++) {
		z1 =  sin (ts + t * (double)i);
		z2 =  sin (ts + t * (double)(i+1));

		if (i == 0) {
			r1 = 0.0;
		} else {
			r1 = sqrt(1.0 - z1 * z1);
		}	
		r2 = sqrt(1.0 - z2 * z2);		
		
		nz1 = z1 / c;
		nz2 = z2 / c;
		z1 *= c;
		z2 *= c;
		fan_poly(z1, z2, r1, r2, nz1, nz2, a1, a2, b1, b2, q, 1, s, e);
	}
	fan_poly(z2, z2, r2, 0.0, 1.0, 1.0, a1, a2, b1, b2, q, 1, s, e);
}

void half_elipse2_otherside(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c, GLint q) {
	GLint i, p = q/4;
	GLdouble r1, r2;
	GLdouble z1, z2;
	GLdouble nz1 ,nz2;
	GLdouble ts, t;

	ts = - PI2;
	t = PI2 / (double)p;

	for (i = 0; i < p ; i++) {
		z1 =  sin (ts + t * (double)i);
		z2 =  sin (ts + t * (double)(i+1));

		if (i == 0) {
			r1 = 0.0;
		} else {
			r1 = sqrt(1.0 - z1 * z1);
		}	
		r2 = sqrt(1.0 - z2 * z2);		
		
		nz1 = z1 / c;
		nz2 = z2 / c;
		z1 *= c;
		z2 *= c;
		elipse2_poly_otherside(z1, z2, r1, r2, nz1, nz2, a1, a2, b1, b2, q, 1);
	}
	elipse2_poly_otherside(z2, z2, r2, 0.0, -1.0, -1.0, a1, a2, b1, b2, q, 1);
}

void half_elipse2_othersidewt(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c, GLint q) {
	GLint i, p = q/4;
	GLdouble r1, r2;
	GLdouble z1, z2;
	GLdouble nz1 ,nz2;
	GLdouble ts, t;

	ts = - PI2;
	t = PI2 / (double)p;

	glEnable(GL_TEXTURE_2D);
	for (i = 0; i < p; i++) {
		z1 =  sin (ts + t * (double)i);
		z2 =  sin (ts + t * (double)(i+1));

		if (i == 0) {
			r1 = 0.0;
		} else {
			r1 = sqrt(1.0 - z1 * z1);
		}	
		r2 = sqrt(1.0 - z2 * z2);		
		
		nz1 = z1 / c;
		nz2 = z2 / c;
		z1 *= c;
		z2 *= c;
		elipse2_poly_othersidewt(z1, z2, r1, r2, nz1, nz2, a1, a2, b1, b2, q, 1, i, p);
	}
	glDisable(GL_TEXTURE_2D);

	GLfloat mat1_dif[4] = {0.5, 0.3, 0.3, 1.0};
	GLfloat mat1_amb[4] = {0.2, 0.2, 0.2, 1.0};
	GLfloat mat1_spe[4] = {0.0, 0.0, 0.0, 1.0};
	GLfloat mat1_emi[4] = {0.0, 0.0, 0.0, 1.0};
	GLfloat mat1_shi = 0.0;

	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat1_dif);
	glMaterialfv(GL_FRONT, GL_AMBIENT, mat1_amb);
	glMaterialfv(GL_FRONT, GL_SPECULAR, mat1_spe);
	glMaterialfv(GL_FRONT, GL_EMISSION, mat1_emi);
	glMaterialf(GL_FRONT, GL_SHININESS, mat1_shi);

	elipse2_poly_otherside(z2, z2, r2, 0.0, -1.0, -1.0, a1, a2, b1, b2, q, 1);
}

void half_elipse2(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c, GLint q) {
	fan_elipse2(a1, a2, b1, b2, c, q, 0, 36);
}

void half_elipse(GLdouble a, GLdouble b, GLdouble c, GLint q) {
	half_elipse2(a, a, b, b, c, q);
}

void half_sphere(GLdouble r, GLint q) {
	half_elipse(r, r, r, q);
}

void corn2(GLdouble z1, GLdouble z2, GLdouble r1, GLdouble r2, GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLint q) {
	GLfloat nz1, nz2, c;
	if (r2 != r1) {
		c = z2 - z1 / (r2 - r1);
  		nz1 = -z1 / c*c;
		nz2 = -z2 / c*c;
	} else {
 		nz1 = 0.0;
		nz2 = 0.0;	
	}

	elipse2_poly(z1, z1, 0.0, r1, -1.0, -1.0, a1, a2, b1, b2, q, 1);
	elipse2_poly(z1, z2, r1,  r2,  nz1,  nz2, a1, a2, b1, b2, q, 1);
	elipse2_poly(z2, z2, r2, 0.0,  1.0,  1.0, a1, a2, b1, b2, q, 1);
}

void corn2o(GLdouble z1, GLdouble z2, GLdouble r1, GLdouble r2, GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLint q) {
	GLdouble nz1, nz2, c;
	if (r2 != r1) {
		c = z2 - z1 / (r2 - r1);
  		nz1 = -z1 / c*c;
		nz2 = -z2 / c*c;
	} else {
 		nz1 = 0.0;
		nz2 = 0.0;	
	}

	elipse2_poly(z1, z2, r1,  r2,  nz1,  nz2, a1, a2, b1, b2, q, 1);
}

void corn(GLdouble z1, GLdouble z2, GLdouble r1, GLdouble r2, GLint q) {
	corn2(z1, z2, r1, r2, 1.0, 1.0, 1.0, 1.0, q);
}

void corno(GLdouble z1, GLdouble z2, GLdouble r1, GLdouble r2, GLint q) {
	corn2o(z1, z2, r1, r2, 1.0, 1.0, 1.0, 1.0, q);
}

void pillar2(GLdouble z1, GLdouble z2, GLdouble r, GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLint q) {
	corn2(z1, z2, r, r, a1, a2, b1, b2, q);
}

void pillar(GLdouble z1, GLdouble z2, GLdouble r, GLint q) {
	corn(z1, z2, r, r, q);
}

void pillaro(GLdouble z1, GLdouble z2, GLdouble r, GLint q) {
	corno(z1, z2, r, r, q);
}

void pillar_top(GLdouble c, GLdouble r, GLint q) {
	GLint i, p = q/4;
	GLdouble r1, r2;
	GLdouble z1, z2;
	GLdouble nz1 ,nz2;
	GLdouble ts, t;

	ts = 0.0;
	t = PI2 / (double)p;

	for (i = 0; i < p; i++) {

		z1 =  sin (ts + t * (double)i);
		z2 =  sin (ts + t * (double)(i+1));

		r1 = sqrt(1.0 - z1 * z1);
		
		if (i == p - 1) {
			r2 = 0.0;
 		} else {
			r2 = sqrt(1.0 - z2 * z2);		
		}
		
		nz1 = z1 / c;
		nz2 = z2 / c;
		z1 *= c;
		z2 *= c;
		elipse2_poly(z1, z2, r1, r2, nz1, nz2, r, r, r, r, q, 1);
	}
}

void pillor_othersidewt(GLdouble z1, GLdouble z2, GLdouble r, GLint q) {
	glEnable(GL_TEXTURE_2D);
	elipse2_poly_othersidewt(z1, z2, r, r, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, q, 1, 0, 1);
	glDisable(GL_TEXTURE_2D);
}

void box(GLdouble x, GLdouble y, GLdouble z) {
	glBegin(GL_QUADS);
    glNormal3f(0.0, 0.0, 1.0);
    glVertex3f( x,  y, z);
	glVertex3f(-x,  y, z);
    glVertex3f(-x, -y, z);
	glVertex3f( x, -y, z);

    glNormal3f(0.0, 0.0, -1.0);
    glVertex3f(-x,-y, 0.0);
	glVertex3f(-x, y, 0.0);
    glVertex3f( x, y, 0.0);
	glVertex3f( x,-y, 0.0);

    glNormal3f(0.0, 1.0, 0.0);
    glVertex3f( x, y,   z);
	glVertex3f( x, y, 0.0);
    glVertex3f(-x, y, 0.0);
	glVertex3f(-x, y,   z);

    glNormal3f(0.0, -1.0, 0.0);
    glVertex3f(-x, -y, 0.0);
	glVertex3f( x, -y, 0.0);
    glVertex3f( x, -y,   z);
	glVertex3f(-x, -y,   z);

    glNormal3f(1.0, 0.0, 0.0);
    glVertex3f( x,  y,   z);
	glVertex3f( x, -y,   z);
    glVertex3f( x, -y, 0.0);
	glVertex3f( x,  y, 0.0);

    glNormal3f(-1.0, 0.0, 0.0);
    glVertex3f(-x, -y, 0.0);
	glVertex3f(-x, -y,   z);
    glVertex3f(-x,  y,   z);
	glVertex3f(-x,  y, 0.0);
 	glEnd();              
}

void box_canvas(GLdouble x, GLdouble y, GLdouble z) {
	glEnable(GL_TEXTURE_2D);
	glBegin(GL_QUADS);
    glNormal3f(0.0, 0.0, 1.0);
	glTexCoord2f(1.0, 0.0);
    glVertex3f( x,  y, z);
	glTexCoord2f(0.0, 0.0);
	glVertex3f(-x,  y, z);
	glTexCoord2f(0.0, 1.0);
    glVertex3f(-x, -y, z);
	glTexCoord2f(1.0, 1.0);
	glVertex3f( x, -y, z);
	glEnd();
	glDisable(GL_TEXTURE_2D);

	glBegin(GL_QUADS);
    glNormal3f(0.0, 0.0, -1.0);
    glVertex3f(-x,-y, 0.0);
	glVertex3f(-x, y, 0.0);
    glVertex3f( x, y, 0.0);
	glVertex3f( x,-y, 0.0);

    glNormal3f(0.0, 1.0, 0.0);
    glVertex3f( x, y,   z);
	glVertex3f( x, y, 0.0);
    glVertex3f(-x, y, 0.0);
	glVertex3f(-x, y,   z);

    glNormal3f(0.0, -1.0, 0.0);
    glVertex3f(-x, -y, 0.0);
	glVertex3f( x, -y, 0.0);
    glVertex3f( x, -y,   z);
	glVertex3f(-x, -y,   z);

    glNormal3f(1.0, 0.0, 0.0);
    glVertex3f( x,  y,   z);
	glVertex3f( x, -y,   z);
    glVertex3f( x, -y, 0.0);
	glVertex3f( x,  y, 0.0);

    glNormal3f(-1.0, 0.0, 0.0);
    glVertex3f(-x, -y, 0.0);
	glVertex3f(-x, -y,   z);
    glVertex3f(-x,  y,   z);
	glVertex3f(-x,  y, 0.0);
 	glEnd();              
}

void box_corner(GLdouble x, GLdouble y, GLdouble z, int number) {
	glEnable(GL_TEXTURE_2D);
	glBegin(GL_QUADS);
    glNormal3f(-1.0, 0.0, 0.0);
	glTexCoord2f((float)(number + 1) * 0.5, 1.0);
	glVertex3f(-x, -y, 0.0);
 	glTexCoord2f((float)(number + 1) * 0.5, 0.0);
 	glVertex3f(-x, -y,   z);
	glTexCoord2f((float)(number) * 0.5, 0.0);
    glVertex3f(-x,  y,   z);
	glTexCoord2f((float)(number) * 0.5, 1.0);
	glVertex3f(-x,  y, 0.0);
 	glEnd();
	glDisable(GL_TEXTURE_2D);

	glBegin(GL_QUADS);
    glNormal3f(0.0, 0.0, 1.0);
    glVertex3f( x,  y, z);
	glVertex3f(-x,  y, z);
    glVertex3f(-x, -y, z);
	glVertex3f( x, -y, z);

    glNormal3f(0.0, 0.0, -1.0);
    glVertex3f(-x,-y, 0.0);
	glVertex3f(-x, y, 0.0);
    glVertex3f( x, y, 0.0);
	glVertex3f( x,-y, 0.0);

    glNormal3f(0.0, 1.0, 0.0);
	glVertex3f( x, y,   z);
	glVertex3f( x, y, 0.0);
    glVertex3f(-x, y, 0.0);
	glVertex3f(-x, y,   z);

    glNormal3f(0.0, -1.0, 0.0);
    glVertex3f(-x, -y, 0.0);
	glVertex3f( x, -y, 0.0);
    glVertex3f( x, -y,   z);
	glVertex3f(-x, -y,   z);

    glNormal3f(1.0, 0.0, 0.0);
    glVertex3f( x,  y,   z);
	glVertex3f( x, -y,   z);
    glVertex3f( x, -y, 0.0);
	glVertex3f( x,  y, 0.0);
 	glEnd();              
}

void camera() {
	glColor3f(1.0, 1.0, 1.0);
    circle_polyn(0.0, 0.0, 0.0, 1.0, 36);
 	glColor3f(0.2, 0.2, 0.2);
    circle_polyn(0.0, 2.0, 1.0, 1.0, 36);

	glPushMatrix();
	glTranslatef(0.0, 0.0, 2.0);
 	glColor3f(0.3, 0.3, 0.3);
	box(1.2, 1.0, 4.0);
	glPopMatrix(); 
	              
	glTranslatef(0.8, 0.0, 3.8);
	glRotatef(90, 0.0, 1.0, 0.0);
 	glColor3f(0.2, 0.2, 0.2);
    circle_polyn(0.0, 2.0, 0.5, 0.5, 36);
 	circle_polyn(2.0, 2.0, 0.5, 0.0, 36);
}

void light() {
	GLint j, q = 18;
	GLdouble r1, r2;
	GLdouble z1, z2;
	GLdouble ts, te, t;

	ts = 0.0;
	te = 2.0;
	t  = (te - ts) / (double)q;

	for (j= 0;j < q; j++) {
		z1 =  ts + t * (double)j;
		z2 =  ts + t * (double)(j+1);

		if (j == 0) {
			r1 = 0.0;
			glColor3f(1.0, 1.0, 0.0);
		} else {
			r1 = sqrt(te - z1);
			glColor3f(0.7, 0.7, 0.7);
		}	
		if (j == q - 1) {
			r2 = 0.0;
 		} else {
			r2 = sqrt(te - z2);		
		}
		circle_polyn(z1, z2, r1, r2, 36);
	}
}

void ring(int partition) {
	int i;
	GLfloat mat_dif[4] = {0.8, 0.8, 0.8, 1.0};
	GLfloat mat_amb[4] = {0.2, 0.2, 0.2, 1.0};
	GLfloat mat_spe[4] = {0.0, 0.0, 0.0, 1.0};
	GLfloat mat_emi[4] = {0.0, 0.0, 0.0, 1.0};
	GLfloat mat_shi = 0.0;
	
	GLfloat pole_dif[4] = {0.4, 0.4, 0.4, 1.0};
	GLfloat pole_amb[4] = {0.2, 0.2, 0.2, 1.0};
	GLfloat pole_spe[4] = {1.0, 1.0, 1.0, 1.0};
	GLfloat pole_emi[4] = {0.0, 0.0, 0.0, 1.0};
	GLfloat pole_shi = 128.0;

	GLfloat corner_dif_white[4] = {1.0, 1.0, 1.0, 1.0};
	GLfloat corner_dif_red[4] = {1.0, 0.0, 0.0, 1.0};
	GLfloat corner_dif_blue[4] = {0.0, 0.0, 1.0, 1.0};
	GLfloat corner_amb[4] = {0.2, 0.2, 0.2, 1.0};
	GLfloat corner_spe[4] = {0.0, 0.0, 0.0, 1.0};
	GLfloat corner_emi[4] = {0.0, 0.0, 0.0, 1.0};
	GLfloat corner_shi = 0.0;

	GLfloat rope_dif_white[4] = {1.0, 1.0, 1.0, 1.0};
	GLfloat rope_dif_red[4] = {1.0, 0.0, 0.0, 1.0};
	GLfloat rope_dif_blue[4] = {0.0, 0.0, 1.0, 1.0};
	GLfloat rope_amb[4] = {0.2, 0.2, 0.2, 1.0};
	GLfloat rope_spe[4] = {0.8, 0.8, 0.8, 1.0};
	GLfloat rope_emi[4] = {0.0, 0.0, 0.0, 1.0};
	GLfloat rope_shi = 64.0;
	GLfloat *rope_color[6];
	rope_color[1] = rope_dif_white;
	rope_color[2] = rope_dif_blue;
	rope_color[3] = rope_dif_white;
	rope_color[4] = rope_dif_red;
	
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_dif);
	glMaterialfv(GL_FRONT, GL_AMBIENT, mat_amb);
	glMaterialfv(GL_FRONT, GL_SPECULAR, mat_spe);
	glMaterialfv(GL_FRONT, GL_EMISSION, mat_emi);
	glMaterialf(GL_FRONT, GL_SHININESS, mat_shi);

	glPushMatrix();
	glTranslatef(0.0, 0.0, -1.0);
	box_canvas(3.0, 3.0, 1.0);
	glPopMatrix();  

	glMaterialfv(GL_FRONT, GL_DIFFUSE, pole_dif);
	glMaterialfv(GL_FRONT, GL_AMBIENT, pole_amb);
	glMaterialfv(GL_FRONT, GL_SPECULAR, pole_spe);
	glMaterialfv(GL_FRONT, GL_EMISSION, pole_emi);
	glMaterialf(GL_FRONT, GL_SHININESS, pole_shi);

	glPushMatrix();
	glTranslatef(2.8, 2.8, 0.0);
	pillaro(0.0, 1.8, 0.15, partition);
	glTranslatef(0.0, 0.0, 1.8);
	pillar_top(0.1, 0.15, partition);
	glPopMatrix();

	glPushMatrix();
	glTranslatef(-2.8, 2.8, 0.0);
	pillaro(0.0, 1.8, 0.15, partition);
	glTranslatef(0.0, 0.0, 1.8);
	pillar_top(0.1, 0.15, partition);
	glPopMatrix();

	glPushMatrix();
	glTranslatef(2.8, -2.8, 0.0);
	pillaro(0.0, 1.8, 0.15, partition);
	glTranslatef(0.0, 0.0, 1.8);
	pillar_top(0.1, 0.15, partition);
	glPopMatrix();

	glPushMatrix();
	glTranslatef(-2.8, -2.8, 0.0);
	pillaro(0.0, 1.8, 0.15, partition);
	glTranslatef(0.0, 0.0, 1.8);
	pillar_top(0.1, 0.15, partition);
	glPopMatrix();

	glMaterialfv(GL_FRONT, GL_DIFFUSE, corner_dif_white);
	glMaterialfv(GL_FRONT, GL_AMBIENT, corner_amb);
	glMaterialfv(GL_FRONT, GL_SPECULAR, corner_spe);
	glMaterialfv(GL_FRONT, GL_EMISSION, corner_emi);
	glMaterialf(GL_FRONT, GL_SHININESS, corner_shi);
	glPushMatrix();
	glTranslatef(2.5, 2.5, 0.1);
	glRotatef(45.0, 0.0, 0.0, 1.0);
	box(0.1, 0.2, 1.5);
	glPopMatrix();

	glMaterialfv(GL_FRONT, GL_DIFFUSE, corner_dif_blue);
	glPushMatrix();
	glTranslatef(-2.5, 2.5, 0.1);
	glRotatef(45.0, 0.0, 0.0, 1.0);
	box(0.2, 0.1, 1.5);
	glPopMatrix();

	glMaterialfv(GL_FRONT, GL_DIFFUSE, corner_dif_red);
	glPushMatrix();
	glTranslatef(2.5, -2.5, 0.1);
	glRotatef(45.0, 0.0, 0.0, 1.0);
	box(0.2, 0.1, 1.5);
	glPopMatrix();

	glMaterialfv(GL_FRONT, GL_DIFFUSE, corner_dif_white);
	glPushMatrix();
	glTranslatef(-2.5, -2.5, 0.1);
	glRotatef(45.0, 0.0, 0.0, 1.0);
	box(0.1, 0.2, 1.5);
	glPopMatrix();
	
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_dif);
	glMaterialfv(GL_FRONT, GL_AMBIENT, mat_amb);
	glMaterialfv(GL_FRONT, GL_SPECULAR, mat_spe);
	glMaterialfv(GL_FRONT, GL_EMISSION, mat_emi);
	glMaterialf(GL_FRONT, GL_SHININESS, mat_shi);

	for (i = 1; i < 5; i++) {
		glPushMatrix();
		glTranslatef(-2.8, 2.8, 0.35 * i);
		glRotatef(90.0, 0.0, 1.0, 0.0);
		glRotatef(45.0, 1.0, 0.0, 0.0);
		corn2o(0.0, 0.4, 0.05, 0.10, 1.0, 1.0, 2.0, 2.0, partition);
		glPopMatrix();
	}

	for (i = 1; i < 5; i++) {
		glPushMatrix();
		glTranslatef(2.8, -2.8, 0.35 * i);
		glRotatef(90.0, 0.0, 1.0, 0.0);
		glRotatef(225.0, 1.0, 0.0, 0.0);
		corn2o(0.0, 0.4, 0.05, 0.10, 1.0, 1.0, 2.0, 2.0, partition);
		glPopMatrix();
	}

	for (i = 1; i < 5; i++) {
		glPushMatrix();
		glTranslatef(-2.8, -2.8, 0.35 * i);
		glRotatef(90.0, 0.0, 1.0, 0.0);
		glRotatef(-45, 1.0, 0.0, 0.0);
		corn2o(0.0, 0.4, 0.05, 0.10, 1.0, 1.0, 2.0, 2.0, partition);
		glPopMatrix();
	}

	for (i = 1; i < 5; i++) {
		glPushMatrix();
		glTranslatef(2.8, 2.8, 0.35 * i);
		glRotatef(90.0, 0.0, 1.0, 0.0);
		glRotatef(-225.0, 1.0, 0.0, 0.0);
		corn2o(0.0, 0.4, 0.05, 0.10, 1.0, 1.0, 2.0, 2.0, partition);
		glPopMatrix();
	}

	glMaterialfv(GL_FRONT, GL_AMBIENT, rope_amb);
	glMaterialfv(GL_FRONT, GL_SPECULAR, rope_spe);
	glMaterialfv(GL_FRONT, GL_EMISSION, rope_emi);
	glMaterialf(GL_FRONT, GL_SHININESS, rope_shi);

	for (i = 1; i < 5; i++) {
		glMaterialfv(GL_FRONT, GL_DIFFUSE, rope_color[i]);
		glPushMatrix();
		glTranslatef(0.0, -2.7, 0.35 * i);
		glRotatef(90.0, 0.0, 1.0, 0.0);
		pillaro(-2.7, 2.7, 0.025, partition);
		glPopMatrix();
	}

	for (i = 1; i < 5; i++) {
		glMaterialfv(GL_FRONT, GL_DIFFUSE, rope_color[i]);
		glPushMatrix();
		glTranslatef(0.0, 2.7, 0.35 * i);
		glRotatef(90.0, 0.0, 1.0, 0.0);
		pillaro(-2.7, 2.7, 0.025, partition);
		glPopMatrix();
	}

	for (i = 1; i < 5; i++) {
		glMaterialfv(GL_FRONT, GL_DIFFUSE, rope_color[i]);
		glPushMatrix();
		glTranslatef(-2.7, 0.0, 0.35 * i);
		glRotatef(90.0, 1.0, 0.0, 0.0);
		pillaro(-2.7, 2.7, 0.025, partition);
		glPopMatrix();
	}

	for (i = 1; i < 5; i++) {
		glMaterialfv(GL_FRONT, GL_DIFFUSE, rope_color[i]);
		glPushMatrix();
		glTranslatef(2.7, 0.0, 0.35 * i);
		glRotatef(90.0, 1.0, 0.0, 0.0);
		pillaro(-2.7, 2.7, 0.025, partition);
		glPopMatrix();
	}
}

void sandbag(int partition) {
	GLfloat mat1_dif[4] = {0.2, 0.2, 0.2, 1.0};
	GLfloat mat1_amb[4] = {0.2, 0.2, 0.2, 1.0};
	GLfloat mat1_spe[4] = {0.0, 0.0, 0.0, 1.0};
	GLfloat mat1_emi[4] = {0.0, 0.0, 0.0, 1.0};
	GLfloat mat1_shi = 0.0;

	GLfloat mat2_dif[4] = {0.1, 0.1, 0.1, 1.0};
	GLfloat mat2_amb[4] = {0.2, 0.2, 0.2, 1.0};
	GLfloat mat2_spe[4] = {1.0, 1.0, 1.0, 1.0};
	GLfloat mat2_emi[4] = {0.0, 0.0, 0.0, 1.0};
	GLfloat mat2_shi = 120.0;

	GLfloat mat3_dif[4] = {0.4, 0.5, 0.9, 1.0};
	GLfloat mat3_amb[4] = {0.2, 0.2, 0.2, 1.0};
	GLfloat mat3_spe[4] = {0.8, 0.8, 0.8, 1.0};
	GLfloat mat3_emi[4] = {0.0, 0.0, 0.0, 1.0};
	GLfloat mat3_shi = 100.0;

	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat3_dif);
	glMaterialfv(GL_FRONT, GL_AMBIENT, mat3_amb);
	glMaterialfv(GL_FRONT, GL_SPECULAR, mat3_spe);
	glMaterialfv(GL_FRONT, GL_EMISSION, mat3_emi);
	glMaterialf(GL_FRONT, GL_SHININESS, mat3_shi);

	glPushMatrix();
		glMaterialfv(GL_FRONT, GL_DIFFUSE, mat1_dif);
		glMaterialfv(GL_FRONT, GL_AMBIENT, mat1_amb);
		glMaterialfv(GL_FRONT, GL_SPECULAR, mat1_spe);
		glMaterialfv(GL_FRONT, GL_EMISSION, mat1_emi);
		glMaterialf(GL_FRONT, GL_SHININESS, mat1_shi);
		glTranslatef(0.0, 0.0, -0.15);
		pillar_top(0.15, 0.25, partition);
	glPopMatrix();  

	glPushMatrix();
		glMaterialfv(GL_FRONT, GL_DIFFUSE, mat3_dif);
		glMaterialfv(GL_FRONT, GL_AMBIENT, mat3_amb);
		glMaterialfv(GL_FRONT, GL_SPECULAR, mat3_spe);
		glMaterialfv(GL_FRONT, GL_EMISSION, mat3_emi);
		glMaterialf(GL_FRONT, GL_SHININESS, mat3_shi);
		glTranslatef(0.0, 0.0, -0.75);
		pillaro(0.0, 0.60, 0.25, partition);
	glPopMatrix();  

	glPushMatrix();
		glMaterialfv(GL_FRONT, GL_DIFFUSE, mat2_dif);
		glMaterialfv(GL_FRONT, GL_AMBIENT, mat2_amb);
		glMaterialfv(GL_FRONT, GL_SPECULAR, mat2_spe);
		glMaterialfv(GL_FRONT, GL_EMISSION, mat2_emi);
		glMaterialf(GL_FRONT, GL_SHININESS, mat2_shi);
		glTranslatef(0.0, 0.0, -1.45);
		pillaro(0.0, 0.70, 0.25, partition);
	glPopMatrix();  

	glPushMatrix();
		glMaterialfv(GL_FRONT, GL_DIFFUSE, mat1_dif);
		glMaterialfv(GL_FRONT, GL_AMBIENT, mat1_amb);
		glMaterialfv(GL_FRONT, GL_SPECULAR, mat1_spe);
		glMaterialfv(GL_FRONT, GL_EMISSION, mat1_emi);
		glMaterialf(GL_FRONT, GL_SHININESS, mat1_shi);
		glRotatef(180.0, 0.0, 1.0, 0.0);
		glTranslatef(0.0, 0.0, 1.45);
		pillar_top(0.15, 0.25, partition);
	glPopMatrix();  
}

void dome(int partition){
	GLfloat mat1_dif[4] = {0.3, 0.3, 0.4, 1.0};
	GLfloat mat1_amb[4] = {0.2, 0.2, 0.2, 1.0};
	GLfloat mat1_spe[4] = {0.0, 0.0, 0.0, 1.0};
	GLfloat mat1_emi[4] = {0.3, 0.3, 0.3, 1.0};
	GLfloat mat1_shi = 0.0;	

	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat1_dif);
	glMaterialfv(GL_FRONT, GL_AMBIENT, mat1_amb);
	glMaterialfv(GL_FRONT, GL_SPECULAR, mat1_spe);
	glMaterialfv(GL_FRONT, GL_EMISSION, mat1_emi);
	glMaterialf(GL_FRONT, GL_SHININESS, mat1_shi);   

	glPushMatrix();
	    glTranslatef(0.0, 0.0, -1.0);    
		glRotatef(180.0, 0.0, 1.0, 0.0);
		half_elipse2_otherside(10.0, 10.0, 10.0, 10.0, 10.0, partition);                            
	glPopMatrix();
}


void background(int partition){
/*
	GLfloat mat1_dif[4] = {0.3, 0.3, 0.4, 1.0};
	GLfloat mat1_amb[4] = {0.2, 0.2, 0.2, 1.0};
	GLfloat mat1_spe[4] = {0.0, 0.0, 0.0, 1.0};
	GLfloat mat1_emi[4] = {0.3, 0.3, 0.3, 1.0};
	GLfloat mat1_shi = 0.0;
*/	
	GLfloat mat1_dif[4] = {1.0, 1.0, 1.0, 1.0};
	GLfloat mat1_amb[4] = {0.2, 0.2, 0.2, 1.0};
	GLfloat mat1_spe[4] = {0.0, 0.0, 0.0, 1.0};
	GLfloat mat1_emi[4] = {0.3, 0.3, 0.3, 1.0};   
	GLfloat mat1_shi = 0.0;
	
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat1_dif);
	glMaterialfv(GL_FRONT, GL_AMBIENT, mat1_amb);
	glMaterialfv(GL_FRONT, GL_SPECULAR, mat1_spe);
	glMaterialfv(GL_FRONT, GL_EMISSION, mat1_emi);
	glMaterialf(GL_FRONT, GL_SHININESS, mat1_shi);

	glPushMatrix();
		glTranslatef(0.0, 0.0, -1.0);
		glRotatef(180.0, 0.0, 1.0, 0.0);
//		half_elipse2_othersidewt(5.0, 5.0, 5.0, 5.0, 5.0, partition);
		half_elipse2_othersidewt(10.0, 10.0, 10.0, 10.0, 10.0, partition);
	glPopMatrix();
}


void normal_vector(
	float x1, float y1, float z1,
	float x2, float y2, float z2,
	float x3, float y3, float z3) {
	float vx1, vy1, vz1;
	float vx2, vy2, vz2;
	float nx, ny, nz;
	vx1 = x2 - x1;
	vy1 = y2 - y1;
	vz1 = z2 - z1;
	vx2 = x3 - x1;
	vy2 = y3 - y1;
	vz2 = z3 - z1;
	nx = vy1*vz2 - vz1*vy2;
	ny = vz1*vx2 - vx1*vz2;
	nz = vx1*vy2 - vy1*vx2;
    glNormal3f(nx, ny, nz);	
}

void triangles(
	float x1, float y1, float z1,
	float x2, float y2, float z2,
	float x3, float y3, float z3) {
	normal_vector(x1, y1, z1, x2, y2, z2, x3, y3, z3);
    glVertex3f(x1, y1, z1);
    glVertex3f(x2, y2, z2);
    glVertex3f(x3, y3, z3);	
}

void triangle(
	float x1, float y1, float z1,
	float x2, float y2, float z2,
	float x3, float y3, float z3) {
	glBegin(GL_TRIANGLE_STRIP);
	triangles(x1, y1, z1, x2, y2, z2, x3, y3, z3);
	glEnd();
}

void square(
	float x1, float y1, float z1,
	float x2, float y2, float z2,
	float x3, float y3, float z3,
	float x4, float y4, float z4) {
	triangles(x1, y1, z1, x2, y2, z2, x3, y3, z3);
    glVertex3f(x4, y4, z4);	
}

void oval(float a1, float a2, float b1, float b2) {
	static GLint i, p;
	static GLdouble o, o1;
	static GLdouble x, y, a, b;

	p = 12;
	o = DPI / (double)p;

	glBegin(GL_TRIANGLE_FAN);
	glNormal3f(0.0, 1.0, 0.0);
	glVertex3f(0.0, 0.0, 0.0);
	for (i = p; i >= 0; i--) {
		if (i< p/2) {
			b = b1;
		} else {
			b = b2;
		}
		if (i< p/4 || i >= p*3/4) {
			a = a1;
		} else {
			a = a2;
		}
		
		o1 = o * (double)i;
		x = a * cos(o1);  
		y = b * sin(o1);  
		glVertex3f(x, 0.0, y);
	}
	glEnd();              
}

void circle(float a, float b) {
	oval(a, a, b, b);
}

void rectangle(float x, float z) {
	glBegin(GL_QUADS);
    glNormal3f(0.0, 1.0, 0.0);
    glVertex3f( x, 0,  z);
	glVertex3f( x, 0, -z);
    glVertex3f(-x, 0, -z);
	glVertex3f(-x, 0,  z);
	glEnd();              
}


void eye_ball(float a1, float a2, float b, float c, float t) {
	glPushMatrix();
	glTranslatef(a1*t, b*1.01, -c*0.05);
 	circle(a1*0.1, a1*0.1);
	glPopMatrix();
	glPushMatrix();
	glTranslatef(-a2*t, b*1.01, -c*0.05);
 	circle(a2*0.1, a2*0.1);
	glPopMatrix();
}

void eye(float a1, float a2, float b, float c, float t, int form) {
	glPushMatrix();
	glTranslatef(a1*t, b, -c*0.05);
	switch (form) {
		case 2:
			oval(a1*0.2, a1*0.2, a1*0.1, a1*0.15);
		break;
		case 3:
			oval(a1*0.2, a1*0.2, a1*0.15, a1*0.1);
		break;
		case 4:
			circle(a1*0.15, a1*0.15);
		break;
		case 5:
			rectangle(a1*0.15, a1*0.15);
		break;
		case 6:
			triangle(0.0, 0.0, -a1*0.15, -a1*0.3, 0.0, a1*0.1, a1*0.3, 0.0, a1*0.1);
		break;
		case 7:
			triangle(0.0, 0.0, a1*0.15, a1*0.25, 0.0, -a1*0.1, -a1*0.25, 0.0, -a1*0.1);
		break;
		default:
			circle(a1*0.2, a1*0.1);
		break;
	}
	glPopMatrix();
	glPushMatrix();
	glTranslatef(-a2*t, b, -c*0.05);
	switch (form) {
		case 2:
		 	oval(a2*0.2, a2*0.2, a2*0.1, a2*0.15);
		break;
		case 3:
		 	oval(a2*0.2, a2*0.2, a2*0.15, a2*0.1);
		break;
		case 4:
		 	circle(a2*0.15, a2*0.15);
		break;
		case 5:
			rectangle(a2*0.15, a2*0.15);
		break;
		case 6:
			triangle(0.0, 0.0, -a2*0.15, -a2*0.3, 0.0, a2*0.1, a2*0.3, 0.0, a2*0.1);
		break;      
		case 7:
			triangle(0.0, 0.0, a2*0.15, a2*0.25, 0.0, -a2*0.1, -a2*0.25, 0.0, -a2*0.1);
		break;      
		default:
		 	circle(a2*0.2, a2*0.1);
		break;
	}
	glPopMatrix();
}

void eyebrow(float a1, float a2, float b, float c, float r, float t, int form) {
	glPushMatrix();
	glTranslatef(a1*0.4, b, c*0.1);
	glRotatef(-r, 0.0, 1.0, 0.0);
	switch (form) {
		case 1:
		 	circle(a1*0.25, a1*0.05*t);	
		break;
		case 2:
		 	triangle(-a1*0.25, 0.0, 0.0, a1*0.25, 0.0, a1*0.1*t, a1*0.25, 0.0, 0.0);	
		break;
		case 3:
		 	triangle(-a1*0.4, 0.0, 0.0, a1*0.25, 0.0, a1*0.1*t, a1*0.25, 0.0, 0.0);	
		break;
		default:
		 	rectangle(a1*0.25, a1*0.05*t);
		break;
	}
	glPopMatrix();
	
	glPushMatrix();
	glTranslatef(-a2*0.4, b, c*0.1);
	glRotatef(+r, 0.0, 1.0, 0.0);
	switch (form) {
		case 1:
		 	circle(a2*0.25, a2*0.05*t);	
		break;
		case 2:
		 	triangle(a2*0.25, 0.0, 0.0, -a2*0.25, 0.0, 0.0, -a2*0.25, 0.0, a2*0.1*t);	
		break;
		case 3:
		 	triangle(a2*0.4, 0.0, 0.0, -a2*0.25, 0.0, 0.0, -a2*0.25, 0.0, a2*0.1*t);	
		break;
		default:
		 	rectangle(a2*0.25, a2*0.05*t);
		break;
	}
	glPopMatrix();
}

void nose(float a, float b, float c) {
	float x, y, z;
	x = a * 0.125;
	y = b * 0.5;
	z = c * 0.35;

	glPushMatrix();
	glTranslatef(0.0, b*0.9, 0.0);
	glBegin(GL_TRIANGLES);
	triangles( x, 0.0, -z, 0.0, y, -z, x, 0.0, -z);
	triangles( x, 0.0, -z, 0.0, y, -z, 0.0, 0.0, 0.0);
	triangles(-x, 0.0, -z, 0.0, 0.0, 0.0, 0.0, y, -z);
	glEnd();              
	glPopMatrix();
}

void nose2(float a, float b, float c) {
	float x, y, z;
	x = a * 0.125;
	y = b * 0.6;
	z = c * 0.25;

	glPushMatrix();
	glTranslatef(0.0, b, -z);
	glRotatef(-90.0, 1.0, 0.0, 0.0);
	half_sphere(x, 24);	
	glPopMatrix();
}

void nose3(float a, float b, float c) {
	float x, y, z;
	x = a * 0.125;
	y = b * 0.6;
	z = c * 0.25;

	glPushMatrix();
	glTranslatef(0.0, b*0.9, -z);
	glRotatef(-90.0, 1.0, 0.0, 0.0);
	corn2o(0.0, y, x, 0.0, 1.0, 1.0, 1.0, 1.0, 24);	
	glPopMatrix();
}

void nose4(float a, float b, float c) {
	float x, y, z;
	x = a * 0.075;
	y = b * 0.6;
	z = c * 0.25;

	glPushMatrix();
	glTranslatef(0.0, b*0.9, -z);
	glRotatef(-90.0, 1.0, 0.0, 0.0);
	pillar(0.0, y, x, 24);	
	glPopMatrix();
}

void nose5(float a, float b, float c) {
	float x, y, z;
	x = a * 0.075;
	y = b * 0.25;
	z = c * 0.30;

	glPushMatrix();
	glTranslatef(0.0, b+y, -z);
	box(x, y, x*2.0);	
	glPopMatrix();
}

void ear(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c, GLint q) {
	GLint i, p = q/4;
	GLdouble r1, r2;
	GLdouble z1, z2;
	GLdouble nz1 ,nz2;
	GLdouble ts, t;
	GLint s, e;
	s = 0;
	e = 36;

	ts = - PI2;
	t = PI2 / (double)p;

	for (i = 0; i < p; i++) {
		z1 =  sin (ts + t * (double)i);
		z2 =  sin (ts + t * (double)(i+1));

		if (i == 0) {
			r1 = 0.0;
		} else {
			r1 = sqrt(1.0 - z1 * z1);
		}	
		r2 = sqrt(1.0 - z2 * z2);		
		
		nz1 = z1 / c;
		nz2 = z2 / c;
		z1 *= c;
		z2 *= c;
		fan_poly(z1, z2, r1, r2, nz1, nz2, a1, a2, b1, b2, q, 1, s, e);
	}
}

void mouth(float a, float b, float c, int form) {
	glPushMatrix();
	glTranslatef(0.0, b*0.9, -c*0.5);
	switch (form) {
		case 2:
			oval(a*0.25, a*0.25, a*0.01, a*0.05);
		break;
		case 3:
			oval(a*0.25, a*0.25, a*0.01, a*0.1);
		break;
		case 4:
			oval(a*0.25, a*0.25, a*0.05, a*0.01);
		break;
		case 5:
			triangle(-a*0.25, 0.0, 0.0, a*0.25, 0.0, 0.0, 0.0, 0.0, -a*0.15);
		break;
		case 6:
			oval(a*0.1, a*0.1, a*0.05, a*0.1);
		break;
		default:
			circle(a*0.25, a*0.05);
		break;	
	}
	glPopMatrix();
}

void hairline(GLint q, GLdouble ra, GLdouble hl, GLdouble hbb, GLdouble hbe, GLint is_back) {
	GLint j;
	GLdouble x0, y0, z0, y1, z1, r1, hb;
	GLdouble ts, t, t1;

	ts = -PI2;
	t = -PI / (double)36;

	x0 = 0.0;
	y0 = 0.0;
	z0 = 0.0;
	glBegin(GL_TRIANGLE_STRIP);
	for (j = 0; j <= q; j++) {
		t1 = ts + t * (double)j;
		r1 = -ra * (1.0 + sin(t1));  
		y1 = r1 * cos(t1);
		z1 = r1 * sin(t1) * hl;
		hb = hbb * (1.0 - hbe * (float)j / (float)q);	

		if (is_back) {
			normal_vector(x0, y0, z0, y1, hb, z1, y1, -hb, z1);
			glVertex3f(y1, -hb, z1);
			glVertex3f(y1,  hb, z1);
			x0 = y1;
			y0 = hb;
			z0 = z1;		
		} else {
			normal_vector(x0, y0, z0, y1, -hb, z1, y1, hb, z1);
			glVertex3f(y1,  hb, z1);
			glVertex3f(y1, -hb, z1);
			x0 = y1;
			y0 = -hb;
			z0 = z1;
		}
	}
	glEnd();        
}

void hair(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c1, GLdouble c2) {
	GLint i, p = 36;
	GLint q[] = {36, 35, 34, 33, 28, 28, 28, 28, 28,
	             33, 33, 33, 33, 33, 33, 34, 35, 36, 
				 36, 36, 36, 36, 36, 36, 36, 36, 36,
				 36, 36, 36, 36, 36, 36, 36, 36, 36};
	GLdouble x, y, ra, hl;
	GLdouble os, o, o1, a, b, aa, bb;

	os = 0.0;
	o = DPI / (double)p;

	for (i = 0; i < p; i++) {
		if (i< p/2) {
			b = b1;
		} else {
			b = b2;
		}
		bb = b*b;

		if (i< p/4 || i >= p*3/4) {
			a = a1;
		} else {
			a = a2;
		}
		aa = a*a;

		o1 = os + o * (double)i;
		x = a * cos(o1);  
		y = b * sin(o1);  
		ra = sqrt(x*x+y*y);

		if (i < p/2) {
			hl = 1.0;
		} else {  
			hl = 1.4;
		}

		glPushMatrix();
		glRotatef(DEG(o1), 0.0, 0.0, 1.0);
		hairline(q[i], ra, hl, 0.0225, 0.8);
		glPopMatrix();
	}
}

void hair_mohican(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c1, GLdouble c2) {
	a1 = a1 * 0.25;
	a2 = a2 * 0.25;
	b1 = b1 * 0.8;
	b2 = b2 * 0.8;
	c2 = c2 * 0.3;
	c2 = c2 * 0.4;
	
	glBegin(GL_QUADS);
    glNormal3f(0.0, 0.0, 1.0);
    glVertex3f( a2,  b1, c2);
	glVertex3f(-a1,  b1, c2);
    glVertex3f(-a1, -b2, c2);
	glVertex3f( a2, -b2, c2);

	glNormal3f(0.0, 1.0, 0.0);
    glVertex3f( a1, b1,  c2);
	glVertex3f( a1, b1, -c1);
    glVertex3f(-a2, b1, -c1);
	glVertex3f(-a2, b1,  c2);

    glNormal3f(0.0, -1.0, 0.0);
    glVertex3f(-a2, -b2, -c1);
	glVertex3f( a1, -b2, -c1);
    glVertex3f( a1, -b2,  c2);
	glVertex3f(-a2, -b2,  c2);

    glNormal3f(1.0, 0.0, 0.0);
    glVertex3f( a1,  b1,  c2);
	glVertex3f( a1, -b2,  c2);
    glVertex3f( a1, -b2, -c1);
	glVertex3f( a1,  b1, -c1);

    glNormal3f(-1.0, 0.0, 0.0);
    glVertex3f(-a2, -b2, -c1);
	glVertex3f(-a2, -b2,  c2);
    glVertex3f(-a2,  b1,  c2);
	glVertex3f(-a2,  b1, -c1);
 	glEnd();
}
	
void hair_mushroom(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c1, GLdouble c2) {
	glTranslatef(0.0, 0.0, -c2*0.9);
	glRotatef(180, 0.0, 1.0, 0.0);
	ear(a2 * 1.2, a1*1.2, b1*1.2, b2*1.2, c2, 24);              
}

void hair_oneline(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c1, GLdouble c2) {
	glPushMatrix();
	glRotatef(90.0, 0.0, 0.0, 1.0);
	glRotatef(15.0, 1.0, 0.0, 0.0);
	hairline(36, b2, 1.0, 0.03, 1.0);
	glPopMatrix();
	glPushMatrix();
	glRotatef(90.0, 0.0, 0.0, 1.0);
	glRotatef(15.0, 1.0, 0.0, 0.0);
	hairline(36, b2, 1.0, 0.03, 1.0, 1);
	glPopMatrix();
}

void hair_tree(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c1, GLdouble c2) {
	float r = (a1+a2)*0.1;
	pillaro(0.0, c2*0.25, r, 12);
	r *= 1.5;
	glPushMatrix();
	glTranslatef(r*sqrt(3.0)*0.5, -r*0.5, c2*0.5-r);
	sphere(r, 12);	
	glPopMatrix();              
	glPushMatrix();
	glTranslatef(0.0, r, c2*0.5-r);
	sphere(r, 12);	
	glPopMatrix();              
	glPushMatrix();
	glTranslatef(-r*sqrt(3.0)*0.5, -r*0.5, c2*0.5-r);
	sphere(r, 12);	
	glPopMatrix();              
	glPushMatrix();
	glTranslatef(0.0, 0.0, c2*0.5);
	sphere(r, 12);	
	glPopMatrix();              
}

void hair_perma(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c1, GLdouble c2) {
	glPushMatrix();
	glTranslatef(0.0, -0.5*b1, -c2*0.8);
	glRotatef(-30.0, 1.0, 0.0, 0.0);
	elipse2(a1*1.5, a2*1.5, b1*1.25, b2*1.20, c1*0.8, c2*1.2, 24);
	glPopMatrix();
}

void hair_hedgehog(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c1, GLdouble c2) {
	GLint j, q = 9;
	GLdouble ts, t, t1;

	glPushMatrix();
	glTranslatef(0.0, 0.0, -c2*0.5);
	corn2o(0.0, c2*2.0, a1*0.5, 0.0, a1/a1, a2/a1, b1/b1, b2/b1, 24);
	glPopMatrix();

	ts = -PI2;
	t = DPI / (double)q;

	for (j = 0; j < q; j++) {
		t1 = ts + t * (double)j;
		glPushMatrix();
		glRotatef(DEG(t1), 0.0, 0.0, 1.0);
		glTranslatef(0.0, b1*0.5, -c2*0.75);
		glRotatef(-15.0, 1.0, 0.0, 0.0);
		corn2o(0.0, c2*1.5, a1*0.4, 0.0, a1/a1, a2/a1, b1/b1, b2/b1, 24);
		glPopMatrix();
	}
}

void hair_sport(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c1, GLdouble c2) {
	GLint i, p = 36;
	GLdouble x, y, ra, hl;
	GLdouble os, o, o1, a, b, aa, bb;

	os = 0.0;
	o = DPI / (double)p;

	for (i = 0; i < p; i++) {
		if (i< p/2) {
			b = b1;
		} else {
			b = b2;
		}
		bb = b*b;

		if (i< p/4 || i >= p*3/4) {
			a = a1;
		} else {
			a = a2;
		}
		aa = a*a;

		o1 = os + o * (double)i;
		x = a * cos(o1);  
		y = b * sin(o1);  
		ra = sqrt(x*x+y*y);

		glPushMatrix();
		glRotatef(DEG(o1), 0.0, 0.0, 1.0);
		if (i < 2) {
			hairline(30, ra, 1.0, 0.0225, 0.8);
		} else if (i >= 2 && i < 16) {
		} else if (i >= 16 && i < 18) {
			hairline(36, ra, 1.0, 0.0225, 0.8);
		} else {
			hairline(36, ra, 1.3, 0.0225, 0.8);		
		}
		glPopMatrix();
	}
	
	a1 = a1*0.8;
	a2 =-a2*0.8; 
	glBegin(GL_TRIANGLES);
	triangles(a1, b1*1.2, c2*0.1, 0.0, b1*1.1, -c2*0.5, a2, b1*1.2, c2*0.1);

	triangles(a1, b1*1.2, c2*0.1, a1*1.3, 0.0, -c2*0.8, 0.0, b1*1.1, -c2*0.5);
	triangles(a1, b1*1.2, c2*0.1, a1, 0.0, c2*0.1, a1*1.3, 0.0, -c2*0.8);

	triangles(a2, b1*1.2, c2*0.1, 0.0, b1*1.1, -c2*0.5, a2*1.3, 0.0, -c2*0.8);
	triangles(a2, b1*1.2, c2*0.1, a2*1.3, 0.0, -c2*0.8, a2, 0.0, c2*0.1);
 	glEnd();

	glBegin(GL_QUADS);
	square(a1, 0.0, c2*0.1, a1, b1*1.2, c2*0.1, a2, b1*1.2, c2*0.1, a2, 0.0, c2*0.1);
	square(a1, 0.0, c2*0.1, a2, 0.0, c2*0.1, a2*1.3, 0.0, -c2*0.8, a1*1.3, 0.0, -c2*0.8);
 	glEnd();
}


void hair_regent(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c1, GLdouble c2) {
	GLint i, p = 36;
	GLdouble x, y, ra, hl;
	GLdouble os, o, o1, a, b, aa, bb;

	os = 0.0;
	o = DPI / (double)p;

	for (i = 0; i < p; i++) {
		if (i< p/2) {
			b = b1;
		} else {
			b = b2;
		}
		bb = b*b;

		if (i< p/4 || i >= p*3/4) {
			a = a1;
		} else {
			a = a2;
		}
		aa = a*a;

		o1 = os + o * (double)i;
		x = a * cos(o1);  
		y = b * sin(o1);  
		ra = sqrt(x*x+y*y);

		glPushMatrix();
		glRotatef(DEG(o1), 0.0, 0.0, 1.0);
		if (i < 2) {
			hairline(30, ra, 1.0, 0.0225, 0.8);
		} else if (i >= 2 && i < 16) {
		} else if (i >= 16 && i < 18) {
			hairline(36, ra, 1.0, 0.0225, 0.8);
		} else {
			hairline(36, ra, 1.3, 0.0225, 0.8);		
		}
		glPopMatrix();
	}
	glPushMatrix();
	glTranslatef(0.0, 0.0, -c2*0.4);
	elipse2(a1*1.2, a2*1.2, b1*3.0, b1*0.1, c2*0.4, c2*0.6, 24);	
	glPopMatrix();                      
}

bool IsHitSphere(float xp, float yp, float zp, float rp,
		float x1, float y1, float z1, float r1) {
	static float dx, dy, dz, dr;
	dx = xp - x1;
	dy = yp - y1;
	dz = zp - z1;
	dr = rp + r1;
//	wxLogError("xp = %f yp = %f zp = %f", xp, yp, zp);
//	wxLogError("x1 = %f y1 = %f z1 = %f", x1, y1, z1);
//	wxLogError("rp = %f r1 = %f", rp, r1);
	if ( (dx * dx + dy * dy + dz * dz) < dr * dr ) {
		return true;	
	}
	return false;
}

bool IsHitPillar(float xp, float yp, float zp, float rp,
	 	float x1, float y1, float z1,
 		float x2, float y2, float z2, float r) {
	static float a, b, c, ap, bp, cp;
	static float v, t, st;
	static float dx, dy, dz, dr;
	a = x2 - x1;
	b = y2 - y1;
	c = z2 - z1;
	ap = xp - x1;
	bp = yp - y1;
	cp = zp - z1;
	v = a*a + b*b + c*c;
	t = (ap * a + bp * b + cp *c) / v; 
	dx = ap - a * t;
	dy = bp - b * t;
	dz = cp - c * t;
	dr = r + rp;
	st = rp / sqrt(v);
	if ( (dx * dx + dy * dy + dz * dz) < dr*dr ) {
//		wxLogError("st = %f t = %f", st, t);
		if ( (t > -st) && (t < 1.0 + st) ) {
			return true;
		}	
	}
	return false;	
}
