#include "matpage.h"
#include "myglcanvas.h"
#include "myslider.h"
#include "boxer.h"

myMaterial::myMaterial(wxWindow* parent, const wxString& name) : wxToggleButton(parent, -1, name) {
	SetProperties();
	DoLayout();
}

void myMaterial::SetProperties() {
}

void myMaterial::DoLayout() {
}

BEGIN_EVENT_TABLE(MatPage, wxScrolledWindow)
	EVT_TOGGLEBUTTON(-1, MatPage::OnToggle) 
END_EVENT_TABLE()

MatPage::MatPage(wxWindow* parent, myGLCanvas *ccanvas) : wxScrolledWindow(parent, -1) {
	canvas = ccanvas;
	SetProperties();
	DoLayout();
}

void MatPage::SetProperties() {
	SetScrollRate(10,10);
	myMaterial *glove = new myMaterial(this, wxT(""));			
	myMaterial *bandage = new myMaterial(this, wxT("Хǡ"));			
	myMaterial *skin = new myMaterial(this, wxT("ȩ"));			
	myMaterial *trunks = new myMaterial(this, wxT("ȥ󥯥"));			
	myMaterial *shoes = new myMaterial(this, wxT("塼"));			

	mats.Add(glove);
	mats.Add(bandage);
	mats.Add(skin);
	mats.Add(trunks);
	mats.Add(shoes);

	dif_r = new mySlider(this, canvas, wxT("Red : "), 0, 255);
	dif_g = new mySlider(this, canvas, wxT("Green : "), 0, 255);
	dif_b = new mySlider(this, canvas, wxT("Blue : "), 0, 255);
	dif_a = new mySlider(this, canvas, wxT("Alpha : "), 0, 255);

	amb_r = new mySlider(this, canvas, wxT("Red : "), 0, 255);
	amb_g = new mySlider(this, canvas, wxT("Green : "), 0, 255);
	amb_b = new mySlider(this, canvas, wxT("Blue : "), 0, 255);
	amb_a = new mySlider(this, canvas, wxT("Alpha : "), 0, 255);

	spe_r = new mySlider(this, canvas, wxT("Red : "), 0, 255);
	spe_g = new mySlider(this, canvas, wxT("Green : "), 0, 255);
	spe_b = new mySlider(this, canvas, wxT("Blue : "), 0, 255);
	spe_a = new mySlider(this, canvas, wxT("Alpha : "), 0, 255);

	emi_r = new mySlider(this, canvas, wxT("Red : "), 0, 255);
	emi_g = new mySlider(this, canvas, wxT("Green : "), 0, 255);
	emi_b = new mySlider(this, canvas, wxT("Blue : "), 0, 255);
	emi_a = new mySlider(this, canvas, wxT("Alpha : "), 0, 255);

	shi = new mySlider(this, canvas, wxT("Intensity : "), 0, 128);

	mats[0]->mat.DefDiffuse(1.0, 0.0, 0.0);
	mats[0]->mat.DefSpecular(1.0, 1.0, 1.0);
	mats[0]->mat.DefShininess(100.0);
    mats[4]->mat = mats[0]->mat;

	mats[1]->mat.DefDiffuse(1.0, 1.0, 1.0);

	mats[2]->mat.DefDiffuse(1.0, 0.6, 0.6);

	mats[3]->mat.DefDiffuse(0.1, 0.1, 0.1);
	mats[3]->mat.DefSpecular(1.0, 1.0, 1.0);
	mats[3]->mat.DefShininess(100.0);
 
	max_mats = mats.Count();
	select_mat = 0;
	LoadMaterial();
	GetMat()->SetValue(true);
}

void MatPage::DoLayout() {
	int i;
    tsizer = new wxBoxSizer(wxVERTICAL);
	gsizer = new wxGridSizer(max_mats/3, 3, 0, 0);

	wxStaticBoxSizer *bsizer0 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("")), wxVERTICAL);
 	wxStaticBoxSizer *bsizer1 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ǥե塼")), wxVERTICAL);
  	wxStaticBoxSizer *bsizer2 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ӥ")), wxVERTICAL);
  	wxStaticBoxSizer *bsizer3 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ڥ顼")), wxVERTICAL);
	wxStaticBoxSizer *bsizer4 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ߥå")), wxVERTICAL);
	wxStaticBoxSizer *bsizer5 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ȿͶ")), wxHORIZONTAL);

	tsizer->Add(bsizer0, 0, wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 5);
	tsizer->Add(bsizer1, 0, wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 5);
	tsizer->Add(bsizer2, 0, wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 5);
	tsizer->Add(bsizer3, 0, wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 5);
	tsizer->Add(bsizer4, 0, wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 5);
	tsizer->Add(bsizer5, 0, wxALIGN_CENTER_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 5);

	bsizer0->Add(gsizer, 0, wxALIGN_CENTRE_HORIZONTAL | wxALIGN_CENTER_VERTICAL | wxALL, 5);
	for (i = 0; i < max_mats; i++) {
		gsizer->Add(mats[i],  0, wxGROW | wxALIGN_CENTRE_VERTICAL | wxALL, 5);
	}

	bsizer1->Add(dif_r, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	bsizer1->Add(dif_g, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	bsizer1->Add(dif_b, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	bsizer1->Add(dif_a, 0, wxGROW |wxALIGN_CENTER_VERTICAL);

	bsizer2->Add(amb_r, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	bsizer2->Add(amb_g, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	bsizer2->Add(amb_b, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	bsizer2->Add(amb_a, 0, wxGROW |wxALIGN_CENTER_VERTICAL);

	bsizer3->Add(spe_r, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	bsizer3->Add(spe_g, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	bsizer3->Add(spe_b, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	bsizer3->Add(spe_a, 0, wxGROW |wxALIGN_CENTER_VERTICAL);

	bsizer4->Add(emi_r, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	bsizer4->Add(emi_g, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	bsizer4->Add(emi_b, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	bsizer4->Add(emi_a, 0, wxGROW |wxALIGN_CENTER_VERTICAL);

	bsizer5->Add(shi, 0, wxGROW |wxALIGN_CENTER_VERTICAL);

	tsizer->SetVirtualSizeHints(this);
  	SetSizer(tsizer);
	FitInside();
    Layout();
}

void MatPage::SetSelectMat(int new_select) {
	mats[new_select]->SetValue(true);

	if (new_select != SelectMat()) {
		GetMat()->SetValue(false);
		SaveMaterial();
		select_mat = new_select;
		LoadMaterial();
	}
// 	tsizer->SetVirtualSizeHints(this);
//	FitInside();
//	Layout();
}


void MatPage::OnToggle(wxCommandEvent &event){
	int i, new_select = 0;
	wxObject *obj = event.GetEventObject();

	for (i = 0; i < max_mats; i++) {
		if(obj == (wxObject*) mats[i]) {
			new_select = i;
			break;
		}
	}
	SetSelectMat(new_select);
}

void MatPage::LoadMaterial() {
	dif_r->SetValueF(GetMat()->mat.DifR(), 255);
	dif_g->SetValueF(GetMat()->mat.DifG(), 255);
	dif_b->SetValueF(GetMat()->mat.DifB(), 255);
	dif_a->SetValueF(GetMat()->mat.DifA(), 255);
	amb_r->SetValueF(GetMat()->mat.AmbR(), 255);
	amb_g->SetValueF(GetMat()->mat.AmbG(), 255);
	amb_b->SetValueF(GetMat()->mat.AmbB(), 255);
	amb_a->SetValueF(GetMat()->mat.AmbA(), 255);
	spe_r->SetValueF(GetMat()->mat.SpeR(), 255);
	spe_g->SetValueF(GetMat()->mat.SpeG(), 255);
	spe_b->SetValueF(GetMat()->mat.SpeB(), 255);
	spe_a->SetValueF(GetMat()->mat.SpeA(), 255);
	emi_r->SetValueF(GetMat()->mat.EmiR(), 255);
	emi_g->SetValueF(GetMat()->mat.EmiG(), 255);
	emi_b->SetValueF(GetMat()->mat.EmiB(), 255);
	emi_a->SetValueF(GetMat()->mat.EmiA(), 255);
	shi->SetValue((int)GetMat()->mat.Shi());
}	

void MatPage::SaveMaterial() {
	GetMat()->mat.DefDiffuse(
		dif_r->GetValue()/255.0,
		dif_g->GetValue()/255.0,
		dif_b->GetValue()/255.0,
		dif_a->GetValue()/255.0);
	GetMat()->mat.DefAmbient(
		amb_r->GetValue()/255.0,
		amb_g->GetValue()/255.0,
		amb_b->GetValue()/255.0,
		amb_a->GetValue()/255.0);
	GetMat()->mat.DefSpecular(
		spe_r->GetValue()/255.0,
		spe_g->GetValue()/255.0,
		spe_b->GetValue()/255.0,
		spe_a->GetValue()/255.0);
	GetMat()->mat.DefEmission(
		emi_r->GetValue()/255.0,
		emi_g->GetValue()/255.0,
		emi_b->GetValue()/255.0,
		emi_a->GetValue()/255.0);
	GetMat()->mat.DefShininess((float)shi->GetValue());
}	

void MatPage::GetMaterial(Boxer &boxer) {
	mats[0]->mat = boxer.glove;
	mats[1]->mat = boxer.bandage;
	mats[2]->mat = boxer.skin;
	mats[3]->mat = boxer.trunks;
	mats[4]->mat = boxer.shoes;
	LoadMaterial(); 
}

void MatPage::SetMaterial(Boxer &boxer) {
	SaveMaterial();
	boxer.glove   = mats[0]->mat;
	boxer.bandage = mats[1]->mat;
	boxer.skin    = mats[2]->mat;
	boxer.trunks  = mats[3]->mat;
	boxer.shoes   = mats[4]->mat; 
	boxer.SetMaterial();
}

bool MatPage::Save(wxTextOutputStream &out) {
	int i;
	wxString str;	
	
	SaveMaterial();
	out << wxT("#Material Data") << endl;
	out << wxT("#Select Material") << endl;
	out << SelectMat() << endl;
	for (i = 0; i < MaxMat(); i++) {
		str.Printf("#Material No.%d", i);
		out << str << endl;
		myMaterial *mat = mats[i];
		out << (int)(mat->mat.DifR()*255) << endl;
		out << (int)(mat->mat.DifG()*255) << endl;
		out << (int)(mat->mat.DifB()*255) << endl;
		out << (int)(mat->mat.DifA()*255) << endl;
		out << (int)(mat->mat.AmbR()*255) << endl;
		out << (int)(mat->mat.AmbG()*255) << endl;
		out << (int)(mat->mat.AmbB()*255) << endl;
		out << (int)(mat->mat.AmbA()*255) << endl;
		out << (int)(mat->mat.SpeR()*255) << endl;
		out << (int)(mat->mat.SpeG()*255) << endl;
		out << (int)(mat->mat.SpeB()*255) << endl;
		out << (int)(mat->mat.SpeA()*255) << endl;
		out << (int)(mat->mat.EmiR()*255) << endl;
		out << (int)(mat->mat.EmiG()*255) << endl;
		out << (int)(mat->mat.EmiB()*255) << endl;
		out << (int)(mat->mat.EmiA()*255) << endl;
		out << (int)(mat->mat.Shi()) << endl; 
	}
	return true;
}

bool MatPage::Load(wxTextInputStream &in) {
	int i, num, r, g, b, a;
	wxString str;

	str = in.ReadLine();
	str = in.ReadLine();
	in >> num;
	if (num >= MaxMat()) {
		wxLogError("ǡ۾Ǥ");
		return false;
	}
	SetSelectMat(num);
	for (i = 0; i < MaxMat(); i++) {
		myMaterial *mat = mats[i];
		str = in.ReadLine();
		in >> r;
		in >> g;
		in >> b;
		in >> a;
		mat->mat.DefDiffuse(
			(float)r/255.0, (float)g/255.0,
			(float)b/255.0, (float)a/255.0);
		in >> r;
		in >> g;
		in >> b;
		in >> a;
		mat->mat.DefAmbient(
			(float)r/255.0, (float)g/255.0,
			(float)b/255.0, (float)a/255.0);
		in >> r;
		in >> g;
		in >> b;
		in >> a;
		mat->mat.DefSpecular(
			(float)r/255.0, (float)g/255.0,
			(float)b/255.0, (float)a/255.0);
		in >> r;
		in >> g;
		in >> b;
		in >> a;
		mat->mat.DefEmission(
			(float)r/255.0, (float)g/255.0,
			(float)b/255.0, (float)a/255.0);
		in >> num;
		mat->mat.DefShininess((float)num);
    }
	LoadMaterial();
	canvas->SetMaterial();			
	canvas->GetBoxer()->MakeDLists();
	return true;
}
