#ifndef	MATPAGE_H
#define MATPAGE_H

#include <wx/wx.h>
#include <wx/tglbtn.h>
#include <wx/wfstream.h>
#include <wx/txtstrm.h>
#include "boxer.h"
#include "glmaterial.h"

class myGLCanvas;
class mySlider;
class MatPage;
class Boxer;

class myMaterial : public wxToggleButton {
public:
	myMaterial(wxWindow* parent, const wxString& name);
	GLMaterial *GetMaterial() {return &mat;}	
private:
    void SetProperties();
    void DoLayout();
	GLMaterial mat;

	friend class MatPage;
};

WX_DEFINE_ARRAY(myMaterial*, myMaterials);

class MatPage : public wxScrolledWindow {
public:
	MatPage(wxWindow* parent, myGLCanvas *ccanvas);
	myMaterial* GetMat() const {return mats[select_mat];}
	int MaxMat() const {return max_mats;}
	int SelectMat() const {return select_mat;}
	void SetSelectMat(int new_select);

	void SaveMaterial();
	void LoadMaterial();	
	void GetMaterial(Boxer &boxer);
	void SetMaterial(Boxer &boxer);
	bool Save(wxTextOutputStream &out);
	bool Load(wxTextInputStream &in);
private:
    void SetProperties();
    void DoLayout();
	void OnToggle(wxCommandEvent &event);		

	int max_mats;
 	int select_mat;
	myMaterials mats;
	wxBoxSizer *tsizer;
	wxGridSizer *gsizer;

	mySlider *dif_r;
	mySlider *dif_g;
	mySlider *dif_b;
	mySlider *dif_a;
	mySlider *amb_r;
	mySlider *amb_g;
	mySlider *amb_b;
	mySlider *amb_a;
	mySlider *spe_r;
	mySlider *spe_g;
	mySlider *spe_b;
	mySlider *spe_a;
	mySlider *emi_r;
	mySlider *emi_g;
	mySlider *emi_b;
	mySlider *emi_a;
	mySlider *shi;

	myGLCanvas *canvas;
	DECLARE_EVENT_TABLE()
};

#endif // MATPAGE_H
