#include "motionpage.h"
#include "myglcanvas.h"
#include "mynotebook.h"
#include "boxer.h"

WX_DEFINE_OBJARRAY(FrameInfos);
WX_DEFINE_OBJARRAY(MotionInfos);

BEGIN_EVENT_TABLE(MotionPanel, wxPanel)
	EVT_BUTTON(ON_RFIST_FIX1_ID, MotionPanel::OnRFistFix1) 
	EVT_BUTTON(ON_RFIST_FIX2_ID, MotionPanel::OnRFistFix2) 
	EVT_BUTTON(ON_RFIST_FIX3_ID, MotionPanel::OnRFistFix3) 
	EVT_BUTTON(ON_RFIST_FIX4_ID, MotionPanel::OnRFistFix4) 
	EVT_BUTTON(ON_LFIST_FIX1_ID, MotionPanel::OnLFistFix1) 
	EVT_BUTTON(ON_LFIST_FIX2_ID, MotionPanel::OnLFistFix2) 
	EVT_BUTTON(ON_LFIST_FIX3_ID, MotionPanel::OnLFistFix3) 
	EVT_BUTTON(ON_LFIST_FIX4_ID, MotionPanel::OnLFistFix4) 
	EVT_BUTTON(ON_RTOE_FIX1_ID, MotionPanel::OnRToeFix1) 
	EVT_BUTTON(ON_RTOE_FIX2_ID, MotionPanel::OnRToeFix2) 
	EVT_BUTTON(ON_RTOE_FIX3_ID, MotionPanel::OnRToeFix3) 
	EVT_BUTTON(ON_RTOE_FIX4_ID, MotionPanel::OnRToeFix4) 
	EVT_BUTTON(ON_LTOE_FIX1_ID, MotionPanel::OnLToeFix1) 
	EVT_BUTTON(ON_LTOE_FIX2_ID, MotionPanel::OnLToeFix2) 
	EVT_BUTTON(ON_LTOE_FIX3_ID, MotionPanel::OnLToeFix3) 
	EVT_BUTTON(ON_LTOE_FIX4_ID, MotionPanel::OnLToeFix4) 
	EVT_BUTTON(ON_WAIST_FIX1_ID, MotionPanel::OnWaistFix1) 
	EVT_BUTTON(ON_WAIST_FIX2_ID, MotionPanel::OnWaistFix2) 
	EVT_BUTTON(ON_WAIST_FIX3_ID, MotionPanel::OnWaistFix3) 
	EVT_BUTTON(ON_WAIST_FIX4_ID, MotionPanel::OnWaistFix4) 
	EVT_BUTTON(ON_HEAD_FIX1_ID, MotionPanel::OnHeadFix1) 
	EVT_BUTTON(ON_HEAD_FIX2_ID, MotionPanel::OnHeadFix2) 
	EVT_BUTTON(ON_HEAD_FIX3_ID, MotionPanel::OnHeadFix3) 
	EVT_BUTTON(ON_HEAD_FIX4_ID, MotionPanel::OnHeadFix4) 
//	EVT_TOGGLEBUTTON(-1, MotionPanel::OnToggle) 
END_EVENT_TABLE()

MotionPanel::MotionPanel(wxWindow* parent, myGLCanvas *ccanvas) : wxPanel(parent, -1) {
	canvas = ccanvas;
	SetProperties();
	DoLayout();
}

void MotionPanel::SetProperties() {
	rfist_x = new ToggleSlider(this, canvas, wxT("X : "), -1200, 1200);
	rfist_y = new ToggleSlider(this, canvas, wxT("Y : "), -1200, 1200);
	rfist_z = new ToggleSlider(this, canvas, wxT("Z : "),     0, 2400);
	rfist_a = new ToggleSlider(this, canvas, wxT(": "), -180, 180);
	rfist_b = new ToggleSlider(this, canvas, wxT(": "), -180, 180);
	rfist_g = new ToggleSlider(this, canvas, wxT(": "), -180, 180);
	rfist_x->Off();
	rfist_y->Off();
	rfist_z->Off();
	rfist_a->Off();
	rfist_b->Off();
	rfist_g->Off();
	rfist_fix1 = new wxButton(this, ON_RFIST_FIX1_ID, "");
	rfist_fix2 = new wxButton(this, ON_RFIST_FIX2_ID, "ָ");
	rfist_fix3 = new wxButton(this, ON_RFIST_FIX3_ID, "ʿ");
	rfist_fix4 = new wxButton(this, ON_RFIST_FIX4_ID, "ͳ");

	lfist_x = new ToggleSlider(this, canvas, wxT("X : "), -1200, 1200);
	lfist_y = new ToggleSlider(this, canvas, wxT("Y : "), -1200, 1200);
	lfist_z = new ToggleSlider(this, canvas, wxT("Z : "),     0, 2400);
	lfist_a = new ToggleSlider(this, canvas, wxT(": "), -180, 180);
	lfist_b = new ToggleSlider(this, canvas, wxT(": "), -180, 180);
	lfist_g = new ToggleSlider(this, canvas, wxT(": "), -180, 180);
	lfist_x->On();
	lfist_y->On();
	lfist_z->On();
	lfist_a->Off();
	lfist_b->Off();
	lfist_g->Off();
	lfist_fix1 = new wxButton(this, ON_LFIST_FIX1_ID, "");
	lfist_fix2 = new wxButton(this, ON_LFIST_FIX2_ID, "ָ");
	lfist_fix3 = new wxButton(this, ON_LFIST_FIX3_ID, "ʿ");
	lfist_fix4 = new wxButton(this, ON_LFIST_FIX4_ID, "ͳ");

	rtoe_x = new ToggleSlider(this, canvas, wxT("X : "), -1200, 1200);
	rtoe_y = new ToggleSlider(this, canvas, wxT("Y : "), -1200, 1200);
	rtoe_z = new ToggleSlider(this, canvas, wxT("Z : "),     0, 2400);
	rtoe_a = new ToggleSlider(this, canvas, wxT(": "), -180, 180);
	rtoe_b = new ToggleSlider(this, canvas, wxT(": "), -180, 180);
	rtoe_g = new ToggleSlider(this, canvas, wxT(": "), -180, 180);
	rtoe_x->On();
	rtoe_y->On();
	rtoe_z->On();
	rtoe_a->On();
	rtoe_b->On();
	rtoe_g->On();
	rtoe_fix1 = new wxButton(this, ON_RTOE_FIX1_ID, "");
	rtoe_fix2 = new wxButton(this, ON_RTOE_FIX2_ID, "žΤ");
	rtoe_fix3 = new wxButton(this, ON_RTOE_FIX3_ID, "̸");
	rtoe_fix4 = new wxButton(this, ON_RTOE_FIX4_ID, "ͳ");
	
	ltoe_x = new ToggleSlider(this, canvas, wxT("X : "), -1200, 1200);
	ltoe_y = new ToggleSlider(this, canvas, wxT("Y : "), -1200, 1200);
	ltoe_z = new ToggleSlider(this, canvas, wxT("Z : "),     0, 2400);
	ltoe_a = new ToggleSlider(this, canvas, wxT(": "), -180, 180);
	ltoe_b = new ToggleSlider(this, canvas, wxT(": "), -180, 180);
	ltoe_g = new ToggleSlider(this, canvas, wxT(": "), -180, 180);
	ltoe_x->On();
	ltoe_y->On();
	ltoe_z->On();
	ltoe_a->On();
	ltoe_b->On();
	ltoe_g->On();
	ltoe_fix1 = new wxButton(this, ON_LTOE_FIX1_ID, "");
	ltoe_fix2 = new wxButton(this, ON_LTOE_FIX2_ID, "žΤ");
	ltoe_fix3 = new wxButton(this, ON_LTOE_FIX3_ID, "̸");
	ltoe_fix4 = new wxButton(this, ON_LTOE_FIX4_ID, "ͳ");
       
	waist_x = new ToggleSlider(this, canvas, wxT("X : "), -1200, 1200);
	waist_y = new ToggleSlider(this, canvas, wxT("Y : "), -1200, 1200);
	waist_z = new ToggleSlider(this, canvas, wxT("Z : "),     0, 2400);
	waist_a = new ToggleSlider(this, canvas, wxT(": "), -180, 180);
	waist_b = new ToggleSlider(this, canvas, wxT(": "), -180, 180);
	waist_g = new ToggleSlider(this, canvas, wxT(": "), -180, 180);
	waist_x->On();
	waist_y->On();
	waist_z->Off();
	waist_a->Off();
	waist_b->Off();
	waist_g->Off();
	waist_fix1 = new wxButton(this, ON_WAIST_FIX1_ID, "");   
	waist_fix2 = new wxButton(this, ON_WAIST_FIX2_ID, "");
	waist_fix3 = new wxButton(this, ON_WAIST_FIX3_ID, "岼");
	waist_fix4 = new wxButton(this, ON_WAIST_FIX4_ID, "ͳ");

	head_x = new ToggleSlider(this, canvas, wxT("X : "),  -1200, 1200);
	head_y = new ToggleSlider(this, canvas, wxT("Y : "),  -1200, 1200);
	head_z = new ToggleSlider(this, canvas, wxT("Z : "),      0, 2400);
	head_a = new ToggleSlider(this, canvas, wxT(": "), -180, 180);
	head_b = new ToggleSlider(this, canvas, wxT(": "), -180, 180);
	head_g = new ToggleSlider(this, canvas, wxT(": "), -180, 180);
	head_x->Off();
	head_y->Off();
	head_z->Off();
	head_a->On();
	head_b->On();
	head_g->On();
	head_fix1 = new wxButton(this, ON_HEAD_FIX1_ID, "");
	head_fix2 = new wxButton(this, ON_HEAD_FIX2_ID, "");
	head_fix3 = new wxButton(this, ON_HEAD_FIX3_ID, "ٸ");
	head_fix4 = new wxButton(this, ON_HEAD_FIX4_ID, "ͳ");
}

void MotionPanel::DoLayout() {
	wxBoxSizer *tsizer = new wxBoxSizer(wxVERTICAL);
	wxStaticBoxSizer *sizer1 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("")), wxVERTICAL);
  	wxStaticBoxSizer *sizer2 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("")), wxVERTICAL);
  	wxStaticBoxSizer *sizer3 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("")), wxVERTICAL);
  	wxStaticBoxSizer *sizer4 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("")), wxVERTICAL);
  	wxStaticBoxSizer *sizer5 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("")), wxVERTICAL);
  	wxStaticBoxSizer *sizer6 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("Ƭ")), wxVERTICAL);

	tsizer->Add(sizer1, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
	tsizer->Add(sizer2, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
	tsizer->Add(sizer3, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
	tsizer->Add(sizer4, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
	tsizer->Add(sizer5, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
	tsizer->Add(sizer6, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);

	wxBoxSizer *sizer1h = new wxBoxSizer(wxHORIZONTAL);
	sizer1h->Add(rfist_fix1, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer1h->Add(rfist_fix2, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer1h->Add(rfist_fix3, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer1h->Add(rfist_fix4, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer1->Add(rfist_x, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer1->Add(rfist_y, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer1->Add(rfist_z, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer1->Add(rfist_a, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer1->Add(rfist_b, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer1->Add(rfist_g, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer1->Add(sizer1h, 0, wxGROW |wxALIGN_CENTER_VERTICAL);

	wxBoxSizer *sizer2h = new wxBoxSizer(wxHORIZONTAL);
	sizer2h->Add(lfist_fix1, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer2h->Add(lfist_fix2, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer2h->Add(lfist_fix3, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer2h->Add(lfist_fix4, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer2->Add(lfist_x, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer2->Add(lfist_y, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer2->Add(lfist_z, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer2->Add(lfist_a, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer2->Add(lfist_b, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer2->Add(lfist_g, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer2->Add(sizer2h, 0, wxGROW |wxALIGN_CENTER_VERTICAL);

	wxBoxSizer *sizer3h = new wxBoxSizer(wxHORIZONTAL);
	sizer3h->Add(rtoe_fix1, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer3h->Add(rtoe_fix2, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer3h->Add(rtoe_fix3, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer3h->Add(rtoe_fix4, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer3->Add(rtoe_x, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer3->Add(rtoe_y, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer3->Add(rtoe_z, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer3->Add(rtoe_a, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer3->Add(rtoe_b, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer3->Add(rtoe_g, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer3->Add(sizer3h, 0, wxGROW |wxALIGN_CENTER_VERTICAL);

	wxBoxSizer *sizer4h = new wxBoxSizer(wxHORIZONTAL);
	sizer4h->Add(ltoe_fix1, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer4h->Add(ltoe_fix2, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer4h->Add(ltoe_fix3, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer4h->Add(ltoe_fix4, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer4->Add(ltoe_x, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer4->Add(ltoe_y, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer4->Add(ltoe_z, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer4->Add(ltoe_a, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer4->Add(ltoe_b, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer4->Add(ltoe_g, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer4->Add(sizer4h, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
     
	wxBoxSizer *sizer5h = new wxBoxSizer(wxHORIZONTAL);
	sizer5h->Add(waist_fix1, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer5h->Add(waist_fix2, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer5h->Add(waist_fix3, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer5h->Add(waist_fix4, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer5->Add(waist_x, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer5->Add(waist_y, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer5->Add(waist_z, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer5->Add(waist_a, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer5->Add(waist_b, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer5->Add(waist_g, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer5->Add(sizer5h, 0, wxGROW |wxALIGN_CENTER_VERTICAL);

	wxBoxSizer *sizer6h = new wxBoxSizer(wxHORIZONTAL);
	sizer6h->Add(head_fix1, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer6h->Add(head_fix2, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer6h->Add(head_fix3, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer6h->Add(head_fix4, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer6->Add(head_x, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer6->Add(head_y, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer6->Add(head_z, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer6->Add(head_a, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer6->Add(head_b, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer6->Add(head_g, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
	sizer6->Add(sizer6h, 0, wxGROW |wxALIGN_CENTER_VERTICAL);
 
 	tsizer->SetSizeHints(this);
	SetSizer(tsizer);
    Layout();
}

void MotionPanel::OnRFistFix1(wxCommandEvent &event) {
	rfist_x->On();
	rfist_y->On();
	rfist_z->On();
	rfist_a->On();
	rfist_b->On();
	rfist_g->On();	
} 

void MotionPanel::OnRFistFix2(wxCommandEvent &event){ 
	rfist_x->On();
	rfist_y->On();
	rfist_z->On();
	rfist_a->Off();
	rfist_b->Off();
	rfist_g->Off();	
} 

void MotionPanel::OnRFistFix3(wxCommandEvent &event){ 
	rfist_x->Off();
	rfist_y->On();
	rfist_z->On();
	rfist_a->Off();
	rfist_b->Off();
	rfist_g->Off();	
} 

void MotionPanel::OnRFistFix4(wxCommandEvent &event){ 
	rfist_x->Off();
	rfist_y->Off();
	rfist_z->Off();
	rfist_a->Off();
	rfist_b->Off();
	rfist_g->Off();	
} 

void MotionPanel::OnLFistFix1(wxCommandEvent &event){ 
	lfist_x->On();
	lfist_y->On();
	lfist_z->On();
	lfist_a->On();
	lfist_b->On();
	lfist_g->On();	
} 

void MotionPanel::OnLFistFix2(wxCommandEvent &event){ 
	lfist_x->On();
	lfist_y->On();
	lfist_z->On();
	lfist_a->Off();
	lfist_b->Off();
	lfist_g->Off();	
} 

void MotionPanel::OnLFistFix3(wxCommandEvent &event){ 
	lfist_x->Off();
	lfist_y->On();
	lfist_z->On();
	lfist_a->Off();
	lfist_b->Off();
	lfist_g->Off();	
} 

void MotionPanel::OnLFistFix4(wxCommandEvent &event){ 
	lfist_x->Off();
	lfist_y->Off();
	lfist_z->Off();
	lfist_a->Off();
	lfist_b->Off();
	lfist_g->Off();	
} 

void MotionPanel::OnRToeFix1(wxCommandEvent &event){ 
	rtoe_x->On();
	rtoe_y->On();
	rtoe_z->On();
	rtoe_a->On();
	rtoe_b->On();
	rtoe_g->On();	
} 

void MotionPanel::OnRToeFix2(wxCommandEvent &event){ 
	rtoe_x->On();
	rtoe_y->On();
	rtoe_z->On();
	rtoe_a->On();
	rtoe_b->On();
	rtoe_g->Off();	
	rtoe_z->SetValue(0);
	rtoe_a->SetValue(0);
	rtoe_b->SetValue(0);
	canvas->Refresh();
} 

void MotionPanel::OnRToeFix3(wxCommandEvent &event){ 
	rtoe_x->Off();
	rtoe_y->Off();
	rtoe_z->On();
	rtoe_a->On();
	rtoe_b->On();
	rtoe_g->Off();	
	rtoe_z->SetValue(0);
	rtoe_a->SetValue(0);
	rtoe_b->SetValue(0);
	canvas->Refresh();
} 

void MotionPanel::OnRToeFix4(wxCommandEvent &event){ 
	rtoe_x->Off();
	rtoe_y->Off();
	rtoe_z->Off();
	rtoe_a->Off();
	rtoe_b->Off();
	rtoe_g->Off();	
}

void MotionPanel::OnLToeFix1(wxCommandEvent &event){ 
	ltoe_x->On();
	ltoe_y->On();
	ltoe_z->On();
	ltoe_a->On();
	ltoe_b->On();
	ltoe_g->On();	
} 

void MotionPanel::OnLToeFix2(wxCommandEvent &event){ 
	ltoe_x->On();
	ltoe_y->On();
	ltoe_z->On();
	ltoe_a->On();
	ltoe_b->On();
	ltoe_g->Off();	
	ltoe_z->SetValue(0);
	ltoe_a->SetValue(0);
	ltoe_b->SetValue(0);
	canvas->Refresh();
} 

void MotionPanel::OnLToeFix3(wxCommandEvent &event){ 
	ltoe_x->Off();
	ltoe_y->Off();
	ltoe_z->On();
	ltoe_a->On();
	ltoe_b->On();
	ltoe_g->Off();	
	ltoe_z->SetValue(0);
	ltoe_a->SetValue(0);
	ltoe_b->SetValue(0);
	canvas->Refresh();
} 

void MotionPanel::OnLToeFix4(wxCommandEvent &event){ 
	ltoe_x->Off();
	ltoe_y->Off();
	ltoe_z->Off();
	ltoe_a->Off();
	ltoe_b->Off();
	ltoe_g->Off();	
} 

void MotionPanel::OnWaistFix1(wxCommandEvent &event){ 
	waist_x->On();
	waist_y->On();
	waist_z->On();
	waist_a->On();
	waist_b->On();
	waist_g->On();
} 

void MotionPanel::OnWaistFix2(wxCommandEvent &event){ 
	waist_x->On();
	waist_y->On();
	waist_z->Off();
	waist_a->Off();
	waist_b->Off();
	waist_g->Off();
	waist_x->SetValue(0);
	waist_y->SetValue(0);
	canvas->Refresh();
} 

void MotionPanel::OnWaistFix3(wxCommandEvent &event){ 
	waist_x->On();
	waist_y->Off();
	waist_z->Off();
	waist_a->Off();
	waist_b->Off();
	waist_g->Off();
	waist_x->SetValue(0);
	canvas->Refresh();
} 

void MotionPanel::OnWaistFix4(wxCommandEvent &event){
	waist_x->Off();
	waist_y->Off();
	waist_z->Off();
	waist_a->Off();
	waist_b->Off();
	waist_g->Off();
} 

void MotionPanel::OnHeadFix1(wxCommandEvent &event){ 
	head_x->On();
	head_y->On();
	head_z->On();
	head_a->On();
	head_b->On();
	head_g->On();
}

void MotionPanel::OnHeadFix2(wxCommandEvent &event){ 
	head_x->Off();
	head_y->Off();
	head_z->Off();
	head_a->On();
	head_b->On();
	head_g->On();
	head_a->SetValue(0);
	head_b->SetValue(0);
	head_g->SetValue(0);
	canvas->Refresh();
} 

void MotionPanel::OnHeadFix3(wxCommandEvent &event){ 
	head_x->Off();
	head_y->Off();
	head_z->Off();
	head_a->On();
	head_b->On();
	head_g->On();
} 

void MotionPanel::OnHeadFix4(wxCommandEvent &event){ 
	head_x->Off();
	head_y->Off();
	head_z->Off();
	head_a->Off();
	head_b->Off();
	head_g->Off();
}

int MotionPanel::RFistFixState(){
	int r_value = 0x0000;
	if (rfist_x->IsOn()) {
		r_value |= 0x0001;
	}
	if (rfist_y->IsOn()) {
		r_value |= 0x0002;
	}
	if (rfist_z->IsOn()) {
		r_value |= 0x0004;
	}
	if (rfist_a->IsOn()) {
		r_value |= 0x0010;
	}
	if (rfist_b->IsOn()) {
		r_value |= 0x0020;
	}
	if (rfist_g->IsOn()) {
		r_value |= 0x0040;
	}
	return r_value;
} 

int MotionPanel::LFistFixState(){
	int r_value = 0x0000;
	if (lfist_x->IsOn()) {
		r_value |= 0x0001;
	}
	if (lfist_y->IsOn()) {
		r_value |= 0x0002;
	}
	if (lfist_z->IsOn()) {
		r_value |= 0x0004;
	}
	if (lfist_a->IsOn()) {
		r_value |= 0x0010;
	}
	if (lfist_b->IsOn()) {
		r_value |= 0x0020;
	}
	if (lfist_g->IsOn()) {
		r_value |= 0x0040;
	}
	return r_value;
} 

int MotionPanel::RToeFixState(){
	int r_value = 0x0000;
	if (rtoe_x->IsOn()) {
		r_value |= 0x0001;
	}
	if (rtoe_y->IsOn()) {
		r_value |= 0x0002;
	}
	if (rtoe_z->IsOn()) {
		r_value |= 0x0004;
	}
	if (rtoe_a->IsOn()) {
		r_value |= 0x0010;
	}
	if (rtoe_b->IsOn()) {
		r_value |= 0x0020;
	}
	if (rtoe_g->IsOn()) {
		r_value |= 0x0040;
	}
	return r_value;
} 

int MotionPanel::LToeFixState(){
	int r_value = 0x0000;
	if (ltoe_x->IsOn()) {
		r_value |= 0x0001;
	}
	if (ltoe_y->IsOn()) {
		r_value |= 0x0002;
	}
	if (ltoe_z->IsOn()) {
		r_value |= 0x0004;
	}
	if (ltoe_a->IsOn()) {
		r_value |= 0x0010;
	}
	if (ltoe_b->IsOn()) {
		r_value |= 0x0020;
	}
	if (ltoe_g->IsOn()) {
		r_value |= 0x0040;
	}
	return r_value;
} 

int MotionPanel::WaistFixState(){
	int r_value = 0x0000;
	if (waist_x->IsOn()) {
		r_value |= 0x0001;
	}
	if (waist_y->IsOn()) {
		r_value |= 0x0002;
	}
	if (waist_z->IsOn()) {
		r_value |= 0x0004;
	}
	if (waist_a->IsOn()) {
		r_value |= 0x0010;
	}
	if (waist_b->IsOn()) {
		r_value |= 0x0020;
	}
	if (waist_g->IsOn()) {
		r_value |= 0x0040;
	}
	return r_value;
} 

int MotionPanel::HeadFixState(){
	int r_value = 0x0000;
	if (head_x->IsOn()) {
		r_value |= 0x0001;
	}
	if (head_y->IsOn()) {
		r_value |= 0x0002;
	}
	if (head_z->IsOn()) {
		r_value |= 0x0004;
	}
	if (head_a->IsOn()) {
		r_value |= 0x0010;
	}
	if (head_b->IsOn()) {
		r_value |= 0x0020;
	}
	if (head_g->IsOn()) {
		r_value |= 0x0040;
	}
	return r_value;
} 

void MotionPanel::OnToggle(wxCommandEvent &event) {
}		

BEGIN_EVENT_TABLE(MotionPage, wxScrolledWindow)
	EVT_COMBOBOX(ON_SELECT_ID, MotionPage::OnSelect)
	EVT_TEXT_ENTER(ON_SELECT_ID, MotionPage::OnChangeName)  
	EVT_SLIDER(ON_SPEED_ID, MotionPage::OnSpeed)
	EVT_SLIDER(ON_CUT_SLIDER_ID, MotionPage::OnCutSlider)
	EVT_SPINCTRL(ON_CUT_SLIDER_ID, MotionPage::OnCutSpin)
	EVT_TOGGLEBUTTON(ON_CUT_SLIDER_ID, MotionPage::OnCut) 
	EVT_TEXT(ON_FRAME_NAME_ID, MotionPage::OnFrameName) 
	EVT_BUTTON(ON_ADD_FRAME_ID, MotionPage::OnAdd) 
	EVT_BUTTON(ON_DEL_FRAME_ID, MotionPage::OnDel) 
	EVT_BUTTON(ON_COPY_FRAME_ID, MotionPage::OnCopy) 
	EVT_BUTTON(ON_PASTE_FRAME_ID, MotionPage::OnPaste) 
	EVT_TOGGLEBUTTON(ON_DO_MOTION_ID, MotionPage::OnDoMotion) 
	EVT_TOGGLEBUTTON(-1, MotionPage::OnToggle)
	EVT_TIMER(ON_MOTION_TIMER_ID, MotionPage::OnMotionTimer)
END_EVENT_TABLE()

MotionPage::MotionPage(wxWindow* parent, myGLCanvas *ccanvas)
	 : wxScrolledWindow(parent, -1), motion_timer(this, ON_MOTION_TIMER_ID) {
	canvas = ccanvas;
	note = (myNotebook *)parent;
	max_frames = 1;
	select_frame = 0;
	max_motions = 1;
	select_motion = 0;

	SetProperties();
	DoLayout();
}

void MotionPage::SetProperties() {
	SetScrollRate(10,10);
	mpanel = new MotionPanel(this, canvas);

	cut = new wxToggleButton(this, ON_CUT_SLIDER_ID, wxT(""));			
	cut_slider = new wxSlider(this, ON_CUT_SLIDER_ID, 0, 0, 50);
	cut_spin = new wxSpinCtrl(this, ON_CUT_SLIDER_ID);
	cut->SetSize(60, 20);
	cut_slider->SetSize(120, 20);
	cut_spin->SetSize(60, 20);

	int i;
	for (i = 0; i < max_frames; i++) {
		MotionFrame *frame = new MotionFrame(this, canvas, i);
		frames.Add(frame);
	}
	frames[SelectFrame()]->On();

	CalcOn();
	name = wxT("ư0");
	cbox = new wxComboBox(this, ON_SELECT_ID);
	speed = new wxSlider(this, ON_SPEED_ID, 20, 10, 100);
	speed->SetSize(120, 20);
	fps = new wxTextCtrl(this, -1, wxT("0"), wxDefaultPosition, wxDefaultSize, wxTE_READONLY );
	fps->SetSize(40,-1);
	framename = new wxTextCtrl(this, ON_FRAME_NAME_ID, frames[0]->GetName());//, wxDefaultPosition, wxDefaultSize, wxTE_RICH);
	framename->SetSize(80,-1);
	add_frame = new wxButton(this, ON_ADD_FRAME_ID, wxT("ե졼"));
	del_frame = new wxButton(this, ON_DEL_FRAME_ID, wxT("ե졼"));	
	do_motion = new wxToggleButton(this, ON_DO_MOTION_ID, wxT("⡼¹"));	
 	copy_frame = new wxButton(this, ON_COPY_FRAME_ID, wxT("ԡ"));
	paste_frame = new wxButton(this, ON_PASTE_FRAME_ID, wxT("ڡ"));	
	do_motion->SetValue(false);

    tsizer = new wxBoxSizer(wxVERTICAL);
	vsizer = new wxBoxSizer(wxVERTICAL);
	SetInfo(0);
	MakeComboList();
	cbox->SetSelection(0);
}

void MotionPage::DoLayout() {
	int i;
    wxBoxSizer *lsizer = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *lsizer2 = new wxBoxSizer(wxHORIZONTAL);
    wxStaticBoxSizer *bsizer = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ե졼")), wxVERTICAL);
    wxStaticBoxSizer *hsizer = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ե졼")), wxVERTICAL);
    wxGridSizer *gsizer = new wxGridSizer(2, 3, 0, 0);

	lsizer->Add(cbox, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
	lsizer->Add(speed, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
	lsizer->Add(fps, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);

	lsizer2->Add(cut, 0, wxALIGN_CENTER_VERTICAL | wxLEFT | wxRIGHT, 5);
	lsizer2->Add(cut_slider, 0, wxALIGN_CENTER_VERTICAL | wxLEFT | wxRIGHT, 5);
	lsizer2->Add(cut_spin, 0, wxALIGN_CENTER_VERTICAL | wxLEFT | wxRIGHT, 5);	

	hsizer->Add(gsizer, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
	hsizer->Add(lsizer2, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL, 0);
	gsizer->Add(framename, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
	gsizer->Add(add_frame, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
	gsizer->Add(del_frame, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
	gsizer->Add(copy_frame, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
	gsizer->Add(paste_frame, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
	gsizer->Add(do_motion, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);

	bsizer->Add(lsizer, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
//	bsizer->Add(lsizer2, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
	bsizer->Add(vsizer, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
	bsizer->Add(hsizer, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
	tsizer->Add(bsizer, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);

	for (i = 0; i < max_frames; i++) {
		vsizer->Add(frames[i],  0, wxGROW |wxALIGN_CENTRE_VERTICAL | wxALL, 5);
	}
	tsizer->Add(mpanel, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);

  	SetSizer(tsizer);
	ReLayout();
}

void MotionPage::ReLayout() {
 	tsizer->SetVirtualSizeHints(this);
	FitInside();
	Layout();
}

void MotionPage::Rename() {
	int i;
	wxString name;
	for (i = 0; i < MaxFrame(); i++) {
		name.Printf("FRAME %d", i);
		frames[i]->SetName(name);
	}
	framename->SetValue(GetFrame()->GetName());	
	name = wxT("ư0"); 
	infos[select_motion].name = name;
	MakeComboList();
	cbox->SetSelection(select_motion);
}

void MotionPage::MakeComboList() {
	int i;
	cbox->Clear();	
	for (i = 0; i < (int)infos.GetCount(); i++) {
		cbox->Append(infos[i].name);
	}  
}

void MotionPage::ClearMotion() {
	infos.Empty();
	select_motion = 0;
	max_motions = 1;
}		

void MotionPage::AddMotion() {
	SetInfo(infos.GetCount());
	infos[max_motions].name.Printf("ư%d", max_motions);	
	cbox->Append(infos[max_motions].name);
	max_motions++;
}		

void MotionPage::DelMotion() {
	if (max_motions <= 0) {
		return;	
	}
	infos.RemoveAt(select_motion);
	cbox->Delete(select_motion);
	max_motions--;
	if (select_motion >= MaxMotion() && MaxMotion()) {
		select_motion--;
	} 
	cbox->SetSelection(select_motion);
	GetInfo(select_motion);
}		

void MotionPage::SetFrameInfo(FrameInfo *finfo, int i) {
	finfo->name = frames[i]->GetName();
   	finfo->number = frames[i]->GetNumber();
   	finfo->bframe = frames[i]->bframe;

	finfo->rfist_fix = frames[i]->rfist_fix;
	finfo->lfist_fix = frames[i]->lfist_fix;
	finfo->rtoe_fix = frames[i]->rtoe_fix;
	finfo->ltoe_fix = frames[i]->ltoe_fix;
	finfo->head_fix = frames[i]->head_fix;
	finfo->waist_fix = frames[i]->waist_fix;
}

void MotionPage::SetFixState(int i) {
	frames[i]->rfist_fix = mpanel->RFistFixState();
	frames[i]->lfist_fix = mpanel->LFistFixState();
	frames[i]->rtoe_fix = mpanel->RToeFixState();
	frames[i]->ltoe_fix = mpanel->LToeFixState();
	frames[i]->head_fix = mpanel->HeadFixState();
	frames[i]->waist_fix = mpanel->WaistFixState();
}

void MotionPage::SetInfo(int number) {
	int i;
	MotionInfo info;
	info.name = name;
	info.speed = speed->GetValue();
 	info.select_frame = select_frame;
 	info.max_frames = max_frames;
	FrameInfo finfo;
	for (i = 0; i < MaxFrame(); i++) {
		SetFrameInfo(&finfo, i);
		info.frames.Add(finfo);
	}
	infos.Insert(info, number);
}

void MotionPage::SaveInfo(int number) {
	infos.RemoveAt(number);
	SetInfo(number);
}

void MotionPage::GetFrameInfo(FrameInfo *finfo, int i) {
	frames[i]->SetName(finfo->name);
   	frames[i]->SetNumber(finfo->number);
   	frames[i]->bframe = finfo->bframe;
	frames[i]->rfist_fix = finfo->rfist_fix;
	frames[i]->lfist_fix = finfo->lfist_fix;
	frames[i]->rtoe_fix = finfo->rtoe_fix;
	frames[i]->ltoe_fix = finfo->ltoe_fix;
	frames[i]->head_fix = finfo->head_fix;
	frames[i]->waist_fix = finfo->waist_fix;
}

void MotionPage::GetFixState(int i) {
	mpanel->rfist_x->SetToggle(frames[i]->rfist_fix & 0x0001);
	mpanel->rfist_y->SetToggle(frames[i]->rfist_fix & 0x0002);
	mpanel->rfist_z->SetToggle(frames[i]->rfist_fix & 0x0004);
	mpanel->rfist_a->SetToggle(frames[i]->rfist_fix & 0x0010);
	mpanel->rfist_b->SetToggle(frames[i]->rfist_fix & 0x0020);
	mpanel->rfist_g->SetToggle(frames[i]->rfist_fix & 0x0040);
   	
	mpanel->lfist_x->SetToggle(frames[i]->lfist_fix & 0x0001);
	mpanel->lfist_y->SetToggle(frames[i]->lfist_fix & 0x0002);
	mpanel->lfist_z->SetToggle(frames[i]->lfist_fix & 0x0004);
	mpanel->lfist_a->SetToggle(frames[i]->lfist_fix & 0x0010);
	mpanel->lfist_b->SetToggle(frames[i]->lfist_fix & 0x0020);
	mpanel->lfist_g->SetToggle(frames[i]->lfist_fix & 0x0040);

	mpanel->rtoe_x->SetToggle(frames[i]->rtoe_fix & 0x0001);
	mpanel->rtoe_y->SetToggle(frames[i]->rtoe_fix & 0x0002);
	mpanel->rtoe_z->SetToggle(frames[i]->rtoe_fix & 0x0004);
	mpanel->rtoe_a->SetToggle(frames[i]->rtoe_fix & 0x0010);
	mpanel->rtoe_b->SetToggle(frames[i]->rtoe_fix & 0x0020);
	mpanel->rtoe_g->SetToggle(frames[i]->rtoe_fix & 0x0040);
  
	mpanel->ltoe_x->SetToggle(frames[i]->ltoe_fix & 0x0001);
	mpanel->ltoe_y->SetToggle(frames[i]->ltoe_fix & 0x0002);
	mpanel->ltoe_z->SetToggle(frames[i]->ltoe_fix & 0x0004);
	mpanel->ltoe_a->SetToggle(frames[i]->ltoe_fix & 0x0010);
	mpanel->ltoe_b->SetToggle(frames[i]->ltoe_fix & 0x0020);
	mpanel->ltoe_g->SetToggle(frames[i]->ltoe_fix & 0x0040);

	mpanel->waist_x->SetToggle(frames[i]->waist_fix & 0x0001);
	mpanel->waist_y->SetToggle(frames[i]->waist_fix & 0x0002);
	mpanel->waist_z->SetToggle(frames[i]->waist_fix & 0x0004);
	mpanel->waist_a->SetToggle(frames[i]->waist_fix & 0x0010);
	mpanel->waist_b->SetToggle(frames[i]->waist_fix & 0x0020);
	mpanel->waist_g->SetToggle(frames[i]->waist_fix & 0x0040);

	mpanel->head_x->SetToggle(frames[i]->head_fix & 0x0001);
	mpanel->head_y->SetToggle(frames[i]->head_fix & 0x0002);
	mpanel->head_z->SetToggle(frames[i]->head_fix & 0x0004);
	mpanel->head_a->SetToggle(frames[i]->head_fix & 0x0010);
	mpanel->head_b->SetToggle(frames[i]->head_fix & 0x0020);
	mpanel->head_g->SetToggle(frames[i]->head_fix & 0x0040);
}

void MotionPage::GetInfo(int number) {
	int i;
	
	MotionInfo info = infos[number];
	name = info.name;
	speed->SetValue(info.speed);
 //	info.max_frames = max_frames;

	while (info.max_frames < MaxFrame()) {
		Del();	
	} 
	while (info.max_frames > MaxFrame()) {
		Add();	
	}

//	SetFixState(SelectFrame());
//	GetFrame()->bframe.Get(canvas->GetBoxer());
	GetFrame()->Off();
	ReLayout();

	for (i = 0; i < MaxFrame(); i++) {
		FrameInfo finfo = info.frames[i];
		GetFrameInfo(&finfo, i);
	}

	select_frame = info.select_frame;
	GetFrame()->On();
	GetFixState(SelectFrame());
	framename->SetValue(GetFrame()->GetName());	
	GetFrame()->bframe.Set(canvas->GetBoxer());
	canvas->SetMotionNoCalc();
}

void MotionPage::Insert() {
	if (current_cut == 0 || cut_number == current_cut) {
		return;
	}
	int i, next_cut;
	for (i = 0; i < MaxFrame(); i++) {
		vsizer->Remove(frames[i]);	
	}
	MotionFrame *frame = new MotionFrame(this, canvas, max_frames);
	frames.Insert(frame, current_frame + 1);

	FrameInfo finfo;
	SetFrameInfo(&finfo, current_frame);
	finfo.name.Printf("FRAME %d", max_frames);
	GetFrameInfo(&finfo, current_frame + 1);

	next_cut = frames[current_frame]->GetNumber() - current_cut;
	frames[current_frame]->SetNumber(current_cut);
	frames[current_frame + 1]->SetNumber(next_cut);
	frames[current_frame + 1]->bframe = bframe;

	if (current_frame < select_frame) {
		select_frame++;
    }
	max_frames++;

	for (i = 0; i < MaxFrame(); i++) {
		vsizer->Add(frames[i],  0, wxGROW |wxALIGN_CENTRE_VERTICAL | wxALL, 5);
	}
}

void MotionPage::Add() {
	if (MaxFrame() > 80) {
		return;	
	}
	int i;
	for (i = 0; i < MaxFrame(); i++) {
		vsizer->Remove(frames[i]);	
	}
	MotionFrame *frame = new MotionFrame(this, canvas, max_frames);
	frames.Insert(frame, SelectFrame());
	FrameInfo finfo;
	SetFrameInfo(&finfo, SelectFrame() + 1);
	finfo.name.Printf("FRAME %d", max_frames);
	GetFrameInfo(&finfo, SelectFrame());

	select_frame++;
	max_frames++;
	for (i = 0; i < MaxFrame(); i++) {
		vsizer->Add(frames[i],  0, wxGROW |wxALIGN_CENTRE_VERTICAL | wxALL, 5);
	}
	SetRange();
}

void MotionPage::OnAdd(wxCommandEvent &event) {
	if (IsCutting()) {
		Insert();
		ReLayout();
		SetCut();
	}
	if (!note->IsMoving()) {
		Add();
		ReLayout();
	}
}

void MotionPage::Del() {
	if (max_frames < 3) {
		return;	
	}
	max_frames--;
	MotionFrame *frame = GetFrame();
	vsizer->Remove(frame);
	frames.Remove(frame);
	delete frame;	
	if (select_frame >= MaxFrame() && MaxFrame()) {
		select_frame--;	
	}

	GetFrame()->On();
	GetFixState(SelectFrame());
	framename->SetValue(GetFrame()->GetName());	

	GetFrame()->bframe.Set(canvas->GetBoxer());
	canvas->SetMotionNoCalc();
	SetRange();
}

void MotionPage::OnDel(wxCommandEvent &event) {
	if (note->IsMoving()) {
		return ;	
	}
	Del();
	ReLayout();
}

void MotionPage::OnFrameName(wxCommandEvent &event) {
	GetFrame()->SetName(framename->GetValue());	
}

void MotionPage::OnSelect(wxCommandEvent &event) {
	int new_select = cbox->GetSelection();
	if (new_select == -1) {
		cbox->SetSelection(select_motion);
	} else if(select_motion != new_select) {
    	MotionOff();
		SaveInfo(select_motion);
		GetInfo(new_select);
		select_motion = new_select;
		SetRange();
		CutOff();
		canvas->SetUndo();
	}
}

void MotionPage::SetRange() {
	int i, total_number = 0;
	for (i = 0; i < MaxFrame(); i++) {
		total_number += frames[i]->GetNumber();	
	}
	cut_spin->SetRange(0, total_number);
	cut_slider->SetRange(0, total_number);
	SelectCutNumber();
}

void MotionPage::SetCutNumber(int number) {
	cut_spin->SetValue(number);	
	cut_slider->SetValue(number);	
}

void MotionPage::SelectCutNumber() {
	int i, cut_number = 0;
	for (i = 0; i < SelectFrame(); i++) {
		cut_number += frames[i]->GetNumber();	
	}
	SetCutNumber(cut_number);
}

void MotionPage::SetCut() {
	int i, get_number, total_number = 0;

	get_number = GetCutNumber();
	for (i = 0; i < MaxFrame(); i++) {
		cut_number = frames[i]->GetNumber();
		if ((total_number + cut_number) >= get_number) {
			break;
		} else {
			total_number += cut_number;
		}
	}

	current_cut = get_number - total_number;
	current_frame = i;
	base = &frames[current_frame]->bframe;
	cut_number = frames[current_frame]->GetNumber();
	if (i != MaxFrame() - 1) {
		next = &frames[current_frame+1]->bframe;
	} else {
		next = &frames[0]->bframe;
	}
	bframe.Interpolate(base, next, current_cut, cut_number);			
	bframe.Set(canvas->GetBoxer());
	canvas->DoMotion();
}

void MotionPage::OnCut(wxCommandEvent &event) {
	if (IsCutting()) {
		if (note->IsMoving()) {
			note->MovingOff();	
			cut->SetValue(true);
		}
		CalcOff();	
		SetCut();		
	} else {	
		CutOff();
	}	
}

void MotionPage::OnCutSlider(wxCommandEvent &event) {
	cut_spin->SetValue(cut_slider->GetValue());
	if (IsCutting()) {
		SetCut();	
	}
}

void MotionPage::OnCutSpin(wxSpinEvent &event) {
	cut_slider->SetValue(cut_spin->GetValue());
	if (IsCutting()) {
		SetCut();	
	}
}

void MotionPage::CutOff() {
	cut->SetValue(false);
	CalcOn();	
	GetFrame()->bframe.Set(canvas->GetBoxer());
	canvas->SetMotionNoCalc();
}

void MotionPage::OnChangeName(wxCommandEvent &event) {
	name = cbox->GetValue(); 
	infos[select_motion].name = name;
	MakeComboList();
	cbox->SetSelection(select_motion);
}

void MotionPage::OnDoMotion(wxCommandEvent &event){
	if (IsDoingMotion()) {
		if (note->IsMoving()) {
			note->MovingOff();	
			do_motion->SetValue(true);
		}
		MotionOn();
	} else {	
		TimerOff();	
		GetFrame()->bframe.Set(canvas->GetBoxer());
		canvas->SetMotionNoCalc();
	}
}

void MotionPage::MotionToggle() {
	if (do_motion->GetValue()) {
		do_motion->SetValue(false);
	} else {
		do_motion->SetValue(true);	
	}

	if (IsDoingMotion()) {
		if (note->IsMoving()) {
			note->MovingOff();	
			do_motion->SetValue(true);
		}
		MotionOn();
	} else {	
		TimerOff();	
		GetFrame()->bframe.Set(canvas->GetBoxer());
		canvas->SetMotionNoCalc();
	}
}

void MotionPage::FrameCopy(){
	SetFrameInfo(&copy, SelectFrame());
}

void MotionPage::FramePaste(){
	if (note->IsMoving()) {
		return;	
	}
	GetFrameInfo(&copy, SelectFrame());
	GetFrame()->bframe.Set(canvas->GetBoxer());
	framename->SetValue(GetFrame()->GetName());	
	canvas->SetMotionNoCalc();
	SetRange();
}

void MotionPage::OnCopy(wxCommandEvent &event){
	FrameCopy();
}

void MotionPage::OnPaste(wxCommandEvent &event){
	FramePaste();
}

void MotionPage::SetSelectFrame(int new_select) {
	if (note->IsMoving()) {
		frames[new_select]->Off();
		GetFrame()->On();
		return;
	} else {
		frames[new_select]->On();
    }

	if (new_select != SelectFrame()) {
		SetFixState(SelectFrame());
		GetFrame()->Off();
		GetFrame()->bframe.Get(canvas->GetBoxer());

        select_frame = new_select;
		FrameInfo finfo;
		GetFixState(SelectFrame());
		framename->SetValue(GetFrame()->GetName());	

		GetFrame()->bframe.Set(canvas->GetBoxer());
		canvas->SetMotionNoCalc();
		canvas->SetUndo();
	}
	SelectCutNumber();
	ReLayout();
}

void MotionPage::OnToggle(wxCommandEvent &event){
	int i, new_select = -1;
	wxObject *obj = event.GetEventObject();

	for (i = 0; i < MaxFrame(); i++) {
		if(obj == frames[i]->Object()) {
			new_select = i;
			break;
		}
	}
	if (new_select != -1) {
		SetSelectFrame(new_select);
	}
}


void MotionPage::FrameUp() {
	int new_select = select_frame - 1;
	if (new_select < 0) {
		new_select = MaxFrame() - 1;	
	}
	SetSelectFrame(new_select);
}

void MotionPage::FrameDown() {
	int new_select = select_frame + 1;
	if (new_select >= MaxFrame()) {
		new_select = 0;	
	}
	SetSelectFrame(new_select);
}

void MotionPage::OnMotionTimer(wxTimerEvent& event) {
	static wxDateTime old_time = wxDateTime::UNow();
	static wxDateTime new_time = wxDateTime::UNow();
	static wxTimeSpan dif_time;
	static wxString str;

	if (current_cut >= cut_number){
		current_cut = 0;	
		current_frame++;

		new_time = wxDateTime::UNow();
		dif_time = new_time.Subtract(old_time);
		if (!dif_time.IsNull()) {
			str.Printf("%3.0f", cut_number * 1000.0/(float)dif_time.GetMilliseconds().ToLong());
			fps->SetValue(str);
		}
		old_time = new_time;
	} 
                                              
	if (current_frame >= MaxFrame()) {
		current_frame = 0;
	}

	base = &(frames[current_frame]->bframe);
	cut_number = frames[current_frame]->GetNumber();
	if (current_frame < MaxFrame() - 1) {
		next = &frames[current_frame + 1]->bframe;	
	} else {
		next = &frames[0]->bframe;		
	}

	bframe.Interpolate(base, next, current_cut, cut_number);
	bframe.Set(canvas->GetBoxer());
	canvas->DoMotion();
	current_cut++;
} 

void MotionPage::TimerOn() {
	CalcOff();	
	motion_timer.Start(speed->GetValue());
	current_frame = 0;
	current_cut = 0;
}

void MotionPage::TimerOff() {
	CalcOn();	
	if (motion_timer.IsRunning()) {
		motion_timer.Stop();		
	}
}

void MotionPage::OnSpeed(wxCommandEvent& event) {
	if (IsDoingMotion()) {
		if (motion_timer.IsRunning()) {
			motion_timer.Stop();		
		}
		motion_timer.Start(speed->GetValue());
	}
}

void MotionPage::MotionOn(){
	do_motion->SetValue(true);
	TimerOn();
}

void MotionPage::MotionOff(){
	if (IsDoingMotion()) {
		do_motion->SetValue(false);
		TimerOff();	
		GetFrame()->bframe.Set(canvas->GetBoxer());
		canvas->SetMotionNoCalc();
	}
}

void MotionPage::OffSet() {
	int i;
	float offset, minz = 1.0e10;
	Boxer &calc = *canvas->GetBoxer();

	for (i = 0; i < MaxFrame(); i++) {
		minz = 1.0e10;
		frames[i]->bframe.Set(&calc);
		calc.CalcCoords();
		if (calc.right_arm.fist.Z() < minz) {
			minz = calc.right_arm.fist.Z();		
		}
		if (calc.left_arm.fist.Z() < minz) {
			minz = calc.left_arm.fist.Z();		
		}
		if (calc.right_leg.toe.Z() < minz) {
			minz = calc.right_leg.toe.Z();		
		}
		if (calc.left_leg.toe.Z() < minz) {
			minz = calc.left_leg.toe.Z();		
		}
		if (calc.head.face.Z() < minz) {
			minz = calc.head.face.Z();		
		}
		if (calc.Z() < minz) {
			minz = calc.Z();		
		}
		offset = 0.0 - minz;
		frames[i]->bframe[2] += offset;
	}
	GetFrame()->bframe.Set(canvas->GetBoxer());
	canvas->SetMotionNoCalc();
}

void MotionPage::OffSetAll() {
	int i, save_select;
	save_select = SelectMotion();

	SaveInfo(save_select);
	for (i = 0; i < MaxMotion(); i++) {
		GetInfo(i);
		OffSet();
		SaveInfo(i);
	}
	GetInfo(save_select);
}

void MotionPage::Reverse() {
	int i;
	float swap;
	for (i = 0; i < MaxFrame(); i++) {
		frames[i]->bframe[0] *= -1.0;
		frames[i]->bframe[4] *= -1.0;
		frames[i]->bframe[5] *= -1.0;

        swap = frames[i]->bframe[6];
		frames[i]->bframe[6] = -frames[i]->bframe[11];
		frames[i]->bframe[11] = -swap;

        swap = frames[i]->bframe[7];
		frames[i]->bframe[7] = frames[i]->bframe[12];
		frames[i]->bframe[12] = swap;

        swap = frames[i]->bframe[8];
		frames[i]->bframe[8] = -frames[i]->bframe[13];
		frames[i]->bframe[13] = -swap;

        swap = frames[i]->bframe[9];
		frames[i]->bframe[9] = frames[i]->bframe[14];
		frames[i]->bframe[14] = swap;

        swap = frames[i]->bframe[10];
		frames[i]->bframe[10] = -frames[i]->bframe[15];
		frames[i]->bframe[15] = -swap;
	
        swap = frames[i]->bframe[16];
		frames[i]->bframe[16] = frames[i]->bframe[24];
		frames[i]->bframe[24] = swap;

		swap = frames[i]->bframe[17];
		frames[i]->bframe[17] = frames[i]->bframe[25];
		frames[i]->bframe[25] = swap;

        swap = frames[i]->bframe[18];
		frames[i]->bframe[18] = -frames[i]->bframe[26];
		frames[i]->bframe[26] = -swap;

        swap = frames[i]->bframe[19];
		frames[i]->bframe[19] = -frames[i]->bframe[27];
		frames[i]->bframe[27] = -swap;

		swap = frames[i]->bframe[20];
		frames[i]->bframe[20] = frames[i]->bframe[28];
		frames[i]->bframe[28] = swap;

		swap = frames[i]->bframe[21];
		frames[i]->bframe[21] = frames[i]->bframe[29];
		frames[i]->bframe[29] = swap;

        swap = frames[i]->bframe[22];
		frames[i]->bframe[22] = -frames[i]->bframe[30];
		frames[i]->bframe[30] = -swap;

        swap = frames[i]->bframe[23];
		frames[i]->bframe[23] = 360 - frames[i]->bframe[31];
		frames[i]->bframe[31] = 360 - swap;

		frames[i]->bframe[33] *= -1.0;
		frames[i]->bframe[34] *= -1.0;
		frames[i]->bframe[36] *= -1.0;
		frames[i]->bframe[37] *= -1.0;
		frames[i]->bframe[39] *= -1.0;
		frames[i]->bframe[40] *= -1.0;
		frames[i]->bframe[42] *= -1.0;
		frames[i]->bframe[43] *= -1.0;
	}
	GetFrame()->bframe.Set(canvas->GetBoxer());
	canvas->SetMotionNoCalc();
}

void MotionPage::ReverseAll() {
	int i, save_select;
	save_select = SelectMotion();

	SaveInfo(save_select);
	for (i = 0; i < MaxMotion(); i++) {
		GetInfo(i);
		Reverse();
		SaveInfo(i);
	}
	GetInfo(save_select);
}

void MotionPage::Interpolate() {
	int i, bnumber, number, max = MaxFrame();
	BFrame *base, *next;

	for (i = 0; i < max; i++) {
		SetSelectFrame(i*2);
		Add();
	}
	SetSelectFrame(0);
	for (i = 0; i < MaxFrame(); i++) {
		if (i % 2) {
			base = &(frames[i - 1]->bframe);
			if (i + 1 < MaxFrame()) {
				next = &frames[i + 1]->bframe;	
			} else {
				next = &frames[0]->bframe;		
			}
			bnumber = frames[i - 1]->GetNumber();
			number = (bnumber + 1) / 2;
			frames[i]->bframe.Interpolate(base, next, number, bnumber);
			frames[i]->SetNumber(number);
		}
	}
	for (i = 0; i < MaxFrame(); i++) {
		if (!(i % 2)) {
			number = (frames[i]->GetNumber() + 1) / 2;
			frames[i]->SetNumber(number);
		}
	}		
	ReLayout();
}


void MotionPage::LagrangeInterpolate() {
	int i, pre_number, base_number, next_number, number, max = MaxFrame();
	BFrame *pre, *base, *next, *nearnext;

	for (i = 0; i < max; i++) {
		SetSelectFrame(i*2);
		Add();
	}
	SetSelectFrame(0);
	for (i = 0; i < MaxFrame(); i++) {
		if (i % 2) {
			if (i - 3 >= 0) {
				pre = &frames[i - 3]->bframe;		
				pre_number = frames[i - 3]->GetNumber();
			} else {
				pre = &frames[MaxFrame() - 1]->bframe;	
				pre_number = frames[MaxFrame() - 1]->GetNumber();
			}
			base = &(frames[i - 1]->bframe);
			base_number = frames[i - 1]->GetNumber();
			if (i + 1 < MaxFrame()) {
				next = &frames[i + 1]->bframe;	
				next_number = frames[i + 1]->GetNumber();	
			} else {
				next = &frames[0]->bframe;		
				next_number = frames[0]->GetNumber();	
			}
			if (i + 3 < MaxFrame()) {
				nearnext = &frames[i + 3]->bframe;	
			} else {
				nearnext = &frames[2]->bframe;		
			}

			number = (base_number + 1) / 2;
			frames[i]->bframe.LagrangeInterpolate(pre, base, next, nearnext, number, pre_number, base_number, next_number);
			frames[i]->SetNumber(number);
		}
	}
	for (i = 0; i < MaxFrame(); i++) {
		if (!(i % 2)) {
			number = (frames[i]->GetNumber() + 1) / 2;
			frames[i]->SetNumber(number);
		}
	}		
	ReLayout();
} 

void MotionPage::FrameAll() {
	int i, save_number;
	save_number = GetCutNumber();
	cut->SetValue(true);
	CalcOff();	
	SetCutNumber(0);
	SetCut();		

	for (i = 1; i < cut_spin->GetMax(); i++) {
		SetCutNumber(i);
		Insert();
		ReLayout();
		SetCut();
	}
	
	SetCutNumber(save_number);
	CutOff();
	cut->SetValue(false);
}

void MotionPage::GetCoords(Boxer &boxer) {
	mpanel->rfist_x->SetValueF(boxer.right_arm.fist.X(), 1000);
	mpanel->rfist_y->SetValueF(boxer.right_arm.fist.Y(), 1000);
	mpanel->rfist_z->SetValueF(boxer.right_arm.fist.Z(), 1000);
	mpanel->rfist_a->SetValue((int)boxer.right_arm.fist.AbsAlpha());
	mpanel->rfist_b->SetValue((int)boxer.right_arm.fist.AbsBeta());
	mpanel->rfist_g->SetValue((int)boxer.right_arm.fist.AbsGamma());
	mpanel->lfist_x->SetValueF(boxer.left_arm.fist.X(), 1000);
	mpanel->lfist_y->SetValueF(boxer.left_arm.fist.Y(), 1000);
	mpanel->lfist_z->SetValueF(boxer.left_arm.fist.Z(), 1000);
	mpanel->lfist_a->SetValue((int)boxer.left_arm.fist.AbsAlpha());
	mpanel->lfist_b->SetValue((int)boxer.left_arm.fist.AbsBeta());
	mpanel->lfist_g->SetValue((int)boxer.left_arm.fist.AbsGamma());

	mpanel->rtoe_x->SetValueF(boxer.right_leg.toe.X(), 1000);
	mpanel->rtoe_y->SetValueF(boxer.right_leg.toe.Y(), 1000);
	mpanel->rtoe_z->SetValueF(boxer.right_leg.toe.Z(), 1000);
	mpanel->rtoe_a->SetValue((int)boxer.right_leg.toe.AbsAlpha());
	mpanel->rtoe_b->SetValue((int)boxer.right_leg.toe.AbsBeta());
	mpanel->rtoe_g->SetValue((int)boxer.right_leg.toe.AbsGamma());
	mpanel->ltoe_x->SetValueF(boxer.left_leg.toe.X(), 1000);
	mpanel->ltoe_y->SetValueF(boxer.left_leg.toe.Y(), 1000);
	mpanel->ltoe_z->SetValueF(boxer.left_leg.toe.Z(), 1000);
	mpanel->ltoe_a->SetValue((int)boxer.left_leg.toe.AbsAlpha());
	mpanel->ltoe_b->SetValue((int)boxer.left_leg.toe.AbsBeta());
	mpanel->ltoe_g->SetValue((int)boxer.left_leg.toe.AbsGamma());

	mpanel->head_x->SetValueF(boxer.head.face.X(), 1000);
	mpanel->head_y->SetValueF(boxer.head.face.Y(), 1000);
	mpanel->head_z->SetValueF(boxer.head.face.Z(), 1000);
	mpanel->head_a->SetValue((int)boxer.head.face.AbsAlpha());
	mpanel->head_b->SetValue((int)boxer.head.face.AbsBeta());
	mpanel->head_g->SetValue((int)boxer.head.face.AbsGamma());

	mpanel->waist_x->SetValueF(boxer.X(), 1000);
	mpanel->waist_y->SetValueF(boxer.Y(), 1000);
	mpanel->waist_z->SetValueF(boxer.Z(), 1000);
	mpanel->waist_a->SetValue((int)boxer.AbsAlpha());
	mpanel->waist_b->SetValue((int)boxer.AbsBeta());
	mpanel->waist_g->SetValue((int)boxer.AbsGamma());
}

void MotionPage::SetCoords(Boxer &boxer) {
	static BCoords coords;
	static BFrame save;
	save.Get(&boxer);

	boxer.right_arm.fist.SetPos(
		mpanel->rfist_x->GetValueF(1000),
		mpanel->rfist_y->GetValueF(1000),
		mpanel->rfist_z->GetValueF(1000));
	boxer.right_arm.fist.SetAbsAngle(
		(float)mpanel->rfist_a->GetValue(),
		(float)mpanel->rfist_b->GetValue(),
		(float)mpanel->rfist_g->GetValue());

	boxer.left_arm.fist.SetPos(
		mpanel->lfist_x->GetValueF(1000),
		mpanel->lfist_y->GetValueF(1000),
		mpanel->lfist_z->GetValueF(1000));
	boxer.left_arm.fist.SetAbsAngle(
		(float)mpanel->lfist_a->GetValue(),
		(float)mpanel->lfist_b->GetValue(),
		(float)mpanel->lfist_g->GetValue());

	boxer.right_leg.toe.SetPos(
		mpanel->rtoe_x->GetValueF(1000),
		mpanel->rtoe_y->GetValueF(1000),
		mpanel->rtoe_z->GetValueF(1000));
	boxer.right_leg.toe.SetAbsAngle(
		(float)mpanel->rtoe_a->GetValue(),
		(float)mpanel->rtoe_b->GetValue(),
		(float)mpanel->rtoe_g->GetValue());

	boxer.left_leg.toe.SetPos(
		mpanel->ltoe_x->GetValueF(1000),
		mpanel->ltoe_y->GetValueF(1000),
		mpanel->ltoe_z->GetValueF(1000));
	boxer.left_leg.toe.SetAbsAngle(
		(float)mpanel->ltoe_a->GetValue(),
		(float)mpanel->ltoe_b->GetValue(),
		(float)mpanel->ltoe_g->GetValue());

	boxer.head.face.SetPos(
		mpanel->head_x->GetValueF(1000),
		mpanel->head_y->GetValueF(1000),
		mpanel->head_z->GetValueF(1000));
	boxer.head.face.SetAbsAngle(
		(float)mpanel->head_a->GetValue(),
		(float)mpanel->head_b->GetValue(),
		(float)mpanel->head_g->GetValue());

	boxer.SetPos(
		mpanel->waist_x->GetValueF(1000),
		mpanel->waist_y->GetValueF(1000),
		mpanel->waist_z->GetValueF(1000));
	boxer.SetAbsAngle(
		(float)mpanel->waist_a->GetValue(),
		(float)mpanel->waist_b->GetValue(),
		(float)mpanel->waist_g->GetValue());

	if(!coords.CalcAngles(&boxer, mpanel->RFistFixState(), mpanel->LFistFixState(), mpanel->RToeFixState(), mpanel->LToeFixState(), mpanel->WaistFixState(), mpanel->HeadFixState())){
		save.Set(&boxer);
	}
}

void MotionPage::SetPanelRightDown(int which_pick) {
	switch (which_pick)  {
		case SELECT_RIGHT_FIST:
			mpanel->rfist_x->Off();
			mpanel->rfist_y->Off();
			mpanel->rfist_z->Off();
		break;
		case SELECT_LEFT_FIST:
			mpanel->lfist_x->Off();
			mpanel->lfist_y->Off();
			mpanel->lfist_z->Off();
		break;
		case SELECT_RIGHT_TOE:
			mpanel->rtoe_x->Off();
			mpanel->rtoe_y->Off();
			mpanel->rtoe_z->Off();
		break;
		case SELECT_LEFT_TOE:
			mpanel->ltoe_x->Off();
			mpanel->ltoe_y->Off();
			mpanel->ltoe_z->Off();
		break;
		case SELECT_WAIST:
			mpanel->waist_x->Off();
			mpanel->waist_y->Off();
			mpanel->waist_z->Off();
		break;
		case SELECT_HEAD:
			mpanel->head_x->Off();
			mpanel->head_y->Off();
			mpanel->head_z->Off();
		break;
	}
}

void MotionPage::SetPanelRightDoubleClick(int which_pick) {
	switch (which_pick)  {
		case SELECT_RIGHT_FIST:
			mpanel->rfist_a->Off();
			mpanel->rfist_b->Off();
			mpanel->rfist_g->Off();
		break;
		case SELECT_LEFT_FIST:
			mpanel->lfist_a->Off();
			mpanel->lfist_b->Off();
			mpanel->lfist_g->Off();
		break;
		case SELECT_RIGHT_TOE:
			mpanel->rtoe_a->Off();
			mpanel->rtoe_b->Off();
			mpanel->rtoe_g->Off();
		break;
		case SELECT_LEFT_TOE:
			mpanel->ltoe_a->Off();
			mpanel->ltoe_b->Off();
			mpanel->ltoe_g->Off();
		break;
		case SELECT_WAIST:
			mpanel->waist_a->Off();
			mpanel->waist_b->Off();
			mpanel->waist_g->Off();
		break;
		case SELECT_HEAD:
			mpanel->head_a->Off();
			mpanel->head_b->Off();
			mpanel->head_g->Off();
		break;
	}
}

void MotionPage::SetPanelViewX(int which_pick, float objx, float objy) {
	switch (which_pick)  {
		case SELECT_RIGHT_FIST:
			mpanel->rfist_x->On();
			mpanel->rfist_y->On();
			mpanel->rfist_x->SetValueF(objx, 1000);
			mpanel->rfist_y->SetValueF(objy, 1000);
		break;
		case SELECT_LEFT_FIST:
			mpanel->lfist_x->On();
			mpanel->lfist_y->On();
			mpanel->lfist_x->SetValueF(objx, 1000);
			mpanel->lfist_y->SetValueF(objy, 1000);
		break;
		case SELECT_RIGHT_TOE:
			mpanel->rtoe_x->On();
			mpanel->rtoe_y->On();
			mpanel->rtoe_x->SetValueF(objx, 1000);
			mpanel->rtoe_y->SetValueF(objy, 1000);
		break;
		case SELECT_LEFT_TOE:
			mpanel->ltoe_x->On();
			mpanel->ltoe_y->On();
			mpanel->ltoe_x->SetValueF(objx, 1000);
			mpanel->ltoe_y->SetValueF(objy, 1000);
		break;
		case SELECT_WAIST:
			mpanel->waist_x->On();
			mpanel->waist_y->On();
			mpanel->waist_x->SetValueF(objx, 1000);
			mpanel->waist_y->SetValueF(objy, 1000);
		break;
		case SELECT_HEAD:
			mpanel->head_x->On();
			mpanel->head_y->On();
			mpanel->head_x->SetValueF(objx, 1000);
			mpanel->head_y->SetValueF(objy, 1000);
		break;
	}
}

void MotionPage::SetPanelViewY(int which_pick, float objy, float objz) {
	switch (which_pick)  {
		case SELECT_RIGHT_FIST:
			mpanel->rfist_y->On();
			mpanel->rfist_z->On();
			mpanel->rfist_y->SetValueF(objy, 1000);
			mpanel->rfist_z->SetValueF(objz, 1000);
		break;
		case SELECT_LEFT_FIST:
			mpanel->lfist_y->On();
			mpanel->lfist_z->On();
			mpanel->lfist_y->SetValueF(objy, 1000);
			mpanel->lfist_z->SetValueF(objz, 1000);
		break;
		case SELECT_RIGHT_TOE:
			mpanel->rtoe_y->On();
			mpanel->rtoe_z->On();
			mpanel->rtoe_y->SetValueF(objy, 1000);
			mpanel->rtoe_z->SetValueF(objz, 1000);
		break;
		case SELECT_LEFT_TOE:
			mpanel->ltoe_y->On();
			mpanel->ltoe_z->On();
			mpanel->ltoe_y->SetValueF(objy, 1000);
			mpanel->ltoe_z->SetValueF(objz, 1000);
		break;
		case SELECT_WAIST:
			mpanel->waist_y->On();
			mpanel->waist_z->On();
			mpanel->waist_y->SetValueF(objy, 1000);
			mpanel->waist_z->SetValueF(objz, 1000);
		break;
		case SELECT_HEAD:
			mpanel->head_y->On();
			mpanel->head_z->On();
			mpanel->head_y->SetValueF(objy, 1000);
			mpanel->head_z->SetValueF(objz, 1000);
		break;
	}
}

void MotionPage::SetPanelViewZ(int which_pick, float objz, float objx) {
	switch (which_pick)  {
		case SELECT_RIGHT_FIST:
			mpanel->rfist_z->On();
			mpanel->rfist_x->On();
			mpanel->rfist_z->SetValueF(objz, 1000);
			mpanel->rfist_x->SetValueF(objx, 1000);
		break;
		case SELECT_LEFT_FIST:
			mpanel->lfist_z->On();
			mpanel->lfist_x->On();
			mpanel->lfist_z->SetValueF(objz, 1000);
			mpanel->lfist_x->SetValueF(objx, 1000);
		break;
		case SELECT_RIGHT_TOE:
			mpanel->rtoe_z->On();
			mpanel->rtoe_x->On();
			mpanel->rtoe_z->SetValueF(objz, 1000);
			mpanel->rtoe_x->SetValueF(objx, 1000);
		break;
		case SELECT_LEFT_TOE:
			mpanel->ltoe_z->On();
			mpanel->ltoe_x->On();
			mpanel->ltoe_z->SetValueF(objz, 1000);
			mpanel->ltoe_x->SetValueF(objx, 1000);
		break;
		case SELECT_WAIST:
			mpanel->waist_z->On();
			mpanel->waist_x->On();
			mpanel->waist_z->SetValueF(objz, 1000);
			mpanel->waist_x->SetValueF(objx, 1000);
		break;
		case SELECT_HEAD:
			mpanel->head_z->On();
			mpanel->head_x->On();
			mpanel->head_z->SetValueF(objz, 1000);
			mpanel->head_x->SetValueF(objx, 1000);
		break;
	}
}

void MotionPage::SetPanelViewP(int which_pick, float objx, float objy, float objz) {
	switch (which_pick)  {
		case SELECT_RIGHT_FIST:
			mpanel->rfist_x->On();
			mpanel->rfist_y->On();
			mpanel->rfist_z->On();
			mpanel->rfist_x->SetValueF(objx, 1000);
			mpanel->rfist_y->SetValueF(objy, 1000);
			mpanel->rfist_z->SetValueF(objz, 1000);
		break;
		case SELECT_LEFT_FIST:
			mpanel->lfist_x->On();
			mpanel->lfist_y->On();
			mpanel->lfist_z->On();
			mpanel->lfist_x->SetValueF(objx, 1000);
			mpanel->lfist_y->SetValueF(objy, 1000);
			mpanel->lfist_z->SetValueF(objz, 1000);
		break;
		case SELECT_RIGHT_TOE:
			mpanel->rtoe_x->On();
			mpanel->rtoe_y->On();
			mpanel->rtoe_z->On();
			mpanel->rtoe_x->SetValueF(objx, 1000);
			mpanel->rtoe_y->SetValueF(objy, 1000);
			mpanel->rtoe_z->SetValueF(objz, 1000);
		break;
		case SELECT_LEFT_TOE:
			mpanel->ltoe_x->On();
			mpanel->ltoe_y->On();
			mpanel->ltoe_z->On();
			mpanel->ltoe_x->SetValueF(objx, 1000);
			mpanel->ltoe_y->SetValueF(objy, 1000);
			mpanel->ltoe_z->SetValueF(objz, 1000);
		break;
		case SELECT_WAIST:
			mpanel->waist_x->On();
			mpanel->waist_y->On();
			mpanel->waist_z->On();
			mpanel->waist_x->SetValueF(objx, 1000);
			mpanel->waist_y->SetValueF(objy, 1000);
			mpanel->waist_z->SetValueF(objz, 1000);
		break;
		case SELECT_HEAD:
			mpanel->head_x->On();
			mpanel->head_y->On();
			mpanel->head_z->On();
			mpanel->head_x->SetValueF(objx, 1000);
			mpanel->head_y->SetValueF(objy, 1000);
			mpanel->head_z->SetValueF(objz, 1000);
		break;
	}
}

bool MotionPage::Save(wxTextOutputStream &out) {
	int i, j, k;
	wxString str;
	SaveInfo(select_motion);
	out << wxT("#Motion Data made by ") << wxT(BM_CAPTION_EN_TITLE) << endl;
	out << wxT("#Max Motion") << endl;
	out << MaxMotion() << endl;;
	out << wxT("#Select Motion") << endl;
	out << SelectMotion() << endl;;
	for (i = 0; i < MaxMotion(); i++) {
		MotionInfo *m = &infos[i];
		str.Printf("#Motion No. %d", i);
		out << str << endl;
		out << wxT("#Motion Name") << endl;
		out << m->name << endl;		
		out << wxT("#Motion Speed") << endl;
		out << m->speed << endl;		
		out << wxT("#Max Frame") << endl;
		out << m->max_frames << endl;		
		out << wxT("#Select Frame") << endl;
		out << m->select_frame << endl;;
		for (j = 0; j < m->max_frames; j++) {
			FrameInfo *f = &m->frames[j];
			str.Printf("#Frame No. %d", j);
			out << str << endl;
			out << wxT("#Frame Name") << endl;
			out << f->name << endl;		
			out << wxT("#Frame Count") << endl;
			out << f->number << endl;		
			out << wxT("#Frame Joint Data") << endl;
			for (k = 0; k < 44; k++) {
				out << f->bframe[k] << endl;
			}
			out << wxT("#Frame Fix State") << endl;
			out << f->rfist_fix << endl;
			out << f->lfist_fix << endl;
			out << f->rtoe_fix << endl;
			out << f->ltoe_fix << endl;
			out << f->waist_fix << endl;
			out << f->head_fix << endl;
		}      
	}        
	return true;
}

bool MotionPage::SaveCurrent(wxTextOutputStream &out) {
	int i, j, k;
	wxString str;
	SaveInfo(select_motion);
	out << wxT("#Motion Data made by ") << wxT(BM_CAPTION_EN_TITLE) << endl;
	out << wxT("#Max Motion") << endl;
	out << 1 << endl;;
	out << wxT("#Select Motion") << endl;
	out << 0 << endl;;
	i = SelectMotion();
	MotionInfo *m = &infos[i];
	str.Printf("#Motion No. %d", 0);
	out << str << endl;
	out << wxT("#Motion Name") << endl;
	out << m->name << endl;		
	out << wxT("#Motion Speed") << endl;
	out << m->speed << endl;		
	out << wxT("#Max Frame") << endl;
	out << m->max_frames << endl;		
	out << wxT("#Select Frame") << endl;
	out << m->select_frame << endl;;
	for (j = 0; j < m->max_frames; j++) {
		FrameInfo *f = &m->frames[j];
		str.Printf("#Frame No. %d", j);
		out << str << endl;
		out << wxT("#Frame Name") << endl;
		out << f->name << endl;		
		out << wxT("#Frame Count") << endl;
		out << f->number << endl;		
		out << wxT("#Frame Joint Data") << endl;
		for (k = 0; k < 44; k++) {
			out << f->bframe[k] << endl;
		}
		out << wxT("#Frame Fix State") << endl;
		out << f->rfist_fix << endl;
		out << f->lfist_fix << endl;
		out << f->rtoe_fix << endl;
		out << f->ltoe_fix << endl;
		out << f->waist_fix << endl;
		out << f->head_fix << endl;
	}      

	return true;
}
	
bool MotionPage::Load(wxTextInputStream &in) {
	int i, j, k, max, max_now, select, max_f;
	float arg;
	wxString str;
	str = in.ReadLine();
	str = in.ReadLine();
	in >> max;
	if (max > 100 || max < 1) {
		wxLogError("⡼ο۾Ǥ");
		return false;
	}
	str = in.ReadLine();
	in >> select;

	max_now = infos.GetCount();
	for (i = 0; i < max; i++) {
		SetInfo(max_now);
	}
	for (i = 0; i < max; i++) {
		MotionInfo *m = &infos[i + max_now];
		str = in.ReadLine();
		str = in.ReadLine();
		m->name = in.ReadLine();
		str = in.ReadLine();
		in >> m->speed;

		str = in.ReadLine();
		in >> max_f;
		if (max_f > 80 || max_f < 2) {
			wxLogError("ե졼ο۾Ǥ");
			return false;
		}

		while((int)m->frames.GetCount() > max_f) {
			m->frames.RemoveAt(0);		
		}
		while((int)m->frames.GetCount() < max_f) {
			FrameInfo new_info;			
			m->frames.Add(new_info);		
		}
		m->max_frames = m->frames.GetCount();

		str = in.ReadLine();
		in >> m->select_frame;
		if (m->select_frame >= m->max_frames) {
			wxLogError("ե졼ǡ۾Ǥ");
			return false;
		}
		for (j = 0; j < max_f; j++) {
			FrameInfo *f = &m->frames[j];
			str = in.ReadLine();
			str = in.ReadLine();
			f->name = in.ReadLine();
			str = in.ReadLine();
			in >> f->number;
			str = in.ReadLine();
			for (k = 0; k < 44; k++) {
				in >> arg;
				f->bframe[k] = arg;
			}
			str = in.ReadLine();
			in >> f->rfist_fix;
			in >> f->lfist_fix;
			in >> f->rtoe_fix;
			in >> f->ltoe_fix;
			in >> f->waist_fix;
			in >> f->head_fix; 
/*			
			f->rfist_fix = 0;
			in >> num;
			f->rfist_fix |= num;
			in >> num;
			f->rfist_fix |= num<<1;
			in >> num;
			f->rfist_fix |= num<<2;
			in >> num;
			f->rfist_fix |= num<<4;
			in >> num;
			f->rfist_fix |= num<<5;
			in >> num;
			f->rfist_fix |= num<<6; */ 
		}
	}
	max_motions = infos.GetCount();
	MakeComboList();
	if (max_now + select >= MaxMotion()) {
		wxLogError("⡼ǡ۾Ǥ");
		return false;
	}
	select_motion = max_now + select;
	GetInfo(select_motion);
	SetSelection(select_motion);
	SetRange();	
	return true;
}
