#include "myframe.h"
#include "myglcanvas.h"
#include "mynotebook.h"

BEGIN_EVENT_TABLE(myFrame, wxFrame)
    EVT_MENU(MENU_SAVE, myFrame::OnSave)
    EVT_MENU(MENU_SAVEAS,myFrame::OnSaveAs)
    EVT_MENU(MENU_LOAD, myFrame::OnLoad)
    EVT_MENU(MENU_LOADOLD, myFrame::OnLoadOld)
    EVT_MENU(MENU_CLEAR, myFrame::OnClear)
    EVT_MENU(MENU_QUIT, myFrame::OnQuit)
   	EVT_MENU(MENU_UNDO, myFrame::OnUndo)
    EVT_MENU(MENU_REDO, myFrame::OnRedo)
    EVT_MENU(MENU_FRAME_COPY, myFrame::OnFrameCopy)
    EVT_MENU(MENU_FRAME_PASTE, myFrame::OnFramePaste)
    EVT_MENU(MENU_FRAME_UP, myFrame::OnFrameUp)
    EVT_MENU(MENU_FRAME_DOWN, myFrame::OnFrameDown)
    EVT_MENU(MENU_MOTION_TOGGLE, myFrame::OnMotionToggle)
	EVT_MENU(MENU_OPTION_RING, myFrame::OnOptionRing)
    EVT_MENU(MENU_OPTION_SANDBAG, myFrame::OnOptionSandbag)
    EVT_MENU(MENU_OPTION_ANOTHERBOXER, myFrame::OnOptionAnotherBoxer)
    EVT_MENU(MENU_OPTION_BACKGROUND, myFrame::OnOptionBackGround)
    EVT_MENU(MENU_OPTION_SHADOW, myFrame::OnOptionShadow)
    EVT_MENU(MENU_OPTION_CENTER, myFrame::OnOptionCenter)
    EVT_MENU(MENU_OPTION_RANGE, myFrame::OnOptionRange)
    EVT_MENU(MENU_OPTION_CAMERAS, myFrame::OnOptionCameras)
    EVT_MENU(MENU_OPTION_MULTI, myFrame::OnOptionMulti)
    EVT_MENU(MENU_OPTION_FIX, myFrame::OnOptionFix)
    EVT_MENU(MENU_OPTION_OTHERSIDE, myFrame::OnOptionOtherSide)
    EVT_MENU(MENU_OPTION_ORTHO, myFrame::OnOptionOrtho)
    EVT_MENU(MENU_OPTION_LIGHT, myFrame::OnOptionLight)
 	EVT_MENU(MENU_MOTION_SAVE, myFrame::OnMotionSave)
    EVT_MENU(MENU_MOTION_SAVEAS, myFrame::OnMotionSaveAs)
    EVT_MENU(MENU_MOTION_SAVECURRENT, myFrame::OnMotionSaveCurrent)
    EVT_MENU(MENU_MOTION_LOAD, myFrame::OnMotionLoad)
    EVT_MENU(MENU_MOTION_LOADADD, myFrame::OnMotionLoadAdd)
    EVT_MENU(MENU_MOTION_ADD, myFrame::OnMotionAdd)
    EVT_MENU(MENU_MOTION_DEL, myFrame::OnMotionDel)
    EVT_MENU(MENU_MOTION_OFFSET, myFrame::OnMotionOffSet)
    EVT_MENU(MENU_MOTION_OFFSET_ALL, myFrame::OnMotionOffSetAll)
    EVT_MENU(MENU_MOTION_REVERSE, myFrame::OnMotionReverse)
    EVT_MENU(MENU_MOTION_REVERSE_ALL, myFrame::OnMotionReverseAll)
    EVT_MENU(MENU_MOTION_INTERPOLATE, myFrame::OnMotionInterpolate)
    EVT_MENU(MENU_MOTION_LAGRANGE, myFrame::OnMotionLagrange)
    EVT_MENU(MENU_MOTION_FRAME_ALL, myFrame::OnMotionFrameAll)
 	EVT_MENU(MENU_THINK_SAVE, myFrame::OnThinkSave)
    EVT_MENU(MENU_THINK_SAVEAS, myFrame::OnThinkSaveAs)
    EVT_MENU(MENU_THINK_LOAD, myFrame::OnThinkLoad)
    EVT_MENU(MENU_THINK_PRE, myFrame::OnThinkPre)
    EVT_MENU(MENU_THINK_NEXT, myFrame::OnThinkNext)
//	EVT_MENU(MENU_HELP, myFrame::OnHelp)
    EVT_MENU(MENU_ABOUT, myFrame::OnAbout)
	EVT_CLOSE(myFrame::OnClose)
END_EVENT_TABLE()

myFrame::myFrame() : wxFrame(NULL, -1, wxT("")) {    
	SetProperties();
    DoLayout();
}

void myFrame::LoadArgumentFile(char *argument) {
	bfile = wxString(argument);
	if (bfile.FileExists()) {
		Load();	
	} else {
		LoadDefaultFile();	
	}
}

void myFrame::LoadDefaultFile() {
#ifndef CUT_PAGES
	bfile = wxT("./default.box");
	if (bfile.FileExists()) {
		Load();	
	}
	bfile.Clear();	
#else
	mfile = wxT("./default.mot");
	if (mfile.FileExists()) {
		note->motionpage->ClearMotion();
		if (!MotionLoadAdd()) {
			note->motionpage->AddMotion();
		}	
		note->MakeComboLists();
		status_bar->SetStatusText(wxT("ɤ߹ߤޤ"));
	}
	mfile.Clear();	
#endif
	tfile.Clear();
}

void myFrame::SetProperties() {
    SetTitle(wxT(BM_CAPTION_TITLE));
#ifdef __WXMSW__
	SetIcon(wxICON(BMICON));
#endif
	SetSize(wxSize(640, 480));
	Centre();
	Maximize();
	SetBackgroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_3DFACE));

#ifdef	 __WXGTK__	
	Show(TRUE);
#else
	canvas = new myGLCanvas(this);
#endif

    menu_bar = new wxMenuBar();
	status_bar = new wxStatusBar(this, -1);

	SetMenuBar(menu_bar);
    wxMenu* file = new wxMenu();
    menu_bar->Append(file, wxT("ե(&F)"));
    file->Append(MENU_SAVE, wxT("¸(&S)\tCtrl-S"), wxT("¸ޤ"));
    file->Append(MENU_SAVEAS, wxT("̾Ĥ¸(&A)\tCtrl-A"), wxT("̾Ĥ¸ޤ"));
    file->Append(MENU_LOAD, wxT("ɹ(&L)\tCtrl-L"), wxT("ɤ߹ߤޤ"));
    file->Append(MENU_LOADOLD, wxT("Сɹ(&O)\tCtrl-O"), wxT("СΥǡɤ߹ߤޤ"));
    file->Append(MENU_CLEAR, wxT("(&N)\tCtrl-N"), wxT("ꥢޤ"));
    file->Append(MENU_QUIT, wxT("λ(&E)\tCtrl-E"), wxT("λޤ"));
	wxMenu *edit = new wxMenu();
	menu_bar->Append(edit, wxT("Խ(&E)"));
	edit->Append(MENU_UNDO, wxT("᤹(&Z)\tCtrl-Z"), wxT("ξ֤ᤷޤ"));
	edit->Append(MENU_REDO, wxT("ľ(&X)\tCtrl-X"), wxT("֤ʤޤ"));
	edit->Append(MENU_FRAME_COPY, wxT("ԡ(&C)\tCtrl-C"), wxT("ե졼Υԡ"));
	edit->Append(MENU_FRAME_PASTE, wxT("ڡ(&V)\tCtrl-V"), wxT("ե졼Υڡ"));
	edit->Append(MENU_FRAME_UP, wxT("ե졼(&F2)\tF2"), wxT("Υե졼"));
	edit->Append(MENU_FRAME_DOWN, wxT("ե졼(&F3)\tF3"), wxT("Υե졼"));
	edit->Append(MENU_MOTION_TOGGLE, wxT("⡼(&F4)\tF4"), wxT("⡼¹"));
	option = new wxMenu();
	menu_bar->Append(option, wxT("ɽ\(&O)"));
	option->AppendCheckItem(MENU_OPTION_RING, wxT("ɽ\(&R)\tShift-R"), wxT("󥰤ɽ\ޤ"));
	option->AppendCheckItem(MENU_OPTION_SANDBAG, wxT("ɥХåɽ\(&S)\tShift-S"), wxT("ɥХåɽ\ޤ"));
	option->AppendCheckItem(MENU_OPTION_ANOTHERBOXER, wxT("ܥɽ\(&B)\tShift-B"), wxT("ܥ⤦Τɽ\ޤ"));
	option->AppendCheckItem(MENU_OPTION_BACKGROUND, wxT("طɽ\(&D)\tShift-D"), wxT("طʤɽ\ޤ"));
	option->AppendCheckItem(MENU_OPTION_SHADOW, wxT("ɽ\(&H)\tShift-H"), wxT("Ƥɽ\ޤ"));
	option->AppendCheckItem(MENU_OPTION_CENTER, wxT("ſɽ\(&G)\tShift-G"), wxT("ſɽ\ޤ"));
	option->AppendCheckItem(MENU_OPTION_RANGE, wxT("ܿɽ\(&A)\tShift-A"), wxT("ܿϰϤɽ\ޤ"));
	option->AppendCheckItem(MENU_OPTION_CAMERAS, wxT("ɽ\(&C)\tShift-C"), wxT("ɽ\ޤ"));
	option->AppendCheckItem(MENU_OPTION_MULTI, wxT("ޥӥ塼(&M)\tShift-M"), wxT("ޥӥ塼ˤޤ"));
	option->Check(MENU_OPTION_MULTI, true);
	option->AppendCheckItem(MENU_OPTION_FIX, wxT("(&F)\tShift-F"), wxT("ޥӥ塼Υꤷޤ"));
	option->Check(MENU_OPTION_FIX, true);
	option->AppendCheckItem(MENU_OPTION_OTHERSIDE, wxT("ȿ(&W)\tShift-W"), wxT("ޥӥ塼ȿˤޤ"));
	option->AppendCheckItem(MENU_OPTION_ORTHO, wxT("ʿ(&O)\tShift-O"), wxT("ƩƤʿƤˤޤ"));
	option->AppendCheckItem(MENU_OPTION_LIGHT, wxT("ŷ饤(&L)\tShift-L"), wxT("ŷΥ饤ȤĤޤ"));
	wxMenu* motion = new wxMenu();
	menu_bar->Append(motion, wxT("⡼(&M)"));
	motion->Append(MENU_MOTION_SAVE, wxT("⡼¸(&S)\tAlt-S"), wxT("⡼¸ޤ"));
	motion->Append(MENU_MOTION_SAVEAS, wxT("̾Ĥ¸(&A)\tAlt-A"), wxT("̾Ĥƥ⡼¸ޤ"));
	motion->Append(MENU_MOTION_SAVECURRENT, wxT("⡼¸(&C)\tAlt-C"), wxT("⡼¸ޤ"));
	motion->Append(MENU_MOTION_LOAD, wxT("⡼ɹ(&L)\tAlt-L"), wxT("⡼ɤ߹ߤޤ"));
	motion->Append(MENU_MOTION_LOADADD, wxT("⡼ɲɹ(&I)\tAlt-I"), wxT("⡼ɲɤ߹ߤޤ"));
	motion->Append(MENU_MOTION_ADD, wxT("⡼ɲ(&M)\tAlt-M"), wxT("⡼ɲäޤ"));
	motion->Append(MENU_MOTION_DEL, wxT("⡼(&D)\tAlt-D"), wxT("⡼ޤ"));
	motion->Append(MENU_MOTION_OFFSET, wxT("⤵եå(&O)\tAlt-O"), wxT("⤵ΥեåȤ򤷤ޤ"));
	motion->Append(MENU_MOTION_OFFSET_ALL, wxT("⤵եå(&Q)\tAlt-Q"), wxT("٤ƹ⤵ΥեåȤ򤷤ޤ"));
	motion->Append(MENU_MOTION_REVERSE, wxT("ȿž(&R)\tAlt-R"), wxT("ȿžޤ"));
	motion->Append(MENU_MOTION_REVERSE_ALL, wxT("ȿž(&U)\tAlt-U"), wxT("٤ƺȿžޤ"));
 	motion->Append(MENU_MOTION_INTERPOLATE, wxT("ե졼(&P)\tAlt-P"), wxT("ե졼֤򤷤ޤ"));
 	motion->Append(MENU_MOTION_LAGRANGE, wxT("饰󥸥(&T)\tAlt-T"), wxT("ե졼Υ饰󥸥֤򤷤ޤ"));
 	motion->Append(MENU_MOTION_FRAME_ALL, wxT("ե졼ಽ(&F)\tAlt-F"), wxT("٤ƤΥޤե졼ಽޤ"));
	wxMenu* think = new wxMenu();
	menu_bar->Append(think, wxT("׹ͥ롼(&T)"));
	think->Append(MENU_THINK_SAVE, wxT("׹ͥ롼¸(&S)\tCtrl-Shift-S"), wxT("׹ͥ롼¸ޤ"));
	think->Append(MENU_THINK_SAVEAS, wxT("̾Ĥ¸(&A)\tCtrl-Shift-A"), wxT("̾Ĥƻ׹ͥ롼¸ޤ"));
	think->Append(MENU_THINK_LOAD, wxT("׹ͥ롼ɹ(&L)\tCtrl-Shift-L"), wxT("׹ͥ롼ɤ߹ߤޤ"));
	think->Append(MENU_THINK_PRE, wxT("λ׹(&F5)\tF5"), wxT("λ׹"));
	think->Append(MENU_THINK_NEXT, wxT("λ׹(&F6)\tF6"), wxT("λ׹"));
    wxMenu* help = new wxMenu();
    menu_bar->Append(help, wxT("إ(&H)"));
//	help->Append(MENU_ABOUT, wxT("С(&V)\tCtrl-V"), wxT("ޥ˥奢ɽޤΥץˤĤ"));
    help->Append(MENU_ABOUT, wxT("С(&H)\tF1"), wxT("ΥץˤĤ"));

/*
	helpwin = new wxFrame(this, -1, wxT("ޥ˥奢"));
	helpwin->Hide();
	wxhtml = new wxHtmlWindow(helpwin);
*/	
	SetStatusBar(status_bar);
}

void myFrame::DoLayout() {
#ifdef	 __WXGTK__	
	canvas = new myGLCanvas(this);
#endif
//	note = new myNotebook(this, canvas);
	note = canvas->GetNote();

	wxBoxSizer *tsizer = new wxBoxSizer(wxHORIZONTAL);
#if wxCHECK_VERSION(2, 6, 0)
	wxBoxSizer *nsizer = new wxBoxSizer(wxHORIZONTAL);
	nsizer->Add(note, 3, wxGROW);
#else
	wxNotebookSizer *nsizer = new wxNotebookSizer(note);
#endif
	tsizer->Add(nsizer, 3, wxGROW);
 	tsizer->Add(canvas, 5, wxGROW);
	SetSizer(tsizer);
	Layout();
}

void myFrame::OnQuit(wxCommandEvent& event) {
	Close(true);
}

void myFrame::OnUndo(wxCommandEvent& event) {
	canvas->Undo();
}

void myFrame::OnRedo(wxCommandEvent& event) {
	canvas->Redo();
}

void myFrame::OnFrameUp(wxCommandEvent& event) {
	note->FrameUp();
}

void myFrame::OnFrameDown(wxCommandEvent& event) {
	note->FrameDown();
}

void myFrame::OnFrameCopy(wxCommandEvent& event) {
	note->FrameCopy();
}

void myFrame::OnFramePaste(wxCommandEvent& event) {
	note->FramePaste();
}

void myFrame::OnMotionToggle(wxCommandEvent& event) {
	note->MotionToggle();
}

void myFrame::OnOptionRing(wxCommandEvent& event) {
	canvas->Refresh();
}

void myFrame::SetOptionRing(bool value) {
	option->Check(MENU_OPTION_RING, value);
}

bool myFrame::IsOptionRing() {
	return option->IsChecked(MENU_OPTION_RING);
}

void myFrame::OnOptionSandbag(wxCommandEvent& event) {
	if (IsOptionSandbag()) {
		SetOptionAnotherBoxer(false);	
	}
	canvas->Refresh();
}

void myFrame::SetOptionSandbag(bool value) {
	option->Check(MENU_OPTION_SANDBAG, value);
}

bool myFrame::IsOptionSandbag() {
	return option->IsChecked(MENU_OPTION_SANDBAG);
}

void myFrame::OnOptionAnotherBoxer(wxCommandEvent& event) {
	if (IsOptionAnotherBoxer()) {
		SetOptionSandbag(false);	
	}
	canvas->Refresh();
}

void myFrame::SetOptionAnotherBoxer(bool value) {
	option->Check(MENU_OPTION_ANOTHERBOXER, value);
}

bool myFrame::IsOptionAnotherBoxer() {
	return option->IsChecked(MENU_OPTION_ANOTHERBOXER);
}

void myFrame::OnOptionBackGround(wxCommandEvent& event) {
	canvas->Refresh();
}

void myFrame::SetOptionBackGround(bool value) {
	option->Check(MENU_OPTION_BACKGROUND, value);
}

bool myFrame::IsOptionBackGround() {
	return option->IsChecked(MENU_OPTION_BACKGROUND);
}

void myFrame::OnOptionShadow(wxCommandEvent& event) {
	canvas->Refresh();
}

void myFrame::SetOptionShadow(bool value) {
	option->Check(MENU_OPTION_SHADOW, value);
}

bool myFrame::IsOptionShadow() {
	return option->IsChecked(MENU_OPTION_SHADOW);
}

void myFrame::OnOptionCameras(wxCommandEvent& event) {
	canvas->Refresh();
}

void myFrame::SetOptionCameras(bool value) {
	option->Check(MENU_OPTION_CAMERAS, value);
}

bool myFrame::IsOptionCameras() {
	return option->IsChecked(MENU_OPTION_CAMERAS);
}

void myFrame::OnOptionMulti(wxCommandEvent& event) {
	canvas->Refresh();
}

void myFrame::SetOptionMulti(bool value) {
	option->Check(MENU_OPTION_MULTI, value);
}

bool myFrame::IsOptionMulti() {
	return option->IsChecked(MENU_OPTION_MULTI);
}

void myFrame::OnOptionOtherSide(wxCommandEvent& event) {
	if (IsOptionOtherSide()) {
		canvas->ChangeDistance(-5.0);
	} else {
		canvas->ChangeDistance(5.0);
	}
	canvas->Refresh();
}

void myFrame::SetOptionOtherSide(bool value) {
	option->Check(MENU_OPTION_OTHERSIDE, value);
	if (IsOptionOtherSide()) {
		canvas->ChangeDistance(-5.0);
	} else {
		canvas->ChangeDistance(5.0);
	}
}

bool myFrame::IsOptionOtherSide() {
	return option->IsChecked(MENU_OPTION_OTHERSIDE);
}

void myFrame::OnOptionOrtho(wxCommandEvent& event) {
	canvas->Refresh();
}

void myFrame::SetOptionOrtho(bool value) {
	option->Check(MENU_OPTION_ORTHO, value);
}

bool myFrame::IsOptionOrtho() {
	return option->IsChecked(MENU_OPTION_ORTHO);
}

void myFrame::SetOptionLight(bool value) {
	option->Check(MENU_OPTION_LIGHT, value);
}

void myFrame::OnOptionLight(wxCommandEvent& event) {
	canvas->Refresh();
}

bool myFrame::IsOptionLight() {
	return option->IsChecked(MENU_OPTION_LIGHT);
}

void myFrame::SetOptionFix(bool value) {
	option->Check(MENU_OPTION_FIX, value);
}

bool myFrame::IsOptionFix() {
	return option->IsChecked(MENU_OPTION_FIX);
}

void myFrame::OnOptionFix(wxCommandEvent& event) {
	canvas->Refresh();
}

void myFrame::SetOptionCenter(bool value) {
	option->Check(MENU_OPTION_CENTER, value);
}

bool myFrame::IsOptionCenter() {
	return option->IsChecked(MENU_OPTION_CENTER);
}

void myFrame::OnOptionCenter(wxCommandEvent& event) {
	SetOptionRange(false);
	canvas->Refresh();
}

void myFrame::SetOptionRange(bool value) {
	option->Check(MENU_OPTION_RANGE, value);
}

bool myFrame::IsOptionRange() {
	return option->IsChecked(MENU_OPTION_RANGE);
}

void myFrame::OnOptionRange(wxCommandEvent& event) {
	SetOptionCenter(false);
	canvas->Refresh();
}

void myFrame::OnMotionAdd(wxCommandEvent& event) {
	note->motionpage->AddMotion();
	note->MakeComboLists();
}

void myFrame::OnMotionDel(wxCommandEvent& event) {
	note->MovingOff();
	note->motionpage->DelMotion();
	note->MakeComboLists();
}

bool myFrame::MotionSave() {
	wxFileOutputStream fout(mfile.GetFullPath());	
	wxTextOutputStream out(fout);	

	if (!fout.Ok()) {
		status_bar->SetStatusText(wxT("ե뤬ޤ"));
		return false;	
	}
	return note->SaveMotion(out);
}

bool myFrame::MotionSaveCurrent() {
	wxFileOutputStream fout(mfile.GetFullPath());	
	wxTextOutputStream out(fout);	

	if (!fout.Ok()) {
		status_bar->SetStatusText(wxT("ե뤬ޤ"));
		return false;	
	}
	return note->SaveCurrentMotion(out);
}

bool myFrame::MotionSaveAs() {
	wxFileDialog dialog(this, wxT("⡼ե"),
	wxT("./"), wxT(""), wxT("Motion (*.mot)|*.mot"), wxSAVE|wxOVERWRITE_PROMPT);
		
	if (dialog.ShowModal() == wxID_OK)	{	
		mfile = dialog.GetPath().c_str();
		return true;
	} else {
		status_bar->SetStatusText(wxT("¸"));
		return false;		 
    }
}

void myFrame::OnMotionSave(wxCommandEvent& event) {
	if (!mfile.IsOk()){
		if(!MotionSaveAs()) {
			return;		
		}
	}
	MotionSave();
	status_bar->SetStatusText(wxT("¸ޤ"));
}

void myFrame::OnMotionSaveAs(wxCommandEvent& event) {
	if(!MotionSaveAs()) {
		return;		
	}
	MotionSave();
	status_bar->SetStatusText(wxT("¸ޤ"));
}

void myFrame::OnMotionSaveCurrent(wxCommandEvent& event) {
	if(!MotionSaveAs()) {
		return;		
	}
	MotionSaveCurrent();
	status_bar->SetStatusText(wxT("¸ޤ"));
}

bool myFrame::MotionLoad() {
	wxFileDialog dialog(this, wxT("⡼ե"),
		wxT("./"), wxT(""), wxT("Motion (*.mot)|*.mot"));

    if (dialog.ShowModal() == wxID_OK)	{
		mfile = dialog.GetPath().c_str();
		return true;
    } else {
		return false;
	}
}

bool myFrame::MotionLoadAdd() {
	wxFileInputStream fin(mfile.GetFullPath());	
	wxTextInputStream in(fin);	
	if (!fin.Ok()) {
		status_bar->SetStatusText(wxT("ե뤬ޤ"));
		return false;	
	}       
	return note->LoadMotion(in);
}

void myFrame::OnMotionLoad(wxCommandEvent& event) {
	note->MovingOff(); 
	if (MotionLoad()) {
		note->motionpage->ClearMotion();
		if (!MotionLoadAdd()) {
			note->motionpage->AddMotion();
		}	
		note->MakeComboLists();
		status_bar->SetStatusText(wxT("ɤ߹ߤޤ"));
	}
}

void myFrame::OnMotionLoadAdd(wxCommandEvent& event) {
	note->MovingOff();
	if (MotionLoad()) {
		MotionLoadAdd();		
		note->MakeComboLists();
		status_bar->SetStatusText(wxT("ɤ߹ߤޤ"));
	}
}

void myFrame::OnMotionOffSet(wxCommandEvent& event) {
	if (!note->IsMoving()){
		note->SetSelection(4);
		note->motionpage->OffSet();
	}
}

void myFrame::OnMotionOffSetAll(wxCommandEvent& event) {
	if (!note->IsMoving()){
		note->SetSelection(4);
		note->motionpage->OffSetAll();
	}
}

void myFrame::OnMotionReverse(wxCommandEvent& event) {
	if (!note->IsMoving()){
		note->SetSelection(4);
		note->motionpage->Reverse();
	}
}

void myFrame::OnMotionReverseAll(wxCommandEvent& event) {
	if (!note->IsMoving()){
		note->SetSelection(4);
		note->motionpage->ReverseAll();
	}
}

void myFrame::OnMotionInterpolate(wxCommandEvent& event) {
	if (!note->IsMoving()){
		if (note->motionpage->MaxFrame() > 32) {
			status_bar->SetStatusText(wxT("ե졼¿ޤ"));		
		} else {
			note->SetSelection(4);
			note->motionpage->Interpolate();		
		}
	}
}

void myFrame::OnMotionLagrange(wxCommandEvent& event) {
	if (!note->IsMoving()){
		if (note->motionpage->MaxFrame() > 32) {
			status_bar->SetStatusText(wxT("ե졼¿ޤ"));		
		} else if (note->motionpage->MaxFrame() < 4){
			status_bar->SetStatusText(wxT("ե졼ʤޤ"));				
		} else {
			note->SetSelection(4);
			note->motionpage->LagrangeInterpolate();		
		}
	}
}

void myFrame::OnMotionFrameAll(wxCommandEvent& event) {
	if (!note->IsMoving()){
		note->SetSelection(4);
		note->motionpage->FrameAll();		
	}
}

bool myFrame::ThinkSave() {
	wxFileOutputStream fout(tfile.GetFullPath());	
	wxTextOutputStream out(fout);	

	if (!fout.Ok()) {
		status_bar->SetStatusText(wxT("ե뤬ޤ"));
		return false;	
	}
	return note->SaveThink(out);
}

bool myFrame::ThinkSaveAs() {
	wxFileDialog dialog(this, wxT("׹ͥե"),
	wxT("./"), wxT(""), wxT("Think (*.thk)|*.thk"), wxSAVE|wxOVERWRITE_PROMPT);
		
	if (dialog.ShowModal() == wxID_OK)	{	
		tfile = dialog.GetPath().c_str();
		return true;
	} else {
		status_bar->SetStatusText(wxT("¸"));
		return false;		 
    }
}

void myFrame::OnThinkSave(wxCommandEvent& event) {
	if (!tfile.IsOk()){
		if(!ThinkSaveAs()) {
			return;		
		}
	}
	ThinkSave();
	status_bar->SetStatusText(wxT("¸ޤ"));
}

void myFrame::OnThinkSaveAs(wxCommandEvent& event) {
	if(!ThinkSaveAs()) {
		return;		
	}
	ThinkSave();
	status_bar->SetStatusText(wxT("¸ޤ"));
}

bool myFrame::ThinkLoad() {
	wxFileDialog dialog(this, wxT("׹ͥե"),
		wxT("./"), wxT(""), wxT("Think (*.thk)|*.thk"));

    if (dialog.ShowModal() == wxID_OK)	{
		tfile = dialog.GetPath().c_str();
    } else {
		return false;
	}	

	wxFileInputStream fin(tfile.GetFullPath());	
	wxTextInputStream in(fin);	

	if (!fin.Ok()) {
		status_bar->SetStatusText(wxT("ե뤬ޤ"));
		return false;	
	}

	return note->LoadThink(in);
}

void myFrame::OnThinkLoad(wxCommandEvent& event) {
	if (ThinkLoad()) {
		note->tpage->MakeComboLists();
		status_bar->SetStatusText(wxT("ɤ߹ߤޤ"));
	}
}


void myFrame::OnThinkPre(wxCommandEvent& event) {
	note->ThinkPre();
}

void myFrame::OnThinkNext(wxCommandEvent& event) {
	note->ThinkNext();
}


bool myFrame::Save() {
	wxFileOutputStream fout(bfile.GetFullPath());	
	wxTextOutputStream out(fout);	
	note->MovingOff();

	if (!fout.Ok()) {
		status_bar->SetStatusText(wxT("ե뤬ޤ"));
		return false;	
	}
	
	wxString str;
	out << wxT("#Boxer Data made by ") << wxT(BM_CAPTION_EN_TITLE) << endl;

	out << wxT("#Optoin State") << endl;
	out << (int)IsOptionMulti() << endl;
	out << (int)IsOptionOrtho() << endl;
	out << (int)IsOptionLight() << endl;
	out << (int)IsOptionRing() << endl;
	out << (int)IsOptionSandbag() << endl;
	out << (int)IsOptionCameras() << endl;
	out << (int)IsOptionFix() << endl;
	out << (int)IsOptionCenter() << endl;
	out << (int)IsOptionRange() << endl;
	out << (int)IsOptionBackGround() << endl;
	out << (int)IsOptionOtherSide() << endl;
	out << (int)IsOptionShadow() << endl;
	out << (int)IsOptionAnotherBoxer() << endl;

	note->SaveBody(out);
	note->SaveMaterial(out);
	note->SaveCamera(out);
	note->SaveMotion(out);
	note->SaveCombo(out);
	note->SaveAssign(out);
	note->SaveRange(out);
	note->SaveThink(out);
	note->SaveOther(out);
	return true;
}

bool myFrame::SaveAs() {
	wxFileDialog dialog(this, wxT("ܥե"),
		wxT("./"), wxT(""), wxT("Boxer (*.box)|*.box"), wxSAVE|wxOVERWRITE_PROMPT);
		
	if (dialog.ShowModal() == wxID_OK)	{	
		bfile = dialog.GetPath().c_str();
		return true;
	} else {
		status_bar->SetStatusText(wxT("¸"));
		return false;		 
    }
}

void myFrame::OnSave(wxCommandEvent& event) {
	if (!bfile.IsOk()){
		if(!SaveAs()) {
			return;		
		}
	}
	if (Save()) {
		status_bar->SetStatusText(wxT("¸ޤ"));	
	}
}

void myFrame::OnSaveAs(wxCommandEvent& event) {
	if(!SaveAs()) {
		return;		
	}
	if (Save()) {
		status_bar->SetStatusText(wxT("¸ޤ"));
	}
}

bool myFrame::Load() {
	wxFileInputStream fin(bfile.GetFullPath());	
	wxTextInputStream in(fin);	
	note->MovingOff();

	if (!fin.Ok()) {
		status_bar->SetStatusText(wxT("ե뤬ޤ"));
		return false;	
	}

	int num;
	wxString str;
	str = in.ReadLine();
//	out << wxT("#Boxer Data made by BoxerMaker") << endl;

	str = in.ReadLine();
//	out << wxT("#Optoin State") << endl;
	in >> num;
	SetOptionMulti((bool)num);
	in >> num;
	SetOptionOrtho((bool)num);
	in >> num;
	SetOptionLight((bool)num);
	in >> num;
	SetOptionRing((bool)num);
	in >> num;
	SetOptionSandbag((bool)num);
	in >> num;
	SetOptionCameras((bool)num);
	in >> num;
	SetOptionFix((bool)num);
	in >> num;
	SetOptionCenter((bool)num);
	in >> num;
	SetOptionRange((bool)num);
	in >> num;
	SetOptionBackGround((bool)num);
	in >> num;
	SetOptionOtherSide((bool)num);
	in >> num;
	SetOptionShadow((bool)num);
	in >> num;
	SetOptionAnotherBoxer((bool)num);

	if(!note->LoadBody(in)) {
		status_bar->SetStatusText(wxT("ǡ۾Ǥ"));		
	}

	if(!note->LoadMaterial(in)) {
		status_bar->SetStatusText(wxT("ǡ۾Ǥ"));				
	}

	if(!note->LoadCamera(in)) {
		status_bar->SetStatusText(wxT("ǡ۾Ǥ"));	
		return false;
    }
	
	note->motionpage->ClearMotion();
	if(!note->LoadMotion(in)) {
		status_bar->SetStatusText(wxT("ǡ۾Ǥ"));	
		return false;
    }
	note->MakeComboLists();

	if(!note->LoadCombo(in)) {
		status_bar->SetStatusText(wxT("ǡ۾Ǥ"));	
		return false;
    }   

	if(!note->LoadAssign(in)) {
		status_bar->SetStatusText(wxT("ǡ۾Ǥ"));	
		return false;
    }   

	if(!note->LoadRange(in)) {
		status_bar->SetStatusText(wxT("ǡ۾Ǥ"));	
		return false;
    }   
	
	if(!note->LoadThink(in)) {
		status_bar->SetStatusText(wxT("ǡ۾Ǥ"));	
		return false;
    }   

	if(!note->LoadOther(in)) {
		status_bar->SetStatusText(wxT("ǡ۾Ǥ"));	
		return false;
    }   
	return true;
}


void myFrame::OnLoad(wxCommandEvent& event) {
	wxFileDialog dialog(this, wxT("ܥե"),
		wxT("./"), wxT(""), wxT("Boxer (*.box)|*.box"));

    if (dialog.ShowModal() == wxID_OK)	{
		bfile = dialog.GetPath().c_str();
    } else {
		status_bar->SetStatusText(wxT("ɤ߹"));
		return;
	}
 
	if (Load()) {
		status_bar->SetStatusText(wxT("ɤ߹ߤޤ"));	
	}
}

bool myFrame::LoadOld() {
	wxFileInputStream fin(bfile.GetFullPath());	
	wxTextInputStream in(fin);	
	note->MovingOff();

	if (!fin.Ok()) {
		status_bar->SetStatusText(wxT("ե뤬ޤ"));
		return false;	
	}

	int num;
	wxString str;
	str = in.ReadLine();
//	out << wxT("#Boxer Data made by BoxerMaker") << endl;

	str = in.ReadLine();
//	out << wxT("#Optoin State") << endl;
	in >> num;
	SetOptionMulti((bool)num);
	in >> num;
	SetOptionOrtho((bool)num);
	in >> num;
	SetOptionLight((bool)num);
	in >> num;
	SetOptionRing((bool)num);
	in >> num;
	SetOptionSandbag((bool)num);
	in >> num;
	SetOptionCameras((bool)num);
	in >> num;
	SetOptionFix((bool)num);
	in >> num;
	SetOptionCenter((bool)num);
	in >> num;
	SetOptionRange((bool)num);
	in >> num;
	SetOptionBackGround((bool)num);
	in >> num;
	SetOptionOtherSide((bool)num);
	in >> num;
	SetOptionShadow((bool)num);
	in >> num;
	SetOptionAnotherBoxer((bool)num);

	if(!note->LoadBody(in)) {
		status_bar->SetStatusText(wxT("ǡ۾Ǥ"));		
	}

	if(!note->LoadMaterial(in)) {
		status_bar->SetStatusText(wxT("ǡ۾Ǥ"));				
	}

	if(!note->LoadCamera(in)) {
		status_bar->SetStatusText(wxT("ǡ۾Ǥ"));	
		return false;
    }
	
	note->motionpage->ClearMotion();
	if(!note->LoadMotion(in)) {
		status_bar->SetStatusText(wxT("ǡ۾Ǥ"));	
		return false;
    }
	note->MakeComboLists();

	if(!note->LoadCombo(in)) {
		status_bar->SetStatusText(wxT("ǡ۾Ǥ"));	
		return false;
    }   

	if(!note->LoadAssign(in)) {
		status_bar->SetStatusText(wxT("ǡ۾Ǥ"));	
		return false;
    }   

	if(!note->LoadRange(in)) {
		status_bar->SetStatusText(wxT("ǡ۾Ǥ"));	
		return false;
    }   
	
	if(!note->LoadThink(in)) {
		status_bar->SetStatusText(wxT("ǡ۾Ǥ"));	
		return false;
    }   

	return true;
}

void myFrame::OnLoadOld(wxCommandEvent& event) {
	wxFileDialog dialog(this, wxT("ܥե"),
		wxT("./"), wxT(""), wxT("Boxer (*.box)|*.box"));

    if (dialog.ShowModal() == wxID_OK)	{
		bfile = dialog.GetPath().c_str();
    } else {
		status_bar->SetStatusText(wxT("ɤ߹"));
		return;
	}
 
	if (LoadOld()) {
		status_bar->SetStatusText(wxT("ɤ߹ߤޤ"));	
	}
}

void myFrame::OnClear(wxCommandEvent& event) {
	bfile.Clear();	
	mfile.Clear();	
	note->Clear();
	status_bar->SetStatusText(wxT("ꥢޤ"));	
}

void myFrame::OnAbout(wxCommandEvent& event) {
    wxMessageBox(wxT(BM_CAPTION_TITLE), wxT("ΥץˤĤ"), wxOK | wxICON_INFORMATION, this);
}

/*
void myFrame::OnHelp(wxCommandEvent& event) {
	wxhtml->LoadPage("./Manual/index.html");
	helpwin->Show();
}
*/

void myFrame::OnClose(wxCloseEvent& event){
#ifndef CUT_PAGES
	bfile = wxT("./default.box");
	Save(); 
#endif
	mfile = wxT("./default.mot");
	MotionSave();
	Destroy();
}
