#ifndef MYFRAME_H
#define MYFRAME_H

#include <wx/wx.h>
#include <wx/filename.h>
#include <wx/wfstream.h>
#include <wx/txtstrm.h>
#include <wx/wxhtml.h>

class myGLCanvas;
class myNotebook;

#define BM_MAJOR_VERSION "1"
#define BM_MINOR_VERSION "2"
#define BM_PATCH_LEVEL   "0"
#define BM_VERSION_NAME "꡼"
#define BM_VERSION_EN_NAME "Release"
#define BM_CAPTION_TITLE "ܥ᡼ Ver " BM_MAJOR_VERSION "." BM_MINOR_VERSION "." BM_PATCH_LEVEL " " BM_VERSION_NAME
#define BM_CAPTION_EN_TITLE "BoxerMaker Ver " BM_MAJOR_VERSION "." BM_MINOR_VERSION "." BM_PATCH_LEVEL " " BM_VERSION_EN_NAME

#ifdef	 __WXGTK__	
#undef	BM_CAPTION_TITLE
#define	BM_CAPTION_TITLE	BM_CAPTION_EN_TITLE
#endif

//#define CUT_PAGES

class myFrame: public wxFrame {
public:
    myFrame();
 	bool IsOptionRing() ;
 	bool IsOptionSandbag();
    bool IsOptionAnotherBoxer();
 	bool IsOptionBackGround();
 	bool IsOptionShadow();
 	bool IsOptionCenter();
 	bool IsOptionRange();
 	bool IsOptionCameras();
 	bool IsOptionMulti();
 	bool IsOptionOtherSide();
 	bool IsOptionOrtho();
 	bool IsOptionLight();
 	bool IsOptionFix();
 	void SetOptionRing(bool value);
 	void SetOptionSandbag(bool value);
    void SetOptionAnotherBoxer(bool value);
 	void SetOptionBackGround(bool value);
 	void SetOptionShadow(bool value);
 	void SetOptionCenter(bool value);
 	void SetOptionRange(bool value);
 	void SetOptionCameras(bool value);
 	void SetOptionMulti(bool value);
 	void SetOptionOtherSide(bool value);
 	void SetOptionOrtho(bool value);
 	void SetOptionLight(bool value);
 	void SetOptionFix(bool value);
	void LoadArgumentFile(char *filename);
	void LoadDefaultFile();
private:
    void SetProperties();
    void DoLayout();
    bool Save();
    bool SaveAs();
  	bool Load();
  	bool LoadOld();
    void OnQuit(wxCommandEvent& event);
    void OnSave(wxCommandEvent& event);
    void OnSaveAs(wxCommandEvent& event);
    void OnLoad(wxCommandEvent& event);
    void OnLoadOld(wxCommandEvent& event);
    void OnClear(wxCommandEvent& event);
//    void OnHelp(wxCommandEvent& event);
    void OnAbout(wxCommandEvent& event);
    void OnClose(wxCloseEvent& event);

    void OnUndo(wxCommandEvent& event);
    void OnRedo(wxCommandEvent& event);
    void OnFrameCopy(wxCommandEvent& event);
    void OnFramePaste(wxCommandEvent& event);
    void OnFrameUp(wxCommandEvent& event);
    void OnFrameDown(wxCommandEvent& event);
    void OnMotionToggle(wxCommandEvent& event);

    void OnOptionRing(wxCommandEvent& event);
    void OnOptionSandbag(wxCommandEvent& event);
    void OnOptionAnotherBoxer(wxCommandEvent& event);
    void OnOptionBackGround(wxCommandEvent& event);
    void OnOptionShadow(wxCommandEvent& event);
    void OnOptionCenter(wxCommandEvent& event);
    void OnOptionRange(wxCommandEvent& event);
    void OnOptionCameras(wxCommandEvent& event);
    void OnOptionMulti(wxCommandEvent& event);
    void OnOptionOtherSide(wxCommandEvent& event);
    void OnOptionOrtho(wxCommandEvent& event);
    void OnOptionLight(wxCommandEvent& event);
    void OnOptionFix(wxCommandEvent& event);

    bool MotionSave();
    bool MotionSaveAs();
    bool MotionSaveCurrent();
    bool MotionLoad();
    bool MotionLoadAdd();
    void OnMotionSave(wxCommandEvent& event);
    void OnMotionSaveAs(wxCommandEvent& event);
    void OnMotionSaveCurrent(wxCommandEvent& event);
    void OnMotionLoad(wxCommandEvent& event);
    void OnMotionLoadAdd(wxCommandEvent& event);
    void OnMotionAdd(wxCommandEvent& event);
    void OnMotionDel(wxCommandEvent& event);
    void OnMotionOffSet(wxCommandEvent& event);
    void OnMotionOffSetAll(wxCommandEvent& event);
    void OnMotionReverse(wxCommandEvent& event);
    void OnMotionReverseAll(wxCommandEvent& event);
    void OnMotionInterpolate(wxCommandEvent& event);
    void OnMotionLagrange(wxCommandEvent& event);
    void OnMotionFrameAll(wxCommandEvent& event);

	bool ThinkSave();
    bool ThinkSaveAs();
    bool ThinkLoad();
	void OnThinkSave(wxCommandEvent& event);
    void OnThinkSaveAs(wxCommandEvent& event);
    void OnThinkLoad(wxCommandEvent& event);
    void OnThinkPre(wxCommandEvent& event);
    void OnThinkNext(wxCommandEvent& event);
   
	myGLCanvas *canvas;
	myNotebook *note;
	wxMenuBar *menu_bar;
	wxStatusBar *status_bar;	
 	wxFileName bfile, mfile, tfile;
	wxMenu *option;
 /*
	wxFrame *helpwin;
	wxHtmlWindow *wxhtml;
*/ 
 	DECLARE_EVENT_TABLE()
};

enum {
    MENU_QUIT  = 1,
    MENU_SAVE,
    MENU_SAVEAS,
    MENU_LOAD,
    MENU_LOADOLD,
	MENU_CLEAR,
    MENU_UNDO,
	MENU_REDO,
	MENU_FRAME_COPY,
	MENU_FRAME_PASTE,
	MENU_FRAME_UP,
	MENU_FRAME_DOWN,
	MENU_MOTION_TOGGLE,
	MENU_OPTION_RING,
	MENU_OPTION_SANDBAG,
	MENU_OPTION_ANOTHERBOXER,
	MENU_OPTION_BACKGROUND,
	MENU_OPTION_SHADOW,
	MENU_OPTION_CAMERAS,
	MENU_OPTION_CENTER,
	MENU_OPTION_RANGE,
	MENU_OPTION_MULTI,
	MENU_OPTION_FIX,
	MENU_OPTION_OTHERSIDE,
	MENU_OPTION_ORTHO,
	MENU_OPTION_LIGHT,
	MENU_MOTION_SAVE,
	MENU_MOTION_SAVEAS,
	MENU_MOTION_SAVECURRENT,
	MENU_MOTION_LOAD,
	MENU_MOTION_LOADADD,
	MENU_MOTION_ADD,
	MENU_MOTION_DEL,
	MENU_MOTION_OFFSET,
	MENU_MOTION_OFFSET_ALL,
 	MENU_MOTION_REVERSE_ALL,
 	MENU_MOTION_REVERSE,
 	MENU_MOTION_INTERPOLATE,
 	MENU_MOTION_LAGRANGE,
 	MENU_MOTION_FRAME_ALL,
	MENU_THINK_SAVE,
	MENU_THINK_SAVEAS,
	MENU_THINK_LOAD,
	MENU_THINK_PRE,
	MENU_THINK_NEXT,
    MENU_HELP,
    MENU_ABOUT = wxID_ABOUT
};

#endif // MYFRAME_H
