#ifndef MYSLIDER_H
#define MYSLIDER_H

#include <wx/wx.h>
#include <wx/spinctrl.h>

class myGLCanvas;

class mySlider : public wxPanel {
public:
    mySlider(wxWindow* parent, myGLCanvas *ccanvas, const wxString & labelstr, int min_value, int max_value);
	int GetValue() const {return spin->GetValue();}
	float GetValueF(int base);
	void SetValue(int value);
	void SetValueF(float value, int base);
	void ValueUp(int value);
	void ValueDown(int value);

private:
    void SetProperties(const wxString & name, int min_value, int max_value);
    void DoLayout();
	void OnSlider(wxCommandEvent &event);
	void OnText(wxCommandEvent &event);
	void OnSpin(wxSpinEvent &event);
	void SetSlider();
	void OnSpinCtrlUp(wxSpinEvent &event);
	void OnSpinCtrlDown(wxSpinEvent &event);

	wxStaticText *label;
	wxSlider *slider;
	wxSpinCtrl *spin;
	myGLCanvas *canvas;
	DECLARE_EVENT_TABLE()
};

enum {
	ON_MY_SLIDER_ID,
	ON_MY_SPINCTRL_ID
};


class wxSpinSlider : public wxPanel {
public:
    wxSpinSlider(wxWindow* parent, int min_value, int max_value, int change_value);
	int GetValue() const {return spin->GetValue();}
	void SetValue(int value);

private:
    void SetProperties(int min_value, int max_value);
    void DoLayout();
	void OnSlider(wxCommandEvent &event);
	void OnText(wxCommandEvent &event);
	void OnSpin(wxSpinEvent &event);
	void SetSlider();
	void OnSpinCtrlUp(wxSpinEvent &event);
	void OnSpinCtrlDown(wxSpinEvent &event);

	wxSlider *slider;
	wxSpinCtrl *spin;
	int change;
	DECLARE_EVENT_TABLE()
};

enum {
	ON_SPINSLIDER_ID,
	ON_SPINSLIDERCTRL_ID
};

#endif // MYSLIDER_H
