#include "rangepage.h"
#include "myglcanvas.h"
#include "mynotebook.h"
#include "motionpage.h"
#include "boxer.h"

BEGIN_EVENT_TABLE(RangePage, wxScrolledWindow)
	EVT_BUTTON(ON_RESET_RANGE_ID, RangePage::OnResetRange)
	EVT_COMBOBOX(ON_BOXER_MOTION_ID, RangePage::OnSelectMotion)
	EVT_SLIDER(ON_BOXER_FRAME_ID, RangePage::OnSelectFrame)
	EVT_TOGGLEBUTTON(ON_SHOW_RANGE_ID, RangePage::OnShowRange) 
END_EVENT_TABLE()

RangePage::	RangePage(wxWindow* parent, myGLCanvas *ccanvas, MotionPage *cpage)
	: wxScrolledWindow(parent, -1) {
	canvas = ccanvas;
	page = cpage;
	SetProperties();
	DoLayout();
}

void RangePage::SetProperties() {
	SetScrollRate(10,10);

	reset = new wxButton(this, ON_RESET_RANGE_ID, wxT("ꥻå"));

	sandbag_dis = new mySlider(this, canvas, wxT("Υ : "), 300, 2000);
	sandbag_dis->SetValue(1000);

	boxer_dis = new mySlider(this, canvas, wxT("Υ : "), 300, 2000);
	boxer_dis->SetValue(1000);
	cbox = new wxComboBox(this, ON_BOXER_MOTION_ID);
//	cbox->SetSize(100, 20);
	cut_slider = new wxSlider(this, ON_BOXER_FRAME_ID, 0, 0, 50);
	cut_slider->SetSize(150, 20);
	show_range = new wxToggleButton(this, ON_SHOW_RANGE_ID, wxT("ܿɽ"));	
	MakeComboList();

	rfist_r = new mySlider(this, canvas, wxT("R : "), 0, 400);
	rfarm_r = new mySlider(this, canvas, wxT("R : "), 0, 400);
	ruarm_r = new mySlider(this, canvas, wxT("R : "), 0, 400);
	rshoulder_r = new mySlider(this, canvas, wxT("R : "), 00, 400);

	lfist_r = new mySlider(this, canvas, wxT("R : "), 0, 400);
	lfarm_r = new mySlider(this, canvas, wxT("R : "), 0, 400);
	luarm_r = new mySlider(this, canvas, wxT("R : "), 0, 400);
	lshoulder_r = new mySlider(this, canvas, wxT("R : "), 0, 400);

	body_r = new mySlider(this, canvas, wxT("ʢR : "), 0, 400);
	body_t = new mySlider(this, canvas, wxT("ʢTop : "), 0, 400);
	body_b = new mySlider(this, canvas, wxT("ʢBot : "), 0, 400);
	liver_r = new mySlider(this, canvas, wxT("¡R : "), 0, 400);
	liver_x = new mySlider(this, canvas, wxT("¡X : "), -400, 400);
	liver_y = new mySlider(this, canvas, wxT("¡Y : "), -400, 400);
	liver_z = new mySlider(this, canvas, wxT("¡Z : "), -400, 400);

	face_r = new mySlider(this, canvas, wxT("R : "), 0, 400);
	face_t = new mySlider(this, canvas, wxT("Top : "), 0, 400);
	face_b = new mySlider(this, canvas, wxT("Bot : "), 0, 400);
	jaw_r = new mySlider(this, canvas, wxT("R : "), 0, 400);
	jaw_x = new mySlider(this, canvas, wxT("X : "), -400, 400);
	jaw_y = new mySlider(this, canvas, wxT("Y : "), -400, 400);
	jaw_z = new mySlider(this, canvas, wxT("Z : "), -400, 400);
}

void RangePage::DoLayout() {
    wxBoxSizer *tsizer = new wxBoxSizer(wxVERTICAL);

    wxStaticBoxSizer *bsizer1 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ɥХå")), wxVERTICAL);
    wxStaticBoxSizer *bsizer2 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ܥ")), wxVERTICAL);
	wxBoxSizer *hsizer2 = new wxBoxSizer(wxHORIZONTAL);
    wxStaticBoxSizer *bsizer3 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("")), wxVERTICAL);
    wxStaticBoxSizer *bsizer4 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("")), wxVERTICAL);
    wxStaticBoxSizer *bsizer5 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ʢ")), wxVERTICAL);
    wxStaticBoxSizer *bsizer6 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("¡")), wxVERTICAL);
    wxStaticBoxSizer *bsizer7 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("")), wxVERTICAL);
    wxStaticBoxSizer *bsizer8 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("")), wxVERTICAL);

    wxBoxSizer *hsizer = new wxBoxSizer(wxHORIZONTAL);

 	tsizer->Add(bsizer1, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
 	tsizer->Add(bsizer2, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
 	tsizer->Add(hsizer2, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
 	tsizer->Add(bsizer3, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
 	tsizer->Add(bsizer4, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
 	tsizer->Add(bsizer5, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
 	tsizer->Add(bsizer6, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
 	tsizer->Add(bsizer7, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
 	tsizer->Add(bsizer8, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);

	bsizer1->Add(sandbag_dis, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);

	bsizer2->Add(boxer_dis, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
	bsizer2->Add(hsizer, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
	hsizer->Add(cbox, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
	hsizer->Add(cut_slider, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);

	hsizer2->Add(reset, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);
	hsizer2->Add(show_range, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 5);

	bsizer3->Add(rfist_r, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 3);
	bsizer3->Add(rfarm_r, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 3);
	bsizer3->Add(ruarm_r, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 3);
	bsizer3->Add(rshoulder_r, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 3);

	bsizer4->Add(lfist_r, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 3);
	bsizer4->Add(lfarm_r, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 3);
	bsizer4->Add(luarm_r, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 3);
	bsizer4->Add(lshoulder_r, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 3);

	bsizer5->Add(body_r, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 3);
	bsizer5->Add(body_t, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 3);
	bsizer5->Add(body_b, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 3);
	bsizer6->Add(liver_r, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 3);
	bsizer6->Add(liver_x, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 3);
	bsizer6->Add(liver_y, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 3);
	bsizer6->Add(liver_z, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 3);

	bsizer7->Add(face_r, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 3);
	bsizer7->Add(face_t, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 3);
	bsizer7->Add(face_b, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 3);
	bsizer8->Add(jaw_r, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 3);
	bsizer8->Add(jaw_x, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 3);
	bsizer8->Add(jaw_y, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 3);
	bsizer8->Add(jaw_z, 0, wxALIGN_CENTRE_HORIZONTAL |wxALIGN_CENTER_VERTICAL | wxALL, 3);

  	SetSizer(tsizer);
 	tsizer->SetVirtualSizeHints(this);
	FitInside();
	Layout();
}

void RangePage::GetRange(Boxer &boxer) {
	rfist_r->SetValueF(boxer.right_arm.fist.R(), 1000);
	rfarm_r->SetValueF(boxer.right_arm.forearm.R(), 1000);
	ruarm_r->SetValueF(boxer.right_arm.upperarm.R(), 1000);
	rshoulder_r->SetValueF(boxer.right_arm.shoulder.R(), 1000);
	
	lfist_r->SetValueF(boxer.left_arm.fist.R(), 1000);
	lfarm_r->SetValueF(boxer.left_arm.forearm.R(), 1000);
	luarm_r->SetValueF(boxer.left_arm.upperarm.R(), 1000);
	lshoulder_r->SetValueF(boxer.left_arm.shoulder.R(), 1000);

	body_r->SetValueF(boxer.body.abdomen.R(), 1000);
	body_t->SetValueF(boxer.body.abdomen.Top(), 1000);
	body_b->SetValueF(boxer.body.abdomen.Bottom(), 1000);
	liver_r->SetValueF(boxer.body.abdomen.LR(), 1000);
	liver_x->SetValueF(boxer.body.abdomen.LRX(), 1000);
	liver_y->SetValueF(boxer.body.abdomen.LRY(), 1000);
	liver_z->SetValueF(boxer.body.abdomen.LRZ(), 1000);
	
	face_r->SetValueF(boxer.head.face.R(), 1000);
	face_t->SetValueF(boxer.head.face.Top(), 1000);
	face_b->SetValueF(boxer.head.face.Bottom(), 1000);
	jaw_r->SetValueF(boxer.head.face.JR(), 1000);
	jaw_x->SetValueF(boxer.head.face.JRX(), 1000);
	jaw_y->SetValueF(boxer.head.face.JRY(), 1000);
	jaw_z->SetValueF(boxer.head.face.JRZ(), 1000);
}

void RangePage::SetRange(Boxer &boxer) {
	boxer.right_arm.fist.SetRange(rfist_r->GetValueF(1000));
	boxer.right_arm.forearm.SetRange(rfarm_r->GetValueF(1000));
	boxer.right_arm.upperarm.SetRange(ruarm_r->GetValueF(1000));
	boxer.right_arm.shoulder.SetRange(rshoulder_r->GetValueF(1000));

	boxer.left_arm.fist.SetRange(lfist_r->GetValueF(1000));
	boxer.left_arm.forearm.SetRange(lfarm_r->GetValueF(1000));
	boxer.left_arm.upperarm.SetRange(luarm_r->GetValueF(1000));
	boxer.left_arm.shoulder.SetRange(lshoulder_r->GetValueF(1000));

	boxer.body.abdomen.SetRange(
		body_r->GetValueF(1000),
		body_t->GetValueF(1000),
		body_b->GetValueF(1000));
	boxer.body.abdomen.SetLiver(
		liver_r->GetValueF(1000),
		liver_x->GetValueF(1000),
		liver_y->GetValueF(1000),
		liver_z->GetValueF(1000));

	boxer.head.face.SetRange(
		face_r->GetValueF(1000),
		face_t->GetValueF(1000),
		face_b->GetValueF(1000));
	boxer.head.face.SetJaw(
		jaw_r->GetValueF(1000),
		jaw_x->GetValueF(1000),
		jaw_y->GetValueF(1000),
		jaw_z->GetValueF(1000));
}

void RangePage::MakeComboList() {
	int i;
	cbox->Clear();	
	for (i = 0; i < (int)page->infos.GetCount(); i++) {
		cbox->Append(page->infos[i].name);
	}
	cbox->SetSelection(0);
	SetSliderRange(); 
}

void RangePage::SetSliderRange() {
	int i, total_number = 0;
	page->SaveInfo(page->SelectMotion());
	for (i = 0; i < page->infos[cbox->GetSelection()].frames.GetCount(); i++) {
		total_number += page->infos[cbox->GetSelection()].frames[i].number;	
	}
	cut_slider->SetRange(0, total_number);
}

void RangePage::SetFrame(Boxer &boxer) {

}

void RangePage::OnSelectMotion(wxCommandEvent &event) {
	if (cbox->GetSelection() == -1) {
		cbox->SetSelection(0);
	} else {
		canvas->Refresh();
	}
	SetSliderRange();
}	

void RangePage::OnResetRange(wxCommandEvent &event) {
	canvas->GetRanges();
	canvas->SetRanges();
	canvas->Refresh();
}

BFrame* RangePage::GetBoxerFrame() {
	BFrame *base, *next;
	int i, get_number, cut_number, total_number = 0;
	int current_cut, current_frame;
	int max_frame, select_motion = cbox->GetSelection();

	if (select_motion >= page->infos.GetCount()){
		select_motion = page->infos.GetCount()-1;	
	}
	if (select_motion < 0){
		select_motion = 0;	
	}
	max_frame = page->infos[select_motion].frames.GetCount();

	get_number = cut_slider->GetValue();
	for (i = 0; i < max_frame; i++) {
		cut_number = page->infos[select_motion].frames[i].number;
		total_number += cut_number;
	}
	if (get_number >= total_number) {
		get_number = total_number-1;	
	}
	total_number = 0;

	for (i = 0; i < max_frame; i++) {
		cut_number = page->infos[select_motion].frames[i].number;
		if ((total_number + cut_number) >= get_number) {
			break;
		} else {
			total_number += cut_number;
		}
	}

	current_cut = get_number - total_number;
	current_frame = i;
	base = &page->infos[select_motion].frames[current_frame].bframe;
	cut_number = page->infos[select_motion].frames[current_frame].number;
	if (i != max_frame - 1) {
		next = &page->infos[select_motion].frames[current_frame+1].bframe;
	} else {
		next = &page->infos[select_motion].frames[0].bframe;
	}
	bframe.Interpolate(base, next, current_cut, cut_number);			
	return &bframe;
}

void RangePage::OnSelectFrame(wxCommandEvent &event) {
	canvas->Refresh();
}		

void RangePage::OnShowRange(wxCommandEvent &event) {
	canvas->Refresh();
}

bool RangePage::Save(wxTextOutputStream &out) {
	out << wxT("#Range Data") << endl;
	out << wxT("#Sandbag Distance") << endl;
	out << sandbag_dis->GetValue() << endl;
	out << wxT("#Boxer Distance") << endl;
	out << sandbag_dis->GetValue() << endl;

	out << wxT("#Show Range") << endl;
	out << (int)show_range->GetValue() << endl;

	out << wxT("#Right Arm Range") << endl;
	out << rfist_r->GetValue() << endl;
	out << rfarm_r->GetValue() << endl;
	out << ruarm_r->GetValue() << endl;
	out << rshoulder_r->GetValue() << endl;

	out << wxT("#Left Arm Range") << endl;
	out << lfist_r->GetValue() << endl;
	out << lfarm_r->GetValue() << endl;
	out << luarm_r->GetValue() << endl;
	out << lshoulder_r->GetValue() << endl;

	out << wxT("#Body Range") << endl;
	out << body_r->GetValue() << endl;
	out << body_t->GetValue() << endl;
	out << body_b->GetValue() << endl;

	out << wxT("#Liver Range") << endl;
	out << liver_r->GetValue() << endl;
	out << liver_x->GetValue() << endl;
	out << liver_y->GetValue() << endl;
	out << liver_z->GetValue() << endl;

	out << wxT("#Face Range") << endl;
	out << face_r->GetValue() << endl;
	out << face_t->GetValue() << endl;
	out << face_b->GetValue() << endl;

	out << wxT("#Jaw Range") << endl;
	out << jaw_r->GetValue() << endl;
	out << jaw_x->GetValue() << endl;
	out << jaw_y->GetValue() << endl;
	out << jaw_z->GetValue() << endl;
	return true;
}
	
bool RangePage::Load(wxTextInputStream &in) {
	int num;
	wxString str;
	str = in.ReadLine();
	str = in.ReadLine();
	in >> num;
	sandbag_dis->SetValue(num);
	str = in.ReadLine();
	in >> num;
	boxer_dis->SetValue(num);

	str = in.ReadLine();
	in >> num;
	show_range->SetValue((bool)num);

	str = in.ReadLine();
	in >> num;
	rfist_r->SetValue(num);
	in >> num;
	rfarm_r->SetValue(num);
	in >> num;
	ruarm_r->SetValue(num);
	in >> num;
	rshoulder_r->SetValue(num);

	str = in.ReadLine();
	in >> num;
	lfist_r->SetValue(num);
	in >> num;
	lfarm_r->SetValue(num);
	in >> num;
	luarm_r->SetValue(num);
	in >> num;
	lshoulder_r->SetValue(num);

	str = in.ReadLine();
	in >> num;
	body_r->SetValue(num);
	in >> num;
	body_t->SetValue(num);
	in >> num;
	body_b->SetValue(num);

	str = in.ReadLine();
	in >> num;
	liver_r->SetValue(num);
	in >> num;
	liver_x->SetValue(num);
	in >> num;
	liver_y->SetValue(num);
	in >> num;
	liver_z->SetValue(num);

	str = in.ReadLine();
	in >> num;
	face_r->SetValue(num);
	in >> num;
	face_t->SetValue(num);
	in >> num;
	face_b->SetValue(num);

	str = in.ReadLine();
	in >> num;
	jaw_r->SetValue(num);
	in >> num;
	jaw_x->SetValue(num);
	in >> num;
	jaw_y->SetValue(num);
	in >> num;
	jaw_z->SetValue(num);

	canvas->SetRanges();	
	return true;
}
