#ifndef	RANGEPAGE_H
#define RANGEPAGE_H

#include <wx/wx.h>
#include <wx/button.h>
#include <wx/tglbtn.h>
#include <wx/combobox.h>
#include <wx/slider.h>
#include <wx/wfstream.h>
#include <wx/txtstrm.h>

#include "bframe.h"
#include "myslider.h"

class Boxer;
class myGLCanvas;
class MotionPage;

class RangePage : public wxScrolledWindow {
public:
	RangePage(wxWindow* parent, myGLCanvas *ccanvas, MotionPage *cpage);
	float SandbagDistance() const {return sandbag_dis->GetValueF(1000);}
	float BoxerDistance() const {return boxer_dis->GetValueF(1000);}
	bool IsShowRange() const {return show_range->GetValue();}
	BFrame* GetBoxerFrame();	
	void GetRange(Boxer &boxer);
	void SetRange(Boxer &boxer);
	void SetFrame(Boxer &boxer);
	void SetSliderRange();
	void MakeComboList();
	bool Save(wxTextOutputStream &out);
	bool Load(wxTextInputStream &in);
private:

	void OnResetRange(wxCommandEvent &event);		
	void OnSelectMotion(wxCommandEvent &event);		
	void OnSelectFrame(wxCommandEvent &event);		
	void OnShowRange(wxCommandEvent &event);

    void SetProperties();
    void DoLayout();

	wxButton *reset;

	mySlider *sandbag_dis;

	mySlider *boxer_dis;
	wxToggleButton *show_range;
	wxSlider *cut_slider;
	wxComboBox *cbox;
	
	mySlider *rfist_r;
	mySlider *rfarm_r;
	mySlider *ruarm_r;
	mySlider *rshoulder_r;

	mySlider *lfist_r;
	mySlider *lfarm_r;
	mySlider *luarm_r;
	mySlider *lshoulder_r;

	mySlider *body_r;
	mySlider *body_t;
	mySlider *body_b;
	mySlider *liver_r;
	mySlider *liver_x;
	mySlider *liver_y;
	mySlider *liver_z;

	mySlider *face_r;
	mySlider *face_t;
	mySlider *face_b;
	mySlider *jaw_r;
	mySlider *jaw_x;
	mySlider *jaw_y;
	mySlider *jaw_z;

	BFrame bframe;
	MotionPage* page;
	myGLCanvas *canvas;
	DECLARE_EVENT_TABLE()
};

enum {
 	ON_RESET_RANGE_ID,
 	ON_BOXER_MOTION_ID,
	ON_BOXER_FRAME_ID,
	ON_SHOW_RANGE_ID
};

#endif // RANGEPAGE_H
