#include "audiopage.h"
#include "basicpage.h"

BEGIN_EVENT_TABLE(AudioPage, wxScrolledWindow)
	EVT_BUTTON(-1, AudioPage::OnSelect) 
END_EVENT_TABLE()

AudioPage::AudioPage(wxWindow* parent) : wxScrolledWindow(parent, -1) {
	SetProperties();
	DoLayout();
}

void AudioPage::SetProperties() {
	int i;

	labelf1= new myLabel(this, wxT("ե̾"));
	labelf2= new myLabel(this, wxT("ե̾"));

	BGMCf = new myFileSelect(this);
	BGMCf->SetStartDir(wxT("./BGM"));
	SECf = new myFileSelect(this);
	SECf->SetStartDir(wxT("./SE"));

	label1[0] = new myLabel(this, wxT("ȥ"));
	label1[1] = new myLabel(this, wxT("ȥ졼˥"));
	label1[2] = new myLabel(this, wxT(""));

	for (i = 0; i < 3; i++) {
		BGM[i] = new myFileSelect(this);
		BGM[i]->SetInfo(wxT("BGMե"));
		BGM[i]->SetWildCard(wxT("BGM (*.mid;*.ogg;*.wav;*.mod;*.s3m;*.it;*.xm;*.mp3)|*.mid;*.ogg;*.wav;*.mod;*.s3m;*.it;*.xm;*.mp3"));
		BGM[i]->SetStartDir(wxT("./BGM"));
	}

	label2[0] = new myLabel(this, wxT(""));
	label2[1] = new myLabel(this, wxT("罪λ"));
	label2[2] = new myLabel(this, wxT(""));
	label2[3] = new myLabel(this, wxT(""));
	label2[4] = new myLabel(this, wxT("å"));
	label2[5] = new myLabel(this, wxT("ҥå"));
	label2[6] = new myLabel(this, wxT("ҥå"));
	label2[7] = new myLabel(this, wxT("ʢҥå"));
	label2[8] = new myLabel(this, wxT("֥å"));
 	label2[9] = new myLabel(this, wxT("ܥå"));
	label2[10] = new myLabel(this, wxT("֥쥤"));
	label2[11] = new myLabel(this, wxT(""));

	for (i = 0; i < 12; i++) {
		SE[i] = new myFileSelect(this);
		SE[i]->SetInfo(wxT("̲ե"));
		SE[i]->SetWildCard(wxT("SE(*.wav;*.ogg;*.aif)|*.wav;*.ogg;*.aif"));
		SE[i]->SetStartDir(wxT("./SE"));
	} 
}

void AudioPage::DoLayout() {
	int i;
	wxBoxSizer *tsizer = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *tsizer1 = new wxBoxSizer(wxVERTICAL);
	wxBoxSizer *tsizer2 = new wxBoxSizer(wxVERTICAL);

	wxStaticBoxSizer *bsizerf1 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("BGMե")), wxHORIZONTAL);
	wxStaticBoxSizer *bsizerf2 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ե")), wxHORIZONTAL);

	wxStaticBoxSizer *bsizer1 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("BGM")), wxVERTICAL);
	wxStaticBoxSizer *bsizer2 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("̲")), wxVERTICAL);

 	tsizer->Add(tsizer1, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 5);
 	tsizer->Add(tsizer2, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 5);

 	tsizer1->Add(bsizerf1, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 5);
 	tsizer1->Add(bsizer1, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 5);
 	tsizer2->Add(bsizerf2, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 5);
 	tsizer2->Add(bsizer2, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 5);

	bsizerf1->Add(labelf1, 0, wxALIGN_CENTER_VERTICAL | wxALL, 0);
	bsizerf1->Add(BGMCf, 0, wxALIGN_CENTER_VERTICAL | wxALL, 0);
	wxBoxSizer *bsizer1h[3];
	for (i = 0; i < 3; i++) {
		bsizer1h[i] = new wxBoxSizer(wxHORIZONTAL);
	 	bsizer1->Add(bsizer1h[i], 0, wxALIGN_CENTER_VERTICAL | wxALL, 0);
		bsizer1h[i]->Add(label1[i], 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
		bsizer1h[i]->Add(BGM[i], 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	}

	bsizerf2->Add(labelf2, 0, wxALIGN_CENTER_VERTICAL | wxALL, 0);
	bsizerf2->Add(SECf, 0, wxALIGN_CENTER_VERTICAL | wxALL, 0);
	wxBoxSizer *bsizer2h[12];
	for (i = 0; i < 12; i++) {
		bsizer2h[i] = new wxBoxSizer(wxHORIZONTAL);
	 	bsizer2->Add(bsizer2h[i], 0, wxALIGN_CENTER_VERTICAL | wxALL, 0);
		bsizer2h[i]->Add(label2[i], 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
		bsizer2h[i]->Add(SE[i], 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	}
	SetSizer(tsizer);
 	tsizer->SetVirtualSizeHints(this);
	FitInside();
	Layout(); 
}

void AudioPage::OnSelect(wxCommandEvent& event) {
	if (BGMCf->IsOK()) {
		LoadBGM();
	}
	if (SECf->IsOK()) {
		LoadSE();
	}
}

void AudioPage::SetDefault() {
	BGMCf->SetFilename(wxT("./BGM/bgmcf.txt"));
	BGM[0]->SetFilename(wxT("./BGM/selectgm.mid"));
	BGM[1]->SetFilename(wxT("./BGM/kokorogm.mid"));
	BGM[2]->SetFilename(wxT("./BGM/cumugm.mid"));

	SECf->SetFilename(wxT("./SE/secf.txt"));
	SE[0]->SetFilename(wxT("./SE/gong.wav"));
	SE[1]->SetFilename(wxT("./SE/ko.wav"));
	SE[2]->SetFilename(wxT("./SE/sha00.wav"));
	SE[3]->SetFilename(wxT("./SE/swing29.wav"));
	SE[4]->SetFilename(wxT("./SE/qu.ogg"));
	SE[5]->SetFilename(wxT("./SE/gun08.wav"));
	SE[6]->SetFilename(wxT("./SE/hit_p01_c.wav"));
	SE[7]->SetFilename(wxT("./SE/hit_s07_a.wav"));
	SE[8]->SetFilename(wxT("./SE/bosu00.wav"));
	SE[9]->SetFilename(wxT("./SE/box.ogg"));
	SE[10]->SetFilename(wxT("./SE/break.ogg"));
	SE[11]->SetFilename(wxT("./SE/down.ogg"));
}


bool AudioPage::SaveBGMCf(wxTextOutputStream &out) {
	wxString str;
	out << BGMCf->GetFilename() << endl;
	return true;
}

bool AudioPage::LoadBGMCf(wxTextInputStream &in) {
	wxString str;
	str = NextLine(in);
	BGMCf->SetFilename(str);
	return true;
}

bool AudioPage::SaveSECf(wxTextOutputStream &out) {
	wxString str;
	out << SECf->GetFilename() << endl;
	return true;
}

bool AudioPage::LoadSECf(wxTextInputStream &in) {
	wxString str;
	str = NextLine(in);
	SECf->SetFilename(str);
	return true;
}

bool AudioPage::SaveBGM() {
	wxFileOutputStream fout(BGMCf->GetFilename());	
	wxTextOutputStream out(fout);	

	if (!fout.Ok()) {
		return false;	
	}

	int i;
	wxString str;	
	out << wxT("#Config File for BGM's") << endl;
	out << endl;
	for (i = 0; i < 3; i++) {
		str.Printf("#BGM No. %d\n", i + 1);
		out << str;
		out << BGM[i]->GetFilename() << endl;
	}
	out << endl;
	out << wxT("#End of File") << endl;
	return true;
}

bool AudioPage::LoadBGM() {
	wxFileInputStream fin(BGMCf->GetFilename());	
	wxTextInputStream in(fin);	

	if (!fin.Ok()) {
		return false;	
	}
	
	int i;
	wxString str;
	for (i = 0; i < 3; i++) {
		str = NextLine(in);
		BGM[i]->SetFilename(str);
	}
	return true;
}

bool AudioPage::SaveSE() {
	wxFileOutputStream fout(SECf->GetFilename());	
	wxTextOutputStream out(fout);	

	if (!fout.Ok()) {
		return false;	
	}

	int i;
	wxString str;	
	out << wxT("#Config File for SE's") << endl;
	out << endl;
	for (i = 0; i < 12; i++) {
		str.Printf("#Sound Effect No. %d\n", i + 1);
		out << str;
		out << SE[i]->GetFilename() << endl;
	}
	out << endl;
	out << wxT("#End of File") << endl;
	return true;
}

bool AudioPage::LoadSE() {
	wxFileInputStream fin(SECf->GetFilename());	
	wxTextInputStream in(fin);	

	if (!fin.Ok()) {
		return false;	
	}

	int i;
	wxString str;
	for (i = 0; i < 12; i++) {
		str = NextLine(in);
		SE[i]->SetFilename(str);
	}
	return true;
}
