#ifndef AUDIOPAGE_H
#define AUDIOPAGE_H

#include <wx/wx.h>
#include <wx/textctrl.h>
#include <wx/wfstream.h>
#include <wx/txtstrm.h>
#include <wx/combobox.h>
#include "myslider.h"
#include "mylabel.h"
#include "mycbox.h"
#include "mytctrl.h"
#include "myfileselect.h"

class AudioPage : public wxScrolledWindow {
public:
    AudioPage(wxWindow* parent);

	void SetDefault();

	bool SaveBGMCf(wxTextOutputStream &out);
	bool SaveSECf(wxTextOutputStream &out);
	bool SaveBGM();
	bool SaveSE();

	bool LoadBGMCf(wxTextInputStream &in);
	bool LoadSECf(wxTextInputStream &in);
	bool LoadBGM();
	bool LoadSE();

private:
    void SetProperties();
    void DoLayout();
	void OnSelect(wxCommandEvent& event);

	myLabel *labelf1;
	myLabel *labelf2;
	myFileSelect *BGMCf;
	myFileSelect *SECf;

	myLabel *label1[3];
	myFileSelect *BGM[3];

	myLabel *label2[12];
	myFileSelect *SE[12];
	
	DECLARE_EVENT_TABLE()
};

#endif // AUDIOPAGE_H
