#ifndef BASICPAGE_H
#define BASICPAGE_H

#include <wx/wx.h>
#include <wx/textctrl.h>
#include <wx/wfstream.h>
#include <wx/txtstrm.h>
#include <wx/combobox.h>
#include "myslider.h"
#include "mylabel.h"
#include "mycbox.h"
#include "mytctrl.h"
#include "myfileselect.h"

class BasicPage : public wxScrolledWindow {
public:
    BasicPage(wxWindow* parent);

	void SetDefault();
	void SetHigherSpec();
	void SetHighSpec();
	void SetMiddleSpec();
	void SetLowSpec();
	void SetLowerSpec();	

	bool Save(wxTextOutputStream &out);
	bool Load(wxTextInputStream &in);

private:
    void SetProperties();
    void DoLayout();

	myLabel *label1;
	myLabel *label2;
	myCBox *ScreenSize;
	myCBox *ScreenMode;

	myLabel *label3;
	myLabel *label4;
	myLabel *label5;
	myLabel *label6;
	myCBox *SoundFreq;
	myCBox *SoundForm;
	myCBox *SoundChan;
	myCBox *SoundBuff;
	
	myLabel *label7;
	myLabel *label8;
	mySlider *BGMVolume;
	mySlider *SEVolume;

	myLabel *label9;
	myLabel *label10;
	myLabel *label10_2;
	myCBox *Lang;
	myCBox *Font;
	myCBox *PFont;

	myLabel *label11;
	myLabel *label12;
	myLabel *label13;
	myLabel *label14;
	myLabel *label15;
	myLabel *label16;
	myLabel *label23;
	myLabel *label24;

	mySlider *Partition;
	myCBox *FaceStyle;
	myCBox *Shadow;
	myCBox *BackGround;
	myCBox *Ads;
	myCBox *MagFilter;
	myCBox *MinFilter;
	mySlider *SkipFrame;

	myLabel *label17;
	myLabel *label18;
	myLabel *label19;
	myLabel *label20;
	myLabel *label21;
	myLabel *label22;

	myCBox *DefaultView;	
	mySlider *Angle;
	mySlider *Brightness;

	myCBox *SkipOpening;
	myCBox *SkipReplay;
	myCBox *SkipDown;
};

wxString NextLine(wxTextInputStream &in);

#endif // BASICPAGE_H
