#include "boxerpage.h"
#include "basicpage.h"

BEGIN_EVENT_TABLE(BoxerPage, wxScrolledWindow)
	EVT_BUTTON(-1, BoxerPage::OnSelect) 
END_EVENT_TABLE()

BoxerPage::BoxerPage(wxWindow* parent) : wxScrolledWindow(parent, -1) {
	SetProperties();
	DoLayout();
}

void BoxerPage::SetProperties() {
	int i;
	wxString str;

	labelf= new myLabel(this, wxT("ե̾"));

	DataCf = new myFileSelect(this);
	DataCf->SetStartDir(wxT("./Data"));

	for (i = 0; i < 30; i++) {
		str.Printf("ܥ No.%d ", i + 1);
		label[i] = new myButton(this, str);

		Data[i] = new myFileSelect(this);
		Data[i]->SetInfo(wxT("ܥե"));
		Data[i]->SetWildCard(wxT("Boxer (*.box)|*.box"));
		Data[i]->SetStartDir(wxT("./Data"));
	}
}

void BoxerPage::DoLayout() {
	int i;
	wxBoxSizer *tsizer = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *tsizer1 = new wxBoxSizer(wxVERTICAL);
	wxBoxSizer *tsizer2 = new wxBoxSizer(wxVERTICAL);

	wxStaticBoxSizer *bsizerf1 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ǡե")), wxHORIZONTAL);

	wxStaticBoxSizer *bsizer1 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ܥǡ")), wxVERTICAL);
	wxStaticBoxSizer *bsizer2 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ܥǡ")), wxVERTICAL);

 	tsizer->Add(tsizer1, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 5);
 	tsizer->Add(tsizer2, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 5);

 	tsizer1->Add(bsizerf1, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 5);
 	tsizer1->Add(bsizer1, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 5);
 	tsizer2->Add(bsizer2, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 5);

	bsizerf1->Add(labelf, 0, wxALIGN_CENTER_VERTICAL | wxALL, 0);
	bsizerf1->Add(DataCf, 0, wxALIGN_CENTER_VERTICAL | wxALL, 0);
	wxBoxSizer *bsizer1h[30];
	for (i = 0; i < 14; i++) {
		bsizer1h[i] = new wxBoxSizer(wxHORIZONTAL);
	 	bsizer1->Add(bsizer1h[i], 0, wxALIGN_CENTER_VERTICAL | wxALL, 0);
		bsizer1h[i]->Add(label[i], 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
		bsizer1h[i]->Add(Data[i], 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	}
	for (i = 14; i < 30; i++) {
		bsizer1h[i] = new wxBoxSizer(wxHORIZONTAL);
	 	bsizer2->Add(bsizer1h[i], 0, wxALIGN_CENTER_VERTICAL | wxALL, 0);
		bsizer1h[i]->Add(label[i], 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
		bsizer1h[i]->Add(Data[i], 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	}

	SetSizer(tsizer);
 	tsizer->SetVirtualSizeHints(this);
	FitInside();
	Layout(); 
}

void BoxerPage::OnSelect(wxCommandEvent& event) {
	int i;
	wxObject *obj = event.GetEventObject();

	for (i = 0; i < 30; i++) {
		if(obj == (wxObject*)label[i]) {
		   if (!Data[i]->GetFilename().IsNull())	{
				wxString str;
				wxString str2;
				str = wxT("./Data/BoxerMaker.exe");
#ifdef	 __WXMSW__	
				str2.Printf("\"%s\"", Data[i]->GetFilename().c_str());
#else
				str2.Printf("%s", Data[i]->GetFilename().c_str());
#endif
				char *argv[3];
				argv[0] = (char *)str.c_str();
				argv[1] = (char *)str2.c_str();
				argv[2] = NULL;
				wxExecute(argv);
			}
			break;
		}
	}
		
	if (DataCf->IsOK()) {
		LoadData();
	}
}

void BoxerPage::SetDefault() {
	int i;
	DataCf->SetFilename(wxT("./Data/datacf.txt"));
	for (i = 0; i < 30; i++) {
		Data[i]->SetFilename(wxT(""));
	}
	LoadData();
/*	Data[0]->SetFilename(wxT("./Data/light.box"));
	Data[1]->SetFilename(wxT("./Data/peekaboo.box"));
	Data[2]->SetFilename(wxT("./Data/detroit.box"));
	Data[3]->SetFilename(wxT("./Data/hardguard.box"));
	Data[4]->SetFilename(wxT("./Data/noguard.box"));
	Data[5]->SetFilename(wxT("./Data/highspeed.box"));
	Data[6]->SetFilename(wxT("./Data/tricky.box"));
	Data[7]->SetFilename(wxT("./Data/lefty.box"));
	Data[8]->SetFilename(wxT("./Data/welter.box"));*/
}

bool BoxerPage::SaveDataCf(wxTextOutputStream &out) {
	wxString str;
	out << DataCf->GetFilename() << endl;
	return true;
}


bool BoxerPage::LoadDataCf(wxTextInputStream &in) {
	wxString str;
	str = NextLine(in);
	DataCf->SetFilename(str);
	return true;
}

bool BoxerPage::SaveData() {
	wxFileOutputStream fout(DataCf->GetFilename());	
	wxTextOutputStream out(fout);	

	if (!fout.Ok()) {
		return false;	
	}

 	int i, max;
	wxString str;	

	out << wxT("#Config File for Boxer Data") << endl;
	out << endl;
	out << wxT("#Gym Member Number") << endl;
	max = 0;
	for (i = 0; i < 30; i++) {
		if (!Data[i]->GetFilename().IsNull()) {
			max++;		
		}
	}
	out << max << endl;
	out << endl;

	for (i = 0; i < max; i++) {
		str.Printf("#Data No. %d\n", i + 1);
		out << str;
		out << Data[i]->GetFilename() << endl;
	}

	str.Printf("\n#Sparring Custom Config\n");
    out << str;
	str.Printf("#No.1 Height 1-7\n");
    out << str;
	str.Printf("#Default 4\n");
    out << str;
	str.Printf("%d\n", Custom1[0]);
    out << str;
	str.Printf("#No.1 Reach 1-7\n");
    out << str;
	str.Printf("#Default 4\n");
    out << str;
	str.Printf("%d\n", Custom1[1]);
    out << str;
	str.Printf("#No.1 Style 1-7\n");
    out << str;
	str.Printf("#Default 1\n");
    out << str;
	str.Printf("%d\n", Custom1[2]);
    out << str;
	str.Printf("#No.1 Stance  0 : Orthodox  1 : Southpaw\n");
    out << str;
	str.Printf("#Default 0\n");
    out << str;
	str.Printf("%d\n", Custom1[3]);
    out << str;
	str.Printf("#No.1 Combination 1-20\n");
    out << str;
	str.Printf("#Default 1\n");
    out << str;
	str.Printf("%d\n", Custom1[4]);
    out << str;
	str.Printf("#No.1 Think 1-14\n");
    out << str;
	str.Printf("#Default 1\n");
    out << str;
	str.Printf("%d\n", Custom1[5]);
    out << str;
	str.Printf("#No.1 Gloves 1-8\n");
    out << str;
	str.Printf("#Default 1\n");
    out << str;
	str.Printf("%d\n", Custom1[6]);
    out << str;
	str.Printf("#No.1 Trunks 1-64\n");
    out << str;
	str.Printf("#Default 1\n");
    out << str;
	str.Printf("%d\n", Custom1[7]);
    out << str;
	str.Printf("#No.1 Skin 1-10\n");
    out << str;
	str.Printf("#Default 3\n");
    out << str;
	str.Printf("%d\n", Custom1[8]);
    out << str;

	str.Printf("#No.2 Height 1-7\n");
    out << str;
	str.Printf("#Default 4\n");
    out << str;
	str.Printf("%d\n", Custom2[0]);
    out << str;
	str.Printf("#No.2 Reach 1-7\n");
    out << str;
	str.Printf("#Default 4\n");
    out << str;
	str.Printf("%d\n", Custom2[1]);
    out << str;
	str.Printf("#No.2 Style 1-7\n");
    out << str;
	str.Printf("#Default 1\n");
    out << str;
	str.Printf("%d\n", Custom2[2]);
    out << str;
	str.Printf("#No.2 Stance  0 : Orthodox  1 : Southpaw\n");
    out << str;
	str.Printf("#Default 0\n");
    out << str;
	str.Printf("%d\n", Custom2[3]);
    out << str;
	str.Printf("#No.2 Combination 1-20\n");
    out << str;
	str.Printf("#Default 1\n");
    out << str;
	str.Printf("%d\n", Custom2[4]);
    out << str;
	str.Printf("#No.2 Think 1-14\n");
    out << str;
	str.Printf("#Default 1\n");
    out << str;
	str.Printf("%d\n", Custom2[5]);
    out << str;
	str.Printf("#No.2 Gloves 1-8\n");
    out << str;
	str.Printf("#Default 1\n");
    out << str;
	str.Printf("%d\n", Custom2[6]);
    out << str;
	str.Printf("#No.2 Trunks 1-64\n");
    out << str;
	str.Printf("#Default 1\n");
    out << str;
	str.Printf("%d\n", Custom2[7]);
    out << str;
	str.Printf("#No.2 Skin 1-10\n");
    out << str;
	str.Printf("#Default 3\n");
    out << str;
	str.Printf("%d\n", Custom2[8]);
    out << str;

	out << endl;
	out << wxT("#End of File") << endl;

	return true;
}

bool BoxerPage::LoadData() {
	wxFileInputStream fin(DataCf->GetFilename());	
	wxTextInputStream in(fin);	

	if (!fin.Ok()) {
		return false;	
	}
	
	int i, max;
	wxString str;

	str = NextLine(in);
	max = atoi(str);
	
	for (i = 0; i < 30; i++) {
		Data[i]->SetFilename(wxT(""));
	}

	for (i = 0; i < max; i++) {
		str = NextLine(in);
		Data[i]->SetFilename(str);
	}

	for (i = 0; i < 9; i++) {
		str = NextLine(in);
		Custom1[i] = atoi(str);
	}
	for (i = 0; i < 9; i++) {
		str = NextLine(in);
		Custom2[i] = atoi(str);
	}
	return true;
}

