#ifndef MANIPPAGE_H
#define MANIPPAGE_H

#include <wx/wx.h>
#include <wx/textctrl.h>
#include <wx/wfstream.h>
#include <wx/txtstrm.h>
#include <wx/combobox.h>
#include "myslider.h"
#include "mylabel.h"
#include "mycbox.h"

class ManipPage : public wxScrolledWindow {
public:
    ManipPage(wxWindow* parent);

	void SetDefault();

	bool Save(wxTextOutputStream &out);
	bool Load(wxTextInputStream &in);
private:
    void SetProperties();
    void DoLayout();

	myLabel *labelr1;
	myLabel *labelr2;
	myLabel *labelr3;
	myLabel *labelr4;
	myLabel *labelr5;
	myLabel *labelr6;
	myLabel *labelr7;
	myLabel *labelr8;
	myLabel *labelr9;
	myLabel *labelr10;
	myLabel *labelr11;
	myLabel *labelr12;
	myLabel *labelr13;

	myCBox *RedManip;

	mySlider *RedPunch;
	mySlider *RedSpeed;
	mySlider *RedStamina;
	
	mySlider *RedDamageRestore;
	mySlider *RedMaxDamage;
	mySlider *RedCyanosisRestore;
	mySlider *RedMaxCyanosis;

	mySlider *RedBlockAbsorb;
	mySlider *RedBodyStrength;
	mySlider *RedLiverStrength;
	mySlider *RedFaceStrength;
	mySlider *RedJawStrength;


	myLabel *labelb1;
	myLabel *labelb2;
	myLabel *labelb3;
	myLabel *labelb4;
	myLabel *labelb5;
	myLabel *labelb6;
	myLabel *labelb7;
	myLabel *labelb8;
	myLabel *labelb9;
	myLabel *labelb10;
	myLabel *labelb11;
	myLabel *labelb12;
	myLabel *labelb13;

	myCBox *BlueManip;

	mySlider *BluePunch;
	mySlider *BlueSpeed;
	mySlider *BlueStamina;
	
	mySlider *BlueDamageRestore;
	mySlider *BlueMaxDamage;
	mySlider *BlueCyanosisRestore;
	mySlider *BlueMaxCyanosis;

	mySlider *BlueBlockAbsorb;
	mySlider *BlueBodyStrength;
	mySlider *BlueLiverStrength;
	mySlider *BlueFaceStrength;
	mySlider *BlueJawStrength;
};

wxString NextLine(wxTextInputStream &in);

#endif // MANIPPAGE_H
