#include "matchpage.h"
#include "basicpage.h"

MatchPage::MatchPage(wxWindow* parent) : wxScrolledWindow(parent, -1) {
	SetProperties();
	DoLayout();
}

void MatchPage::SetProperties() {
	int i;
	wxString str;

	label1 = new myLabel(this, wxT("饦"));
	label2 = new myLabel(this, wxT("饦ɥ"));

	MaxRound = new mySlider(this, 1, 15, 1);
	RoundTime = new mySlider(this, 10, 600, 30);

	label3 = new myLabel(this, wxT("TKOƥ"));
	label4 = new myLabel(this, wxT("åƥ"));
	label5 = new myLabel(this, wxT("󥰸Υ"));
	label12 = new myLabel(this, wxT("ȥ饦"));
	label6 = new myLabel(this, wxT("KO"));

	TKOSystem = new myCBox(this);
	TKOSystem->Append(wxT("2Υå"));
	TKOSystem->Append(wxT("3Υå"));
	TKOSystem->Append(wxT("ե꡼Υå"));
	JudgeSystem = new myCBox(this);
	JudgeSystem->Append(wxT("饦ɥޥ"));
	JudgeSystem->Append(wxT("饦ɥޥ"));
	CountSystem = new myCBox(this);
	CountSystem->Append(wxT("ǽ饦ɤΤ"));
	CountSystem->Append(wxT("ǽ饦ɤΤ³"));
	CountSystem->Append(wxT("饦"));
	CountSystem->Append(wxT("饦³"));
	ExtraRound = new myCBox(this);
	ExtraRound->Append(wxT("̵"));
	ExtraRound->Append(wxT("ͭ"));
	KOCount = new mySlider(this, 3, 10, 1);
	 
	label7 = new myLabel(this, wxT("å1"));
	label8 = new myLabel(this, wxT("å2"));
	label9 = new myLabel(this, wxT("å3"));

	Judge1 = new myCBox(this);
	Judge1->Append(wxT(""));
	Judge1->Append(wxT("ҥå"));
	Judge1->Append(wxT("ƥ"));
	Judge1->Append(wxT("᡼"));
	Judge2 = new myCBox(this);
	Judge2->Append(wxT(""));
	Judge2->Append(wxT("ҥå"));
	Judge2->Append(wxT("ƥ"));
	Judge2->Append(wxT("᡼"));
	Judge3 = new myCBox(this);
	Judge3->Append(wxT(""));
	Judge3->Append(wxT("ҥå"));
	Judge3->Append(wxT("ƥ"));
	Judge3->Append(wxT("᡼"));

	label10 = new myLabel(this, wxT("ɲþ"));
	label11 = new myLabel(this, wxT("ץ쥤졼"));

	ExtraInfo = new myCBox(this);
	ExtraInfo->Append(wxT("OFF"));
	ExtraInfo->Append(wxT("ON"));
    ReplayRate = new mySlider(this, 1, 10, 1);
	
	labelf = new myLabel(this, wxT("ե̾"));;
	ReplayCf = new myFileSelect(this);
	ReplayCf->SetStartDir(wxT("./Replay"));

	label15 = new myLabel(this, wxT("ץ쥤¸"));;
	ChoiceSave = new myCBox(this);
	ChoiceSave->Append(wxT("ʤ"));
	ChoiceSave->Append(wxT(""));
	
	label13 = new myLabel(this, wxT("ץ쥤"));
	label14 = new myLabel(this, wxT("ߤΥץ쥤"));

	ReplayNumber = new mySlider(this, 1, 999, 10);
	CurrentReplay = new mySlider(this, 1, 999, 10);

	for (i = 0; i < 9; i++) {
		str.Printf("ץ쥤å No.%d ", i + 1);
		label[i] = new myLabel(this, str);

		Replay[i] = new myFileSelect(this);
		Replay[i]->SetInfo(wxT("ץ쥤ե"));
		Replay[i]->SetWildCard(wxT("ץ쥤 (*.rep)|*.rep"));
		Replay[i]->SetStartDir(wxT("./Replay"));
	}
}

void MatchPage::DoLayout() {
	int i;
	wxBoxSizer *tsizer = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *tsizer1 = new wxBoxSizer(wxVERTICAL);
	wxBoxSizer *tsizer2 = new wxBoxSizer(wxVERTICAL);
	
	wxStaticBoxSizer *bsizer1 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("Ĺ")), wxVERTICAL);
	wxStaticBoxSizer *bsizer2 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("Ƽ롼")), wxVERTICAL);
	wxStaticBoxSizer *bsizer3 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("å")), wxVERTICAL);
	wxStaticBoxSizer *bsizer4 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("¾")), wxVERTICAL);

	wxStaticBoxSizer *bsizer1r = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ץ쥤ե")), wxVERTICAL);
	wxStaticBoxSizer *bsizer12r = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ץ쥤¸")), wxVERTICAL);
	wxStaticBoxSizer *bsizer2r = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ץ쥤")), wxVERTICAL);
	wxStaticBoxSizer *bsizer3r = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ץ쥤å")), wxVERTICAL);

	wxBoxSizer *bsizer11 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer12 = new wxBoxSizer(wxHORIZONTAL);

	wxBoxSizer *bsizer21 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer22 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer23 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer24 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer25 = new wxBoxSizer(wxHORIZONTAL);

	wxBoxSizer *bsizer31 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer32 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer33 = new wxBoxSizer(wxHORIZONTAL);

	wxBoxSizer *bsizer41 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer42 = new wxBoxSizer(wxHORIZONTAL);

	wxBoxSizer *bsizer11r = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer121r = new wxBoxSizer(wxHORIZONTAL);

	wxBoxSizer *bsizer21r = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer22r = new wxBoxSizer(wxHORIZONTAL);

	wxBoxSizer *bsizer3rh[9];
	for (i = 0; i < 9; i++) {
		bsizer3rh[i] = new wxBoxSizer(wxHORIZONTAL);
	 	bsizer3r->Add(bsizer3rh[i], 0, wxALIGN_CENTER_VERTICAL | wxALL, 0);
		bsizer3rh[i]->Add(label[i], 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
		bsizer3rh[i]->Add(Replay[i], 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	}

 	tsizer->Add(tsizer1, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 5);
 	tsizer->Add(tsizer2, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 5);

 	tsizer1->Add(bsizer1, 0, wxALIGN_CENTER_VERTICAL | wxALL, 5);
 	tsizer1->Add(bsizer2, 0, wxALIGN_CENTER_VERTICAL | wxALL, 5);
 	tsizer1->Add(bsizer3, 0, wxALIGN_CENTER_VERTICAL | wxALL, 5);
 	tsizer1->Add(bsizer4, 0, wxALIGN_CENTER_VERTICAL | wxALL, 5);

 	tsizer2->Add(bsizer1r, 0, wxALIGN_CENTER_VERTICAL | wxALL, 5);
 	tsizer2->Add(bsizer12r, 0, wxALIGN_CENTER_VERTICAL | wxALL, 5);
 	tsizer2->Add(bsizer2r, 0, wxALIGN_CENTER_VERTICAL | wxALL, 5);
 	tsizer2->Add(bsizer3r, 0, wxALIGN_CENTER_VERTICAL | wxALL, 5);

 	bsizer1->Add(bsizer11, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer1->Add(bsizer12, 0, wxALIGN_CENTRE_HORIZONTAL, 0);

 	bsizer2->Add(bsizer21, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer2->Add(bsizer22, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer2->Add(bsizer23, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer2->Add(bsizer24, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer2->Add(bsizer25, 0, wxALIGN_CENTRE_HORIZONTAL, 0);

 	bsizer3->Add(bsizer31, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer3->Add(bsizer32, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer3->Add(bsizer33, 0, wxALIGN_CENTRE_HORIZONTAL, 0);

 	bsizer4->Add(bsizer41, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer4->Add(bsizer42, 0, wxALIGN_CENTRE_HORIZONTAL, 0);

 	bsizer1r->Add(bsizer11r, 0, wxALIGN_CENTRE_HORIZONTAL, 0);

 	bsizer12r->Add(bsizer121r, 0, wxALIGN_CENTRE_HORIZONTAL, 0);

 	bsizer2r->Add(bsizer21r, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer2r->Add(bsizer22r, 0, wxALIGN_CENTRE_HORIZONTAL, 0);

	bsizer11->Add(label1, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer11->Add(MaxRound, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer12->Add(label2, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer12->Add(RoundTime, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);

	bsizer21->Add(label3, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer21->Add(TKOSystem, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer22->Add(label4, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer22->Add(JudgeSystem, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer23->Add(label5, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer23->Add(CountSystem, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer24->Add(label12, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer24->Add(ExtraRound, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer25->Add(label6, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer25->Add(KOCount, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
 
	bsizer31->Add(label7, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer31->Add(Judge1, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer32->Add(label8, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer32->Add(Judge2, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer33->Add(label9, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer33->Add(Judge3, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);

	bsizer41->Add(label10, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer41->Add(ExtraInfo, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer42->Add(label11, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer42->Add(ReplayRate, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
         
	bsizer11r->Add(labelf, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer11r->Add(ReplayCf, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);

	bsizer121r->Add(label15, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer121r->Add(ChoiceSave, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);

	bsizer21r->Add(label13, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer21r->Add(ReplayNumber, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer22r->Add(label14, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer22r->Add(CurrentReplay, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);

	SetSizer(tsizer);
 	tsizer->SetVirtualSizeHints(this);
	FitInside();
	Layout(); 
}

void MatchPage::SetDefault() {
	MaxRound->SetValue(6);
	RoundTime->SetValue(60);
	
	TKOSystem->SetSelection(1);
	JudgeSystem->SetSelection(0);
	CountSystem->SetSelection(0);
	ExtraRound->SetSelection(0);
	KOCount->SetValue(10);
	
	Judge1->SetSelection(0);
	Judge2->SetSelection(0);
	Judge2->SetSelection(0);

	ExtraInfo->SetSelection(0);
	ReplayRate->SetValue(5);
	
	int i;
	ReplayCf->SetFilename(wxT("./Replay/replaycf.txt"));
	ChoiceSave->SetSelection(0);
	ReplayNumber->SetValue(100);
	CurrentReplay->SetValue(100);
	for (i = 0; i < 9; i++) {
		Replay[i]->SetFilename(wxT(""));
	}	
}

bool MatchPage::Save(wxTextOutputStream &out) {
	wxString str;

	str.Printf("\n#Match Rules Config\n");
	out << str;
	str.Printf("#Max Round\n");
	out << str;
	str.Printf("#Default 6\n");
	out << str;
	str.Printf("%d\n", MaxRound->GetValue());
	out << str;
	str.Printf("#Round Time\n");
	out << str;
	str.Printf("#Default 60\n");
	out << str;
	str.Printf("%d\n", RoundTime->GetValue());
	out << str;
	str.Printf("#TKO System\n");
	out << str;
	str.Printf("#Default 3\n");
	out << str;
	switch (TKOSystem->GetSelection()) {
		case 0:
			out << wxT("2") << endl;		
		break;
		case 1:
			out << wxT("3") << endl;				
		break;
		default:
			out << wxT("255") << endl;				
		break;			
	}

	str.Printf("#Judging System 0 : Round Must  1 : Not Round Must\n");
	out << str;
	str.Printf("#Default 0\n");
	out << str;
	str.Printf("%d\n", JudgeSystem->GetSelection());
	out << str;
	str.Printf("#Count System 0 : Last Round Stop  1 : Last Round Continue\n");
	out << str;
	str.Printf("#             2 : All Round Stop   3 : All Round Continue\n");
	out << str;
	str.Printf("#Default 0\n");
	out << str;
	str.Printf("%d\n", CountSystem->GetSelection());
	out << str;
	str.Printf("#Extra Round 0 : OFF 1 : ON\n");
	out << str;
	str.Printf("#Default 0\n");
	out << str;
	str.Printf("%d\n", ExtraRound->GetSelection());
	out << str;
	str.Printf("#KO Count\n");
	out << str;
	str.Printf("#Default 10\n");
	out << str;
	str.Printf("%d\n", KOCount->GetValue());
	out << str;

	str.Printf("#Judge Type 0 : Random  1 : Hit  2 : Critical  3 : Damage\n");
	out << str;
	str.Printf("#Default 0\n");
	out << str;
	str.Printf("%d\n", Judge1->GetSelection());
	out << str;
	str.Printf("%d\n", Judge2->GetSelection());
	out << str;
	str.Printf("%d\n", Judge3->GetSelection());
	out << str;

	str.Printf("#Extra Information 0 : OFF 1 : ON\n");
	out << str;
	str.Printf("#Default 0\n");
	out << str;
	str.Printf("%d\n", ExtraInfo->GetSelection());
	out << str;
	str.Printf("##Replay Rate  1-10\n");
	out << str;
	str.Printf("#Default 5\n");
	out << str;
	str.Printf("%d\n", ReplayRate->GetValue());
	out << str;

	return true;
}

bool MatchPage::Load(wxTextInputStream &in) {
	wxString str;
	str = NextLine(in);
	MaxRound->SetValue(atoi(str));
	str = NextLine(in);
	RoundTime->SetValue(atoi(str));

	str = NextLine(in);
	switch (atoi(str)) {
		case 2:
			TKOSystem->SetSelection(0);
		break;
		case 3:
			TKOSystem->SetSelection(1);
		break;
		default:
			TKOSystem->SetSelection(2);
		break;
	}
	str = NextLine(in);
	JudgeSystem->SetSelection(atoi(str));
	str = NextLine(in);
	CountSystem->SetSelection(atoi(str));
	str = NextLine(in);
	ExtraRound->SetSelection(atoi(str));
	str = NextLine(in);
	KOCount->SetValue(atoi(str));
	
	str = NextLine(in);
	Judge1->SetSelection(atoi(str));
	str = NextLine(in);
	Judge2->SetSelection(atoi(str));
	str = NextLine(in);
	Judge3->SetSelection(atoi(str));

	str = NextLine(in);
	ExtraInfo->SetSelection(atoi(str));
	str = NextLine(in);
	ReplayRate->SetValue(atoi(str));	
	return true;
}

void MatchPage::OnSelect(wxCommandEvent& event) {
	if (ReplayCf->IsOK()) {
		LoadReplay();
	}
}

bool MatchPage::SaveReplayCf(wxTextOutputStream &out) {
	wxString str;
	out << ReplayCf->GetFilename() << endl;
	return true;
}

bool MatchPage::LoadReplayCf(wxTextInputStream &in) {
	wxString str;
	str = NextLine(in);
	ReplayCf->SetFilename(str);
	return true;
}

bool MatchPage::SaveReplay() {
	wxFileOutputStream fout(ReplayCf->GetFilename());	
	wxTextOutputStream out(fout);	

	if (!fout.Ok()) {
		return false;	
	}

 	int i, max;
	wxString str;	

	out << wxT("#Config File for Replay") << endl;
	out << endl;

	out << wxT("##Choice Save Replay File  0 : DO 1 : NOT DO") << endl;
	out << wxT("#Default 0") << endl;
	out << ChoiceSave->GetSelection() << endl;
	out << endl;

	out << wxT("#Maximum Replay Number") << endl;
	out << ReplayNumber->GetValue() << endl;
	out << wxT("#Current Replay Number") << endl;
	out << CurrentReplay->GetValue() << endl;
	out << endl;

	max = 0;
	for (i = 0; i < 9; i++) {
		if (!Replay[i]->GetFilename().IsNull()) {
			max++;		
		}
	}
	out << wxT("#Slot Replay Number") << endl;
	out << max << endl;
	out << endl;

	for (i = 0; i < max; i++) {
		str.Printf("#Replay No. %d\n", i + 1);
		out << str;
		out << Replay[i]->GetFilename() << endl;
	}

	out << endl;
	out << wxT("#End of File") << endl;

	return true;
}

bool MatchPage::LoadReplay() {
	wxFileInputStream fin(ReplayCf->GetFilename());	
	wxTextInputStream in(fin);	

	if (!fin.Ok()) {
		return false;	
	}
	
	int i, max;
	wxString str;

	str = NextLine(in);
	ChoiceSave->SetSelection(atoi(str));

	str = NextLine(in);
	ReplayNumber->SetValue(atoi(str));
	str = NextLine(in);
	CurrentReplay->SetValue(atoi(str));
		
	str = NextLine(in);
	max = atoi(str);
	
	for (i = 0; i < 9; i++) {
		Replay[i]->SetFilename(wxT(""));
	}

	for (i = 0; i < max; i++) {
		str = NextLine(in);
		Replay[i]->SetFilename(str);
	}
	return true;
}
