#ifndef MATCHPAGE_H
#define MATCHPAGE_H

#include <wx/wx.h>
#include <wx/textctrl.h>
#include <wx/wfstream.h>
#include <wx/txtstrm.h>
#include <wx/combobox.h>
#include "myslider.h"
#include "mylabel.h"
#include "mycbox.h"
#include "myfileselect.h"

class MatchPage : public wxScrolledWindow {
public:
    MatchPage(wxWindow* parent);

	void SetDefault();

	bool Save(wxTextOutputStream &out);
	bool Load(wxTextInputStream &in);
	
	bool SaveReplayCf(wxTextOutputStream &out);
	bool SaveReplay();
	bool LoadReplayCf(wxTextInputStream &in);
	bool LoadReplay();

private:
    void SetProperties();
    void DoLayout();
	void OnSelect(wxCommandEvent& event);

	myLabel *label1;
	myLabel *label2;

	mySlider *MaxRound;
	mySlider *RoundTime;

	myLabel *label3;
	myLabel *label4;
	myLabel *label5;
	myLabel *label6;
	myLabel *label12;

	myCBox *TKOSystem;
	myCBox *JudgeSystem;
	myCBox *CountSystem;
	myCBox *ExtraRound;
	mySlider *KOCount;
	
	myLabel *label7;
	myLabel *label8;
	myLabel *label9;

	myCBox *Judge1;
	myCBox *Judge2;
	myCBox *Judge3;

	myLabel *label10;
	myLabel *label11;

	myCBox *ExtraInfo;
	mySlider *ReplayRate;

	myLabel *labelf;
	myFileSelect *ReplayCf;

	myLabel *label15;
	myCBox *ChoiceSave;

	myLabel *label13;
	myLabel *label14;

	mySlider *ReplayNumber;
	mySlider *CurrentReplay;

	myLabel *label[9];
	myFileSelect *Replay[9];
};

wxString NextLine(wxTextInputStream &in);

#endif // MATCHPAGE_H
