#include "myfileselect.h"

BEGIN_EVENT_TABLE(myFileSelect, wxPanel)
	EVT_BUTTON(-1, myFileSelect::OnSelect) 
END_EVENT_TABLE()

myFileSelect::myFileSelect(wxWindow* parent, const wxString &default_filename) : wxPanel(parent, -1) {
    SetProperties(default_filename);
    DoLayout();		
}

#if wxCHECK_VERSION(2, 6, 0)
void myFileSelect::SetProperties(const wxString &filename) {
	SetSize(160,20);

	text = new wxTextCtrl(this, -1, filename, wxDefaultPosition, wxSize(130, 20), wxTE_LEFT | wxTE_RICH);
	text->SetFont(wxFont(10, wxDEFAULT, wxNORMAL, wxNORMAL));
	text->Clear();
	text->AppendText(filename);

	button = new wxButton(this, -1, wxT("<-"), wxDefaultPosition, wxSize(30,20));
	button->SetFont(wxFont(10, wxDEFAULT, wxNORMAL, wxNORMAL));

	info = wxT("ե");
	wildcard = wxT("Text (*.txt)|*.txt");
	startdir = wxT("./");
	
	is_rel = true;
	is_ok = false;
}

#else
void myFileSelect::SetProperties(const wxString &filename) {
	SetSize(160,20);

	text = new wxTextCtrl(this, -1, filename, wxDefaultPosition, wxDefaultSize, wxTE_LEFT | wxTE_RICH);
	text->SetFont(wxFont(10, wxDEFAULT, wxNORMAL, wxNORMAL));
	text->Clear();
	text->AppendText(filename);
	text->SetSize(130, 20);

	button = new wxButton(this, -1, wxT("<-"));
	button->SetFont(wxFont(10, wxDEFAULT, wxNORMAL, wxNORMAL));
	button->SetSize(30, 20);

	info = wxT("ե");
	wildcard = wxT("Text (*.txt)|*.txt");
	startdir = wxT("./");
	
	is_rel = true;
	is_ok = false;
}
#endif

void myFileSelect::DoLayout() {
	wxBoxSizer *sizer = new wxBoxSizer(wxHORIZONTAL);
	sizer->Add(text, 0, wxALIGN_CENTER_HORIZONTAL | wxLEFT | wxRIGHT, 0);
	sizer->Add(button,  0, wxALIGN_CENTER_HORIZONTAL | wxLEFT | wxRIGHT, 0);
 	SetSizer(sizer);
	Layout();
}

void myFileSelect::OnSelect(wxCommandEvent& event) {
	wxFileDialog dialog(this, info, wxT(""), wxT(""), wildcard);

	dialog.SetDirectory(startdir);

	is_ok = false;
    if (dialog.ShowModal() == wxID_OK)	{
		wxFileName fn(dialog.GetPath().c_str());
		if (is_rel) {
			fn.MakeRelativeTo();
		}
		text->Clear();
		text->AppendText(fn.GetFullPath());
		is_ok = true;
	}
	event.Skip();
}

wxString myFileSelect::GetFilename() {
	return text->GetValue();
}

void myFileSelect::SetFilename(const wxString &setname) {
	text->Clear();
	text->AppendText(setname);
}
