#ifndef MYFILESELECT_H
#define MYFILESELECT_H

#include <wx/wx.h>
#include <wx/filename.h>

class myFileSelect : public wxPanel {
public:
    myFileSelect(wxWindow* parent, const wxString &default_filename = wxT(".\\"));
	wxString GetFilename();
	void SetFilename(const wxString &setname);

	void SetInfo(const wxString &str) {info = str;}
	void SetStartDir(const wxString &str) {startdir = str;}
	void SetWildCard(const wxString &str) {wildcard = str;}
	void SetFulPath() {is_rel = false;}
	void SetRelPath() {is_rel = true;}
	bool IsOK() {
		if (is_ok) {
			is_ok = false;
			return true;		
		} else {
			return false;		
		}
	}
private:
    void SetProperties(const wxString &filename);
    void DoLayout();
	void OnSelect(wxCommandEvent& event);

	wxTextCtrl *text;
	wxButton *button;

	wxString wildcard;
	wxString startdir;
	wxString info;
	
	bool is_rel;
	bool is_ok;
    DECLARE_EVENT_TABLE()
};

#endif // MYFILESELECT_H
