#include "myframe.h"
#include "mynotebook.h"

BEGIN_EVENT_TABLE(myFrame, wxFrame)
	EVT_MENU(MENU_SAVE, myFrame::OnSave)
	EVT_MENU(MENU_SAVEAS, myFrame::OnSaveAs)
	EVT_MENU(MENU_LOAD, myFrame::OnLoad)
	EVT_MENU(MENU_CLEAR, myFrame::OnClear)
	EVT_MENU(MENU_NOSAVE, myFrame::OnQuitNoSave)
	EVT_MENU(MENU_QUIT, myFrame::OnQuit)
	EVT_MENU(MENU_ABOUT, myFrame::OnAbout)
	EVT_MENU(MENU_EXEC, myFrame::OnExecute)
	EVT_MENU(MENU_REPLAY, myFrame::OnReplay)
	EVT_MENU(MENU_BOXERMAKER, myFrame::OnBoxerMaker)
	EVT_MENU(MENU_HIGHERSPEC, myFrame::OnHigherSpec)
	EVT_MENU(MENU_HIGHSPEC, myFrame::OnHighSpec)
	EVT_MENU(MENU_MIDDLESPEC, myFrame::OnMiddleSpec)
	EVT_MENU(MENU_LOWSPEC, myFrame::OnLowSpec)
	EVT_MENU(MENU_LOWERSPEC, myFrame::OnLowerSpec)
	EVT_CLOSE(myFrame::OnClose)
END_EVENT_TABLE()

myFrame::myFrame() : wxFrame(NULL, -1, wxT("")) {    
	SetProperties();
    DoLayout();
}

void myFrame::SetProperties() {
    SetTitle(wxT(CAPTION_TITLE));
#ifdef __WXMSW__
	SetIcon(wxICON(CPICON));
#endif
	SetSize(wxSize(640, 480));
	Centre();
	SetBackgroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_3DFACE));

	note = new myNotebook(this);
    menu_bar = new wxMenuBar();
	status_bar = new wxStatusBar(this, -1);

	SetMenuBar(menu_bar);
	wxMenu* file = new wxMenu();  
    menu_bar->Append(file, wxT("ե(&F)"));
    file->Append(MENU_SAVE, wxT("¸(&S)\tCtrl-S"), wxT("¸ޤ"));
    file->Append(MENU_SAVEAS, wxT("̾Ĥ¸(&A)\tCtrl-A"), wxT("̾Ĥ¸ޤ"));
    file->Append(MENU_LOAD, wxT("ɹ(&L)\tCtrl-L"), wxT("ɤ߹ߤޤ"));
 //   file->Append(MENU_LOADOLD, wxT("Сɹ(&O)\tCtrl-O"), wxT("СΥǡɤ߹ߤޤ"));
    file->Append(MENU_CLEAR, wxT("(&N)\tCtrl-N"), wxT("ˤޤ"));
    file->Append(MENU_NOSAVE, wxT("¸˽λ(&Q)\tCtrl-Q"), wxT("¸˽λޤ"));
    file->Append(MENU_QUIT, wxT("λ(&E)\tCtrl-E"), wxT("λޤ"));

	wxMenu *exec = new wxMenu();
	menu_bar->Append(exec, wxT("¹(&E)"));
	exec->Append(MENU_EXEC, wxT("¸Ƽ¹(&X)\tCtrl-X"), wxT("ݥꥴǥܥ󥰤¹Ԥޤ"));
	exec->Append(MENU_REPLAY, wxT("ץ쥤(&R)\tCtrl-R"), wxT("ץ쥤ޤ"));
	exec->Append(MENU_BOXERMAKER, wxT("ܥ᡼(&B)\tCtrl-B"), wxT("ܥ᡼ưޤ"));
 
 	wxMenu *spec = new wxMenu();
	menu_bar->Append(spec, wxT("ޥ󥹥ڥå(&S)"));
	spec->Append(MENU_HIGHERSPEC, wxT("˹⥹ڥå(&1)\tCtrl-1"), wxT("Ķ⥹ڥå"));
	spec->Append(MENU_HIGHSPEC, wxT("⥹ڥå(&2)\tCtrl-2"), wxT("⥹ڥå"));
	spec->Append(MENU_MIDDLESPEC, wxT("楹ڥå(&4)\tCtrl-3"), wxT("楹ڥå"));
	spec->Append(MENU_LOWSPEC, wxT("㥹ڥå(&4)\tCtrl-4"), wxT("㥹ڥå"));
	spec->Append(MENU_LOWERSPEC, wxT("㥹ڥå(&5)\tCtrl-5"), wxT("Ķ㥹ڥå"));
 
    wxMenu* help = new wxMenu();
    menu_bar->Append(help, wxT("إ(&H)"));
    help->Append(MENU_ABOUT, wxT("С(&H)\tF1"), wxT("ΥץˤĤ"));
	
	SetStatusBar(status_bar);

	cfile = wxT("./config.txt");
	Load();
}

void myFrame::DoLayout() {
	wxBoxSizer *tsizer = new wxBoxSizer(wxHORIZONTAL);
#if wxCHECK_VERSION(2, 6, 0)
	wxBoxSizer *nsizer = new wxBoxSizer(wxHORIZONTAL);
 	nsizer->Add(note, 3, wxGROW);
#else
	wxNotebookSizer *nsizer = new wxNotebookSizer(note);
#endif
	tsizer->Add(nsizer, 1, wxGROW);
	SetSizer(tsizer);
	Layout();
}

bool myFrame::Load() {
	wxFileInputStream fin(cfile.GetFullPath());	
	wxTextInputStream in(fin);	

	if (!fin.Ok()) {
		status_bar->SetStatusText(wxT("ե뤬ޤ"));
		return false;	
	}

	if(!note->bpage->Load(in)) {
		status_bar->SetStatusText(wxT("꤬۾Ǥ"));	
		return false;
    }   
	if(!note->npage->Load(in)) {
		status_bar->SetStatusText(wxT("꤬̿۾Ǥ"));	
		return false;
    }   
	if(!note->cpage->Load(in)) {
		status_bar->SetStatusText(wxT("꤬۾Ǥ"));	
		return false;
    }   
	if(!note->mpage->Load(in)) {
		status_bar->SetStatusText(wxT("꤬۾Ǥ"));	
		return false;
    } 
	if(!note->ppage->Load(in)) {
		status_bar->SetStatusText(wxT("꤬۾Ǥ"));	
		return false;
    } 

	if(!note->mpage->LoadReplayCf(in)) {
		status_bar->SetStatusText(wxT("ץ쥤ե뤬۾Ǥ"));	
		return false;
    }   
	if(!note->mpage->LoadReplay()) {
		status_bar->SetStatusText(wxT("ץ쥤ե뤬۾Ǥ"));	
		return false;
    }  	
	if(!note->vpage->LoadFontCf(in)) {
		status_bar->SetStatusText(wxT("եե뤬۾Ǥ"));	
		return false;
    }   
	if(!note->vpage->LoadFont()) {
		status_bar->SetStatusText(wxT("եե뤬۾Ǥ"));	
		return false;
    }   
	if(!note->vpage->LoadImageCf(in)) {
		status_bar->SetStatusText(wxT("ե뤬۾Ǥ"));	
		return false;
    }   
	if(!note->apage->LoadBGMCf(in)) {
		status_bar->SetStatusText(wxT("BGMե뤬۾Ǥ"));	
		return false;
    }
	if(!note->apage->LoadBGM()) {
		status_bar->SetStatusText(wxT("BGMե뤬۾Ǥ"));	
		return false;
    }
	if(!note->vpage->LoadImage()) {
		status_bar->SetStatusText(wxT("ե뤬۾Ǥ"));	
		return false;
    }   
	if(!note->apage->LoadSECf(in)) {
		status_bar->SetStatusText(wxT("̲ե뤬۾Ǥ"));	
		return false;
    }   
	if(!note->apage->LoadSE()) {
		status_bar->SetStatusText(wxT("̲ե뤬۾Ǥ"));	
		return false;
    }   
	if(!note->gpage->LoadDataCf(in)) {
		status_bar->SetStatusText(wxT("ǡե뤬۾Ǥ"));	
		return false;
    }   
	if(!note->gpage->LoadData()) {
		status_bar->SetStatusText(wxT("ǡե뤬۾Ǥ"));	
		return false;
    }
	if(!note->tpage->LoadThinkCf(in)) {
		status_bar->SetStatusText(wxT("ե뤬۾Ǥ"));	
		return false;
    }   
	if(!note->tpage->LoadThink()) {
		status_bar->SetStatusText(wxT("ե뤬۾Ǥ"));	
		return false;
    }
	   
	return true;
}

void myFrame::OnLoad(wxCommandEvent& event) {
	wxFileDialog dialog(this, wxT("ե"),
		wxT("./"), wxT(""), wxT(" (*.txt)|*.txt"));

    if (dialog.ShowModal() == wxID_OK)	{
		cfile = dialog.GetPath().c_str();
    } else {
		status_bar->SetStatusText(wxT("ɤ߹"));
		return;
	}
 
	if (Load()) {
		status_bar->SetStatusText(wxT("ɤ߹ߤޤ"));	
	}
}

bool myFrame::Save() {
	wxFileOutputStream fout(cfile.GetFullPath());	
	wxTextOutputStream out(fout);	

	if (!fout.Ok()) {
		status_bar->SetStatusText(wxT("ե뤬ޤ"));
		return false;	
	}
	
	wxString str;
	str.Printf("#Config File for %s", PDB_CAPTION_EN_TITLE);
	out << str << endl;
	out << wxT("#made by ") << wxT(CAPTION_EN_TITLE) << endl;
	
	note->bpage->Save(out);
	note->npage->Save(out);
	note->cpage->Save(out);
	note->mpage->Save(out);
	note->ppage->Save(out);

	str.Printf("\n#Config Files\n");
	out << str;
	str.Printf("#Replay Config File\n");
	out << str;
	str.Printf("#Default ./Replay/replaycf.txt\n");
	out << str;
	note->mpage->SaveReplayCf(out);
	str.Printf("#BGM Config File\n");
	out << str;
	str.Printf("#Default ./BGM/bgmcf.txt\n");
	out << str;
	note->vpage->SaveFontCf(out);
	str.Printf("#Image Config File\n");
	out << str;
	str.Printf("#Default ./Image/imagecf.txt\n");
	out << str;
	note->vpage->SaveImageCf(out);
	str.Printf("#Sound Effect Config File\n");
	out << str;
	str.Printf("#Default ./SE/secf.txt\n");
	out << str;
	note->apage->SaveBGMCf(out);
	str.Printf("#Font Config File\n");
	out << str;
	str.Printf("#Default ./Font/fontcf.txt\n");
	out << str;
	note->apage->SaveSECf(out);
	str.Printf("#Data Config File\n");
	out << str;
	str.Printf("#Default ./Data/datacf.txt\n");
	out << str;
	note->gpage->SaveDataCf(out);
	str.Printf("#Think Config File\n");
	out << str;
	str.Printf("#Default ./Data/thinkcf.txt\n");
	out << str;
	note->tpage->SaveThinkCf(out);
	str.Printf("\n#End of File\n");
	out << str;

	note->mpage->SaveReplay(); 
	note->vpage->SaveFont();
	note->vpage->SaveImage();
	note->apage->SaveBGM();
	note->apage->SaveSE();
	note->gpage->SaveData(); 
	note->tpage->SaveThink(); 

	return true;
}

bool myFrame::SaveAs() {
	wxFileDialog dialog(this, wxT("ե"),
		wxT("./"), wxT(""), wxT(" (*.txt)|*.txt"), wxSAVE|wxOVERWRITE_PROMPT);
		
	if (dialog.ShowModal() == wxID_OK)	{	
		cfile = dialog.GetPath().c_str();
		return true;
	} else {
		status_bar->SetStatusText(wxT("¸"));
		return false;		 
    }
}

void myFrame::OnSave(wxCommandEvent& event) {
	if (!cfile.IsOk()){
		if(!SaveAs()) {
			return;		
		}
	}
	if (Save()) {
		status_bar->SetStatusText(wxT("¸ޤ"));	
	}
}

void myFrame::OnSaveAs(wxCommandEvent& event) {
	if(!SaveAs()) {
		return;		
	}
	if (Save()) {
		status_bar->SetStatusText(wxT("¸ޤ"));
	}
}

void myFrame::OnClear(wxCommandEvent& event){
	note->bpage->SetDefault();
	note->npage->SetDefault();
	note->cpage->SetDefault();
	note->mpage->SetDefault();
	note->ppage->SetDefault();
	note->apage->SetDefault();
	note->vpage->SetDefault();
	note->gpage->SetDefault();
	note->tpage->SetDefault();
}

void myFrame::OnHigherSpec(wxCommandEvent& event) {note->bpage->SetHigherSpec();}
void myFrame::OnHighSpec(wxCommandEvent& event) {note->bpage->SetHighSpec();}
void myFrame::OnMiddleSpec(wxCommandEvent& event) {note->bpage->SetMiddleSpec();}
void myFrame::OnLowSpec(wxCommandEvent& event) {note->bpage->SetLowSpec();}
void myFrame::OnLowerSpec(wxCommandEvent& event) {note->bpage->SetLowerSpec();}

void myFrame::OnExecute(wxCommandEvent& event){
	cfile = wxT("./config.txt");
	Save(); 
	wxExecute("./PdBoxing.exe");
}

void myFrame::OnReplay(wxCommandEvent& event){
	wxFileDialog dialog(this, wxT("ץ쥤ե"), wxT(""), wxT(""), wxT("ץ쥤 (*.rep)|*.rep"));

	dialog.SetDirectory(wxT("./Replay"));

    if (dialog.ShowModal() == wxID_OK)	{
		wxString str;
		wxString str2;
		str = wxT("./PdBoxing.exe");
#ifdef	 __WXMSW__	
		str2.Printf("\"%s\"", dialog.GetPath().c_str());
#else
		str2.Printf("%s", dialog.GetPath().c_str());
#endif
		char *argv[3];
		argv[0] = (char *)str.c_str();
		argv[1] = (char *)str2.c_str();
		argv[2] = NULL;
		wxExecute(argv);
	}
}

void myFrame::OnBoxerMaker(wxCommandEvent& event){
	wxExecute("./Data/BoxerMaker.exe");
}

void myFrame::OnClose(wxCloseEvent& event){
	cfile = wxT("./config.txt");
	Save(); 
	Destroy();
}

void myFrame::OnQuit(wxCommandEvent& event) {
	Close(true);
} 

void myFrame::OnQuitNoSave(wxCommandEvent& event){
	Destroy();
}

void myFrame::OnAbout(wxCommandEvent& event) {
    wxMessageBox(wxT(CAPTION_TITLE), wxT("ΥץˤĤ"), wxOK | wxICON_INFORMATION, this);
}


bool DnDFile::OnDropFiles(wxCoord, wxCoord, const wxArrayString& filenames) {
	wxString str;
	wxString str2;
	str = wxT("./PdBoxing.exe");
	str2.Printf("\"%s\"", filenames[0].c_str());
	char *argv[3];
	argv[0] = (char *)str.c_str();
	argv[1] = (char *)str2.c_str();
	argv[2] = NULL;
	wxExecute(argv);
    return true;
}
