#ifndef MYFRAME_H
#define MYFRAME_H

#include <wx/wx.h>
#include <wx/dnd.h>
#include <wx/filename.h>
#include <wx/wfstream.h>
#include <wx/txtstrm.h>

class myNotebook;

#define CP_MAJOR_VERSION "1"
#define CP_MINOR_VERSION "2"
#define CP_PATCH_LEVEL   "0"
#define CP_VERSION_NAME "꡼"
#define CP_VERSION_EN_NAME "Release"
#define CAPTION_TITLE "ݥ Ver " CP_MAJOR_VERSION "." CP_MINOR_VERSION "." CP_PATCH_LEVEL " " CP_VERSION_NAME
#define CAPTION_EN_TITLE "Configure for Polygon de Boxing Ver " CP_MAJOR_VERSION "." CP_MINOR_VERSION "." CP_PATCH_LEVEL " " CP_VERSION_EN_NAME

#define PDB_MAJOR_VERSION "1"
#define PDB_MINOR_VERSION "2"
#define PDB_PATCH_LEVEL   "0"

#define PDB_VERSION_NAME "꡼"
#define PDB_VERSION_EN_NAME "Release"
#define PDB_VERSION_CODE (atoi(PDB_MAJOR_VERSION) * 1000 + atoi(PDB_MINOR_VERSION) * 100 + atoi(PDB_PATCH_LEVEL))
#define PDB_CAPTION_TITLE "ݥꥴǥܥ Ver " PDB_MAJOR_VERSION "." PDB_MINOR_VERSION "." PDB_PATCH_LEVEL " " PDB_VERSION_NAME
#define PDB_CAPTION_ICON  "ݥꥴǥܥ"
#define PDB_CAPTION_EN_TITLE "Polygon de Boxing Ver " PDB_MAJOR_VERSION "." PDB_MINOR_VERSION "." PDB_PATCH_LEVEL " " PDB_VERSION_EN_NAME
#define PDB_CAPTION_EN_ICON  "Polygon de Boxing"

#ifdef	 __WXGTK__	
#undef	CAPTION_TITLE
#define	CAPTION_TITLE	CAPTION_EN_TITLE
#endif

class myFrame: public wxFrame {
public:
    myFrame();
	
private:
    void SetProperties();
    void DoLayout();

 	void OnSave(wxCommandEvent& event);
 	void OnSaveAs(wxCommandEvent& event);
 	void OnLoad(wxCommandEvent& event);
 	void OnClear(wxCommandEvent& event);
  	void OnQuitNoSave(wxCommandEvent& event);
  	void OnQuit(wxCommandEvent& event);
 	void OnAbout(wxCommandEvent& event);

 	void OnExecute(wxCommandEvent& event);
 	void OnReplay(wxCommandEvent& event);
 	void OnBoxerMaker(wxCommandEvent& event);
 	void OnClose(wxCloseEvent& event);

 	void OnHigherSpec(wxCommandEvent& event);
 	void OnHighSpec(wxCommandEvent& event);
 	void OnMiddleSpec(wxCommandEvent& event);
 	void OnLowSpec(wxCommandEvent& event);
 	void OnLowerSpec(wxCommandEvent& event);

	bool Save();
	bool SaveAs();
	bool Load();
	
	myNotebook *note;
	wxMenuBar *menu_bar;
	wxStatusBar *status_bar;	
 	wxFileName cfile;
	wxMenu *option;

 	DECLARE_EVENT_TABLE()
};

enum {
    MENU_QUIT  = 1,
    MENU_SAVE,
    MENU_SAVEAS,
    MENU_LOAD,
    MENU_LOADOLD,
	MENU_CLEAR,
	MENU_NOSAVE,
	MENU_EXEC,
	MENU_REPLAY,
	MENU_BOXERMAKER,
	MENU_HIGHERSPEC,
	MENU_HIGHSPEC,
	MENU_MIDDLESPEC,
	MENU_LOWSPEC,
	MENU_LOWERSPEC,	
    MENU_ABOUT = wxID_ABOUT
};

class DnDFile : public wxFileDropTarget {
public:
    DnDFile(myFrame *mf) {mf = f;}
    virtual bool OnDropFiles(wxCoord x, wxCoord y, const wxArrayString& filenames);

private:
    myFrame *f;
};

#endif // MYFRAME_H
