#ifndef MYNOTEBOOK_H
#define MYNOTEBOOK_H

#include <wx/wx.h>
#include <wx/notebook.h>
#include <wx/wfstream.h>
#include <wx/txtstrm.h>

#include "myframe.h"
#include "basicpage.h"
#include "netpage.h"
#include "controlpage.h"
#include "matchpage.h"
#include "manippage.h"
#include "audiopage.h"
#include "visualpage.h"
#include "boxerpage.h"
#include "thinkpage.h"

class myNotebook : public wxNotebook {
public:
    myNotebook(wxWindow* parent);

private:
    void SetProperties();
    void DoLayout();

	BasicPage *bpage;
	NetPage *npage;
	ControlPage *cpage;
	MatchPage *mpage;
	ManipPage *ppage;
	AudioPage *apage;
	VisualPage *vpage;
	BoxerPage *gpage;
 	ThinkPage *tpage;

	friend class myFrame;
};

enum {
	ON_NOTEBOOK_ID
};

#endif // MYFNOTEBOOK_H
