#include "myslider.h"

BEGIN_EVENT_TABLE(mySlider, wxPanel)
	EVT_SLIDER(ON_SPINSLIDER_ID, mySlider::OnSlider)
	EVT_TEXT_ENTER(ON_SPINSLIDERCTRL_ID, mySlider::OnText)
	EVT_SPINCTRL(ON_SPINSLIDERCTRL_ID, mySlider::OnSpin)
	EVT_SPIN_UP(ON_SPINSLIDERCTRL_ID, mySlider::OnSpinCtrlUp)
	EVT_SPIN_DOWN(ON_SPINSLIDERCTRL_ID, mySlider::OnSpinCtrlDown)
END_EVENT_TABLE()

mySlider::mySlider(wxWindow* parent, int min_value, int max_value, int change_value) : wxPanel(parent, -1) {
	change = change_value - 1;
    SetProperties(min_value, max_value);
    DoLayout();		
}

#if wxCHECK_VERSION(2, 6, 0)
void mySlider::SetProperties(int min_value, int max_value) {
 	SetSize(160,20);
	slider = new wxSlider(this, ON_SPINSLIDER_ID, 0, 0, 255);
	slider->SetRange(min_value, max_value);
	spin = new wxSpinCtrl(this, ON_SPINSLIDERCTRL_ID, wxEmptyString, wxDefaultPosition, wxSize(60, -1));	
	spin->SetRange(min_value, max_value);
	spin->SetValue(slider->GetValue());
	slider->SetSize(100, -1);
}
#else

void mySlider::SetProperties(int min_value, int max_value) {
 	SetSize(160,20);
	slider = new wxSlider(this, ON_SPINSLIDER_ID, 0, 0, 255);
	slider->SetRange(min_value, max_value);
	spin = new wxSpinCtrl(this, ON_SPINSLIDERCTRL_ID);	
	spin->SetRange(min_value, max_value);
	spin->SetValue(slider->GetValue());
	slider->SetSize(100, -1);
	spin->SetSize(60, -1);
}
#endif

void mySlider::DoLayout() {
	wxBoxSizer *sizer = new wxBoxSizer(wxHORIZONTAL);
	sizer->Add(slider, 0, wxALIGN_CENTER_HORIZONTAL | wxLEFT | wxRIGHT, 0);
	sizer->Add(spin, 0, wxALIGN_CENTER_HORIZONTAL | wxLEFT | wxRIGHT, 0);	
  	sizer->SetSizeHints(this);
 	SetSizer(sizer);
	Layout();
}

void mySlider::SetValue(int value) {
	spin->SetValue(value);
	slider->SetValue(value);
}

void mySlider::OnSlider(wxCommandEvent &event) {
	spin->SetValue(slider->GetValue());
	event.Skip();
}

void mySlider::OnText(wxCommandEvent &event) {
	SetSlider();
	event.Skip();
}

void mySlider::OnSpin(wxSpinEvent &event) {
	SetSlider();
	event.Skip();
}

void mySlider::SetSlider() {
	slider->SetValue(spin->GetValue());
}

void mySlider::OnSpinCtrlUp(wxSpinEvent &event) {
	SetValue(GetValue() + change);
	event.Skip();
}

void mySlider::OnSpinCtrlDown(wxSpinEvent &event) {
	SetValue(GetValue() - change);
	event.Skip();
}
