#include "mytctrl.h"

BEGIN_EVENT_TABLE(myTCtrl, wxTextCtrl)
	EVT_CHAR(myTCtrl::OnChar)
	EVT_KEY_DOWN(myTCtrl::OnKeyDown)
END_EVENT_TABLE() 

#if wxCHECK_VERSION(2, 6, 0)
myTCtrl::myTCtrl(wxWindow* parent)              
           : wxTextCtrl(parent, -1, wxT(""), wxDefaultPosition, wxSize(160, 20), wxTE_LEFT| wxTE_RICH) {
	SetProperties();
}

void myTCtrl::SetProperties() {
	SetFont(wxFont(10, wxDEFAULT, wxNORMAL, wxNORMAL));
}

#else
myTCtrl::myTCtrl(wxWindow* parent)              
           : wxTextCtrl(parent, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_LEFT| wxTE_RICH) {
	SetProperties();
}

void myTCtrl::SetProperties() {
	SetFont(wxFont(10, wxDEFAULT, wxNORMAL, wxNORMAL));
	SetSize(160,20);
}
#endif

void myTCtrl::OnKeyDown(wxKeyEvent &event) {
	switch(event.GetRawKeyCode()) {
		case 0x6A:
			SetValue("[*]");		
		case 0x6B:
			SetValue("[+]");		
		case 0x6C:
			SetValue("[-]");		
		case 0x6D:
			SetValue("[-]");		
		case 0x6E:
			SetValue("[.]");		
		case 0x6F:
			SetValue("[/]");		
		return;
	}	

	switch(event.GetKeyCode()) {
		case WXK_RETURN:
			SetValue("return");		
		break;	
		case WXK_SPACE:
			SetValue("space");		
		break;	
		case WXK_SHIFT:
			SetValue("left shift");		
		break;	
		case WXK_CONTROL:
			SetValue("left ctrl");		
		break;	
		case WXK_LEFT:
			SetValue("left");		
		break;	
		case WXK_RIGHT:
			SetValue("right");		
		break;	
		case WXK_UP:
			SetValue("up");		
		break;	
		case WXK_DOWN:
			SetValue("down");		
		break;	
		case WXK_NUMPAD0:
			SetValue("[0]");		
		break;	
  		case WXK_NUMPAD1:
			SetValue("[1]");		
		break;	
		case WXK_NUMPAD2:
			SetValue("[2]");		
		break;	
		case WXK_NUMPAD3:
			SetValue("[3]");		
		break;	
		case WXK_NUMPAD4:
			SetValue("[4]");		
		break;	
		case WXK_NUMPAD5:
			SetValue("[5]");		
		break;	
		case WXK_NUMPAD6:
			SetValue("[6]");		
		break;	
		case WXK_NUMPAD7:
			SetValue("[7]");		
		break;	
		case WXK_NUMPAD8:
			SetValue("[8]");		
		break;	
		case WXK_NUMPAD9:
			SetValue("[9]");		
		break;	
		default:
			event.Skip();	
		break;
	}
}

void myTCtrl::OnChar(wxKeyEvent &event) {
	switch(event.GetKeyCode()) {
 		case '3':
			SetValue("3");		
		break;	
		case '4':
			SetValue("4");		
		break;	
		case '5':
			SetValue("5");		
		break;	
		case '6':
			SetValue("6");		
		break;	
		case '7':
			SetValue("7");		
		break;	
		case '8':
			SetValue("8");		
		break;	
		case '9':
			SetValue("9");		
		break;	
		case '0':
			SetValue("0");		
		break;	
		case '-':
			SetValue("-");		
		break;	
		case 'q':
			SetValue("q");		
		break;	
		case 'w':
			SetValue("w");		
		break;	
		case 'e':
			SetValue("e");		
		break;	
		case 'r':
			SetValue("r");		
		break;	
		case 't':
			SetValue("t");		
		break;	
		case 'y':
			SetValue("y");		
		break;	
		case 'u':
			SetValue("u");		
		break;	
		case 'i':
			SetValue("i");		
		break;	
		case 'o':
			SetValue("o");		
		break;	
		case 'p':
			SetValue("p");		
		break;	
		case '[':
			SetValue("[");		
		break;	
		case 'a':
			SetValue("a");		
		break;	
		case 's':
			SetValue("s");		
		break;	
		case 'd':
			SetValue("d");		
		break;	
		case 'f':
			SetValue("f");		
		break;	
		case 'g':
			SetValue("g");		
		break;	
		case 'h':
			SetValue("h");		
		break;	
		case 'j':
			SetValue("j");		
		break;	
		case 'k':
			SetValue("k");		
		break;	
		case 'l':
			SetValue("l");		
		break;	
		case ';':
			SetValue(";");		
		break;	
		case ']':
			SetValue("]");		
		break;	
		case 'z':
			SetValue("z");		
		break;	
		case 'x':
			SetValue("x");		
		break;	
		case 'c':
			SetValue("c");		
		break;	
		case 'v':
			SetValue("v");		
		break;	
		case 'b':
			SetValue("b");		
		break;	
		case 'n':
			SetValue("n");		
		break;	
		case 'm':
			SetValue("m");		
		break;	
		case ',':
			SetValue(",");		
		break;	
		case '.':
			SetValue(".");		
		break;	
		case '/':
			SetValue("/");		
		break;	
		case '\\':
			SetValue("\\");		
		break;	
	}
}


#if wxCHECK_VERSION(2, 6, 0)
myInput::myInput(wxWindow* parent)              
           : wxTextCtrl(parent, -1, wxT(""), wxDefaultPosition, wxSize(160, 20), wxTE_LEFT| wxTE_RICH) {
	SetProperties();
}

void myInput::SetProperties() {
	SetFont(wxFont(10, wxDEFAULT, wxNORMAL, wxNORMAL));
}

#else
myInput::myInput(wxWindow* parent)              
           : wxTextCtrl(parent, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_LEFT| wxTE_RICH) {
	SetProperties();
}

void myInput::SetProperties() {
	SetFont(wxFont(10, wxDEFAULT, wxNORMAL, wxNORMAL));
	SetSize(160,20);
}
#endif
