#include "netpage.h"
#include "basicpage.h"

NetPage::NetPage(wxWindow* parent) : wxScrolledWindow(parent, -1) {
	SetProperties();
	DoLayout();
}

void NetPage::SetProperties() {
	label1 = new myLabel(this, wxT("̾(ϻʸ)"));
	label2 = new myLabel(this, wxT("ۥ(IP)"));
	label3 = new myLabel(this, wxT("CGIۥ"));
	label4 = new myLabel(this, wxT("CGI(ޥåᥤ)"));
	label5 = new myLabel(this, wxT("CGI(ӡ)"));
	label6 = new myLabel(this, wxT("ݡ"));;
	label7 = new myLabel(this, wxT("ݡ(ӡ)"));;
	label8 = new myLabel(this, wxT("ӡ⡼"));;

	UserName = new myInput(this);
	HostName = new myInput(this);
	HostCGI = new myInput(this);
	MatchMakeCGI = new myInput(this);
	LobbyCGI = new myInput(this);
	Port = new myInput(this);
	PortUDP = new myInput(this);

	LobbyMode = new myCBox(this);
	LobbyMode->Append(wxT(""));
	LobbyMode->Append(wxT("CGI")); 
}

void NetPage::DoLayout() {
	wxBoxSizer *tsizer = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *tsizer1 = new wxBoxSizer(wxVERTICAL);
	
	wxStaticBoxSizer *bsizer1 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ͥå")), wxVERTICAL);

	wxBoxSizer *bsizer11 = new wxBoxSizer(wxHORIZONTAL);
 	wxBoxSizer *bsizer12 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer13 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer14 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer15 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer16 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer17 = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *bsizer18 = new wxBoxSizer(wxHORIZONTAL);

 	tsizer->Add(tsizer1, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 5);
 	tsizer1->Add(bsizer1, 0, wxALIGN_CENTER_VERTICAL | wxALL, 5);

 	bsizer1->Add(bsizer11, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer1->Add(bsizer12, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer1->Add(bsizer13, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer1->Add(bsizer14, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer1->Add(bsizer15, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer1->Add(bsizer16, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer1->Add(bsizer17, 0, wxALIGN_CENTRE_HORIZONTAL, 0);
 	bsizer1->Add(bsizer18, 0, wxALIGN_CENTRE_HORIZONTAL, 0);

	bsizer11->Add(label1, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer11->Add(UserName, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer12->Add(label2, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer12->Add(HostName, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer13->Add(label3, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer13->Add(HostCGI, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer14->Add(label4, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer14->Add(MatchMakeCGI, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer15->Add(label5, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer15->Add(LobbyCGI, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer16->Add(label6, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer16->Add(Port, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer17->Add(label7, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer17->Add(PortUDP, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer18->Add(label8, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer18->Add(LobbyMode, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
 
	SetSizer(tsizer);
 	tsizer->SetVirtualSizeHints(this);
	FitInside();
	Layout(); 
}

void NetPage::SetDefault() {
	UserName->SetValue("user");
	HostName->SetValue("localhost");
	HostCGI->SetValue("hpcgi2.nifty.com");
	MatchMakeCGI->SetValue("/FengDan/matchmake.cgi");
	LobbyCGI->SetValue("/FengDan/lobby.cgi");
	Port->SetValue("2000");
	PortUDP->SetValue("3000");
	LobbyMode->SetSelection(1);
}

bool NetPage::Save(wxTextOutputStream &out) {
	wxString str;

	str.Printf( "\n#Network Config\n");
	out << str;
	str.Printf( "#User Name\n");
	out << str;
	str.Printf( "#Default user\n");
	out << str;
	out << UserName->GetValue();
	out << endl;

	str.Printf( "#Host Name\n");
	out << str;
	str.Printf( "#Default localhost\n");
	out << str;
	out << HostName->GetValue();
	out << endl;

	str.Printf( "#CGI Host Name\n");
	out << str;
	str.Printf( "#Default hpcgi2.nifty.com\n");
	out << str;
	out << HostCGI->GetValue();
	out << endl;

	str.Printf( "#Match Make CGI\n");
	out << str;
	str.Printf( "#Default /FengDan/matchmake.cgi\n");
	out << str;
	out << MatchMakeCGI->GetValue();
	out << endl;

	str.Printf( "#Lobby CGI\n");
	out << str;
	str.Printf( "#Default /FengDan/lobby.cgi\n");
	out << str;
	out << LobbyCGI->GetValue();
	out << endl;

	str.Printf( "#Port(TCP)\n");
	out << str;
	str.Printf( "#Default 2000\n");
	out << str;
	out << Port->GetValue();
	out << endl;

	str.Printf( "#Port(UDP)\n");
	out << str;
	str.Printf( "#Default 3000\n");
	out << str;
	out << PortUDP->GetValue();
	out << endl;

	str.Printf( "#Lobby Mode  0 : Local  1 : CGI\n");
	out << str;
	str.Printf( "#Default 1\n");
	out << str;
	out << LobbyMode->GetSelection();
	out << endl;

	return true;
}

bool NetPage::Load(wxTextInputStream &in) {
	wxString str;

	str = NextLine(in);
	UserName->SetValue(str);
	str = NextLine(in);
	HostName->SetValue(str);
	str = NextLine(in);
	HostCGI->SetValue(str);
	str = NextLine(in);
	MatchMakeCGI->SetValue(str);
	str = NextLine(in);
	LobbyCGI->SetValue(str);

	str = NextLine(in);
	Port->SetValue(str);
	str = NextLine(in);
	PortUDP->SetValue(str);

	str = NextLine(in);
	LobbyMode->SetSelection(atoi(str));
	return true;
}
