#include "thinkpage.h"
#include "basicpage.h"

BEGIN_EVENT_TABLE(ThinkPage, wxScrolledWindow)
	EVT_BUTTON(-1, ThinkPage::OnSelect) 
END_EVENT_TABLE()

ThinkPage::ThinkPage(wxWindow* parent) : wxScrolledWindow(parent, -1) {
	SetProperties();
	DoLayout();
}

void ThinkPage::SetProperties() {
	int i;
	wxString str;

	labelf= new myLabel(this, wxT("ե̾"));

	ThinkCf = new myFileSelect(this);
	ThinkCf->SetStartDir(wxT("./Data"));

	for (i = 0; i < 15; i++) {
		str.Printf(" No.%d ", i + 1);
		label[i] = new myLabel(this, str);

		Think[i] = new myFileSelect(this);
		Think[i]->SetInfo(wxT("׹ͥե"));
		Think[i]->SetWildCard(wxT("׹ (*.thk)|*.thk"));
		Think[i]->SetStartDir(wxT("./Data"));
	}
}

void ThinkPage::DoLayout() {
	int i;
	wxBoxSizer *tsizer = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *tsizer1 = new wxBoxSizer(wxVERTICAL);

	wxStaticBoxSizer *bsizerf1 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ե")), wxHORIZONTAL);
	wxStaticBoxSizer *bsizer1 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("׹ͥե")), wxVERTICAL);

 	tsizer->Add(tsizer1, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 5);
	tsizer1->Add(bsizerf1, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 5);
 	tsizer1->Add(bsizer1, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 5);

	bsizerf1->Add(labelf, 0, wxALIGN_CENTER_VERTICAL | wxALL, 0);
	bsizerf1->Add(ThinkCf, 0, wxALIGN_CENTER_VERTICAL | wxALL, 0);
	wxBoxSizer *bsizer1h[15];
	for (i = 0; i < 15; i++) {
		bsizer1h[i] = new wxBoxSizer(wxHORIZONTAL);
	 	bsizer1->Add(bsizer1h[i], 0, wxALIGN_CENTER_VERTICAL | wxALL, 0);
		bsizer1h[i]->Add(label[i], 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
		bsizer1h[i]->Add(Think[i], 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	}

	SetSizer(tsizer);
 	tsizer->SetVirtualSizeHints(this);
	FitInside();
	Layout(); 
}

void ThinkPage::OnSelect(wxCommandEvent& event) {
	if (ThinkCf->IsOK()) {
		LoadThink();
	}
}

void ThinkPage::SetDefault() {
	int i;
	ThinkCf->SetFilename(wxT("./Data/thinkcf.txt"));
	for (i = 0; i < 15; i++) {
		Think[i]->SetFilename(wxT(""));
	}
	LoadThink();
/*	Think[0]->SetFilename(wxT("./Think/light.thk"));
	Think[1]->SetFilename(wxT("./Think/peekaboo.thk"));
	Think[2]->SetFilename(wxT("./Think/detroit.thk"));
	Think[3]->SetFilename(wxT("./Think/hardguard.thk"));
	Think[4]->SetFilename(wxT("./Think/noguard.thk"));
	Think[5]->SetFilename(wxT("./Think/highspeed.thk"));
	Think[6]->SetFilename(wxT("./Think/tricky.thk"));
	Think[7]->SetFilename(wxT("./Think/lefty.thk"));
	Think[8]->SetFilename(wxT("./Think/welter.thk")); */
}

bool ThinkPage::SaveThinkCf(wxTextOutputStream &out) {
	wxString str;
	out << ThinkCf->GetFilename() << endl;
	return true;
}


bool ThinkPage::LoadThinkCf(wxTextInputStream &in) {
	wxString str;
	str = NextLine(in);
	ThinkCf->SetFilename(str);
	return true;
}

bool ThinkPage::SaveThink() {
	wxFileOutputStream fout(ThinkCf->GetFilename());	
	wxTextOutputStream out(fout);	

	if (!fout.Ok()) {
		return false;	
	}

 	int i, max;
	wxString str;	

	out << wxT("#Config File for Think Data") << endl;
	out << endl;
	out << wxT("#Think Number") << endl;
	max = 0;
	for (i = 0; i < 15; i++) {
		if (!Think[i]->GetFilename().IsNull()) {
			max++;		
		}
	}
	out << max << endl;
	out << endl;

	for (i = 0; i < max; i++) {
		str.Printf("#Think No. %d\n", i + 1);
		out << str;
		out << Think[i]->GetFilename() << endl;
	}

	out << endl;
	out << wxT("#End of File") << endl;

	return true;
}

bool ThinkPage::LoadThink() {
	wxFileInputStream fin(ThinkCf->GetFilename());	
	wxTextInputStream in(fin);	

	if (!fin.Ok()) {
		return false;	
	}
	
	int i, max;
	wxString str;

	str = NextLine(in);
	max = atoi(str);
	
	for (i = 0; i < 15; i++) {
		Think[i]->SetFilename(wxT(""));
	}

	for (i = 0; i < max; i++) {
		str = NextLine(in);
		Think[i]->SetFilename(str);
	}
	return true;
}

