#include "visualpage.h"
#include "basicpage.h"

BEGIN_EVENT_TABLE(VisualPage, wxScrolledWindow)
	EVT_BUTTON(-1, VisualPage::OnSelect) 
END_EVENT_TABLE()

VisualPage::VisualPage(wxWindow* parent) : wxScrolledWindow(parent, -1) {
	SetProperties();
	DoLayout();
}

void VisualPage::SetProperties() {
	int i;

	labelf1= new myLabel(this, wxT("ե̾"));
	labelf2= new myLabel(this, wxT("ե̾"));

	ImageCf = new myFileSelect(this);
	ImageCf->SetStartDir(wxT("./Image"));
	FontCf = new myFileSelect(this);
	FontCf->SetStartDir(wxT("./Font"));

	label1[0] = new myLabel(this, wxT("Х"));
	label1[1] = new myLabel(this, wxT(""));
	label1[2] = new myLabel(this, wxT("ط"));
	label1[3] = new myLabel(this, wxT(""));
	label1[4] = new myLabel(this, wxT("ŷ"));
  	label1[5] = new myLabel(this, wxT("ʡ"));

	for (i = 0; i < 6; i++) {
		Image[i] = new myFileSelect(this);
		Image[i]->SetInfo(wxT("ե"));
		Image[i]->SetWildCard(wxT(" (*.bmp;*.jpg;*.png;*.gif;*.pcx;*.tif;*.tga;*.lbm;*.xpm)|*.bmp;*.jpg;*.png;*.gif;*.pcx;*.tif;*.tga;*.lbm;*.xpm"));
		Image[i]->SetStartDir(wxT("./Image"));
	}

	label2[0] = new myLabel(this, wxT("ȥ"));
	label2[1] = new myLabel(this, wxT("(ȥ)"));
	label2[2] = new myLabel(this, wxT("ƥ"));
	label2[3] = new myLabel(this, wxT("(ƥ)"));

	for (i = 0; i < 2; i++) {
		Font[i] = new myFileSelect(this);
		Font[i]->SetInfo(wxT("եȥե"));
		Font[i]->SetWildCard(wxT("ե(*.ttf;*.ttc)|*.ttf;*.ttc"));
		Font[i]->SetStartDir(wxT("./Font"));
	} 
//	Font[1]->SetStartDir(wxT("c:/windows/fonts"));
	Font[1]->SetFulPath();

	for (i = 0; i < 2; i++) {
		FontSize[i] = new mySlider(this, 8, 128, 4);
	} 
}

void VisualPage::DoLayout() {
	int i;
	wxBoxSizer *tsizer = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *tsizer1 = new wxBoxSizer(wxVERTICAL);
	wxBoxSizer *tsizer2 = new wxBoxSizer(wxVERTICAL);

	wxStaticBoxSizer *bsizerf1 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("᡼ե")), wxHORIZONTAL);
	wxStaticBoxSizer *bsizerf2 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("եե")), wxHORIZONTAL);

	wxStaticBoxSizer *bsizer1 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("᡼")), wxVERTICAL);
	wxStaticBoxSizer *bsizer2 = new wxStaticBoxSizer(new wxStaticBox(this, -1, wxT("ե")), wxVERTICAL);

 	tsizer->Add(tsizer1, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 5);
 	tsizer->Add(tsizer2, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 5);

 	tsizer1->Add(bsizerf1, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 5);
 	tsizer1->Add(bsizer1, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 5);
 	tsizer2->Add(bsizerf2, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 5);
 	tsizer2->Add(bsizer2, 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 5);

	bsizerf1->Add(labelf1, 0, wxALIGN_CENTER_VERTICAL | wxALL, 0);
	bsizerf1->Add(ImageCf, 0, wxALIGN_CENTER_VERTICAL | wxALL, 0);
	wxBoxSizer *bsizer1h[6];
	for (i = 0; i < 6; i++) {
		bsizer1h[i] = new wxBoxSizer(wxHORIZONTAL);
	 	bsizer1->Add(bsizer1h[i], 0, wxALIGN_CENTER_VERTICAL | wxALL, 0);
		bsizer1h[i]->Add(label1[i], 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
		bsizer1h[i]->Add(Image[i], 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	}

	bsizerf2->Add(labelf2, 0, wxALIGN_CENTER_VERTICAL | wxALL, 0);
	bsizerf2->Add(FontCf, 0, wxALIGN_CENTER_VERTICAL | wxALL, 0);
	wxBoxSizer *bsizer2h[4];
	for (i = 0; i < 4; i++) {
		bsizer2h[i] = new wxBoxSizer(wxHORIZONTAL);
	 	bsizer2->Add(bsizer2h[i], 0, wxALIGN_CENTER_VERTICAL | wxALL, 0);
		bsizer2h[i]->Add(label2[i], 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	}
	bsizer2h[0]->Add(Font[0], 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer2h[1]->Add(FontSize[0], 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer2h[2]->Add(Font[1], 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);
	bsizer2h[3]->Add(FontSize[1], 0, wxALIGN_CENTRE_HORIZONTAL | wxALL, 0);

	SetSizer(tsizer);
 	tsizer->SetVirtualSizeHints(this);
	FitInside();
	Layout(); 
}

void VisualPage::OnSelect(wxCommandEvent& event) {
	if (ImageCf->IsOK()) {
		LoadImage();
	}
	if (FontCf->IsOK()) {
		LoadFont();
	}
}

void VisualPage::SetDefault() {
	ImageCf->SetFilename(wxT("./Image/imagecf.txt"));
	Image[0]->SetFilename(wxT("./Image/canvas.jpg"));
	Image[1]->SetFilename(wxT("./Image/henoheno.png"));
	Image[2]->SetFilename(wxT("./Image/background.jpg"));
	Image[3]->SetFilename(wxT("./Image/floor.jpg"));
	Image[4]->SetFilename(wxT("./Image/roof.jpg"));
	Image[5]->SetFilename(wxT("./Image/ads.png"));

	FontCf->SetFilename(wxT("./Font/fontcf.txt"));
	LoadFont();
/*	Font[0]->SetFilename(wxT("./Font/kana-029.ttc"));
	Font[1]->SetFilename(wxT("c:/Windows/fonts/msgothic.ttc"));
	FontSize[0]->SetValue(32);
	FontSize[1]->SetValue(32);  */
}

bool VisualPage::SaveImageCf(wxTextOutputStream &out) {
	wxString str;
	out << ImageCf->GetFilename()  << endl;
	return true;
}

bool VisualPage::LoadImageCf(wxTextInputStream &in) {
	wxString str;
	str = NextLine(in);
	ImageCf->SetFilename(str);
	return true;
}

bool VisualPage::SaveFontCf(wxTextOutputStream &out) {
	wxString str;
	out << FontCf->GetFilename()  << endl;
	return true;
}

bool VisualPage::LoadFontCf(wxTextInputStream &in) {
	wxString str;
	str = NextLine(in);
	FontCf->SetFilename(str);
	return true;
}

bool VisualPage::SaveImage() {
	wxFileOutputStream fout(ImageCf->GetFilename());	
	wxTextOutputStream out(fout);	

	if (!fout.Ok()) {
		return false;	
	}

	out << wxT("#Config File for Images") << endl;
	out << endl;

	out << wxT("#Ring Canvas Image") << endl;
	out << Image[0]->GetFilename() << endl;
	out << wxT("#Face Image") << endl;
	out << Image[1]->GetFilename() << endl;
	out << wxT("#Background Image") << endl;
	out << Image[2]->GetFilename() << endl;
	out << wxT("#Floor Image") << endl;
	out << Image[3]->GetFilename() << endl;
	out << wxT("#Roof Image") << endl;
	out << Image[4]->GetFilename() << endl;
	out << wxT("#Ring Ad's Image") << endl;
	out << Image[5]->GetFilename() << endl;

	out << endl;
	out << wxT("#End of File") << endl;

	return true;
}

bool VisualPage::LoadImage() {
	wxFileInputStream fin(ImageCf->GetFilename());	
	wxTextInputStream in(fin);	

	if (!fin.Ok()) {
		return false;	
	}
	
	int i;
	wxString str;
	for (i = 0; i < 6; i++) {
		str = NextLine(in);
		Image[i]->SetFilename(str);
	}
	return true;
}

bool VisualPage::SaveFont() {
	wxFileOutputStream fout(FontCf->GetFilename());	
	wxTextOutputStream out(fout);	

	if (!fout.Ok()) {
		return false;	
	}

	out << wxT("#Config File for Fonts") << endl;
	out << endl;

	out << wxT("#Title Font") << endl;
	out << Font[0]->GetFilename() << endl;
	out << wxT("#Title Font Size") << endl;
	out << FontSize[0]->GetValue() << endl;

	out << wxT("#System Font") << endl;
	out << Font[1]->GetFilename() << endl;
	out << wxT("#System Font Size") << endl;
	out << FontSize[1]->GetValue() << endl;

	out << endl;
	out << wxT("#End of File") << endl;

	return true;
}

bool VisualPage::LoadFont() {
	wxFileInputStream fin(FontCf->GetFilename());	
	wxTextInputStream in(fin);	

	if (!fin.Ok()) {
		return false;	
	}

	int i;
	wxString str;
	for (i = 0; i < 2; i++) {
		str = NextLine(in);
		Font[i]->SetFilename(str);
		str = NextLine(in);
		FontSize[i]->SetValue(atoi(str));
	}
	return true;
}
