#ifndef VISUALPAGE_H
#define VISUALPAGE_H

#include <wx/wx.h>
#include <wx/textctrl.h>
#include <wx/wfstream.h>
#include <wx/txtstrm.h>
#include <wx/combobox.h>
#include "myslider.h"
#include "mylabel.h"
#include "mycbox.h"
#include "mytctrl.h"
#include "myfileselect.h"

class VisualPage : public wxScrolledWindow {
public:
    VisualPage(wxWindow* parent);

	void SetDefault();

	bool SaveImageCf(wxTextOutputStream &out);
	bool SaveFontCf(wxTextOutputStream &out);
	bool SaveImage();
	bool SaveFont();

	bool LoadImageCf(wxTextInputStream &in);
	bool LoadFontCf(wxTextInputStream &in);
	bool LoadImage();
	bool LoadFont();

private:
    void SetProperties();
    void DoLayout();
	void OnSelect(wxCommandEvent& event);

	myLabel *labelf1;
	myLabel *labelf2;
	myFileSelect *ImageCf;
	myFileSelect *FontCf;

	myLabel *label1[6];
	myFileSelect *Image[6];

	myLabel *label2[4];
	myFileSelect *Font[2];
	mySlider *FontSize[2];
	
	DECLARE_EVENT_TABLE()
};

#endif // VISUALPAGE_H
