#include "boxerhandler.h"

void BoxerHandler::CheckHitPunch(Boxer &m_boxer, MotionHandler &m_motion, Boxer &o_boxer, BoxerHandler &o_handler) {
	select_sound = NO_SOUND;

	if (state == R_OFFENSE) {  /* E̍U? */
		o_handler.hit_parts = o_boxer.IsHitRightPunch(m_boxer);
		o_handler.hit_damage = m_boxer.CalcDamageRight();
	} else {
		o_handler.hit_parts = o_boxer.IsHitLeftPunch(m_boxer);
		o_handler.hit_damage = m_boxer.CalcDamageLeft();
	}
	if (m_motion.IsActionOverFirst()) { /* [Vȍ~ */
		o_handler.hit_damage *= punch_manip;
		o_handler.hit_damage += m_boxer.CalcCounterDamage(o_boxer);
	} else {
		o_handler.hit_damage = 0.0;
	}
			
	o_handler.hit_state = NO_DAMAGE;
	if (o_handler.IsHitJaw()) {  // 
		o_handler.hit_damage *= absorb * o_handler.face_strength;
		o_handler.face_damage += o_handler.hit_damage;
		o_handler.brain_damage += o_handler.hit_damage * o_handler.jaw_strength;
		if (o_handler.IsMinimamDamage()) {
			o_handler.HitInc();
			o_handler.RoundDamageInc(o_handler.hit_damage* (1.0 + o_handler.jaw_strength));
			if (o_handler.hit_damage / o_handler.max_damage > 0.10) {
				o_handler.CriticalInc();
				o_handler.hit_state = FACE_DAMAGE;
				select_sound = SE_HIT_JAW;
			} else {
				o_handler.hit_state = SMALL_DAMAGE;			
			}
		}      
	} else if (o_handler.IsHitFace()) {  // 
		o_handler.hit_damage *= absorb * o_handler.face_strength;
		o_handler.face_damage += o_handler.hit_damage;
		if (o_handler.IsMinimamDamage()) {
			o_handler.HitInc();
			o_handler.RoundDamageInc(o_handler.hit_damage);
			if (o_handler.hit_damage / o_handler.max_damage > 0.10) {
				o_handler.CriticalInc();
				o_handler.hit_state = FACE_DAMAGE;
				select_sound = SE_HIT_FACE;
   			} else {
				o_handler.hit_state = SMALL_DAMAGE;			
			}
		} 
	} else if (o_handler.IsHitLiver()) {  // ̑
		o_handler.hit_damage *= absorb * o_handler.body_strength * o_handler.liver_strength;
		o_handler.body_damage += o_handler.hit_damage;
		if (o_handler.IsMinimamDamage()) {
			o_handler.HitInc();
			o_handler.RoundDamageInc(o_handler.hit_damage);
			if (o_handler.hit_damage / o_handler.max_damage > 0.075) {
				o_handler.CriticalInc();
				o_handler.hit_state = BODY_DAMAGE;
				select_sound = SE_HIT_BODY;
			} else {
				o_handler.hit_state = SMALL_DAMAGE;					
			}
		}     
	} else if (o_handler.IsHitBody()) { // 
		o_handler.hit_damage *= absorb * o_handler.body_strength;
		o_handler.body_damage += o_handler.hit_damage;
		if (o_handler.IsMinimamDamage()) {
			o_handler.HitInc();
			o_handler.RoundDamageInc(o_handler.hit_damage);
			if (o_handler.hit_damage / o_handler.max_damage > 0.05) {
				o_handler.CriticalInc();
				o_handler.hit_state = BODY_DAMAGE;
				select_sound = SE_HIT_BODY;
			} else {
				o_handler.hit_state = SMALL_DAMAGE;					
			} 
		} 
		
	} else {
		if (o_handler.IsHitRShoul()) { // E
			if (o_handler.IsDefenseState()) {
	    		absorb *= o_handler.defense_shoulder_absorb;
			} else if (o_handler.CanBlock()){
	    		absorb *= o_handler.normal_shoulder_absorb;			
			} else {
	    		absorb *= o_handler.offense_shoulder_absorb;						
			}
			if (IsFirstHit()) {
				Blocked();
				select_sound = SE_BLOCK;
			}
		}
		if (o_handler.IsHitRUarm()) { // Er
			if (o_handler.IsDefenseState()) {
	    		absorb *= o_handler.defense_upperarm_absorb;
			} else if (o_handler.CanBlock()){
	    		absorb *= o_handler.normal_upperarm_absorb;			
			} else {
	    		absorb *= o_handler.offense_upperarm_absorb;						
			}
			if (IsFirstHit()) {
				Blocked();
				select_sound = SE_BLOCK;
			}
		}
		if (o_handler.IsHitRFarm()) {  // EOr
			if (o_handler.IsDefenseState()) {
	    		absorb *= o_handler.defense_forearm_absorb;
			} else if (o_handler.CanBlock()){
	    		absorb *= o_handler.normal_forearm_absorb;			
			} else {
	    		absorb *= o_handler.offense_forearm_absorb;						
			}
			if (IsFirstHit()) {
				Blocked();
				select_sound = SE_BLOCK;
			}
		}
		if (o_handler.IsHitRFist()) {  // E
			if (o_handler.IsDefenseState()) {
	    		absorb *= o_handler.defense_fist_absorb;
			} else if (o_handler.CanBlock()){
	    		absorb *= o_handler.normal_fist_absorb;			
			} else {
	    		absorb *= o_handler.offense_fist_absorb;						
			}
			if (IsFirstHit()) {
				Blocked();
				select_sound = SE_BLOCK;
			}
		}

		if (o_handler.IsHitLShoul()) { // 
			if (o_handler.IsDefenseState()) {
	    		absorb *= o_handler.defense_shoulder_absorb;
			} else if (o_handler.CanBlock()){
	    		absorb *= o_handler.normal_shoulder_absorb;			
			} else {
	    		absorb *= o_handler.offense_shoulder_absorb;						
			}
			if (IsFirstHit()) {
				Blocked();
				select_sound = SE_BLOCK;
			}
		}
		if (o_handler.IsHitLUarm()) {  // r
			if (o_handler.IsDefenseState()) {
	    		absorb *= o_handler.defense_upperarm_absorb;
			} else if (o_handler.CanBlock()){
	    		absorb *= o_handler.normal_upperarm_absorb;			
			} else {
	    		absorb *= o_handler.offense_upperarm_absorb;						
			}
			if (IsFirstHit()) {
				Blocked();
				select_sound = SE_BLOCK;
			}
		}
		if (o_handler.IsHitLFarm()) {  // Or
			if (o_handler.IsDefenseState()) {
	    		absorb *= o_handler.defense_forearm_absorb;
			} else if (o_handler.CanBlock()){
	    		absorb *= o_handler.normal_forearm_absorb;			
			} else {
	    		absorb *= o_handler.offense_forearm_absorb;						
			}
			if (IsFirstHit()) {
				Blocked();
				select_sound = SE_BLOCK;
			}
		}
		if (o_handler.IsHitLFist()) { // 
			if (o_handler.IsDefenseState()) {
	    		absorb *= o_handler.defense_fist_absorb;
			} else if (o_handler.CanBlock()){
	    		absorb *= o_handler.normal_fist_absorb;			
			} else {
	    		absorb *= o_handler.offense_fist_absorb;						
			}
			if (IsFirstHit()) {
				Blocked();
				select_sound = SE_BLOCK;
			}
		}
	}
}

void BoxerHandler::RestoreCyanosis(Boxer &boxer) {
	if (CanBreathe()) {
		cyanosis-= cyanosis_restore;	/* ʉ */
		if (cyanosis < 0.0)  {
			cyanosis = 0.0;	
		} else {						/* X^~iɂ */
			restore_rate = 2.0 * cyanosis_restore * stamina / max_stamina;
			cyanosis-= restore_rate;
			stamina-= restore_rate;
			if (cyanosis < 0.0)  {
				stamina+= -cyanosis; 
				cyanosis = 0.0;	
		    }
		}
	}
}

void BoxerHandler::CalcCyanosis(Boxer &boxer) {
	cyanosis+= boxer.CalcEnergy();
	cyanosis_rate = cyanosis / max_cyanosis;
#if CHANGE_SPECIFICATIONS
	swing_speed = 1.25 - 0.25 * stamina/max_stamina + 1.25*cyanosis_rate;
#else 
	swing_speed = 1.0 + cyanosis_rate;
#endif
	if (cyanosis_rate > 1.0) {
		cyanosis_rate = 1.0;	
	}
}

void BoxerHandler::CyanosisColor(float *r, float *g, float *b) {
	*r = 1.0 + (0.8 - 1.0) * cyanosis_rate;
	*g = 0.7 + (0.2 - 0.7) * cyanosis_rate;
	*b = 0.7 + (0.8 - 0.7) * cyanosis_rate;
}

void BoxerHandler::RestoreDamage() {
	brain_damage-= damage_restore * 2.0;
	if (brain_damage < 0.0) {
		brain_damage = 0.0;	
	}

	restore_rate = damage_restore * stamina / max_stamina;
	face_damage-= restore_rate;
	stamina-= restore_rate;
	if (face_damage < 0.0) {
		stamina+= -face_damage; 
		face_damage = 0.0;	
	}

	restore_rate = damage_restore * stamina / max_stamina;
	body_damage-= restore_rate * 0.5;
	stamina-= restore_rate;
	if (body_damage < 0.0) {
		stamina+= -body_damage * 2.0; 
		body_damage = 0.0;	
	}
}

void BoxerHandler::RestoreDamageInterval(MatchHandler &match) {
	int i, over_time, restore_time;
	over_time = match.TimeCount() - match.RoundTime();
	restore_time = match.IntervalTime() - over_time;
	if (restore_time < 0) {
		restore_time = 0;	
	}
	for (i = 0; i < restore_time; i++) {
		RestoreDamage();	
	}
}
	
void BoxerHandler::CalcDamage() {
	damage = traum_damage + brain_damage + face_damage + body_damage;
#if CHANGE_SPECIFICATIONS
	move_speed = 1.25 - 0.25 * stamina/max_stamina + damage/max_damage;	
#else
	move_speed = 1.0 + damage/max_damage;	
#endif
}	

bool BoxerHandler::IsMinimamDamage() {
	return (hit_damage > 1.0);
}

bool BoxerHandler::CanOffense() {
#if CHANGE_SPECIFICATIONS
	if (swing_speed <= 2.5) {
#else
	if (swing_speed <= 2.0) {
#endif
		return true;
	}
	return false;
}

void BoxerHandler::SetDamage(Boxer &boxer, MotionHandler &motion) {
	if (damage > max_damage) { /* Ez? */
		if (IsDamageFace()) { /* Ƀqbg */
			motion.SetDowningFace(IsRhythmState());		
			action = DOWNING_FACE;
		} else { /* Ƃ{fB */
			motion.SetDowningBody(IsRhythmState());		
			action = DOWNING_BODY;
		}
		if (IsCounting()) { /* _ȆŌ */
			DownDec();		
		}
		state = DOWNING; /* Ԃ̕ω */
		combination = 0; /* Ô */
		deadly = 0;
	} else {
		if (IsDamageFace()) { /* Ƀqbg */
			motion.SetDamagedFace(0.50*hit_damage/max_damage, IsRhythmState());		
			state = DAMAGED;
			action = GET_HIT_FACE;
			combination = 0;
			deadly = 0;
		} else if (IsDamageBody()) { /* {fBɃqbg */
			motion.SetDamagedBody(0.25*hit_damage/max_damage, IsRhythmState());		
			state = DAMAGED;
			action = GET_HIT_BODY;
			combination = 0;
			deadly = 0;
		}
	}					
}

void BoxerHandler::GetComStates(MatchHandler &match, Boxer& m_boxer, BoxerHandler& o_handler) {
	int i, tr_state;
	
	InitKey();
	if (IsDownState()) {
		Defense();
		return;
	}

	for (i = 0; i < max_think; i++) {
		tr_state = think[i].Consider(match, *this, m_boxer, o_handler);
		if (tr_state != TR_THROUGH) {
		//	think[i].Print(match, *this, m_boxer, o_handler);			
			break;
		}
	}

	switch (tr_state) {
		case TR_FORWARD:
			Forward();
		break;
		case TR_BACK:
			Back();
		break;
		case TR_RIGHT:
			Right();
		break;
		case TR_LEFT:
			Left();
		break;
		case TR_RIGHT_N:
			RightOffense();
		break;
		case TR_RIGHT_F:
			RightOffense();
			Forward();
		break;
		case TR_RIGHT_B:
			RightOffense();
			Back();
		break;
		case TR_RIGHT_R:
			RightOffense();
			Right();
		break;
		case TR_RIGHT_L:
			RightOffense();
			Left();
		break;
		case TR_RIGHT_RF:
			RightOffense();
			Right();
			Forward();
		break;
		case TR_RIGHT_LF:
			RightOffense();
			Left();
			Forward();
		break;
		case TR_RIGHT_RB:
			RightOffense();
			Right();
			Back();
		break;
		case TR_RIGHT_LB:
		break;
			RightOffense();
			Left();
			Back();
		case TR_LEFT_N:
			LeftOffense();
		break;
		case TR_LEFT_F:
			LeftOffense();
			Forward();
		break;
		case TR_LEFT_B:
			LeftOffense();
			Back();
		break;
		case TR_LEFT_R:
			LeftOffense();
			Right();
		break;
		case TR_LEFT_L:
			LeftOffense();
			Left();
		break;
		case TR_LEFT_RF:
			LeftOffense();
			Right();
			Forward();
		break;
		case TR_LEFT_LF:
			LeftOffense();
			Left();
			Forward();
		break;
		case TR_LEFT_RB:
			LeftOffense();
			Right();
			Back();
		break;
		case TR_LEFT_LB:
			LeftOffense();
			Left();
			Back();
		break;
		case TR_DEFENSE_N:
			Defense();
		break;
		case TR_DEFENSE_F:
			Defense();
			Forward();
		break;
		case TR_DEFENSE_B:
			Defense();
			Back();
		break;
		case TR_DEFENSE_R:
			Defense();
			Right();
		break;
		case TR_DEFENSE_L:
			Defense();
			Left();
		break;
		case TR_DEFENSE_RF:
			Defense();
			Right();
			Forward();
		break;
		case TR_DEFENSE_LF:
			Defense();
			Left();
			Forward();
		break;
		case TR_DEFENSE_RB:
			Defense();
			Right();
			Back();
		break;
		case TR_DEFENSE_LB:
			Defense();
			Left();
			Back();
		break;
		case TR_CLINCH:
			Defense();
			RightOffense();			
		break;		
		case TR_DEADLY:
			RightOffense();
			LeftOffense();
		break;		
	}

#if 0
	fprintf(stderr, "%2d ", i);
	switch (tr_state) {
		case TR_FORWARD:
			fprintf(stderr, "Oړ\n");
		break;
		case TR_BACK:
			fprintf(stderr, "ړ\n");
		break;
		case TR_RIGHT:
			fprintf(stderr, "Eړ\n");
		break;
		case TR_LEFT:
			fprintf(stderr, "ړ\n");
		break;
		case TR_RIGHT_N:
			fprintf(stderr, "EU+\n");
		break;
		case TR_RIGHT_F:
			fprintf(stderr, "EU+O\n");
		break;
		case TR_RIGHT_B:
			fprintf(stderr, "EU+\n");
		break;
		case TR_RIGHT_R:
			fprintf(stderr, "EU+E\n");
		break;
		case TR_RIGHT_L:
			fprintf(stderr, "EU+\n");
		break;
		case TR_RIGHT_RF:
			fprintf(stderr, "EU+EO\n");
		break;
		case TR_RIGHT_LF:
			fprintf(stderr, "EU+O\n");
		break;
		case TR_RIGHT_RB:
			fprintf(stderr, "EU+E\n");
		break;
		case TR_RIGHT_LB:
			fprintf(stderr, "EU+\n");
		break;
		case TR_LEFT_N:
			fprintf(stderr, "U+\n");
		break;
		case TR_LEFT_F:
			fprintf(stderr, "U+O\n");
		break;
		case TR_LEFT_B:
			fprintf(stderr, "U+\n");
		break;
		case TR_LEFT_R:
			fprintf(stderr, "U+E\n");
		break;
		case TR_LEFT_L:
			fprintf(stderr, "U+\n");
		break;
		case TR_LEFT_RF:
			fprintf(stderr, "U+EO\n");
		break;
		case TR_LEFT_LF:
			fprintf(stderr, "U+O\n");
		break;
		case TR_LEFT_RB:
			fprintf(stderr, "U+E\n");
		break;
		case TR_LEFT_LB:
			fprintf(stderr, "U+\n");
		break;
		case TR_DEFENSE_N:
			fprintf(stderr, "h+\n");
		break;
		case TR_DEFENSE_F:
			fprintf(stderr, "h+O\n");
		break;
		case TR_DEFENSE_B:
			fprintf(stderr, "h+\n");
		break;
		case TR_DEFENSE_R:
			fprintf(stderr, "h+E\n");
		break;
		case TR_DEFENSE_L:
			fprintf(stderr, "h+\n");
		break;
		case TR_DEFENSE_RF:
			fprintf(stderr, "h+EO\n");
		break;
		case TR_DEFENSE_LF:
			fprintf(stderr, "h+O\n");
		break;
		case TR_DEFENSE_RB:
			fprintf(stderr, "h+E\n");
		break;
		case TR_DEFENSE_LB:
			fprintf(stderr, "h+\n");
		break;
		case TR_CLINCH:
			fprintf(stderr, "N`\n");
		break;		
		case TR_DEADLY:
			fprintf(stderr, "KERrl[V\n");
		break;		
		case TR_NOTHING:
			fprintf(stderr, "s\n");
		break;	
	}
#endif
}

void BoxerHandler::Reverse() {
	int i;
	for (i = 0; i < max_think; i++) {
		think[i].Reverse();	
	}
}
