#include "boxerhandler.h"

void BoxerHandler::LoadStoryBoxer(Boxer &boxer, MotionHandler &motion, StoryBoxer &sb) {
	SetBoxerColor(boxer, sb.Gloves(), sb.Trunks(), sb.Skin(), sb.HairColor());
	SetBoxerBody(boxer, (sb.Height() - 1) * 7 + sb.Reach());
	SetBoxerFace(boxer, sb.HairStyle(), sb.Eyebrow(), sb.Eye(), sb.Nose(), sb.Mouth());
	SetBoxerMotion(motion, sb.Style());
	SetBoxerCombo(motion, sb.Comb()*2 + sb.Stance());

	if (sb.Thought() < 3) {
		SetBoxerThink((sb.Style() - 1)* 2 + sb.Thought());
	} else {
		SetBoxerThink(sb.Thought() - 2);
	}
	SaveDefaultThink();
	
	if (sb.Stance()) {
		motion.Reverse();
		Reverse();
	}
}

void BoxerHandler::SetStoryBoxer(Boxer &boxer, MotionHandler &motion, StoryBoxer &sb) {
	LoadStoryBoxer(boxer, motion, sb);
	SetBoxerManip(sb);
	SetTraumRate(sb.Traum());
	SetBoxerName(sb);
}

void BoxerHandler::SetBoxerColor(Boxer &boxer, int c1, int c2, int c3, int c4) {
	SetBandageColor(boxer, c1);
	SetGlovesColor(boxer, c1);
	SetShoesColor(boxer, c1);
	SetTrunksColor(boxer, c2);
	SetSkinColor(boxer, c3);
	SetHairColor(boxer, c4);
}

void BoxerHandler::SetGlovesColor(Boxer &boxer, int cn) {
	switch (cn) {
		case 1:
			boxer.glove.DefDiffuse(1.0, 0.0, 0.0);		
		break;		
		case 2:
			boxer.glove.DefDiffuse(0.0, 0.0, 1.0);				
		break;	
		case 3:
			boxer.glove.DefDiffuse(1.0, 1.0, 0.0);				
		break;		
		case 4:
			boxer.glove.DefDiffuse(0.1, 0.1, 0.1);				
		break;		
		case 5:
			boxer.glove.DefDiffuse(0.9, 0.9, 0.9);				
		break;		
		case 6:
			boxer.glove.DefDiffuse(0.0, 0.7, 0.0);				
		break;		
		case 7:
			boxer.glove.DefDiffuse(0.7, 0.0, 0.7);				
		break;		
		case 8:
			boxer.glove.DefDiffuse(0.0, 0.7, 0.7);				
		break;		
		default:
			boxer.glove.DefDiffuse(1.0, 0.0, 0.0);		
		break;		
	}

	boxer.glove.DefAmbient(0.2, 0.2, 0.2);
	boxer.glove.DefSpecular(1.0, 1.0, 1.0);
	boxer.glove.DefEmission(0.0, 0.0, 0.0);
	boxer.glove.DefShininess(100.0);
}

void BoxerHandler::SetShoesColor(Boxer &boxer, int cn) {
	switch (cn) {
		case 1:
			boxer.shoes.DefDiffuse(1.0, 0.0, 0.0);		
		break;		
		case 2:
			boxer.shoes.DefDiffuse(0.0, 0.0, 1.0);				
		break;	
		case 3:
			boxer.shoes.DefDiffuse(1.0, 1.0, 0.0);				
		break;		
		case 4:
			boxer.shoes.DefDiffuse(0.1, 0.1, 0.1);				
		break;		
		case 5:
			boxer.shoes.DefDiffuse(0.9, 0.9, 0.9);				
		break;		
		case 6:
			boxer.shoes.DefDiffuse(0.0, 0.7, 0.0);				
		break;		
		case 7:
			boxer.shoes.DefDiffuse(0.7, 0.0, 0.7);				
		break;		
		case 8:
			boxer.shoes.DefDiffuse(0.0, 0.7, 0.7);				
		break;		
		default:
			boxer.shoes.DefDiffuse(1.0, 0.0, 0.0);		
		break;		
	}

	boxer.shoes.DefAmbient(0.2, 0.2, 0.2);
	boxer.shoes.DefSpecular(1.0, 1.0, 1.0);
	boxer.shoes.DefEmission(0.0, 0.0, 0.0);
	boxer.shoes.DefShininess(100.0);
}

void BoxerHandler::SetTrunksColor(Boxer &boxer, int cn) {
	switch (cn) {
		case 1:
			boxer.trunks.DefDiffuse(0.1, 0.1, 0.1);		
		break;		
		case 2:
			boxer.trunks.DefDiffuse(0.9, 0.9, 0.9);				
		break;	
		case 3:
			boxer.trunks.DefDiffuse(0.9, 0.9, 0.6);				
		break;		
		case 4:
			boxer.trunks.DefDiffuse(0.9, 0.9, 0.3);				
		break;		
		case 5:
			boxer.trunks.DefDiffuse(0.9, 0.9, 0.0);				
		break;		
		case 6:
			boxer.trunks.DefDiffuse(0.9, 0.6, 0.9);				
		break;		
		case 7:
			boxer.trunks.DefDiffuse(0.9, 0.6, 0.6);				
		break;		
		case 8:
			boxer.trunks.DefDiffuse(0.9, 0.6, 0.3);				
		break;		
		case 9:
			boxer.trunks.DefDiffuse(0.9, 0.6, 0.0);				
		break;		
		case 10:
			boxer.trunks.DefDiffuse(0.9, 0.3, 0.9);				
		break;		
		case 11:
			boxer.trunks.DefDiffuse(0.9, 0.3, 0.6);				
		break;		
		case 12:
			boxer.trunks.DefDiffuse(0.9, 0.3, 0.3);				
		break;		
		case 13:
			boxer.trunks.DefDiffuse(0.9, 0.3, 0.0);				
		break;		
		case 14:
			boxer.trunks.DefDiffuse(0.9, 0.0, 0.9);				
		break;		
		case 15:
			boxer.trunks.DefDiffuse(0.9, 0.0, 0.6);				
		break;		
		case 16:
			boxer.trunks.DefDiffuse(0.9, 0.0, 0.3);				
		break;		
		case 17:
			boxer.trunks.DefDiffuse(0.9, 0.0, 0.0);				
		break;		

		case 18:
			boxer.trunks.DefDiffuse(0.6, 0.9, 0.9);				
		break;	
		case 19:
			boxer.trunks.DefDiffuse(0.6, 0.9, 0.6);				
		break;		
		case 20:
			boxer.trunks.DefDiffuse(0.6, 0.9, 0.3);				
		break;		
		case 21:
			boxer.trunks.DefDiffuse(0.6, 0.9, 0.0);				
		break;		
		case 22:
			boxer.trunks.DefDiffuse(0.6, 0.6, 0.9);				
		break;		
		case 23:
			boxer.trunks.DefDiffuse(0.6, 0.6, 0.6);				
		break;		
		case 24:
			boxer.trunks.DefDiffuse(0.6, 0.6, 0.3);				
		break;		
		case 25:
			boxer.trunks.DefDiffuse(0.6, 0.6, 0.0);				
		break;		
		case 26:
			boxer.trunks.DefDiffuse(0.6, 0.3, 0.9);				
		break;		
		case 27:
			boxer.trunks.DefDiffuse(0.6, 0.3, 0.6);				
		break;		
		case 28:
			boxer.trunks.DefDiffuse(0.6, 0.3, 0.3);				
		break;		
		case 29:
			boxer.trunks.DefDiffuse(0.6, 0.3, 0.0);				
		break;		
		case 30:
			boxer.trunks.DefDiffuse(0.6, 0.0, 0.9);				
		break;		
		case 31:
			boxer.trunks.DefDiffuse(0.6, 0.0, 0.6);				
		break;		
		case 32:
			boxer.trunks.DefDiffuse(0.6, 0.0, 0.3);				
		break;		
		case 33:
			boxer.trunks.DefDiffuse(0.6, 0.0, 0.0);				
		break;		

		case 34:
			boxer.trunks.DefDiffuse(0.3, 0.9, 0.9);				
		break;	
		case 35:
			boxer.trunks.DefDiffuse(0.3, 0.9, 0.6);				
		break;		
		case 36:
			boxer.trunks.DefDiffuse(0.3, 0.9, 0.3);				
		break;		
		case 37:
			boxer.trunks.DefDiffuse(0.3, 0.9, 0.0);				
		break;		
		case 38:
			boxer.trunks.DefDiffuse(0.3, 0.6, 0.9);				
		break;		
		case 39:
			boxer.trunks.DefDiffuse(0.3, 0.6, 0.6);				
		break;		
		case 40:
			boxer.trunks.DefDiffuse(0.3, 0.6, 0.3);				
		break;		
		case 41:
			boxer.trunks.DefDiffuse(0.3, 0.6, 0.0);				
		break;		
		case 42:
			boxer.trunks.DefDiffuse(0.3, 0.3, 0.9);				
		break;		
		case 43:
			boxer.trunks.DefDiffuse(0.3, 0.3, 0.6);				
		break;		
		case 44:
			boxer.trunks.DefDiffuse(0.3, 0.3, 0.3);				
		break;		
		case 45:
			boxer.trunks.DefDiffuse(0.3, 0.3, 0.0);				
		break;		
		case 46:
			boxer.trunks.DefDiffuse(0.3, 0.0, 0.9);				
		break;		
		case 47:
			boxer.trunks.DefDiffuse(0.3, 0.0, 0.6);				
		break;		
		case 48:
			boxer.trunks.DefDiffuse(0.3, 0.0, 0.3);				
		break;		
		case 49:
			boxer.trunks.DefDiffuse(0.3, 0.0, 0.0);				
		break;		

		case 50:
			boxer.trunks.DefDiffuse(0.0, 0.9, 0.9);				
		break;	
		case 51:
			boxer.trunks.DefDiffuse(0.0, 0.9, 0.6);				
		break;		
		case 52:
			boxer.trunks.DefDiffuse(0.0, 0.9, 0.3);				
		break;		
		case 53:
			boxer.trunks.DefDiffuse(0.0, 0.9, 0.0);				
		break;		
		case 54:
			boxer.trunks.DefDiffuse(0.0, 0.6, 0.9);				
		break;		
		case 55:
			boxer.trunks.DefDiffuse(0.0, 0.6, 0.6);				
		break;		
		case 56:
			boxer.trunks.DefDiffuse(0.0, 0.6, 0.3);				
		break;		
		case 57:
			boxer.trunks.DefDiffuse(0.0, 0.6, 0.0);				
		break;		
		case 58:
			boxer.trunks.DefDiffuse(0.0, 0.3, 0.9);				
		break;		
		case 59:
			boxer.trunks.DefDiffuse(0.0, 0.3, 0.6);				
		break;		
		case 60:
			boxer.trunks.DefDiffuse(0.0, 0.3, 0.3);				
		break;		
		case 61:
			boxer.trunks.DefDiffuse(0.0, 0.3, 0.0);				
		break;		
		case 62:
			boxer.trunks.DefDiffuse(0.0, 0.0, 0.9);				
		break;		
		case 63:
			boxer.trunks.DefDiffuse(0.0, 0.0, 0.6);				
		break;		
		case 64:
			boxer.trunks.DefDiffuse(0.0, 0.0, 0.3);				
		break;		

		default:
			boxer.trunks.DefDiffuse(0.1, 0.1, 0.1);		
		break;		
	}

	boxer.trunks.DefAmbient(0.2, 0.2, 0.2);
	boxer.trunks.DefSpecular(1.0, 1.0, 1.0);
	boxer.trunks.DefEmission(0.0, 0.0, 0.0);
	boxer.trunks.DefShininess(100.0);
}

void BoxerHandler::SetBandageColor(Boxer &boxer, int cn) {
	boxer.bandage.DefDiffuse(1.0, 1.0, 1.0);
	boxer.bandage.DefAmbient(0.2, 0.2, 0.2);
	boxer.bandage.DefSpecular(0.0, 0.0, 0.0);
	boxer.bandage.DefEmission(0.0, 0.0, 0.0);
	boxer.bandage.DefShininess(00.0);
}

void BoxerHandler::SetSkinColor(Boxer &boxer, int cn) {
	switch (cn) {
		case 1:
			boxer.skin.DefDiffuse(1.0, 0.8, 0.8);				
		break;	
		case 2:
			boxer.skin.DefDiffuse(1.0, 0.7, 0.7);				
		break;	
		case 3:
			boxer.skin.DefDiffuse(1.0, 0.6, 0.6);				
		break;	
		case 4:
			boxer.skin.DefDiffuse(0.9, 0.6, 0.6);				
		break;	
		case 5:
			boxer.skin.DefDiffuse(0.8, 0.5, 0.5);				
		break;	
		case 6:
			boxer.skin.DefDiffuse(0.7, 0.5, 0.5);				
		break;	
		case 7:
			boxer.skin.DefDiffuse(0.6, 0.4, 0.4);				
		break;	
		case 8:
			boxer.skin.DefDiffuse(0.5, 0.3, 0.3);				
		break;	
		case 9:
			boxer.skin.DefDiffuse(0.4, 0.2, 0.2);				
		break;
		case 10:
			boxer.skin.DefDiffuse(0.3, 0.2, 0.2);				
		break;
		default:
			boxer.skin.DefDiffuse(1.0, 0.6, 0.6);		
		break;		
	}

	boxer.skin.DefAmbient(0.2, 0.2, 0.2);
	boxer.skin.DefSpecular(0.0, 0.0, 0.0);
	boxer.skin.DefEmission(0.0, 0.0, 0.0);
	boxer.skin.DefShininess(0.0);
}

void BoxerHandler::SetHairColor(Boxer &boxer, int cn) {
	switch (cn) {
		case 1:
			boxer.hair.DefDiffuse(0.9, 0.9, 0.9);				
		break;	
		case 2:
			boxer.hair.DefDiffuse(0.8, 0.8, 0.0);				
		break;	
		case 3:
			boxer.hair.DefDiffuse(0.7, 0.0, 0.0);				
		break;	
		case 4:
			boxer.hair.DefDiffuse(0.6, 0.1, 0.1);				
		break;	
		case 5:
			boxer.hair.DefDiffuse(0.5, 0.2, 0.2);				
		break;	
		case 6:
			boxer.hair.DefDiffuse(0.4, 0.2, 0.2);				
		break;	
		case 7:
			boxer.hair.DefDiffuse(0.3, 0.2, 0.2);				
		break;	
		case 8:
			boxer.hair.DefDiffuse(0.2, 0.2, 0.2);				
		break;	
		case 9:
			boxer.hair.DefDiffuse(0.1, 0.1, 0.1);				
		break;
		case 10:
			boxer.hair.DefDiffuse(0.0, 0.0, 0.0);		
		break;
		default:
			boxer.hair.DefDiffuse(0.0, 0.0, 0.0);		
		break;		
	}

	boxer.hair.DefAmbient(0.2, 0.2, 0.2);
	boxer.hair.DefSpecular(0.5, 0.5, 0.5);
	boxer.hair.DefShininess(128.0);
}

void BoxerHandler::SetBoxerFace(Boxer &boxer, int c1, int c2, int c3, int c4, int c5) {
	boxer.hair_style = c1;
	boxer.eyebrow = c2;
	boxer.eye = c3;
	boxer.nose = c4;
	boxer.mouth = c5;
}

void BoxerHandler::SetBoxerBody(Boxer &boxer, int c) {
	switch (c) {
		case 1:
		 	LoadBinBoxerBodySet(boxer, BoxerBody11());	
		break;
		case 2:
		 	LoadBinBoxerBodySet(boxer, BoxerBody12());	
		break;
		case 3:
		 	LoadBinBoxerBodySet(boxer, BoxerBody13());	
		break;
		case 4:
		 	LoadBinBoxerBodySet(boxer, BoxerBody14());	
		break;
		case 5:
		 	LoadBinBoxerBodySet(boxer, BoxerBody15());	
		break;
	 	case 6:
		 	LoadBinBoxerBodySet(boxer, BoxerBody16());	
		break;
		case 7:
		 	LoadBinBoxerBodySet(boxer, BoxerBody17());	
		break;
		case 8:
		 	LoadBinBoxerBodySet(boxer, BoxerBody21());	
		break;
		case 9:
		 	LoadBinBoxerBodySet(boxer, BoxerBody22());	
		break;
		case 10:
		 	LoadBinBoxerBodySet(boxer, BoxerBody23());	
		break;
		case 11:
		 	LoadBinBoxerBodySet(boxer, BoxerBody24());	
		break;
		case 12:
		 	LoadBinBoxerBodySet(boxer, BoxerBody25());	
		break;
		case 13:
		 	LoadBinBoxerBodySet(boxer, BoxerBody26());	
		break;
		case 14:
		 	LoadBinBoxerBodySet(boxer, BoxerBody27());	
		break;
		case 15:
		 	LoadBinBoxerBodySet(boxer, BoxerBody31());	
		break;
		case 16:
		 	LoadBinBoxerBodySet(boxer, BoxerBody32());	
		break;
		case 17:
		 	LoadBinBoxerBodySet(boxer, BoxerBody33());	
		break;
		case 18:
		 	LoadBinBoxerBodySet(boxer, BoxerBody34());	
		break;
		case 19:
		 	LoadBinBoxerBodySet(boxer, BoxerBody35());	
		break;
		case 20:
		 	LoadBinBoxerBodySet(boxer, BoxerBody36());	
		break;
		case 21:
		 	LoadBinBoxerBodySet(boxer, BoxerBody37());	
		break;
		case 22:
		 	LoadBinBoxerBodySet(boxer, BoxerBody41());	
		break;
		case 23:
		 	LoadBinBoxerBodySet(boxer, BoxerBody42());	
		break;
		case 24:
		 	LoadBinBoxerBodySet(boxer, BoxerBody43());	
		break;
		case 25:
		 	LoadBinBoxerBodySet(boxer, BoxerBody44());	
		break;
		case 26:
		 	LoadBinBoxerBodySet(boxer, BoxerBody45());	
		break;
		case 27:
		 	LoadBinBoxerBodySet(boxer, BoxerBody46());	
		break;
		case 28:
		 	LoadBinBoxerBodySet(boxer, BoxerBody47());	
		break;
		case 29:
		 	LoadBinBoxerBodySet(boxer, BoxerBody51());	
		break;
		case 30:
		 	LoadBinBoxerBodySet(boxer, BoxerBody52());	
		break;
		case 31:
		 	LoadBinBoxerBodySet(boxer, BoxerBody53());	
		break;
		case 32:
		 	LoadBinBoxerBodySet(boxer, BoxerBody54());	
		break;
		case 33:
		 	LoadBinBoxerBodySet(boxer, BoxerBody55());	
		break;
		case 34:
		 	LoadBinBoxerBodySet(boxer, BoxerBody56());	
		break;
		case 35:
		 	LoadBinBoxerBodySet(boxer, BoxerBody57());	
		break;
		case 36:
		 	LoadBinBoxerBodySet(boxer, BoxerBody61());	
		break;
		case 37:
		 	LoadBinBoxerBodySet(boxer, BoxerBody62());	
		break;
		case 38:
		 	LoadBinBoxerBodySet(boxer, BoxerBody63());	
		break;
		case 39:
		 	LoadBinBoxerBodySet(boxer, BoxerBody64());	
		break;
		case 40:
		 	LoadBinBoxerBodySet(boxer, BoxerBody65());	
		break;
		case 41:
		 	LoadBinBoxerBodySet(boxer, BoxerBody66());	
		break;
		case 42:
		 	LoadBinBoxerBodySet(boxer, BoxerBody67());	
		break;
		case 43:
		 	LoadBinBoxerBodySet(boxer, BoxerBody71());	
		break;
		case 44:
		 	LoadBinBoxerBodySet(boxer, BoxerBody72());	
		break;
		case 45:
		 	LoadBinBoxerBodySet(boxer, BoxerBody73());	
		break;
		case 46:
		 	LoadBinBoxerBodySet(boxer, BoxerBody74());	
		break;
		case 47:
		 	LoadBinBoxerBodySet(boxer, BoxerBody75());	
		break;
		case 48:
		 	LoadBinBoxerBodySet(boxer, BoxerBody76());	
		break;
		case 49:
		 	LoadBinBoxerBodySet(boxer, BoxerBody77());	
		break;
		default:
		 	LoadBinBoxerBodySet(boxer, BoxerBody44());	
		break;
	}
}

void BoxerHandler::SetBoxerMotion(MotionHandler &motion, int c) {
	switch (c) {
		case 1:
		 	LoadBinBoxerMotionSet(motion, BoxerMotion1());	
		break;
		case 2:
		 	LoadBinBoxerMotionSet(motion, BoxerMotion2());	
		break;
		case 3:
		 	LoadBinBoxerMotionSet(motion, BoxerMotion3());	
		break;
		case 4:
		 	LoadBinBoxerMotionSet(motion, BoxerMotion4());	
		break;
		case 5:
		 	LoadBinBoxerMotionSet(motion, BoxerMotion5());	
		break;
		case 6:
		 	LoadBinBoxerMotionSet(motion, BoxerMotion6());	
		break;
		case 7:
		 	LoadBinBoxerMotionSet(motion, BoxerMotion7());	
		break;
		default:
		 	LoadBinBoxerMotionSet(motion, BoxerMotion1());	
		break;
	}
}

void BoxerHandler::SetBoxerCombo(MotionHandler &motion, int c) {
	switch (c) {
		case 0:
			motion.assign[DEADLY1] = LEFT_N;	
			motion.assign[DEADLY2] = RIGHT_N;		
			motion.assign[DEADLY3] = -1;	
			motion.assign[DEADLY4] = -1;	
		break;
		case 2:
			motion.assign[DEADLY1] = LEFT_N;	
			motion.assign[DEADLY2] = RIGHT_B;		
			motion.assign[DEADLY3] = LEFT_B;	
			motion.assign[DEADLY4] = RIGHT_B;	
		break;
		case 4:
			motion.assign[DEADLY1] = DEFENSE_F;	
			motion.assign[DEADLY2] = LEFT_R;	
			motion.assign[DEADLY3] = RIGHT_R;		
			motion.assign[DEADLY4] = -1;	
		break;
		case 6:
			motion.assign[DEADLY1] = LEFT_B;	
			motion.assign[DEADLY2] = RIGHT_B;	
			motion.assign[DEADLY3] = LEFT_B;		
			motion.assign[DEADLY4] = RIGHT_B;	
		break;
		case 8:
			motion.assign[DEADLY1] = LEFT_N;	
			motion.assign[DEADLY2] = RIGHT_N;	
			motion.assign[DEADLY3] = LEFT_F;		
			motion.assign[DEADLY4] = RIGHT_R;	
		break;
		case 10:
			motion.assign[DEADLY1] = LEFT_N;	
			motion.assign[DEADLY2] = LEFT_N;	
			motion.assign[DEADLY3] = RIGHT_N;		
			motion.assign[DEADLY4] = -1;	
		break;
		case 12:
			motion.assign[DEADLY1] = LEFT_N;	
			motion.assign[DEADLY2] = LEFT_N;	
			motion.assign[DEADLY3] = RIGHT_N;		
			motion.assign[DEADLY4] = -1;	
		break;
		case 14:
			motion.assign[DEADLY1] = RIGHT_B;	
			motion.assign[DEADLY2] = LEFT_B;	
			motion.assign[DEADLY3] = LEFT_F;		
			motion.assign[DEADLY4] = RIGHT_F;	
		break;
		case 16:
			motion.assign[DEADLY1] = DEFENSE_F;	
			motion.assign[DEADLY2] = RIGHT_F;	
			motion.assign[DEADLY3] = LEFT_R;		
			motion.assign[DEADLY4] = -1;	
		break;
		case 18:
			motion.assign[DEADLY1] = LEFT_N;	
			motion.assign[DEADLY2] = RIGHT_N;		
			motion.assign[DEADLY3] = LEFT_B;	
			motion.assign[DEADLY4] = RIGHT_B;	
		break;
		case 20:
			motion.assign[DEADLY1] = LEFT_L;	
			motion.assign[DEADLY2] = DEFENSE_B;		
			motion.assign[DEADLY3] = LEFT_N;	
			motion.assign[DEADLY4] = RIGHT_N;	
		break;
		case 22:
			motion.assign[DEADLY1] = DEFENSE_F;	
			motion.assign[DEADLY2] = RIGHT_F;		
			motion.assign[DEADLY3] = LEFT_B;	
			motion.assign[DEADLY4] = RIGHT_B;	
		break;
		case 24:
			motion.assign[DEADLY1] = LEFT_L;	
			motion.assign[DEADLY2] = RIGHT_F;		
			motion.assign[DEADLY3] = LEFT_B;	
			motion.assign[DEADLY4] = RIGHT_B;	
		break;
		case 26:
			motion.assign[DEADLY1] = LEFT_N;	
			motion.assign[DEADLY2] = LEFT_F;		
			motion.assign[DEADLY3] = LEFT_N;	
			motion.assign[DEADLY4] = LEFT_F;	
		break;
		case 28:
			motion.assign[DEADLY1] = DEFENSE_B;	
			motion.assign[DEADLY2] = RIGHT_R;		
			motion.assign[DEADLY3] = LEFT_N;	
			motion.assign[DEADLY4] = RIGHT_N;	
		break;
		case 30:
			motion.assign[DEADLY1] = LEFT_L;	
			motion.assign[DEADLY2] = RIGHT_L;	
			motion.assign[DEADLY3] = -1;		
			motion.assign[DEADLY4] = -1;	
		break;
		case 32:
			motion.assign[DEADLY1] = LEFT_L;	
			motion.assign[DEADLY2] = RIGHT_L;	
			motion.assign[DEADLY3] = -1;		
			motion.assign[DEADLY4] = -1;	
		break;
		case 34:
			motion.assign[DEADLY1] = LEFT_L;	
			motion.assign[DEADLY2] = RIGHT_F;	
			motion.assign[DEADLY3] = -1;		
			motion.assign[DEADLY4] = -1;	
		break;
		case 36:
			motion.assign[DEADLY1] = RIGHT_L;	
			motion.assign[DEADLY2] = LEFT_R;	
			motion.assign[DEADLY3] = -1;		
			motion.assign[DEADLY4] = -1;	
		break;
		case 38:
			motion.assign[DEADLY1] = LEFT_N;	
			motion.assign[DEADLY2] = LEFT_N;	
			motion.assign[DEADLY3] = RIGHT_N;		
			motion.assign[DEADLY4] = RIGHT_N;	
		break;
		case 40:
			motion.assign[DEADLY1] = LEFT_N;	
			motion.assign[DEADLY2] = RIGHT_N;	
			motion.assign[DEADLY3] = LEFT_F;		
			motion.assign[DEADLY4] = RIGHT_R;	
		break;

		case 1:
			motion.assign[DEADLY1] = RIGHT_N;	
			motion.assign[DEADLY2] = LEFT_N;		
			motion.assign[DEADLY3] = -1;	
			motion.assign[DEADLY4] = -1;	
		break;
		case 3:
			motion.assign[DEADLY1] = RIGHT_N;	
			motion.assign[DEADLY2] = LEFT_B;		
			motion.assign[DEADLY3] = RIGHT_B;	
			motion.assign[DEADLY4] = LEFT_B;	
		break;
		case 5:
			motion.assign[DEADLY1] = DEFENSE_F;	
			motion.assign[DEADLY2] = RIGHT_R;	
			motion.assign[DEADLY3] = LEFT_R;		
			motion.assign[DEADLY4] = -1;	
		break;
		case 7:
			motion.assign[DEADLY1] = RIGHT_B;	
			motion.assign[DEADLY2] = LEFT_B;	
			motion.assign[DEADLY3] = RIGHT_B;		
			motion.assign[DEADLY4] = LEFT_B;	
		break;
		case 9:
			motion.assign[DEADLY1] = RIGHT_N;	
			motion.assign[DEADLY2] = LEFT_N;	
			motion.assign[DEADLY3] = RIGHT_F;		
			motion.assign[DEADLY4] = LEFT_R;	
		break;
		case 11:
			motion.assign[DEADLY1] = RIGHT_N;	
			motion.assign[DEADLY2] = RIGHT_N;	
			motion.assign[DEADLY3] = LEFT_N;		
			motion.assign[DEADLY4] = -1;	
		break;
		case 13:
			motion.assign[DEADLY1] = RIGHT_N;	
			motion.assign[DEADLY2] = RIGHT_N;	
			motion.assign[DEADLY3] = LEFT_N;		
			motion.assign[DEADLY4] = -1;	
		break;
		case 15:
			motion.assign[DEADLY1] = LEFT_B;	
			motion.assign[DEADLY2] = RIGHT_B;	
			motion.assign[DEADLY3] = RIGHT_F;		
			motion.assign[DEADLY4] = LEFT_F;	
		break;
		case 17:
			motion.assign[DEADLY1] = DEFENSE_F;	
			motion.assign[DEADLY2] = LEFT_F;	
			motion.assign[DEADLY3] = RIGHT_R;		
			motion.assign[DEADLY4] = -1;	
		break;
		case 19:
			motion.assign[DEADLY1] = RIGHT_N;	
			motion.assign[DEADLY2] = LEFT_N;		
			motion.assign[DEADLY3] = RIGHT_B;	
			motion.assign[DEADLY4] = LEFT_B;	
		break;
		case 21:
			motion.assign[DEADLY1] = RIGHT_L;	
			motion.assign[DEADLY2] = DEFENSE_B;		
			motion.assign[DEADLY3] = RIGHT_N;	
			motion.assign[DEADLY4] = LEFT_N;	
		break;
		case 23:
			motion.assign[DEADLY1] = DEFENSE_F;	
			motion.assign[DEADLY2] = LEFT_F;		
			motion.assign[DEADLY3] = RIGHT_B;	
			motion.assign[DEADLY4] = LEFT_B;	
		break;
		case 25:
			motion.assign[DEADLY1] = RIGHT_L;	
			motion.assign[DEADLY2] = LEFT_F;		
			motion.assign[DEADLY3] = RIGHT_B;	
			motion.assign[DEADLY4] = LEFT_B;	
		break;
		case 27:
			motion.assign[DEADLY1] = RIGHT_N;	
			motion.assign[DEADLY2] = RIGHT_F;		
			motion.assign[DEADLY3] = RIGHT_N;	
			motion.assign[DEADLY4] = RIGHT_F;	
		break;
		case 29:
			motion.assign[DEADLY1] = DEFENSE_B;	
			motion.assign[DEADLY2] = LEFT_R;		
			motion.assign[DEADLY3] = RIGHT_N;	
			motion.assign[DEADLY4] = LEFT_N;	
		break;
		case 31:
			motion.assign[DEADLY1] = RIGHT_L;	
			motion.assign[DEADLY2] = LEFT_L;	
			motion.assign[DEADLY3] = -1;		
			motion.assign[DEADLY4] = -1;	
		break;
		case 33:
			motion.assign[DEADLY1] = RIGHT_L;	
			motion.assign[DEADLY2] = LEFT_L;	
			motion.assign[DEADLY3] = -1;		
			motion.assign[DEADLY4] = -1;	
		break;
		case 35:
			motion.assign[DEADLY1] = RIGHT_L;	
			motion.assign[DEADLY2] = LEFT_F;	
			motion.assign[DEADLY3] = -1;		
			motion.assign[DEADLY4] = -1;	
		break;
		case 37:
			motion.assign[DEADLY1] = LEFT_L;	
			motion.assign[DEADLY2] = RIGHT_R;	
			motion.assign[DEADLY3] = -1;		
			motion.assign[DEADLY4] = -1;	
		break;
		case 39:
			motion.assign[DEADLY1] = RIGHT_N;	
			motion.assign[DEADLY2] = RIGHT_N;	
			motion.assign[DEADLY3] = LEFT_N;		
			motion.assign[DEADLY4] = LEFT_N;	
		break;
		case 41:
			motion.assign[DEADLY1] = RIGHT_N;	
			motion.assign[DEADLY2] = LEFT_N;	
			motion.assign[DEADLY3] = RIGHT_F;		
			motion.assign[DEADLY4] = LEFT_R;	
		break;

		default:
			motion.assign[DEADLY1] = LEFT_N;	
			motion.assign[DEADLY2] = RIGHT_N;		
			motion.assign[DEADLY3] = -1;	
			motion.assign[DEADLY4] = -1;	
		break;
	}
}

void BoxerHandler::SetBoxerThink(int c) {
	switch (c) {
		case 1:
		 	LoadBinBoxerThink(BoxerThink11());	
		break;
		case 2:
		 	LoadBinBoxerThink(BoxerThink12());	
		break;
		case 3:
		 	LoadBinBoxerThink(BoxerThink21());	
		break;
		case 4:
		 	LoadBinBoxerThink(BoxerThink22());	
		break;
		case 5:
		 	LoadBinBoxerThink(BoxerThink31());	
		break;
		case 6:
		 	LoadBinBoxerThink(BoxerThink32());	
		break;
		case 7:
		 	LoadBinBoxerThink(BoxerThink41());	
		break;
		case 8:
		 	LoadBinBoxerThink(BoxerThink42());	
		break;
		case 9:
		 	LoadBinBoxerThink(BoxerThink51());	
		break;
		case 10:
		 	LoadBinBoxerThink(BoxerThink52());	
		break;
		case 11:
		 	LoadBinBoxerThink(BoxerThink61());	
		break;
		case 12:
		 	LoadBinBoxerThink(BoxerThink62());	
		break;
		case 13:
		 	LoadBinBoxerThink(BoxerThink71());	
		break;
		case 14:
		 	LoadBinBoxerThink(BoxerThink72());	
		break;
		default:
		 	LoadBinBoxerThink(BoxerThink11());	
		break;
	}
}

void BoxerHandler::SetBoxerName(StoryBoxer &sb) {
	SetRingName(sb.RingName());	
	if (sb.Nation() == JAPAN) {
		SetFamilyNameJapan(sb.FamilyName());	
    } else {
		SetFamilyNameForeign(sb.FamilyName());		
	}
}

void BoxerHandler::SetBoxerManip(StoryBoxer &sb) {
	float rate;

	punch_manip = 1.0 + (float)sb.Punch() / 100.0;
	speed_manip = 1.0 / (1.0 + (float)sb.Speed() / 100.0);
	stamina_manip = 1.0 + (float)sb.Stamina() / 100.0;

	damage_restore_manip = 1.0 + (float)sb.DamageRestore() / 100.0;
	max_damage_manip = 1.0 + (float)sb.MaxDamage() / 100.0;
	cyanosis_restore_manip = 1.0 + (float)sb.CyanosisRestore() / 100.0;
	max_cyanosis_manip = 1.0 + (float)sb.MaxCyanosis() / 100.0;

	rate = (float)sb.BlockAbsorb() / 1000.0;
	defense_shoulder_absorb = 0.5 - rate;
	defense_upperarm_absorb = 0.6 - rate;
	defense_forearm_absorb  = 0.7 - rate;
	defense_fist_absorb     = 0.8 - rate;

	normal_shoulder_absorb = 0.75 - rate;
	normal_upperarm_absorb = 0.80 - rate;
	normal_forearm_absorb  = 0.85 - rate;
	normal_fist_absorb     = 0.90 - rate;

	offense_shoulder_absorb = 0.875 - rate;
	offense_upperarm_absorb = 0.900 - rate;
	offense_forearm_absorb  = 0.925 - rate;
	offense_fist_absorb     = 0.950 - rate;

	body_strength = 1.0 / (1.0 + (float)sb.BodyStrength() / 100.0);
	liver_strength = 1.5 - (float)sb.LiverStrength() / 100.0;
	face_strength = 1.0 / (1.0 + (float)sb.FaceStrength() / 100.0);
	jaw_strength = 1.5 - (float)sb.JawStrength() / 100.0;
}

void BoxerHandler::CleanManip() {
	punch_manip = 1.0;
	speed_manip = 1.0;
	stamina_manip = 1.0;

	damage_restore_manip = 1.0;
	max_damage_manip = 1.0;
	cyanosis_restore_manip = 1.0;
	max_cyanosis_manip = 1.0;

	defense_shoulder_absorb = 0.5;
	defense_upperarm_absorb = 0.6;
	defense_forearm_absorb  = 0.7;
	defense_fist_absorb     = 0.8;

	normal_shoulder_absorb = 0.75;
	normal_upperarm_absorb = 0.80;
	normal_forearm_absorb  = 0.85;
	normal_fist_absorb     = 0.90;

	offense_shoulder_absorb = 0.875;
	offense_upperarm_absorb = 0.900;
	offense_forearm_absorb  = 0.925;
	offense_fist_absorb     = 0.950;

	body_strength = 1.0;
	liver_strength = 1.5;
	face_strength = 1.0;
	jaw_strength = 1.5;
}

void BoxerHandler::SetCustomName(char *name, int number) {
	name[NAME_LENGTH] = '\0';
    strcpy(nickname_jp, name);
    strcpy(nickname_en, name);

	if (number < 100) {
		sprintf(familyname_jp, "p%d", number);
		sprintf(familyname_en, "Only No.%d", number);
	} else {
		strcpy(familyname_jp, "");
		strcpy(familyname_en, "Official");	
	}
}


void BoxerHandler::SetRingName(int c) {
	static char *nicknames[] = { 
		"Ȃ",		"You",
/* MV_b */
		"AgX",		"Atlas",
	    "A|",		"Apollo",
	    "AI",		"Arion",
		"A[X",		"Aleus",
	    "EmX",		"Uranus",
		"GseEX",	"Epimetheus",
	    "JIX",		"Chaos",
	    "NmX",		"Cronus",
	    "[EX",		"Zeus",
		"nfX",		"Hades",
	    "qyI",	"Hyperion",
		"veEX",	"Prometheus",
	    "wIX",		"Helios",
	    "|ZCh",	"Poseidon",
	    "ALX",		"Achilles",
		"CJX",		"Icarius",
		"wNX",	"Hercules",
		"yZEX",	"Perseus",
/* k_b */
		"I[fB[",	"Odin",
		"L",			"Loki",
		"oh",		"Baldur",
		"g[",		"Thor",
		"wC_",	"Heimdall",
		"tF",	"Fenrir",
		"Kh",	"Jormungand",
		"K",		"Garm",
/* z̓Ȃ */			
		"ASX",		"Argus",
		"GWF",	"Angel",
		"oVXN",	"Basilisk",
		"JvR[",	"Capricorn",
		"PxX",	"Cerberus",
		"P^EX",	"Centaurus",
		"N[P",	"Clarcken",
		"RJgX",	"Cckatrice",
		"hL",	"Dracula",
		"hS",		"Dragon",
		"Gt",		"Elf",
		"tFA[",	"Fairy",
		"t@g",	"Phantom",
		"K[SC",	"Gargoyle",
		"O[",		"Ghoul",
		"S[Xg",		"Ghost",
		"WAg",	"Gigant",
		"m[",		"Gnome",
		"Su",		"Goblin",
		"S[",		"Golem",
		"SS",		"Gorgon",
		"O",	"Gremlin",
		"OtB",	"Griffin",
		"wnEh",	"HellHound",
		"q|Ot",	"Hippogriff",
		"qh",		"Hydra",
		"R{g",		"Kobold",
		"vJ[",	"Leprechaun",
		"}eBRA",	"Manticore",
		"}[}",		"Merman",
		"~m^EX",	"Minotaur",
		"~C",		"Mummy",
		"X^[",	"Monster",
		"yKTX",		"Pegasus",
		"tFjbNX", "Phoenix",
		"sNV[",		"Pixy",
		"T}_[", "Salamander",
		"Th}",	"Sandman",
		"XPg",	"Skelton",
		"XCvj",	"Sleipnir",
		"XC",		"Slime",
		"XtBNX", "Sphinx",
		"XvK",	"Spriggan",
		"XvCg",	"Sprite",
		"VtB[h",	"Sylphid",
		"^C^",		"Titan",
		"g",		"Troll",
		"jR[", 	"Unicorn",
		"EfB[l",	"Undine",
		"E{X", 	"Ouroboros",
		"opCA",	"Vampire",
		"[Et",	"Werewolf",
		"Co[",	"Wyvern",
   		"]r", 		"Zombie",
/* EƂȂ */			
		"ANZ",		"Accelerator",
		"AiCU[",	"Analyzer",
		"AiXg",	"Annalist",
		"AiET[",	"Announcer",
		"A[eBXg",	"Artist",
		"A^bJ[",	"Attacker",
		"o`[",	"Bachelor",
		"og[",		"Battler",
		"o[oA",	"Barbarian",
		"s[^[",		"Beater",
		"o[T[J[",	"Berserker",
		"oC^[",		"Biter",
		"ub`[",	"Butcher",
		"o[O[",	"Burglar",
		"{o[",		"Bomber",
		"`[t",		"Chief",
		"JE{[C",	"Cowboy",
		"RN^[",	"Collector",
		"fXgC",	"Destroyer",
		"hN^[",		"Doctor",
		"GSCXg",	"Egoist",
		"GWjA",	"Engineer",
		"GO[L^",	"Executor",
		"GN\x83\\VXg","Exorcist",
		"GLXp[g",	"Expert",
		"n^[",		"Hunter",
		"CxC_[",	"Invader",
		"t@C^[",	"Fighter",
		"Q",		"Guerrilla",
		"WjAX",		"Genius",
		"}WV",	"Magician",
		"}X^[",		"Master",
		"pgIbg",	"Patriot",
		"vtFbT",	"Professor",
		"vtFbg",	"Prophet",
		"|Gbg",		"Poet",
		"VFCJ[",	"Shaker",
		"XiCp[",	"Sniper",
		"\x83\\W[",	"Soldier",
		"XgCJ[",	"Striker",
		"T[W",	"Surgeon",
		"\x83\\[h}",	"Swordsman",
		"^NeV",	"Tactician",
		"^[~l[^",	"Terminator",
		"g[p[",	"Trooper",
		"EH[A[",	"Warrior",
/* @BނȂ */			
		"AhCh",	"Android",
		"A[",		"Arrow",
		"A[}[",		"Armor",
		"AbNX",		"Axe",
		"oX",			"Bus",
		"oY[J",		"Bazooka",
		"oJ",		"Balkan",
		"r[",		"Beam",
		"ubg",		"Bullet",
		"Lm",		"Cannon",
		"LA[",	"Carrier",
		"L^s",	"Caterpillar",
		"J^pg",	"Catapult",
		"`F[\x83\\[","ChainSaw",
		"Jb^[",		"Cutter",
		"`bp[",	"Chopper",
		"TC{[O",	"Cyborg",
		"_Ch",	"Diamond",
		"_Ci}Cg",	"Dynamite",
		"GW",		"Engine",
		"tH[N",		"Fork",
		"Kgbg",	"Gauntlet",
		"M`",		"Guillotine",
		"n`bg",	"Hatchet",
		"wbg",	"Helmet",
		"q}mCh",	"Humanoid",
		"Jug",		"Kabuto",
		"J^i",		"Katana",
		"X",		"Lance",
		"}bg",		"Mallet",
 		"}V",		"Machine",
  		"hCo[",	"ScrewDriver",
  		"h",		"Drill",
  		"n}[",		"Hammer",
  		"WFbg",		"Jet",
  		"[U[",		"Laser",
		"`[",	"Launcher",
  		"}VK",	"MachineGun",
		"}OlVE",	"Magnesium",
		"[U[",		"Meser",
  		"~TC",		"Missile",
		"j[h",		"Needle",
		"ACA",		"Iron",
		"iCt",		"Knife",
   		"sXg",		"Piston",
		"vgjE",	"Plutonium",
   		"veN^[",	"Protector",
		"|CY",		"Poison",
		"CU[",		"Razor",
 		"WG^[",	"Radiator",
  		"{o[",	"Revolver",
		"Ct",		"Rifle",
		"{bg",		"Robot",
		"Pbg",		"Rocket",
		"\x83\\[h",		"Sword",
		"VP",	"Shuriken",
		"T[x",		"Saber",
		"V[h",		"Shield",
		"VU[Y",		"Scissors",
		"XN[",	"Screw",
		"XRbv",		"Scoop",
		"Vx",		"Shovel",
		"VbgK",	"ShotGun",
		"Xv[",		"Spoon",
		"XsA[",		"Spear",
		"XeBbN",	"Stick",
		"Tu}",	"Submarine",
		"TuEFC",	"Subway",
  		"[_[",		"Radar",
		"^N",		"Tank",
		"^NV[",		"Taxi",
		"g}z[N",	"Tomahawk",
		"gC",		"Train",
		"^[r",		"Turbine",
		"^[{",		"Turbo",
/* RۂȂ */			
		"I[",		"Aurora",
		"uU[h",	"Blizzard",
		"TCN",	"Cyclone",
		"fBUX^[",	"Disaster",
		"CNvX",	"Eclipse",
		"tHO",		"Fog",
		"wCXg",	"Hailstorm",
		"nP[",	"Hurricane",
		"~[W",	"Mirage",
		"~Xg",		"Mist",
		"NGCN",		"Quake",
		"C{[",	"Rainbow",
		"V}[",		"Shimmer",
		"Xg[",		"Storm",
		"eyXg",	"Tempest",
		"T_[",		"Thunder",
		"gl[h",	"Tornade",
		"gsJ",	"Tropical",
		"gDCX^[",	"Twister",
		"^Ct[",	"Typhoon",
		"EG[u",		"Wave",
		"EBh",		"Wind",
/* ֌W */			
		"t@[Xg",	"First",
		"ZJh",		"Second",
		"T[h",		"Third",
		"nhbh",	"Hundred",
		"TEUg",	"Thousand",
		"~I",		"Million",
		"rI",		"Billion",
		"gI",	"Trillion",				
/* F֌W */			
		"bh",		"Red",
		"u[",		"Blue",
		"CG[",		"Yellow",
		"zCg",		"White",
		"ubN",		"Black",
		"O[",		"Green",
		"p[v",		"Purple",
		"oCIbg",	"Violet",
		"AWXg",	"Amethyst",
		"CfBS",	"Indigo",
		"S[h",		"Gold",
		"Vo[",		"Silver",
		"v`i",		"Platina",
		"^bN",	"Metallic",
/*  */			
		"r[g",		"Beetle",
		"o^tC",	"Butterfly",
		"Z`s[h",	"Centipede",
		"ZPC_",		"Cicada",
		"h[hoO",	"Doodlebug",
		"nj[r[",	"HoneyBee",
		"zbp[",		"Hopper",
		"z[lbg",	"Hornet",
		"fBoO",	"Ladybug",
		"}eBX",	"Mantis",
		"XpC_[",	"Spider",
		"^`",	"Tarantula",
		"Xv",		"Wasp",
/*  */			
		"AogX",	"Albatross",
		"AQ[^[",	"Alligator",
		"AiR_",	"Anaconda",
		"obg",		"Bat",
		"xA",			"Bear",
		"oC\x83\\",	"Bison",
		"obt@[",	"Buffalo",
		"JC}",		"Caiman",
		"Lbg",		"Cat",
		"`[^[",		"Cheetah",
		"`L",		"Chicken",
		"Ru",		"Cobra",
		"Rh",		"Condor",
		"R[e",		"Coyote",
		"NR_C",	"Crocodile",
		"NE",		"Crow",
		"hbO",		"Dog",
		"C[O",		"Eagle",
   		"Gt@g",	"Elephant",
 		"t@R",	"Falcon",
		"t~S",	"Flamingo",
		"Wt",		"Giraffe",
 		"z[N",		"Hawk",
		"q||eX",	"Hippopotamus",
   		"n~Ooh",	"Hummingbird",
   		"nCGi",		"Hyena",
		"WbJ",	"Jackal",
   		"CI",		"Lion",
		"U[h",		"Lizard",
		"Oz[", "LongHorn",
		"}V",		"Mamushi",
   		"}X",		"Mammoth",
   		"}EX",		"Mouse",
		"iC`Q",	"Nightingale",
 		"IXgb`",	"Ostrich",
   		"pT[",		"Panther",
		"yM",		"Penguin",
   		"s[}",		"Puma",
   		"oC\x83\\",	"Python",
   		"rbg",		"Rabbit",
   		"Cx",		"Raven",
   		"V[v",		"Sheep",
   		"Xl[N",		"Snake",
   		"T[yg",	"Serpent",
		"Xp[",		"Sparrow",
		"X[",		"Swallow",		
   		"mTEX",	"Rhinoceros",
   		"^CK[",		"Tiger",
		"g[^X",		"Tortoise",
   		"^[g",		"Turtol",
   		"Et",		"Wolf",
		"[u",		"Bebra",
/* Ebk */			
 		"AiCg",	"Ammonite",
		"Nu",		"Crab",
		"htB",	"Dolphin",
		"C[",		"Eel",
  		"}bJ",	"Mackerel",
		"tbO",		"Frog",
  		"OpX",	"Grampus",
  		"փO",		"Herring",
		"uX^[",	"Lobster",
		"Kh",	"Megalodon",
		"INgpX",	"Octopus",
		"ICX^[",	"Oyster",
 		"T[",		"Salmon",
  		"T[fB",	"Sardine",
  		"XR[sI",	"Scorpion",
  		"V[N",		"Shark",
		"VF", 		"Shell",
  		"Vv",	"Shrimp",
  		"ci",			"Tuna",
  		"zG[",		"Whale",
/* ؁Eʕ */					
		"Abv",		"Apple",
		"o[_bN",	"Burdock",
		"Lbg",	"Carrot",
		"O[v",		"Grape",
		"fBbV",	"Radish",
		"g}g",		"Tomato",
		"pCibv",	"Pineapple",		 
		"|eg",		"Potato",		 
		"pvL",	"Pumpkin",		
		"Xsjb`",	"Spinach",
		"^[bN",	"Turmeric",
/* ȓ{ */			
		"_C~[",	"Daimyo",
		"AVK",		"Ashigaru",
		"JuL",		"Kabuki",
		"jW",		"Ninja",
		"n`[",	"Hancho",
		"TC",		"Samurai",
		"V[O",	"Shogun",
		"eO",		"Tengu",
/* R̊KƂ */			
		"WFl",	"General",
		"Ah~",	"Admiral",
		"}[V",	"Marshal",
		"uKfBA",	"Brigadier",
		"Rh[",	"Commodore",
		"[eig",	"Lieutenant",
		"CW[",	"Major",
		"J[l",		"Colonel",
		"XNAh",	"Squadron",
		"Lve",	"Captain",
		"ItBT[",	"Officer",
		"T[WFg",	"Sergeant",
		"vCx[g",	"Private",		
/* M̊K */			
		"|[",		"Pawn",
		"iCg",		"Night",
		"rVbv",	"Bishop",
		"[N",		"Rook",
		"JCU[",		"Kaiser",
		"Gy[",	"Emperor",
		"LO",		"King",
		"vX",		"Prince",
		"f[N",		"Duke",
		"JEg",		"Count",
		"rXJEg",	"Viscount",
		"}[JX",		"Marquis",
		"o",		"Baron",	
/* `e */			
		"ArVX",	"Ambitious",
		"A[WO",	"Amazing",
		"IbT",		"Awesome",
		"r[eB",	"Beautiful",
		"rbO",		"Big",
		"vCu",		"Brave",
		"uAg",	"Brilliant",
		"`[~O",	"Charming",
		"No[",		"Clever",
		"N[",		"Cool",
		"JCW@X",	"Courageous",
		"N[A",	"Cruel",
		"VjJ",		"Cynical",
		"fWX",	"Dangerous",
		"fP[g",	"Delicate",
		"ftBJg",	"Diffcult",
		"hbht",	"Dreadful",
		"C[W[",		"Easy",
		"CNXg",	"Extreme",
		"GLTCg",	"Exciting",
		"tBAt",	"Fearful",
		"WFg",	"Gentle",
		"OY[",	"Grisly",
		"O[g",		"Great",
		"OA|",		"Guapo",		
		"nT",		"Handsome",
		"qCbN",	"Heroic",
		"IlXg",		"Honest",
		"nu",		"Humble",
		"nO[",	"Hungry",
		"Ce",		"Intelligent",
		"ACj[",	"Irony",
		"C}Wi[",	"Imaginary",		
		"C|Vu",	"Impossible",		
		"AC\x83\\Cg","Isolate",		
		"bL[",		"Lucky",
		"}WFXeN",	"Majestic",
		"}b`",		"Macho",
		"}[xX",	"Marvelous",
		"~[u",	"Miserable",
		"}XL[",	"Muscular",
		"[^",		"Motal",
		"~XeAX",	"Mysterious",
		"m[u",		"Noble",
		"yCVFg",	"Patient",
		"tBWJ",	"Physical",
		"tFmi",	"Phenomenal",
		"pt",		"Powerful",
		"vt@h",	"Profound",
		"NCbN",		"Quick",
        "}`bN",	"Romantic",
        "I[fBi",	"Ordinarlly",
		"A",		"Real",
		"bNX",	"Reckless",
		"XL[",		"Risky",
		"X}[g",		"Smart",
		"XgNg",	"Strict",
		"X[p[",		"Super",
		"XyV",	"Special",
		"XgO",	"Strong",
		"X^{[",	"Stubborn",
		"TvCY",	"Surprise",
		"XC[g",		"Sweet",
		"I[eBg",	"Ultimate",
		"Eg",		"Ultra",
		"AO[",		"Ugly",
		"g[^",		"Total",
		"^t",			"Tough",
		"Ch[",	"Wildly",
/* ۖ */					
		"r[t",		"Belief",
		"NCVX",	"Crisis",
		"GtH[g",	"Effort",
		"fXeBj[",	"Destiny",
		"h[",		"Dream",
		"tFCg",		"Fate",
		"tH[`",	"Fortune",
		"z[v",		"Hope",
		"z[",		"Horror",
		"WXeBX",	"Justice",
		"~bV",	"Mission",
		"~N",		"Miracle",
		"pbV",	"Passion",
		"pjbN",		"Panic",
		"s[X",		"Peace",
		"vCh",		"Pride",
		"vXyNg",	"Prospect",
		"v~X",		"Promise",
		"XyNg",	"Respect",
		"VbN",		"Shock",
		"\x83\\E",		"Soul",
		"TNZX",		"Success",
		"Xsbg",	"Spirit",
		"gu",		"Trouble",
		"gXg",		"Trust",
		"rNg[",	"Victory",		
		"EBbV",	"Wish",
		"_[",		"Wonder",
/* pnOl */
		"A[T[",		"Arthur",
		"A[lXg",	"Ernest",
		"A[mh",	"Arnold",
		"ACUbN",	"Isaac",
		"A_",		"Adam",
		"A",		"Alan",
		"AB",	"Alvin",
		"Ao[g",	"Albert",
		"Atbh",	"Alfred ",
		"ALT_",	"Alexander",
		"A\x83\\j[",	"Anthony",
		"AfB",		"Andy",
		"Ah[",	"Andrew",
		"CA",		"Ian",
		"BN^[",	"Victor",
		"BZg",	"Vincent",
		"EHX",		"Wallace",
		"GCun",	"Abraham",
		"Ghh",	"Edmund",
		"Gh[h",	"Edward",
		"G}jG",	"Emanuel",
		"GbN",		"Eric",
		"G}[",		"Elmer",
		"I[EF",	"Owen",
		"IXJ[",		"Oscar",
		"Ibg[",		"Otto",
		"Io[",		"Oliver",
		"J[`X",		"Curtis",
		"J[",		"Carl",
		"JTh",	"Cassandra",
		"KuG",	"Gabriel",
		"JVAX",		"Cassius",
		"L",	"Cameron",
		"Lo[g",	"Gilbert",
		"NFeC",	"Quentin",
		"N[N",		"Clark",
		"NCh",		"Clyde",
		"OS[",	"Gregory",
		"O",		"Glenn",
		"Pr",		"Kevin",
		"S[h",		"Gordon",
		"R[lAX",	"Cornelius",
		"Rbh",	"Conrad",
		"TC",		"Simon",
		"T",			"Sam",
   		"W[W",		"George",
   		"W",		"John",
		"WFCN",		"Jake",
		"WFt",		"Jeff",
		"WF[",		"Jerry",
		"W",			"Jim",
		"WN\x83\\",	"Jackson",
		"WXeB",	"Justin",
		"WXp[",	"Jasper",
		"WbN",		"Jack",
		"WbL[",	"Jackie",
		"WAX",	"Julius",
		"WA",	"Julian",
		"WfB[",	"Jody",
		"WiT",	"Jonathan",
		"Wj[",		"Johnny",
		"XRbg",		"Scott",
		"X`A[g",	"Stewart",
		"XeB[",	"Steve",
		"eIhA",		"Theodore",
		"ZhbN",	"Cedric",
		"_J",		"Duncan",
		"`[[",	"Charly",
		"_jG",		"Daniel",
		"fB[",		"Dean",
		"eBV[",	"Timothy",
		"frbg",		"David",
		"ebh",		"Ted",
		"efB[",		"Teddy",
		"fjX",		"Dennis",
		"e[",		"Terry",
		"fN",		"Derek",
		"hDGC",	"Dwayne",
		"hDCg",	"Dwight",
		"g[}X",		"Thomas",
		"hih",		"Donald",
		"j[",		"Neal",
		"jRX",		"Nicholas",
		"m[}",		"Norman",
		"o[g",		"Bert",
		"o[i[h",	"Bernard",
		"n[o[g",	"Herbert",
		"nEG",		"Howell",
		"pgbN",	"Patrick",
		"n~g",	"Hamilton",
		"nh",		"Harold",
		"n[h",		"Howard",
		"njo",	"Hannibal",
		"nt[",	"Humphry",
		"s[^[",		"Peter",
   		"r",			"Bill",
		"tBbv",	"Philip",
		"tFbNX",	"Felix",
		"uCA",	"Brian",
		"tN",		"Frank",
		"u[X",		"Bruce",
		"tfB",		"Freddy",
		"wN^[",		"Hector",
		"xW~",	"Benjamin",
		"z[}[",		"Homer",
		"{X",		"Boris",
		"}[N",		"Mark",
		"}[eB",	"Martin",
		"}CP",		"Michael",
		"}CN",		"Mike",
		"}V[",		"Matthew",
		"}bNX",		"Max",
		"~bL[",		"Micky",
		"[K",		"Morgan",
		"X",		"Maurice",
		"[W",		"Eugene",
		"A",		"Urian",
		"CiX",		"Linus",
		"bZ",		"Russel",
		"t",		"Ralph",
		"bN",		"Rick",
		"`[h",	"Richard",
		"CX",		"Lewis",
		"[N",		"Luke",
		"[T[",		"Luther",
		"^[",		"Luther",
		"ht",		"Rudolph",
		"C",			"Ray",
		"Ch",	"Raymond",
		"Iih",	"Leonard ",
		"I",		"Leon",
		"X^[",		"Lester",
		"X[",		"Leslie",
		"bNX",		"Rex", 
		"C",			"Roy", 
		"[h",	"Roland",
		"[X",	"Laurence",
		"W[",		"Roger",
		"ih",		"Ronald",
		"o[g",		"Robert",
/* XyCnOl */
		"Axg",	"Alberto",
		"Anh",	"Alejandro",
		"AtH\x83\\","Alfonso",
		"AgjI",	"Antonio",
		"A}h",	"Armando",
		"AEOXg",	"Augusto",
		"xih",	"Bernardo",
		"u[m",		"Bruno",
		"KXp",		"Gaspar",
		"JX",		"Carlos",
		"NEfBI",	"Claudio",
		"Ne",	"Clemente",
		"Ghh",	"Edmundo",
		"G~I",		"Emilio",
		"GlXg",	"Ernesto",
		"tFih",	"Fernando",
		"tVXR",	"Francisco",
		"tfR",	"Frederico",
		"I|h",	"Leopoldo",
		"zw",		"Jorge",
   		"zZ",			"Jose",
		"wh",		"Gerardo",
		"qxg",	"Gilberto",	
		"Ah",		"Aroldo",
		"GP",		"Enrique",
		"fBGS",		"Diego",
		"tI",		"Julio",		
		"\x83\\",	"Lorenzo",
		"}eI",		"Mateo",
		"}EVI",	"Mauricio",
		"~Q",		"Miguel",
		"pu",		"Pablo",
		"yh",		"Pedro",
		"Jh",		"Ricardo",
		"xg",		"Roberto",
		"hS",		"Rodrigo",
		"GXeo",	"Esteban",
/* hCcnOl */
		"A}fEX",	"Amadeus",
		"Ag",		"Anton",
		"A}g",	"Armand",
		"xng",	"Bernhard",
		"J[",		"Karl",
		"fB[gq",	"Diedrich",
		"G[q",		"Erich",
		"GXg",	"Ernst",
		"ICQ",		"Eugen",
		"tc",		"Franz",
		"t[hq",	"Friedrich",
		"QIQ",		"George",
		"Qng",	"Gerhart",
		"Mxg",	"Gilbert",			
		"OSEX",	"Gregorius",
		"OX^t",		"Gustav",
		"nCq",	"Heinrich",
		"w}",		"Hermann",
		"nX",		"Hans",
		"[c",	"Lorenz",
		"[gBq",	"Ludwig",
		"}eEX",		"Matheus",
		"[bc",	"Moriz",
		"~nG",		"Michael",
		"NEX",		"Klaus",
		"Ibg[",		"Otto",
		"ht",		"Rudolf",
		"W[Ntg",	"Siegfried",
		"W[Ng",	"Siegmund",
		"eIh[",	"Theodor",
		"fB[gq",	"Dietrich",
		"@^[",	"Walter",
		"Bw",	"Wilhelm",
/* {l */				
		"C`[",		"Ichiro",	
		"}iu",		"Manabu",	
		"}Tg",		"Masato",	
		"}T",		"Masaru",	
		"cg",		"Tsutomu",	
		"IT",		"Osamu",	
		"XX",		"Susumu",	
		"^J",		"Yutaka",	
		"CT",		"Isamu",	
		"AL",		"Akira",	
		"}",		"Mamoru",	
		"~c",		"Mitsuru",	
		"^PV",		"Takeshi",	
		"qV",		"Hiroshi",	
		"`J",		"Chikara",	
		"VQ",		"Shigeru",	
		"W[",		"Joe",	
		"gI",		"Tohru",	
		"JI",		"Kaoru",	
		"JY",			"Kazu",	
		"^N~",		"Takumi",	
		"~cO",		"Mitsugu",	
		"WE",		"Jiro",	
		"Tg",		"Satoru",	
		"^c",		"Tamotsu",	
		"}TV",		"Masashi",	
		"^_V",		"Tadashi",	
		"qgV",		"Hitoshi",	
		"Vmu",		"Shinobu",	
		"^N",		"Takuya",	
		"AcV",		"Astsushi",	
		"iIg",		"Naoto",	
		"cJT",		"Tsukasa",	
		"~m",		"Minoru",	
		"}Rg",		"Makoto",	
		"PCW",		"Keiji",
/*@tbJ[񂩂̐E(AWAn?) */	
		"hVN",		"DongSig",
		"hS",		"DongGong",
		"W",	"YongZhong",
		"Wv",	"ZhanYop",
		"Ci",		"YilNam",
		"\x83\\`",	"SonChor",
		"nWF",		"Hanje",
		"X",		"YongSu",
		"qW",	"HyoJing",
		"WO",	"JungGung",
		"tW",		"FunJing",
		"s",		"YongPil",
		"~h",		"MungDo",
		"ip[|",	"Naparpon",
		"ip ",		"Napa",
		"y",			"Lupe",
		"CVg",		"Yishirto",
		"W}",		"Joma",
		"KIOC",	"Gaogray",
		"o[ix",		"Barnabe",
		"``C",	"Chachay",
		"xNbN",	"Bergreg",
		"[Ti",	"Yosanang",
		"bN^C",	"Yokutay",
		"T}",		"Saman",
		"WF[",		"Jerry",
		"ZTN",		"Sensaku",
		"JITC",		"Kaosai",
		"JIR[",		"Kaoko",
		"v[",		"Purn",
		"Z[\x83\\[",	"SeanSo",
		"T_E",		"Sadaw",
		"}R",		"Marcom",
		"p[",	"Palinya"
	};
	
	strcpy(nickname_jp, nicknames[c*2]);
	strcpy(nickname_en, nicknames[c*2 + 1]);
}

void BoxerHandler::SetFamilyNameJapan(int c) {
	static char *familynames[] = { 
		"ł",		"Player",
/* {n */
		"c",		"Aida",
		"", 	"Aihara",
		"",		"Aoki",
		"Ԗ",		"Akagi",
		"Hc",		"Akita",
		"\x8f\\",	"Igarashi",
		"rc",		"Ikeda",
		"Γc",		"Ishida",
		"",		"Inoue",
		"",		"Iwasaki",
		"c",		"Ueda",
		"c",		"Uchida",
		"C",		"Utsumi",
		"~c",		"Umeda",
		"]",		"Eguchi",
		"|{",		"Enomoto",
		"",		"Endo",
		"",		"Ohishi",
		"剺",		"Ohshita",
		"|",		"Ohtake",
		"吼",		"Ohnishi",
		"",		"Okazaki",
		"",		"Ogawa",
		"{",		"Okimoto",
		"c",		"Okuda",
		"",		"Ozawa",
		"",		"Kagawa",
		"ЎR",		"Katayama",
		"c",		"Kadota",
		"q",		"Kaneko",
		"T",		"Kamei",
		"",		"Kawaguchi",
		"͑",		"Kwamura",
		"_c",		"Kanda",
		"ؓc",		"Kida",
		"k",		"Kitagawa",
		"؉",		"Kinoshita",
		"ؑ",		"Kimura",
		"",	"Kusakabe",
		"",		"Kuniyasu",
		"v",		"Kubo",
		"FJ",		"Kumagai",
		"I",		"Kurihara",
		"c",		"Kuroda",
		"K",		"Kuwabara",
		"É",		"Koga",
		"J",		"Kotani",
		"",		"Kobayashi",
		"",		"Komatsu",
		"",		"Saeki",
		"ē",		"Saito",
		"",		"Sakai",
		"{",		"Sakamoto",
		"",		"Sako",
		"X",	"Sasaki",
		"c",		"Sakuta",
		"",		"Sato",
		"Vc",		"Sawada",
		"J",		"Shiotani",
		"",		"Shishido",
		"",		"Shima",
		"c",		"Shimoda",
		"VJ",		"Shintani",
		"",		"Kan",
		"Y",		"Sugiura",
		"",		"Suzuki",
		"Zg",		"Sumiyoshi",
		"",		"Segwa",
		"]",		"Soga",
		"",		"Sora",
		"c",		"Tao",
		"",		"Takai",
		"J",	"Tagaya",
		"{",		"Takimoto",
		"c",		"Takeda",
		"",		"Tachibana",
		"c",		"Tanaka",
		"J",		"Tanigawa",
		"c",		"Tahara",
		"c",		"Tamura",
		"t",		"Chiba",
		"Ð",		"Tsugawa",
		"Җ{",		"Tsuzimoto",
		"ߓc",		"Tsuruta",
		"o",		"Deguchi",
		"y",		"Doi",
		"i",		"Tokunaga",
		"L",		"Toyoshima",
		"",		"Torii",
		"",		"Nakagawa",
		"",		"Nakazima",
		"ic",		"Nagata",
		"{",		"Nishimoto",
		"c",		"Noda",
		"",		"Hattori",
		"lc",		"Hamada",
		"",		"Hayashi",
		"",		"Hara",
		"Y",		"Hiura",
		"",		"Hiraga",
		"L",		"Hirose",
		"",		"Fukushima",
		"",		"Fujii",
		"Ð",		"Furukawa",
		"c",		"Masuda",
		"x",		"Hori",
		"Oc",		"Maeda",
		"Y",		"Matsuura",
		"{",		"Matsumoto",
		"O",		"Miki",
		"",		"Minami",
		"{",		"Miyazaki",
		"{{",		"Miyamoto",
		"",		"Mutai",
		"",		"Murakami",
		"Xc",		"Morita",
		"",		"Yano",
		"R",		"Yamaoka",
		"R",		"Yamazaki",
		"R",		"Yamashita",
		"R{",		"Yamamoto",
		"R",		"Yokoyama",
		"g",		"Yoshii",
		"g{",		"Yoshimoto",
		"ac",		"Wada",
		"n",		"Watanabe",
		"",		"Yagi",
		"n",		"Baba"
	};

	strcpy(familyname_jp, familynames[c*2]);
	strcpy(familyname_en, familynames[c*2 + 1]);
}

void BoxerHandler::SetFamilyNameForeign(int c) {
	static char *familynames[] = {
		"ł",			"Player", 
/* pꕗ */
		"A{bg",		"Abbot", 
		"AbJ[\x83\\","Ackerson",
		"ANCh",	"Ackroyd",
		"A_X",		"Adams",
		"IfBX",	"Aldis",
		"GCY",		"Ames",
		"A_[\x83\\","Anderson",
		"Ah[Y",	"Andrewes",
		"A[`[",	"Archer",
		"A[`{h",	"Archibald",
		"AgLY",	"Atkins",
		"x[R",		"Bacon",
		"xCJ[",		"Baker",
		"oNX",		"Banks",
		"o[o[",		"Barber",
		"o[Y",		"Barnes",
		"oNX^[",	"Baxter",
		"r[",		"Bean",
		"r[g",		"Beaton",
		"{[g",	"Beaumont",
		"xPbg",		"Becket",
		"xbJ",		"Beckam",
		"xT",		"Bentham",
		"o[}",		"Berman",
		"o[i[Y",	"Berners",
		"BX",		"Binns",
		"o[j[",		"Birnie",
		"u[",		"Bloom",
		"{h",		"Bond",
		"{[",		"Bone",
		"{XEF",	"Boswell",
		"{CX",		"Boyce",
		"{Ch",		"Boyd",
		"{C",		"Boyle",
		"ui",		"Brenan",
		"uCY",		"Brise",
		"ubN",		"Brooke",
		"obN[",	"Buckley",
		"oMY",		"Buggins",
		"o[Y",		"Burns",
		"ubV",		"Bush",
		"RhEF",	"Caldwell",
		"Ln",	"Callaghan",
		"Lx",	"Campbell",
		"J[^[",		"Carter",
		"`[`",	"Churchill",
		"NCg",	"Clayton",
		"Ng",	"Clinton",
		"R[G",		"Cohen",
		"RY",		"Collins",
		"R[}",	"Colman",
		"REF",	"Colwell",
		"Rl[",		"Connery",
		"N[K",		"Coogan",
		"R[}bN",	"Cormack",
		"R[EF",	"Cornwell",
		"NT[h",	"Coulthard",
		"JYY",		"Cousins",
		"RbNX",		"Cox",
		"NtH[h",	"Crawford",
		"NXr[",	"Crosby",
		"JjOn",	"Cuningham",
		"J[eBX",	"Curtis",
		"_g",		"Dalton",
		"_[r[",		"Darby",
		"_x|[g",	"Davenport",
		"f[BX",	"Davies",
		"h[\x83\\",	"Dawson",
		"fbJ[",		"Decker",
		"fW[",	"Dellinger",
		"fBN\x83\\",	"Dixon",
		"_OX",		"Douglas",
		"hC",		"Doyle",
		"hh",	"Drummond",
		"_C\x83\\",	"Dyson",
		"GX",		"Ellis",
		"GX"	,	"Else",
		"GN\x83\\",	"Erikson",
		"A[XL",	"Erskine",
		"GoX",		"Evans",
		"tFA}",	"Fairman",
		"tH[Ni[",	"Falkner",
		"t@[}[",	"Farmer",
		"tFAzNX",	"Fayrfax",
		"tFg",	"Felton",
		"t@[K[\x83\\","Ferguson",
		"tBbV[",	"Fisher",
		"t~O",	"Fleming",
		"tb`[",	"Fletcher",
		"tH[uX",	"Forbes",
		"tH[h",		"Ford",
		"tHX^[",	"Forester",
		"tH[TCX",	"Forsyth",
		"tHX^[",	"Foster",
		"t@l",		"Funnel",
		"S[g",	"Galton",
		"K[hi[",	"Gardner",
		"K[h",	"Garland",
		"K[\x83\\",	"Carson",
		"M[\x83\\",	"Geeson",
		"Mu\x83\\",	"Gibson",
		"OhXg",	"Gladstone",
		"On",		"Graham",
		"Og",		"Grant",
		"OtBX",	"Griffith",
		"MlX",		"Guiness",
		"nEF",	"Halliwell",
		"nvV[",	"Hamphshire",
		"nZ",		"Hansson",
		"z[LO",	"Hawking",
		"wC[h",	"Hayward",
		"w_[\x83\\","Henderson",
		"wjO",		"Henning",
		"wbvo[",	"Hepburn",
		"q[Cbg",	"Hewit",
		"wCEbh",	"Heywood",
		"qg",		"Hillton",
		"zt}",		"Hoffman",
		"zvLX",	"Hopkins",
		"nEX}",	"Houseman",
		"nh\x83\\",	"Hudson",
		"q[Y",		"Hughes",
		"nCAbg",	"Hyat",
		"CO",	"Ingram",
		"A[oC",	"Irvine",
		"WFt@\x83\\","Jefferson",
		"WFLX",	"Jenkins",
		"W[Y",	"Jones",
		"Ph[",	"Kendall",
		"PlfB",		"Kennedy",
		"Pv[",		"Kepler",
		"Lo[",	"Kimbery",
		"LPCh",	"Kincaid",
		"LOX[",	"Kingsley",
		"LOXg",	"Kingstone",
		"LbVW",	"Kissinger",
		"m[h",	"Knowland",
		"mbNX"	,	"Knox",
		"Ng[",		"Kroto",
		"o[g",	"Lambert",
		"[\x83\\",	"Lawson",
		"[",			"Leigh",
		"[C",		"Lindsay",
		"lJ[",		"Lineker",
		"vg",		"Lipton",
		"X^[",		"Liter",
		"Ch",		"Lloyd",
		"bNn[g",	"Lockhart",
		"[EF",	"Lowell",
		"`",		"Lynch",
		"bg",		"Lytton",
		"}Nhih",	"MacDonald",
		"}bPC",		"Mackey",
		"}bPW[",	"Mackenzie",
		"}N[",	"MacLaine",
  		"}hbN",		"Maddock",
		"}g",		"Mantle",
		"}NXEF",	"Maxwell",
		"}NxC",	"McBein",
		"~Y",		"Mills",
		"~g",		"Milton",
		"[",		"Monroe",
		"S[",	"Montgomerie",
		"E",		"Morrow",
		"[X",		"Morse",
		"X",			"Moss",
		"[g",		"Morton",
		"_[",		"Moulder",
		"}[hbN",	"Murdock",
		"}[tB[",	"Murphy",
		"}C[Y",	"Myers",
		"j[\x83\\",	"Neeson",
		"l\x83\\",	"Nelson",
		"j[g",	"Newton",
		"m[tH[N",	"Norfolk",
		"m[g",		"Norton",
		"IuCG",	"O'Brien",
		"IRi[",		"O'Connor",
		"Ihl",		"O'Donnell",
		"Ij[",		"O'Neill",
		"I[h}",	"Oldman",
		"I[EF",	"Orwell",
		"IY{[",	"Osborn",
		"I[eBX",	"Otis",
		"I[EF",	"Owen",
		"p[J[",		"Parker",
		"p[\x83\\",	"Parson",
		"sbg}",	"Pitman",
		"pEG",		"Powell",
		"NB",		"Quin",
		"b`[",		"Ritchie",
		"o[c",		"Robarts",
		"r\x83\\",	"Robinson",
		"[O",		"Roeg",
		"X",			"Roth",
		"[X",		"Ruth",
		"[O",	"Rowling",
		"[xX",	"Rubens",
		"h[",	"Rundall",
		"bZ",		"Russel",
		"TW[",	"Salinger",
		"VA[Y",		"Sears",
		"V[g",		"Seaton",
		"ZK[",		"Segall",
		"Z[Y",		"Sellers",
		"V[}",	"Shaman",
		"Vv\x83\\",	"Simpson",
		"VX[",		"Sisley",
		"X~X",		"Smith",
		"\x83\\[",		"Soane",
		"TU[h",	"Sotherland",
		"XyT[",	"Spencer",
		"Xg[NX",	"Stokes",
		"XgK[",	"Stringer",
		"^[i[",		"Tanner",
		"eC[",		"Taylor",
		"etH[h",	"Telford",
		"ev",		"Temple",
		"ej\x83\\",	"Tennyson",
		"Tb`[",	"Thatcher",
		"gv\x83\\",	"Thompson",
		"\x83\\[g",	"Thornton",
		"^E[g",	"Townsend",
		"g@[X",	"Travers",
  		"g}[",		"Trimmer",
		"g[}",	"Truman",
		"^bJ[",		"Tucker",
		"^C[",		"Tyler",
		"^C\x83\\",	"Tyson",
		"A[V",	"Ursula",
		"@bZ",	"Vassel",
		"BbJ[",	"Vicker",
		"EH[J[",	"Walker",
		"EHX",		"Wallace",
		"EHV",	"Walsh",
		"[i[",		"Warner",
		"Vg",	"Washington",
		"g\x83\\",	"Watson",
		"bg",		"Watt",
		"EFuX^[",	"Webster",
		"Co[O",	"Weinberg",
		"EFY",		"Wells",
 		"EFXg",		"West",
		"EBX[",	"Whistler",
		"EBr[",	"Wilbye",
		"C_[",	"Wilder",
		"EB^[Y",	"Winters",
		"EbhQCg",	"Woodgate",
/* hCcꕗ */
		"Ah[",		"Adler",
		"At@O",	"Anfang",
		"AEA[",		"Auer",
		"obn",		"Bach",
		"o[e",		"Barten",
		"oEA[",		"Bauer",
		"oE}",		"Baumann",
		"rfog",	"Bindewald",
		"{[",		"Bohme",
		"ug",		"Brandt",
		"u[",		"Brehme",
		"_CX[",	"Deisler",
		"f[jbc",	"Denitz",
		"GbJ[g",	"Eckert",
		"ACq}",	"Eichmann",
		"tBP",		"Finke",
		"tCg",	"Freund",
		"Qng",	"Gerhard",
		"OCbq",	"Greilich",
		"w[Q",		"Hagen",
		"n[l",		"Hahne",
		"ng}",	"Hartmann",
		"nCfbK[",	"Heidegger",
		"nCbq",	"Heinrich",
		"wP",		"Henkel",
		"wcH[N",	"Herzog",
		"wbZ",		"Hesse",
		"Z",		"Jansen",
		"J[",		"Kahn",
		"Jc",		"Kaltz",
		"Jp",		"Kampa",
		"Jg",		"Kant",
		"P[",		"Kehl",
		"P[",		"Keller",
		"P",		"Kern",
		"PX[",		"Kessler",
		"Lq",		"Kirch",
		"NN",		"Kling",
		"Rbz",		"Koch",
		"NCc",		"Kreuz",
		"Nc",		"Kurz",
		"[}",		"Lehmann",
		"Cvjbc",	"Leibniz",
		"f}",	"Lindemann",
		"P",		"Merkel",
		"~[",		"Muller",
		"Cq",		"Reich",
		"q^[",		"Richter",
		"Vc",		"Sholz",
		"V~bg",	"Schmidt",
		"ViC_[",	"Schneider",
		"V[_[",	"Schroeder",
		"Vc",		"Schulz",
		"V}bn[",	"Schumacher",
		"Vc",	"Schwarz",
		"UCf",		"Seidel",
		"]}[",		"Sommer",
		"V^P",	"Starke",
		"VgEX",	"Strauss",
		"^Cq}",	"Teichmann",
		"Ebq",	"Ulrich",
		"EFo[",		"Weber",
		"F_[X",	"Wenders",
		"c@[x",	"Zabel",
		"cBbN[",	"Zickler",
/* C^Aꕗ */
		"Ao[j",	"Albani",
		"AxeB",	"Alberiti",
		"obW",		"Baggio",
		"ofB[j",	"Bandini",
		"{[j",	"Bologna",
		"JrAJ",	"Cabianca",
		"J[j",	"Camerini",
		"J{[j",	"Carboni",
		"h~jb`",	"Dominici",
		"hihj",		"Donadoni",
		"t@j[j",	"Fagnini",
		"tF[",	"Ferrari",
		"KC",		"Galilei",
		"Kr[m",	"Gambino",
		"WF~",		"Germi",
		"Wr[j",	"Giombini",
		"qui[",	"Hubner",
		"Ph[",	"Kendall",
		"[j",		"Larini",
		"I[l",		"Leone",
		"[",		"Loren",
		"}fB[j",	"Maldini",
		"}s[M",	"Maldini",
		"}V[i",		"Masina",
		"fB[j",	"Mondini",
		"bcB",		"Muzzi",
		"ij[j",	"Nannini",
		"IbL[j",	"Occhini",
		"pKj[j",	"Paganini",
		"p][j",	"Pasolini",
		"y[]",		"Peluso",
		"sb`I[j",	"Piccioni",
		"vbcA[",	"Putzer",
		"NAI",		"Quario",
		"ofB",	"Ranbaldi",
		"bWF[",	"Reggeri",
		"b",		"Rollero",
		"XeBP",	"Rustichelli",
		"TG",		"Salieri",
		"Tgph",	"Santopadre",
		"Vjb",	"Signorelli",
		"^fb",	"Tardelli",
		"ebT",		"Tessari",
		"g}[W",	"Tommasi",
		"FfB",	"Verdi",
		"UlbeB",	"Zanetti",
		"YbR[",	"Zuccoli",
/* tXꕗ */
		"AW[j",	"Adjani",
		"ABi",	"Alvina",
		"AX",		"Amoros",
		"AjVi",		"Anissina",
		"A_",		"Ardant",
		"AXJh",	"Ascaride",
		"AgL",		"Atkine",
		"oUbN",	"Balzac",
		"xbP",		"Becker",
		"rmV",		"Binoche",
		"{b\x83\\",	"Boisson",
		"ubTX",	"Brassens",
		"Lf",	"Candeloro",
		"N}eB",	"Clementi",
		"RFV",	"Conversi",
		"Nb\x83\\",	"Cresson",
		"_",		"Darlan",
		"hjN[",	"Denicourt",
		"fBI[",	"Dior",
		"hP[",	"Drucker",
		"Ag",	"Entremont",
		"t@WA",	"Farrugia",
		"tN[",	"Frankeur",
		"QYu[",	"Gainsbourg",
		"S[",		"Ghosn",
		"S_[",		"Godard",
		"OWF",	"Grange",
		"Mj[",	"Guignard",
		"IKh",		"Holgado",
		"Wm[",		"Jannot",
		"JtH",	"Kalfon",
		"NWbN",	"Krawczyk",
		"OWF",	"Lagrange",
		"uV",	"Lebranchu",
		"bL[j",	"Luchini",
		"}uN",	"Malbranque",
		"_",		"Merenda",
		"^j[",	"Montagny",
		"lOI",		"Negrao",
		"pXJ",		"Pascal",
		"y[",		"Perrault",
		"sG",		"Pierrot",
		"|gt",		"Politoff",
		"Lj[",	"Quignard",
		"m[",		"Renaud",
		"x[",		"Robert",
		"\x83\\[",		"Rousseau",
		"Tj",		"Sagnol",
		"\x83\\jG",	"Saulnier",
		"Z",		"Sevran",
		"XgCt",	"Streiff",
		"eB{[",		"Thibaud",
		"g][",	"Tresor",
		"FW",	"Vergez",
		"BZg",	"Vincent",
		"[eY[",	"Waterhouse",
		"]",			"Zola",
/* AWA? */
		"AC",		"Ai",
		"AI",		"Ao",
		"oC",		"Bai",
		"xC",		"Bei",
		"VF",	"Chen",
		"t@",		"Fa",
	   	"hD",		"Du",
		"t@",		"Fa",
		"t@",	"Fang",
		"tF",	"Feng",
		"KI",		"Gao",
		"S",		"Gong",
		"O@",	"Guan",
		"t",		"He",
		"",		"Li",
		"I",		"Luo",
		"A",	"Luan",
		"L",		"Kim",
		"}",		"Ma",
		"C",		"Mei",
		"~",		"Ming",
		"",		"Rong",
		"pN",		"Paku",
		"y",		"Pe",
		"yN",		"Peku",
		"^",		"Tang",
		"gE",		"Tou",
		"",		"Wang",
		"EFC",	"Wei",
		"",		"Yang",
		"C",		"Yi",
		"`F",		"Zhe",
		"`",	"Zhang",
/* tbJ[ɂ鐄E */		
		"[",		"Lie",
		"`C",	"Choi",
		"m",		"No",
		"R",		"Ko",
		"i",		"Nam",
		"`[",	"Cho",
		"J",		"Kan",
		"",		"Yung",
		"Qb\x83\\bg",	"Gesolitt",
		"`ImC",		"Chionoy",	
		"`o",	"Chalvan",
		"QmV",	"Gennorashin",
		"`C",	"Wangchai",
		"rJ|",	"Birakanpo",
		"}f",		"Madera",
		"GXsmT",	"Espinosa",
		"yjT",	"Penarosa",
		"cjJI",	"Sonakao",
		"LOsb`",	"Kingpitch",
		"MNV[",	"Galaxy",
		"VXI[",		"Shisoh",
		"|g",			"Poto",
		"sg[",	"Pingtall",
		"AX",	"Muanslin",
		"VXt@[",	"Shisfer",
		"^`bg",	"Talanchit",
		"W{[",	"Junborn",
		"K{A",		"Ganbore",
		"Gf",		"Herorde"
	}; 

	strcpy(familyname_jp, familynames[c*2]);
	strcpy(familyname_en, familynames[c*2 + 1]);
}
