#include "cgi.h"

CGI::CGI() {
	cgi_socket = NULL;
}

CGI::~CGI() {
}

int CGI::MatchMake(int select, char* cgi_host, char* cgi_url, char* cgi_name, Uint16 cgi_port, char* user_agent) {
	int size;
	if (SDLNet_ResolveHost(&cgi_ip, cgi_host, 80)) {
		emes("CGI::MatchMake -> Can't find cgi server.");
		rmes();
		return SDL_FAILURE;
	}
	smes("CGI::MatchMake -> Find CGI Server");
	shost(cgi_host);

	cgi_socket = SDLNet_TCP_Open(&cgi_ip);
	if (cgi_socket == NULL) {
		emes("CGI::MatchMake -> Can't open cgi socket.");
		ehost(cgi_host);
		rmes();
		return SDL_FAILURE;	
	}

 	sprintf(request, "GET %s?select=%d&name=%s&port=%d&passwd=%s HTTP/1.0\nHost: %s:80\nUser-Agent: %s\n\n",
		cgi_url, select, cgi_name, cgi_port, CGI_PASSWD, cgi_host, user_agent);
#ifdef DEBUG
   	fprintf(stderr, "%s\n", request);
#endif	
	SDLNet_TCP_Send(cgi_socket, request, strlen(request)); 

	size = GetString(cgi_socket, buf, MAX_BUFFER); 
	buf[size] = '\0';
 //   	fprintf(stderr, "%s\n", buf);

	get_string.OpenFrom(buf, size);
	SDLNet_TCP_Close(cgi_socket); 
}

int CGI::Official(char* cgi_host, char* cgi_url, char* cgi_name, Uint16 cgi_port, char* user_agent) {
	int size;
	if (SDLNet_ResolveHost(&cgi_ip, cgi_host, 80)) {
		emes("CGI::Official -> Can't find cgi server.");
		rmes();
		return SDL_FAILURE;
	}
	smes("CGI::Official -> Find CGI Server");
	shost(cgi_host);

	cgi_socket = SDLNet_TCP_Open(&cgi_ip);
	if (cgi_socket == NULL) {
		emes("CGI::Official -> Can't open cgi socket.");
		ehost(cgi_host);
		rmes();
		return SDL_FAILURE;	
	}

 	sprintf(request, "GET %s?name=%s&port=%d&passwd=%s HTTP/1.0\nHost: %s:80\nUser-Agent: %s\n\n",
		cgi_url, cgi_name, cgi_port, CGI_PASSWD, cgi_host, user_agent);
#ifdef DEBUG
   	fprintf(stderr, "%s\n", request);
#endif	
	SDLNet_TCP_Send(cgi_socket, request, strlen(request)); 

	size = GetString(cgi_socket, buf, MAX_BUFFER); 
	buf[size] = '\0';
//  	fprintf(stderr, "%s\n", buf);

	get_string.OpenFrom(buf, size);
	SDLNet_TCP_Close(cgi_socket); 
}


int CGI::Lobby(char* cgi_host, char* cgi_url, char* cgi_command, Uint16 cgi_port, char* user_agent) {
	int size;
	if (SDLNet_ResolveHost(&cgi_ip, cgi_host, 80)) {
		emes("CGI::Lobby -> Can't find cgi server.");
		rmes();
		return SDL_FAILURE;
	}
	smes("CGI::Lobby -> Find CGI Server");
	shost(cgi_host);

	cgi_socket = SDLNet_TCP_Open(&cgi_ip);
	if (cgi_socket == NULL) {
		emes("CGI::Lobby( -> Can't open cgi socket.");
		ehost(cgi_host);
		rmes();
		return SDL_FAILURE;	
	}

 	sprintf(request, "GET %s?&command=%s&port=%d&passwd=%s HTTP/1.0\nHost: %s:80\nUser-Agent: %s\n\n",
		cgi_url, cgi_command, cgi_port, CGI_PASSWD, cgi_host, user_agent);
#ifdef DEBUG
   	fprintf(stderr, "%s\n", request);
#endif
	SDLNet_TCP_Send(cgi_socket, request, strlen(request)); 

	size = GetString(cgi_socket, buf, MAX_BUFFER); 
	buf[size] = '\0';

	get_string.OpenFrom(buf, size);
	SDLNet_TCP_Close(cgi_socket); 
}

int CGI::GetString(TCPsocket &cgi_socket, void *data, int max_size) {
	static int size, get_size, left;
	get_size = 0;
	left = max_size;
	while(left > 0) {
		size = SDLNet_TCP_Recv(cgi_socket, (Uint8 *)data + get_size, left);
		if (size <= 0) {
    		break;
		} 
		get_size+= size;
		left = max_size - get_size;	
	}
	return get_size;
}

int CGI::SetState() {
	int number;
	type = 0;
	while(!get_string.IsLast()) {
		get_string.NextChar(buf);
#ifdef DEBUG
		fprintf(stderr, "%s\n", buf);
#endif
		if (!strcmp(buf, "[Server]")) {
			type = SERVER;
			break;
		}	
		if (!strcmp(buf, "[Client]")) {
			type = CLIENT;
			break;
		}	
		if (!strcmp(buf, "[Quit_Server]")) {
			type = QUIT_SERVER;
			break;
		}	
		if (!strcmp(buf, "[Error]")) {
			return SDL_FAILURE;
		}	      
		if (!strcmp(buf, "[Number]")) {
			number = get_string.NextInt();
			if (number < 0) {
				number = 0;			
			}
			if (number >= MAX_CGI_ROOM) {
				number = MAX_CGI_ROOM - 1;			
			}
		}	
		if (!strcmp(buf, "[Name]")) {
			get_string.NextChar(name[number]);
		}	
		if (!strcmp(buf, "[IP]")) {
			get_string.NextChar(host[number]);
		}	
		if (!strcmp(buf, "[Port]")) {
			port[number] = get_string.NextInt();
		}	
	}
	return type;
}
