#ifndef CGI_H
#define CGI_H

#include "csdl.h"
#include "creader.h"
#include "snet.h"

#define MAX_CGI_ROOM	4
#define CGI_PASSWD		"1234abcd"
#define MAX_BUFFER		4096

class CGI {
public:
	CGI();
	~CGI();
	int MatchMake(int select, char* cgi_host, char* cgi_url, char* cgi_name, Uint16 cgi_port, char* user_agent);
	int Official(char* cgi_host, char* cgi_url, char* cgi_name, Uint16 cgi_port, char* user_agent);
	int Lobby(char* cgi_host, char* cgi_url, char* cgi_command, Uint16 cgi_port, char* user_agent);
	int GetString(TCPsocket &cgi_socket, void *data, int max_size);
	int SetState();
	char *Name(int number) {return name[number];}
	char *Host(int number) {return host[number];}
	Uint16 Port(int number){return port[number];}	
	bool IsServer() const {return (type == SERVER);}
	bool IsClient() const {return (type == CLIENT);}
private :
	TCPsocket cgi_socket;
	IPaddress cgi_ip;
	CReader get_string;
	char request[512], buf[MAX_BUFFER];

	char name[MAX_CGI_ROOM][MAX_LINE_SIZE];
	char host[MAX_CGI_ROOM][MAX_LINE_SIZE];	
	Uint16 port[MAX_CGI_ROOM];
	int type;
};

#endif // CGI_H
