#ifndef CSDL_H
#define CSDL_H

#include<stdio.h>
#include<stdlib.h>
#include<ctype.h>
#include<string.h>
#include<SDL.h>

#define HAVE_OPENGL

#ifdef HAVE_OPENGL //@OpenGL
#include "myglheader.h"
#endif

#define USE_BABEL
//#define USE_SJIS2UNI

#ifdef USE_BABEL
#include "babel/babel.h"
#else
#include "sjis2uni/sjis2uni.h"
#endif

/* e탁bZ[Wp̃}N */
#ifdef DEBUG
#define smes(X) fprintf(stdout, "SUCCESS : " X "\n")
#define sfile(X) fprintf(stdout, "SUCCESS : File Name -> %s \n", X)
#define shost(X) fprintf(stdout, "SUCCESS : Host Name -> %s \n", X)
#else 
#define smes(X)
#define sfile(X)
#define shost(X)
#endif

#define emes(X) fprintf(stderr, "ERROR : " X "\n")
#define efile(X) fprintf(stderr, "ERROR : File Name -> %s \n", X)
#define ehost(X) fprintf(stderr, "ERROR : Host Name -> %s \n", X)
#define wmes(X) fprintf(stderr, "WARNING : " X "\n")
#define wfile(X) fprintf(stderr, "WARNING : File Name -> %s \n", X)
#define whost(X) fprintf(stderr, "WARNING : Host Name -> %s \n", X)
#define wmes2(X1,X2) fprintf(stderr, "WARNING : Rquired Size %d  Set Up Size %dB\n", X1, X2)	 				
#define rmes() fprintf(stderr, "CAUSE : %s \n", SDL_GetError())

#define SDL_SUCCESS 0
#define SDL_FAILURE -1

enum {
	GAME_NOEVENT,
	GAME_EXIT,
	GAME_CONTINUE,
	GAME_EXPOSE,
	GAME_NEXT
};

// ^C}[
class STimer {
public:
	STimer();
	~STimer();
	int Init();
	void Quit();
	bool WasInit();
	Uint32 GetTicks();
	void Delay(Uint32 ms);
	void SetFPS(int input_fps);
	int GetFPS();
	int FPS() const {return fps;}
	Uint32 Wait();
	char *FPSString();
private:
	Uint32 time_now;
	Uint32 time_pre;
	Uint32 delay;
	Uint32 count;	
	Uint32 fpsi;
	int fps;	
	char fps_str[20];
};

// rfI
class SVideo {
public:
	SVideo();
	~SVideo();
	int Init();
	void Quit();
	bool WasInit();
};

// I[fBI
class SAudio {
public:
	SAudio();
	~SAudio();
	int Init();
	void Quit();
	bool WasInit();
};

// Cxg
class SEvent {
public:
	SEvent();
	~SEvent();
	void Init();
	void Clear();
	bool IsNoEvent();
	bool IsContinue();
	bool IsExpose();
	bool IsQuit();
	bool IsNext();
	void Poll();
	void Wait();
	void Select();	
	int KeyDown();	
	int KeyUp();
	int HitKey() {return event.key.keysym.sym;}

	bool IsKeyPressed(int key_number) {
		if (keys[key_number] == SDL_PRESSED) {
			return true;		
		}
		return false;				
	}

	bool IsKeyReleased(int key_number) {
		if (keys[key_number] == SDL_RELEASED) {
			return true;		
		}
		return false;				
	}

	bool IsKeyChanged(int key_number) {
		if (keys[key_number] == keys_pre[key_number]) {
			keys[key_number] = keys_pre[key_number];		
			return true;		
		}
		return false;				
	}

	bool IsKeyDown(int key_number) {
		if (keys_pre[key_number] == SDL_RELEASED &&
			keys[key_number] == SDL_PRESSED) {
			keys[key_number] = SDL_RELEASED;		
			return true;		
		}
		return false;				
	}

	bool IsKeyUp(int key_number) {
		if (keys_pre[key_number] == SDL_PRESSED &&
			keys[key_number] == SDL_RELEASED) {
			keys[key_number] = SDL_PRESSED;		
			return true;		
		}
		return false;				
	}

	void KeyPress(int key_number) {
		keys_pre[key_number] = SDL_PRESSED;		
		keys[key_number] = SDL_PRESSED;		
	}

	void KeyRelease(int key_number) {
		keys_pre[key_number] = SDL_RELEASED;		
		keys[key_number] = SDL_RELEASED;		
	}

	int KeyCount(int key_number) {
		return keys_count[key_number];
	}

	void KeyCountClear(int key_number) {
		keys_count[key_number] = 0;
	}
	
	int MouseDown();	
	int MouseUp();
	bool IsMouse1Pressed() {
		return (bool)(buttons & SDL_BUTTON(1));	
	}
	bool IsMouse2Pressed() {
		return (bool)(buttons & SDL_BUTTON(2) || wheel);	
	}
	bool IsMouse3Pressed() {
		return (bool)(buttons & SDL_BUTTON(3));	
	}
	bool IsMouse1Released() {return !IsMouse1Pressed();}
	bool IsMouse2Released() {return !IsMouse2Pressed();}
	bool IsMouse3Released() {return !IsMouse3Pressed();}
	bool IsMouseChanged(int number) {
		if (buttons & SDL_BUTTON(number) != buttons_pre & SDL_BUTTON(number)) {
			if (buttons_pre & SDL_BUTTON(number)) {
				buttons |= SDL_BUTTON(number);
			} else {
				buttons &= ~SDL_BUTTON(number);			
			}
		 	return true;		
		}
		return false;
	}
	bool IsMouse1Changed() {return IsMouseChanged(1);}
	bool IsMouse2Changed() {return IsMouseChanged(2);}
	bool IsMouse3Changed() {return IsMouseChanged(3);}

	bool IsMouseDown(int number) {
		if ((buttons & SDL_BUTTON(number)) && !(buttons_pre & SDL_BUTTON(number))) {
			buttons &= ~SDL_BUTTON(number);			
		 	return true;		
		}
		return false;
	}
	bool IsAnyMouseDown() {
		int i;
		for (i = 0; i < 3; i++) {
			if (IsMouseDown(i)) {
				return true;			
			}		
		}	
		return false;
	}
	bool IsMouse1Down() {return IsMouseDown(1);}
	bool IsMouse2Down() {return IsMouseDown(2);}
	bool IsMouse3Down() {return IsMouseDown(3);}

	bool IsMouseUp(int number) {
		if (!(buttons & SDL_BUTTON(number)) && (buttons_pre & SDL_BUTTON(number))) {
			buttons |= SDL_BUTTON(number);			
		 	return true;		
		}
		return false;
	}
	bool IsAnyMouseUp() {
		int i;
		for (i = 0; i < 3; i++) {
			if (IsMouseUp(i)) {
				return true;			
			}		
		}	
		return false;
	}
	bool IsMouse1Up() {return IsMouseUp(1);}
	bool IsMouse2Up() {return IsMouseUp(2);}
	bool IsMouse3Up() {return IsMouseUp(3);}

	int MouseMotion();
	int MouseX() const {return x;}
	int MouseY() const {return y;}

private:
//	SDL_Surface *video_surface;
//	int width, height;
	SDL_Event event;
	int state;

	Uint8 *keys_state;
	int keys_number;
	int *keys;
	int *keys_pre;
	int *keys_count;

	Uint8 buttons;
	Uint8 buttons_pre;
	Uint8 wheel;
	int x, y;
	int xo, yo;
	int xrel, yrel;
};

void SetMinMax(int *value, int minimum, int maximum);
int GetSDLKey(char *key_name, int default_key);

#endif // CSDL_H
