#ifndef GAME_H
#define GAME_H

/* ȂACRŗ̂ŏĂ */
#ifdef __BORLANDC__
#include<float.h>
#endif

#include "csdl.h"
#include "random.h"
#include "creader.h"
#include "boxer.h"
#include "bframe.h"
#include "boxerdata.h"
#include "storyboxer.h"
#include "storyhandler.h"
#include "motionhandler.h"
#include "boxerhandler.h"
#include "matchhandler.h"
#include "glbackground.h"
#include "glring.h"
#include "glsandbag.h"
#include "meters.h"
#include "mscreen.h"
#include "smixer.h"
#include "ssurface.h"
#include "sttf.h"
#include "snet.h"
#include "lobby.h"
#include "cgi.h"
#include "gltexture.h"
#include "glshapes.h"
#include "glpolygonize.h"
#include "gldlist.h"
#include "glptext.h"
#include "glttext.h"
#include "glmaterial.h"
#include "gllight.h"
#include "glcamera.h"

#define CONFIG_FILE "config.txt"
#define REPLAYCF_FILE "./Replay/replaycf.txt"
#define BGMCF_FILE "./BGM/bgmcf.txt"
#define FONTCF_FILE "./Font/fontcf.txt"
#define IMAGECF_FILE "./Image/imagecf.txt"
#define SECF_FILE "./SE/secf.txt"
#define DATACF_FILE "./Data/datacf.txt"
#define THINKCF_FILE "./Data/thinkcf.txt"

#define MAX_FONT_NUMBER 2
#define FONT_NAME1 "./Font/kana-029.ttc"
#define FONT_SIZE1 32
#define FONT_NAME2 "c:/windows/fonts/msgothic.ttc"
#define FONT_SIZE2 32

#define PDB_MAJOR_VERSION "1"
#define PDB_MINOR_VERSION "2"
#define PDB_PATCH_LEVEL   "0"

#define PDB_VERSION_NAME "[X"
#define PDB_VERSION_EN_NAME "Release"
#define PDB_VERSION_CODE (atoi(PDB_MAJOR_VERSION) * 1000 + atoi(PDB_MINOR_VERSION) * 100 + atoi(PDB_PATCH_LEVEL))
#define PDB_CAPTION_TITLE "|SŃ{NVO Ver " PDB_MAJOR_VERSION "." PDB_MINOR_VERSION "." PDB_PATCH_LEVEL " " PDB_VERSION_NAME
#define PDB_CAPTION_ICON  "|SŃ{NVO"
#define PDB_CAPTION_EN_TITLE "Polygon de Boxing Ver " PDB_MAJOR_VERSION "." PDB_MINOR_VERSION "." PDB_PATCH_LEVEL " " PDB_VERSION_EN_NAME
#define PDB_CAPTION_EN_ICON  "Polygon de Boxing"

#ifdef	LINUX
#undef	PDB_CAPTION_TITLE
#undef	PDB_CAPTION_ICON
#define	PDB_CAPTION_TITLE	PDB_CAPTION_EN_TITLE
#define	PDB_CAPTION_ICON	PDB_CAPTION_EN_ICON
#endif

#define MAX_REPLAYS 9
#define MAX_MEMBERS 30
#define MAX_THINKS  15

#define	TIMEOUT_COUNT	500
#define	ROUND_END_CODE	0x00ffff00
#define	MATCH_START		9998
#define	MATCH_END_CODE	9999
#define	REMATCH_CODE	10000
#define	QUIT_MATCH		0xffffff00

enum {
	TE_CANVAS,
	TE_FACE,
	TE_BACKGROUND,
	TE_FLOOR,
	TE_ROOF,
	TE_ADS,
	MAX_IMAGES
};

enum {
	FONT_TITLE,
	FONT_SYSTEM,
	MAX_FONTS
};

enum {
	BGM_OPENING,
	BGM_TRAINING,
	BGM_MATCH,
	MAX_BGMS
};

enum {
	SIDE_VIEW1 = 0x0011,
	SIDE_VIEW2 = 0x0021,
	BACK_VIEW1 = 0x0012,
	BACK_VIEW2 = 0x0022,
	TOP_VIEW1 = 0x0013,
	TOP_VIEW2 = 0x0023,
	BOXER_VIEW1 = 0x0014,
	BOXER_VIEW2 = 0x0024,
	FIXED_VIEW1 = 0x0015,
	FIXED_VIEW2 = 0x0016,
	FIXED_VIEW3 = 0x0017,
	FIXED_VIEW4 = 0x0018,
	FIXED_VIEW5 = 0x0025,
	FIXED_VIEW6 = 0x0026,
	FIXED_VIEW7 = 0x0027,
	FIXED_VIEW8 = 0x0028,
	SELECT_VIEW1 = 0x0010,
	SELECT_VIEW2 = 0x0020,
	VIEW_FILTER = 0x00f0,	
};

enum {
	SELECT_NOTHING,
	SELECT_1PSPARRING,
	SELECT_2PMATCH,
	SELECT_LAN,
	SELECT_TRAINING,
	SELECT_STORY_RED,
	SELECT_STORY_BLUE,
	SELECT_STORY_COM,
	SELECT_REPLAY,
	SELECT_REPLAY_MENU,
	SELECT_REPLAY_ARGUMENT,
	NO_REPLAY,
	CYCLE_REPLAY,
	SLOT_REPLAY
};

enum {
	REDCORNER_UP = 1024,
	REDCORNER_DOWN,
	BLUECORNER_UP,
	BLUECORNER_DOWN,
	REPLAY_UP,
	REPLAY_DOWN,
	REPLAY_RIGHT,
	REPLAY_LEFT,
	RANKING_UP1,
	RANKING_UP2,
	RANKING_DOWN1,
	RANKING_DOWN2,
	OUTPUT_SCORE,
	GO_NEXT
};

enum {
	INTERFACE_TOGGLE,
	MOVE_TOGGLE,
	NEXT_TIME,
	PREVIOUS_TIME,
	ROUND_START,
	ROUND_END,
	NEXT_ROUND,
	PREVIOUS_ROUND,
	MOVESPEED_UP,
	MOVESPEED_DOWN
};

class Game {
public:
	Game(int argc, char* argv[]);
	~Game();
	void Quit();

	void TestMatch();
	void CalcMeters();
	void ShowMeters();
	void ShowShadow(Boxer &shadow_boxer);
	void CalcAdjust();
	void GetKeyStates(BoxerHandler &handler);
	void GetOffenseKeyStates(BoxerHandler &handler);
	void GetMouseStates(BoxerHandler &handler);
	void GetOffenseMouseStates();
	void GetComStates(BoxerHandler &handler);
	void GetCom2States(BoxerHandler &handler);
	bool LoadBoxer(BoxerHandler &handler, Boxer &boxer, MotionHandler &motion, const char *filename);
	bool LoadThink(BoxerHandler &handler, const char *filename);
	void ChangeThink1();
	void ChangeThink2();	
	bool FaceClicked(int which);
	void SelectThink(BoxerHandler &handler, int select);
	int SelectStop(int select_type);
	void ThrowIn(int select_type);					
	void ShowNext();
	int IsNext() {return next;}
	void NextOff() {next = 0;}	
	void ShowStop();
	int IsStop() {return stop;}
	void StopOff() {stop = 0;}	
	MatchHandler & MatchRefer() {return match;} 

	void Config();
	void ReadConfig();
	void WriteConfig();
	void ScreenConfig();
	void ScreenReconfig();
	void SoundConfig();
	void FontConfig();
	void ImageConfig();
	void BGMConfig();
	void SEConfig();
	void DataConfig();
	void DataConfigSave();
	void ThinkConfig();
	void ReplayConfig();
	void ReplayConfigSave();

	void Opening();
	void InitOpening();
	void CanvasMaker();

	bool SetUpEventBoxer(StoryHandler &story);
	void InitEnding();
	void Ending(StoryHandler &story);
	void InitBurnOut();
	void BurnOut(StoryHandler &story);
	void InitTournamentVictor();
	void TournamentVictor(StoryHandler &story);
	void InitWonTitle();
	void WonTitle(StoryHandler &story);

	int DummyMenu();
 	int LobbyFailedMessage();
 	int LobbyClientFailedMessage();
 	int PleaseMessage();
 	int TopMenu();
	int SaveReplayMenu();
	int SelectSlotReplayMenu();
	int LANMenu();
	int OfficialModeMenu();
	int WaitClientMessage(SNet &snet, int i);
	int VersionFailureMessage(int is_old = 0);
	int NetErrorMessage();
	int ServerOKMenu(SNet &snet);
	int ClientOKMenu(SNet &snet);
	int ServerFailedMenu(SNet &snet);
	int ClientFailedMenu(SNet &snet);
	int CGIFailedMessage();
	int CGIErrorMessage();
	int ContinueMenu();
	int StoryMenu(int month);
	int YesNoMenu();
	int ChoiceMenu();	
	int GetOfferMenu();	
	int SendOfferMenu();	
	int HowManyMenu(int number = 3);
//	int WhenMenu(int number = 3);	
	int DefendMenu(int region = JAPAN);
	int OKMenu();	
	int UndecidedMenu();	
	int RetireMenu();	
	int SaveErrorMessage();	
	int LoadErrorMessage();	
	int WaitMessage(int percent);	
	int ParticipateMenu(int t_select = ROOKIE, int region = JAPAN);
	int ChallengerMenu(int month = 2, int region = JAPAN);
	void SetMenu(char *menu_kanji[], char *menu_kana[], char *menu_english[], int max_select);
	int Menu(int key_select, int min_select, int max_select);
	void InitMenu();

	void SelectView();
	void SetDefaultView();
	void AdjustSideView(Boxer &m_boxer, Boxer &o_boxer);
	void AdjustBackView(Boxer &m_boxer, Boxer &o_boxer);
	void AdjustTopView(Boxer &m_boxer, Boxer &o_boxer);
	void AdjustBoxerView(Boxer &m_boxer, Boxer &o_boxer, BoxerHandler &handler);
	void AdjustFixedView1(Boxer &m_boxer, Boxer &o_boxer, int corner, int fixed);
	void AdjustFixedView2(Boxer &m_boxer, Boxer &o_boxer, int corner, int fixed);
	void SetCamera();
	void SetLights();
	void CalcDistance();

	void MenuOptions();
	void SelectOptions();
	void RankingOptions() {MenuOptions();}
	void MatchOptions();
	void ScreenOptions();
	void VolumeOptions();
	void ViewOptions();
	void SetKeySideView1();
	void SetKeySideView2();
	void SetKeyBackView1();
	void SetKeyBackView2();
	void SelectSideView1();
	void SelectSideView2();
	void SelectBackView1();
	void SelectBackView2();
	void SelectTopView1();
	void SelectTopView2();
	void SelectBoxerView1();
	void SelectBoxerView2();
	void SelectFixedView1();
	void SelectFixedView2();
	void SelectFixedView3();
	void SelectFixedView4();
	void SelectFixedView5();
	void SelectFixedView6();
	void SelectFixedView7();
	void SelectFixedView8();
	void SetTransparent();
	void SetAngle();
	void SetBrightness();
	void SetKey1P();
	void SetKey2P();	
	void SetKeyBlueCorner();
	void SetKeyRedCorner();	
	void MakeObjects(int partition);
	void ExposeScreen();
	void PanicPause();	
	bool IsView1() {return (view & VIEW_FILTER) == SELECT_VIEW1;}
	bool IsView2() {return (view & VIEW_FILTER) == SELECT_VIEW2;}
	bool IsSideView1() {return (view == SIDE_VIEW1);}
	bool IsBackView1() {return (view == BACK_VIEW1);}
	bool IsTopView1() {return (view == TOP_VIEW1);}
	bool IsBoxerView1() {return (view == BOXER_VIEW1);}
	bool IsBoxerView2() {return (view == BOXER_VIEW2);}

	void InitRanking();
	void ExposeRanking();
	void MouseSelectRegion(int &mouse_select, int x, int y);
	void MouseSelectSort(int &mouse_select, int x, int y);
	void MouseSelectUpDown(int &mouse_select, int x, int y);
	void MouseSelectBoxer(int &mouse_rank, int x, int y);
	void ShowRegionInterface(int key_select, int mouse_select, float ssize, char *buf);
	void ShowSortInterface(int key_select, int mouse_select, float csize, char *buf);
	void ShowUpDownInterface(int mouse_select);
	int Ranking(StoryHandler &story, int select_mode = 0);
	void MouseSelectTournament(int &mouse_select, int x, int y);
	void ShowTournamentInterface(int key_select, int mouse_select, int t_select, float csize, char *buf);
	void Tournament(StoryHandler &story);
	void MouseSelectMatch(int &mouse_select, int x, int y);
	void StoryMatches(StoryHandler &story, int result_mode);
	char* RegionStr(int i);
	char* RankerStr();
	char* RookieStr();
	void TableStr(int i, char* buf);
	char* NationSign(int i);
	char* StateStr(int i);
/*	int ResultRed(int result);
	int ResultBlue(int result);	 */

	void InitSelectBoxer();
	void ExposeSelectBoxer();
	void SetUpBoxer1();
	void SetUpBoxer2();
	bool SelectBoxer1File(int file_number);
	bool SelectBoxer2File(int file_number);
	void SetUpStoryBoxer1(StoryBoxer &sb);
	void SetUpStoryBoxer2(StoryBoxer &sb);
	void MouseSelectGoNext(int &mouse_select, int x, int y);
	void SelectMatchType(int match_type, StoryBoxer &sb);
	void SelectStory(int select_type, StoryHandler &story);
	bool ShowMatchProfile(StoryHandler &story, int number1, int number2, int watch_mode = 1);
	bool SelectRecord(StoryHandler &story, int number);
	void MouseSelectCustom(int &mouse_select, int x, int y);
	void CustomizeBoxer(StoryHandler &story);
	void CustomizeSparBoxer(int number);
	void ShowRecentResults(StoryBoxer& sb, char *buf);
	void ShowHeldTitles(StoryBoxer& sb, char *buf);
	void ShowChallengerProfile(StoryHandler &story, int boxer_number);
	int ShowChallengers(StoryHandler &story, int *challengers, int max_select);
	void ShowBoxerProfile(StoryHandler &story, int boxer_number);
	bool SelectBoxer(int select_type);
	void MouseSelectReplay(int &mouse_select, int x, int y);
	bool SelectReplay(int replay_type = SELECT_REPLAY_MENU, char* filename = NULL);
	void ShowMatchInfo(char *buf);
	void ShowMatchResult(char *buf);
	void RedCornerBoxer();
	void RedCornerInfo(int select_boxer2, char *buf);
	void BlueCornerBoxer();
	void BlueCornerInfo(int select_boxer1, char *buf);	
	void BoxerRecordInfo(StoryBoxer &sb, int region, int rank, char *buf);	
	void BoxerNumberStr(int i, char* buf);
	void BoxerNameStr(BoxerHandler &handler, char* buf);
	void BoxerHeightStr(Boxer &boxer, char* buf);
	void BoxerWeightStr(Boxer &boxer, char* buf);
	void BoxerReachStr(Boxer &boxer, char* buf);
	void BoxerClassStr(Boxer &boxer, char* buf);
	void SelectCustomStr(int i, char* buf);
	void CustomStyleStr(int i, char* buf);
	void CustomStanceStr(int i, char* buf);
	void CustomThoughtStr(int i, char* buf);
	void CustomNationStr(int i, char* buf);

	int MatchInfo1Str(int region, int match_type, char *buf);
	void MatchInfo2Str(int match_type, char *buf);
	void CareerStr(StoryBoxer &sb, char *buf);
	void RecordStr(StoryBoxer &sb, char *buf);
	void RankStr(int region, int rank, char *buf);
	void TitleStr(int region, int rank, char *buf);
	void RecentStr(StoryBoxer &sb, char *buf);
	char ResultMark(int i);
	char* ResultMarkJp(int i);
	char* ResultMarkEn(int i);
	
	int WorldTitleStr(StoryBoxer &sb, char *buf);
	int AreaTitleStr(StoryBoxer &sb, char *buf);
	int NationTitleStr(StoryBoxer &sb, char *buf);
	int WorldRankerStr(StoryBoxer &sbo, char *buf);
	int AreaRankerStr(StoryBoxer &sb, char *buf);
	int NationRankerStr(StoryBoxer &sb, char *buf);
	int RookieKingStr(StoryBoxer &sb, char *buf);
	
	void Story();
	void InitStoryData(StoryHandler &story);
	void SelectGameMode(StoryHandler &story);
	void MyMatch(StoryHandler &story, int number);
	void MouseSelectRecord(int &mouse_record, int x, int y);
	void RecordDate(StoryHandler &story, int number, char *buf);
	void RecordName(StoryHandler &story, int number, char *buf);
	void RecordTime(StoryHandler &story, int number, char *buf);
	void RecordJudge(StoryHandler &story, int number, char *buf);
 	void Record(StoryHandler &story);
	char* ScoreStr(int number);
 	void ShowScore(StoryHandler &story);
	void PrintScore(StoryHandler &story);
 	void Retire(StoryHandler &story);
	bool MatchSilent(int select_type, int match_number);
	void CalcRoutineSilent();
	void RoundEndSilent();		

	void Training();

	bool Match(int select_type);
	void ShowRoutine();
	void CalcRoutine();
	void CheckResult();
	void SetBoxerPosition(float c_distance);
	void SetBoxerName();
	void RoundStart();		
	void RoundEnd();
	void ShowRefereeMessages();
	void ShowBoxerNames();		
	void ShowRound();
	void ShowMessages();		
	void ShowResults();		
	void MatchRoundsStr(char *buf);		
	void ResultStr(char *buf);		
	void SituationStr(char *buf);		
	void RedWinStr(char *buf);		
	void BlueWinStr(char *buf);		
	void DrawStr(char *buf);		
	void JudgeStr(char *buf);		
	void ExtraRedWinStr(char *buf);		
	void ExtraBlueWinStr(char *buf);		

	void NetworkMatch();
	void ServerLAN();
	void ClientLAN();
	Uint32 MakeSendData(Uint32 key, Uint32 round, Uint32 count);
	Uint8 MakeGetData(Uint32 get_data, Uint8 *round, Uint16 *count);
	void ClearDelayKeysLAN(SNet &snet, Uint32 *send_count, Uint32 *get_count);
	bool SelectBoxerLAN(SNet &snet);
	bool MatchLAN(SNet &snet);

	void NetLobby();
	void NetLobbyClient();
	int LobbyMatch(SNet &snet);

	void OfficialMode();
	int NetOfficial();
	bool OfficialWait(SNet &sent, CGI &cgi);
	bool ShowBoxerOfficial(SNet &snet, StoryBoxer &sb1, StoryBoxer &sb2);
	bool MatchOfficial(SNet &snet);

	void NetLobbyClientUDP();
	bool ClearFlowDataUDP(LobbyClientUDP &lc);
	void ClearDelayKeysUDP(LobbyClientUDP &lc, Uint32 *send_count, Uint32 *get_count);
	bool MatchUDP(LobbyClientUDP &lc);
	bool SelectBoxerUDP(LobbyClientUDP &lc);
	bool SendBoxerDataUDP(LobbyClientUDP &lc);
	void StartMatchUDP(LobbyClientUDP &lc);
	bool CheckVersionUDP(LobbyClientUDP &lc);
	bool CheckEndCodeUDP(LobbyClientUDP &lc, Uint32 *check_end);
  	void PlayerNumberStr(int number, char *buf);

	void NetLobby2();
	void NetLobbyClient2();
	bool ClearFlowData2(LobbyClient2 &lc);
	void ClearDelayKeys2(LobbyClient2 &lc, Uint32 *send_count, Uint32 *get_count);
	bool LobbyMatch2(LobbyClient2 &lc);
	bool SelectBoxer2(LobbyClient2 &lc);
	bool SendBoxerData2(LobbyClient2 &lc);
	void StartMatch2(LobbyClient2 &lc);
	bool CheckVersion2(LobbyClient2 &lc);
	bool CheckEndCode2(LobbyClient2 &lc, Uint32 *check_end);
	
	int MatchMake();
	
	void Replay();
	void ShowReplayRoutine();
	void CalcReplayRoutine();
	void RoundReplayEnd();		
	void ShowReplayMessages();
	void ReplayInterface();
	void ShowReplayInterface();
	int SaveReplayFile(const char *filename);
	int SaveReplay(SDL_RWops *rwops);
	void SaveReplaySelect();
	void SaveReplayCycle();
	int SaveSlotReplay();
	int LoadReplayFile(const char *filename, int round_data);
	int LoadReplay(SDL_RWops *rwops, int round_data);

	void Demo();
	void Demo1();
	void InitDemo1();
	void Demo2();
	void InitDemo2();
	void Demo3();
	void InitDemo3();
	void Demo4();
	void InitDemo4();
	void Demo5();
	void InitDemo5();
	void PeopleMaker();
	
	bool IsAnyKeyDown() {
		return event.IsKeyDown(go_next) ||
			event.IsKeyDown(kb2_right_offense) ||
			event.IsKeyDown(kb2_left_offense) ||
			event.IsKeyDown(kb2_defense); 			
	}
private:	
	CReader reader;
	Random random;
	STimer timer;
	MScreen screen;
	SMixer mixer;
	STTF ttf;
	GLPolygonize glp;
	GLPText ptext;
	GLTText ttext;
	SEvent event;
	SSurface icon;
	SSurfaces surfaces;
	GLTextures texs;
	GLCameras camera;
	GLLight light, light2;
	Boxer boxer1, boxer2;
	BoxerHandler handler1, handler2;
	MotionHandler motion1, motion2;
	MatchHandler match;

	GLSandbag glsandbag;
	GLRing glring;
	GLBackGround glbg;
	CyanosisMeter cyanosis_meter;
	DamageMeter damage_meter;
	DistanceMeter distance_meter;
	
	float distance, angle_cos, angle_sin, rot_cos, rot_sin, brightness;
	float cxp, cyp, czp, cxd , cyd, czd, carg;
	float nox1, noy1, not1, nox2, noy2, not2, meterspec;
	int show1, show2, view, show_interface, replay_select;
	int	replay_speed, replay_pause, replay_move, pause_time_count;
	int next, stop, use_mouse, which_select;
	int treble_mode, can_change_mode1, can_change_mode2;
	char player1_name[MAX_LINE_SIZE], player2_name[MAX_LINE_SIZE];
	char boxer1_file[MAX_LINE_SIZE], boxer2_file[MAX_LINE_SIZE];

	int go_next;
	int kb1_forward, kb1_back, kb1_right, kb1_left;
	int kb1_right_offense, kb1_left_offense, kb1_defense;
	int kb2_forward, kb2_back, kb2_right, kb2_left;
	int kb2_right_offense, kb2_left_offense, kb2_defense;

	char menu[8][50];
	int width, height;
	int	ScreenSize, ScreenMode;
	int SoundFreq, SoundFormat, SoundChannel, SoundBuffer; 
	int BGMVolume, SEVolume, MakeFromTTF, UsePText;
	Uint16 format, frequency, channel, buffer;
	enum {
		Kana,
		Japanese,
		English
	} lang;
	int Partition, FaceStyle, ShadowSwitch, BackGroundSwitch, AdsSwitch;
	int Mag_Linear, Min_Linear, SkipFrame;

	int DefaultView, Angle, Rotation, Brightness;
	int SkipOpening, SkipReplay, SkipDown;

	char UserName[MAX_LINE_SIZE];
	char HostName[MAX_LINE_SIZE];
	char HostCGI[MAX_LINE_SIZE];
	char MatchMakeCGI[MAX_LINE_SIZE];
	char LobbyCGI[MAX_LINE_SIZE];
	Uint16 Port;
	Uint16 PortLobby;
	int LobbyMode;

	int Player1Mode, Player2Mode, UseMouse;
	int KB1Forward, KB1Back, KB1Right, KB1Left;
	int KB1RightOffense, KB1LeftOffense, KB1Defense;
	int KB2Forward, KB2Back, KB2Right, KB2Left;
	int KB2RightOffense, KB2LeftOffense, KB2Defense;
	int KB3Forward, KB3Back, KB3Right, KB3Left;
	int KB3RightOffense, KB3LeftOffense, KB3Defense;

	int MaxRound, RoundTime;
	int TKOSystem, JudgeSystem, CountSystem, ExtraRound, KOCount;
	int Judge1Type, Judge2Type, Judge3Type;	
	int ExtraInfo, ReplayRate;	

	int RedManipOn, BlueManipOn;
	StoryBoxer RedManip, BlueManip, BoxerOM;

	char ReplayCf[MAX_LINE_SIZE];
	char FontCf[MAX_LINE_SIZE];
	char ImageCf[MAX_LINE_SIZE];
	char BGMCf[MAX_LINE_SIZE];
	char SECf[MAX_LINE_SIZE];
	char DataCf[MAX_LINE_SIZE];
	char ThinkCf[MAX_LINE_SIZE];
	
	int ChoiceSaveReplay;
	int ReplayNumber;	
	int CurrentReplay;	
	int SlotReplayNumber;	
	char SlotReplay[MAX_REPLAYS][MAX_LINE_SIZE];
	int MembersNumber;	
	char GymMembers[MAX_MEMBERS][MAX_LINE_SIZE];
	int ThinkNumber;	
	char ThinkFiles[MAX_THINKS+1][MAX_LINE_SIZE];
};

#endif // GAME_H
