#include "game.h"

void Game::SelectView() {
	switch (view) {
		case SIDE_VIEW1:
			AdjustSideView(boxer1, boxer2);	
		break;
		case SIDE_VIEW2:
			AdjustSideView(boxer2, boxer1);	
		break;
		case BACK_VIEW1:
			AdjustBackView(boxer1, boxer2);
		break;
		case BACK_VIEW2:
			AdjustBackView(boxer2, boxer1);
		break;
		case TOP_VIEW1:
			AdjustTopView(boxer1, boxer2);
		break;
		case TOP_VIEW2:
			AdjustTopView(boxer2, boxer1);
		break;
		case BOXER_VIEW1:
			AdjustBoxerView(boxer1, boxer2, handler2);
		break;
		case BOXER_VIEW2:
			AdjustBoxerView(boxer2, boxer1, handler1);
		break;
		case FIXED_VIEW1:
			AdjustFixedView1(boxer1, boxer2, 0, 0);
		break;
		case FIXED_VIEW5:
			AdjustFixedView1(boxer2, boxer1, 1, 0);
		break;
		case FIXED_VIEW2:
			AdjustFixedView1(boxer1, boxer2, 0, 1);
		break;
		case FIXED_VIEW6:
			AdjustFixedView1(boxer2, boxer1, 1, 1);
		break;
		case FIXED_VIEW3:
			AdjustFixedView2(boxer1, boxer2, 0, 0);
		break;
		case FIXED_VIEW7:
			AdjustFixedView2(boxer2, boxer1, 1, 0);
		break;
		case FIXED_VIEW4:
			AdjustFixedView2(boxer1, boxer2, 0, 1);
		break;
		case FIXED_VIEW8:
			AdjustFixedView2(boxer2, boxer1, 1, 1);
		break;
		default:
			AdjustSideView(boxer1, boxer2);	
		break;
	}
	camera.Set(0);
}		

void Game::SetDefaultView() {
	switch (DefaultView) {
		case 1: 
			SelectSideView2();			
		break;
		case 2: 
			SelectBackView1();					
		break;
		case 3: 
			SelectBackView2();							
		break;
		case 4: 
			SelectTopView1();									
		break;
		case 5: 
			SelectTopView2();											
		break;
		case 6: 
			SelectBoxerView1();											
		break;
		case 7: 
			SelectBoxerView2();											
		break;
		case 8: 
			SelectFixedView1();											
		break;
		case 9: 
			SelectFixedView2();											
		break;
		case 10: 
			SelectFixedView3();											
		break;
		case 11: 
			SelectFixedView4();											
		break;
		case 12: 
			SelectFixedView5();											
		break;
		case 13: 
			SelectFixedView6();											
		break;
		case 14: 
			SelectFixedView7();											
		break;
		case 15: 
			SelectFixedView8();											
		break;
		default:
			SelectSideView1();	
		break;
	}
}


void Game::AdjustSideView(Boxer &m_boxer, Boxer &o_boxer) {
	float ds, dc, d2, dx, dy, x1, y1, x2, y2, xp, yp, zp, xd, yd, zd;
	x1 = m_boxer.OX();
	y1 = m_boxer.OY();
	x2 = o_boxer.OX();
	y2 = o_boxer.OY();

	dx = x2 - x1;	
	dy = y2 - y1;
	d2 = dx * dx + dy * dy;
	distance = sqrt(d2);

	xd = x1 + 0.5 * dx;
	yd = y1 + 0.5 * dy;
	zd = m_boxer.LegHeight();

	if (distance < 1.5) {
		dc = 2.0 * angle_cos / distance;
		ds = 2.0 * angle_sin;
	} else {
		dc = 1.33 * angle_cos;
		ds = 1.33 * angle_sin * distance;
	}
	xp = xd - dy * dc;
	yp = yd + dx * dc;
	zp = zd + ds;

	cxp += (xp - cxp) * 0.1;
	cyp += (yp - cyp) * 0.1;
	czp += (zp - czp) * 0.1;
	cxd += (xd - cxd) * 0.1;
	cyd += (yd - cyd) * 0.1;
	czd += (zd - czd) * 0.1;
//	carg += (0.0 - carg) * 0.1;

	camera.DefPosition(cxp, cyp, czp);
	camera.DefDirection(cxd, cyd, czd);
	camera.DefRotation(0.0f);  
}

void Game::AdjustBackView(Boxer &m_boxer, Boxer &o_boxer) {
	float d2, dc, ds, dx, dy, x1, y1, x2, y2, xp, yp, zp, xd, yd, zd;
	x1 = m_boxer.OX();
	y1 = m_boxer.OY();
	x2 = o_boxer.OX();
	y2 = o_boxer.OY();

	dx = x2 - x1;	
	dy = y2 - y1;
	d2 = dx * dx + dy * dy;
	distance = sqrt(d2);

	xd = x1;//+ 0.5 * dx;
	yd = y1;// + 0.5 * dy;
	zd = m_boxer.LegHeight();


	dc = 1.2 * angle_cos / distance;
	ds = 1.2 * angle_sin;
	xp = x2 + dx * dc;
	yp = y2 + dy * dc;
	zp = zd + ds;

	cxp += (xp - cxp) * 0.1;
	cyp += (yp - cyp) * 0.1;
	czp += (zp - czp) * 0.1;
	cxd += (xd - cxd) * 0.1;
	cyd += (yd - cyd) * 0.1;
	czd += (zd - czd) * 0.1;
//	carg += (0.0 - carg) * 0.1;
	
	camera.DefPosition(cxp, cyp, czp);
	camera.DefDirection(cxd, cyd, czd);
	camera.DefRotation(0.0f);  
}


void Game::AdjustTopView(Boxer &m_boxer, Boxer &o_boxer) {
	float d2, dx, dy, x1, y1, x2, y2, xd, yd, zd, darg, arg;
	x1 = m_boxer.OX();
	y1 = m_boxer.OY();
	x2 = o_boxer.OX();
	y2 = o_boxer.OY();

	dx = x2 - x1;	
	dy = y2 - y1;
	d2 = dx * dx + dy * dy;
	distance = sqrt(d2);

	xd = x1 + 0.5 * dx;
	yd = y1 + 0.5 * dy;
	zd = 1.5 + distance;
	if (zd < 2.5) {
		zd = 2.5;			
	}

	arg = DEG(atan(dy/dx));
	if (dy >= 0.0) {
		if (dx >= 0.0) {
		
		} else {
			arg += 180.0; 		
		}
	} else {
		if (dx >= 0.0) {
			arg += 360.0; 				
		} else {
			arg += 180.0;		
		}	
	}
	darg = arg - carg;
	if (darg >= 180.0) {
		darg -= 360.0;	
	}
	if (darg <= -180.0) {
		darg += 360.0;		
	} 

	cxd += (xd - cxd) * 0.1;
	cyd += (yd - cyd) * 0.1;
	czd += (0.0 - czd) * 0.1;
	cxp = cxd;
	cyp = cyd;
	czp += (zd - czp) * 0.1;
	carg += darg * 0.1;

	if (carg < 0.0) {
		carg+=360.0;	
	}
	if (carg > 360) {
		carg-=360.0;	
	}

	camera.DefPosition(cxp, cyp, czp);
	camera.DefDirection(cxd, cyd, czd);
	camera.DefRotation(-carg);  
}

void Game::AdjustBoxerView(Boxer &m_boxer, Boxer &o_boxer, BoxerHandler &handler) {
	float d2, dx, dy, x1, y1, x2, y2, xp, yp, xd, yd;
	float zd, zp, xh, yh, zh;
	static float cxh = 0.0, cyh = 0.0, czh = 1.0;

	x1 = m_boxer.OX();
	y1 = m_boxer.OY();
	x2 = o_boxer.OX();
	y2 = o_boxer.OY();

	dx = x2 - x1;	
	dy = y2 - y1;
	d2 = dx * dx + dy * dy;
	distance = sqrt(d2);
	
	xp = o_boxer.head.face.X();
	yp = o_boxer.head.face.Y();
	zp = o_boxer.head.face.Z();
	if (handler.State() == DOWN || czh < 0.05) {
		xd = o_boxer.head.face.DirX();
		yd = o_boxer.head.face.DirY();
		zd = o_boxer.head.face.DirZ();		
	} else {
		xd = m_boxer.head.face.X();
		yd = m_boxer.head.face.Y();
		zd = m_boxer.head.face.Z();
	}
	xh = o_boxer.head.face.HeadX();
	yh = o_boxer.head.face.HeadY();
	zh = o_boxer.head.face.HeadZ();

	cxp += (xp - cxp) * 0.1;
	cyp += (yp - cyp) * 0.1;
	czp += (zp - czp) * 0.1;
	cxd += (xd - cxd) * 0.1;
	cyd += (yd - cyd) * 0.1;
	czd += (zd - czd) * 0.1;
	cxh += (xh - cxh) * 0.1;
	cyh += (yh - cyh) * 0.1;
	czh += (zh - czh) * 0.1;
	
	camera.DefPosition(xp, yp, zp);
	camera.DefDirection(cxd, cyd, czd);
	camera.DefHeadUp(cxh, cyh, czh);  
}


void Game::AdjustFixedView1(Boxer &m_boxer, Boxer &o_boxer, int corner, int fixed) {
	float ds, dc, d2, dx, dy, x1, y1, x2, y2, o, rot, xp, yp, zp, xd, yd, zd, arg;
	x1 = m_boxer.OX();
	y1 = m_boxer.OY();
	x2 = o_boxer.OX();
	y2 = o_boxer.OY();
 	o = o_boxer.OT();

	dx = x2 - x1;	
	dy = y2 - y1;
	d2 = dx * dx + dy * dy;
	distance = sqrt(d2);

	if (fixed) {
		xd = 0.0;
		yd = 0.0;
		zd = m_boxer.LegHeight();
		if (corner) {
			dc = -4.6*rot_cos;
			ds = -4.6*rot_sin;		
		} else {
			dc = 4.6*rot_cos;
			ds = 4.6*rot_sin;		
		}
	} else {
		xd = x1 + 0.5 * dx;
		yd = y1 + 0.5 * dy;
		zd = m_boxer.LegHeight();

		if (corner) {
			if (distance < 1.5) {
				dc = -2.0 * rot_cos;
				ds = -2.0 * rot_sin;
			} else {
				dc = -1.4*distance*rot_cos;
				ds = -1.4*distance*rot_sin;
			}	
		} else {
			if (distance < 1.5) {
				dc = 2.0 * rot_cos;
				ds = 2.0 * rot_sin;
			} else {
				dc = 1.4*distance*rot_cos;
				ds = 1.4*distance*rot_sin;
			}	
		}
	}
	
	xp = xd + dc;
	yp = yd + ds;
	zp = zd + angle_sin * sqrt(dc*dc+ds*ds);

	rot = (float)Rotation;
	if (corner) {
		rot += 180.0;
		o = o_boxer.OT() + rot;	
	} else {
		o = m_boxer.OT() + rot;		
	}
	if (o >= 360.0) {
	 	o -= 360.0;
	} 
	if (o < 0.0) {
	 	o += 360.0;
	} 

	if (o < 45.0) {
		SetKeyBackView1();
	} else if (o < 135.0) {
		SetKeySideView2();		
	} else if (o < 225.0) {
		SetKeyBackView2();		
	} else if (o < 315.0) {
		SetKeySideView1();				
	} else {
		SetKeyBackView1();
	} 
	
	cxp += (xp - cxp) * 0.1;
	cyp += (yp - cyp) * 0.1;
	czp += (zp - czp) * 0.1;
	cxd += (xd - cxd) * 0.1;
	cyd += (yd - cyd) * 0.1;
	czd += (zd - czd) * 0.1;

	camera.DefPosition(cxp, cyp, czp);
	camera.DefDirection(cxd, cyd, czd);
	camera.DefRotation(0.0f);  
}


void Game::AdjustFixedView2(Boxer &m_boxer, Boxer &o_boxer, int corner, int fixed) {
	float d2, dx, dy, x1, y1, x2, y2, o, rot, xd, yd, zd, darg, arg;
	x1 = m_boxer.OX();
	y1 = m_boxer.OY();
	x2 = o_boxer.OX();
	y2 = o_boxer.OY();

	dx = x2 - x1;	
	dy = y2 - y1;
	d2 = dx * dx + dy * dy;
	distance = sqrt(d2);

	if (fixed) {
		xd = 0.0;
		yd = 0.0;
		zd = 6.0;
	} else {
		xd = x1 + 0.5 * dx;
		yd = y1 + 0.5 * dy;
		zd = 1.5 + distance;
		if (zd < 2.5) {
			zd = 2.5;			
		}
	}

	cxd += (xd - cxd) * 0.1;
	cyd += (yd - cyd) * 0.1;
	czd += (0.0 - czd) * 0.1;
	cxp = cxd;
	cyp = cyd;
	czp += (zd - czp) * 0.1;
	carg += darg * 0.1;

	rot = (float)Rotation;
	if (corner) {
		rot += 180.0;
		o = o_boxer.OT() + rot;	
	} else {
		o = m_boxer.OT() + rot;		
	}
	if (o >= 360.0) {
	 	o -= 360.0;
	} 
	if (o < 0.0) {
	 	o += 360.0;
	} 

	if (o < 45.0) {
		SetKeyBackView1();
	} else if (o < 135.0) {
		SetKeySideView2();		
	} else if (o < 225.0) {
		SetKeyBackView2();		
	} else if (o < 315.0) {
		SetKeySideView1();				
	} else {
		SetKeyBackView1();
	} 
	camera.DefPosition(cxp, cyp, czp);
	camera.DefDirection(cxd, cyd, czd);
	camera.DefRotation(rot);  
}

void Game::SetCamera() {
	distance = 0.0;
	cxp = 0.0; cyp = 0.0; czp = 0.0;
	cxd = 0.0; cyd = 0.0; czd = 0.0;
	carg = 0.0;

	camera.Init(2);
	camera.Perspective(60.0, 0.05, 20.0);
}

void Game::SetLights() {
	light.Init(0);
	light2.Init(1);
	light.DefDiffuse(0.8, 0.8, 0.8);
	light.DefPosition(0.0, 0.0, 1.0);
	light2.DefPosition(0.0, 0.0, 3.0);
	light2.DefDiffuse(0.8, 0.8, 0.8);
}

void Game::CalcDistance() {
	float d2, dx, dy, x1, y1, x2, y2;
	x1 = boxer1.OX();
	y1 = boxer1.OY();
	x2 = boxer2.OX();
	y2 = boxer2.OY();

	dx = x2 - x1;	
	dy = y2 - y1;
	d2 = dx * dx + dy * dy;
	distance = sqrt(d2);
}
