#include "game.h"

int Game::MatchMake() {
    static char buf[MAX_LINE_SIZE];
	static int select, mouse_select, key_select;
	static int i, loop, x, y, return_value;
	static float ssize, csize;
	static char *title[] = {"}b`CNCGI", "}b`CNCGI", "Match Make CGI"};
	static char *renew[] = {"", "XV", "Renew"};
	Uint32 iver, get_iver, size;
	SNet snet;
	CGI cgi;
	SData send, get;
	
	return_value = SDL_FAILURE;
	if (snet.Init() == SDL_FAILURE) {
		return SDL_FAILURE;	
	}

	if (cgi.MatchMake(-1, HostCGI, MatchMakeCGI, UserName, Port, PDB_CAPTION_EN_TITLE) == SDL_FAILURE) {
		CGIFailedMessage();
		return SDL_FAILURE;
	}
	cgi.SetState();

	timer.SetFPS(50);	
	do {
		glClearColor(0.33, 0.33, 0.33, 0.0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		SelectOptions();

		SDL_GetMouseState(&x, &y);
		mouse_select = -1;
		MouseSelectGoNext(mouse_select, x, y);
		if (width*0.25  < x && width*0.75 > x) {
			for (i = 0; i < MAX_CGI_ROOM+1; i++) {
				if (height*(0.33 + (float)i*0.09) < y &&
					height*(0.41 + (float)i*0.09) > y) {
   		    		mouse_select = i;
				}
			}
		}

		if (event.IsKeyDown(kb2_left) ||  
			event.IsKeyDown(kb2_forward)) {  
			if (key_select > 0) {
				key_select--;
			}
		}
		if (event.IsKeyDown(kb2_right) ||  
			event.IsKeyDown(kb2_back)) {  
			if (key_select < MAX_CGI_ROOM) {
				key_select++;
			}
		}
		csize = (1.0 + 0.2 * sin(RAD(2*loop++)));

		ttext.MessageEnter();
		ttext.Print(title[lang], 0.5, 0, 50);
		for (i = 0; i < MAX_CGI_ROOM + 1; i++) {
			if (i == MAX_CGI_ROOM) {
				strcpy(buf, renew[lang]);			
			} else {
				strcpy(buf, cgi.Name(i));
			}
			ttext.SelectColor(mouse_select == i);
			key_select == i ? ssize = csize : ssize = 1.0;
			ttext.Print(buf, 0.5 * ssize, 0, 30 - i*20);
		}

		select = -1;
		if (IsAnyKeyDown()) {
			select = key_select;
		}
		if (mouse_select != -1 && event.IsMouse1Down()) {
			select = mouse_select;
		}			
		if (select != -1) {
			if (cgi.MatchMake(select, HostCGI, MatchMakeCGI, UserName, Port, PDB_CAPTION_EN_TITLE) == SDL_FAILURE) {
				CGIFailedMessage();
				return SDL_FAILURE;
			}
			switch (cgi.SetState()) {
			 	case SERVER:
					snet.Server(Port);	
				break;
				case CLIENT:		
					if (snet.Client(cgi.Host(select), cgi.Port(select)) == SDL_FAILURE) {
						CGIFailedMessage();
						return SDL_FAILURE;
		    		}
				break;			
				case QUIT_SERVER:
					snet.CloseSockets();			
				break;
			}
		}

		ttext.SelectColor(mouse_select == GO_NEXT);
   		ttext.Print("Quit", 0.25, -100, -100);
		ttext.SetColor(1.0, 1.0, 1.0);	
 		ttext.Print(timer.FPSString(), 0.25, 100, -100);
		ttext.MessageLeave();		

		SDL_GL_SwapBuffers(); 
		GLmes();

		timer.Wait();
		event.Poll();
		if (snet.IsServer()) {
			if (snet.WaitClient() == SDL_SUCCESS) {
				break;	
			}
		} else if (snet.IsClient()) {
			break;
		}
		if (event.IsKeyDown(go_next) ||
			(mouse_select == GO_NEXT && event.IsMouse1Down())) {
			return_value = SDL_SUCCESS;
			break;
		}
		ExposeSelectBoxer();
	} while(!event.IsQuit());
	cgi.MatchMake(-1, HostCGI, MatchMakeCGI, UserName, Port, PDB_CAPTION_EN_TITLE);
	cgi.SetState();
	if (event.IsQuit()) {
		Quit();
	}
 	glClearColor(0.0, 0.0, 0.0, 0.0);
	if (return_value == SDL_SUCCESS) {
		return return_value;	
	}

	iver = PDB_VERSION_CODE;	
	snet.Send32(iver);
	get_iver = snet.Get32();
	if (get_iver != iver) {
		wmes("Game::MatchMake -> Version is different.");
		VersionFailureMessage();
	}
	smes("Game::MatchMake -> Version OK");		

	while(1) {
		if (snet.IsServer()) {
			SetKeyRedCorner();
		} else {
	  		SetKeyBlueCorner();	
		}
		if (!SelectBoxerLAN(snet)) {
			NetErrorMessage();
			break;		
		}
		PleaseMessage();
   
		if (snet.IsServer()) {
			send.Init(handler2.CalcDataSize(motion2));
			handler2.SaveBinBoxer(boxer2, motion2, send.RWops());
    	} else {
			send.Init(handler1.CalcDataSize(motion1));
			handler1.SaveBinBoxer(boxer1, motion1, send.RWops());
    	}
		snet.Send32(send.Size());   
		snet.SendData(send.Data(), send.Size());   

		size = snet.Get32();
		if (size == QUIT_MATCH) {
			wmes("Game::MatchMake -> Opponent is quit.");
			break;		
		}
		get.Init(size);
		snet.GetData(get.Data(), get.Size());
		if (snet.IsServer()) {
			handler1.LoadBinBoxer(boxer1, motion1, get.RWops());
			boxer1.MakeDLists(Partition, FaceStyle);
			boxer1.MakeRanges(Partition);
		} else {
			handler2.LoadBinBoxer(boxer2, motion2, get.RWops());	
			boxer2.MakeDLists(Partition, FaceStyle);
			boxer2.MakeRanges(Partition);	
		}

		if (snet.IsServer()) {
			SetKeyRedCorner();
		} else {
	  		SetKeyBlueCorner();	
		}

		snet.Send32(MATCH_START);
		if (snet.Get32() != MATCH_START) {
			wmes("Game::MatchMake -> Match Start Code Error");
		}
		smes("Game::MatchMake -> Match Start");		

		if (MatchLAN(snet)) {
			SaveReplayCycle();
			if (!SkipReplay) {
				Replay();
			}
		}
		if (snet.IsClient()) {
			SetKey1P();
		}
		
		PleaseMessage();
		snet.Send32(MATCH_END_CODE);
		if (snet.Get32() != MATCH_END_CODE) {
			wmes("Game::MatchMake -> Match End Code Error");
			NetErrorMessage();
			break;
		}
		smes("Game::MatchMake -> Match End");		

		PleaseMessage();
		if (snet.IsServer()) {
			if (snet.Get32() != REMATCH_CODE) {
				break;
			}
		} else {		
			if (ContinueMenu()) {
				snet.Send32(REMATCH_CODE+1);		
				break;		
			}
			snet.Send32(REMATCH_CODE);		
		}
	}
}


