#include "game.h"

void Game::Demo() {
	if (handler1.LoadBinBoxer(boxer1, motion1, DemoBoxer2()) == SDL_FAILURE) {
		return;	
	}	
	if (handler2.LoadBinBoxer(boxer2, motion2, DemoBoxer1()) == SDL_FAILURE) {
		return;	
	}	

	boxer1.SetDefaultFace();
	boxer2.SetDefaultFace();	
 	boxer1.SetPoint(0.0, 0.0, 0.0);
 	boxer2.SetPoint(0.0, 0.0, 0.0);
 
  	mixer.PlayMusic(BGM_MATCH);	
	InitDemo5();
	Demo5();
 	InitDemo1();
	Demo1();
	mixer.PlayMusic(BGM_TRAINING);	
 	InitDemo2();
	Demo2();
 	InitDemo3();
	Demo3();
	InitDemo4();
	Demo4(); 
 
	ptext.Clear();		 	
}


void Game::InitDemo1() {
	MakeObjects(Partition);
	camera.Init(2);
	camera.Perspective(60.0, 0.05, 20.0);
	camera[0].DefPosition(0.0f, -4.0f, 3.0f);
	camera[0].DefDirection(0.0f, 0.0f, 1.0f);
	camera[0].DefRotation(0.0f);

	light.Init(0);
	light2.Init(1);
	light.DefDiffuse(0.8, 0.8, 0.8);
	light.DefPosition(0.0, 0.0, 1.0);
	light2.DefPosition(0.0, 0.0, 3.0);
	light2.DefDiffuse(0.5, 0.5, 0.5);
	light.On();
	light2.On();
}

void Game::Demo1() {
	int i=0, k =-100, kadd = 1;

	ptext.MakeText("[h[N");
	ptext.MakeText("OőI");

	motion1[17].SetFrame(0);
	motion2[17].SetFrame(20);

	timer.SetFPS(50);	
	do {
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		light.Set();
		camera[0].Set();
		light2.Set();

		texs.Choice(TE_FACE);

		int i2 = i +180;
		glPushMatrix();
		glTranslatef(2.3*cos(RAD(i2)), 2.3 * sin(RAD(i2)), 0.0);
		glRotatef((float)(i2), 0.0, 0.0, 1.0);
		motion1[17].NextFrame();
		motion1[17].CurrentFrame().Set(&boxer1);
		ShowShadow(boxer1);
		boxer1.CallLists();
		boxer1.CalcCoords();
		glPopMatrix();

		glPushMatrix();
		glTranslatef(2.3*cos(RAD(i*2)), 2.3 * sin(RAD(i*2)), 0.0);
		glRotatef((float)(i*2), 0.0, 0.0, 1.0);
		motion2[17].NextFrame();
		motion2[17].CurrentFrame().Set(&boxer2);
		ShowShadow(boxer2);
		boxer2.CallLists();
		boxer2.CalcCoords();
		glPopMatrix();

		glbg.Show();
		glring.ShowAll();

  		ptext.MessageEnter();
		ptext.SetColor(1.0, 0.0, 0.0);	
		switch (lang) {
			case Kana:
				ptext.Print("[h[N", 1.0, 0, 60);
            break;
			case English:
				ptext.Print("Road Work", 1.0, 0, 60);
            break;
			default:
				ptext.Print("[h[N", 1.0, 0, 60);
            break;			
		}

		ptext.SetColor(1.0, 1.0, 1.0);	
		switch (lang) {
			case Kana:
				ptext.Print("Ƃ͂", 0.5, -k, 0);
            break;
			case English:
				ptext.Print("Run outside!", 0.5, -k, 0);
            break;
			default:
				ptext.Print("O𑖂I", 0.5, -k, 0);
            break;			
		}
  		ptext.MessageLeave();  

		ttext.MessageEnter();
		ttext.SetColor(1.0, 1.0, 1.0);	
  		ttext.Print(timer.FPSString(), 0.25, 100, -100);
		ttext.MessageLeave();

		if (k >= -100 && k <= 100) {
			k += kadd;
		} else {
			kadd *= -1;
			k += kadd;
		}

		if(i++ >= 360) {
			i = 0;
		}

		SDL_GL_SwapBuffers(); 
		GLmes();

		timer.Wait();
		event.Poll();
		if (IsAnyKeyDown() || event.IsMouse1Down()) {
			break;		
		}
		if (event.IsExpose() && ScreenMode) {
			ScreenReconfig();	
			InitDemo1();
			event.Clear();
			wmes("Change Resolution");
		} 
	} while(!event.IsQuit());
	if (event.IsQuit()) {
		Quit();
	}
}	


void Game::InitDemo2() {
	MakeObjects(Partition);
	camera.Init(2);
	camera.Perspective(60.0, 0.05, 20.0);
	camera[0].DefPosition(1.5f, 1.5f, 1.0f);
	camera[0].DefDirection(0.0f, 0.0f, 1.0f);
	camera[0].DefRotation(0.0f);

	light.Init(0);
	light2.Init(1);
	light.DefDiffuse(0.8, 0.8, 0.8);
	light.DefPosition(0.0, 0.0, 1.0);
	light2.DefPosition(0.0, 0.0, 3.0);
	light2.DefDiffuse(0.8, 0.8, 0.8);
	light.On();
	light2.On();
}


void Game::Demo2() {
	int i=0, k =-100, kadd = 1;

	ptext.MakeText("g[jO");

	motion1[3].SetFrame(0);
	motion2[7].SetFrame(20);

	timer.SetFPS(50);	
	do {
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		light.Set();
		camera[0].Set();
		light2.Set();

		texs.Choice(TE_FACE);
		glPushMatrix();
		glTranslatef(-0.7, 0.7, 0.0);
		glRotatef(225.0, 0.0, 0.0, 1.0);
		motion1[3].NextFrame();
		motion1[3].CurrentFrame().Set(&boxer1);
		ShowShadow(boxer1);
		boxer1.CallLists();
		boxer1.CalcCoords();
		glPopMatrix();

		glPushMatrix();
		glTranslatef(0.6, -0.6, 0.0);
		glRotatef(45.0, 0.0, 0.0, 1.0);
		motion2[7].NextFrame();
		motion2[7].CurrentFrame().Set(&boxer2);
		ShowShadow(boxer2);
		boxer2.CallLists();
		boxer2.CalcCoords();
		glPopMatrix();

		glbg.Show();
		glring.ShowAll();
		glPushMatrix();
		glTranslatef(0.5, -0.5, 0.0);
		glsandbag.Show();
		glPopMatrix();

  		ptext.MessageEnter();
		ptext.SetColor(1.0, 1.0, 1.0);
		switch (lang) {
			case Kana:
				ptext.Print("тg[jO", 0.5, -k, 0);
            break;
			case English:
				ptext.Print("It's hard work.", 0.5, -k, 0);
            break;
			default:
				ptext.Print("g[jO", 0.5, -k, 0);
            break;			
		}
  		ptext.MessageLeave();  

		ttext.MessageEnter();
		ttext.SetColor(1.0, 1.0, 1.0);	
  		ttext.Print(timer.FPSString(), 0.25, 100, -100);
		ttext.MessageLeave();

		if (k >= -100 && k <= 100) {
			k+=kadd;
		} else {
			kadd*=-1;
			k+=kadd;
		}

		if(i++ >= 360) {
			i = 0;
		}
		if((i % 40) == 0) {
			mixer.PlayChunk(SE_HIT_FACE);			
		}

		SDL_GL_SwapBuffers(); 
		GLmes();

		timer.Wait();
		event.Poll();
		if (IsAnyKeyDown() || event.IsMouse1Down()) {
			break;		
		}
		if (event.IsExpose() && ScreenMode) {
			ScreenReconfig();	
			InitDemo2();
			event.Clear();
			wmes("Change Resolution");
		} 
	} while(!event.IsQuit());
	if (event.IsQuit()) {
		Quit();
	}
}

void Game::InitDemo3() {
	MakeObjects(Partition);
	camera.Init(2);
	camera.Perspective(60.0, 0.05, 20.0);
	camera[0].DefPosition(2.0f, 1.0f, 0.5f);
	camera[0].DefDirection(0.0f, 0.0f, 0.0f);
	camera[0].DefRotation(0.0f);

	light.Init(0);
	light2.Init(1);
	light.DefDiffuse(0.8, 0.8, 0.8);
	light.DefPosition(0.0, 0.0, 1.0);
	light2.DefPosition(0.0, 0.0, 3.0);
	light2.DefDiffuse(0.5, 0.5, 0.5);
	light.On();
	light2.On();
}

void Game::Demo3() {
	int i=0, k =-100, kadd = 1;

	ptext.MakeText("O[u͂I");
	ptext.MakeText("ؗ͋");

	motion1[19].SetFrame(0);
	motion2[18].SetFrame(20);

	timer.SetFPS(50);	
	do {
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		light.Set();
		camera[0].Set();
		light2.Set();

		texs.Choice(TE_FACE);
		glPushMatrix();
		glTranslatef(0.0, 0.8, 0.0);
		glRotatef(0.0, 0.0, 0.0, 1.0);
		motion1[19].NextFrame();
		motion1[19].CurrentFrame().Set(&boxer1);
		ShowShadow(boxer1);
		boxer1.CallLists();
		boxer1.CalcCoords();
		glPopMatrix();

		glPushMatrix();
		glTranslatef(0.0, -0.8, 0.0);
		glRotatef(0.0, 0.0, 0.0, 1.0);
		motion2[18].NextFrame();
		motion2[18].CurrentFrame().Set(&boxer2);
		ShowShadow(boxer2);
		boxer2.CallLists();
		boxer2.CalcCoords();
		glPopMatrix();

		glbg.Show();
		glring.ShowAll();

  		ptext.MessageEnter();
 		ptext.SetColor(1.0, 1.0, 1.0);
		switch (lang) {
			case Kana:
				ptext.Print("傭傤", 0.5, 0, 80);
            break;
			case English:
				ptext.Print("Build Up the Muscle", 0.5, 0, 80);
            break;
			default:
				ptext.Print("ؗ͋", 1.0, 0, 80);
            break;			
		}

		ptext.SetColor(1.0, 0.0, 0.0);
		switch (lang) {
			case Kana:
				ptext.Print("O[u͂", 0.5, -k, -20);
            break;
			case English:
				ptext.Print("Take off your gloves!", 0.5, -k, -20);
            break;
			default:
				ptext.Print("O[u͂I", 0.5, -k, -20);
            break;			
		}
  		ptext.MessageLeave();  

		ttext.MessageEnter();
		ttext.SetColor(1.0, 1.0, 1.0);	
  		ttext.Print(timer.FPSString(), 0.25, 100, -100);
		ttext.MessageLeave();

		if (k >= -100 && k <= 100) {
			k+=kadd;
		} else {
			kadd*=-1;
			k+=kadd;
		}

		if(++i>=360) {
			i = 0;
		}

		SDL_GL_SwapBuffers(); 
		GLmes();

		timer.Wait();
		event.Poll();
		if (IsAnyKeyDown() || event.IsMouse1Down()) {
			break;		
		}
		if (event.IsExpose() && ScreenMode) {
			ScreenReconfig();	
			InitDemo3();
			event.Clear();
			wmes("Change Resolution");
		} 
	} while(!event.IsQuit());
	if (event.IsQuit()) {
		Quit();
	}
}

void Game::InitDemo4() {
	MakeObjects(Partition);
	camera.Init(2);
	camera.Perspective(60.0, 0.05, 20.0);
	camera[0].DefPosition(0.0f, -2.5f, 1.0f);
	camera[0].DefDirection(0.0f, 0.0f, 1.0f);
	camera[0].DefRotation(0.0f);

	light.Init(0);
	light2.Init(1);
	light.DefDiffuse(0.8, 0.8, 0.8);
	light.DefPosition(0.0, 0.0, 1.0);
	light2.DefPosition(0.0, 0.0, 3.0);
	light2.DefDiffuse(0.8, 0.8, 0.8);
	light.On();
	light2.On();	
}


void Game::Demo4() {
	int i=0, k =-100, kadd = 1, m = 0, chunk_number = 2;
	int mm[]= {2, 3, 7, 8, 9, 10, 11, 12};

	ptext.MakeText("@A@A@IIIi䂵Ȃłˁj");

	motion1[3].SetFrame(0);
	motion2[7].SetFrame(20);

	timer.SetFPS(50);	
	do {
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		light.Set();
		camera[0].Set();
		light2.Set();

		texs.Choice(TE_FACE);

		glPushMatrix();
		glTranslatef(0.0, -0.75, 0.0);
		glRotatef(0.0, 0.0, 0.0, 1.0);
		motion2[mm[m]].NextFrame();
		motion2[mm[m]].CurrentFrame().Set(&boxer2);
		ShowShadow(boxer2);
		boxer2.CallLists();
		boxer2.CalcCoords();
		glPopMatrix();

		glbg.Show();
		glring.ShowAll();
		glPushMatrix();
		glTranslatef(0.5, -0.5, 0.0);
		glsandbag.Show();
		glPopMatrix();

  		ptext.MessageEnter();
		ptext.SetColor(1.0, 1.0, 1.0);
		switch (lang) {
			case Kana:
				ptext.Print("AA", 0.5, -k, 0);
				ptext.Print("Ȃł", 0.5, k, -20);
            break;
			case English:
				ptext.Print("Hit, hit, hit!!!", 0.5, -k, 0);
				ptext.Print("(Don't hurt yourself.)", 0.5, k, -20);
            break;
			default:
				ptext.Print("@A@A@III", 0.5, -k, 0);
				ptext.Print("i䂵Ȃłˁj", 0.5, k, -20);
            break;			
		}
  		ptext.MessageLeave();  

		ttext.MessageEnter();
		ttext.SetColor(1.0, 1.0, 1.0);	
  		ttext.Print(timer.FPSString(), 0.25, 100, -100);
		ttext.MessageLeave();

		if (k >= -100 && k <= 100) {
			k+=kadd;
		} else {
			kadd*=-1;
			k+=kadd;
		}

		if(++i>=360) {
			i = 0;
		}
		if(motion2[mm[m]].CutNumber() == motion2[mm[m]].TotalCut()) {
			m++;
			if (m == 8) {
			 	m = 0;
			}
			motion2[mm[m]].SetFrame(0);
			mixer.PlayChunk(chunk_number++);			
			if (chunk_number == 9) {
				chunk_number = 2;
		 	}
		}

		SDL_GL_SwapBuffers(); 
		GLmes();

		timer.Wait();
		event.Poll();
		if (IsAnyKeyDown() || event.IsMouse1Down()) {
			break;		
		}
		if (event.IsExpose() && ScreenMode) {
			ScreenReconfig();	
			InitDemo4();
			event.Clear();
			wmes("Change Resolution");
		} 
	} while(!event.IsQuit());
	if (event.IsQuit()) {
		Quit();
	}
}

void Game::InitDemo5() {
	MakeObjects(Partition);

	camera.Init(2);
	camera.Perspective(60.0, 0.05, 20.0);
	camera[0].DefPosition(-0.0f, 4.0f, 2.0f);
	camera[0].DefDirection(0.0f, 0.0f, 0.0f);
	camera[0].DefRotation(0.0f);

	light.Init(0);
	light2.Init(1);
	light.DefDiffuse(0.8, 0.8, 0.8);
	light.DefPosition(0.0, 0.0, 1.0);
	light2.DefPosition(0.0, 0.0, 3.0);
	light2.DefDiffuse(0.5, 0.5, 0.5);
	light.On();
	light2.On();
}

void Game::Demo5() {
	int i=0, k =0, kadd = 1;

	ptext.MakeText("Ȃł̂?");
	
	motion1[0].SetFrame(0);
	motion2[0].SetFrame(0);
	motion1[0].CurrentFrame().Set(&boxer1);
	motion2[0].CurrentFrame().Set(&boxer2);

	timer.SetFPS(50);	
	do {
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		light.Set();
		camera[0].Set();
		light2.Set();

		texs.Choice(TE_FACE);
		glPushMatrix();
		glTranslatef(-0.8, -1.0, 0.0);
		glRotatef((float)-i, 0.0, 0.0, 1.0);
		ShowShadow(boxer2);
		boxer2.CallLists();
		boxer2.CalcCoords();
		glPopMatrix();

		glPushMatrix();
		glTranslatef(0.8, -1.0, 0.0);
		glRotatef((float)i, 0.0, 0.0, 1.0);
		ShowShadow(boxer1);
		boxer1.CallLists();
		boxer1.CalcCoords();
		glPopMatrix();

		texs.Choice(TE_FACE);
		glPushMatrix();
		glTranslatef(-0.8, 2.0, 0.0);
		glRotatef((float)-i, 0.0, 0.0, 1.0);
		ShowShadow(boxer1);
		boxer1.CallLists();
		boxer1.CalcCoords();
		glPopMatrix();

		glPushMatrix();
		glTranslatef(0.8, 2.0, 0.0);
		glRotatef((float)i, 0.0, 0.0, 1.0);
		ShowShadow(boxer2);
		boxer2.CallLists();
		boxer2.CalcCoords();
		glPopMatrix();

		glbg.Show();
		glring.ShowAll();

  		ptext.MessageEnter();
		ptext.SetColor(1.0, 1.0, 1.0);
		switch (lang) {
			case Kana:
				ptext.Print("Ȃł̂", 0.7, 0, -k);
            break;
			case English:
				ptext.Print("Is that OK with this?", 0.7, 0, -k);
            break;
			default:
				ptext.Print("Ȃł̂H", 0.7, 0, -k);
            break;			
		}
  		ptext.MessageLeave();  

		ttext.MessageEnter();
		ttext.SetColor(1.0, 1.0, 1.0);	
  		ttext.Print(timer.FPSString(), 0.25, 100, -100);
		ttext.MessageLeave();

		if (k >= -80 && k <= 80) {
			k+=kadd;
		} else {
			kadd*=-1;
			k+=kadd;
		}

		if(++i>=360) {
			i = 0;
		}
		SDL_GL_SwapBuffers(); 
		GLmes();

		timer.Wait();
		event.Poll();
		if (IsAnyKeyDown() || event.IsMouse1Down()) {
			break;		
		}
		if (event.IsExpose() && ScreenMode) {
			ScreenReconfig();	
			InitDemo5();
			event.Clear();
			wmes("Change Resolution");
		} 
	} while(!event.IsQuit());
	if (event.IsQuit()) {
		Quit();
	}
}

void Game::PeopleMaker() {
	int i=0, k =0, kadd = 1;
	if (!LoadBoxer(handler2, boxer2, motion2, "./Data/people.box")) {
		return;	
	}	
	if (!LoadBoxer(handler1, boxer1, motion1, "./Data/people2.box")) {
		return;	
	}	

 	boxer1.SetPoint(0.0, 0.0, 0.0);
 	boxer2.SetPoint(0.0, 0.0, 0.0);
 
	MakeObjects(Partition);
	boxer1.MakeDLists(Partition, FaceStyle, 1);
	boxer2.MakeDLists(Partition, FaceStyle, 1);	

	camera.Init(2);
	camera.Ortho(0.01, 20.0, 2560, 1920);
//	camera.Ortho(0.01, 20.0, 320, 240);
//	camera.Perspective(60.0, 0.05, 20.0);
	camera[0].DefPosition(-0.0f, 10.0f, 1.0f);
	camera[0].DefDirection(0.0f, 0.0f, 1.0f);
	camera[0].DefRotation(0.0f);

	light.Init(0);
	light2.Init(1);
	light.DefDiffuse(0.8, 0.8, 0.8);
	light.DefPosition(0.0, 0.0, 1.0);
	light2.DefPosition(0.0, 0.0, 3.0);
	light2.DefDiffuse(0.5, 0.5, 0.5);
	light.On();
	light2.On();

	timer.SetFPS(50);	
	do {
		glClearColor(0.1, 0.1, 0.1, 0.0);		
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		light.Set();
		camera[0].Set();
		light2.Set();

		motion1[0].SetFrame(0);
		motion2[1].SetFrame(0);
		motion1[0].CurrentFrame().Set(&boxer1);
		motion2[1].CurrentFrame().Set(&boxer2);

		for (k = 0; k < 13; k++) { 
			texs.Choice(TE_FACE);
			glPushMatrix();
			glTranslatef(-15.5 + k*2*0.6, 2.0, 0.0);
			glRotatef(0, 0.0, 0.0, 1.0);
			ShowShadow(boxer1);
			boxer1.CallPeople();
			boxer1.CalcCoords();
			glPopMatrix();
			glPushMatrix();
			glTranslatef(-15.5 + (k*2+1)*0.6, 1.0, 0.0);
			glRotatef(0, 0.0, 0.0, 1.0);
			ShowShadow(boxer2);
			boxer2.CallPeople();
			boxer2.CalcCoords();
			glPopMatrix();

			glPushMatrix();
			glTranslatef(+15.5 - k*2*0.6, 2.0, 0.0);
			glRotatef(0, 0.0, 0.0, 1.0);
			ShowShadow(boxer1);
			boxer1.CallPeople();
			boxer1.CalcCoords();
			glPopMatrix();
			glPushMatrix();
			glTranslatef(+15.5 - (k*2+1)*0.6, 1.0, 0.0);
			glRotatef(0, 0.0, 0.0, 1.0);
			ShowShadow(boxer2);
			boxer2.CallPeople();
			boxer2.CalcCoords();
			glPopMatrix();
		}

		motion1[4].SetFrame(0);
		motion2[5].SetFrame(0);
		motion1[4].CurrentFrame().Set(&boxer1);
		motion2[5].CurrentFrame().Set(&boxer2);

		for (k = 0; k < 13; k++) { 
			texs.Choice(TE_FACE);
			glPushMatrix();
			glTranslatef(-15.5 + (k*2+1)*0.6, -2.0, 0.5);
			glRotatef(0, 0.0, 0.0, 1.0);
			ShowShadow(boxer1);
			boxer1.CallPeople();
			boxer1.CalcCoords();
			glPopMatrix();
			glPushMatrix();
			glTranslatef(-15.5 + (k*2)*0.6, -2.0, 0.5);
			glRotatef(0, 0.0, 0.0, 1.0);
			ShowShadow(boxer2);
			boxer2.CallPeople();
			boxer2.CalcCoords();
			glPopMatrix();

			glPushMatrix();
			glTranslatef(+15.5 - (k*2+1)*0.6, -2.0, 0.5);
			glRotatef(0, 0.0, 0.0, 1.0);
			ShowShadow(boxer1);
			boxer1.CallPeople();
			boxer1.CalcCoords();
			glPopMatrix();
			glPushMatrix();
			glTranslatef(+15.5 - (k*2)*0.6, -2.0, 0.5);
			glRotatef(0, 0.0, 0.0, 1.0);
			ShowShadow(boxer2);
			boxer2.CallPeople();
			boxer2.CalcCoords();
			glPopMatrix();
		}

		motion1[2].SetFrame(0);
		motion2[3].SetFrame(0);
		motion1[2].CurrentFrame().Set(&boxer1);
		motion2[3].CurrentFrame().Set(&boxer2);


		for (k = 0; k < 13; k++) { 
			texs.Choice(TE_FACE);
			glPushMatrix();
			glTranslatef(-15.5 + (k*2)*0.6, -3.0, 0.75);
			glRotatef(0, 0.0, 0.0, 1.0);
			ShowShadow(boxer1);
			boxer1.CallPeople();
			boxer1.CalcCoords();
			glPopMatrix();
			glPushMatrix();
			glTranslatef(+15.5 - (k*2+1)*0.6, -3.0, 0.75);
			glRotatef(0, 0.0, 0.0, 1.0);
			ShowShadow(boxer2);
			boxer2.CallPeople();
			boxer2.CalcCoords();
			glPopMatrix();

			glPushMatrix();
			glTranslatef(+15.5 - (k*2)*0.6, -3.0, 0.75);
			glRotatef(0, 0.0, 0.0, 1.0);
			ShowShadow(boxer1);
			boxer1.CallPeople();
			boxer1.CalcCoords();
			glPopMatrix();
			glPushMatrix();
			glTranslatef(-15.5 + (k*2+1)*0.6, -3.0, 0.75);
			glRotatef(0, 0.0, 0.0, 1.0);
			ShowShadow(boxer2);
			boxer2.CallPeople();
			boxer2.CalcCoords();
			glPopMatrix();
		}

   /*
		for (k = 0; k < 26; k++) { 
			texs.Choice(TE_FACE);
			glPushMatrix();
			glTranslatef(-15.5 + (k*2)*0.6, -4.0, 1.5);
			glRotatef(0, 0.0, 0.0, 1.0);
			ShowShadow(boxer1);
			boxer1.CallPeople();
			boxer1.CalcCoords();
			glPopMatrix();

			glPushMatrix();
			glTranslatef(-15.5 + (k*2+1)*0.6, -4.0, 1.5);
			glRotatef(0, 0.0, 0.0, 1.0);
			ShowShadow(boxer2);
			boxer2.CallPeople();
			boxer2.CalcCoords();
			glPopMatrix();
		}    */            

		SDL_GL_SwapBuffers(); 
		GLmes();

		timer.Wait();
		event.Poll();
		if (IsAnyKeyDown() || event.IsMouse1Down()) {
			break;		
		}
	/*	if (event.IsExpose() && ScreenMode) {
			ScreenReconfig();	
			InitDemo5();
			event.Clear();
			wmes("Change Resolution");
		}   */
	} while(!event.IsQuit());
	if (event.IsQuit()) {
		Quit();
	}

	ptext.Clear();		 	
}
