#include "game.h"
#include "boxerhandler.h"

void Game::NetworkMatch() {
	while(1) {
		switch (LANMenu()) {
//			case 0:	/*  */
//				OfficialMode();
//			break;
			case 0:	/* }b`CNCGI */
				MatchMake();
			break;
			case 1:	/* JX^ */
				CustomizeSparBoxer(1);
			break;
			case 2:	/* T[o[ */
				ServerLAN();
			break;	
			case 3:	/* NCAg */
				ClientLAN();
			break;
			case 4:	/* r[ */
				NetLobby2();
			break;   
			case 5:	/* r[NCAg */
				NetLobbyClient2();
			break;	
			case 6:	/* ߂ */
				return;
			break;
		}
	}
}

void Game::ServerLAN() {
	int i;
	Uint32 iver, get_iver, size;
	SNet snet;
	SData send, get;

	if (snet.Init() == SDL_FAILURE) {
		return;	
	}
	snet.Server(Port);

	i = 0;
	while(1) {
		WaitClientMessage(snet, i++);
		if (snet.WaitClient() == SDL_SUCCESS) {
			break;	
		}
		event.Poll();
		if (IsAnyKeyDown() || event.IsMouse1Down()) {
  			ServerFailedMenu(snet);
			return;
		}
	}
	ServerOKMenu(snet);

	iver = PDB_VERSION_CODE;	
	snet.Send32(iver);
	get_iver = snet.Get32();
	if (get_iver != iver) {
		VersionFailureMessage();
		wmes("Game::ServerLAN -> Version is different.");
	}
	smes("Game::ServerLAN -> Version OK");		

	while(1) {
		SetKeyRedCorner();
		if (!SelectBoxerLAN(snet)) {
			NetErrorMessage();
			break;		
		}
		PleaseMessage();
   
		send.Init(handler2.CalcDataSize(motion2));
		handler2.SaveBinBoxer(boxer2, motion2, send.RWops());
		snet.Send32(send.Size());   
		snet.SendData(send.Data(), send.Size());   

		size = snet.Get32();
		if (size == QUIT_MATCH) {
			wmes("Game::ServerLAN -> Opponent is quit.");
			break;		
		}
		get.Init(size);
		snet.GetData(get.Data(), get.Size());
		handler1.LoadBinBoxer(boxer1, motion1, get.RWops());
		boxer1.MakeDLists(Partition, FaceStyle);
		boxer1.MakeRanges(Partition);

		snet.Send32(MATCH_START);
		if (snet.Get32() != MATCH_START) {
			wmes("Game::ServerLAN -> Match Start Code Error");
			NetErrorMessage();
			break;
		}
		smes("Game::ServerLAN -> Match Start");		

		if (MatchLAN(snet)) {
			SaveReplayCycle();
			if (!SkipReplay) {
				Replay();
			}
		}
		
		PleaseMessage();
		snet.Send32(MATCH_END_CODE);
		if (snet.Get32() != MATCH_END_CODE) {
			wmes("Game::ServerLAN -> Match End Code Error");
			NetErrorMessage();
			break;
		}
		smes("Game::ServerLAN -> Match End");		

		PleaseMessage();
		if (snet.Get32() != REMATCH_CODE) {
			smes("Game::ServerLAN -> Unconnect");		
			break;
		}
		smes("Game::ServerLAN -> Rematch");		
	}
}

void Game::ClientLAN() {
	Uint32 iver, get_iver, size;
	SNet snet;
	SData send, get;

	if (snet.Init() == SDL_FAILURE) {
		return;	
	}
	if (snet.Client(HostName, Port) == SDL_FAILURE) {
  		ClientFailedMenu(snet);	
		return;
	}
	ClientOKMenu(snet);
	
	iver = PDB_VERSION_CODE;	
	snet.Send32(iver);
	get_iver = snet.Get32();
	if (get_iver != iver) {
		VersionFailureMessage();
		wmes("Game::ClientLAN -> Version is different.");
	}
	smes("Game::ClientLAN -> Version OK");		
	
	while(1) {
		PleaseMessage();
		SetKeyBlueCorner();
		if (!SelectBoxerLAN(snet)) {
			NetErrorMessage();
			break;		
		}
		PleaseMessage();
	
		send.Init(handler1.CalcDataSize(motion1));
		handler1.SaveBinBoxer(boxer1, motion1, send.RWops());
		snet.Send32(send.Size());   
		snet.SendData(send.Data(), send.Size());   

		size = snet.Get32();
		if (size == QUIT_MATCH) {
			wmes("Game::ClientLAN -> Opponent is quit.");
			break;		
		}
		get.Init(size);
		snet.GetData(get.Data(), get.Size());
		handler2.LoadBinBoxer(boxer2, motion2, get.RWops());	
		boxer2.MakeDLists(Partition, FaceStyle);
		boxer2.MakeRanges(Partition); 

		snet.Send32(MATCH_START);
		if (snet.Get32() != MATCH_START) {
			wmes("Game::ClientLAN -> Match Start Code Error");
			NetErrorMessage();
			break;
		}
		smes("Game::ClientLAN -> Match Start");		

		SetKeyBlueCorner();
		if (MatchLAN(snet)) {
			SaveReplayCycle();
			if (!SkipReplay) {
				Replay();
			}
		}
		SetKey1P();
		
		PleaseMessage();
		snet.Send32(MATCH_END_CODE);
		if (snet.Get32() != MATCH_END_CODE) {
			wmes("Game::ClientLAN -> Match End Code Error");		
			NetErrorMessage();
			break;		
		}
		smes("Game::ClientLAN -> Match End");		

		if (ContinueMenu()) {
			snet.Send16(REMATCH_CODE+1);		
			break;		
		} 
		snet.Send16(REMATCH_CODE);		
	}
}

Uint32 Game::MakeSendData(Uint32 key, Uint32 round, Uint32 count) {
	return key | round << 24 | count << 8;
}

Uint8 Game::MakeGetData(Uint32 get_data, Uint8 *round, Uint16 *count) {
	*round = (get_data & 0xff000000) >> 24;
	*count = (get_data & 0x00ffff00) >> 8;
	return get_data & 0x000000ff;
}

void Game::ClearDelayKeysLAN(SNet &snet, Uint32 *send_count, Uint32 *get_count) {
	Uint32 timeout_count;
	int i;
	if (*send_count == 0 && *get_count == 0) {
		return;
	}
	
	snet.Send32(ROUND_END_CODE);
	timeout_count = 0;		
	while(1) {
		if (snet.IsSocketReady()) {
			if (snet.Get32() == ROUND_END_CODE) {
				break;		
			}
		}	
		timeout_count++;
		SDL_Delay(10);
		if (timeout_count > TIMEOUT_COUNT) {
			if (snet.IsClient()) {
				wmes("Game::ClearDelayKeysLAN -> Time Out by Client");
			} else {
				wmes("Game::ClearDelayKeysLAN -> Time Out by Server");
			}
		 	break;
		}
	}
	for (i = *get_count + 1; i <= *send_count; i++) {
			handler1.InvalidKey();
			handler2.InvalidKey();
			handler1.SaveKeyStates(i);
			handler2.SaveKeyStates(i);	
	}
	*send_count = 0;
	*get_count = 0;
}

bool Game::MatchLAN(SNet &snet) {
	Uint32 send_count, get_count, delay, max_delay;
	Uint32 send_data, get_data;
	Uint8 get_round;
	Uint16 get_timecount;
	max_delay = 5;
	send_count = 0;
	get_count = 0;

	mixer.PlayMusic(BGM_MATCH);

	handler1.Init(boxer1, motion1, match);
	handler2.Init(boxer2, motion2, match);

	can_change_mode1 = 0;
	can_change_mode2 = 0;
	which_select = 0;

	handler1.SetMode(FULL_CONTROL);
	handler2.SetMode(FULL_CONTROL);		

	SetCamera();
	SetLights();
	SetDefaultView();	
	SetBoxerPosition(1.6);
	SetBoxerName();

	handler1.SetDistance(distance);	
	handler2.SetDistance(distance);	
	handler1.SetRound(1);
	handler2.SetRound(1);	
	handler1.SaveInfo(0, boxer1, motion1);
	handler2.SaveInfo(0, boxer2, motion2);	 
    match.SetCounter(50);

	NextOff();
	timer.SetFPS(50);	
	do {
		MatchOptions();
		
		match.CalcModeOff();
  
		if (match.IsShowRound()) {
			if (match.RingGong()) {
				mixer.PlayChunk(SE_GONG);
			}
			if (match.HasShownRound()) {
				match.Matching();
				handler1.SaveInfo(0, boxer1, motion1);
				handler2.SaveInfo(0, boxer2, motion2);	
				match.SetCounter(-50);		
			}
		} 
	
		handler1.SetDistance(distance);	
		handler2.SetDistance(distance);	

		if (match.IsMatching()) {
			if (snet.IsClient()) {
				GetKeyStates(handler1);
				GetOffenseMouseStates();
		//		handler1.GetComStates(match, boxer2, handler1);

				delay = send_count - get_count;
				if (delay < max_delay) {
					send_data = MakeSendData(handler1.GetKeyState(), match.Round(), send_count);
					snet.Send32(send_data);
					handler1.SaveKeyStates(send_count);
					send_count++;			
				}  	
				
				if (snet.IsSocketReady()) {
					get_data = snet.Get32();
					handler2.SetKeyState(MakeGetData(get_data, &get_round, &get_timecount));
					handler2.SaveKeyStates(get_count);
					handler1.LoadKeyStates(get_count);
					get_count++;
				} else {
					handler2.InvalidKey();
				}
			} else {
				GetKeyStates(handler2);
				GetOffenseMouseStates();		
		//		handler2.GetComStates(match, boxer2, handler1);

				delay = send_count - get_count;
				if (delay < max_delay) {
					send_data = MakeSendData(handler2.GetKeyState(), match.Round(), send_count);
					snet.Send32(send_data);
					handler2.SaveKeyStates(send_count);
					send_count++;			
				}  	
				
				if (snet.IsSocketReady()) {
					get_data = snet.Get32();
					handler1.SetKeyState(MakeGetData(get_data, &get_round, &get_timecount));
					handler1.SaveKeyStates(get_count);
					handler2.LoadKeyStates(get_count);
					get_count++;
				} else {
					handler1.InvalidKey();
				}
			}
		} else {
			handler1.InitKey();
			handler2.InitKey();
			handler1.Defense();
			handler2.Defense();
			handler1.SaveKeyStates(match.TimeCount());
			handler2.SaveKeyStates(match.TimeCount());
		}
   
		if (match.IsEnd()) {
			match.CalcModeOff();
			ClearDelayKeysLAN(snet, &send_count, &get_count);
		}		
		if (match.IsCalcMode() && !match.IsMatching()) {
			handler1.Defense();			
			handler2.Defense();				
		}

		if (match.IsBeforeMatch() && match.IsCounterZero()) {	
			if ((handler2.IsAnyAction() || handler2.IsFullAuto()) &&
				(handler1.IsAnyAction() || handler1.IsFullAuto())) {
				match.ShowRound();
			}
		}

		if (match.IsRoundInterval()) {	
			ClearDelayKeysLAN(snet, &send_count, &get_count);
			if ((handler2.IsFullControl() && handler2.IsNoKey()) ||
				(handler1.IsFullControl() && handler1.IsNoKey()) ||
				(handler2.IsSemiAuto() && !handler2.IsAnyAction()) ||
				(handler1.IsSemiAuto() && !handler1.IsAnyAction())) {
				match.SkipIntervalCount();			
			}
			if (match.IsSkipInterval() &&
				((handler2.IsAnyAction() || handler2.IsFullAuto()) &&
				 (handler1.IsAnyAction() || handler1.IsFullAuto())) ||
				event.IsKeyPressed(go_next) || event.IsMouse1Pressed()) {
				match.CalcModeOn();
			}
			if (distance > 6.0 &&
				(handler2.IsAnyAction() || handler2.IsFullAuto()) &&
				(handler1.IsAnyAction() || handler1.IsFullAuto())) {
				if (match.IsLastRound()) {
					match.Decision(handler1, handler2);
					if (match.IsExtraRoundSystem() && match.IsDraw() && !match.IsExtraRound()) {
						RoundStart();
					} else {
						match.End();
						mixer.PlayChunk(SE_KO);
						handler1.SaveEndInfo(boxer1, motion1);
						handler2.SaveEndInfo(boxer2, motion2);			
					}
				} else {
					RoundStart();
				}
			}
		}

		if (handler1.IsKeyValid() && handler2.IsKeyValid()) {
			if (!match.IsMatching()) {
				handler1.InitKey();		
				handler2.InitKey();	
			} else {
				if (match.Round() != get_round ||
					match.TimeCount() != get_timecount) {
					if (snet.IsClient()) {
						wmes(" Game::MatchLAN -> Synchronize Error by Client");
					} else {
						wmes(" Game::MatchLAN -> Synchronize Error by Server");				
					}
					fprintf(stderr, "Round = %d,%d TimeCount = %d,%d\n", match.Round(), get_round, match.TimeCount(), get_timecount);			
					break;
				}	
			
				if (handler2.IsCounting() && !handler1.IsCounting()) {
					handler1.InitKey();				
				}
				if (handler1.IsCounting() && !handler2.IsCounting()) {
					handler2.InitKey();		
				}
			}
			if (match.IsCalcMode()) {
				CalcRoutine();		
			} else {
				ShowRoutine();		
			}
		}

		event.Poll();
		ExposeScreen();
		if (match.IsEnd() && (event.IsKeyDown(go_next) || IsNext())) {
			break;		
		}
	} while(!event.IsQuit());
	if (event.IsQuit()) {
		Quit();
	}

	return true;	
}

bool Game::SelectBoxerLAN(SNet &snet) {
	static char buf[255];
	static int select_boxer1 = 1, select_boxer2 = 0;
	static int pre_select_boxer1 = select_boxer1;
	static int pre_select_boxer2 = select_boxer2;
	static int x, y, loop, mouse_select = -1;
	static bool red_select = true, blue_select = false;
	static float size, csize;
	 
	if (snet.IsServer()) {
		match.Init(MaxRound, RoundTime,
			TKOSystem, JudgeSystem, CountSystem, ExtraRound, KOCount,
			Judge1Type, Judge2Type, Judge3Type, 
			ExtraInfo, ReplayRate);
		if (snet.SendData(&match, sizeof(MatchHandler)) == SDL_FAILURE) {
			return false;		
		}
		match.Reset();
 	} else {
		if (snet.GetData(&match, sizeof(MatchHandler)) == SDL_FAILURE) { 
			return false;		
		}
		match.Reset();
	}

	select_boxer1 = -1;
	select_boxer2 = -1;
	if (!SelectBoxer1File(select_boxer1) ||
		!SelectBoxer2File(select_boxer2)) {
		false;
	}

	if (snet.IsServer()) {
		red_select = true;
		blue_select = false;
	} else {
		red_select = false;
		blue_select = true;
	}

	InitSelectBoxer();
	if (select_boxer1 < 0) {
		motion1.OffSet(boxer1);
	}
	if (select_boxer2 < 0) {
		motion2.OffSet(boxer2);
	}	
	
	timer.SetFPS(50);	
	do {
		glClearColor(0.33, 0.33, 0.33, 0.0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		csize =	(0.9 + 0.1 * sin(RAD(5*loop++)));

		SDL_GetMouseState(&x, &y);
		mouse_select = -1;
		MouseSelectGoNext(mouse_select, x, y);
		if (width * 0.00 < x && width * 0.07 > x) {
			if (height* 0.57 < y && height* 0.64 > y) {
				mouse_select = REDCORNER_DOWN;			
			}
			if (height* 0.50 < y && height* 0.57 > y) {
				mouse_select = REDCORNER_UP;			
			}
		}
		if (width * 0.50 < x && width * 0.57 > x) {
			if (height* 0.57 < y && height* 0.64 > y) {
				mouse_select = BLUECORNER_DOWN;			
			}
			if (height* 0.50 < y && height* 0.57 > y) {
				mouse_select = BLUECORNER_UP;			
			}
		}

		if ((mouse_select == BLUECORNER_UP && event.IsMouse1Down()) ||
			event.IsKeyDown(kb1_right) ||
			(blue_select && event.IsKeyDown(kb2_left))) {
			pre_select_boxer1 = select_boxer1;
			select_boxer1++;		
			if (select_boxer1 >= MembersNumber) {
				select_boxer1 = -2;			
			}
		}  
		if ((mouse_select == BLUECORNER_DOWN && event.IsMouse1Down()) ||
			event.IsKeyDown(kb1_left) ||
			(blue_select && event.IsKeyDown(kb2_right))) {
			pre_select_boxer1 = select_boxer1;
			select_boxer1--;		
			if (select_boxer1 < -2) {
				select_boxer1 = MembersNumber - 1;			
			}
		}  
		if ((red_select && event.IsKeyDown(kb2_left)) ||
			(mouse_select == REDCORNER_UP && event.IsMouse1Down())) {
			pre_select_boxer2 = select_boxer2;
			select_boxer2++;		
			if (select_boxer2 >= MembersNumber) {
				select_boxer2 = -2;			
			}
		}  
		if ((red_select && event.IsKeyDown(kb2_right)) ||
			(mouse_select == REDCORNER_DOWN && event.IsMouse1Down())) {
			pre_select_boxer2 = select_boxer2;
			select_boxer2--;		
			if (select_boxer2 < -2) {
				select_boxer2 = MembersNumber - 1;			
			}
		}  

		if (pre_select_boxer1 != select_boxer1) {
			if (SelectBoxer1File(select_boxer1)) {
				boxer1.MakeDLists(Partition, FaceStyle);
				boxer1.MakeRanges(Partition);
				if (select_boxer1 < 0) {
					motion1.OffSet(boxer1);
				}
				pre_select_boxer1 = select_boxer1;
			} else {
				select_boxer1 = pre_select_boxer1;				
				SelectBoxer1File(select_boxer1);				
			}
		}
		if (pre_select_boxer2 != select_boxer2) {
			if (SelectBoxer2File(select_boxer2)) {
				boxer2.MakeDLists(Partition, FaceStyle);
				boxer2.MakeRanges(Partition);
				if (select_boxer2 < 0) {
					motion2.OffSet(boxer2);
				}
				pre_select_boxer2 = select_boxer2;
			} else {
				select_boxer2 = pre_select_boxer2;				
				SelectBoxer2File(select_boxer2);				
			}
		}

		if (snet.IsServer()) {
			RedCornerBoxer();
			RedCornerInfo(select_boxer2, buf);

			if (UsePText) {
				ptext.MessageEnter();
				ptext.SetSpecular(0.0, 0.0, 0.0);
				red_select ? size = csize :size = 1.0;
				ptext.SelectColor(mouse_select == REDCORNER_UP);
				ptext.Symbol(SYMBOL_TRIANGLE_UP2, 0.8*size, -92, 95);
				ptext.SelectColor(mouse_select == REDCORNER_DOWN);
				ptext.Symbol(SYMBOL_TRIANGLE_DOWN2, 0.8*size, -92, 70);
   				ptext.MessageLeave();
			} else {
				ttext.MessageEnter();
				red_select ? size = csize :size = 1.0;
				ttext.SelectColor(mouse_select == REDCORNER_UP);
				ttext.Symbol(SYMBOL_TRIANGLE_UP2, 0.8*size, -92, 95);
				ttext.SelectColor(mouse_select == REDCORNER_DOWN);
				ttext.Symbol(SYMBOL_TRIANGLE_DOWN2, 0.8*size, -92, 70);
   				ttext.MessageLeave();			
			}

/*			glViewport(width/2, height/2, width/2, height/2);
			glMatrixMode(GL_MODELVIEW);
			glLoadIdentity();
			light.Set();
			camera[1].Set();
			light2.Set();
			glring.ShowAll(); */
		} else {
    		BlueCornerBoxer();
			BlueCornerInfo(select_boxer1, buf);
			
			if (UsePText) {
				ptext.MessageEnter();
				ptext.SetSpecular(0.0, 0.0, 0.0);
				blue_select ? size = csize : size = 1.0;
				ptext.SelectColor(mouse_select == BLUECORNER_UP);
				ptext.Symbol(SYMBOL_TRIANGLE_UP2, 0.8*size, -92, 95);
				ptext.SelectColor(mouse_select == BLUECORNER_DOWN);
				ptext.Symbol(SYMBOL_TRIANGLE_DOWN2, 0.8*size, -92, 70);
	   			ptext.MessageLeave();
			} else {
				ttext.MessageEnter();
				blue_select ? size = csize : size = 1.0;
				ttext.SelectColor(mouse_select == BLUECORNER_UP);
				ttext.Symbol(SYMBOL_TRIANGLE_UP2, 0.8*size, -92, 95);
				ttext.SelectColor(mouse_select == BLUECORNER_DOWN);
				ttext.Symbol(SYMBOL_TRIANGLE_DOWN2, 0.8*size, -92, 70);
	   			ttext.MessageLeave();			
			}

/*			glViewport(0, height/2, width/2, height/2);
			glMatrixMode(GL_MODELVIEW);
			glLoadIdentity();
			light.Set();
			camera[0].Set();
			light2.Set();
			glring.ShowAll();  */
		}
		
		glViewport(0, 0, width, height);
		SelectOptions();
		ttext.MessageEnter();
		ShowMatchInfo(buf);
		ttext.SelectColor(mouse_select == GO_NEXT);
   		ttext.Print("Next", 0.25, -100, -100);
		ttext.SetColor(1.0, 1.0, 1.0);	
 		ttext.Print(timer.FPSString(), 0.25, 100, -100);
		ttext.MessageLeave();		

		SDL_GL_SwapBuffers(); 
		GLmes();

		timer.Wait();
		event.Poll();
		if (event.IsKeyDown(go_next) ||
			(mouse_select == GO_NEXT && event.IsMouse1Down())) {
			break;		
		}
		ExposeSelectBoxer();
	} while(!event.IsQuit());
	if (event.IsQuit()) {
		snet.Send32(QUIT_MATCH);
		Quit();
	}
 
 	glViewport(0, 0, width, height);
 	glClearColor(0.0, 0.0, 0.0, 0.0);
//	ttext.Clear();	 	
	return true;
}
