#include "game.h"

void Game::NetLobby() {
    static char buf[20];
	int i, x, y, mouse_select;
	Lobby lobby;
	CGI cgi;

	if (lobby.Init() == SDL_FAILURE) {
		return;	
	}
	if (lobby.ResolveHost(PortLobby) == SDL_FAILURE) {
		LobbyFailedMessage();
		return;	
	}

	if (LobbyMode) {
		if (cgi.Lobby(HostCGI, LobbyCGI, "open", PortLobby, PDB_CAPTION_EN_TITLE) == SDL_FAILURE) {
			CGIFailedMessage();
			return;		
		}
		if (cgi.SetState() == SDL_FAILURE) {
			CGIErrorMessage();
			return;		
		}
	}
	
	timer.SetFPS(1);	
	do {
		glClearColor(0.33, 0.33, 0.33, 0.0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		SelectOptions();

		SDL_GetMouseState(&x, &y);
		mouse_select = -1;
		MouseSelectGoNext(mouse_select, x, y);

		ttext.MessageEnter();
		PlayerNumberStr(lobby.PlayerNumber(), buf);
		ttext.Print(buf, 0.5, 0, 90);
		for (i = 0; i < MAX_ROOM; i++) {
			switch (lobby.RoomState(i)){
				case EMPTY_ROOM :
					strcpy(buf, "[----------]");
				break;
				default : 
					strcpy(buf, (char *)lobby.RoomName(i));
				break;
			}
			ttext.Print(buf, 0.5, 0, 70 - i*20);
		}
		
		ttext.SelectColor(mouse_select == GO_NEXT);
   		ttext.Print("Quit", 0.25, -100, -100);
		ttext.SetColor(1.0, 1.0, 1.0);	
 		ttext.Print(timer.FPSString(), 0.25, 100, -100);
		ttext.MessageLeave();		

		SDL_GL_SwapBuffers(); 
		GLmes();

		lobby.CheckSockets();
		lobby.WaitClients();
		lobby.HandleClients();

	//	timer.Wait();
		event.Poll();
		if (event.IsKeyDown(go_next) ||
			(mouse_select == GO_NEXT && event.IsMouse1Down())) {
			break;		
		}
		ExposeSelectBoxer();
	} while(!event.IsQuit());
	if (LobbyMode) {
		cgi.Lobby(HostCGI, LobbyCGI, "close", PortLobby, PDB_CAPTION_EN_TITLE);
		cgi.SetState();
	}
	if (event.IsQuit()) {
		Quit();
	}
 	glClearColor(0.0, 0.0, 0.0, 0.0);
}

void Game::NetLobby2() {
    static char buf[20];
	int i, x, y, mouse_select;
	Lobby2 lobby;
	CGI cgi;

	if (lobby.Init() == SDL_FAILURE) {
		return;	
	}
	if (lobby.ResolveHost(PortLobby) == SDL_FAILURE) {
		LobbyFailedMessage();
		return;	
	}

	if (LobbyMode) {
		if (cgi.Lobby(HostCGI, LobbyCGI, "open", PortLobby, PDB_CAPTION_EN_TITLE) == SDL_FAILURE) {
			CGIFailedMessage();
			return;		
		}
		if (cgi.SetState() == SDL_FAILURE) {
			CGIErrorMessage();
			return;		
		}
	}
	
	timer.SetFPS(1);	
	do {
		glClearColor(0.33, 0.33, 0.33, 0.0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		SelectOptions();

		SDL_GetMouseState(&x, &y);
		mouse_select = -1;
		MouseSelectGoNext(mouse_select, x, y);

		ttext.MessageEnter();
		PlayerNumberStr(lobby.PlayerNumber(), buf);
		ttext.Print(buf, 0.5, 0, 90);
		for (i = 0; i < MAX_ROOM; i++) {
			switch (lobby.RoomState(i)){
				case EMPTY_ROOM :
					strcpy(buf, "[----------]");
				break;
				default : 
					strcpy(buf, (char *)lobby.RoomName(i));
				break;
			}
			ttext.Print(buf, 0.5, 0, 70 - i*20);
		}
		
		ttext.SelectColor(mouse_select == GO_NEXT);
   		ttext.Print("Quit", 0.25, -100, -100);
		ttext.SetColor(1.0, 1.0, 1.0);	
 		ttext.Print(timer.FPSString(), 0.25, 100, -100);
		ttext.MessageLeave();		

		SDL_GL_SwapBuffers(); 
		GLmes();

		lobby.CheckSockets();
		lobby.WaitClients();
		lobby.HandleClients();

	//	timer.Wait();
		event.Poll();
		if (event.IsKeyDown(go_next) ||
			(mouse_select == GO_NEXT && event.IsMouse1Down())) {
			break;		
		}
		ExposeSelectBoxer();
	} while(!event.IsQuit());
	if (LobbyMode) {
		cgi.Lobby(HostCGI, LobbyCGI, "close", PortLobby, PDB_CAPTION_EN_TITLE);
		cgi.SetState();
	}
	if (event.IsQuit()) {
		Quit();
	}
 	glClearColor(0.0, 0.0, 0.0, 0.0);
}


void Game::NetLobbyClient() {
	static int select, mouse_select, key_select;
	static int i, loop, x, y;
	static float ssize, csize;
    static char buf[20];

	LobbyClient client;
	SNet snet;
	CGI cgi;

	if (client.Init() == SDL_FAILURE) {
		return;	
	}
	if (snet.Init() == SDL_FAILURE) {
		return;	
	}

	if (LobbyMode) {
		if (cgi.Lobby(HostCGI, LobbyCGI, "client", PortLobby, PDB_CAPTION_EN_TITLE) == SDL_FAILURE) {
			CGIFailedMessage();
			return;	
		}
		if (cgi.SetState() == SDL_FAILURE) {
			CGIErrorMessage();
			return;		
		}		
		if (client.ConnectLobby(UserName, cgi.Host(0), cgi.Port(0), Port) == SDL_FAILURE) {
			LobbyClientFailedMessage();
			return;	
		}	
	} else {
		if (client.ConnectLobby(UserName, HostName, PortLobby, Port) == SDL_FAILURE) {
			LobbyClientFailedMessage();
			return;	
		}
	}	

	timer.SetFPS(50);	
	do {
		glClearColor(0.33, 0.33, 0.33, 0.0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		SelectOptions();

		SDL_GetMouseState(&x, &y);
		mouse_select = -1;
		MouseSelectGoNext(mouse_select, x, y);
		if (width*0.25  < x && width*0.75 > x) {
			for (i = 0; i < MAX_ROOM; i++) {
				if (height*(0.15 + (float)i*0.09) < y &&
					height*(0.24 + (float)i*0.09) > y) {
   		    		mouse_select = i;
				}
			}
		}

		if (event.IsKeyDown(kb2_left) ||  
			event.IsKeyDown(kb2_forward)) {  
			if (key_select > 0) {
				key_select--;
			}
		}
		if (event.IsKeyDown(kb2_right) ||  
			event.IsKeyDown(kb2_back)) {  
			if (key_select < MAX_ROOM-1) {
				key_select++;
			}
		}
		csize =	(1.0 + 0.2 * sin(RAD(2*loop++)));

		ttext.MessageEnter();
		PlayerNumberStr(client.PlayerNumber(), buf);
		ttext.Print(buf, 0.5, 0, 90);

		for (i = 0; i < MAX_ROOM; i++) {
			ttext.SelectColor(mouse_select == i);
			key_select == i ? ssize = csize : ssize = 1.0;
			switch (client.RoomState(i)){
				case EMPTY_ROOM :
					strcpy(buf, "[----------]");
				break;
				default : 
					strcpy(buf, (char *)client.RoomName(i));
				break;
			}
			ttext.Print(buf, 0.5 * ssize, 0, 70 - i*20);
		}

		if (IsAnyKeyDown()) {
			client.RequestRoom(key_select);
		}
		if (mouse_select != -1 && event.IsMouse1Down()) {
			client.RequestRoom(mouse_select);
		}
				
		ttext.SelectColor(mouse_select == GO_NEXT);
   		ttext.Print("Quit", 0.25, -100, -100);
		ttext.SetColor(1.0, 1.0, 1.0);	
 		ttext.Print(timer.FPSString(), 0.25, 100, -100);
		ttext.MessageLeave();		

		SDL_GL_SwapBuffers(); 
		GLmes();

		if (client.IsReady()) {
			switch (client.Handle()) {
				case MATCH_RED:
					snet.Server(Port);
					LobbyMatch(snet);
					snet.CloseSockets();
					client.ReturnLobby();
				break;	
				case MATCH_BLUE:
					SDL_Delay(500);
					fprintf(stderr, "ip = %s port = %d\n", client.HostIP(), client.Port());
					if (snet.Client(client.HostIP(), client.Port()) == SDL_FAILURE) {
						CGIFailedMessage();
						client.ReturnLobby();
		    		} else {
						LobbyMatch(snet);
						snet.CloseSockets();
						client.ReturnLobby();				
					}
				break;	
				default:
				break;			
			}
		}			

		timer.Wait();
		event.Poll();
		if (event.IsKeyDown(go_next) ||
			(mouse_select == GO_NEXT && event.IsMouse1Down())) {
			break;		
		}
		ExposeSelectBoxer();
	} while(!event.IsQuit());
	client.LeaveLobby();
	if (event.IsQuit()) {
		Quit();
	}
 	glClearColor(0.0, 0.0, 0.0, 0.0);
}


int Game::LobbyMatch(SNet &snet) {
	Uint32 iver, get_iver, size;
	SData send, get;
	
	if (snet.IsServer()) {
		while (1) {
			if (snet.WaitClient() == SDL_SUCCESS) {
				break;			
			}
			SDL_Delay(10);		
		}
	}

	iver = PDB_VERSION_CODE;	
	snet.Send32(iver);
	get_iver = snet.Get32();
	if (get_iver != iver) {
		wmes("Game::LobbyMatch -> Version is diffrent.");
		VersionFailureMessage();
	}
	smes("Game::LobbyMatch");		

	if (snet.IsServer()) {
		SetKeyRedCorner();
	} else {
		SetKeyBlueCorner();	
	}

	if (!SelectBoxerLAN(snet)) {
		NetErrorMessage();
		return SDL_FAILURE;
	}
	PleaseMessage();
   
	if (snet.IsServer()) {
		send.Init(handler2.CalcDataSize(motion2));
   		handler2.SaveBinBoxer(boxer2, motion2, send.RWops());
	} else {
   		send.Init(handler1.CalcDataSize(motion1));
		handler1.SaveBinBoxer(boxer1, motion1, send.RWops());
	}
	snet.Send32(send.Size());   
	snet.SendData(send.Data(), send.Size());   

	size = snet.Get32();
	if (size == QUIT_MATCH) {
		wmes("Game::LobbyMatch -> Opponent is quit.");
		return SDL_FAILURE;
	}
	get.Init(size);
	snet.GetData(get.Data(), get.Size());
	if (snet.IsServer()) {
		handler1.LoadBinBoxer(boxer1, motion1, get.RWops());
		boxer1.MakeDLists(Partition, FaceStyle);
		boxer1.MakeRanges(Partition);
	} else {
		handler2.LoadBinBoxer(boxer2, motion2, get.RWops());	
		boxer2.MakeDLists(Partition, FaceStyle);
		boxer2.MakeRanges(Partition);	
	}

	snet.Send32(MATCH_START);
	if (snet.Get32() != MATCH_START) {
		wmes("Game::LobbyMatch -> Code Error");
		NetErrorMessage();
		return SDL_FAILURE;
	}
	smes("Game::LobbyMatch -> Match Start");		

	if (snet.IsServer()) {
		SetKeyRedCorner();
	} else {
		SetKeyBlueCorner();	
	}
	if (MatchLAN(snet)) {
		SaveReplayCycle();
		if (!SkipReplay) {
			Replay();
		}
	}
	if (snet.IsClient()) {
		SetKey1P();
	}
		
	PleaseMessage();
	snet.Send32(MATCH_END_CODE);
	if (snet.Get32() != MATCH_END_CODE) {
		wmes("Game::LobbyMatch -> Match End Code Error");
		NetErrorMessage();
		return SDL_FAILURE;
	}
	smes("Game::LobbyMatch -> Match End");		
}

void Game::NetLobbyClient2() {
	static int select, mouse_select, key_select;
	static int i, loop, x, y;
	static float size, csize;
    static char buf[20];

	LobbyClient2 client;
	CGI cgi;

	if (client.Init() == SDL_FAILURE) {
		return;	
	}

	if (LobbyMode) {
		if (cgi.Lobby(HostCGI, LobbyCGI, "client", PortLobby, PDB_CAPTION_EN_TITLE) == SDL_FAILURE) {
			CGIFailedMessage();
			return;	
		}
		if (cgi.SetState() == SDL_FAILURE) {
			CGIErrorMessage();
			return;		
		}		
		if (client.ConnectLobby(UserName, cgi.Host(0), cgi.Port(0)) == SDL_FAILURE) {
			LobbyClientFailedMessage();
			return;	
		}	
	} else {
		if (client.ConnectLobby(UserName, HostName, PortLobby) == SDL_FAILURE) {
			LobbyClientFailedMessage();
			return;	
		}
	}	

	timer.SetFPS(50);	
	do {
		glClearColor(0.33, 0.33, 0.33, 0.0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		SelectOptions();

		SDL_GetMouseState(&x, &y);
		mouse_select = -1;
		MouseSelectGoNext(mouse_select, x, y);
		if (width*0.25  < x && width*0.75 > x) {
			for (i = 0; i < MAX_ROOM; i++) {
				if (height*(0.15 + (float)i*0.09) < y &&
					height*(0.24 + (float)i*0.09) > y) {
   		    		mouse_select = i;
				}
			}
		}

		if (event.IsKeyDown(kb2_left) ||  
			event.IsKeyDown(kb2_forward)) {  
			if (key_select > 0) {
				key_select--;
			}
		}
		if (event.IsKeyDown(kb2_right) ||  
			event.IsKeyDown(kb2_back)) {  
			if (key_select < MAX_ROOM-1) {
				key_select++;
			}
		}
		csize =	(1.0 + 0.2 * sin(RAD(2*loop++)));

		ttext.MessageEnter();
		PlayerNumberStr(client.PlayerNumber(), buf);
		ttext.Print(buf, 0.5, 0, 90);

		for (i = 0; i < MAX_ROOM; i++) {
			ttext.SelectColor(mouse_select == i);
			key_select == i ? size = csize : size = 1.0;
			switch (client.RoomState(i)){
				case EMPTY_ROOM :
					strcpy(buf, "[----------]");
				break;
				default : 
					strcpy(buf, (char *)client.RoomName(i));
				break;
			}
			ttext.Print(buf, 0.5 * size, 0, 70 - i*20);
		}

		if (IsAnyKeyDown()) {
			client.RequestRoom(key_select);
		}
		if (mouse_select != -1 && event.IsMouse1Down()) {
			client.RequestRoom(mouse_select);
		}
				
		ttext.SelectColor(mouse_select == GO_NEXT);
   		ttext.Print("Quit", 0.25, -100, -100);
		ttext.SetColor(1.0, 1.0, 1.0);	
 		ttext.Print(timer.FPSString(), 0.25, 100, -100);
		ttext.MessageLeave();		

		SDL_GL_SwapBuffers(); 
		GLmes();

		if (client.IsReady()) {
			switch (client.Handle()) {
				case MATCH_BLUE:			
				case MATCH_RED:			
					if (SelectBoxer2(client)) {
						StartMatch2(client);
					}
					client.ReturnLobby();
				break;	
				default:
				break;			
			}
		}			
		timer.Wait();
		event.Poll();
		if (event.IsKeyDown(go_next) ||
			(mouse_select == GO_NEXT && event.IsMouse1Down())) {
			break;		
		}
		ExposeSelectBoxer();
	} while(!event.IsQuit());
	client.LeaveLobby();
	if (event.IsQuit()) {
		Quit();
	}
 	glClearColor(0.0, 0.0, 0.0, 0.0);
}


bool Game::ClearFlowData2(LobbyClient2 &lc) {
	int timeout_count;

	lc.SendInt(MATCH_START);	
	timeout_count = 0;		
	while(1) {
		SDL_Delay(10);
		if (lc.IsReady2()) {
			if (lc.GetInt() == MATCH_START) {
				break;
			}
		}	
		timeout_count++;
		if (timeout_count > TIMEOUT_COUNT) {
			if (lc.IsBlueCorner()) {
				wmes("Game::ClearFlowData2 -> Time Out by Blue");
			} else {
				wmes("Game::ClearFlowData2 -> Time Out by Red");
			}
			return false;
		}
	}
	return true;
}


void Game::ClearDelayKeys2(LobbyClient2 &lc, Uint32 *send_count, Uint32 *get_count) {
	Uint32 end_code;
	int i, timeout_count;
	if (*send_count == 0 && *get_count == 0) {
		return;
	}
	
	lc.SendInt(ROUND_END_CODE);
	timeout_count = 0;		
	while(1) {
		if (lc.IsReady2()) {
			end_code = lc.GetInt();
			if (end_code == ROUND_END_CODE) {
				break;		
			}
		}	
		timeout_count++;
		SDL_Delay(10);
		if (timeout_count > TIMEOUT_COUNT) {
			if (lc.IsBlueCorner()) {
				wmes("Game::ClearDelayKeys2 -> Time Out by Blue");
			} else {
				wmes("Game::ClearDelayKeys2 -> Time Out by Red");
			}
		 	break;
		}
	}
	for (i = *get_count + 1; i <= *send_count; i++) {
			handler1.InvalidKey();
			handler2.InvalidKey();
			handler1.SaveKeyStates(i);
			handler2.SaveKeyStates(i);	
	}
	*send_count = 0;
	*get_count = 0;
}


bool Game::LobbyMatch2(LobbyClient2 &lc) {
	Uint32 send_count, get_count, delay, max_delay;
	Uint32 send_data, get_data, check_end;
	Uint16 get_timecount;
	Uint8 get_round;
	check_end = 1;
	max_delay = 5;
	send_count = 0;
	get_count = 0;

	mixer.PlayMusic(BGM_MATCH);

	handler1.Init(boxer1, motion1, match);
	handler2.Init(boxer2, motion2, match);

	can_change_mode1 = 0;
	can_change_mode2 = 0;
	which_select = 0;

	handler1.SetMode(FULL_CONTROL);
	handler2.SetMode(FULL_CONTROL);		

	SetCamera();
	SetLights();
	SetDefaultView();	
	SetBoxerPosition(1.6);
	SetBoxerName();

	handler1.SetDistance(distance);	
	handler2.SetDistance(distance);	
	handler1.SetRound(1);
	handler2.SetRound(1);	
	handler1.SaveInfo(0, boxer1, motion1);
	handler2.SaveInfo(0, boxer2, motion2);	 
    match.SetCounter(50);

	NextOff();
	timer.SetFPS(50);	
	do {
		MatchOptions();
		
		match.CalcModeOff();
  
		if (match.IsShowRound()) {
			if (match.RingGong()) {
				mixer.PlayChunk(SE_GONG);
			}
			if (match.HasShownRound()) {
				match.Matching();
				handler1.SaveInfo(0, boxer1, motion1);
				handler2.SaveInfo(0, boxer2, motion2);	
				match.SetCounter(-50);		
			}
		} 
	
		handler1.SetDistance(distance);	
		handler2.SetDistance(distance);	

		if (match.IsMatching()) {
			if (lc.IsBlueCorner()) {
				GetKeyStates(handler1);
				GetOffenseMouseStates();
		//		handler1.GetComStates(match, boxer2, handler1);

				delay = send_count - get_count;
				if (delay < max_delay) {
					send_data = MakeSendData(handler1.GetKeyState(), match.Round(), send_count);
					lc.SendInt(send_data);
					handler1.SaveKeyStates(send_count);
					send_count++;			
				}  	
				
				if (lc.IsReady2()) {
					get_data = lc.GetInt();
					handler2.SetKeyState(MakeGetData(get_data, &get_round, &get_timecount));
					handler2.SaveKeyStates(get_count);
					handler1.LoadKeyStates(get_count);
					get_count++;
				} else {
					handler2.InvalidKey();
				}
			} else {
				GetKeyStates(handler2);
				GetOffenseMouseStates();		
		//		handler2.GetComStates(match, boxer2, handler1);

				delay = send_count - get_count;
				if (delay < max_delay) {
					send_data = MakeSendData(handler2.GetKeyState(), match.Round(), send_count);
					lc.SendInt(send_data);
					handler2.SaveKeyStates(send_count);
					send_count++;			
				}  	
				
				if (lc.IsReady2()) {
					get_data = lc.GetInt();
					handler1.SetKeyState(MakeGetData(get_data, &get_round, &get_timecount));
					handler1.SaveKeyStates(get_count);
					handler2.LoadKeyStates(get_count);
					get_count++;
				} else {
					handler1.InvalidKey();
				}
			}
		} else {
			handler1.InitKey();
			handler2.InitKey();
			handler1.Defense();
			handler2.Defense();
			handler1.SaveKeyStates(match.TimeCount());
			handler2.SaveKeyStates(match.TimeCount());
		}

		if (match.IsEnd()) {
			match.CalcModeOff();
			ClearDelayKeys2(lc, &send_count, &get_count);
			CheckEndCode2(lc, &check_end);
		}		
		if (match.IsCalcMode() && !match.IsMatching()) {
			handler1.Defense();			
			handler2.Defense();				
		}

		if (match.IsBeforeMatch() && match.IsCounterZero()) {	
			if ((handler2.IsAnyAction() || handler2.IsFullAuto()) &&
				(handler1.IsAnyAction() || handler1.IsFullAuto())) {
				match.ShowRound();
			}
		}

		if (match.IsRoundInterval()) {	
			ClearDelayKeys2(lc, &send_count, &get_count);
			if ((handler2.IsFullControl() && handler2.IsNoKey()) ||
				(handler1.IsFullControl() && handler1.IsNoKey()) ||
				(handler2.IsSemiAuto() && !handler2.IsAnyAction()) ||
				(handler1.IsSemiAuto() && !handler1.IsAnyAction())) {
				match.SkipIntervalCount();			
			}
			if (match.IsSkipInterval() &&
				((handler2.IsAnyAction() || handler2.IsFullAuto()) &&
				 (handler1.IsAnyAction() || handler1.IsFullAuto())) ||
				event.IsKeyPressed(go_next) || event.IsMouse1Pressed()) {
				match.CalcModeOn();
			}
			if (distance > 6.0 &&
				(handler2.IsAnyAction() || handler2.IsFullAuto()) &&
				(handler1.IsAnyAction() || handler1.IsFullAuto())) {
				if (match.IsLastRound()) {
					match.Decision(handler1, handler2);
					if (match.IsExtraRoundSystem() && match.IsDraw() && !match.IsExtraRound()) {
						RoundStart();
					} else {
						match.End();
						mixer.PlayChunk(SE_KO);
						handler1.SaveEndInfo(boxer1, motion1);
						handler2.SaveEndInfo(boxer2, motion2);			
					}
				} else {
					RoundStart();
				}
			}
		}

		if (handler1.IsKeyValid() && handler2.IsKeyValid()) {
			if (!match.IsMatching()) {
				handler1.InitKey();		
				handler2.InitKey();	
			} else {
				if (match.Round() != get_round ||
					match.TimeCount() != get_timecount) {
					if (lc.IsBlueCorner()) {
						wmes("Game::LobbyMatch2 -> Synchronize Error by Blue");
					} else {
						wmes("Game::LobbyMatch2 -> Synchronize Error by Red");				
					}
					fprintf(stderr, "Round = %d,%d TimeCount = %d,%d\n", match.Round(), get_round, match.TimeCount(), get_timecount);			
					break;
				}	
			
				if (handler2.IsCounting() && !handler1.IsCounting()) {
					handler1.InitKey();				
				}
				if (handler1.IsCounting() && !handler2.IsCounting()) {
					handler2.InitKey();		
				}
			}
			if (match.IsCalcMode()) {
				CalcRoutine();		
			} else {
				ShowRoutine();		
			}
		}

		event.Poll();
		ExposeScreen();
		if (match.IsEnd() && (event.IsKeyDown(go_next) || IsNext())) {
			break;		
		}
	} while(!event.IsQuit());
	if (event.IsQuit()) {
		lc.SendInt(QUIT_MATCH);
		lc.LeaveLobby();
		Quit();
	}

	return true;	
}

bool Game::SelectBoxer2(LobbyClient2 &lc) {
	static char buf[255];
	static int select_boxer1 = 1, select_boxer2 = 0;
	static int pre_select_boxer1 = select_boxer1;
	static int pre_select_boxer2 = select_boxer2;
	static int x, y, loop, mouse_select = -1;
	static bool red_select = true, blue_select = false;
	static float size, csize;

/*	if (!ClearFlowData2(lc)) {
		return false;	
	}   */ 

	CheckVersion2(lc);

	if (lc.IsRedCorner()) {
		match.Init(MaxRound, RoundTime,
			TKOSystem, JudgeSystem, CountSystem, ExtraRound, KOCount,
			Judge1Type, Judge2Type, Judge3Type, 
			ExtraInfo, ReplayRate);
		if (lc.SendPacket(&match, sizeof(MatchHandler)) == SDL_FAILURE) {
			wmes("Game::SelectBoxer2 -> Can't send match data.");
			return false;		
		}    
		match.Reset();
 	} else {
		if (lc.WaitData2(300) == SDL_FAILURE) {
			wmes("Game::SelectBoxer2 -> Time Out by Blue");	
		}
		if (lc.GetPacket(&match, sizeof(MatchHandler)) == SDL_FAILURE) { 
			wmes("Game::SelectBoxer2 -> Can't get match data.");
			return false;		
		}   
		match.Reset();
	}

 	select_boxer1 = -1;
 	select_boxer2 = -1;	
	if (!SelectBoxer1File(select_boxer1) ||
		!SelectBoxer2File(select_boxer2)) {
		false;
	}

	if (lc.IsRedCorner()) {
		red_select = true;
		blue_select = false;
	} else {
		red_select = false;
		blue_select = true;
	}

	InitSelectBoxer();	
	if (select_boxer1 < 0) {
		motion1.OffSet(boxer1);
	}
	if (select_boxer2 < 0) {
		motion2.OffSet(boxer2);
	}	

	timer.SetFPS(50);	
	do {
		glClearColor(0.33, 0.33, 0.33, 0.0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		csize =	(0.9 + 0.1 * sin(RAD(5*loop++)));

		SDL_GetMouseState(&x, &y);
		mouse_select = -1;
		MouseSelectGoNext(mouse_select, x, y);
		if (width * 0.00 < x && width * 0.07 > x) {
			if (height* 0.57 < y && height* 0.64 > y) {
				mouse_select = REDCORNER_DOWN;			
			}
			if (height* 0.50 < y && height* 0.57 > y) {
				mouse_select = REDCORNER_UP;			
			}
		}
		if (width * 0.50 < x && width * 0.57 > x) {
			if (height* 0.57 < y && height* 0.64 > y) {
				mouse_select = BLUECORNER_DOWN;			
			}
			if (height* 0.50 < y && height* 0.57 > y) {
				mouse_select = BLUECORNER_UP;			
			}
		}

		if ((mouse_select == BLUECORNER_UP && event.IsMouse1Down()) ||
			event.IsKeyDown(kb1_right) ||
			(blue_select && event.IsKeyDown(kb2_left))) {
			pre_select_boxer1 = select_boxer1;
			select_boxer1++;		
			if (select_boxer1 >= MembersNumber) {
				select_boxer1 = -2;			
			}
		}  
		if ((mouse_select == BLUECORNER_DOWN && event.IsMouse1Down()) ||
			event.IsKeyDown(kb1_left) ||
			(blue_select && event.IsKeyDown(kb2_right))) {
			pre_select_boxer1 = select_boxer1;
			select_boxer1--;		
			if (select_boxer1 < -2) {
				select_boxer1 = MembersNumber - 1;			
			}
		}  
		if ((red_select && event.IsKeyDown(kb2_left)) ||
			(mouse_select == REDCORNER_UP && event.IsMouse1Down())) {
			pre_select_boxer2 = select_boxer2;
			select_boxer2++;		
			if (select_boxer2 >= MembersNumber) {
				select_boxer2 = -2;			
			}
		}  
		if ((red_select && event.IsKeyDown(kb2_right)) ||
			(mouse_select == REDCORNER_DOWN && event.IsMouse1Down())) {
			pre_select_boxer2 = select_boxer2;
			select_boxer2--;		
			if (select_boxer2 < -2) {
				select_boxer2 = MembersNumber - 1;			
			}
		}  

		if (pre_select_boxer1 != select_boxer1) {
			if (SelectBoxer1File(select_boxer1)) {
				boxer1.MakeDLists(Partition, FaceStyle);
				boxer1.MakeRanges(Partition);
				if (select_boxer1 < 0) {
					motion1.OffSet(boxer1);
				}
				pre_select_boxer1 = select_boxer1;
			} else {
				select_boxer1 = pre_select_boxer1;				
				SelectBoxer1File(select_boxer1);				
			}
		}
		if (pre_select_boxer2 != select_boxer2) {
			if (SelectBoxer2File(select_boxer2)) {
				boxer2.MakeDLists(Partition, FaceStyle);
				boxer2.MakeRanges(Partition);
				if (select_boxer2 < 0) {
					motion2.OffSet(boxer2);
				}
				pre_select_boxer2 = select_boxer2;
			} else {
				select_boxer2 = pre_select_boxer2;				
				SelectBoxer2File(select_boxer2);				
			}
		}

		if (lc.IsRedCorner()) {
			RedCornerBoxer();
			RedCornerInfo(select_boxer2, buf);

			if (UsePText) {
				ptext.MessageEnter();
				ptext.SetSpecular(0.0, 0.0, 0.0);
				red_select ? size = csize :size = 1.0;
				ptext.SelectColor(mouse_select == REDCORNER_UP);
				ptext.Symbol(SYMBOL_TRIANGLE_UP2, 0.8*size, -92, 95);
				ptext.SelectColor(mouse_select == REDCORNER_DOWN);
				ptext.Symbol(SYMBOL_TRIANGLE_DOWN2, 0.8*size, -92, 70);
   				ptext.MessageLeave();
			} else {
				ttext.MessageEnter();
				red_select ? size = csize :size = 1.0;
				ttext.SelectColor(mouse_select == REDCORNER_UP);
				ttext.Symbol(SYMBOL_TRIANGLE_UP2, 0.8*size, -92, 95);
				ttext.SelectColor(mouse_select == REDCORNER_DOWN);
				ttext.Symbol(SYMBOL_TRIANGLE_DOWN2, 0.8*size, -92, 70);
   				ttext.MessageLeave();			
			}
		} else {
    		BlueCornerBoxer();
			BlueCornerInfo(select_boxer1, buf);
			
			if (UsePText) {
				ptext.MessageEnter();
				ptext.SetSpecular(0.0, 0.0, 0.0);
				blue_select ? size = csize : size = 1.0;
				ptext.SelectColor(mouse_select == BLUECORNER_UP);
				ptext.Symbol(SYMBOL_TRIANGLE_UP2, 0.8*size, -92, 95);
				ptext.SelectColor(mouse_select == BLUECORNER_DOWN);
				ptext.Symbol(SYMBOL_TRIANGLE_DOWN2, 0.8*size, -92, 70);
	   			ptext.MessageLeave();
			} else {
				ttext.MessageEnter();
				blue_select ? size = csize : size = 1.0;
				ttext.SelectColor(mouse_select == BLUECORNER_UP);
				ttext.Symbol(SYMBOL_TRIANGLE_UP2, 0.8*size, -92, 95);
				ttext.SelectColor(mouse_select == BLUECORNER_DOWN);
				ttext.Symbol(SYMBOL_TRIANGLE_DOWN2, 0.8*size, -92, 70);
	   			ttext.MessageLeave();			
			}
		}
		
		glViewport(0, 0, width, height);
		SelectOptions();
		ttext.MessageEnter();
		ShowMatchInfo(buf);
		ttext.SelectColor(mouse_select == GO_NEXT);
   		ttext.Print("Next", 0.25, -100, -100);
		ttext.SetColor(1.0, 1.0, 1.0);	
 		ttext.Print(timer.FPSString(), 0.25, 100, -100);
		ttext.MessageLeave();		

		SDL_GL_SwapBuffers(); 
		GLmes();

		timer.Wait();
		event.Poll();
		if (event.IsKeyDown(go_next) ||
			(mouse_select == GO_NEXT && event.IsMouse1Down())) {
			break;		
		}
		ExposeSelectBoxer();
	} while(!event.IsQuit());
	if (event.IsQuit()) {
		lc.SendInt(QUIT_MATCH);
		lc.LeaveLobby();
		Quit();
	}
 	glViewport(0, 0, width, height);
 	glClearColor(0.0, 0.0, 0.0, 0.0);

	return SendBoxerData2(lc);
}

bool Game::SendBoxerData2(LobbyClient2 &lc) {
	SData send, get;
	Uint32 size;

	PleaseMessage();
	if (lc.IsBlueCorner()) {
		send.Init(handler1.CalcDataSize(motion1));
		handler1.SaveBinBoxer(boxer1, motion1, send.RWops());
    } else {
		send.Init(handler2.CalcDataSize(motion2));
		handler2.SaveBinBoxer(boxer2, motion2, send.RWops());	
	}

	size = send.Size();
 	lc.SendInt(size);
	if (lc.SendPacket(send.Data(), send.Size()) == SDL_FAILURE) {
		wmes("Game::SendBoxerData2 -> Can't send data.");
		return false;	
	}  

	size = lc.GetInt();
	if (size == QUIT_MATCH) {
		wmes("Game::SendBoxerData2 -> Opponent is quit.");
		return false;	
	}
	get.Init(size);
	if (lc.GetPacket(get.Data(), get.Size()) == SDL_FAILURE) {
		wmes("Game::SendBoxerData2 -> Can't get data.");
		return false;	
	} 

	if (lc.IsBlueCorner()) {
		handler2.LoadBinBoxer(boxer2, motion2, get.RWops());	
		boxer2.MakeDLists(Partition, FaceStyle);
		boxer2.MakeRanges(Partition); 
	} else {
		handler1.LoadBinBoxer(boxer1, motion1, get.RWops());	
		boxer1.MakeDLists(Partition, FaceStyle);
		boxer1.MakeRanges(Partition); 	
	}

	return true;
}

void Game::StartMatch2(LobbyClient2 &lc) {
	if (lc.IsBlueCorner()) {
		SetKeyBlueCorner();
	}		

	if (LobbyMatch2(lc)) {
		if (!SkipReplay) {
			Replay();
		}
	}

	if (lc.IsBlueCorner()) {
		SetKey1P();
	}	
}

bool Game::CheckVersion2(LobbyClient2 &lc) {
	Uint32 iver, get_iver;
	iver = PDB_VERSION_CODE;
	lc.SendInt(iver);
	
	get_iver = lc.GetInt();		
	if (iver != get_iver) {
		wmes("Game::CheckVersion2 -> Version is different.");
		if (lc.IsRedCorner()) {
			fprintf(stderr, "Red  ver = %d\n", iver);
			fprintf(stderr, "Blue ver = %d\n", get_iver);
		} else {
			fprintf(stderr, "Blue ver = %d\n", iver);
			fprintf(stderr, "Red  ver = %d\n", get_iver);
		}
		return false;
	}
	smes("Game::CheckVersion2 -> Match Start");	
	return true;
}

bool Game::CheckEndCode2(LobbyClient2 &lc, Uint32 *check_end) {
	if (!*check_end) {
		return false;	
	}
	lc.SendInt(MATCH_END_CODE);	
	if (lc.WaitData2(3000) == SDL_FAILURE) {
		if (lc.IsBlueCorner()) {
			wmes("Game::CheckEndCode2 -> Time Out by Blue");
		} else {
			wmes("Game::CheckEndCode2 -> Time Out by Red");
		}
		NetErrorMessage();	
		return false;
	}

	if (lc.GetInt() != MATCH_END_CODE) {
		if (lc.IsRedCorner()) {
			wmes("Game::CheckEndCode2 -> Code Error by Red");		
		} else {
			wmes("Game::CheckEndCode2 -> Code Error by Blue");
		}
		NetErrorMessage();	
		return false;
	}
	smes("Game::CheckEndCode2 -> Match End");		

	*check_end = 0;
	return true;
}

void Game::NetLobbyClientUDP() {
	static int select, mouse_select, key_select;
	static int i, loop, x, y;
	static float size, csize;
    static char buf[20];

	LobbyClientUDP client;
	CGI cgi;

	if (client.Init() == SDL_FAILURE) {
		return;	
	}

	if (LobbyMode) {
		if (cgi.Lobby(HostCGI, LobbyCGI, "client", PortLobby, PDB_CAPTION_EN_TITLE) == SDL_FAILURE) {
			CGIFailedMessage();
			return;	
		}
		if (cgi.SetState() == SDL_FAILURE) {
			CGIErrorMessage();
			return;		
		}		
		if (client.ConnectLobby(UserName, cgi.Host(0), cgi.Port(0), Port) == SDL_FAILURE) {
			LobbyClientFailedMessage();
			return;	
		}	
	} else {
		if (client.ConnectLobby(UserName, HostName, PortLobby, Port) == SDL_FAILURE) {
			LobbyClientFailedMessage();
			return;	
		}
	}	

	timer.SetFPS(50);	
	do {
		glClearColor(0.33, 0.33, 0.33, 0.0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		SelectOptions();

		SDL_GetMouseState(&x, &y);
		mouse_select = -1;
		MouseSelectGoNext(mouse_select, x, y);
		if (width*0.25  < x && width*0.75 > x) {
			for (i = 0; i < MAX_ROOM; i++) {
				if (height*(0.15 + (float)i*0.09) < y &&
					height*(0.24 + (float)i*0.09) > y) {
   		    		mouse_select = i;
				}
			}
		}

		if (event.IsKeyDown(kb2_left) ||  
			event.IsKeyDown(kb2_forward)) {  
			if (key_select > 0) {
				key_select--;
			}
		}
		if (event.IsKeyDown(kb2_right) ||  
			event.IsKeyDown(kb2_back)) {  
			if (key_select < MAX_ROOM-1) {
				key_select++;
			}
		}
		csize =	(1.0 + 0.2 * sin(RAD(2*loop++)));

		ttext.MessageEnter();
		PlayerNumberStr(client.PlayerNumber(), buf);
		ttext.Print(buf, 0.5, 0, 90);

		for (i = 0; i < MAX_ROOM; i++) {
			ttext.SelectColor(mouse_select == i);
			key_select == i ? size = csize : size = 1.0;
			switch (client.RoomState(i)){
				case EMPTY_ROOM :
					strcpy(buf, "[----------]");
				break;
				default : 
					strcpy(buf, (char *)client.RoomName(i));
				break;
			}
			ttext.Print(buf, 0.5 * size, 0, 70 - i*20);
		}

		if (IsAnyKeyDown()) {
			client.RequestRoom(key_select);
		}
		if (mouse_select != -1 && event.IsMouse1Down()) {
			client.RequestRoom(mouse_select);
		}
				
		ttext.SelectColor(mouse_select == GO_NEXT);
   		ttext.Print("Quit", 0.25, -100, -100);
		ttext.SetColor(1.0, 1.0, 1.0);	
 		ttext.Print(timer.FPSString(), 0.25, 100, -100);
		ttext.MessageLeave();		

		SDL_GL_SwapBuffers(); 
		GLmes();

		if (client.IsReady()) {
			switch (client.Handle()) {
				case MATCH_BLUE:			
				case MATCH_RED:			
					if (SelectBoxerUDP(client)) {
						StartMatchUDP(client);
					}
					client.ReturnLobby();
				break;	
				default:
				break;			
			}
		}			
		timer.Wait();
		event.Poll();
		if (event.IsKeyDown(go_next) ||
			(mouse_select == GO_NEXT && event.IsMouse1Down())) {
			break;		
		}
		ExposeSelectBoxer();
	} while(!event.IsQuit());
	client.LeaveLobby();
	if (event.IsQuit()) {
		Quit();
	}
 	glClearColor(0.0, 0.0, 0.0, 0.0);
}


bool Game::ClearFlowDataUDP(LobbyClientUDP &lc) {
	int timeout_count;

	lc.Send32(MATCH_START);	
	timeout_count = 0;		
	while(1) {
		SDL_Delay(10);
		if (lc.IsUDPReady()) {
			if (lc.Get32() == MATCH_START) {
				break;
			}
		}	
		timeout_count++;
		if (timeout_count > TIMEOUT_COUNT) {
			if (lc.IsBlueCorner()) {
				wmes("Game::ClearFlowDataUDP -> Time Out by Blue");
			} else {
				wmes("Game::ClearFlowDataUDP -> Time Out by Red");
			}
			return false;
		}
	}
	return true;
}


void Game::ClearDelayKeysUDP(LobbyClientUDP &lc, Uint32 *send_count, Uint32 *get_count) {
	Uint32 end_code;
	int i, timeout_count;
	if (*send_count == 0 && *get_count == 0) {
		return;
	}
	
	lc.Send32(ROUND_END_CODE);
	timeout_count = 0;		
	while(1) {
		if (lc.IsUDPReady()) {
			end_code = lc.Get32();
			if (end_code == ROUND_END_CODE) {
				break;		
			}
		}	
		timeout_count++;
		SDL_Delay(10);
		if (timeout_count > TIMEOUT_COUNT) {
			if (lc.IsBlueCorner()) {
				wmes("Game::ClearDelayKeysUDP -> Time Out by Blue");
			} else {
				wmes("Game::ClearDelayKeysUDP -> Time Out by Red");
			}
		 	break;
		}
	}
	for (i = *get_count + 1; i <= *send_count; i++) {
			handler1.InvalidKey();
			handler2.InvalidKey();
			handler1.SaveKeyStates(i);
			handler2.SaveKeyStates(i);	
	}
	*send_count = 0;
	*get_count = 0;
}


bool Game::MatchUDP(LobbyClientUDP &lc) {
	Uint32 send_count, get_count, delay, max_delay;
	Uint32 send_data, get_data, check_end;
	Uint16 get_timecount;
	Uint8 get_round;
	check_end = 1;
	max_delay = 5;
	send_count = 0;
	get_count = 0;

	mixer.PlayMusic(BGM_MATCH);

	handler1.Init(boxer1, motion1, match);
	handler2.Init(boxer2, motion2, match);

	can_change_mode1 = 0;
	can_change_mode2 = 0;
	which_select = 0;

	handler1.SetMode(FULL_CONTROL);
	handler2.SetMode(FULL_CONTROL);		

	SetCamera();
	SetLights();
	SetDefaultView();	
	SetBoxerPosition(1.6);
	SetBoxerName();

	handler1.SetDistance(distance);	
	handler2.SetDistance(distance);	
	handler1.SetRound(1);
	handler2.SetRound(1);	
	handler1.SaveInfo(0, boxer1, motion1);
	handler2.SaveInfo(0, boxer2, motion2);	 
    match.SetCounter(50);

	NextOff();
	timer.SetFPS(50);	
	do {
		MatchOptions();
		
		match.CalcModeOff();
  
		if (match.IsShowRound()) {
			if (match.RingGong()) {
				mixer.PlayChunk(SE_GONG);
			}
			if (match.HasShownRound()) {
				match.Matching();
				handler1.SaveInfo(0, boxer1, motion1);
				handler2.SaveInfo(0, boxer2, motion2);	
				match.SetCounter(-50);		
			}
		} 
	
		handler1.SetDistance(distance);	
		handler2.SetDistance(distance);	

		if (match.IsMatching()) {
			if (lc.IsBlueCorner()) {
				GetKeyStates(handler1);
				GetOffenseMouseStates();
		//		handler1.GetComStates(match, boxer2, handler1);

				delay = send_count - get_count;
				if (delay < max_delay) {
					send_data = MakeSendData(handler1.GetKeyState(), match.Round(), send_count);
					lc.Send32(send_data);
					handler1.SaveKeyStates(send_count);
					send_count++;			
				}  	
				
				if (lc.IsUDPReady()) {
					get_data = lc.Get32();
					handler2.SetKeyState(MakeGetData(get_data, &get_round, &get_timecount));
					handler2.SaveKeyStates(get_count);
					handler1.LoadKeyStates(get_count);
					get_count++;
				} else {
					handler2.InvalidKey();
				}
			} else {
				GetKeyStates(handler2);
				GetOffenseMouseStates();		
		//		handler2.GetComStates(match, boxer2, handler1);

				delay = send_count - get_count;
				if (delay < max_delay) {
					send_data = MakeSendData(handler2.GetKeyState(), match.Round(), send_count);
					lc.Send32(send_data);
					handler2.SaveKeyStates(send_count);
					send_count++;			
				}  	
				
				if (lc.IsUDPReady()) {
					get_data = lc.Get32();
					handler1.SetKeyState(MakeGetData(get_data, &get_round, &get_timecount));
					handler1.SaveKeyStates(get_count);
					handler2.LoadKeyStates(get_count);
					get_count++;
				} else {
					handler1.InvalidKey();
				}
			}
		} else {
			handler1.InitKey();
			handler2.InitKey();
			handler1.Defense();
			handler2.Defense();
			handler1.SaveKeyStates(match.TimeCount());
			handler2.SaveKeyStates(match.TimeCount());
		}

		if (match.IsEnd()) {
			match.CalcModeOff();
			ClearDelayKeysUDP(lc, &send_count, &get_count);
			CheckEndCodeUDP(lc, &check_end);
		}		
		if (match.IsCalcMode() && !match.IsMatching()) {
			handler1.Defense();			
			handler2.Defense();				
		}

		if (match.IsBeforeMatch() && match.IsCounterZero()) {	
			if ((handler2.IsAnyAction() || handler2.IsFullAuto()) &&
				(handler1.IsAnyAction() || handler1.IsFullAuto())) {
				match.ShowRound();
			}
		}

		if (match.IsRoundInterval()) {	
			ClearDelayKeysUDP(lc, &send_count, &get_count);
			if ((handler2.IsFullControl() && handler2.IsNoKey()) ||
				(handler1.IsFullControl() && handler1.IsNoKey()) ||
				(handler2.IsSemiAuto() && !handler2.IsAnyAction()) ||
				(handler1.IsSemiAuto() && !handler1.IsAnyAction())) {
				match.SkipIntervalCount();			
			}
			if (match.IsSkipInterval() &&
				((handler2.IsAnyAction() || handler2.IsFullAuto()) &&
				 (handler1.IsAnyAction() || handler1.IsFullAuto())) ||
				event.IsKeyPressed(go_next) || event.IsMouse1Pressed()) {
				match.CalcModeOn();
			}
			if (distance > 6.0 &&
				(handler2.IsAnyAction() || handler2.IsFullAuto()) &&
				(handler1.IsAnyAction() || handler1.IsFullAuto())) {
				if (match.IsLastRound()) {
					match.Decision(handler1, handler2);
					if (match.IsExtraRoundSystem() && match.IsDraw() && !match.IsExtraRound()) {
						RoundStart();
					} else {
						match.End();
						mixer.PlayChunk(SE_KO);
						handler1.SaveEndInfo(boxer1, motion1);
						handler2.SaveEndInfo(boxer2, motion2);			
					}
				} else {
					RoundStart();
				}
			}
		}

		if (handler1.IsKeyValid() && handler2.IsKeyValid()) {
			if (!match.IsMatching()) {
				handler1.InitKey();		
				handler2.InitKey();	
			} else {
				if (match.Round() != get_round ||
					match.TimeCount() != get_timecount) {
					if (lc.IsBlueCorner()) {
						wmes("Game::MatchUDP -> Synchronize Error by Blue");
					} else {
						wmes("Game::MatchUDP -> Synchronize Error by Red");				
					}
					fprintf(stderr, "Round = %d,%d TimeCount = %d,%d\n", match.Round(), get_round, match.TimeCount(), get_timecount);			
					break;
				}	
			
				if (handler2.IsCounting() && !handler1.IsCounting()) {
					handler1.InitKey();				
				}
				if (handler1.IsCounting() && !handler2.IsCounting()) {
					handler2.InitKey();		
				}
			}
			if (match.IsCalcMode()) {
				CalcRoutine();		
			} else {
				ShowRoutine();		
			}
		}

		event.Poll();
		ExposeScreen();
		if (match.IsEnd() && (event.IsKeyDown(go_next) || IsNext())) {
			break;		
		}
	} while(!event.IsQuit());
	if (event.IsQuit()) {
		lc.Send32(QUIT_MATCH);
		lc.LeaveLobby();
		Quit();
	}

	return true;	
}

bool Game::SelectBoxerUDP(LobbyClientUDP &lc) {
	static char buf[255];
	static int select_boxer1 = 1, select_boxer2 = 0;
	static int pre_select_boxer1 = select_boxer1;
	static int pre_select_boxer2 = select_boxer2;
	static int x, y, loop, mouse_select = -1;
	static bool red_select = true, blue_select = false;
	static float size, csize;

	if (!ClearFlowDataUDP(lc)) {
		return false;	
	}

	CheckVersionUDP(lc);

	if (lc.IsRedCorner()) {
		match.Init(MaxRound, RoundTime,
			TKOSystem, JudgeSystem, CountSystem, ExtraRound, KOCount,
			Judge1Type, Judge2Type, Judge3Type, 
			ExtraInfo, ReplayRate);
		if (lc.SendData(&match, sizeof(MatchHandler)) == SDL_FAILURE) {
			wmes("Game::SelectBoxerUDP -> Can't send match data.");
			return false;		
		}    
		match.Reset();
 	} else {
		if (lc.WaitUDPData(300) == SDL_FAILURE) {
			wmes("Game::SelectBoxerUDP -> Time Out by Blue");
		}
		if (lc.GetData(&match, sizeof(MatchHandler)) == SDL_FAILURE) { 
			wmes("Game::SelectBoxerUDP -> Can't get match data.");
			return false;		
		}   
		match.Reset();
	}

 	select_boxer1 = -1;
 	select_boxer2 = -1;	
	if (!SelectBoxer1File(select_boxer1) ||
		!SelectBoxer2File(select_boxer2)) {
		false;
	}

	if (lc.IsRedCorner()) {
		red_select = true;
		blue_select = false;
	} else {
		red_select = false;
		blue_select = true;
	}

	InitSelectBoxer();	
	if (select_boxer1 < 0) {
		motion1.OffSet(boxer1);
	}
	if (select_boxer2 < 0) {
		motion2.OffSet(boxer2);
	}	

	timer.SetFPS(50);	
	do {
		glClearColor(0.33, 0.33, 0.33, 0.0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		csize =	(0.9 + 0.1 * sin(RAD(5*loop++)));

		SDL_GetMouseState(&x, &y);
		mouse_select = -1;
		MouseSelectGoNext(mouse_select, x, y);
		if (width * 0.00 < x && width * 0.07 > x) {
			if (height* 0.57 < y && height* 0.64 > y) {
				mouse_select = REDCORNER_DOWN;			
			}
			if (height* 0.50 < y && height* 0.57 > y) {
				mouse_select = REDCORNER_UP;			
			}
		}
		if (width * 0.50 < x && width * 0.57 > x) {
			if (height* 0.57 < y && height* 0.64 > y) {
				mouse_select = BLUECORNER_DOWN;			
			}
			if (height* 0.50 < y && height* 0.57 > y) {
				mouse_select = BLUECORNER_UP;			
			}
		}

		if ((mouse_select == BLUECORNER_UP && event.IsMouse1Down()) ||
			event.IsKeyDown(kb1_right) ||
			(blue_select && event.IsKeyDown(kb2_left))) {
			pre_select_boxer1 = select_boxer1;
			select_boxer1++;		
			if (select_boxer1 >= MembersNumber) {
				select_boxer1 = -2;			
			}
		}  
		if ((mouse_select == BLUECORNER_DOWN && event.IsMouse1Down()) ||
			event.IsKeyDown(kb1_left) ||
			(blue_select && event.IsKeyDown(kb2_right))) {
			pre_select_boxer1 = select_boxer1;
			select_boxer1--;		
			if (select_boxer1 < -2) {
				select_boxer1 = MembersNumber - 1;			
			}
		}  
		if ((red_select && event.IsKeyDown(kb2_left)) ||
			(mouse_select == REDCORNER_UP && event.IsMouse1Down())) {
			pre_select_boxer2 = select_boxer2;
			select_boxer2++;		
			if (select_boxer2 >= MembersNumber) {
				select_boxer2 = -2;			
			}
		}  
		if ((red_select && event.IsKeyDown(kb2_right)) ||
			(mouse_select == REDCORNER_DOWN && event.IsMouse1Down())) {
			pre_select_boxer2 = select_boxer2;
			select_boxer2--;		
			if (select_boxer2 < -2) {
				select_boxer2 = MembersNumber - 1;			
			}
		}  

		if (pre_select_boxer1 != select_boxer1) {
			if (SelectBoxer1File(select_boxer1)) {
				boxer1.MakeDLists(Partition, FaceStyle);
				boxer1.MakeRanges(Partition);
				if (select_boxer1 < 0) {
					motion1.OffSet(boxer1);
				}
				pre_select_boxer1 = select_boxer1;
			} else {
				select_boxer1 = pre_select_boxer1;				
				SelectBoxer1File(select_boxer1);				
			}
		}
		if (pre_select_boxer2 != select_boxer2) {
			if (SelectBoxer2File(select_boxer2)) {
				boxer2.MakeDLists(Partition, FaceStyle);
				boxer2.MakeRanges(Partition);
				if (select_boxer2 < 0) {
					motion2.OffSet(boxer2);
				}
				pre_select_boxer2 = select_boxer2;
			} else {
				select_boxer2 = pre_select_boxer2;				
				SelectBoxer2File(select_boxer2);				
			}
		}

		if (lc.IsRedCorner()) {
			RedCornerBoxer();
			RedCornerInfo(select_boxer2, buf);

			if (UsePText) {
				ptext.MessageEnter();
				ptext.SetSpecular(0.0, 0.0, 0.0);
				red_select ? size = csize :size = 1.0;
				ptext.SelectColor(mouse_select == REDCORNER_UP);
				ptext.Symbol(SYMBOL_TRIANGLE_UP2, 0.8*size, -92, 95);
				ptext.SelectColor(mouse_select == REDCORNER_DOWN);
				ptext.Symbol(SYMBOL_TRIANGLE_DOWN2, 0.8*size, -92, 70);
   				ptext.MessageLeave();
			} else {
				ttext.MessageEnter();
				red_select ? size = csize :size = 1.0;
				ttext.SelectColor(mouse_select == REDCORNER_UP);
				ttext.Symbol(SYMBOL_TRIANGLE_UP2, 0.8*size, -92, 95);
				ttext.SelectColor(mouse_select == REDCORNER_DOWN);
				ttext.Symbol(SYMBOL_TRIANGLE_DOWN2, 0.8*size, -92, 70);
   				ttext.MessageLeave();			
			}
		} else {
    		BlueCornerBoxer();
			BlueCornerInfo(select_boxer1, buf);
			
			if (UsePText) {
				ptext.MessageEnter();
				ptext.SetSpecular(0.0, 0.0, 0.0);
				blue_select ? size = csize : size = 1.0;
				ptext.SelectColor(mouse_select == BLUECORNER_UP);
				ptext.Symbol(SYMBOL_TRIANGLE_UP2, 0.8*size, -92, 95);
				ptext.SelectColor(mouse_select == BLUECORNER_DOWN);
				ptext.Symbol(SYMBOL_TRIANGLE_DOWN2, 0.8*size, -92, 70);
	   			ptext.MessageLeave();
			} else {
				ttext.MessageEnter();
				blue_select ? size = csize : size = 1.0;
				ttext.SelectColor(mouse_select == BLUECORNER_UP);
				ttext.Symbol(SYMBOL_TRIANGLE_UP2, 0.8*size, -92, 95);
				ttext.SelectColor(mouse_select == BLUECORNER_DOWN);
				ttext.Symbol(SYMBOL_TRIANGLE_DOWN2, 0.8*size, -92, 70);
	   			ttext.MessageLeave();			
			}
		}
		
		glViewport(0, 0, width, height);
		SelectOptions();
		ttext.MessageEnter();
		ShowMatchInfo(buf);
		ttext.SelectColor(mouse_select == GO_NEXT);
   		ttext.Print("Next", 0.25, -100, -100);
		ttext.SetColor(1.0, 1.0, 1.0);	
 		ttext.Print(timer.FPSString(), 0.25, 100, -100);
		ttext.MessageLeave();		

		SDL_GL_SwapBuffers(); 
		GLmes();

		timer.Wait();
		event.Poll();
		if (event.IsKeyDown(go_next) ||
			(mouse_select == GO_NEXT && event.IsMouse1Down())) {
			break;		
		}
		ExposeSelectBoxer();
	} while(!event.IsQuit());
	if (event.IsQuit()) {
		lc.Send32(QUIT_MATCH);
		lc.LeaveLobby();
		Quit();
	}
 	glViewport(0, 0, width, height);
 	glClearColor(0.0, 0.0, 0.0, 0.0);

	return SendBoxerDataUDP(lc);
}

bool Game::SendBoxerDataUDP(LobbyClientUDP &lc) {
	SData send, get;
	Uint32 size;

	PleaseMessage();
	if (lc.IsBlueCorner()) {
		send.Init(handler1.CalcDataSize(motion1));
		handler1.SaveBinBoxer(boxer1, motion1, send.RWops());
    } else {
		send.Init(handler2.CalcDataSize(motion2));
		handler2.SaveBinBoxer(boxer2, motion2, send.RWops());	
	}

	size = send.Size();
 	lc.Send32(size);
	if (lc.SendData(send.Data(), send.Size()) == SDL_FAILURE) {
		wmes("Game::SendBoxerDataUDP -> Can't send data.");
		return false;	
	}  

	size = lc.Get32();
	if (size == QUIT_MATCH) {
		wmes("Game::SendBoxerDataUDP -> Opponent is quit.");
		return false;	
	}
	get.Init(size);
	if (lc.GetData(get.Data(), get.Size()) == SDL_FAILURE) {
		wmes("Game::SendBoxerDataUDP -> Can't get data.");
		return false;	
	} 

	if (lc.IsBlueCorner()) {
		handler2.LoadBinBoxer(boxer2, motion2, get.RWops());	
		boxer2.MakeDLists(Partition, FaceStyle);
		boxer2.MakeRanges(Partition); 
	} else {
		handler1.LoadBinBoxer(boxer1, motion1, get.RWops());	
		boxer1.MakeDLists(Partition, FaceStyle);
		boxer1.MakeRanges(Partition); 	
	}

	return true;
}

void Game::StartMatchUDP(LobbyClientUDP &lc) {
	if (lc.IsBlueCorner()) {
		SetKeyBlueCorner();
	}		

	if (MatchUDP(lc)) {
		if (!SkipReplay) {
			Replay();
		}
	}

	if (lc.IsBlueCorner()) {
		SetKey1P();
	}	
}

bool Game::CheckVersionUDP(LobbyClientUDP &lc) {
	Uint32 iver, get_iver;
	iver = PDB_VERSION_CODE;
	lc.Send32(iver);
	
	get_iver = lc.Get32();		
	if (iver != get_iver) {
		wmes("Game::CheckVersionUD -> Version is different.");
		if (lc.IsRedCorner()) {
			fprintf(stderr, "Red  ver = %d\n", iver);
			fprintf(stderr, "Blue ver = %d\n", get_iver);
		} else {
			fprintf(stderr, "Blue ver = %d\n", iver);
			fprintf(stderr, "Red  ver = %d\n", get_iver);
		}
		return false;
	}
	smes("Game::CheckVersionUD -> Match Start");	
	return true;
}

bool Game::CheckEndCodeUDP(LobbyClientUDP &lc, Uint32 *check_end) {
	if (!*check_end) {
		return false;	
	}
	lc.Send32(MATCH_END_CODE);	
	if (lc.WaitUDPData(3000) == SDL_FAILURE) {
		if (lc.IsBlueCorner()) {
			wmes("Game::CheckEndCodeUDP -> Time Out by Blue");
		} else {
			wmes("Game::CheckEndCodeUDP -> Time Out by Red");
		}
		NetErrorMessage();	
		return false;
	}

	if (lc.Get32() != MATCH_END_CODE) {
		if (lc.IsRedCorner()) {
			wmes("Game::CheckEndCodeUDP -> Code Error by Red");		
		} else {
			wmes("Game::CheckEndCodeUDP -> Code Error by Blue");
		}
		NetErrorMessage();	
		return false;
	}
	smes("Game::CheckEndCodeUDP -> Match End");		

	*check_end = 0;
	return true;
}

void Game::PlayerNumberStr(int number, char *buf) {
	switch (lang) {
		case Kana :
			sprintf(buf, "%dɂ񂢂܂", number);
		break;		
		case English :		
			sprintf(buf, "Now %d Players", number);
		break;		
		default :
			sprintf(buf, "%d", number);
		break;
	}
}


