#include "game.h"

void Game::InitMenu() {
	glring.Make(1, texs[TE_CANVAS], texs[TE_ADS], 36);

	camera.Init(2);
	camera.Perspective(60.0, 0.05, 20.0);
	camera[0].DefPosition(0.0, -3.0, 1.0);
	camera[0].DefDirection(0.0, 0.0, 0.0);
	camera[0].DefRotation(0.0);

	light.Init(0);
	light.DefDiffuse(0.7, 0.7, 0.7);
	light.DefPosition(0.0, 0.0, 1.0);
	light.On();

	light2.Init(1);
	light2.DefPosition(0.0, 0.0, 3.0);
	light2.DefDiffuse(0.3, 0.3, 0.3);
	light2.On();
	
	ptext.SetSpecular(0.0, 0.0, 0.0);
}

int Game::LobbyFailedMessage() {
	static char *menu_kanji[] = {"", "r[J܂łB", "", "", "", "", "", "OK"};
	static char *menu_kana[] = {"", "r[Ђ炯܂ł", "", "", "", "", "", "OK"};
	static char *menu_english[] = {"", "Couldn't open lobby", "", "", "", "", "", "OK"};
	static int key_select = 7;
	SetMenu(menu_kanji, menu_kana, menu_english, 8);
	sprintf(menu[4], "Port : %d", Port);
	return Menu(key_select, 8, 8);
}

int Game::LobbyClientFailedMessage() {
	static char *menu_kanji[] = {"", "ڑł܂ł", "", "", "", "", "", "OK"};
	static char *menu_kana[] = {"", "ł܂ł", "", "", "", "", "", "OK"};
	static char *menu_english[] = {"", "Couldn't connect to a lobby", "", "", "", "", "", "OK"};
	static int key_select = 7;
	SetMenu(menu_kanji, menu_kana, menu_english, 8);
	sprintf(menu[3], "Host Name : %s", HostName);
	sprintf(menu[4], "Port : %d", Port);
	return Menu(key_select, 8, 8);
}

int Game::DummyMenu() {
/*	static char *menu_kanji[] = {"", "NCAg҂Ă܂", "", "", "", ""};
	static char *menu_kana[] = {"", "NCAg܂Ă܂", "", "", "", ""};
	static char *menu_english[] = {"", "Waiting for a client", "", "", "", ""};
	static int key_select = 7;
	SetMenu(menu_kanji, menu_kana, menu_english, 7);
	sprintf(menu[2], "(%d)", 50);
	sprintf(menu[3], "Host Name : %s", "PdBoxing_Server");
	sprintf(menu[4], "IP Address : %d.%d.%d.%d", 0, 0, 0, 0);
	sprintf(menu[5], "Port : %d", 2000);
	return Menu(key_select, 7, 7); */
 
/*	static char *menu_kanji[] = {"", "̃NCAgڑ܂", "", "", "", "", "", "OK"};
	static char *menu_kana[] = {"", "ȂNCAg", "", "", "", "", "", "OK"};
	static char *menu_english[] = {"", "Connected from this client", "", "", "", "", "", "OK"};
	static int key_select = 7;
	SetMenu(menu_kanji, menu_kana, menu_english, 8);
	sprintf(menu[3], "Remote Name : %s", "PdBoxing_Client");
	sprintf(menu[4], "IP Address : %d.%d.%d.%d", 110, 110, 110, 110);
	sprintf(menu[5], "Port : %d", 2000);
	return Menu(key_select, 8, 8);  */

	static char *menu_kanji[] = {"", "ڑ܂ł", "", "", "", "", "", "OK"};
	static char *menu_kana[] = {"", "܂ł", "", "", "", "", "", "OK"};
	static char *menu_english[] = {"", "Connected from this client", "", "", "", "", "", "OK"};
	static int key_select = 7;
	SetMenu(menu_kanji, menu_kana, menu_english, 8);
	sprintf(menu[3], "Host Name : %s", "PdBoxing_Server");
	sprintf(menu[4], "IP Address : %d.%d.%d.%d", 0, 0, 0, 0);
	sprintf(menu[5], "Port : %d", 2000);
	return Menu(key_select, 8, 8);

/*	static char *menu_kanji[] = {"", "̃T[o[ɐڑ܂", "", "", "", "", "", "OK"};
	static char *menu_kana[] = {"", "ȂT[o[", "", "", "", "", "", "OK"};
	static char *menu_english[] = {"", "Connected to this server", "", "", "", "", "", "OK"};
	static int key_select = 7;
	SetMenu(menu_kanji, menu_kana, menu_english, 8);
	sprintf(menu[3], "Host Name : %s", "PdBoxing_Server");
	sprintf(menu[4], "IP Address : %d.%d.%d.%d", 255, 255, 255, 255);
	sprintf(menu[5], "Port : %d", 2000);
	return Menu(key_select, 8, 8);  */

/*	static char *menu_kanji[] = {"", "ڑł܂ł", "", "", "", "", "", "OK"};
	static char *menu_kana[] = {"", "ł܂ł", "", "", "", "", "", "OK"};
	static char *menu_english[] = {"", "Couldn't connect to a server", "", "", "", "", "", "OK"};
	static int key_select = 7;
	SetMenu(menu_kanji, menu_kana, menu_english, 8);
	sprintf(menu[3], "Host Name : %s", "PdBoxing_Server");
	sprintf(menu[4], "IP Address : %d.%d.%d.%d", 255, 255, 255, 255);
	sprintf(menu[5], "Port : %d", 2000);
	return Menu(key_select, 8, 8); */
 
}

int Game::SaveReplayMenu() {
	static char *menu_kanji[] = {"", "vCۑ܂?", "", "TCN", "Xbg", "ۑȂ"};
	static char *menu_kana[] = {"", "vCق񂵂܂", "", "TCN", "Xbg", "ق񂵂Ȃ"};
	static char *menu_english[] = {"Would you like to save", "a replay file?", "", "Cycle", "Slot", "Not Save"};
	static int key_select = 3;
	SetMenu(menu_kanji, menu_kana, menu_english, 6);
	key_select = Menu(key_select, 4, 6);
	return key_select - 3;
}

int Game::SelectSlotReplayMenu() {
	static char *menu_kanji[] = {"XbgI", "", "", "", "", "", "", ""};
	static char *menu_kana[] = {"Xbg񂽂", "", "", "", "", "", "", ""};
	static char *menu_english[] = {"Select Slot", "", "", "", "", "", "", ""};
	static int key_select = 1;
	int i, empty_select, return_select;
	empty_select = -1;
	SetMenu(menu_kanji, menu_kana, menu_english, 8);
	switch (lang) {
		case Kana:	
			for (i = 1; i < SlotReplayNumber+1 && i < 7; i++) {
				sprintf(menu[i], "XbgNo.%dɂ킪", i);
			}
			if (i < 7) {
				key_select = i;
				empty_select = i;
				sprintf(menu[i], "̃XbgNo.%d", i);
				i++;
			}
			return_select = i;
			strcpy(menu[i++], "ǂ");
		break;					
		case English:
			for (i = 1; i < SlotReplayNumber + 1 && i < 7; i++) {
				sprintf(menu[i], "Overwrite Slot No.%d", i);
			}
			if (i < 7) {
				key_select = i;
				empty_select = i;
				sprintf(menu[i], "Empty Slot No.%d", i);
				i++;
			}
			return_select = i;
			strcpy(menu[i++], "Return");
		break;
		default:	
			for (i = 1; i < SlotReplayNumber + 1 && i < 7; i++) {
				sprintf(menu[i], "XbgNo.%dɏ㏑", i);
			}
			if (i < 7) {
				key_select = i;
				empty_select = i;
				sprintf(menu[i], "XbgNo.%d", i);
				i++;
			}
			return_select = i;
			strcpy(menu[i++], "߂");
		break;					
	}
	key_select = Menu(key_select, 2, i);
	if (key_select == return_select) {
		return -1;	
	}
	if (key_select == empty_select) {
		SlotReplayNumber++;
	}
	return key_select - 1;
}

int Game::PleaseMessage() {
	static char *menu_kanji[] = {"", "҂", ""};
	static char *menu_kana[] = {"", "܂", ""};
	static char *menu_english[] = {"", "Wait a few seconds.", ""};
	static int key_select = -1;
	SetMenu(menu_kanji, menu_kana, menu_english, 3);
	return Menu(key_select, 3, 3);
}

int Game::TopMenu() {
	static char *menu_kanji[] = {"Xg[[", "1P Xp[", "2P ΐ@", "lbgΐ", "g[jO", "vC", "f", "I"};
	static char *menu_kana[] = {"Xg[[", "1P Xp[  ", "2P ", "lbg", "g[jO", "vC", "f", "イ傤"};
	static char *menu_english[] = {"Story", "1P Sparring", "2P Match   ", "Network Match", "Training", "Replay", "Demo", "Exit"};
	static int key_select = 0;
	SetMenu(menu_kanji, menu_kana, menu_english, 8);
	key_select = Menu(key_select, 1, 8);
	mixer.StopMusic(); 
	return key_select;
}

int Game::LANMenu() {
	static char *menu_kanji[] = {"}b`CNCGI", "JX^", "T[o[", "NCAg", "r[", "r[NCAg", "߂"};
	static char *menu_kana[] = {"}b`CNCGI",  "JX^", "T[o[", "NCAg", "r[", "r[NCAg", "ǂ"};
	static char *menu_english[] = {"Match Make CGI", "Custom", "Server", "Client", "Lobby", "Lobby Client", "Return"};
	static int key_select = 0;
	SetMenu(menu_kanji, menu_kana, menu_english, 7);
	key_select = Menu(key_select, 1, 7);
	return key_select;
}

/*
int Game::LANMenu() {
	static char *menu_kanji[] = {"탂[h", "}b`CNCGI", "JX^", "T[o[", "NCAg", "r[", "r[NCAg", "߂"};
	static char *menu_kana[] = {"񃂁[h", "}b`CNCGI",  "JX^", "T[o[", "NCAg", "r[", "r[NCAg", "ǂ"};
	static char *menu_english[] = {"Official Match Mode", "Match Make CGI", "Custom", "Server", "Client", "Lobby", "Lobby Client", "Return"};
	static int key_select = 0;
	SetMenu(menu_kanji, menu_kana, menu_english, 8);
	key_select = Menu(key_select, 1, 8);
	return key_select;
}
*/

int Game::OfficialModeMenu() {
	static char *menu_kanji[] = {"", "o^", "߂", ""};
	static char *menu_kana[] = {"", "񂽂", "ǂ",  "񂽂"};
	static char *menu_english[] = {"Offical Match", "Register", "Return", "Retire"};
	static int key_select = 0;
	SetMenu(menu_kanji, menu_kana, menu_english, 4);
	key_select = Menu(key_select, 1, 4);
	return key_select;
}

int Game::WaitClientMessage(SNet &snet, int i) {
	static char *menu_kanji[] = {"", "NCAg҂Ă܂", "", "", "", "", ""};
	static char *menu_kana[] = {"", "NCAg܂Ă܂", "", "", "", "", ""};
	static char *menu_english[] = {"", "Waiting for a client", "", "", "", "", ""};
	static int key_select = -1;
	SetMenu(menu_kanji, menu_kana, menu_english, 7);
	sprintf(menu[2], "(%d)", i);
	sprintf(menu[3], "Host Name : %s", snet.HostName());
	sprintf(menu[4], "IP Address : %d.%d.%d.%d", snet.ServerIP1(), snet.ServerIP2(), snet.ServerIP3(), snet.ServerIP4());
	sprintf(menu[5], "Port : %d", snet.ServerPort());
	return Menu(key_select, 7, 7);
}

int Game::VersionFailureMessage(int is_old) {
	static char *menu_kanji[] = {"", "o[WႢ܂", "", "OK"};
	static char *menu_kana[] = {"", "o[W܂", "", "OK"};
	static char *menu_english[] = {"", "Version Failure", "", "OK"};
	static int key_select = 3;
	SetMenu(menu_kanji, menu_kana, menu_english, 4);
	if (is_old) {
		switch (lang) {
			case Kana :
				strcpy(menu[2], "Please, use latest version.");	
			break;
			case English :
				strcpy(menu[2], "炵̂Ă");	
			break;
			default :
				strcpy(menu[2], "ŐVłgpĂ");	
			break;
		}
	}
	return Menu(key_select, 4, 4) - 3;
}

int Game::NetErrorMessage() {
	static char *menu_kanji[] = {"", "ʐMG[܂", "", "OK"};
	static char *menu_kana[] = {"", "G[܂", "", "OK"};
	static char *menu_english[] = {"", "There's a connection error.", "", "OK"};
	static int key_select = 3;
	SetMenu(menu_kanji, menu_kana, menu_english, 4);
	return Menu(key_select, 4, 4) - 3;
}

int Game::ServerOKMenu(SNet &snet) {
	static char *menu_kanji[] = {"", "̃NCAgڑ܂", "", "", "", "", "", "OK"};
	static char *menu_kana[] = {"", "ȂNCAg", "", "", "", "", "", "OK"};
	static char *menu_english[] = {"", "Connected from this client", "", "", "", "", "", "OK"};
	static int key_select = 7;
	SetMenu(menu_kanji, menu_kana, menu_english, 8);
	sprintf(menu[3], "Remote Name : %s", snet.RemoteName());
	sprintf(menu[4], "IP Address : %d.%d.%d.%d", snet.ClientIP1(), snet.ClientIP2(), snet.ClientIP3(), snet.ClientIP4());
	sprintf(menu[5], "Port : %d", snet.ClientPort());
	return Menu(key_select, 8, 8);
}

int Game::ServerFailedMenu(SNet &snet) {
	static char *menu_kanji[] = {"", "ڑ܂ł", "", "", "", "", "", "OK"};
	static char *menu_kana[] = {"", "܂ł", "", "", "", "", "", "OK"};
	static char *menu_english[] = {"", "There's no connecting", "", "", "", "", "", "OK"};
	static int key_select = 7;
	SetMenu(menu_kanji, menu_kana, menu_english, 8);
	sprintf(menu[3], "Host Name : %s", snet.HostName());
	sprintf(menu[4], "IP Address : %d.%d.%d.%d", snet.ServerIP1(), snet.ServerIP2(), snet.ServerIP3(), snet.ServerIP4());
	sprintf(menu[5], "Port : %d", snet.ServerPort());
	return Menu(key_select, 8, 8);
}

int Game::ClientOKMenu(SNet &snet) {
	static char *menu_kanji[] = {"", "̃T[o[ɐڑ܂", "", "", "", "", "", "OK"};
	static char *menu_kana[] = {"", "ȂT[o[", "", "", "", "", "", "OK"};
	static char *menu_english[] = {"", "Connected to this server", "", "", "", "", "", "OK"};
	static int key_select = 7;
	SetMenu(menu_kanji, menu_kana, menu_english, 8);
	sprintf(menu[3], "Host Name : %s", snet.HostName());
	sprintf(menu[4], "IP Address : %d.%d.%d.%d", snet.ServerIP1(), snet.ServerIP2(), snet.ServerIP3(), snet.ServerIP4());
	sprintf(menu[5], "Port : %d", snet.ServerPort());
	return Menu(key_select, 8, 8);
}

int Game::ClientFailedMenu(SNet &snet) {
	static char *menu_kanji[] = {"", "ڑł܂ł", "", "", "", "", "", "OK"};
	static char *menu_kana[] = {"", "ł܂ł", "", "", "", "", "", "OK"};
	static char *menu_english[] = {"", "Couldn't connect to a server", "", "", "", "", "", "OK"};
	static int key_select = 7;
	SetMenu(menu_kanji, menu_kana, menu_english, 8);
	sprintf(menu[3], "Host Name : %s", snet.HostName());
	sprintf(menu[4], "IP Address : %d.%d.%d.%d", snet.ServerIP1(), snet.ServerIP2(), snet.ServerIP3(), snet.ServerIP4());
	sprintf(menu[5], "Port : %d", snet.ServerPort());
	return Menu(key_select, 8, 8);
}

int Game::CGIFailedMessage() {
	static char *menu_kanji[] = {"", "ڑł܂ł", "", "", "", "", "", "OK"};
	static char *menu_kana[] = {"", "ł܂ł", "", "", "", "", "", "OK"};
	static char *menu_english[] = {"", "Couldn't connect to a server", "", "", "", "", "", "OK"};
	static int key_select = 7;
	SetMenu(menu_kanji, menu_kana, menu_english, 8);
	return Menu(key_select, 8, 8);
}

int Game::CGIErrorMessage() {
	static char *menu_kanji[] = {"", "CGIG[", "", "", "", "", "", "OK"};
	static char *menu_kana[] = {"", "CGIG[", "", "", "", "", "", "OK"};
	static char *menu_english[] = {"", "CGI Error", "", "", "", "", "", "OK"};
	static int key_select = 7;
	SetMenu(menu_kanji, menu_kana, menu_english, 8);
	return Menu(key_select, 8, 8);
}

int Game::ContinueMenu() {
	static char *menu_kanji[] = {"", "܂H", "",  "͂", ""};
	static char *menu_kana[] = {"", "Â܂?", "", "͂", ""};
	static char *menu_english[] = {"", "Will you continue?", "", "Yes", "No"};
	static int key_select = 3;
	SetMenu(menu_kanji, menu_kana, menu_english, 5);
	return Menu(key_select, 4, 5) - 3;
}

int Game::StoryMenu(int month) {
	static char *menu_kanji[] = {"", "", "LO", "g[ig", "挎̌", "", "߂", ""};
	static char *menu_kana[] = {"", "炢", "LO", "g[ig",  "񂰂̂", "񂹂", "ǂ", "񂽂"};
	static char *menu_english[] = {"", "Go Next Month", "Ranking", "Tournament", "Last Month's Results", "Record", "Return to Top Menu", "Retire"};
//	static char *month_kanji[] = {"", "", "O", "l", "", "Z", "", "", "", "\", "\", "\"};
	static char *month_kanji[] = {"P", "Q", "R", "S", "T", "U", "V", "W", "X", "10", "11", "12"};
	static char *month_kana[] = {" 1", " 2", " 3", " 4", " 5", " 6", " 7", " 8", " 9", "10", "11", "12"};
	static char *month_english[] = {"January", "February", "March", "April", "May", "June",
					"July", "August", "September", "October", "November", "December"};
	static int key_select = 1;
	mixer.StopMusic(); 
	SetMenu(menu_kanji, menu_kana, menu_english, 8);
	switch (lang) {
		case Kana :
			sprintf(menu[0], "%s̂", month_kana[month-1]);	
		break;
		case English :
			sprintf(menu[0], "Matches in %s", month_english[month-1]);	
		break;
		default :
			sprintf(menu[0], "%s̎", month_kanji[month-1]);	
		break;
	}
	key_select = Menu(key_select, 1, 8);
	return key_select;
}

int Game::YesNoMenu() {
	static char *menu_kanji[] = {"", "{CłH", "",  "͂", ""};
	static char *menu_kana[] = {"", "ق񂫂ł?", "", "͂", ""};
	static char *menu_english[] = {"", "Are you sure?", "", "Yes", "No"};
	static int key_select = 4;
	SetMenu(menu_kanji, menu_kana, menu_english, 5);
	return Menu(key_select, 4, 5) - 3;
}

int Game::ChoiceMenu() {
	static char *menu_kanji[] = {"", "Q[[hI", "",  "JX^", "LO", "IWi"};
	static char *menu_kana[] = {"", "Q[[h񂽂", "", "JX^", "LO", "IWi"};
	static char *menu_english[] = {"", "Select Game Mode", "", "Custom", "Ranking", "Original"};
	static int key_select = 3;
	SetMenu(menu_kanji, menu_kana, menu_english, 6);
	return Menu(key_select, 4, 6) - 3;
}

int Game::GetOfferMenu() {
	static char *menu_kanji[] = {"ʑI肩玎", "\x90\\݂܂B", "󂯂܂H", "", "vtB[", "󂯂", "f"};
	static char *menu_kana[] = {"̃{NT[炵", "݂܂B", "܂?", "", "vtB[", "", "Ƃ"};
	static char *menu_english[] = {"You have an offer", "from a higher-ranked boxer.", "Will you accept?", "", "Profile", "Accept", "Reject"};
	static int key_select = 5;
	SetMenu(menu_kanji, menu_kana, menu_english, 7);

	return Menu(key_select, 5, 7) - 4;
}

int Game::SendOfferMenu() {
	static char *menu_kanji[] = {"", "\x90\\݂܂?", "", "", "͂", ""};
	static char *menu_kana[] = {"", "݂̂܂?", "", "ǂ", "͂", ""};
	static char *menu_english[] = {"Would you like to make", "an offer of match?", "", "Auto", "Yes", "No"};
	static int key_select = 4;
	SetMenu(menu_kanji, menu_kana, menu_english, 6);

	return Menu(key_select, 4, 6) - 3;
}

/*
int Game::WhenMenu(int number) {
	static char *menu_kanji[] = {"ɂ܂?", "", "2", "3", "4", "5", "6"};
	static char *menu_kana[] = {"Ȃ񂩂ɂ܂?", "", "2", "3", "3", "4", "5", "6"};
	static char *menu_english[] = {"When would you like to match?", "", "2 months later", "3 months later", "4 months later", "5 months later", "6 months later"};
	static int key_select = 2;
	SetMenu(menu_kanji, menu_kana, menu_english, number + 1);
	return Menu(key_select, 3, number + 1) - 2;
}
 */
int Game::HowManyMenu(int number) {	
	static char *menu_kanji[] = {"N̒҂", "lɂ܂?", "", "l", "l", "Ol", "ll"};
	static char *menu_kana[] = {"Ƃ̂傤񂵂", "Ȃɂɂ܂?", "", "ЂƂ", "ӂ", "ɂ", "ɂ"};
	static char *menu_english[] = {"How many challegers", "do you want in this year?", "", "One", "Two", "Three", "Four"};
	int key_select = number + 1;
	SetMenu(menu_kanji, menu_kana, menu_english, number+3);
	return Menu(key_select, 4, number+3) - 2;
}

int Game::DefendMenu(int region) {
	static char *menu_kanji[] = {"", "hq܂?", "", "I", "hq", "ԏシ"};
	static char *menu_kana[] = {"", "ڂ܂?", "", "ǂĂ", "ڂ", "ւ񂶂傤"};
	static char *menu_english[] = {"Will you defend", "", "", "Auto Select", "Defend", "Return"};
	static int key_select = 4;
	SetMenu(menu_kanji, menu_kana, menu_english, 6);

	switch (lang) {
		case Kana:	
			sprintf(menu[0], "%s^Cg", RegionStr(region));
		break;					
		case English:
			sprintf(menu[1], "the %s Title?", RegionStr(region));
		break;
		default:	
			sprintf(menu[0], "%s^Cg", RegionStr(region));
		break;					
	}		
	return Menu(key_select, 4, 6) - 3;
}


int Game::ChallengerMenu(int region, int month) {
	static char *menu_kanji[] = {"", "̒҂ɑI΂܂B", "󂯂܂H", "", "", "vtB[", "킷", "f"};
	static char *menu_kana[] = {"", "ɂ傤ł܂B", "ǂ܂?", "", "", "vtB[", "傤񂷂", "Ƃ"};
	static char *menu_english[] = {"You will be able to challege", "", "Will you challenge?", "", "", "Profile", "Challenge", "Refuse"};
	static int key_select = 6;
	SetMenu(menu_kanji, menu_kana, menu_english, 8);

	switch (lang) {
		case Kana:	
			sprintf(menu[0], "%s^Cg}b`", RegionStr(region));
			sprintf(menu[3], "(₭%d)", month);
		break;					
		case English:
			sprintf(menu[1], "the %s Champion.", RegionStr(region));
			sprintf(menu[3], "(About %d months later)", month);
		break;
		default:	
			sprintf(menu[0], "%s^Cg}b`", RegionStr(region));
			sprintf(menu[3], "(%d)",  month);
		break;					
	}		
	return Menu(key_select, 6, 8) - 5;
}

int Game::ParticipateMenu(int t_select, int region) {
	static char *menu_kanji[] = {"", "g[igJÂ܂B", "Q܂H", "", "Q", "QȂ"};
	static char *menu_kana[] = {"", "g[igȂ܂B", "񂩂܂?", "", "񂩂", "񂩂Ȃ"};
	static char *menu_english[] = {"", "tornament will be held.", "Will you participate?", "", "Participate", "Not Participate"};

	static int key_select = 4;

	SetMenu(menu_kanji, menu_kana, menu_english, 6);
	if (t_select == ROOKIE) {
		switch (lang) {
			case English:
				sprintf(menu[0], "%s %s", RegionStr(region), RookieStr());
			break;
			case Kana:	
			default:	
				sprintf(menu[0], "%s%s",  RegionStr(region), RookieStr());
			break;					
		}
	} else {
		switch (lang) {
			case English:
				sprintf(menu[0], "%s %s", RegionStr(region), RankerStr());
			break;
			case Kana:	
			default:	
				sprintf(menu[0], "%s%s",  RegionStr(region), RankerStr());
			break;					
		}	
	}	
	return Menu(key_select, 5, 6) - 4;
}

int Game::UndecidedMenu() {
	static char *menu_kanji[] = {"", "ΐ푊͖łB", "", "OK"};
	static char *menu_kana[] = {"", "Ă͂܂Ă܂B", "", "OK"};
	static char *menu_english[] = {"", "The champion is undecided.", "", "OK"};
	static int key_select = 3;
	SetMenu(menu_kanji, menu_kana, menu_english, 4);
	return Menu(key_select, 4, 4) - 3;
}

int Game::OKMenu() {
	static char *menu_kanji[] = {"", "낵łˁH", "", "OK"};
	static char *menu_kana[] = {"", "낵ł?", "", "OK"};
	static char *menu_english[] = {"", "Is that OK?", "", "OK"};
	static int key_select = 3;
	SetMenu(menu_kanji, menu_kana, menu_english, 4);
	return Menu(key_select, 4, 4) - 3;
}

int Game::RetireMenu() {
	static char *menu_kanji[] = {"", "E悤łB", "", "OK"};
	static char *menu_kana[] = {"񂽂", "񂩂悤łB", "", "OK"};
	static char *menu_english[] = {"Retire", "You were burnout.", "", "OK"};
	static int key_select = 3;
	SetMenu(menu_kanji, menu_kana, menu_english, 4);
	return Menu(key_select, 4, 4) - 3;
}


int Game::SaveErrorMessage() {
	static char *menu_kanji[] = {"", "Z[uf[^܂", "", "OK"};
	static char *menu_kana[] = {"", "Z[uf[^܂", "", "OK"};
	static char *menu_english[] = {"", "Can't make save file.", "", "OK"};
	static int key_select = 3;
	SetMenu(menu_kanji, menu_kana, menu_english, 4);
	return Menu(key_select, 4, 4) - 3;
}

int Game::LoadErrorMessage() {
	static char *menu_kanji[] = {"", "f[^Ǎ߂܂", "", "OK"};
	static char *menu_kana[] = {"", "f[^݂߂܂", "", "OK"};
	static char *menu_english[] = {"", "Can't load data file.", "", "OK"};
	static int key_select = 3;
	SetMenu(menu_kanji, menu_kana, menu_english, 4);
	return Menu(key_select, 4, 4) - 3;
}

int Game::WaitMessage(int percent) {
	static char *menu_kanji[] = {"", "f[^쐬ł", ""};
	static char *menu_kana[] = {"", "f[^Ă܂", ""};
	static char *menu_english[] = {"", "Now Making Boxers' Data.", ""};
	static int key_select = -1;
	SetMenu(menu_kanji, menu_kana, menu_english, 3);
	sprintf(menu[2], "(Now %d%%)", percent);
	return Menu(key_select, 3, 3);
}

void Game::SetMenu(char *menu_kanji[], char *menu_kana[], char *menu_english[], int max_select) {
	int i;
	for (i = 0; i < max_select; i++) {
		switch (lang) {
			case Kana:
				strcpy(menu[i], menu_kana[i]); 			
			break;
			case English:
				strcpy(menu[i], menu_english[i]); 						
			break;
			default:	
				strcpy(menu[i], menu_kanji[i]); 						
			break;					
		}	
	}
} 

int Game::Menu(int key_select, int min_select, int max_select) {
	static int select, mouse_select;
	static int i, loop, x, y;
	static float size, csize;
	
	loop = 0;
	ttf.Choice(lang);

	SetKey1P();
	InitMenu();

	timer.SetFPS(50);	
	do {
		MenuOptions();
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
 		light.Set();
  		camera[0].Set();
		light2.Set();
 
/* Ỏ]ƕ\ */
		glring.ShowAll();

  		SDL_GetMouseState(&x, &y);
		mouse_select = -1;
		if (width*0.25  < x && width*0.75 > x) {
			for (i = min_select-1; i < max_select; i++) {
				if (height*(0.15 + (float)i*0.09) < y &&
					height*(0.24 + (float)i*0.09) > y) {
   		    		mouse_select = i;
				}
			}
		}

		if (event.IsKeyDown(kb2_left) ||  
			event.IsKeyDown(kb2_forward)) {  
			if (key_select > min_select-1) {
				key_select--;
			}
		}
		if (event.IsKeyDown(kb2_right) ||  
			event.IsKeyDown(kb2_back)) {  
			if (key_select < max_select-1) {
				key_select++;
			}
		}
		csize =	(1.0 + 0.2 * sin(RAD(2*loop++)));

		ttext.MessageEnter();
		for (i = 0; i < max_select; i++) {
			ttext.SelectColor(mouse_select == i);
			key_select == i ? size = csize : size = 1.0;
			ttext.Print(menu[i], 0.5 * size, 0, 70 - i*20);
		}

		ttext.SetColor(1.0, 1.0, 1.0);	
  		ttext.Print(timer.FPSString(), 0.25, 100, -100);
		ttext.MessageLeave();

		SDL_GL_SwapBuffers(); 
		GLmes();

		timer.Wait();
		event.Poll();
		if (key_select == -1) {
			break;		
		}
		if (IsAnyKeyDown()) {
			select = key_select;
			break;		
		}
		if (mouse_select != -1 && event.IsMouse1Down()) {
			select = mouse_select;
			break;			
		}
		if (event.IsExpose() && ScreenMode) {
			ScreenReconfig();	
			InitMenu();
			event.Clear();
			wmes("Change Resolution");
		}
	} while(!event.IsQuit());
	if (event.IsQuit()) {
		Quit();
	}	

//	ttext.Clear();		 	
	return select;
}
