#include "game.h"

void Game::OfficialMode() {
	while(1) {
		switch (OfficialModeMenu()) {
			case 0:	/*  */
				NetOfficial();
			break;
			case 1:	/* o^ */
				CustomizeSparBoxer(100);
			break;
			case 2:	/* ߂ */
				return;
			break;
			case 3:	/*  */
				return;
			break;	
		}
	}
}

int Game::NetOfficial() {
	Uint32 iver, get_iver, size;
	SNet snet;
	CGI cgi;
	SData send, get;
	StoryBoxer sb1, sb2;
	
	if (snet.Init() == SDL_FAILURE) {
		return SDL_FAILURE;	
	}

	if (cgi.Official(HostCGI, "./FengDan/official.cgi", UserName, Port, PDB_CAPTION_EN_TITLE) == SDL_FAILURE) {
		CGIFailedMessage();
		return SDL_FAILURE;
	}
	switch (cgi.SetState()) {
		case SERVER:
			snet.Server(Port);	
			if (!OfficialWait(snet, cgi)) {
				return SDL_FAILURE;		
			}
		break;
		case CLIENT:		
			if (snet.Client(cgi.Host(0), cgi.Port(0)) == SDL_FAILURE) {
				CGIFailedMessage();
				return SDL_FAILURE;
		    }
		break;			
		default:
			return SDL_FAILURE;
		break;
	}

	iver = PDB_VERSION_CODE;	
	snet.Send32(iver);
	get_iver = snet.Get32();
	if (get_iver < iver) {
		VersionFailureMessage();
		wmes("Game::NetOfficial -> Version is different.");
		return SDL_FAILURE;
	} else if (get_iver > iver) {
		VersionFailureMessage(1);
		wmes("Game::NetOfficial -> Version is different.");
		return SDL_FAILURE;
	}
	smes("Game::NetOfficial -> Match Start");		

	if (snet.IsServer()) {
		sb2 = BoxerOM; 
		if (snet.SendData(&sb2, sizeof(StoryBoxer)) == SDL_FAILURE) {
			return false;		
		}
		if (snet.GetData(&sb1, sizeof(StoryBoxer)) == SDL_FAILURE) {
			return false;		
		}

		match.Init(MaxRound, RoundTime, TKOSystem, JudgeSystem, CountSystem,
			0, 10, 0, 0, 0, 0, ReplayRate);
		if (snet.SendData(&match, sizeof(MatchHandler)) == SDL_FAILURE) {
			return false;		
		}
		match.Reset();
 	} else {
		sb1 = BoxerOM; 
		if (snet.SendData(&sb1, sizeof(StoryBoxer)) == SDL_FAILURE) {
			return false;		
		}
		if (snet.GetData(&sb2, sizeof(StoryBoxer)) == SDL_FAILURE) {
			return false;		
		}

		if (snet.GetData(&match, sizeof(MatchHandler)) == SDL_FAILURE) { 
			return false;		
		}
		match.Reset();
	}

	handler1.LoadStoryBoxer(boxer1, motion1, sb1);
	handler1.SetCustomName(UserName, 100);
	handler1.CleanManip();
	SetUpBoxer1();
	handler2.LoadStoryBoxer(boxer2, motion2, sb2);
	handler2.SetCustomName(UserName, 100);
	handler2.CleanManip();
	SetUpBoxer2();
	
	InitSelectBoxer();
	motion1.OffSet(boxer1);
	motion2.OffSet(boxer2);

   	if (snet.IsServer()) {
		send.Init(handler2.CalcDataSize(motion2));
		handler2.SaveBinBoxer(boxer2, motion2, send.RWops());
    } else {
		send.Init(handler1.CalcDataSize(motion1));
		handler1.SaveBinBoxer(boxer1, motion1, send.RWops());
    }
	snet.Send32(send.Size());   
	snet.SendData(send.Data(), send.Size());   
	size = snet.Get32();
	get.Init(size);
	snet.GetData(get.Data(), get.Size());
	if (snet.IsServer()) {
		handler1.LoadBinBoxer(boxer1, motion1, get.RWops());
		boxer1.MakeDLists(Partition, FaceStyle);
		boxer1.MakeRanges(Partition);
	} else {
		handler2.LoadBinBoxer(boxer2, motion2, get.RWops());	
		boxer2.MakeDLists(Partition, FaceStyle);
		boxer2.MakeRanges(Partition);	
	}
	
	if (!ShowBoxerOfficial(snet, sb1, sb2)) {
		NetErrorMessage();
		return SDL_FAILURE;
	}
	PleaseMessage();
   
	if (snet.IsServer()) {
		SetKeyRedCorner();
	} else {
  		SetKeyBlueCorner();	
	}
	if (MatchOfficial(snet)) {
		SaveReplayCycle();
	}
	if (snet.IsClient()) {
		SetKey1P();
	}
}

bool Game::OfficialWait(SNet &snet, CGI &cgi) {
	static int select, mouse_select, key_select;
	static int i, loop, x, y;
	static float ssize, csize;
	static bool return_value;
	
	return_value = false;
	
	timer.SetFPS(50);	
	do {
		glClearColor(0.33, 0.33, 0.33, 0.0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		SelectOptions();

		SDL_GetMouseState(&x, &y);
		mouse_select = -1;
		MouseSelectGoNext(mouse_select, x, y);

		csize = (1.0 + 0.2 * sin(RAD(2*loop++)));

		ttext.MessageEnter();
		ttext.Print("Waiting!", 1.0 * csize, 0, 10);

		select = -1;
		if (IsAnyKeyDown()) {
			select = key_select;
		}
		if (mouse_select != -1 && event.IsMouse1Down()) {
			select = mouse_select;
		}			

		ttext.SelectColor(mouse_select == GO_NEXT);
   		ttext.Print("Quit", 0.25, -100, -100);
		ttext.SetColor(1.0, 1.0, 1.0);	
 		ttext.Print(timer.FPSString(), 0.25, 100, -100);
		ttext.MessageLeave();		

		SDL_GL_SwapBuffers(); 
		GLmes();

		timer.Wait();
		event.Poll();
		if (snet.WaitClient() == SDL_SUCCESS) {
			glClearColor(0.0, 0.0, 0.0, 0.0);
			return_value = true;
			break;
		}
		if (event.IsKeyDown(go_next) || event.IsMouse3Down() ||
			(mouse_select == GO_NEXT && event.IsMouse1Down())) {
			break;
		}
		ExposeSelectBoxer();
	} while(!event.IsQuit());
	cgi.Official(HostCGI, "./FengDan/official.cgi", UserName, Port, PDB_CAPTION_EN_TITLE);
	cgi.SetState();
	if (event.IsQuit()) {
		Quit();
	} 
	glClearColor(0.0, 0.0, 0.0, 0.0);
	return return_value;
}

bool Game::MatchOfficial(SNet &snet) {
	Uint32 send_count, get_count, delay, max_delay;
	Uint32 send_data, get_data;
	Uint16 get_timecount;
	Uint8 get_round;
	int quit_match;
	quit_match = 0;
	max_delay = 5;
	send_count = 0;
	get_count = 0;

	mixer.PlayMusic(BGM_MATCH);

	handler1.Init(boxer1, motion1, match);
	handler2.Init(boxer2, motion2, match);

	can_change_mode1 = 0;
	can_change_mode2 = 0;
	which_select = 0;

	handler1.SetMode(FULL_CONTROL);
	handler2.SetMode(FULL_CONTROL);		

	SetCamera();
	SetLights();
	SetDefaultView();	
	SetBoxerPosition(1.6);
	SetBoxerName();

	handler1.SetDistance(distance);	
	handler2.SetDistance(distance);	
	handler1.SetRound(1);
	handler2.SetRound(1);	
	handler1.SaveInfo(0, boxer1, motion1);
	handler2.SaveInfo(0, boxer2, motion2);	 
    match.SetCounter(50);

	NextOff();
	timer.SetFPS(50);	
	do {
//		MatchOptions();
		
		match.CalcModeOff();
  
		if (match.IsShowRound()) {
			if (match.RingGong()) {
				mixer.PlayChunk(SE_GONG);
			}
			if (match.HasShownRound()) {
				match.Matching();
				handler1.SaveInfo(0, boxer1, motion1);
				handler2.SaveInfo(0, boxer2, motion2);	
				match.SetCounter(-50);		
			}
		} 
	
		handler1.SetDistance(distance);	
		handler2.SetDistance(distance);	

		if (match.IsMatching()) {
			if (snet.IsClient()) {
				GetKeyStates(handler1);
				GetOffenseMouseStates();

				delay = send_count - get_count;
				if (delay < max_delay) {
					send_data = MakeSendData(handler1.GetKeyState(), match.Round(), send_count);
					snet.Send32(send_data);
					handler1.SaveKeyStates(send_count);
					send_count++;			
				}  	
				
				if (snet.IsSocketReady()) {
					get_data = snet.Get32();
					if (get_data == QUIT_MATCH) {
						quit_match = BLUE_WON_TKO;					
					}
					handler2.SetKeyState(MakeGetData(get_data, &get_round, &get_timecount));
					handler2.SaveKeyStates(get_count);
					handler1.LoadKeyStates(get_count);
					get_count++;
				} else {
					handler2.InvalidKey();
				}
			} else {
				GetKeyStates(handler2);
				GetOffenseMouseStates();		

				delay = send_count - get_count;
				if (delay < max_delay) {
					send_data = MakeSendData(handler2.GetKeyState(), match.Round(), send_count);
					snet.Send32(send_data);
					handler2.SaveKeyStates(send_count);
					send_count++;			
				}  	
				
				if (snet.IsSocketReady()) {
					get_data = snet.Get32();
					if (get_data == QUIT_MATCH) {
						quit_match = RED_WON_TKO;					
					}
					handler1.SetKeyState(MakeGetData(get_data, &get_round, &get_timecount));
					handler1.SaveKeyStates(get_count);
					handler2.LoadKeyStates(get_count);
					get_count++;
				} else {
					handler1.InvalidKey();
				}
			}
		} else {
			handler1.InitKey();
			handler2.InitKey();
			handler1.Defense();
			handler2.Defense();
			handler1.SaveKeyStates(match.TimeCount());
			handler2.SaveKeyStates(match.TimeCount());
		}

		if (event.IsKeyDown(SDLK_TAB)) {
			if (snet.IsServer()) {
				quit_match = BLUE_WON_TKO;					
			} else {
				quit_match = RED_WON_TKO;								
			}
			snet.Send32(QUIT_MATCH);
		}
	
		if (match.IsEnd()) {
			match.CalcModeOff();
			ClearDelayKeysLAN(snet, &send_count, &get_count);
		}		
		if (match.IsCalcMode() && !match.IsMatching()) {
			handler1.Defense();			
			handler2.Defense();				
		}

		if (match.IsBeforeMatch() && match.IsCounterZero()) {	
			if ((handler2.IsAnyAction() || handler2.IsFullAuto()) &&
				(handler1.IsAnyAction() || handler1.IsFullAuto())) {
				match.ShowRound();
			}
		}

		if (match.IsRoundInterval()) {	
			ClearDelayKeysLAN(snet, &send_count, &get_count);
			if ((handler2.IsFullControl() && handler2.IsNoKey()) ||
				(handler1.IsFullControl() && handler1.IsNoKey()) ||
				(handler2.IsSemiAuto() && !handler2.IsAnyAction()) ||
				(handler1.IsSemiAuto() && !handler1.IsAnyAction())) {
				match.SkipIntervalCount();			
			}
			if (match.IsSkipInterval() &&
				((handler2.IsAnyAction() || handler2.IsFullAuto()) &&
				 (handler1.IsAnyAction() || handler1.IsFullAuto())) ||
				event.IsKeyPressed(go_next) || event.IsMouse1Pressed()) {
				match.CalcModeOn();
			}
			if (distance > 6.0 &&
				(handler2.IsAnyAction() || handler2.IsFullAuto()) &&
				(handler1.IsAnyAction() || handler1.IsFullAuto())) {
				if (match.IsLastRound()) {
					match.Decision(handler1, handler2);
					if (match.IsExtraRoundSystem() && match.IsDraw() && !match.IsExtraRound()) {
						RoundStart();
					} else {
						match.End();
						mixer.PlayChunk(SE_KO);
						handler1.SaveEndInfo(boxer1, motion1);
						handler2.SaveEndInfo(boxer2, motion2);			
					}
				} else {
					RoundStart();
				}
			}
		}

		if (handler1.IsKeyValid() && handler2.IsKeyValid()) {
			if (!match.IsMatching()) {
				handler1.InitKey();		
				handler2.InitKey();	
			} else {
				if (match.Round() != get_round ||
					match.TimeCount() != get_timecount) {
					if (snet.IsClient()) {
						wmes("Game::MatchOfficial -> Synchronize Error by Client");
					} else {
						wmes("Game::MatchOfficial -> Synchronize Error by Server");				
					}
					fprintf(stderr, "Round = %d,%d TimeCount = %d,%d\n", match.Round(), get_round, match.TimeCount(), get_timecount);			
					if (!quit_match) {
						quit_match = NO_CONTEST;
					}
				}			
				if (handler2.IsCounting() && !handler1.IsCounting()) {
					handler1.InitKey();				
				}
				if (handler1.IsCounting() && !handler2.IsCounting()) {
					handler2.InitKey();		
				}
			}
			if (match.IsCalcMode()) {
				CalcRoutine();		
			} else {
				if (quit_match) {
					ThrowIn(quit_match);
					quit_match = 0;
				} else {
					ShowRoutine();
				}
			}
		}
		
		event.Poll();
		ExposeScreen();
		if (match.IsEnd() && (event.IsKeyDown(go_next) || IsNext())) {
			break;		
		}
	} while(!event.IsQuit());
	if (event.IsQuit()) {
		snet.Send32(QUIT_MATCH);
		Quit();
	}
	return true;	
}

bool Game::ShowBoxerOfficial(SNet &snet, StoryBoxer &sb1, StoryBoxer &sb2) {
	static char buf[255];
	static int x, y, mouse_select = -1;

	timer.SetFPS(50);	
	do {
		glClearColor(0.33, 0.33, 0.33, 0.0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

		SDL_GetMouseState(&x, &y);
		mouse_select = -1;
		MouseSelectGoNext(mouse_select, x, y);

		RedCornerBoxer();
		RedCornerInfo(-1, buf);
		ttext.MessageEnter();
		RecordStr(sb2, buf);
	 	ttext.Print(buf, 0.5, 0, -55);
		ttext.MessageLeave();		

		BlueCornerBoxer();
		BlueCornerInfo(-1, buf);		
		ttext.MessageEnter();
		RecordStr(sb1, buf);
	 	ttext.Print(buf, 0.5, 0, -55);
		ttext.MessageLeave();		

		glViewport(0, 0, width, height);
		SelectOptions();
		ttext.MessageEnter();
		ShowMatchInfo(buf);
		if (match.ResultState() != NO_RESULT) {
			ShowMatchResult(buf);	
		}
		ttext.SelectColor(mouse_select == GO_NEXT);
	   	ttext.Print("Next", 0.25, -100, -100);		
		ttext.SetColor(1.0, 1.0, 1.0);	
 		ttext.Print(timer.FPSString(), 0.25, 100, -100);
		ttext.MessageLeave();		

		SDL_GL_SwapBuffers(); 
		GLmes();

		timer.Wait();
		event.Poll();
		if (event.IsKeyDown(go_next)|| 
			(mouse_select == GO_NEXT && event.IsMouse1Down())) {
			break;		
		}
		ExposeSelectBoxer();
	} while(!event.IsQuit());
	if (event.IsQuit()) {
		snet.Send32(QUIT_MATCH);
		Quit();
	}
 
 	glViewport(0, 0, width, height);
 	glClearColor(0.0, 0.0, 0.0, 0.0);
	return true;
}

