#include "game.h"

void Game::InitOpening() {
/* ÕfBXvCXg */
	glring.Make(1, texs[TE_CANVAS], texs[TE_ADS], 36);

/* JƃCg */
	camera.Init(2);
	camera[0].DefPosition(0.0, 0.0, 10.0);
	camera[1].DefPosition(0.0, 0.0, 5.0);
	camera.Perspective(60.0, 0.05, 20.0);

	light.Init(0);
	light.On();
}

void Game::Opening() {
	int i = 0, chunk_number = 0;
    float ax = 0.0, ay = 0.0, az = 0.0;
    float dax = 1.0, day = 0.0, daz = 0.0;

/* BGM̉t */
	mixer.PlayMusic(BGM_OPENING); 

/* |StHg̍쐬 */
	ttf.Choice(FONT_TITLE);
	ptext.MakeText("|SŃ{NVO");

/* ގƂ̐ݒ */
	GLMaterial title_color, fps_color, name_color;
	title_color.DefDiffuse(1.0, 0.0, 0.0);
	title_color.DefSpecular(1.0, 1.0, 1.0);
	title_color.DefShininess(100.0);
	fps_color.DefDiffuse(1.0, 1.0, 1.0);

	InitOpening();

	timer.SetFPS(50);	
	do {
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		light.Set();
  		camera[0].Set();

/* Ỏ]ƕ\ */
		glRotatef(ax, 1.0, 0.0, 0.0);
  		glRotatef(ay, 0.0, 1.0, 0.0);
   		glRotatef(az, 0.0, 0.0, 1.0);
		glring.ShowAll();

		ax += dax;
		ay += day;
		az += daz;
	    if(ax >= 360.0) {
	    	ax = 0.0;
	        dax = 0.0;
	        day = 1.0;
	    }
	    if(ay >= 360.0) {
	    	ay = 0.0;
	        day = 0.0;
	        daz = 1.0;
	    }
	    if(az >= 360.0) {
	    	az = 0.0;
	        daz = 0.0;
	        dax = 1.0;
	    }

/* ^Cg̕\ */
  		glLoadIdentity();
		camera[1].Set();

		title_color.Set();

	  	glPushMatrix();
		glScalef(1.2, 1.2, 1.2);
  		glTranslatef(0.0, 1.0, 0.0);
  		glRotatef(i, 0.0, 1.0, 0.0);
 	 	glTranslatef(-2.0, 0.0, 0.0);
		ptext.Text("|S");
  		glPopMatrix();

		glPushMatrix();
		glScalef(1.2, 1.2, 1.2);
 		glTranslatef(0.0, 0.0, 0.0);
  		glRotatef(-i, 0.0, 1.0, 0.0);
	  	glTranslatef(-0.5, 0.0, 0.0);
		ptext.Text("");
  		glPopMatrix();

  		glPushMatrix();
		glScalef(1.2, 1.2, 1.2);
  		glTranslatef(0.0, -1.0, 0.0);
  		glRotatef(i, 0.0, 1.0, 0.0);
	  	glTranslatef(-2.5, 0.0, 0.0);
		ptext.Text("{NVO");
 		glPopMatrix();
 
/* ҂̕\ */
		name_color.Set();
		glPushMatrix();
		glScalef(0.4, 0.25, 0.25);
 		glTranslatef(-5.0, -7.0, 4.0*sin(RAD(i)));
		ptext.Text("Producted by FengDan");
		glPopMatrix();


/* FPS̕\ */
		fps_color.Set();
  		glPushMatrix();
  		glTranslatef(2.50, -2.8, 0.0);
		glScalef(0.25, 0.25, 0.25);
		ptext.Text(timer.FPSString());
  		glPopMatrix(); 

/* ʉ̐؂ւ */
		i++;
		if(i >= 360) {
			i = 0;
			mixer.PlayChunk(chunk_number++);			
			if (chunk_number == SE_BOX) {
				chunk_number = 0;
		 	}
		}

		SDL_GL_SwapBuffers(); 
		GLmes();

		timer.Wait();
		event.Poll();
		if (event.IsKeyDown(go_next) || event.IsMouse1Down()) {
			break;		
		}
		if (event.IsExpose() && ScreenMode) {
			ScreenReconfig();	
			InitOpening();
			event.Clear();
			wmes("Game::Opening -> Change Resolution");
		} 
	} while(!event.IsQuit());
	if (event.IsQuit()) {
		Quit();
	}	
	ptext.Clear();		 	
	ttf.Choice(lang);
}


void Game::CanvasMaker() {
	char title[] = "Polygon de Boxing";
	int i = 0, chunk_number = 0;

/* |StHg̍쐬 */
	ttf.Choice(FONT_TITLE);
	ptext.MakeText(title);

/* ގƂ̐ݒ */
	GLMaterial title_color, ver_color;
	title_color.DefDiffuse(1.0, 0.0, 0.0);
	title_color.DefSpecular(1.0, 1.0, 1.0);
	title_color.DefShininess(100.0);

	ver_color.DefDiffuse(0.2, 0.2, 0.2);

	InitOpening();

	timer.SetFPS(50);	
	do {
		glClearColor(0.6, 0.6, 0.8, 0.0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		light.Set();
  		camera[0].Set();

/* ̕\ */
  		glLoadIdentity();
		camera[1].Set();

		title_color.Set();
		for (i = 0; title[i] != '\0'; i++) {
		  	glPushMatrix();
			glScalef(1.2, 1.2, 1.2);
  			glRotatef(-20.0*i, 0.0, 0.0, 1.0);
  			glTranslatef(-0.2, 1.0, 0.0);
			ptext.Char(title[i]);
	  		glPopMatrix();
		}

		ver_color.Set();
		glPushMatrix();
		glScalef(0.25, 0.25, 0.25);
 		glTranslatef(-4.0, -0.2, 4.0);
		ptext.Text("Ver 1.2 Release");
		glPopMatrix();

		SDL_GL_SwapBuffers(); 
		GLmes();

		timer.Wait();
		event.Poll();
		if (event.IsKeyDown(go_next) || event.IsMouse1Down()) {
			break;		
		}
		if (event.IsExpose() && ScreenMode) {
			ScreenReconfig();	
			InitOpening();
			event.Clear();
			wmes("Change Resolution");
		} 
	} while(!event.IsQuit());
	if (event.IsQuit()) {
		Quit();
	}	
	ptext.Clear();		 	
	ttf.Choice(lang);
}
