#include "game.h"

void Game::MenuOptions() {
	if (event.IsKeyDown(SDLK_TAB)) {
		PanicPause();		
	}

	if (event.IsKeyDown(SDLK_F1)) {
		WriteConfig();		
	}

	if (event.IsKeyDown(SDLK_F2)) {
		if (ScreenMode) {
			ScreenMode = 0;			
		} else {
			ScreenMode = 1;						
		}

		ScreenReconfig();
		InitMenu();
		event.Clear();
	}

	if (event.IsKeyDown(SDLK_INSERT)) {
		if (SDL_GetModState() & KMOD_SHIFT)  {
			if (--ScreenSize < 0) {
				ScreenSize = 5;			
			}		
		} else {
			if (++ScreenSize > 5) {
				ScreenSize = 0;			
			}
		}		
		ScreenReconfig();
		InitMenu();
		event.Clear();
	}		
	VolumeOptions();
}

void Game::SelectOptions() {
	if (event.IsKeyDown(SDLK_TAB)) {
		PanicPause();		
	}

	if (event.IsKeyDown(SDLK_F1)) {
		WriteConfig();		
	}

	if (event.IsKeyDown(SDLK_F2)) {
		if (ScreenMode) {
			ScreenMode = 0;			
		} else {
			ScreenMode = 1;						
		}

		ScreenReconfig();
		InitSelectBoxer();
		event.Clear();
	}

	if (event.IsKeyDown(SDLK_INSERT)) {
		if (SDL_GetModState() & KMOD_SHIFT)  {
			if (--ScreenSize < 0) {
				ScreenSize = 5;			
			}		
		} else {
			if (++ScreenSize > 5) {
				ScreenSize = 0;			
			}
		}		
		ScreenReconfig();
		InitSelectBoxer();
		event.Clear();
	}		
	VolumeOptions();
}

void Game::MatchOptions() {
	ScreenOptions();
	ViewOptions();
	VolumeOptions();

	if (event.IsKeyDown(SDLK_F4)) {
		if (show1) {
			show1 = 0;		
		} else {
			show1 = 1;			
		}
	}
	if (event.IsKeyDown(SDLK_F3)) {
		if (show2) {
			show2 = 0;		
		} else {
			show2 = 1;			
		}
	}
}


void Game::ScreenOptions() {
/*	if (event.IsKeyDown(SDLK_RETURN) && (SDL_GetModState() & KMOD_LALT)) {
		screen.IconifyWindow();
	}   */

	if (event.IsKeyDown(SDLK_TAB)) {
		PanicPause();		
	}

	if (event.IsKeyDown(SDLK_F1)) {
		WriteConfig();		
	}

	if (event.IsKeyDown(SDLK_F2)) {
		if (ScreenMode) {
			ScreenMode = 0;			
		} else {
			ScreenMode = 1;						
		}

		ScreenReconfig();
		MakeObjects(Partition);
		event.Clear();
	}

	if (event.IsKeyDown(SDLK_INSERT)) {
		if (SDL_GetModState() & KMOD_SHIFT)  {
			if (--ScreenSize < 0) {
				ScreenSize = 5;			
			}		
		} else {
			if (++ScreenSize > 5) {
				ScreenSize = 0;			
			}
		}		
		ScreenReconfig();
		MakeObjects(Partition);
		event.Clear();
	}		
/*
	if (event.IsKeyDown(SDLK_DELETE)) {
		if (--ScreenSize < 0) {
			ScreenSize = 5;			
		}

		ScreenReconfig();
		MakeObjects(Partition);
		event.Clear();
	}	
*/
}

void Game::ViewOptions() {
	if (event.IsKeyDown(SDLK_F5)) {
		if (SDL_GetModState() & KMOD_CTRL) {
			Angle += 5;
			SetAngle();
		} else if (SDL_GetModState() & KMOD_SHIFT)  {
			SelectSideView2();
		} else{
			SelectSideView1();
		}
	}
	if (event.IsKeyDown(SDLK_F6)) {
		if (SDL_GetModState() & KMOD_CTRL) {
			Angle -= 5;
			SetAngle();
		} else if (SDL_GetModState() & KMOD_SHIFT)  {
			SelectBackView2();
		} else {
			SelectBackView1();		
		}
	}
	if (event.IsKeyDown(SDLK_F7)) {
		if (SDL_GetModState() & KMOD_CTRL) {
			Brightness += 5;
			if (Brightness > 100) {
				Brightness = 100;			
			}
			SetBrightness();
		} else if (SDL_GetModState() & KMOD_SHIFT)  {
			SelectTopView2();
		} else {
			SelectTopView1();
		}
	}
	if (event.IsKeyDown(SDLK_F8)) {
		if (SDL_GetModState() & KMOD_CTRL) {
			Brightness -= 5;
			if (Brightness < -100) {
				Brightness = -100;			
			}
			SetBrightness();
		} else if (SDL_GetModState() & KMOD_SHIFT)  {
			SelectBoxerView2();
		} else {
			SelectBoxerView1();
		}
	}
	if (event.IsKeyDown(SDLK_F9)) {
		if (SDL_GetModState() & KMOD_CTRL) {
			Rotation += 5;
			SetAngle();
		} else if (SDL_GetModState() & KMOD_SHIFT)  {
			SelectFixedView5();
		} else {
			SelectFixedView1();
		}
	}
	if (event.IsKeyDown(SDLK_F10)) {
		if (SDL_GetModState() & KMOD_CTRL) {
			Rotation -= 5;
			SetAngle();
		} else if (SDL_GetModState() & KMOD_SHIFT)  {
			SelectFixedView6();
		} else {
			SelectFixedView2();
		}
	}
	if (event.IsKeyDown(SDLK_F11)) {
		if (SDL_GetModState() & KMOD_CTRL) {
			Rotation += 5;
			SetAngle();
		} else if (SDL_GetModState() & KMOD_SHIFT)  {
			SelectFixedView7();
		} else {
			SelectFixedView3();
		}
	}
	if (event.IsKeyDown(SDLK_F12)) {
		if (SDL_GetModState() & KMOD_CTRL) {
			Rotation -= 5;
			SetAngle();
		} else if (SDL_GetModState() & KMOD_SHIFT)  {
			SelectFixedView8();
		} else {
			SelectFixedView4();
		}
	}
}

void Game::VolumeOptions() {
	if (event.IsKeyDown(SDLK_HOME)) {
		SEVolume+=8;
		if (SEVolume > 128) {
			SEVolume = 128;			
		}
		mixer.SetChunkVolume(SEVolume);
	}
	if (event.IsKeyDown(SDLK_END)) {
		SEVolume-=8;
		if (SEVolume < 0) {
			SEVolume = 0;			
		}
		mixer.SetChunkVolume(SEVolume);
	}

	if (event.IsKeyDown(SDLK_PAGEUP)) {
		BGMVolume+=8;
		if (BGMVolume > 128) {
			BGMVolume = 128;			
		}
		mixer.SetMusicVolume(BGMVolume);
	}
	if (event.IsKeyDown(SDLK_PAGEDOWN)) {
		BGMVolume-=8;
		if (BGMVolume < 0) {
			BGMVolume = 0;			
		}
		mixer.SetMusicVolume(BGMVolume);
	}
}

void Game::SetKeySideView1() {
	handler1.SetLeftOffense(kb1_left_offense);
	handler1.SetRightOffense(kb1_right_offense);
	handler1.SetDefense(kb1_defense);

	handler1.SetForward(kb1_forward);
	handler1.SetBack(kb1_back);
	handler1.SetRight(kb1_right);
	handler1.SetLeft(kb1_left);


	handler2.SetLeftOffense(kb2_left_offense);
	handler2.SetRightOffense(kb2_right_offense);
	handler2.SetDefense(kb2_defense);

	handler2.SetForward(kb2_forward);
	handler2.SetBack(kb2_back);
	handler2.SetRight(kb2_right);
	handler2.SetLeft(kb2_left);
}

void Game::SetKeySideView2() {
	handler1.SetLeftOffense(kb1_left_offense);
	handler1.SetRightOffense(kb1_right_offense);
	handler1.SetDefense(kb1_defense);

	handler1.SetForward(kb1_back);
	handler1.SetBack(kb1_forward);
	handler1.SetRight(kb1_left);
	handler1.SetLeft(kb1_right);


	handler2.SetLeftOffense(kb2_left_offense);
	handler2.SetRightOffense(kb2_right_offense);
	handler2.SetDefense(kb2_defense);

	handler2.SetForward(kb2_back);
	handler2.SetBack(kb2_forward);
	handler2.SetRight(kb2_left);
	handler2.SetLeft(kb2_right);
}

void Game::SetKeyBackView1() {
	handler1.SetLeftOffense(kb1_left_offense);
	handler1.SetRightOffense(kb1_right_offense);
	handler1.SetDefense(kb1_defense);

	handler1.SetForward(kb1_left);
	handler1.SetBack(kb1_right);
	handler1.SetRight(kb1_forward);
	handler1.SetLeft(kb1_back);


	handler2.SetLeftOffense(kb2_left_offense);
	handler2.SetRightOffense(kb2_right_offense);
	handler2.SetDefense(kb2_defense);

	handler2.SetForward(kb2_left);
	handler2.SetBack(kb2_right);
	handler2.SetRight(kb2_forward);
	handler2.SetLeft(kb2_back);
}

void Game::SetKeyBackView2() {
	handler1.SetLeftOffense(kb1_left_offense);
	handler1.SetRightOffense(kb1_right_offense);
	handler1.SetDefense(kb1_defense);

	handler1.SetForward(kb1_right);
	handler1.SetBack(kb1_left);
	handler1.SetRight(kb1_back);
	handler1.SetLeft(kb1_forward);


	handler2.SetLeftOffense(kb2_left_offense);
	handler2.SetRightOffense(kb2_right_offense);
	handler2.SetDefense(kb2_defense);

	handler2.SetForward(kb2_right);
	handler2.SetBack(kb2_left);
	handler2.SetRight(kb2_back);
	handler2.SetLeft(kb2_forward);
}

void Game::SelectSideView1() {
	DefaultView = 0;
	view = SIDE_VIEW1;
	SetTransparent();
	SetBrightness();
	camera.Perspective(60.0, 0.05, 20.0);
	SetKeySideView1();
}

void Game::SelectSideView2() {
	DefaultView = 1;
	view = SIDE_VIEW2;
	SetTransparent();
	SetBrightness();
	camera.Perspective(60.0, 0.05, 20.0);
	SetKeySideView2();
}

void Game::SelectBackView1() {
	DefaultView = 2;
	view = BACK_VIEW1;
	SetTransparent();
	SetBrightness();
	camera.Perspective(60.0, 0.05, 20.0);
	SetKeyBackView1();
}

void Game::SelectBackView2() {
	DefaultView = 3;
	view = BACK_VIEW2;
	SetTransparent();
	SetBrightness();
	camera.Perspective(60.0, 0.05, 20.0);
	SetKeyBackView2();
}

void Game::SelectTopView1() {
	DefaultView = 4;
	view = TOP_VIEW1;
	SetTransparent();
	SetBrightness();
	camera.Perspective(60.0, 0.05, 20.0);
	SetKeySideView1();
}

void Game::SelectTopView2() {
	DefaultView = 5;
	view = TOP_VIEW2;
	SetTransparent();
	SetBrightness();
	camera.Perspective(60.0, 0.05, 20.0);
	SetKeySideView2();
}

void Game::SelectBoxerView1() {
	DefaultView = 6;
	view = BOXER_VIEW1;
	SetTransparent();
	SetBrightness();
	camera.Perspective(60.0, 0.02, 20.0);
	SetKeyBackView1();
}

void Game::SelectBoxerView2() {
	DefaultView = 7;
	view = BOXER_VIEW2;
	SetTransparent();
	SetBrightness();
	camera.Perspective(60.0, 0.02, 20.0);
	SetKeyBackView2();
}

void Game::SelectFixedView1() {
	DefaultView = 8;
	view = FIXED_VIEW1;
	SetTransparent();
	SetBrightness();
	camera.Perspective(60.0, 0.05, 20.0);
	SetKeySideView1();
}

void Game::SelectFixedView2() {
	DefaultView = 9;
	view = FIXED_VIEW2;
	SetTransparent();
	SetBrightness();
	camera.Perspective(60.0, 0.05, 20.0);
	SetKeySideView2();
}

void Game::SelectFixedView3() {
	DefaultView = 10;
	view = FIXED_VIEW3;
	SetTransparent();
	SetBrightness();
	camera.Perspective(60.0, 0.05, 20.0);
	SetKeySideView1();
}

void Game::SelectFixedView4() {
	DefaultView = 11;
	view = FIXED_VIEW4;
	SetTransparent();
	SetBrightness();
	camera.Perspective(60.0, 0.05, 20.0);
	SetKeySideView2();
}

void Game::SelectFixedView5() {
	DefaultView = 12;
	view = FIXED_VIEW5;
	SetTransparent();
	SetBrightness();
	camera.Perspective(60.0, 0.05, 20.0);
	SetKeySideView1();
}

void Game::SelectFixedView6() {
	DefaultView = 13;
	view = FIXED_VIEW6;
	SetTransparent();
	SetBrightness();
	camera.Perspective(60.0, 0.05, 20.0);
	SetKeySideView2();
}

void Game::SelectFixedView7() {
	DefaultView = 14;
	view = FIXED_VIEW7;
	SetTransparent();
	SetBrightness();
	camera.Perspective(60.0, 0.05, 20.0);
	SetKeySideView1();
}

void Game::SelectFixedView8() {
	DefaultView = 15;
	view = FIXED_VIEW8;
	SetTransparent();
	SetBrightness();
	camera.Perspective(60.0, 0.05, 20.0);
	SetKeySideView2();
}

void Game::SetTransparent() {
	switch (view) {
		case BACK_VIEW1:
			boxer1.skin.DefDiffuse(NO_CHANGE, NO_CHANGE, NO_CHANGE, 1.0);
			boxer2.skin.DefDiffuse(NO_CHANGE, NO_CHANGE, NO_CHANGE, 0.333);
			boxer1.hair.DefDiffuse(NO_CHANGE, NO_CHANGE, NO_CHANGE, 1.0);
			boxer2.hair.DefDiffuse(NO_CHANGE, NO_CHANGE, NO_CHANGE, 0.1);
		break;
		case BACK_VIEW2:
			boxer1.skin.DefDiffuse(NO_CHANGE, NO_CHANGE, NO_CHANGE, 0.333);
			boxer2.skin.DefDiffuse(NO_CHANGE, NO_CHANGE, NO_CHANGE, 1.0);
			boxer1.hair.DefDiffuse(NO_CHANGE, NO_CHANGE, NO_CHANGE, 0.1);
			boxer2.hair.DefDiffuse(NO_CHANGE, NO_CHANGE, NO_CHANGE, 1.0);
		break;
		default :
			boxer1.skin.DefDiffuse(NO_CHANGE, NO_CHANGE, NO_CHANGE, 1.0);
			boxer2.skin.DefDiffuse(NO_CHANGE, NO_CHANGE, NO_CHANGE, 1.0);
			boxer1.hair.DefDiffuse(NO_CHANGE, NO_CHANGE, NO_CHANGE, 1.0);
			boxer2.hair.DefDiffuse(NO_CHANGE, NO_CHANGE, NO_CHANGE, 1.0);
		break;
	}
}

void Game::SetAngle() {
	if (Angle > 90) {
		Angle = 90;			
	}
	if (Angle < -90) {
		Angle = -90;			
	}
	if (Rotation > 135) {
		Rotation = 135;			
	}
	if (Rotation < -45) {
		Rotation = -45;			
	}
	angle_cos = cos(RAD(Angle));		
	angle_sin = sin(RAD(Angle));		
	rot_cos = cos(RAD((90 - Rotation)));		
	rot_sin = sin(RAD((90 - Rotation)));		
	SetBrightness();
}

void Game::SetBrightness() {
	switch (view) {
		case TOP_VIEW1:
		case TOP_VIEW2:
		case FIXED_VIEW3:
		case FIXED_VIEW4:
		case FIXED_VIEW7:
		case FIXED_VIEW8:
			brightness = 0.2 + (float)Brightness/100.0; 
		break;
		case BOXER_VIEW1:
		case BOXER_VIEW2:
			brightness = 0.8 + (float)Brightness/100.0; 
		break;
		default :
			brightness = 0.8 + (float)Brightness/100.0; 
			if (Angle > 0) {
				brightness -= (float)Angle / 90.0 * 0.6;
			}
		break;
	}
	if (brightness < 0.0) {
		brightness = 0.0;
	}
	if (brightness > 1.0) {
		brightness = 1.0;
	}
	light2.Diffuse(brightness, brightness, brightness);
}

void Game::ExposeScreen() {
	if (event.IsExpose() && ScreenMode) {
		ScreenReconfig();
		MakeObjects(Partition);
		event.Clear();
		wmes("ExposeScreen -> Change Resolution");
	} 
}

void Game::MakeObjects(int partition) {
	glring.Make(AdsSwitch, texs[TE_CANVAS], texs[TE_ADS], Partition);
	glbg.Make(texs[TE_BACKGROUND], texs[TE_FLOOR], texs[TE_ROOF], BackGroundSwitch, Partition);
	glsandbag.Make(Partition);
	cyanosis_meter.Make(Partition);
    damage_meter.Make(Partition);
	distance_meter.Make(Partition);

	boxer1.MakeDLists(Partition, FaceStyle);
	boxer1.MakeRanges(Partition);
	boxer2.MakeDLists(Partition, FaceStyle);
	boxer2.MakeRanges(Partition);

	light.Init(0);
	light2.Init(1);
	light.On();
	light2.On();
}

void Game::PanicPause() {
	do {
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		ttext.MessageEnter();
		switch (lang) {
			case Kana:
				ttext.Print("ق񂻂  @@"								 , 0.25, -90, 95);        
				ttext.Print("EscL[łイ傤                    @@      ", 0.25, 0, 85);
				ttext.Print("Xy[Xłɂ                      @@   ", 0.25, 0, 75);

				ttext.Print("Ăւ񂱂@@"								 , 0.25, -90, 65);
				ttext.Print("F5L[ł܂悱̂Ă                    @@ ", 0.25, 0, 55);
				ttext.Print("F6L[ł܂납̂Ă                  @@ ", 0.25, 0, 45);
				ttext.Print("F7L[ł܂̂Ă                    @@ ", 0.25, 0, 35);
				ttext.Print("F8L[Ń{NT[Ă                      @@   ", 0.25, 0, 25);
				ttext.Print("Shift + F5`F8L[łႭق̂Ă@@ ", 0.25, 0, 15);
				ttext.Print("CTRL + F5`F8L[ŃAOƂ邳ւ񂱂      ", 0.25, 0, 5);

				ttext.Print("ւ񂱂@@"								, 0.25, -90, -5);
				ttext.Print("1/2L[ł/R[i[{NT[̂ւ񂱂", 0.25, 0, -15);

				ttext.Print("񂫂傤Ă"								 , 0.25, -90, -25);
				ttext.Print("F1L[łĂق                    @@     ", 0.25, 0, -35);
				ttext.Print("F2L[ŃtXN[/EBhEւ񂱂    @@  ", 0.25, 0, -45);
				ttext.Print("InsertL[łǂւ񂱂             @@@@", 0.25, 0, -55);
				ttext.Print("Home/EndL[ł{[Abv/_E@@", 0.25, 0, -65);
				ttext.Print("Page Up/Page DownL[BGM{[Abv/_E@", 0.25, 0, -75);

				ttext.Print("|[Y@@@@@@"								 , 0.25, -90, -85);
				ttext.Print("TabL[łЂ傤|[Y(񂢃wv)   @@     ", 0.25, 0, -95);			
			break;
			
			case English:
				ttext.Print("Basic Control      "							   , 0.25, -90, 95);        
				ttext.Print("Esc Key : Quit                                   ", 0.25, 0, 85);
				ttext.Print("Space Key : Go Next                              ", 0.25, 0, 75);

				ttext.Print("Change View        "							   , 0.25, -90, 65);
				ttext.Print("F5 Key : Side View                               ", 0.25, 0, 55);
				ttext.Print("F6 Key : Back View                               ", 0.25, 0, 45);
				ttext.Print("F7 Key : Top View                                ", 0.25, 0, 35);
				ttext.Print("F8 Key : Boxer's View                            ", 0.25, 0, 25);
				ttext.Print("Shift + F5-F8 Key : Each Views of the Other Sides", 0.25, 0, 15);
				ttext.Print("CTRL + F5-F8 Key : Change Angle or Brightness    ", 0.25, 0, 5);

				ttext.Print("Change Control Mode"							   , 0.25, -90, -5);
				ttext.Print("1/2 Key : Change Boxer's Control Mode            ", 0.25, 0, -15);			

				ttext.Print("Environment        "							   , 0.25, -90, -25);
				ttext.Print("F1 Key : Save Environemnt                        ", 0.25, 0, -35);
				ttext.Print("F2 Key : Change Window/Full Screen Mode          ", 0.25, 0, -45);
				ttext.Print("Insert Key : Change Resolution                   ", 0.25, 0, -55);
				ttext.Print("Home/End Key : Sound Effect Volume Up/Down       ", 0.25, 0, -65);
				ttext.Print("Page Up/Page Down Key : BGM Volume Up/Down       ", 0.25, 0, -75);

				ttext.Print("Pause              "							   , 0.25, -90, -85);
				ttext.Print("Tab Key : Emergency Pause(Simple Help)           ", 0.25, 0, -95);			
			break;
			
			default:		
				ttext.Print("{"									    , 0.25, -90, 95);        
				ttext.Print("EscL[ŏI                                    ", 0.25, 0, 85);
				ttext.Print("Xy[XŎɐi                               ", 0.25, 0, 75);

				ttext.Print("_ύX"									    , 0.25, -90, 65);
				ttext.Print("F5L[Ő^̎_                           ", 0.25, 0, 55);
				ttext.Print("F6L[Ő^납̎_                         ", 0.25, 0, 45);
				ttext.Print("F7L[Ő^ォ̎_                           ", 0.25, 0, 35);
				ttext.Print("F8L[Ń{NT[ڐ                             ", 0.25, 0, 25);
				ttext.Print("Shift + F5`F8L[ŋt̎_             ", 0.25, 0, 15);
				ttext.Print("CTRL + F5`F8L[ŃAOƖ邳ύX          ", 0.25, 0, 5);

				ttext.Print("ύX"									  , 0.25, -90, -5);
				ttext.Print("1/2L[Ő/R[i[{NT[̑샂[hύX   ", 0.25, 0, -15);

				ttext.Print("ݒ"										, 0.25, -90, -25);
				ttext.Print("F1L[Őݒۑ                                 ", 0.25, 0, -35);
				ttext.Print("F2L[ŃEBhE/tXN[ύX            ", 0.25, 0, -45);
				ttext.Print("InsertL[ŉ𑜓xύX          @@@@@@@   ", 0.25, 0, -55);
				ttext.Print("Home/EndL[Ōʉ{[Abv/_E      ", 0.25, 0, -65);
				ttext.Print("Page Up/Page DownL[BGM{[Abv/_E", 0.25, 0, -75);

				ttext.Print("|[Y@"									    , 0.25, -90, -85);
				ttext.Print("TabL[Ŕ펞|[Y(ȈՃwv)                ", 0.25, 0, -95);
			break;  
		}
		ttext.MessageLeave();
		SDL_GL_SwapBuffers();
	 	GLmes();
		timer.Wait();

		event.Poll();
		ExposeScreen();
		if (event.IsKeyDown(go_next) || event.IsMouse1Down()) {
			break;		
		}
	} while(!event.IsQuit());
	if (event.IsQuit()) {
		Quit();
	}
}

void Game::SetKeyBlueCorner() {
	use_mouse = 1;

	kb1_left_offense  = KB1LeftOffense;
	kb1_right_offense = KB1RightOffense;
	kb1_defense       = KB1Defense;
	kb1_forward       = KB1Back;
	kb1_back          = KB1Forward;
	kb1_right         = KB1Left;
	kb1_left          = KB1Right;
	
	kb2_left_offense  = KB3LeftOffense;
	kb2_right_offense = KB3RightOffense;
	kb2_defense       = KB3Defense;
	kb2_forward       = KB3Back;
	kb2_back          = KB3Forward;
	kb2_right         = KB3Left;
	kb2_left          = KB3Right;
}

void Game::SetKeyRedCorner() {
	SetKey1P();
}

void Game::SetKey1P() {
	use_mouse = 2;

	kb1_left_offense  = KB3LeftOffense;
	kb1_right_offense = KB3RightOffense;
	kb1_defense       = KB3Defense;
	kb1_forward       = KB3Forward;
	kb1_back          = KB3Back;
	kb1_right         = KB3Right;
	kb1_left          = KB3Left;
	
	kb2_left_offense  = KB1LeftOffense;
	kb2_right_offense = KB1RightOffense;
	kb2_defense       = KB1Defense;
	kb2_forward       = KB1Forward;
	kb2_back          = KB1Back;
	kb2_right         = KB1Right;
	kb2_left          = KB1Left;
}

void Game::SetKey2P() {
	if (UseMouse == 1) {
		use_mouse = 2;
	} else {
		use_mouse = 1;	
	}

	kb1_left_offense  = KB3LeftOffense;
	kb1_right_offense = KB3RightOffense;
	kb1_defense       = KB3Defense;
	kb1_forward       = KB3Forward;
	kb1_back          = KB3Back;
	kb1_right         = KB3Right;
	kb1_left          = KB3Left;
	
	kb2_left_offense  = KB2LeftOffense;
	kb2_right_offense = KB2RightOffense;
	kb2_defense       = KB2Defense;
	kb2_forward       = KB2Forward;
	kb2_back          = KB2Back;
	kb2_right         = KB2Right;
	kb2_left          = KB2Left;
}
