#include "game.h"

void Game::InitRanking() {
	InitMenu();
}

void Game::ExposeRanking() {
	if (event.IsExpose() && ScreenMode) {
		ScreenReconfig();	
		InitRanking();
		event.Clear();
		wmes("ExposeRanking -> Change Resolution");
	} 
}

void Game::MouseSelectRegion(int &mouse_select, int x, int y) {
	int i;
/* EI@*/
	if (width * 0.40 < x && width * 0.50 > x) {
		if (height* 0.00 < y && height* 0.05 > y) {
			mouse_select = WORLD;			
		}
	}
/* nI */
	if (height* 0.05 < y && height* 0.10 > y) {
		for (i = 0; i < 5; i++) {
			if (width* (i * 0.2) < x &&
				width* ((i+1) * 0.2) > x) {
				mouse_select = ASIA_OCEANIA + i;
			}
		}
	}
/* I(AWAEIZAjA) */
	if (width * 0.0 < x && width * 0.2 > x) {
		for (i = 0; i < 6; i++) {
			if (height* (0.10 + i * 0.035) < y &&
				height* (0.10 + (i+1) * 0.035) > y) {
				mouse_select = i;
			}
		}
	}
/* I(AtJ) */
	if (width * 0.2 < x && width * 0.4 > x) {
		for (i = 0; i < 6; i++) {
			if (height* (0.10 + i * 0.035) < y &&
				height* (0.10 + (i+1) * 0.035) > y) {
				mouse_select = i + SOUTH_AFRICA;
			}
		}
	}
/* I([bp ) */
	if (width * 0.4 < x && width * 0.6 > x) {
		for (i = 0; i < 7; i++) {
			if (height* (0.10 + i * 0.035) < y &&
				height* (0.10 + (i+1) * 0.035) > y) {
				mouse_select = i + UK;
			}
		}
	}
/* I(kAJ) */
	if (width * 0.6 < x && width * 0.8 > x) {
		for (i = 0; i < 7; i++) {
			if (height* (0.10 + i * 0.035) < y &&
				height* (0.10 + (i+1) * 0.035) > y) {
				mouse_select = i + USA_EAST;
			}
		}
	}
/* I(AJ) */
	if (width * 0.8 < x && width * 1.0 > x) {
		for (i = 0; i < 6; i++) {
			if (height* (0.10 + i * 0.035) < y &&
				height* (0.10 + (i+1) * 0.035) > y) {
				mouse_select = i + VENEZUELA;
			}
		}
	}
}

void Game::MouseSelectSort(int &mouse_select, int x, int y) {
	int i;
/* \[gI */
	if (height* 0.35 < y && height* 0.40 > y) {
		if (width* 0.0 < x && width* 0.05 > x) {
			mouse_select = RANK;
		}
		for (i = 0; i < 2; i++) {
			if (width* (0.4 + i * 0.04) < x &&
				width* (0.4 + (i+1) * 0.04) > x) {
				mouse_select = AGE + i;
			}
		}      
		for (i = 0; i < 7; i++) {
			if (width* (0.5 + i * 0.05) < x &&
				width* (0.5 + (i+1) * 0.05) > x) {
				mouse_select = MATCH + i;
			}
		}      
	}
}

void Game::MouseSelectUpDown(int &mouse_select, int x, int y) {
/* \㉺I */
	if (width * 0.95 < x && width * 1.0 > x) {
		if (height* 0.37 < y && height* 0.47 > y) {
			mouse_select = RANKING_UP1;
		}
		if (height* 0.55 < y && height* 0.65 > y) {
			mouse_select = RANKING_UP2;
		}
		if (height* 0.65 < y && height* 0.75 > y) {
			mouse_select = RANKING_DOWN2;
		}
		if (height* 0.87 < y && height* 0.97 > y) {
			mouse_select = RANKING_DOWN1;
		}
	}
}

void Game::MouseSelectBoxer(int &mouse_rank, int x, int y) {
	int i;
/* {NT[I */
	if (width * 0.05 < x && width * 0.4 > x) {
		for (i = 0; i < 16; i++) {
			if (height* (0.40 + i * 0.035) < y &&
				height* (0.40 + (i+1) * 0.035) > y) {
				mouse_rank = i;
			}
		}
	}
}

void Game::ShowRegionInterface(int key_select, int mouse_select, float ssize, char *buf) {
	int i;
	float size, psize;
	
	ttext.SetColor(1.0, 1.0, 1.0);	
	sprintf(buf, "%s", RegionStr(WORLD));
	key_select == WORLD ? size = ssize : size = 1.0;
	ttext.SelectColor(mouse_select == WORLD);
	ttext.Print(buf, 0.25 * size, -10, 98);

	lang != Kana ? psize = 0.18 : psize = 0.15;			
	sprintf(buf, "%-18s", RegionStr(ASIA_OCEANIA));
	key_select == ASIA_OCEANIA ? size = ssize : size = 1.0;
	ttext.SelectColor(mouse_select == ASIA_OCEANIA);
	ttext.Print(buf, psize * size, -95, 88);
	sprintf(buf, "%-18s", RegionStr(AFRICA));
	key_select == AFRICA ? size = ssize : size = 1.0;
	ttext.SelectColor(mouse_select == AFRICA);
	ttext.Print(buf, psize * size, -40, 88);
	sprintf(buf, "%-18s", RegionStr(EUROPE));
	key_select == EUROPE ? size = ssize : size = 1.0;
	ttext.SelectColor(mouse_select == EUROPE);
	ttext.Print(buf, psize * size, 0, 88);
	sprintf(buf, "%-18s", RegionStr(NORTH_AMERICA));
	key_select == NORTH_AMERICA ? size = ssize : size = 1.0;
	ttext.SelectColor(mouse_select == NORTH_AMERICA);
	ttext.Print(buf, psize * size, 50, 88);
	sprintf(buf, "%-18s", RegionStr(SOUTH_AMERICA));
	key_select == SOUTH_AMERICA ? size = ssize : size = 1.0;
	ttext.SelectColor(mouse_select == SOUTH_AMERICA);
	ttext.Print(buf, psize * size, 100, 88);

	for (i = 0; i < 6; i++) {
		sprintf(buf, "%-18s", RegionStr(i));
		key_select == i ? size = ssize : size = 1.0;
		ttext.SelectColor(mouse_select == i);
		ttext.Print(buf, psize*size, -95, 80 - i*7);
	}
	for (i = 0; i < 6; i++) {
		sprintf(buf, "%-18s", RegionStr(SOUTH_AFRICA+i));
		key_select == SOUTH_AFRICA+i ? size = ssize : size = 1.0;
		ttext.SelectColor(mouse_select == SOUTH_AFRICA+i);
		ttext.Print(buf, psize*size, -40, 80 - i*7);
	}
	for (i = 0; i < 7; i++) {
		sprintf(buf, "%-18s", RegionStr(UK+i));
		key_select == UK+i ? size = ssize : size = 1.0;
		ttext.SelectColor(mouse_select == UK+i);
		ttext.Print(buf, psize*size, 0, 80 - i*7);
	}
	for (i = 0; i < 7; i++) {
		sprintf(buf, "%-18s", RegionStr(USA_EAST+i));
		key_select == USA_EAST+i ? size = ssize : size = 1.0;
		ttext.SelectColor(mouse_select == USA_EAST+i);
		ttext.Print(buf, psize*size, 50, 80 - i*7);
	}
	for (i = 0; i < 6; i++) {
		key_select == VENEZUELA+i ? size = ssize : size = 1.0;
		sprintf(buf, "%-18s", RegionStr(VENEZUELA+i));
		ttext.SelectColor(mouse_select == VENEZUELA+i);
		ttext.Print(buf, psize*size, 100, 80 - i*7);
	}
}


void Game::ShowSortInterface(int key_select, int mouse_select, float csize, char *buf) {
	int i;
	float size;

	TableStr(RANK, buf);
	ttext.SelectColor(mouse_select == RANK);
	key_select == RANK ? size = csize: size = 1.0;
	if (lang == Japanese) {
		ttext.Print(buf, 0.20*size, -95, 27);		
	} else {
		ttext.Print(buf, 0.20*size, -98, 27);				
	}
	TableStr(RINGNAME, buf);
	ttext.SetColor(1.0, 1.0, 1.0);	
	ttext.Print(buf, 0.20, -70, 27);		
	for (i = 0; i < 2; i++) {
		TableStr(AGE + i, buf);
		ttext.SelectColor(mouse_select == AGE+i);
		key_select == AGE+i ? size = csize : size = 1.0;
		ttext.Print(buf, 0.20*size, -19 + i * 9, 27);
	}
	for (i = 0; i < 7; i++) {
		TableStr(MATCH + i, buf);
		ttext.SelectColor(mouse_select == MATCH+i);
		key_select == MATCH+i ? size = csize : size = 1.0;
		ttext.Print(buf, 0.20*size, (int)(2 + i * 10.2), 27);
	}
	ttext.SetColor(1.0, 1.0, 1.0);	
	for (i = 0; i < 2; i++) {
		TableStr(COUNTRY + i, buf);
		ttext.Print(buf, 0.20, 76 + i * 10, 27);
	}
}

void Game::ShowUpDownInterface(int mouse_select) {
	if (UsePText) {
		ptext.MessageEnter();
//		ptext.SetSpecular(0.0, 0.0, 0.0);
		ptext.SelectColor(mouse_select == RANKING_UP1);
		ptext.Symbol(SYMBOL_TRIANGLE_UP1, 0.4, 97, 20);
		ptext.SelectColor(mouse_select == RANKING_UP2);
		ptext.Symbol(SYMBOL_TRIANGLE_UP2, 0.4, 97, -28);
		ptext.SelectColor(mouse_select == RANKING_DOWN2);
		ptext.Symbol(SYMBOL_TRIANGLE_DOWN2, 0.4, 97, -42);
		ptext.SelectColor(mouse_select == RANKING_DOWN1);
		ptext.Symbol(SYMBOL_TRIANGLE_DOWN1, 0.4, 97, -90);
		ptext.MessageLeave();
	} else {
		ttext.MessageEnter();
		ttext.SelectColor(mouse_select == RANKING_UP1);
		ttext.Symbol(SYMBOL_TRIANGLE_UP1, 0.4, 97, 20);
		ttext.SelectColor(mouse_select == RANKING_UP2);
		ttext.Symbol(SYMBOL_TRIANGLE_UP2, 0.4, 97, -28);
		ttext.SelectColor(mouse_select == RANKING_DOWN2);
		ttext.Symbol(SYMBOL_TRIANGLE_DOWN2, 0.4, 97, -42);
		ttext.SelectColor(mouse_select == RANKING_DOWN1);
		ttext.Symbol(SYMBOL_TRIANGLE_DOWN1, 0.4, 97, -90);
		ttext.MessageLeave();	
	}
}

int Game::Ranking(StoryHandler &story, int select_mode) {
	static char line[] = "---------------------------------------------------------------------------";
	static char buf[255], name[30], rank[10];
	static int key_select = 0, key_rank = 0;
	static int mouse_select = -1, mouse_rank = -1;
	static int x, y, i, loop, key_pressed, show_info;
	static int boxer_number, column_number = 0, max_column;	
	static float size, csize, ssize;
	 
	InitRanking();
	max_column = story.MaxColumn(MY_BOXER);
	key_select = story.SelectRegion();
	column_number = story.RankingOrder(MY_BOXER) / 16;	
	key_rank	  = story.RankingOrder(MY_BOXER) % 16;

	timer.SetFPS(50);	
	do {
		RankingOptions();
		glClearColor(0.33, 0.33, 0.33, 0.0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		ssize =	(0.9 + 0.1 * sin(RAD(3*loop++)));
		csize =	(1.1 + 0.1 * sin(RAD(5*loop)));

		SDL_GetMouseState(&x, &y);
		mouse_select = -1;

		MouseSelectGoNext(mouse_select, x, y);
		MouseSelectRegion(mouse_select, x, y);
		MouseSelectSort(mouse_select, x, y);
		MouseSelectUpDown(mouse_select, x, y);
		mouse_rank = -1;
		MouseSelectBoxer(mouse_rank, x, y);

/* \[gI(L[{[h) */
		if (event.IsKeyDown(kb2_back)) {
			if (--key_select < JAPAN) {
			 	key_select = KO_RATE;
			}
		}
		if (event.IsKeyDown(kb2_forward)) {
			if (++key_select > KO_RATE) {
			 	key_select = JAPAN;
			}
		}

		key_pressed = 0;		
		if ((mouse_select>=JAPAN && mouse_select<=KO_RATE) && event.IsMouse1Down()) {
			key_pressed = 1;		
			key_select = mouse_select;
		}
		if (event.IsKeyDown(kb2_defense)) {
			key_pressed = 1;		
		}
		if (key_pressed) {
			if (key_select>=JAPAN && key_select<=WORLD) {
				max_column = story.SetRegion(key_select);
				story.SetData(SORT_REGIONRANK);
				story.QuickSort();
			} else if (key_select>=RANK && key_select<=KO_RATE) {
				switch (key_select) {
					case AGE :			
						story.SetData(SORT_AGE);
					break;		
					case CAREER :			
						story.SetData(SORT_CAREER);
					break;		
					case MATCH :			
						story.SetData(SORT_MATCH);
					break;		
					case WIN :			
						story.SetData(SORT_WIN);
					break;		
					case WIN_RATE :			
						story.SetData(SORT_WIN_RATE);
					break;		
					case LOSS :			
						story.SetData(SORT_LOSS);
					break;		
					case DRAW :			
						story.SetData(SORT_DRAW);
					break;		
					case KO :			
						story.SetData(SORT_KO);
					break;		
					case KO_RATE :			
						story.SetData(SORT_KO_RATE);
					break;		
					case RANK :
					default :			
						story.SetData(SORT_REGIONRANK);
					break;		
				}
				story.BubbleSort();
			}
			column_number = story.RankingOrder(MY_BOXER) / 16;	
			key_rank	  = story.RankingOrder(MY_BOXER) % 16;
		}

		if (mouse_select == RANKING_UP1 && event.IsMouse1Down()) {
			column_number = 0;
		}
 		if (mouse_select == RANKING_DOWN1 && event.IsMouse1Down()){
			column_number = max_column;
		}
		if (mouse_select == RANKING_UP2 && event.IsMouse1Down()) {
			if (--column_number < 0) {
				column_number = 0;
            }
		}
 		if (mouse_select == RANKING_DOWN2 && event.IsMouse1Down()) {
			if (++column_number > max_column) {
				column_number = max_column;
			}
		}

 		if (event.IsKeyDown(kb2_left)) {
			if (event.IsKeyPressed(kb2_right_offense)) {
				if (--column_number < 0) {
					column_number = 0;
 	        	}			
			} else {
				if (--key_rank < 0) {
					if (--column_number < 0) {
						column_number = 0;
					 	key_rank = 0;
					} else {
					 	key_rank = 15;			
					}	 
				}
			}
		}
		if (event.IsKeyDown(kb2_right)) {
			if (event.IsKeyPressed(kb2_right_offense)) {
				if (++column_number > max_column) {
					column_number = max_column;
				}
			} else {
				if (++key_rank > 15) {
					if (++column_number > max_column) {
						column_number = max_column;
					 	key_rank = 15;
					} else {
					 	key_rank = 0;			
					} 
				}
			}
		}

		show_info = 0;
		if (mouse_rank >= 0 && mouse_rank <= 15 && event.IsMouse1Down()) {
			key_rank = mouse_rank;
		    show_info = 1;
		}
		if (event.IsKeyDown(kb2_left_offense)) {
		    show_info = 1;
		}
		if (show_info) {
			boxer_number = column_number * 16 + key_rank;
			if (boxer_number < MAX_BOXER &&
				story.SortBoxer(boxer_number).IsInRegion()) {
	//			CustomizeBoxer(story);
				ShowBoxerProfile(story, story.Sort(boxer_number));
			}
		}

		ShowUpDownInterface(mouse_select);

		ttext.MessageEnter();
		ShowRegionInterface(key_select, mouse_select, ssize, buf);
		ShowSortInterface(key_select, mouse_select, csize, buf);

        ttext.Print(line, 0.20, -90, 22);
		for (i = 0; i < 16; i++) {
			boxer_number = column_number * 16 + i;
			if (boxer_number < MAX_BOXER) {
				StoryBoxer &sb = story.SortBoxer(boxer_number);
				if (sb.IsInRegion()) {
					handler1.SetBoxerName(sb);
					if (sb.RegionRank()== 0) {
						sprintf(rank, "C%3d", story.TitleDefending(story.SelectRegion()));	
					} else {
					 	sprintf(rank, "%4d", sb.RegionRank());
					}
					sprintf(buf, "%4s                           %2d %2d  %3d %3d %3d %3d %3d %3d %3d  %3s %3s",
						rank, sb.Age(), sb.CareerYear(),
						sb.Match(), sb.Win(), sb.WinRate(),
						sb.Loss(), sb.Draw(), sb.KO(), sb.KORate(),
						NationSign(sb.Nation()), StateStr(sb.State())
					);
					ttext.SetColor(1.0, 1.0, 1.0);	
					ttext.Print(buf, 0.20, -80, 17 - i * 7);		

					BoxerNameStr(handler1, name);
					sprintf(buf, "%-26s", name);
					ttext.SelectColor(mouse_rank == i);
					key_rank == i ? size = ssize : size = 1.0;
					ttext.Print(buf, 0.20*size, -80, 17 - i * 7);		

				} else {
					if (key_rank >= i) {
					 	key_rank = i - 1;
					}				
				}
			}
		}
		ttext.SetColor(1.0, 1.0, 1.0);	
        ttext.Print(line, 0.20, -90, -94);		

		ttext.SelectColor(mouse_select == GO_NEXT);
		if (select_mode) {
	   		ttext.Print("Next", 0.25, -100, -100);
		} else { 
	   		ttext.Print("Back", 0.25, -100, -100);
		}
		ttext.SetColor(1.0, 1.0, 1.0);	
 		ttext.Print(timer.FPSString(), 0.25, 100, -100);
		ttext.MessageLeave();				

		SDL_GL_SwapBuffers(); 
		GLmes();

		timer.Wait();
		event.Poll();
		if (event.IsKeyDown(go_next) || event.IsMouse3Down() || 
			(mouse_select == GO_NEXT && event.IsMouse1Down())) {
			break;		
		}
		ExposeRanking();
	} while(!event.IsQuit());
	if (event.IsQuit()) {
		Quit();
	}
 
 	glViewport(0, 0, width, height);
 	glClearColor(0.0, 0.0, 0.0, 0.0);
//	ttext.Clear();	 	
	
	boxer_number = story.Sort(column_number * 16 + key_rank);
	story.SortRegion(WORLD);
	return boxer_number;
}

void Game::MouseSelectTournament(int &mouse_select, int x, int y) {
/* g[igI */
	if (height* 0.35 < y && height* 0.40 > y) {
		if (width* 0.20 < x && width* 0.40 > x) {
			mouse_select = ROOKIE;
		}
		if (width* 0.60 < x && width* 0.80 > x) {
			mouse_select = RANKER;
		}
	}
}

void Game::ShowTournamentInterface(int key_select, int mouse_select, int t_select, float csize, char *buf) {
	float size;

	ttext.SelectColor(mouse_select == ROOKIE);
	key_select == ROOKIE ? size = csize: size = 1.0;
	ttext.Print(RookieStr(), 0.20*size, -50, 27);				
	if (t_select == ROOKIE) {
		ttext.SetColor(1.0, 1.0, 1.0);
		ttext.Print(">", 0.20, -60, 27);
	}

	ttext.SelectColor(mouse_select == RANKER);
	key_select == RANKER ? size = csize: size = 1.0;
	ttext.Print(RankerStr(), 0.20*size, 50, 27);
	if (t_select == RANKER) {
		ttext.SetColor(1.0, 1.0, 1.0);
		ttext.Print(">", 0.20, 32, 27);
	}
}

void Game::Tournament(StoryHandler &story) {
	static char line[] = "---------------------------------------------------------------------------";
	static char buf[255], name[30], rank[10];
	static int t_select = 0;
	static int key_select = 0, key_boxer = 0;
	static int mouse_select = -1, mouse_boxer = -1;
	static int x, y, i, j, loop, key_pressed, show_info;
	static int column_number = 0, max_column;	
	static int boxer_number, max_boxer, region;	
	static float size, ssize;
	 
	InitRanking();
	t_select = story.Boxer(MY_BOXER).WhichTournament();
	column_number = story.TournamentBlock(MY_BOXER) / 16;
	key_boxer	  = story.TournamentBlock(MY_BOXER) % 16;
	region = story.SelectRegion();
	story.SortRegion(region);
	max_boxer = story.MaxTournament(region, t_select);
	max_column = max_boxer / 16;
	key_select = region;

	timer.SetFPS(50);	
	do {
		RankingOptions();
		glClearColor(0.33, 0.33, 0.33, 0.0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		ssize =	(0.9 + 0.1 * sin(RAD(3*loop++)));

		SDL_GetMouseState(&x, &y);
		mouse_select = -1;
		MouseSelectGoNext(mouse_select, x, y);
		MouseSelectRegion(mouse_select, x, y);
		MouseSelectUpDown(mouse_select, x, y);
		MouseSelectTournament(mouse_select, x, y);
		mouse_boxer = -1;
		MouseSelectBoxer(mouse_boxer, x, y);

/* \[gI(L[{[h) */
		if (event.IsKeyDown(kb2_back)) {
			if (--key_select < JAPAN) {
			 	key_select = RANKER;
			}
		}
		if (event.IsKeyDown(kb2_forward)) {
			if (++key_select > RANKER) {
			 	key_select = JAPAN;
			}
		}

		if (mouse_select == RANKING_UP1 && event.IsMouse1Down()) {
			column_number = 0;
		}
 		if (mouse_select == RANKING_DOWN1 && event.IsMouse1Down()){
			column_number = max_column;
		}
		if (mouse_select == RANKING_UP2 && event.IsMouse1Down()) {
			if (--column_number < 0) {
				column_number = 0;
            }
		}
 		if (mouse_select == RANKING_DOWN2 && event.IsMouse1Down()) {
			if (++column_number > max_column) {
				column_number = max_column;
			}
		}

 		if (event.IsKeyDown(kb2_left)) {
			if (event.IsKeyPressed(kb2_right_offense)) {
				if (--column_number < 0) {
					column_number = 0;
 	        	}			
			} else {
				if (--key_boxer < 0) {
					if (--column_number < 0) {
						column_number = 0;
					 	key_boxer = 0;
					} else {
					 	key_boxer = 15;			
					}	 
				}
			}
			while(!story.IsInTournament(region, t_select, column_number * 16 + key_boxer)) {
				if (--key_boxer < 0) {
					for (i = 0; i< 16; i++) {
						if (story.IsInTournament(region, t_select, column_number * 16 + i)){
							key_boxer = i;
							break;
						}
					}
					break;
				}    
			}		
		}
		if (event.IsKeyDown(kb2_right)) {
			if (event.IsKeyPressed(kb2_right_offense)) {
				if (++column_number > max_column) {
					column_number = max_column;
				}
			} else {
				if (++key_boxer > 15) {
					if (++column_number > max_column) {
						column_number = max_column;
					 	key_boxer = 15;
					} else {
					 	key_boxer = 0;			
					} 
				}
			}
			while(story.TournamentBoxer(region, t_select, column_number * 16 + key_boxer) == NO_BOXER) {
				if (++key_boxer > 15) {
					for (i = 15; i >= 0; i--) {
						if (story.TournamentBoxer(region, t_select, column_number * 16 + i) != NO_BOXER){
							key_boxer = i;
							break;
						}				
					}
					break;    
				}
			}		
		}
		
		key_pressed = 0;		
		if ((mouse_select>=JAPAN && mouse_select<=RANKER) && event.IsMouse1Down()) {
			key_pressed = 1;		
			key_select = mouse_select;
		}
		if (event.IsKeyDown(kb2_defense)) {
			key_pressed = 1;		
		}
		if (key_pressed) {
			if (key_select>=JAPAN && key_select<=WORLD) {
				region = key_select;
				story.SortRegion(region);
				if (key_select>=ASIA_OCEANIA && key_select<=WORLD) {
					t_select = RANKER;			
				}
			} else {
				t_select = key_select;
			}
			max_boxer = story.MaxTournament(region, t_select);
			max_column = max_boxer / 16;
			column_number = 0;
		}

		show_info = 0;
		if (mouse_boxer >= 0 && mouse_boxer <= 15 && event.IsMouse1Down()) {
			key_boxer = mouse_boxer;
		    show_info = 1;
		}
		if (event.IsKeyDown(kb2_left_offense)) {
		    show_info = 1;
		}
		if (show_info) {
			boxer_number = story.TournamentBoxer(region, t_select, column_number * 16 + key_boxer);
			if (boxer_number < MAX_BOXER && boxer_number != NO_BOXER) {
				ShowBoxerProfile(story, boxer_number);
			} else {
				for (i = 0; i< 16; i++) {
					if (story.IsInTournament(region, t_select, column_number * 16 + i)){
						key_boxer = i;
						break;
					}
				}
			}
		}

		ShowUpDownInterface(mouse_select);

		ttext.MessageEnter();
		ShowRegionInterface(key_select, mouse_select, ssize, buf);
		ShowTournamentInterface(key_select, mouse_select, t_select, ssize, buf);

		ttext.SetColor(1.0, 1.0, 1.0);	
        ttext.Print(line, 0.20, -90, 22);
		for (i = 0; i < 16; i++) {
			boxer_number = story.TournamentBoxer(region, t_select, column_number * 16 + i);
			if (boxer_number != NO_BOXER) {
				StoryBoxer &sb = story.Boxer(boxer_number);
				handler1.SetBoxerName(sb);
				if (sb.RegionRank() == 0) {
					sprintf(rank, "C%3d", story.TitleDefending(story.SelectRegion()));	
				} else {
					sprintf(rank, "%4d", sb.RegionRank());
				}
				switch (lang) {
					case Kana :
					case English :
						sprintf(buf, "%4s. ", rank);										
					break;				
					default :
						sprintf(buf, "%4s", rank);					
					break;								
				}
				ttext.SetColor(1.0, 1.0, 1.0);	
				ttext.Print(buf, 0.20, -10, 17 - i * 7);		

				BoxerNameStr(handler1, name);
				sprintf(buf, "%-25s", name);
				ttext.SelectColor(mouse_boxer == i);
				key_boxer == i ? size = ssize : size = 1.0;
				ttext.Print(buf, 0.20*size, -80, 17 - i * 7);
			}
		}
		ttext.SetColor(1.0, 1.0, 1.0);	
        ttext.Print(line, 0.20, -90, -94);		

		glDisable(GL_BLEND);
		glDisable(GL_TEXTURE_2D);
		glLineWidth(width/320.0);
//		glColor3f(1.0, 1.0, 1.0);
		glBegin(GL_LINES);
		for (i = 0; i < 16; i++) {
			if (story.IsInTournament(region, t_select, column_number * 16 + i)) {
			 	glVertex2f(0.10, 0.48 - (float)i * 0.202);
				glVertex2f(0.50, 0.48 - (float)i * 0.202);	
				glVertex2f(0.50, 0.48 - (float)i * 0.202);	
				if (i % 2) {
					glVertex2f(0.50, 0.48 - (float)i * 0.202 + 0.101);				
				} else {
					glVertex2f(0.50, 0.48 - (float)i * 0.202 - 0.101);	
				}
			}
		}

		for (i = 0; i < 8; i++) {
			for (j = 0; j < 2; j++) {
				if (story.IsInTournament(region, t_select, column_number * 16 + i*2 + j)) {
				 	glVertex2f(0.50, 0.379 - (float)i * 0.404);
					glVertex2f(0.90, 0.379 - (float)i * 0.404);	
					glVertex2f(0.90, 0.379 - (float)i * 0.404);	
					if (i % 2) {
						glVertex2f(0.90, 0.379 - (float)i * 0.404 + 0.202);				
					} else {
						glVertex2f(0.90, 0.379 - (float)i * 0.404 - 0.202);	
					}
					break;
				}
			}
		}

		for (i = 0; i < 4; i++) {
			for (j = 0; j < 4; j++) {
			if (story.IsInTournament(region, t_select, column_number * 16 + i*4 + j)) {
				 	glVertex2f(0.90, 0.177 - (float)i * 0.808);
					glVertex2f(1.40, 0.177 - (float)i * 0.808);	
					glVertex2f(1.40, 0.177 - (float)i * 0.808);	
					if (i % 2) {
						glVertex2f(1.40, 0.177 - (float)i * 0.808 + 0.404);				
					} else {
						glVertex2f(1.40, 0.177 - (float)i * 0.808 - 0.404);	
					}
					break;
				}
			}		
		}

		for (i = 0; i < 2; i++) {
			for (j = 0; j < 8; j++) {
				if (story.IsInTournament(region, t_select, column_number * 16 + i*8 + j)) {
				 	glVertex2f(1.40, -0.227 - (float)i * 1.616);
					glVertex2f(1.90, -0.227 - (float)i * 1.616);	
					glVertex2f(1.90, -0.227 - (float)i * 1.616);	
					if (i % 2) {
						glVertex2f(1.90, -0.227 - (float)i * 1.616 + 0.808);				
					} else {
						glVertex2f(1.90, -0.227 - (float)i * 1.616 - 0.808);	
					}
					break;
				}		
			}
		}
		for (j = 0; j < 16; j++) {
			if (story.IsInTournament(region, t_select, column_number * 16 + j)) {
				glVertex2f(1.90, -0.227 - 0.808);
				glVertex2f(2.40, -0.227 - 0.808);	
            	break;
 			}
		}

		glEnd();
		glEnable(GL_TEXTURE_2D);
		glEnable(GL_BLEND); 

		ttext.SelectColor(mouse_select == GO_NEXT);
   		ttext.Print("Back", 0.25, -100, -100);
		ttext.SetColor(1.0, 1.0, 1.0);	
 		ttext.Print(timer.FPSString(), 0.25, 100, -100);
		ttext.MessageLeave();				

		SDL_GL_SwapBuffers(); 
		GLmes();

		timer.Wait();
		event.Poll();
		if (event.IsKeyDown(go_next) || event.IsMouse3Down() || 
			(mouse_select == GO_NEXT && event.IsMouse1Down())) {
			break;		
		}
		ExposeRanking();
	} while(!event.IsQuit());
	if (event.IsQuit()) {
		Quit();
	}
 
 	glViewport(0, 0, width, height);
 	glClearColor(0.0, 0.0, 0.0, 0.0);
//	ttext.Clear();	 	

	story.SortRegion(WORLD);
}

void Game::MouseSelectMatch(int &mouse_match, int x, int y) {
	int i;
/* I */
	if (width * 0.05 < x && width * 0.95 > x) {
		for (i = 0; i < 16; i++) {
			if (height* (0.40 + i * 0.035) < y &&
				height* (0.40 + (i+1) * 0.035) > y) {
				mouse_match = i;
			}
		}
	}
}

void Game::StoryMatches(StoryHandler &story, int result_mode) {
	static char line[] = "---------------------------------------------------------------------------";
	static char buf[255], name1[30], name2[30], number[10];
	static int key_select = 0, key_match = 0;
	static int mouse_select = -1, mouse_match = -1;
	static int x, y, i, loop, key_pressed, show_info;
	static int column_number = 0, max_column;	
	static int match_number, boxer1_number, boxer2_number;
	static float size, csize, ssize;
	StoryMatch *select_match;
	 
	InitRanking();
	story.MaxColumn(MY_BOXER);
	key_select = story.SelectRegion();
	if (result_mode) {
		max_column = (story.RegionResult(key_select) - 1) / 16;		
		key_match  = story.WhichResult(MY_BOXER);
	} else {
		max_column = (story.RegionMatch(key_select) - 1) / 16;	
		key_match  = story.WhichMatch(MY_BOXER);
    }
 	column_number = key_match / 16;
	key_match	  = key_match % 16;

	timer.SetFPS(50);	
	do {
		RankingOptions();
		glClearColor(0.33, 0.33, 0.33, 0.0);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		ssize =	(0.9 + 0.1 * sin(RAD(3*loop++)));
		csize =	(1.1 + 0.1 * sin(RAD(5*loop)));

		SDL_GetMouseState(&x, &y);
		mouse_select = -1;
		MouseSelectGoNext(mouse_select, x, y);
		MouseSelectRegion(mouse_select, x, y);
		MouseSelectUpDown(mouse_select, x, y);
		mouse_match = -1;
		MouseSelectMatch(mouse_match, x, y);

/* \[gI(L[{[h) */
		if (event.IsKeyDown(kb2_back)) {
			if (--key_select < JAPAN) {
			 	key_select = RANKER;
			}
		}
		if (event.IsKeyDown(kb2_forward)) {
			if (++key_select > RANKER) {
			 	key_select = JAPAN;
			}
		}

		if (mouse_select == RANKING_UP1 && event.IsMouse1Down()) {
			column_number = 0;
		}
 		if (mouse_select == RANKING_DOWN1 && event.IsMouse1Down()){
			column_number = max_column;
		}
		if (mouse_select == RANKING_UP2 && event.IsMouse1Down()) {
			if (--column_number < 0) {
				column_number = 0;
            }
		}
 		if (mouse_select == RANKING_DOWN2 && event.IsMouse1Down()) {
			if (++column_number > max_column) {
				column_number = max_column;
			}
		}

 		if (event.IsKeyDown(kb2_left)) {
			if (event.IsKeyPressed(kb2_right_offense)) {
				if (--column_number < 0) {
					column_number = 0;
 	        	}			
			} else {
				if (--key_match < 0) {
					if (--column_number < 0) {
						column_number = 0;
					 	key_match = 0;
					} else {
					 	key_match = 15;			
					}	 
				}
			}
		}
		if (event.IsKeyDown(kb2_right)) {
			if (event.IsKeyPressed(kb2_right_offense)) {
				if (++column_number > max_column) {
					column_number = max_column;
				}
			} else {
				if (++key_match > 15) {
					if (++column_number > max_column) {
						column_number = max_column;
					 	key_match = 15;
					} else {
					 	key_match = 0;			
					} 
				}
			}
		}
		
		key_pressed = 0;		
		if ((mouse_select>=JAPAN && mouse_select<=RANKER) && event.IsMouse1Down()) {
			key_pressed = 1;		
			key_select = mouse_select;
		}
		if (event.IsKeyDown(kb2_defense)) {
			key_pressed = 1;		
		}
		if (key_pressed) {
			if (key_select>=JAPAN && key_select<=WORLD) {
				story.SortRegion(key_select);
				if (result_mode) {
					max_column = (story.RegionResult(key_select) - 1) / 16;	
					key_match  = story.WhichResult(MY_BOXER);
            	} else {
					max_column = (story.RegionMatch(key_select) - 1) / 16;					
					key_match  = story.WhichMatch(MY_BOXER);
				}
			 	column_number = key_match / 16;
				key_match	  = key_match % 16;
			}
		}

		show_info = 0;
		if (mouse_match >= 0 && mouse_match <= 15 && event.IsMouse1Down()) {
			key_match = mouse_match;
		    show_info = 1;
		}
		if (event.IsKeyDown(kb2_left_offense)) {
		    show_info = 1;
		}
		if (show_info) {
			match_number = column_number * 16 + key_match;
			if (story.MatchExists(match_number)) {
				if (result_mode) {
					select_match = story.SelectResult(match_number);			
				} else {
					select_match = story.SelectMatch(match_number);			
				}
				boxer1_number = select_match->low_ranked;
				boxer2_number = select_match->high_ranked;
				
				SelectMatchType(select_match->match_type, story.Boxer(boxer1_number));
				match.SetResultState(select_match->result);
				story.SortRegion(match.MatchRegion());
				if ((boxer1_number == MY_BOXER || boxer2_number == MY_BOXER) &&
					select_match->result == NO_RESULT) {
					MyMatch(story, match_number);					
				} else if (ShowMatchProfile(story, boxer1_number, boxer2_number, 1)) {
					if (select_match->result == NO_RESULT) { 			
						if (Match(SELECT_STORY_COM)) {
							match.WhichWin(handler1, handler2);
							select_match->result = match.ResultState();		
							story.MatchRecord(select_match);
							SaveReplayCycle();
							select_match->replay = CurrentReplay;		
							if (!SkipReplay) {
								Replay();
							}
						}
					} else if (select_match->replay) {
						sprintf(buf, "./Replay/cycle%03d.rep", select_match->replay);
						if (LoadReplayFile(buf, 1) == SDL_SUCCESS) {
							Replay();
						}
					}
				}
				story.SortRegion(key_select);
			} else {
				for (i = 0; i< 16; i++) {
					if (story.MatchExists(column_number * 16 + i)) {
						key_match = i;
						break;
					}
				}			
			}
		}

		ShowUpDownInterface(mouse_select);

		ttext.MessageEnter();
		ShowRegionInterface(key_select, mouse_select, ssize, buf);

		ttext.SetColor(1.0, 1.0, 1.0);	
        ttext.Print(line, 0.20, -90, 22);
		for (i = 0; i < 16; i++) {
			match_number = column_number * 16 + i;
			if (story.MatchExists(match_number)) {
				sprintf(number, "%4d.", match_number+1);
				ttext.SelectColor(mouse_match == i);
				key_match == i ? size = csize : size = 1.0;
		        ttext.Print(number, 0.20*size, -95, 17 - i * 7);		
		        ttext.Print("vs", 0.20*size, 0, 17 - i * 7);		

				if (result_mode) {
					select_match = story.SelectResult(match_number);			
				} else {
					select_match = story.SelectMatch(match_number);			
				}
				StoryBoxer &sb1 = story.Boxer(select_match->low_ranked);
				StoryBoxer &sb2 = story.Boxer(select_match->high_ranked);

				handler1.SetBoxerName(sb1);
				handler2.SetBoxerName(sb2);
				BoxerNameStr(handler1, name1);
				BoxerNameStr(handler2, name2);

				sprintf(buf, "%25s    %-25s", name2, name1);										
				ttext.SetColor(1.0, 1.0, 1.0);	
				ttext.Print(buf, 0.20, 0, 17 - i * 7);
				if (select_match->result != NO_RESULT) {
					if (lang == Japanese) {
						ttext.Print(ResultMarkJp(sb2.GetRecent(0)), 0.20, -75, 17 - i * 7);
						ttext.Print(ResultMarkJp(sb1.GetRecent(0)), 0.20, 75, 17 - i * 7);				
					} else {
						ttext.Symbol(ResultMark(sb1.GetRecent(0)), 0.25, -75, 17 - i * 7);
						ttext.Symbol(ResultMark(sb2.GetRecent(0)), 0.25, 75, 17 - i * 7);									
					}
				}
			} else {
				break;			
			}
		}
		ttext.SetColor(1.0, 1.0, 1.0);	
        ttext.Print(line, 0.20, -90, -94);		

		ttext.SelectColor(mouse_select == GO_NEXT);
   		ttext.Print("Back", 0.25, -100, -100);
		ttext.SetColor(1.0, 1.0, 1.0);	
 		ttext.Print(timer.FPSString(), 0.25, 100, -100);
		ttext.MessageLeave();				

		SDL_GL_SwapBuffers(); 
		GLmes();

		timer.Wait();
		event.Poll();
		if (event.IsKeyDown(go_next) || event.IsMouse3Down() ||
			(mouse_select == GO_NEXT && event.IsMouse1Down())) {
			break;		
		}
		ExposeRanking();
	} while(!event.IsQuit());
	if (event.IsQuit()) {
		Quit();
	}
 
 	glViewport(0, 0, width, height);
 	glClearColor(0.0, 0.0, 0.0, 0.0);
//	ttext.Clear();	 	

	story.SortRegion(WORLD);
}

char* Game::RegionStr(int i) {
	static char *region_kanji[] = {
		"{",
		"؍",
		"^C",
		"tBs",
		"I[XgA",
		"AWA",
		"AtJ",
		"iCWFA",
		"Pj",
		"K[i",
		"J[",
		"AtJ",
		"CMX",
		"tX",
		"hCc",
		"VA",
		"C^A",
		"XyC",
		"[bp",
		"AJ",
		"AJ",
		"Ji_",
		"LVR",
		"pi}",
		"L[o",
		"kAJ",
		"xlYG",
		"RsA",
		"uW",
		"A[`",
		"GNAh",
		"AJ",
		"AWAEIZAjA",
		"AtJ",
		"[bp",
		"kAJ",
		"AJ",
		"E"
	};
	static char *region_kana[] = {
		"ɂق",
		"񂱂",
		"^C",
		"tBs",
		"I[XgA",
		"AWA傱",
		"݂Ȃ݃AtJ",
		"iCWFA",
		"Pj",
		"K[i",
		"J[",
		"AtJ傱",
		"CMX",
		"tX",
		"hCc",
		"VA",
		"C^A",
		"XyC",
		"[bp傱",
		"AJЂ",
		"AJɂ",
		"Ji_",
		"LVR",
		"pi}",
		"L[o",
		"قׂ傱",
		"xlYG",
		"RsA",
		"uW",
		"A[`",
		"GNAh",
		"Ȃׂ傱",
		"AWA/IZAjA",
		"AtJ",
		"[bp",
		"AJ",
		"݂Ȃ݃AJ",
		""
	};
	static char *region_english[] = {
		"Japan",
		"Korea",
		"Thailand",
		"Philippines",
		"Australia",
		"Asian Cos.",
		"South Africa",
		"Nigeria",
		"Kenya",
		"Ghana",
		"Cameroon",
		"African Cos.",
		"United Kingdom",
		"France",
		"Germany",
		"Rossia",
		"Italia",
		"Spain",
		"European Cos.",
		"USA East",
		"USA West",
		"Canada",
		"Mexico",
		"Panama",
		"Cuba",
		"NA Cos.",
		"Venezuela",
		"Colombia",
		"Brazil",
		"Argentina",
		"Ecuador",
		"SA Cos.",
		"Asia/Oceania",
		"Africa",
		"Europe",
		"North America",
		"South America",
		"World"
	};
	switch (lang) {
		case Kana:
			return region_kana[i];
		break;	
		case English:
			return region_english[i];
		break;	
		default:
			return region_kanji[i];
		break;
	}
}

char* Game::RankerStr() {
	static char ranker_jp[] = "J[";
	static char ranker_en[] = "Rankers'";
	switch (lang) {
		case English:
			return ranker_en;
		break;		
		case Kana:
		default:	
			return ranker_jp;
		break;			
	}
}

char* Game::RookieStr() {
	static char rookie_king_kanji[] = "Vl";
	static char rookie_king_kana[] = "񂶂񂨂";
	static char rookie_king_english[] = "Rookie King";
	switch (lang) {
		case Kana:
			return rookie_king_kana;
		break;		
		case English:
			return rookie_king_english;
		break;		
		default:	
			return rookie_king_kanji;
		break;			
	}
}
 
void Game::TableStr(int i, char* buf) {
	static char *table_jp[] = {
		"", "", "L",
		"", "", "", "", "", "KO", "",
		"", "",
		"Ol[",
	};
	static char *table_en[] = {
		"Rank", "Ag", "C",
		"T", "W", "Av", "L", "D", "KO", "Av",
		"N", "S",
		"Ring Name",
	};
	switch (lang) {
		case Kana:
		case English:
			strcpy(buf, table_en[i-RANK]);
		break;	
		default:
			strcpy(buf, table_jp[i-RANK]);
		break;
	}
}

char* Game::NationSign(int i) {
	static char *nation_en[] = {
		"JPN", "KRE", "THI", "PHI", "AUS", "ASC",
		"SAF", "NIG", "KNY", "GHA", "CMR", "AFC",
		"UK", "FRN", "GER", "ROS", "ITA", "SPA", "EUC",
		"USE", "USW", "CAN", "MEX", "PAN", "CUB", "NAC",
		"VEN", "COL", "BRA", "ARG", "ECU", "SAC"
	}; 
	static char *nation_jp[] = {
		"", "", "", "", "", "C",
		"A", "i", "P", "K", "J", "AC",
		"p", "", "", "I", "", "", "C",
		"E", "W", "", "", "p", "L", "kC",
		"", "R", "u", "A", "G", "C"
	};
	switch (lang) {
		case Kana:
		case English:
			return nation_en[i];
		break;	
		default:
			return nation_jp[i];
		break;
	}
}

char* Game::StateStr(int i) {
	static char *state_jp[] = {
		"", "^", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "10", "11", "g", "V", "x", "f", "l", "Z", "", "\x8f\\", ""  
	};
	static char *state_en[] = {
		"Wa", "TM", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "RT", "RK", "R", "DM", "4R", "6R", "8R", "10R", "Re" 
	};
	if (i == NO_MATCHING) {
 		i = 0;
	} else if (i >= RANKER_T0 && i <= RANKER_T15) {
		i = 13;	
	} else if (i >= ROOKIE_T0 && i <= ROOKIE_T63) {
		i = 14;	
	} else if (i >= REST_MONTH0 && i <= REST_MONTH6) {
		i = 15;	
	} else if (i == DEBUT) {
		i = 16;	
	} else if (i == ROUND4) {
		i = 17;	
	} else if (i == ROUND6) {
		i = 18;	
	} else if (i == ROUND8) {
		i = 19;	
	} else if (i == ROUND10) {
		i = 20;	
	} else if (i == RETIRE_STATE) {
		i = 21;	
	}
	switch (lang) {
		case Kana:
		case English:
			return state_en[i];
		break;	
		default:
			return state_jp[i];
		break;
	}
}

/*
int Game::ResultRed(int result) {
	switch(result) {
		case RED_WON_KO :
		case RED_WON_TKO :
			return 1;		
		break;
		case RED_WON_JUDGE :
			return 2;		
		break;
    	case JUDGE_DRAW :
	  	case JUDGE_DRAW_RED :
  		case JUDGE_DRAW_BLUE :
			return 3;
		break;
    	case DKO_DRAW :
	  	case DKO_DRAW_RED :
  		case DKO_DRAW_BLUE :
			return 4;
		break;
		case BLUE_WON_JUDGE :
			return 5;
		break;
		case BLUE_WON_TKO :
		case BLUE_WON_KO :
			return 6;		
		break;
		default :
			return 0;
		break;
	}
}

int Game::ResultBlue(int result) {
	switch(result) {
		case BLUE_WON_KO :
		case BLUE_WON_TKO :
			return 1;		
		break;
		case BLUE_WON_JUDGE :
			return 2;		
		break;
    	case JUDGE_DRAW :
	  	case JUDGE_DRAW_RED :
  		case JUDGE_DRAW_BLUE :
			return 3;
		break;
    	case DKO_DRAW :
	  	case DKO_DRAW_RED :
  		case DKO_DRAW_BLUE :
			return 4;
		break;
		case RED_WON_JUDGE :
			return 5;
		break;
		case RED_WON_TKO :
		case RED_WON_KO :
			return 6;		
		break;
		default :
			return 0;
		break;
	}
}
  */

