#include "game.h"

void Game::Training() {
	mixer.PlayMusic(BGM_TRAINING);

	handler1.Init(boxer1, motion1, match);
	handler2.Init(boxer2, motion2, match);	
    handler1.SetMode(FULL_AUTO);
    handler2.SetMode(Player1Mode);

	float damage;
	static int show1_pre;
	show1_pre = show1;
	show1 = 1;

	SetCamera();
	SetLights();
	SetDefaultView();	
	SetBoxerPosition(1.0);
	NextOff();

	timer.SetFPS(50);	
	do {
    	MatchOptions();

	 	if (event.IsKeyDown(SDLK_1)) {
			handler2.NextMode();
		}
			
		switch (handler2.WhichMode()) {
			case SEMI_AUTO:
				handler2.GetComStates(match, boxer2, handler1);
				handler2.DeleteOffenseKey();
				GetOffenseKeyStates(handler2);
				GetMouseStates(handler2);    
			break;		
			case FULL_AUTO:
				handler2.GetComStates(match, boxer2, handler1);
			break;
			default:
				GetKeyStates(handler2);
				GetMouseStates(handler2);
			break;
		}

 		handler2.SetDistance(boxer2.CalcDistance(boxer1));
		handler2.BoxerHandling(boxer2, motion2);
		if (handler2.IsSound()) {
			mixer.PlayChunk(handler2.SelectSound());	
		}

		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		light.Set();
		SelectView();
		light2.Set();

		boxer1.CalcCoords();
		boxer1.CalcCenter();
		boxer2.CalcCoords();
		boxer2.CalcCenter();

//		sandbag.ShowShadow();
		if (ShadowSwitch) {
			ShowShadow(boxer2);
        }
		if (BackGroundSwitch) {
			glbg.Show();
		}
		glring.Show(cxp, cyp, czp);
		glsandbag.Move();
		glsandbag.Show();
		
		texs.Choice(TE_FACE);

		handler2.SetNoDamage();
		if (handler2.IsRightOffenseState()) {
			damage = boxer2.CalcDamageRight();
			if (glsandbag.IsHit(boxer2.right_arm.fist.X(), 
				boxer2.right_arm.fist.Y(),	
				boxer2.right_arm.fist.Z(),
				boxer2.right_arm.fist.R())) {
				if (damage > 1.0 && motion2.IsActionOverFirst()) {
					handler2.SetSmallDamage();
					glsandbag.ShowHit();
					glsandbag.Hit(boxer2.right_arm.fist.X(), boxer2.right_arm.fist.Y(), damage);					
					mixer.PlayChunk(SE_HIT_FACE);
					handler2.SetStatePull();
				}
			}															
		}

		if (handler2.IsLeftOffenseState()) {
			damage = boxer2.CalcDamageLeft();
			if (glsandbag.IsHit(boxer2.left_arm.fist.X(), 
				boxer2.left_arm.fist.Y(),	
				boxer2.left_arm.fist.Z(),
				boxer2.left_arm.fist.R())) {
				if (damage > 1.0 && motion2.IsActionOverFirst()) {
					handler2.SetSmallDamage();
					glsandbag.ShowHit();
					glsandbag.Hit(boxer2.left_arm.fist.X(), boxer2.left_arm.fist.Y(), damage);					
					mixer.PlayChunk(SE_HIT_BODY);
					handler2.SetStatePull();
				}															
			}
		}

		if (show2)  {
			boxer2.CallHitRanges(boxer1);
		} else {
			boxer2.CallLists(IsBoxerView1());
		}

	//	boxer2.CalcDamageRight();

		float ot = boxer1.OT();
		boxer1.SetPoint(-0.5, 0.5, ot);
		boxer1.SetPos(0.0, 0.0, boxer1.LegHeight());

		handler2.Move(boxer2);

//		ShowMeters();
		CalcAdjust();
		if (handler1.IsCounting() && !handler2.IsCounting()) {
			boxer2.GoNeutralCorner(boxer1);
		} else {
			boxer2.SetPoint(nox2, noy2, not2);		
		}
	
	//	sprintf(timestr,"Time %05.2f/%05.2f Sec",(float) j++ /50.0, (timer.GetTicks() - st)/1000.0);
		
//		sprintf(timestr,"Round %02d  %2d:%02d:%2d", 1,  j++ /(3000), j / 50, j);
//		sprintf(fpsstr,"Now %d FPS", timer.GetFPS());
		
		ttext.MessageEnter();
		ttext.Print(match.TimeString(), 0.4, 25, 100);
  		ttext.Print(timer.FPSString(), 0.25, 100, -100);
		ShowNext();
 /*
		char buf[255];
		sprintf(buf,"stamina = %f swing speed %f", handler2.stamina, 1.0/handler2.swing_speed);
		ttext.Print(buf, 0.25, 0, 90.0);
		sprintf(buf,"boxer size = %d motion size = %d handler size %d", sizeof(BFrameList), sizeof(motion2), sizeof(handler2));
		ttext.Print(buf, 0.25, 0, 80.0);
*/
/*		sprintf(buf,"center = %f rotate = %f  total = %f", boxer2.damage_center, boxer2.damage_rotate, boxer2.damage_center + boxer2.damage_rotate);
		ttext.Print(buf, 0.25, 0, 90.0);
		sprintf(buf,"vnx = %f vny = %f vnz = %f", boxer2.vnx, boxer2.vny, boxer2.vnz);
		ttext.Print(buf, 0.25, 0, 80.0);
		sprintf(buf,"vfx = %f vfy = %f vfz = %f", boxer2.vgxs, boxer2.vgys, boxer2.vgzs);
		ttext.Print(buf, 0.25, 0, 70.0);
		sprintf(buf,"vgx = %f vgy = %f vgz = %f", boxer2.vgxs * boxer2.vnx * boxer2.Weight() * 50000.0, boxer2.vgys * boxer2.vny * boxer2.Weight() * 50000.0, boxer2.vgzs * boxer2.vnz * boxer2.Weight() * 50000.0);
		ttext.Print(buf, 0.25, 0, 60.0);

		sprintf(buf,"wna = %f wnb = %f wng = %f", boxer2.wna, boxer2.wnb, boxer2.wng);
		ttext.Print(buf, 0.25, 0, 50.0);
		sprintf(buf,"wfa = %f wfb = %f wfg = %f", boxer2.wgas, boxer2.wgbs, boxer2.wggs);
		ttext.Print(buf, 0.25, 0, 40.0);
		sprintf(buf,"wga = %f wgb = %f wgg = %f", boxer2.wgas * boxer2.wna * boxer2.Weight() * 50000.0, boxer2.wgbs * boxer2.wnb * boxer2.Weight() * 50000.0, boxer2.wggs * boxer2.wng * boxer2.Weight() * 50000.0);
		ttext.Print(buf, 0.25, 0, 30.0);    */
/*		
		sprintf(buf,"damage_center = %f damage_rotate = %f total = %f", boxer2.damage_center,  boxer2.damage_rotate, boxer2.damage_center + boxer2.damage_rotate);
		ttext.Print(buf, 0.25, 0, 70.0); 
		boxer2.CalcEnergy();
		sprintf(buf,"energy_center = %f energy_rotate = %f total = %f", boxer2.vg_energy,  boxer2.wg_energy, boxer2.vg_energy + boxer2.wg_energy);
		ttext.Print(buf, 0.25, 0, 60.0); 
 */   

		static char hit[255] = "Hit   0";
		if (handler2.IsDamaged()) {
			sprintf(hit,"Hit %3.0f", damage);
		}
		ttext.Print(hit, 0.4, -75, 100); 

/*		static char hit_right[255] = "Hit   0";
		static char hit_left[255] = "Hit   0";
		if (motion2.IsActionOverFirst()) {
			if (handler2.IsLeftOffenseState()) {
				sprintf(hit_right,"Hit Left %3.0f", boxer2.CalcDamageLeft());
    		}
			if (handler2.IsRightOffenseState()) {
				sprintf(hit_left,"Hit Right %3.0f", boxer2.CalcDamageRight());
    		}
		}
		ttext.Print(hit_right, 0.3, -75, 88); 
		ttext.Print(hit_left,  0.3, -75, 78);   */

		ttext.MessageLeave();
 
 		if (match.TimeCount() % SkipFrame == 0) SDL_GL_SwapBuffers(); 
		GLmes();

		timer.Wait();
		event.Poll();
		ExposeScreen();
		if (event.IsKeyDown(go_next) || IsNext()) {
			break;		
		}
		match.TickTime();
	} while(!event.IsQuit());
	if (event.IsQuit()) {
		Quit();
	}	
	show1 = show1_pre;
}
