#include "glbackground.h"

void GLBackGround::Make(GLTexture &background_tex, GLTexture &floor_tex, GLTexture &roof_tex, int pattern, int partition) {
	GLMaterial mat;

	if (pattern == 1) {
		mat.DefDiffuse(0.3, 0.3, 0.4, 1.0);
		mat.DefAmbient(0.2, 0.2, 0.2, 1.0);
		mat.DefSpecular(0.0, 0.0, 0.0, 1.0);
		mat.DefEmission(0.2, 0.2, 0.2, 1.0);
		mat.DefShininess(0.0);
		glbackground.Generate();
		glbackground.NewList();

		mat.Set();
		glBegin(GL_QUADS);
	    glNormal3f(0.0, 0.0, 1.0);
	    glVertex3f( 10.0,  10.0, -1.0);
		glVertex3f(-10.0,  10.0, -1.0);
	    glVertex3f(-10.0, -10.0, -1.0);
		glVertex3f( 10.0, -10.0, -1.0);
		glEnd();
		glPushMatrix();
		glTranslatef(0.0, 0.0, -1.0);
		glRotatef(180.0, 0.0, 1.0, 0.0);
		elipse2_poly_otherside(-15.7, 0.0, 10.0, 10.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, partition, 1);
		glPopMatrix();

		glbackground.EndList();
     	return;
	}

	mat.DefDiffuse(1.0, 1.0, 1.0, 1.0);
	mat.DefAmbient(0.2, 0.2, 0.2, 1.0);
	mat.DefSpecular(0.0, 0.0, 0.0, 1.0);
	mat.DefEmission(0.3, 0.3, 0.3, 1.0);
	mat.DefShininess(0.0);
	glbackground.Generate();
	glbackground.NewList();
	
	mat.Set();
	glEnable(GL_TEXTURE_2D);

	floor_tex.Bind();
	glBegin(GL_QUADS);
    glNormal3f(0.0, 0.0, 1.0);
	glTexCoord2f(20.0, 0.0);
    glVertex3f( 10.0,  10.0, -1.0);
	glTexCoord2f(0.0, 0.0);
	glVertex3f(-10.0,  10.0, -1.0);
	glTexCoord2f(0.0, 20.0);
    glVertex3f(-10.0, -10.0, -1.0);
	glTexCoord2f(20.0, 20.0);
	glVertex3f( 10.0, -10.0, -1.0);
	glEnd();

	roof_tex.Bind();
	glBegin(GL_QUADS);
    glNormal3f(0.0, 0.0, -1.0);
	glTexCoord2f(5.0, 5.0);
	glVertex3f( 10.0, -10.0, 14.7);
	glTexCoord2f(0.0, 5.0);
    glVertex3f(-10.0, -10.0, 14.7);
	glTexCoord2f(0.0, 0.0);
	glVertex3f(-10.0,  10.0, 14.7);
	glTexCoord2f(5.0, 0.0);
    glVertex3f( 10.0,  10.0, 14.7);
	glEnd();
	glDisable(GL_TEXTURE_2D);

	background_tex.Bind();
	glPushMatrix();
	glTranslatef(0.0, 0.0, -1.0);
	glRotatef(180.0, 0.0, 1.0, 0.0);
	pillor_othersidewt(-15.7, 0.0, 10.0, partition);
	glPopMatrix(); 

	glbackground.EndList();
}

void GLBackGround::Show() {
	glbackground.CallList();
}
