#include "gldlist.h"

GLDList::GLDList(bool gen) {
	dlname = 0;
	if (gen) {
		Generate();
	}
}

int GLDList::Generate() {
	if (WasGenerate()) {
		Delete();
	}
	dlname = glGenLists(1);
	if (!WasGenerate()) {
		emes("GLDList::Generate");
		GLmes();
		return false;	
	}
	return true;
}

void GLDList::Delete() {
	if(WasGenerate()) {
		glDeleteLists(dlname, 1);
	}
}

bool GLDList::WasGenerate() {
	if (glIsList(dlname)) {
		return true;
	}
	return false;
}

// GLDLists
GLDLists::GLDLists() {
	dlname = 0;
	mnumber = 0;
	cnumber = 0;
}

int GLDLists::Generate(int number) {
	if (WasGenerate()) {
		Delete();
	}
	mnumber = number;
	dlname = glGenLists(mnumber);
	if (!WasGenerate()) {
		emes("GLDLists::Generate");
		GLmes();
		return false;	
	}
	return true;
}

void GLDLists::Delete() {
	if(WasGenerate()) {
		glDeleteLists(dlname, mnumber);
		dlname = 0;
	}
}

void GLDLists::Delete(int number) {
	Choice(number);
	if(WasGenerate(number)) {
		glDeleteLists(dlname + cnumber, 1);
	}
}

void GLDLists::NewList(GLenum mode) {
	glNewList(dlname + cnumber, mode);
}

void GLDLists::NewList(int number, GLenum mode) {
	Choice(number);
	NewList(mode);
}
	
void GLDLists::CallList(int number) {
	Choice(number);
	CallList();
}

void GLDLists::Choice(int number) {
	if (number >= 0 && number < mnumber) {
		cnumber = number;
	}
}

bool GLDLists::WasGenerate(int number) {
	Choice(number);
	if (glIsList(dlname + cnumber)) {
		return true;
	}
	return false;
}

bool GLDLists::WasGenerate() {
	if (glIsList(dlname)) {
		return true;
	}
	return false;
}
