#ifndef GLMATRIX_H
#define GLMATRIX_H

#include <stdio.h>
#include <stdlib.h>
#include "myglheader.h"

class GLMatrix {
public:
	GLMatrix(GLenum cmode = GL_MODELVIEW_MATRIX);
	~GLMatrix();
	void Set() {glLoadMatrixf(matrix);}
	void Get() {glGetFloatv(mode, matrix);}
	float* Matrix() {return matrix;}
	void Mult() {glMultMatrixf(matrix);}
	void Mode() {glMatrixMode(mode);}
	float X() const {return x;}
	float Y() const {return y;}
	float Z() const {return z;}
	float M11() const { return matrix[0];}
	float M21() const { return matrix[1];}
	float M31() const { return matrix[2];}
	float M41() const { return matrix[3];}
	float M12() const { return matrix[4];}
	float M22() const { return matrix[5];}
	float M32() const { return matrix[6];}
	float M42() const { return matrix[7];}
	float M13() const { return matrix[8];}
	float M23() const { return matrix[9];}
	float M33() const {return matrix[10];}
	float M43() const {return matrix[11];}
	float M14() const {return matrix[12];}
	float M24() const {return matrix[13];}
	float M34() const {return matrix[14];}
	float M44() const {return matrix[15];}

	void Calc(float cx, float cy, float cz);
	void CalcUnit(float cx, float cy, float cz);
	void SetMode(GLenum cmode = GL_MODELVIEW_MATRIX) {mode = cmode;}
	void Print();
	void PrintCoord();
 	float& operator[](int number) {return matrix[number];}
private:
	float x, y, z;
	GLfloat matrix[16];
	GLenum mode;	
};


#endif // GLMATRIX
