/*
	̃vO
	http://astronomy.swin.edu.au/~pbourke/modelling/polygonise/
	http://www.media.t-kougei.ac.jp/~nagae/pub/94/thesis/
	Ȃǂ̃TCgQlɂč܂Bby P`
*/

#include "glpolygonize.h"

static SDL_Surface *text;
static float func_surface(int i, int j, int k);

static char ccode;
#ifdef USE_GFX_FONT
static float func_character(int i, int j, int k);
#else
static float func_mycharacter(int i, int j, int k);
#endif

#ifdef USE_GFX_FONT
#include <SDL_gfxPrimitives_font.h>
#else
#include "alphabetfont.h"
#endif

GLPolygonize::GLPolygonize() {
	make_table();
	threshold = 0.5;
}

GLPolygonize::~GLPolygonize() {
}

/* |Sp̃e[u */
void GLPolygonize::make_table() {
	int i, j, k, l, m, n, nj, nk, index_number;
/* _̃rbgCfbNX */
	int index[] = {0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80};
	int point_number,point_index[8];
	int edge_number,edge_index[12],polygon_index[4][8];
	int polygon_number, polygon_point;
	int start_edge, next_edge, point_bit[8];
	int face, face_point[4], face_edge[4];
/* eʂ̒_ԍ */ 
	int point[6][4] ={{ 0, 1, 5, 4},{ 2, 3, 1, 0},
					  { 2, 0, 4, 6},{ 1, 3, 7, 5},
					  { 4, 5, 7, 6},{ 6, 7, 3, 2}};
/* eʂ̕Ӕԍ */ 
	int edge[6][4] = {{ 0, 9, 2, 8},{ 1, 5, 0, 4},
					  { 4, 8, 6,10},{ 5,11, 7, 9},
					  { 2, 7, 3, 6},{ 3,11, 1,10}};

/* ׂĂ̑gݍ킹𒲂ׂ */
	for (i= 0; i<=255; i++) {
		point_number = 0;
		for (j = 0; j < 8; j++) { /* _̐ƃrbg */
			if (index[j] & i) {
				point_index[point_number++] = j;
				point_bit[j] = 1;
			} else {
				point_bit[j] = 0;
			}
		}

		edge_number = 0;
		polygon_number = 0;
		for (j = 0; j < 6; j++){
			for (k = 0; k < 4; k++){
				for (l = 0; l < 4; l++){
					face_point[l] = point[j][(k + l) % 4];
					face_edge[l] = edge[j][(k + l) % 4];
				}
				face = j;
			/* ̕ӂʉ߂邩? */
				if (point_bit[face_point[0]] == 1 && point_bit[face_point[1]] == 0) {
					start_edge = face_edge[0];
					next_edge = -1;
					for (l = 0; l < edge_number; l++) {
						if (start_edge == edge_index[l]) {
							next_edge = start_edge;							
						}								
					}
				/* Ė߂Ă */
					if (next_edge != start_edge) {
						edge_index[edge_number++]	= start_edge;			
						polygon_point = 1;						
						polygon_index[polygon_number][1] = start_edge;
					}

					while (start_edge != next_edge) {
						/* ǂ̕ӂɂȂ邩 */
						if (point_bit[face_point[2]] == 0 && point_bit[face_point[3]] == 0) {
							next_edge = face_edge[3]; /* E */
						}
						if (point_bit[face_point[2]] == 1 && point_bit[face_point[3]] == 0) {
							next_edge = face_edge[3];	/* E */			
						}
						if (point_bit[face_point[2]] == 0 && point_bit[face_point[3]] == 1) {
							next_edge = face_edge[2];	/*  */								
						}
						if (point_bit[face_point[2]] == 1 && point_bit[face_point[3]] == 1) {
							next_edge = face_edge[1];	/*  */			
						}
						for (m = 0; m < 6; m++) {	/* ͂ǂ̕ӂɂ邩 */
							for (n = 0; n < 4; n++) {
								if (next_edge == edge[m][n] && m != face) {
									nj = m;
									nk = n;
								}
							}
						} 	
						for (l = 0; l < 4; l++) { /* ̕ӂ_ɂ */
							face_point[l] = point[nj][(nk + l) % 4];
							face_edge[l] = edge[nj][(nk + l) % 4];
						}                 	
						face = nj;

						if (next_edge != start_edge) { /* ʂӂL */
							edge_index[edge_number++]	= next_edge;			
							polygon_index[polygon_number][++polygon_point] = next_edge;						
						} else {
							polygon_index[polygon_number++][0] = polygon_point;												
						}
					}
				}
			}
		}

	/* mF̂߂̕\ */
/*		printf("Index No.%3d\n",i);
		if (point_number > 0) {
			printf("Point Number         = %2d   Index = ",point_number);
			for (j = 0; j < point_number; j++) {
				printf(" %2d",point_index[j]);
			}
			printf("\n");
		}
		if (edge_number > 0) {
			printf("Edge Number          = %2d   Index = ",edge_number);
			for (j = 0; j < edge_number; j++) {
				printf(" %2d",edge_index[j]);
			}
			printf("\n");
		}
		if (polygon_number > 0) {
			printf("Polygon Number       = %2d\n",polygon_number);
			for (j = 0; j < polygon_number; j++) {
				polygon_point = polygon_index[j][0];
				printf("Polygon Point Number = %2d   Index = ",polygon_point);
				for (k = 1; k <= polygon_point; k++) {
					printf(" %2d",polygon_index[j][k]);
				}
				printf("\n");
			}
		}
		printf("\n");*/

		/* e[u */
		index_number = 0;	
		edge_index_table[i][index_number++] = edge_number;
		for (j = 0; j<12 ;j++) {
			edge_index_table[i][index_number++] = edge_index[j];
		}
		index_number = 0;	
		polygon_index_table[i][index_number++] = polygon_number;
		for (j = 0; j < polygon_number; j++) {
			polygon_point = polygon_index[j][0];
			polygon_index_table[i][index_number++] = polygon_point;
			for (k = 1; k <= polygon_point; k++) {
				polygon_index_table[i][index_number++] = polygon_index[j][k];
			}
		}
	}
}

/* Xp̊֐ */
void GLPolygonize::make_edge_x(float *edge, float *edgen, float *p1, float *p2) {
	float a;
	a = p1[F]/(p1[F] - p2[F]);
/* ؒf_͈ꎟߎŋ߂ */
	edge[X] = p1[X] + a * (p2[X] - p1[X]);
	edge[Y] = p1[Y];
	edge[Z] = p1[Z];
/* @͍ŋ߂ */
	edgen[X] = p1[RX] + a * (p2[RX] - p1[RX]);
	edgen[Y] = p1[RY] + a * (p2[RY] - p1[RY]);
	edgen[Z] = p1[RZ] + a * (p2[RZ] - p1[RZ]);
}

/* Yp̊֐ */
void GLPolygonize::make_edge_y(float *edge, float *edgen, float *p1, float *p2) {
	float a;
	a = p1[F]/(p1[F] - p2[F]);
	edge[X] = p1[X];
	edge[Y] = p1[Y] + a * (p2[Y] - p1[Y]);
	edge[Z] = p1[Z];
	edgen[X] = p1[RX] + a * (p2[RX] - p1[RX]);
	edgen[Y] = p1[RY] + a * (p2[RY] - p1[RY]);
	edgen[Z] = p1[RZ] + a * (p2[RZ] - p1[RZ]);
}

/* Zp̊֐ */
void GLPolygonize::make_edge_z(float *edge, float *edgen, float *p1, float *p2) {
	float a;
	a = p1[F]/(p1[F] - p2[F]);
	edge[X] = p1[X];
	edge[Y] = p1[Y];
	edge[Z] = p1[Z] + a * (p2[Z] - p1[Z]);
	edgen[X] = p1[RX] + a * (p2[RX] - p1[RX]);
	edgen[Y] = p1[RY] + a * (p2[RY] - p1[RY]);
	edgen[Z] = p1[RZ] + a * (p2[RZ] - p1[RZ]);
}

/* 낢ȑp`Ń|S */
int GLPolygonize::Make(int im, int jm, int km, float xs, float ys, float zs, float xl, float yl, float zl, float (func)(int, int, int)) {
	int i, j, k, k_1, k0, k1, k2, l, m, sp;
	int edge_number, polygon_number, polygon_point;
	int edge_index, polygon_index, index_number;
	float dx, dy, dz;
	float p[7], p0[7], p1[7], p2[7], p3[7], p4[7], p5[7], p6[7], p7[7];
	float edge[12][3], edgen[12][3];

	if (im > 128 || jm > 128) {
		emes("GLPolygonize::Make -> Division is too many.");
		return SDL_FAILURE;
	}

	dx = xl / (float)im;
	dy = yl / (float)jm;;
	dz = zl / (float)km;

	for (k = 0; k < 2; k++) { /* pɕۑ */
		p[Z] = zs + (float)k * dz;		
		for (j= 0; j < jm; j++) {
			p[Y] = ys + (float)j * dy;		
			for (i= 0; i < im; i++) {
					p[X] = xs + (float)i * dx;		
					f[i][j][k] = threshold - func(i, j, k);
			}
		}
	}

	for (k = 0; k < km - 1; k++) {
		k_1 = (k - 1) % 4;
		k0  =  k      % 4;
		k1  = (k + 1) % 4;
		k2  = (k + 2) % 4;

		if ((k + 2) <= km) {
			p[Z] = zs + (float)(k+2) * dz;		
			for (j= 0; j < jm; j++) {
				p[Y] = ys + (float)j * dy;		
				for (i= 0; i < im; i++) {
						p[X] = xs + (float)i * dx;		
						f[i][j][k2] = threshold - func(i, j, k+2);
				}
			}
		}

		p0[Z] = p1[Z] = p2[Z] = p3[Z] = zs + (float)k * dz;		
		p4[Z] = p5[Z] = p6[Z] = p7[Z] = p0[Z] + dz;
		for (j = 0; j < jm - 1; j++) {
			p0[Y] = p1[Y] = p4[Y] = p5[Y] = ys + (float)j * dy;		
			p2[Y] = p3[Y] = p6[Y] = p7[Y] = p0[Y] + dy;		
			for (i = 0; i < im - 1; i++) {
				p0[X] = p2[X] = p4[X] = p6[X] = xs + (float)i * dx;		
				p1[X] = p3[X] = p5[X] = p7[X] = p0[X] + dx;		

				p0[F] = f[i][j][k0];
				p1[F] = f[i+1][j][k0];
				p2[F] = f[i][j+1][k0];
				p3[F] = f[i+1][j+1][k0];
				p4[F] = f[i][j][k1];
				p5[F] = f[i+1][j][k1];
				p6[F] = f[i][j+1][k1];
				p7[F] = f[i+1][j+1][k1];

				sp = 0x00; /* CfbXŇvZ */
				if (p0[F] > 0.0) {sp|=0x01;}
				if (p1[F] > 0.0) {sp|=0x02;}
				if (p2[F] > 0.0) {sp|=0x04;}
				if (p3[F] > 0.0) {sp|=0x08;}
				if (p4[F] > 0.0) {sp|=0x10;}
				if (p5[F] > 0.0) {sp|=0x20;}
				if (p6[F] > 0.0) {sp|=0x40;}
				if (p7[F] > 0.0) {sp|=0x80;}
				
				if (sp != 0x00 && sp != 0xff) { /* Ŗ@vZ */
					if (i == 0) { /* Б */
						p0[RX] = (f[i+1][j][k0]    - f[i][j][k0]  )*2.0;
						p2[RX] = (f[i+1][j+1][k0]  - f[i][j+1][k0])*2.0;
						p4[RX] = (f[i+1][j][k1]    - f[i][j][k1]  )*2.0;
						p6[RX] = (f[i+1][j+1][k1]  - f[i][j+1][k1])*2.0;					
					} else {      /*  */
						p0[RX] = f[i+1][j][k0]    - f[i-1][j][k0];
						p2[RX] = f[i+1][j+1][k0]  - f[i-1][j+1][k0];
						p4[RX] = f[i+1][j][k1]    - f[i-1][j][k1];
						p6[RX] = f[i+1][j+1][k1]  - f[i-1][j+1][k1];
					}

					if (i == (im - 1)) {
						p1[RX] = (f[i+1][j][k0]    - f[i][j][k0]  )*2.0;
						p3[RX] = (f[i+1][j+1][k0]  - f[i][j+1][k0])*2.0;
						p5[RX] = (f[i+1][j][k1]    - f[i][j][k1]  )*2.0;
						p7[RX] = (f[i+1][j+1][k1]  - f[i][j+1][k1])*2.0;
					} else {
						p1[RX] = f[i+2][j][k0]    - f[i][j][k0];
						p3[RX] = f[i+2][j+1][k0]  - f[i][j+1][k0];
						p5[RX] = f[i+2][j][k1]    - f[i][j][k1];
						p7[RX] = f[i+2][j+1][k1]  - f[i][j+1][k1];
					}

					if (j == 0) {
						p0[RY] = (  f[i][j+1][k0]  -   f[i][j][k0])*2.0;
						p1[RY] = (f[i+1][j+1][k0]  - f[i+1][j][k0])*2.0;
						p4[RY] = (  f[i][j+1][k1]  -   f[i][j][k1])*2.0;
						p5[RY] = (f[i+1][j+1][k1]  - f[i+1][j][k1])*2.0;					
					} else {
						p0[RY] =   f[i][j+1][k0]  -   f[i][j-1][k0];
						p1[RY] = f[i+1][j+1][k0]  - f[i+1][j-1][k0];
						p4[RY] =   f[i][j+1][k1]  -   f[i][j-1][k1];
						p5[RY] = f[i+1][j+1][k1]  - f[i+1][j-1][k1];
					}

					if (j == (jm - 1)) {
						p2[RY] = (  f[i][j+1][k0]  -   f[i][j][k0])*2.0;
						p3[RY] = (f[i+1][j+1][k0]  - f[i+1][j][k0])*2.0;
						p6[RY] = (  f[i][j+1][k1]  -   f[i][j][k1])*2.0;
						p7[RY] = (f[i+1][j+1][k1]  - f[i+1][j][k1])*2.0;					
					} else {
						p2[RY] =   f[i][j+2][k0]  -   f[i][j][k0];
						p3[RY] = f[i+1][j+2][k0]  - f[i+1][j][k0];
						p6[RY] =   f[i][j+2][k1]  -   f[i][j][k1];
						p7[RY] = f[i+1][j+2][k1]  - f[i+1][j][k1];
					}
					
					if (k == 0) {
						p0[RZ] = (    f[i][j][k1]  -     f[i][j][k0])*2.0;
						p1[RZ] = (  f[i+1][j][k1]  -   f[i+1][j][k0])*2.0;
						p2[RZ] = (  f[i][j+1][k1]  -   f[i][j+1][k0])*2.0;
						p3[RZ] = (f[i+1][j+1][k1]  - f[i+1][j+1][k0])*2.0;					
					} else {
						p0[RZ] =     f[i][j][k1]  -     f[i][j][k_1];
						p1[RZ] =   f[i+1][j][k1]  -   f[i+1][j][k_1];
						p2[RZ] =   f[i][j+1][k1]  -   f[i][j+1][k_1];
						p3[RZ] = f[i+1][j+1][k1]  - f[i+1][j+1][k_1];
					}

					if (k == (km -1)) {
						p4[RZ] = (    f[i][j][k1]  -     f[i][j][k0])*2.0;
						p5[RZ] = (  f[i+1][j][k1]  -   f[i+1][j][k0])*2.0;
						p6[RZ] = (  f[i][j+1][k1]  -   f[i][j+1][k0])*2.0;
						p7[RZ] = (f[i+1][j+1][k1]  - f[i+1][j+1][k0])*2.0;
					} else {
						p4[RZ] =     f[i][j][k2]  -     f[i][j][k0];
						p5[RZ] =   f[i+1][j][k2]  -   f[i+1][j][k0];
						p6[RZ] =   f[i][j+1][k2]  -   f[i][j+1][k0];
						p7[RZ] = f[i+1][j+1][k2]  - f[i+1][j+1][k0];
					}
					
					edge_number =  edge_index_table[sp][0];
					for (l = 1; l <= edge_number; l++) { /* ӂ̕_ꎟԂŋ߂ */
						edge_index = edge_index_table[sp][l];
						switch(edge_index) {
							case  0:
              					make_edge_x(edge[0],edgen[0],p0,p1);
							break;
							case  1:
								make_edge_x(edge[1],edgen[1],p2,p3);
							break;
							case  2:
								make_edge_x(edge[2],edgen[2],p4,p5);
							break;
							case  3:
								make_edge_x(edge[3],edgen[3],p6,p7);
							break;
							case  4:
								make_edge_y(edge[4],edgen[4],p0,p2);
							break;
							case  5:
								make_edge_y(edge[5],edgen[5],p1,p3);
							break;
							case  6:
								make_edge_y(edge[6],edgen[6],p4,p6);
							break;
							case  7:
								make_edge_y(edge[7],edgen[7],p5,p7);
							break;
							case  8:
								make_edge_z(edge[8],edgen[8],p0,p4);
							break;
							case  9:
								make_edge_z(edge[9],edgen[9],p1,p5);
							break;
							case 10:
								make_edge_z(edge[10],edgen[10],p2,p6);
							break;
							case 11:
								make_edge_z(edge[11],edgen[11],p3,p7);
							break;
						}
					}					
							
					index_number = 0;
					polygon_number =  polygon_index_table[sp][index_number++];
					for (l = 0;l < polygon_number; l++) { /* |S\ */
						polygon_point = polygon_index_table[sp][index_number++];
						switch(polygon_point) {
							case 3:
								glBegin(GL_TRIANGLES);
								glNormal3fv(edgen[polygon_index_table[sp][index_number]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number++]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number++]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number++]]);
								glEnd();
							break;
							case 4:
								glBegin(GL_QUADS);
								glNormal3fv(edgen[polygon_index_table[sp][index_number]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number++]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number++]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number++]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number++]]);
								glEnd();
							break;
							case 5:  
							case 6:
							case 7:
								glBegin(GL_POLYGON);
								for (m = 0; m < polygon_point; m++) {
									glNormal3fv(edgen[polygon_index_table[sp][index_number]]);
									glVertex3fv(edge[polygon_index_table[sp][index_number++]]);
								} 
								glEnd();  
							break;
						}									 	
					}						
				}  
			}
		}
	}
}

/* SOp`Ń|S(gp) */
int GLPolygonize::MakeAT(int im, int jm, int km, float xs, float ys, float zs, float xl, float yl, float zl, float (func)(int, int, int)) {
	int i, j, k, k_1, k0, k1, k2, l, m, sp;
	int edge_number, polygon_number, polygon_point;
	int edge_index, polygon_index, index_number;
	float dx, dy, dz;
	float p[7], p0[7], p1[7], p2[7], p3[7], p4[7], p5[7], p6[7], p7[7];
	float edge[12][3], edgen[12][3];

	if (im > 256 || jm > 128) {
		emes("GLPolygonize::Make -> Division is too many.");
		return SDL_FAILURE;
	}

	dx = xl / (float)im;
	dy = yl / (float)jm;;
	dz = zl / (float)km;

	for (k = 0; k < 2; k++) { /* pɕۑ */
		p[Z] = zs + (float)k * dz;		
		for (j= 0; j < jm; j++) {
			p[Y] = ys + (float)j * dy;		
			for (i= 0; i < im; i++) {
					p[X] = xs + (float)i * dx;		
					f[i][j][k] = threshold - func(i, j, k);
			}
		}
	}

	glBegin(GL_TRIANGLES);
	for (k = 0; k < km - 1; k++) {
		k_1 = (k - 1) % 4;
		k0  =  k      % 4;
		k1  = (k + 1) % 4;
		k2  = (k + 2) % 4;

		if ((k + 2) <= km) {
			p[Z] = zs + (float)(k+2) * dz;		
			for (j= 0; j < jm; j++) {
				p[Y] = ys + (float)j * dy;		
				for (i= 0; i < im; i++) {
						p[X] = xs + (float)i * dx;		
						f[i][j][k2] = threshold - func(i, j, k+2);
				}
			}
		}

		p0[Z] = p1[Z] = p2[Z] = p3[Z] = zs + (float)k * dz;		
		p4[Z] = p5[Z] = p6[Z] = p7[Z] = p0[Z] + dz;
		for (j = 0; j < jm - 1; j++) {
			p0[Y] = p1[Y] = p4[Y] = p5[Y] = ys + (float)j * dy;		
			p2[Y] = p3[Y] = p6[Y] = p7[Y] = p0[Y] + dy;		
			for (i = 0; i < im - 1; i++) {
				p0[X] = p2[X] = p4[X] = p6[X] = xs + (float)i * dx;		
				p1[X] = p3[X] = p5[X] = p7[X] = p0[X] + dx;		

				p0[F] = f[i][j][k0];
				p1[F] = f[i+1][j][k0];
				p2[F] = f[i][j+1][k0];
				p3[F] = f[i+1][j+1][k0];
				p4[F] = f[i][j][k1];
				p5[F] = f[i+1][j][k1];
				p6[F] = f[i][j+1][k1];
				p7[F] = f[i+1][j+1][k1];

				sp = 0x00; /* CfbXŇvZ */
				if (p0[F] > 0.0) {sp|=0x01;}
				if (p1[F] > 0.0) {sp|=0x02;}
				if (p2[F] > 0.0) {sp|=0x04;}
				if (p3[F] > 0.0) {sp|=0x08;}
				if (p4[F] > 0.0) {sp|=0x10;}
				if (p5[F] > 0.0) {sp|=0x20;}
				if (p6[F] > 0.0) {sp|=0x40;}
				if (p7[F] > 0.0) {sp|=0x80;}
				
				if (sp != 0x00 && sp != 0xff) { /* Ŗ@vZ */
					if (i == 0) { /* Б */
						p0[RX] = (f[i+1][j][k0]    - f[i][j][k0]  )*2.0;
						p2[RX] = (f[i+1][j+1][k0]  - f[i][j+1][k0])*2.0;
						p4[RX] = (f[i+1][j][k1]    - f[i][j][k1]  )*2.0;
						p6[RX] = (f[i+1][j+1][k1]  - f[i][j+1][k1])*2.0;					
					} else {      /*  */
						p0[RX] = f[i+1][j][k0]    - f[i-1][j][k0];
						p2[RX] = f[i+1][j+1][k0]  - f[i-1][j+1][k0];
						p4[RX] = f[i+1][j][k1]    - f[i-1][j][k1];
						p6[RX] = f[i+1][j+1][k1]  - f[i-1][j+1][k1];
					}

					if (i == (im - 1)) {
						p1[RX] = (f[i+1][j][k0]    - f[i][j][k0]  )*2.0;
						p3[RX] = (f[i+1][j+1][k0]  - f[i][j+1][k0])*2.0;
						p5[RX] = (f[i+1][j][k1]    - f[i][j][k1]  )*2.0;
						p7[RX] = (f[i+1][j+1][k1]  - f[i][j+1][k1])*2.0;
					} else {
						p1[RX] = f[i+2][j][k0]    - f[i][j][k0];
						p3[RX] = f[i+2][j+1][k0]  - f[i][j+1][k0];
						p5[RX] = f[i+2][j][k1]    - f[i][j][k1];
						p7[RX] = f[i+2][j+1][k1]  - f[i][j+1][k1];
					}

					if (j == 0) {
						p0[RY] = (  f[i][j+1][k0]  -   f[i][j][k0])*2.0;
						p1[RY] = (f[i+1][j+1][k0]  - f[i+1][j][k0])*2.0;
						p4[RY] = (  f[i][j+1][k1]  -   f[i][j][k1])*2.0;
						p5[RY] = (f[i+1][j+1][k1]  - f[i+1][j][k1])*2.0;					
					} else {
						p0[RY] =   f[i][j+1][k0]  -   f[i][j-1][k0];
						p1[RY] = f[i+1][j+1][k0]  - f[i+1][j-1][k0];
						p4[RY] =   f[i][j+1][k1]  -   f[i][j-1][k1];
						p5[RY] = f[i+1][j+1][k1]  - f[i+1][j-1][k1];
					}

					if (j == (jm - 1)) {
						p2[RY] = (  f[i][j+1][k0]  -   f[i][j][k0])*2.0;
						p3[RY] = (f[i+1][j+1][k0]  - f[i+1][j][k0])*2.0;
						p6[RY] = (  f[i][j+1][k1]  -   f[i][j][k1])*2.0;
						p7[RY] = (f[i+1][j+1][k1]  - f[i+1][j][k1])*2.0;					
					} else {
						p2[RY] =   f[i][j+2][k0]  -   f[i][j][k0];
						p3[RY] = f[i+1][j+2][k0]  - f[i+1][j][k0];
						p6[RY] =   f[i][j+2][k1]  -   f[i][j][k1];
						p7[RY] = f[i+1][j+2][k1]  - f[i+1][j][k1];
					}
					
					if (k == 0) {
						p0[RZ] = (    f[i][j][k1]  -     f[i][j][k0])*2.0;
						p1[RZ] = (  f[i+1][j][k1]  -   f[i+1][j][k0])*2.0;
						p2[RZ] = (  f[i][j+1][k1]  -   f[i][j+1][k0])*2.0;
						p3[RZ] = (f[i+1][j+1][k1]  - f[i+1][j+1][k0])*2.0;					
					} else {
						p0[RZ] =     f[i][j][k1]  -     f[i][j][k_1];
						p1[RZ] =   f[i+1][j][k1]  -   f[i+1][j][k_1];
						p2[RZ] =   f[i][j+1][k1]  -   f[i][j+1][k_1];
						p3[RZ] = f[i+1][j+1][k1]  - f[i+1][j+1][k_1];
					}

					if (k == (km -1)) {
						p4[RZ] = (    f[i][j][k1]  -     f[i][j][k0])*2.0;
						p5[RZ] = (  f[i+1][j][k1]  -   f[i+1][j][k0])*2.0;
						p6[RZ] = (  f[i][j+1][k1]  -   f[i][j+1][k0])*2.0;
						p7[RZ] = (f[i+1][j+1][k1]  - f[i+1][j+1][k0])*2.0;
					} else {
						p4[RZ] =     f[i][j][k2]  -     f[i][j][k0];
						p5[RZ] =   f[i+1][j][k2]  -   f[i+1][j][k0];
						p6[RZ] =   f[i][j+1][k2]  -   f[i][j+1][k0];
						p7[RZ] = f[i+1][j+1][k2]  - f[i+1][j+1][k0];
					}
					
					edge_number =  edge_index_table[sp][0];
					for (l = 1; l <= edge_number; l++) { /* ӂ̕_ꎟԂŋ߂ */
						edge_index = edge_index_table[sp][l];
						switch(edge_index) {
							case  0:
              					make_edge_x(edge[0],edgen[0],p0,p1);
							break;
							case  1:
								make_edge_x(edge[1],edgen[1],p2,p3);
							break;
							case  2:
								make_edge_x(edge[2],edgen[2],p4,p5);
							break;
							case  3:
								make_edge_x(edge[3],edgen[3],p6,p7);
							break;
							case  4:
								make_edge_y(edge[4],edgen[4],p0,p2);
							break;
							case  5:
								make_edge_y(edge[5],edgen[5],p1,p3);
							break;
							case  6:
								make_edge_y(edge[6],edgen[6],p4,p6);
							break;
							case  7:
								make_edge_y(edge[7],edgen[7],p5,p7);
							break;
							case  8:
								make_edge_z(edge[8],edgen[8],p0,p4);
							break;
							case  9:
								make_edge_z(edge[9],edgen[9],p1,p5);
							break;
							case 10:
								make_edge_z(edge[10],edgen[10],p2,p6);
							break;
							case 11:
								make_edge_z(edge[11],edgen[11],p3,p7);
							break;
						}
					}					
							
					index_number = 0;
					polygon_number =  polygon_index_table[sp][index_number++];
					for (l = 0;l < polygon_number; l++) { /* |S\ */
						polygon_point = polygon_index_table[sp][index_number++];
						switch(polygon_point) {
							case 3:
								glNormal3fv(edgen[polygon_index_table[sp][index_number]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+1]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+1]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+2]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+2]]);
								index_number+=2;
							break;
							case 4:
								glNormal3fv(edgen[polygon_index_table[sp][index_number]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+1]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+1]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+2]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+2]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+2]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+2]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+3]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+3]]);
								index_number+=3;
							break;
							case 5:  
								glNormal3fv(edgen[polygon_index_table[sp][index_number]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+1]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+1]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+2]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+2]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+2]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+2]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+3]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+3]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+3]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+3]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+4]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+4]]);
								index_number+=4;
							case 6:
								glNormal3fv(edgen[polygon_index_table[sp][index_number]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+1]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+1]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+2]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+2]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+2]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+2]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+3]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+3]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+3]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+3]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+4]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+4]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+4]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+4]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+5]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+5]]);
								index_number+=5;
							case 7:
								glNormal3fv(edgen[polygon_index_table[sp][index_number]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+1]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+1]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+2]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+2]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+2]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+2]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+3]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+3]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+3]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+3]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+4]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+4]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+4]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+4]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+5]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+5]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+5]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+5]]);
								glNormal3fv(edgen[polygon_index_table[sp][index_number+6]]);
								glVertex3fv(edge[polygon_index_table[sp][index_number+6]]);
								index_number+=6;
							break;
						}									 	
					}						
				}  
			}
		}
	}
	glEnd();
}

/* f[^Zxz */
void GLPolygonize::Alphabet(char c) {
	ccode = c;
#ifdef USE_GFX_FONT
/* SDL_gfx̃tHg */
	Make(10, 10, 5, -0.03, -0.06, -0.125, 0.53, 1.006, 0.25, func_character);
#else
/* ƎҏW̃tHg */
	Make(12, 13, 5, -0.05, -0.1, -0.125, 0.55, 1.1, 0.25, func_mycharacter);
#endif
}

/* T[tFCXZxz */
void GLPolygonize::Surface(SDL_Surface *surface) {
	text = surface;
	Make(text->w + 2, text->h + 2, 10, 0.0, 0.0, -0.125, text->w/(float)text->h, 1.0, 0.25, func_surface);
/* J */
	SDL_FreeSurface(surface);
}

/* SDL_gfx̃tHg̔Zxz쐬p */
#ifdef USE_GFX_FONT
float func_character(int i, int j, int k) {
	int index_y;
	Uint8 index_x = 128;
	float r_value = 0.0;
                             
	if (k != 0 && k < 4) {
		if (i != 0 && i < 9 && j != 0 && j < 9) {
			index_y = 8 - j;
			index_x >>= (i - 1);
			if (gfxPrimitivesFontdata[8*ccode+index_y] & index_x) {
				r_value = 1.0;						
			}
		}
	}
	return r_value;
}
#else
/* ƎҏW̃tHg̔Zxz쐬p */
float func_mycharacter(int i, int j, int k) {
	int index_y;
	Uint16 index_x = 1;
	float r_value = 0.0;
                             
	if (k != 0 && k < 4) {
		if (i != 0 && i < 11 && j != 0 && j < 12) {
			index_y = 11 - j;
			index_x <<= i;
			if (alphabet_font[11*ccode+index_y] & index_x) {
				r_value = 1.0;						
			}
		}
	}
	return r_value;
} 
#endif

/* T[tFCXZxz쐬p */
float func_surface(int i, int j, int k) {
	int index_y;
	int index_x;
	Uint8 *pixel;
    int bpp = text->format->BytesPerPixel;
	SDL_Palette* palette = text->format->palette;
	float r_value = 0.0;

	if (k != 0 && k < 9) {
		if (i != 0 && i < text->w && j != 0 && j < text->h) {
			index_y = text->h - j - 1;
			index_x = i - 1;
			pixel = (Uint8 *)text->pixels + index_y * text->pitch + index_x * bpp;
				
    		switch(bpp) {
    			case 1: /* RenderSolid̏ꍇ */
					if (palette->colors[0].r == 255 - palette->colors[1].r &&
						palette->colors[0].g == 255 - palette->colors[1].g &&
						palette->colors[0].b == 255 - palette->colors[1].b) {
						if (*pixel) {
							r_value = 1.0;
						}
					} else { /* RenderShaded̏ꍇ */
						r_value = *pixel / 255.0;
					}
				break;
    			case 2:
					r_value = *(Uint16 *)pixel / 65535.0;
				break;
    			case 3:
					r_value = *(Uint32 *)pixel / 16777215.0;
				break;
    			case 4: /* RenderBlended̏ꍇ */
					r_value = *(Uint32 *)pixel / 4294967295.0;
				break;
				default:
					r_value = 0.0;				
			}
		}
	}
	return r_value;
}
