#ifndef GLPTEXT_H
#define GLPTEXT_H

#include "csdl.h"

class STTF;
class GLPolygonize;
class GLDLists;

#include "symbol.h"
#include "gllight.h"
#include "glcamera.h"
#include "glmaterial.h"

#define YSSIZE 3.00
#define XSSIZE 4.00

/* 2oCgp̍őfBXvCXg */
#define MAX_GLDLISTS 255
/* fBXvCXgŏ̃R[h */
#define CHAR_START 1
/* fBXvCXgŌ̃R[h */
#define CHAR_END  126

class GLPText {
public:
	GLPText();
	~GLPText();
	int Init(GLPolygonize *glp_in, STTF *ttf_in);
	void Char(char c);
	void Text(char *str);
	void Symbol(char symbol, float size = 0.5, int xpos = 0, int ypos = 0);
	void Print(char *str, float size = 0.5, int xpos = 0, int ypos = 0);
	void LongPrint(char *str, float size = 0.5, int xpos = 80, int ypos = 80);

	void TextVertical(char *str);
	void PrintVertical(char *str, float size = 0.5, int xpos = 0, int ypos = 0);

	void Message(char *str, float size = 0.5, int xpos = 0, int ypos = 0);
	void LongMessage(char *str, float size = 0.5, int xpos = 80, int ypos = 80);
	void Pause(char *str, float size = 0.5, int xpos = 0, int ypos = 0);

	void Char2(char *str);
	void MakeText(char *str);
	void MakeChar2(char *str);

	void SetColor(float r, float g, float b) {color.Diffuse(r, g, b);}
	void SetAlpha(float a) {color.Diffuse(NO_CHANGE, NO_CHANGE, NO_CHANGE, a);}
	void SetDiffuse(float r, float g, float b) {color.Diffuse(r, g, b);}
	void SetAmbient(float r, float g, float b) {color.Ambient(r, g, b);}
	void SetSpecular(float r, float g, float b) {color.Specular(r, g, b);}
	void SetEmission(float r, float g, float b) {color.Emission(r, g, b);}
	void SetShininess(float p) {color.Shininess(p);}
	void SelectColor(bool is_true) {
		if (is_true) {
			SetColor(1.0, 0.0, 0.0);	
		} else {
			SetColor(1.0, 1.0, 1.0);	
		}	
	}

	void MessageEnter();
	void MessageLeave();
	void Clear();
	void ClearAlphabet();
	void MakeAlphabetFromTTF();
	void Close();
	bool WasInit();

private:
	STTF *ttf;
	GLPolygonize *glp;
	GLDLists surface;
	GLDLists alphabet;
	GLLight light_save, light;
	GLCamera camera;	
	GLMaterial color;	
	char code2[MAX_GLDLISTS][3];
	int mnumber;
	int cnumber;
	bool wasinit;
};

#endif //GLPTEXT_H
