#include "glring.h"

void GLRing::Make(int ads_switch, GLTexture &canvas_tex, GLTexture &ads_tex, int partition) {
	int i;
	GLMaterial rope_color[5];
	GLMaterial canvas_color;	
	GLMaterial red_color;	
	GLMaterial blue_color;	
	GLMaterial neutral_color;	

	GLMaterial pole_red;	
	GLMaterial pole_blue;	
	GLMaterial pole_neutral;	

	canvas_color.DefDiffuse(0.8, 0.8, 0.8, 1.0);
	canvas_color.DefAmbient(0.2, 0.2, 0.2, 1.0);
	canvas_color.DefSpecular(0.0, 0.0, 0.0, 1.0);
	canvas_color.DefEmission(0.0, 0.0, 0.0, 1.0);
	canvas_color.DefShininess(0.0);

	pole_red.DefDiffuse(1.0, 0.2, 0.2, 1.0);
	pole_red.DefAmbient(0.2, 0.2, 0.2, 1.0);
	pole_red.DefSpecular(0.0, 0.0, 0.0, 0.0);
	pole_red.DefEmission(0.0, 0.0, 0.0, 1.0);
	pole_red.DefShininess(0.0);

	pole_blue.DefDiffuse(0.2, 0.2, 1.0, 1.0);
	pole_blue.DefAmbient(0.2, 0.2, 0.2, 1.0);
	pole_blue.DefSpecular(0.0, 0.0, 0.0, 0.0);
	pole_blue.DefEmission(0.0, 0.0, 0.0, 1.0);
	pole_blue.DefShininess(0.0);

	pole_neutral.DefDiffuse(1.0, 1.0, 1.0, 1.0);
	pole_neutral.DefAmbient(0.2, 0.2, 0.2, 1.0);
	pole_neutral.DefSpecular(0.0, 0.0, 0.0, 0.0);
	pole_neutral.DefEmission(0.0, 0.0, 0.0, 1.0);
	pole_neutral.DefShininess(0.0);

	red_color.DefDiffuse(1.0, 0.0, 0.0, 1.0);
	red_color.DefAmbient(0.2, 0.2, 0.2, 1.0);
	red_color.DefSpecular(0.0, 0.0, 0.0, 1.0);
	red_color.DefEmission(0.0, 0.0, 0.0, 1.0);
	red_color.DefShininess(0.0);

	blue_color.DefDiffuse(0.0, 0.0, 1.0, 1.0);
	blue_color.DefAmbient(0.2, 0.2, 0.2, 1.0);
	blue_color.DefSpecular(0.0, 0.0, 0.0, 1.0);
	blue_color.DefEmission(0.0, 0.0, 0.0, 1.0);
	blue_color.DefShininess(0.0);

	neutral_color.DefDiffuse(1.0, 1.0, 1.0, 1.0);
	neutral_color.DefAmbient(0.2, 0.2, 0.2, 1.0);
	neutral_color.DefSpecular(0.0, 0.0, 0.0, 1.0);
	neutral_color.DefEmission(0.0, 0.0, 0.0, 1.0);
	neutral_color.DefShininess(0.0);

	rope_color[1].DefDiffuse(1.0, 1.0, 1.0, 1.0);
	rope_color[1].DefAmbient(0.2, 0.2, 0.2, 1.0);
	rope_color[1].DefSpecular(0.8, 0.8, 0.8, 1.0);
	rope_color[1].DefEmission(0.0, 0.0, 0.0, 1.0);
	rope_color[1].DefShininess(64.0);

	rope_color[2].DefDiffuse(0.0, 0.0, 1.0, 1.0);
	rope_color[2].DefAmbient(0.2, 0.2, 0.2, 1.0);
	rope_color[2].DefSpecular(0.8, 0.8, 0.8, 1.0);
	rope_color[2].DefEmission(0.0, 0.0, 0.0, 1.0);
	rope_color[2].DefShininess(64.0);

	rope_color[3].DefDiffuse(1.0, 1.0, 1.0, 1.0);
	rope_color[3].DefAmbient(0.2, 0.2, 0.2, 1.0);
	rope_color[3].DefSpecular(0.8, 0.8, 0.8, 1.0);
	rope_color[3].DefEmission(0.0, 0.0, 0.0, 1.0);
	rope_color[3].DefShininess(64.0);

	rope_color[4].DefDiffuse(1.0, 0.0, 0.0, 1.0);
	rope_color[4].DefAmbient(0.2, 0.2, 0.2, 1.0);
	rope_color[4].DefSpecular(0.8, 0.8, 0.8, 1.0);
	rope_color[4].DefEmission(0.0, 0.0, 0.0, 1.0);
	rope_color[4].DefShininess(64.0);

	canvas.Generate();
	canvas.NewList();
	canvas_color.Set();
	if (ads_switch) {
		canvas_tex.Bind();
	}
	glPushMatrix();
	glTranslatef(0.0, 0.0, -1.0);
	if (ads_switch) {
		box_canvas(3.0, 3.0, 1.0);
	} else {
		box(3.0, 3.0, 1.0);	
	}
	glPopMatrix();  
	canvas.EndList();

	neutral_corner1.Generate();
	neutral_corner1.NewList();
	if (ads_switch) {
		ads_tex.Bind();
	}
	pole_neutral.Set();
	glPushMatrix();
	glTranslatef(2.5, 2.5, 0.2);
	glRotatef(45.0, 0.0, 0.0, 1.0);
	if (ads_switch) {
		box_corner(0.05, 0.15, 1.4, 1);
	} else {
		box(0.05, 0.15, 1.4);	
	}
	glPopMatrix();

	for (i = 1; i < 5; i++) {
		glPushMatrix();
		glTranslatef(2.88, 2.88, 0.35 * i);
		glRotatef(90.0, 0.0, 1.0, 0.0);
		glRotatef(-225.0, 1.0, 0.0, 0.0);
		corn2o(0.0, 0.5, 0.05, 0.080, 1.0, 1.0, 1.5, 1.5, partition);
		glPopMatrix();
	}

	neutral_color.Set();
	glPushMatrix();
	glTranslatef(2.9, 2.9, 0.0);
	pillaro(0.0, 1.5, 0.08, partition);
	glTranslatef(0.0, 0.0, 1.5);
	pillar_top(0.1, 0.08, partition);
	glPopMatrix();
	neutral_corner1.EndList();

	neutral_corner2.Generate();
	neutral_corner2.NewList();
	if (ads_switch) {
		ads_tex.Bind();
	}
	pole_neutral.Set();
	glPushMatrix();
	glTranslatef(-2.5, -2.5, 0.2);
	glRotatef(225.0, 0.0, 0.0, 1.0);
	if (ads_switch) {
		box_corner(0.05, 0.15, 1.4, 0);
	} else {
		box(0.05, 0.15, 1.4);	
	}
	glPopMatrix();

	for (i = 1; i < 5; i++) {
		glPushMatrix();
		glTranslatef(-2.88, -2.88, 0.35 * i);
		glRotatef(90.0, 0.0, 1.0, 0.0);
		glRotatef(-45, 1.0, 0.0, 0.0);
		corn2o(0.0, 0.5, 0.05, 0.080, 1.0, 1.0, 1.5, 1.5, partition);
		glPopMatrix();
	}

	neutral_color.Set();
	glPushMatrix();
	glTranslatef(-2.9, -2.9, 0.0);
	pillaro(0.0, 1.5, 0.08, partition);
	glTranslatef(0.0, 0.0, 1.5);
	pillar_top(0.1, 0.08, partition);
	glPopMatrix();
	neutral_corner2.EndList();

	red_corner.Generate();
	red_corner.NewList();
	pole_red.Set();
	glPushMatrix();
	glTranslatef(2.5, -2.5, 0.2);
	glRotatef(-45.0, 0.0, 0.0, 1.0);
	box(0.05, 0.15, 1.4);
	glPopMatrix();

	for (i = 1; i < 5; i++) {
		glPushMatrix();
		glTranslatef(2.88, -2.88, 0.35 * i);
		glRotatef(90.0, 0.0, 1.0, 0.0);
		glRotatef(225.0, 1.0, 0.0, 0.0);
		corn2o(0.0, 0.5, 0.05, 0.080, 1.0, 1.0, 1.5, 1.5, partition);
		glPopMatrix();
	}

	red_color.Set();
	glPushMatrix();
	glTranslatef(2.9, -2.9, 0.0);
	pillaro(0.0, 1.5, 0.08, partition);
	glTranslatef(0.0, 0.0, 1.5);
	pillar_top(0.1, 0.08, partition);
	glPopMatrix();
	red_corner.EndList();

	blue_corner.Generate();
	blue_corner.NewList();
	pole_blue.Set();
	glPushMatrix();
	glTranslatef(-2.5, 2.5, 0.2);
	glRotatef(-225.0, 0.0, 0.0, 1.0);
	box(0.05, 0.15, 1.4);
	glPopMatrix();

	for (i = 1; i < 5; i++) {
		glPushMatrix();
		glTranslatef(-2.88, 2.88, 0.35 * i);
		glRotatef(90.0, 0.0, 1.0, 0.0);
		glRotatef(45.0, 1.0, 0.0, 0.0);
		corn2o(0.0, 0.5, 0.05, 0.080, 1.0, 1.0, 1.5, 1.5, partition);
		glPopMatrix();
	}

	blue_color.Set();
	glPushMatrix();
	glTranslatef(-2.9, 2.9, 0.0);
	pillaro(0.0, 1.5, 0.08, partition);
	glTranslatef(0.0, 0.0, 1.5);
	pillar_top(0.1, 0.08, partition);
	glPopMatrix();
	blue_corner.EndList();


	rope1.Generate();
	rope1.NewList();
	rope_color[0].Set();
	for (i = 1; i < 5; i++) {
		rope_color[i].SetDiffuse();
		glPushMatrix();
		glTranslatef(0.0, -2.7, 0.35 * i);
		glRotatef(90.0, 0.0, 1.0, 0.0);
		pillaro(-2.7, 2.7, 0.025, partition);
		glPopMatrix();
	}
	rope1.EndList();

	rope2.Generate();
	rope2.NewList();
	rope_color[0].Set();
	for (i = 1; i < 5; i++) {
		rope_color[i].SetDiffuse();
		glPushMatrix();
		glTranslatef(0.0, 2.7, 0.35 * i);
		glRotatef(90.0, 0.0, 1.0, 0.0);
		pillaro(-2.7, 2.7, 0.025, partition);
		glPopMatrix();
	}
	rope2.EndList();

	rope3.Generate();
	rope3.NewList();
	rope_color[0].Set();
	for (i = 1; i < 5; i++) {
		rope_color[i].SetDiffuse();
		glPushMatrix();
		glTranslatef(-2.7, 0.0, 0.35 * i);
		glRotatef(90.0, 1.0, 0.0, 0.0);
		pillaro(-2.7, 2.7, 0.025, partition);
		glPopMatrix();
	}
	rope3.EndList();

	rope4.Generate();
	rope4.NewList();
	rope_color[0].Set();
	for (i = 1; i < 5; i++) {
		rope_color[i].SetDiffuse();
		glPushMatrix();
		glTranslatef(2.7, 0.0, 0.35 * i);
		glRotatef(90.0, 1.0, 0.0, 0.0);
		pillaro(-2.7, 2.7, 0.025, partition);
		glPopMatrix();
	}
	rope4.EndList();
}

void GLRing::Show(float px, float py, float pz) {
	if (pz > 2.0) {
		ShowAll();
		return;
	}
	canvas.CallList();
	if (px > 2.2) {
		neutral_corner2.CallList();
		blue_corner.CallList();
		rope3.CallList();
		if (py > 2.2) {
			red_corner.CallList();
			rope1.CallList();
		} else if (py >= -2.2) {
			neutral_corner1.CallList();
			red_corner.CallList();
			rope1.CallList();
			rope2.CallList();
		} else {
			neutral_corner1.CallList();
			rope2.CallList();
		}
	} else if (px >= -2.2) {
		rope3.CallList();
		neutral_corner1.CallList();
		neutral_corner2.CallList();
		red_corner.CallList();
		blue_corner.CallList();
		rope4.CallList();	
		if (py > 2.2) {
			rope1.CallList();
		} else if (py >= -2.2) {
			rope1.CallList();
			rope2.CallList();
		} else {
			rope2.CallList();
		}	
	} else {
		neutral_corner1.CallList();
		red_corner.CallList();
		rope4.CallList();	
		if (py > 2.2) {
			neutral_corner2.CallList();
			rope1.CallList();
		} else if (py >= -2.2) {
			neutral_corner2.CallList();
			blue_corner.CallList();
			rope1.CallList();
			rope2.CallList();
		} else {
			blue_corner.CallList();
			rope2.CallList();
		}		
	}	
}

void GLRing::ShowWithRopes(float px, float py, float pz) {
	if (pz > 2.0) {
		ShowAll();
		return;
	}
	canvas.CallList();
	if (px > 2.2) {
		neutral_corner2.CallList();
		blue_corner.CallList();
		if (py > 2.2) {
			red_corner.CallList();
		} else if (py >= -2.2) {
			neutral_corner1.CallList();
			red_corner.CallList();
		} else {
			neutral_corner1.CallList();
		}
	} else if (px >= -2.2) {
			neutral_corner1.CallList();
			neutral_corner2.CallList();
			red_corner.CallList();
			blue_corner.CallList();
	} else {
		neutral_corner1.CallList();
		red_corner.CallList();
		if (py > 2.2) {
			neutral_corner2.CallList();
		} else if (py >= -2.2) {
			neutral_corner2.CallList();
			blue_corner.CallList();
		} else {
			blue_corner.CallList();
		}		
	}	
	rope1.CallList();
	rope2.CallList();
	rope3.CallList();
	rope4.CallList();
}

void GLRing::ShowAll() {
	canvas.CallList();
	neutral_corner1.CallList();
	neutral_corner2.CallList();
	blue_corner.CallList();
	red_corner.CallList();
	rope1.CallList();
	rope2.CallList();
	rope3.CallList();
	rope4.CallList();
}

