#ifndef GLRING_H
#define GLRING_H

#include "myglheader.h"
#include "glshapes.h"
#include "gldlist.h"
#include "glmaterial.h"
#include "glmatrix.h"
#include "gltexture.h"

class GLRing {
public:
	GLRing() : canvas(false), red_corner(false), blue_corner(false),
		neutral_corner1(false), neutral_corner2(false),
		rope1(false), rope2(false), rope3(false), rope4(false) {}
	~GLRing() {}

	void Show(float px, float py, float pz);
	void ShowWithRopes(float px, float py, float pz);
	void ShowAll();
	void Make(int ads_switch, GLTexture &canvas_tex, GLTexture &ads_tex, int partition = 36);
private:
	GLDList canvas, red_corner, blue_corner;
	GLDList neutral_corner1, neutral_corner2;
	GLDList rope1, rope2, rope3, rope4;
};

#endif /// GLRING_H
