#ifndef GLSANDBAG_H
#define GLSANDBAG_H

#include "myglheader.h"
#include "glshapes.h"
#include "gldlist.h"
#include "glmaterial.h"
#include "glmatrix.h"

class GLSandbag {
public:
	GLSandbag() : glsandbag(false) {}
	~GLSandbag() {}

	void Show();
	void ShowShadow();
	void ShowHit();
	void Make(int partition = 36);
	void Move();
	bool IsHit(float px, float py, float pz, float pr);
	void Hit(float px, float py, float damage);
	void CalcCoords();

private:
	GLDList glsandbag;
	GLMatrix matrix;
	float x, y, z;
	float x1, y1, z1;
	float x2, y2, z2;
	float a, b, g;	
	float da, db, dg;	
	float aa, ab, ag;
	int count;	
};

#endif // GLSANDBAG_H
