#ifndef GLSHAPES_H
#define GLSHAPES_H

#include <stdio.h>		
#include <math.h>
#include "myglheader.h"

/*@e萔 */
#define DPI  6.28318530717958647692
#define PI   3.14159265358979323846
#define PI2  1.57079632679489661923
#define PI4  0.785398163397448309616
#define RAD(X) (X * 0.01745329251994329547)
#define DEG(X) (X * 57.29577951308232286)

void fan_poly(GLdouble z1, GLdouble z2, GLdouble r1, GLdouble r2, GLdouble nz1, GLdouble nz2, GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLint p, GLint nn, GLint s, GLint e);
void elipse2_polywt(GLdouble z1, GLdouble z2, GLdouble r1, GLdouble r2, GLdouble nz1, GLdouble nz2, GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLint p, GLint nn, int q, int j);
void elipse2_poly_otherside(GLdouble z1, GLdouble z2, GLdouble r1, GLdouble r2, GLdouble nz1, GLdouble nz2, GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLint p, GLint nn);
void elipse2_poly_othersidewt(GLdouble z1, GLdouble z2, GLdouble r1, GLdouble r2, GLdouble nz1, GLdouble nz2, GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLint p, GLint nn, int q, int j);
void elipse2_poly(GLdouble z1, GLdouble z2, GLdouble r1, GLdouble r2, GLdouble nz1, GLdouble nz2, GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLint p, GLint nn);
void elipse_poly(GLdouble z1, GLdouble z2, GLdouble r1, GLdouble r2, GLdouble nz1, GLdouble nz2, GLdouble a, GLdouble b, GLint p, GLint nn);
void circle_poly(GLdouble z1, GLdouble z2, GLdouble r1, GLdouble r2, GLdouble nz1, GLdouble nz2, GLint p);
void circle_polyn(GLdouble z1, GLdouble z2, GLdouble r1, GLdouble r2, GLint p);

void elipse2(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c1, GLdouble c2, GLint q);
void elipse2wt(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c1, GLdouble c2, GLint q);
void elipse2c(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c1, GLdouble c2, int cs, int ce, GLint q);
void elipse(GLdouble a, GLdouble b, GLdouble c, GLint q);
void sphere(GLdouble r, GLint q);

void fan_elipse2(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c, GLint q, GLint s, GLint e);
void half_elipse2_otherside(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c, GLint q);
void half_elipse2_othersidewt(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c, GLint q);
void half_elipse2(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c, GLint q);
void half_elipse(GLdouble a, GLdouble b, GLdouble c, GLint q);
void half_sphere(GLdouble r, GLint q);

void corn2(GLdouble z1, GLdouble z2, GLdouble r1, GLdouble r2, GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLint q);
void corn2o(GLdouble z1, GLdouble z2, GLdouble r1, GLdouble r2, GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLint q);
void corn(GLdouble z1, GLdouble z2, GLdouble r1, GLdouble r2, GLint q);
void corno(GLdouble z1, GLdouble z2, GLdouble r1, GLdouble r2, GLint q);

void pillar2(GLdouble z1, GLdouble z2, GLdouble r, GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLint q);
void pillar(GLdouble z1, GLdouble z2, GLdouble r, GLint q);
void pillaro(GLdouble z1, GLdouble z2, GLdouble r, GLint q);
void pillar_top(GLdouble c, GLdouble r, GLint q);
void pillor_othersidewt(GLdouble z1, GLdouble z2, GLdouble r, GLint q);

void box(GLdouble x, GLdouble y, GLdouble z);
void box_canvas(GLdouble x, GLdouble y, GLdouble z);
void box_corner(GLdouble x, GLdouble y, GLdouble z, int number);

void camera();
void light();
void ring(int partition = 36);
void sandbag(int partition = 36);
void dome(int partition = 36);
void background(int partition = 36);

void normal_vector(
	float x1, float y1, float z1,
	float x2, float y2, float z2,
	float x3, float y3, float z3);
void triangles
	(float x1, float y1, float z1,
	float x2, float y2, float z2,
	float x3, float y3, float z3);
void triangle(
	float x1, float y1, float z1,
	float x2, float y2, float z2,
	float x3, float y3, float z3);
void square(
	float x1, float y1, float z1,
	float x2, float y2, float z2,
	float x3, float y3, float z3,
	float x4, float y4, float z4);
void oval(float a1, float a2, float b1, float b2);
void circle(float a, float b);
void rectangle(float x, float z);

void eye_ball(float a1, float a2, float b, float c, float t);
void eye(float a1, float a2, float b, float c, float t, int form);
void eyebrow(float a1, float a2, float b, float c, float r, float t, int form);
void nose(float a, float b, float c);
void nose2(float a, float b, float c);
void nose3(float a, float b, float c);
void nose4(float a, float b, float c);
void nose5(float a, float b, float c);
void mouth(float a, float b, float c, int form);
void ear(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c, GLint q);

void hairline(GLint q,  GLdouble ra, GLdouble hl, GLdouble hbb, GLdouble hbe, GLint is_back = 0);
void hair(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c1, GLdouble c2);
void hair_mohican(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c1, GLdouble c2);
void hair_perma(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c1, GLdouble c2);
void hair_oneline(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c1, GLdouble c2);
void hair_tree(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c1, GLdouble c2);
void hair_mushroom(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c1, GLdouble c2);
void hair_hedgehog(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c1, GLdouble c2);
void hair_sport(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c1, GLdouble c2);
void hair_regent(GLdouble a1, GLdouble a2, GLdouble b1, GLdouble b2, GLdouble c1, GLdouble c2);

bool IsHitSphere(float xp, float yp, float zp, float rp,
		float x1, float y1, float z1, float r1);

bool IsHitPillar(float xp, float yp, float zp, float rp,
	 	float x1, float y1, float z1,
 		float x2, float y2, float z2, float r);

#endif // GLSHAPES_H
