#ifndef GLTEXTURE_H
#define GLTEXTURE_H

#include "csdl.h"

class GLSurface {
public:
	GLSurface();
	~GLSurface();
	void Free();
	int Create(SDL_Surface* image);
	int Create(int x, int y);
	SDL_Surface* Get();
	void* Pixel();
	int Width();
	int Height();	
	void Set(SDL_Surface* set_surf);
	void Cls();
	int power_of_two(int input);
	bool WasCreate();
protected:
	SDL_Surface *surface;
};

class GLTexture {
public:
	GLTexture();
	~GLTexture();
	int Generate(SDL_Surface *surface, int mag_linear = 0, int min_linear = 0);
	void Bind();
	void Delete();
	int Width();
	int Height();	
	float WidthRatio();
	float HeightRatio();	
	bool WasGenerate();
private:
	GLuint texname;
	float w_ratio, h_ratio;	
	int w, h;
};

class GLTextures {
public:
	GLTextures();
	~GLTextures();
	int Init(int number);
	void Free();
	void Choice(int number);
	int Generate(SDL_Surface *surface);
	int Generate(int number, SDL_Surface *surface);
	int Width();
	int Width(int number);
	int Height();	
	int Height(int number);	
	float WidthRatio();
	float WidthRatio(int number);
	float HeightRatio();
	float HeightRatio(int number);
	void SetMagFilter(int filter) {mag_filter = filter;}
	void SetMinFilter(int filter) {min_filter = filter;}
	GLTexture& operator[](int number);
	bool WasInit();
private:
	GLTexture *textures;
	int mag_filter, min_filter;
	int mnumber;
	int cnumber;
};

#endif // GLTEXTURE_H
