#ifndef GLTTEXT_H
#define GLTTEXT_H

#include "csdl.h"

class STTF;
class GLDLists;

#include "symbol.h"
#include "gllight.h"
#include "glcamera.h"
#include "glmaterial.h"

#define YSSIZE 3.00
#define XSSIZE 4.00

/* 2oCgp̍őeNX` */
#define MAX_GLTEXTURES 255
/* eNX`ŏ̃R[h */
#define TCHAR_START 1
/* eNX`Ō̃R[h */
#define TCHAR_END  126

//#define USE_GFX_FONT

class GLTText {
public:
	GLTText();
	~GLTText();
	int Init(STTF *ttf_in);
	void Char(char c);
	void CharD(char c);
	void Text(char *str);
	void TextPitch(char *str, float pitch);
	void TextSingle(char *str);
	void Symbol(char symbol, float size = 0.5, int xpos = 0, int ypos = 0);
	void Print(char *str, float size = 0.5, int xpos = 0, int ypos = 0);
	void LongPrint(char *str, float size = 0.5, int xpos = 80, int ypos = 80);

	void TextVertical(char *str);
	void PrintVertical(char *str, float size = 0.5, int xpos = 0, int ypos = 0);

	void ShadowOn() {with_shadow = true;}
	void ShadowOff() {with_shadow = false;}
	void Message(char *str, float size = 0.5, int xpos = 0, int ypos = 0);
	void LongMessage(char *str, float size = 0.5, int xpos = 80, int ypos = 80);
	void Pause(char *str, float size = 0.5, int xpos = 0, int ypos = 0);
	int Render(char ccode, SDL_Surface *surface);
	void MakeTexture(int number, SDL_Surface *render);
  	void CallTexture(int number);
  	void CallTextureD(int number);

	void Char2(char *str);
	void Char2D(char *str);
	void MakeText(char *str);
	void MakeChar2(char *str);

	void SetColor(float r, float g, float b) {color.Diffuse(r, g, b);}
	void SetAlpha(float a) {color.Diffuse(NO_CHANGE, NO_CHANGE, NO_CHANGE, a);}
//	void SetSpecular(float r, float g, float b){}
//	void SetShininess(float p) {}
	void SelectColor(bool is_true) {
		if (is_true) {
			SetColor(1.0, 0.0, 0.0);	
		} else {
			SetColor(1.0, 1.0, 1.0);	
		}	
	}

	void MessageEnter();
	void MessageLeave();
	void Clear();
	void ClearAlphabet();
	void MakeAlphabetFromTTF();
	void Close();
	bool WasInit();

private:
	STTF *ttf;
	GLTextures surface;
	GLTextures alphabet;
	RenderType save_rendertype;
	GLLight light_save, light;
	GLCamera camera;	
	GLMaterial color, color_save, shadow_color;
	char code2[MAX_GLTEXTURES][3];
	int mnumber;
	int cnumber;
	bool with_shadow;
	bool wasinit;
};

#endif //GLTTEXT_H
