#include "meters.h"

void CyanosisMeter::Make(int partition) {
	head.Generate();
	head.NewList();
	fan_elipse2(0.40, 0.40, 0.40, 0.60, 0.25, partition, 0, 18);	
	head.EndList();

	face.Generate();
	face.NewList();
	fan_elipse2(0.40, 0.40, 0.40, 0.60, 0.25, partition, 18, 36);	
	face.EndList();
}

void CyanosisMeter::ShowHead1() {
	glPushMatrix();
	glTranslatef( 3.0, 2.15, 0.0);
	glRotatef(180.0, 0.0, 1.0, 0.0);
	head.CallList();
	glPopMatrix();
}

void CyanosisMeter::ShowFace1() {
	glPushMatrix();
	glTranslatef( 3.0, 2.15, 0.0);
	glRotatef(180.0, 0.0, 1.0, 0.0);
	face.CallList();
	glPopMatrix();
}

void CyanosisMeter::ShowHead2() {
	glPushMatrix();
	glTranslatef(-3.0, 2.15, 0.0);
	glRotatef(180.0, 0.0, 1.0, 0.0);
	head.CallList();
	glPopMatrix();
}

void CyanosisMeter::ShowFace2() {
	glPushMatrix();
	glTranslatef(-3.0, 2.15, 0.0);
	glRotatef(180.0, 0.0, 1.0, 0.0);
	face.CallList();
	glPopMatrix();
}


void DamageMeter::Make(int partition) {
	gldamage.Generate();
	gldamage.NewList();
	pillaro(0.0, 1.0, 0.16, partition);	
	gldamage.EndList();
}

void DamageMeter::Show1First(float damage) {
	damage *= 0.005;
	glPushMatrix();
	glTranslatef( 3.70, -2.5, 0.0);
	glRotatef(90.0, 0.0, 1.0, 0.0);
	glRotatef(-90.0, 1.0, 0.0, 0.0);
	glScalef(1.0, 1.0, damage);
	gldamage.CallList();
	glPopMatrix();
	total_damage = damage;
}

void DamageMeter::Show1Next(float damage) {
	damage *= 0.005;
	glPushMatrix();
	glTranslatef( 3.70, -2.5 + total_damage, 0.0);
	glRotatef(90.0, 0.0, 1.0, 0.0);
	glRotatef(-90.0, 1.0, 0.0, 0.0);
	glScalef(1.0, 1.0, damage);
	gldamage.CallList();
	glPopMatrix();
	total_damage += damage;
}

void DamageMeter::Show2First(float damage) {
	damage *= 0.005;
	glPushMatrix();
	glTranslatef(-3.70, -2.5, 0.0);
	glRotatef(90.0, 0.0, 1.0, 0.0);
	glRotatef(-90.0, 1.0, 0.0, 0.0);
	glScalef(1.0, 1.0, damage);
	gldamage.CallList();
	glPopMatrix();
	total_damage = damage;
}

void DamageMeter::Show2Next(float damage) {
	damage *= 0.005;
	glPushMatrix();
	glTranslatef(-3.70, -2.5+total_damage, 0.0);
	glRotatef(90.0, 0.0, 1.0, 0.0);
	glRotatef(-90.0, 1.0, 0.0, 0.0);
	glScalef(1.0, 1.0, damage);
	gldamage.CallList();
	glPopMatrix();
	total_damage += damage;
}

void DistanceMeter::Make(int partition) {
	gldistance.Generate();
	gldistance.NewList();
	pillaro(-0.5, 0.5, 0.08, 36);	
	gldistance.EndList();
}

void DistanceMeter::Show(float distance) {
	glPushMatrix();
	glTranslatef(0.0, -2.9, 0.0);
	glRotatef(90.0, 0.0, 1.0, 0.0);
	glScalef(1.0, 1.0, distance);
	gldistance.CallList();
	glPopMatrix();
}
