#ifndef METERS_H
#define METERS_H

#include "myglheader.h"
#include "glshapes.h"
#include "gldlist.h"
#include "glmaterial.h"
#include "glmatrix.h"

class CyanosisMeter {
public:
	CyanosisMeter() : face(false), head(false){}
	~CyanosisMeter() {}

	void Make(int partition = 36);
	void ShowHead1();
	void ShowHead2();
	void ShowFace1();
	void ShowFace2();
private:
	GLDList face;
	GLDList head;
};

class DamageMeter {
public:
	DamageMeter() : gldamage(false) {}
	~DamageMeter() {}

	void Make(int partition = 36);
	void Show1First(float damage);
	void Show1Next(float damage);
	void Show2First(float damage);
	void Show2Next(float damage);
private:
	GLDList gldamage;
	float total_damage;
};


class DistanceMeter {
public:
	DistanceMeter() : gldistance(false) {}
	~DistanceMeter() {}

	void Make(int partition = 36);
	void Show(float distance);
private:
	GLDList gldistance;
};

#endif /// METERS_H
