#include "mscreen.h"

// RXgN`[
MScreen::MScreen() {
	ms_surface = NULL;
}

// fXgN`[
MScreen::~MScreen() {
}

// rfI[h̐ݒ
int MScreen::SetVideoMode(int width, int height, int bpp, Uint32 flags) {
	if (svideo.WasInit()) {
		if (WasSet()) {
			Reset();
		}

#ifdef HAVE_OPENGL // OpenGL̐ݒ
		if (flags & SDL_OPENGL) {
			if(SetOpenGL(bpp) == SDL_FAILURE) {
				emes("MScreen::SetVideoMode -> Cant' set up OpenGL.");	 		
			} else {
				smes("MScreen::SetVideoMode -> Set Up OpenGL");	 				
			} 
		}
#endif

		if (SDL_VideoModeOK(width, height, bpp, flags)) {
			ms_surface = SDL_SetVideoMode(width, height, bpp, flags);
		} else {
			width = 640;
			height = 480;
			ms_surface = SDL_SetVideoMode(width, height, bpp, flags);

			wmes("MScreen::SetVideoMode -> Can't select this resolution.");		
		}
		if (ms_surface == NULL) {
			emes("MScreen::SetVideoMode -> Can't set up main screen.");
			rmes();	
			return SDL_FAILURE;		
		} else {
			smes("MScreen::SetVideoMode -> Set Up Main Screen");	
		}
	} else {
		emes("MScreen::SetVideoMode -> Video isn't initialized.");	
		return SDL_FAILURE;
	}
/* SDL̃oO(?)̂߃EBhE𒆉ɂ̂ɕKv
(̂Ƃ) */
#if defined(__BORLANDC__) || defined(__VISUALC__) 
	if (!(flags & SDL_FULLSCREEN)) {
		SDL_SysWMinfo info;
		SDL_VERSION(&info.version);
		if (SDL_VERSIONNUM(SDL_Linked_Version()->major, SDL_Linked_Version()->minor, SDL_Linked_Version()->patch) >= SDL_VERSIONNUM(1, 2, 7)) {
	 		SDL_GetWMInfo(&info);
			SetWindowPos(info.window, NULL, (GetSystemMetrics(SM_CXFULLSCREEN) - width)/2, (GetSystemMetrics(SM_CYFULLSCREEN) - height)/2, 0, 0, SWP_NOZORDER | SWP_NOSIZE);     
		} 
    } 
#endif

#ifdef HAVE_OPENGL // OpenGL̃`FbNƐݒ
	if (flags & SDL_OPENGL) {
		if(CheckOpenGL(bpp) == SDL_FAILURE) {
			PrintGLInfo();	
			emes("MScreen::SetVideoMode -> Check OpenGL is failed.");
		} else {
			smes("MScreen::SetVideoMode -> Check OpenGL");	 				
		}
		GLInit();
		GLSetPerspective(width, height);
	}
#endif

	return SDL_SUCCESS;
}


// EBhE}l[W[֘A
void MScreen::SetCaption(const char *title, const char *icon) {
	SDL_WM_SetCaption(title, icon);
}

void MScreen::GetCaption(char **title, char **icon) {
	if (ms_surface == NULL) {
		emes("MScreen::GetCaption");	
	} else {
	    SDL_WM_GetCaption(title, icon);
	}
}

void MScreen::SetIcon(SDL_Surface *icon, Uint8 *mask) {
	SDL_WM_SetIcon(icon, mask);
}

int	MScreen::IconifyWindow() {
	if (ms_surface == NULL) {
		emes("MScreen::IconifyWindow -> Main screein isn't set.");	
		return SDL_FAILURE;
	} else if (SDL_WM_IconifyWindow() == SDL_FAILURE) {
		emes("MScreen::IconifyWindow -> Can't iconify.");
		rmes();
		return SDL_FAILURE;
	}

	return SDL_SUCCESS;
}
    
int	MScreen::ToggleFullScreen() {
	if (ms_surface == NULL) {
		emes("MScreen::ToggleFullScreen -> Main screen isn't set.");	
		return SDL_FAILURE;
	} else if (SDL_WM_ToggleFullScreen(ms_surface) == SDL_FAILURE) {
		emes("MScreen::ToggleFullScreen -> Can't change full screen.");
		rmes();
		return SDL_FAILURE;
	}

	return SDL_SUCCESS;
}

SDL_GrabMode MScreen::GrabInput(SDL_GrabMode mode) {
	return SDL_WM_GrabInput(mode);
}

void MScreen::Cls() {
	SDL_FillRect(ms_surface, NULL, SDL_MapRGBA(ms_surface->format, 0, 0, 0, 0));
}

int MScreen::BlitSurface(SDL_Surface *surface, int x, int y) {
	SDL_Rect dst;
	dst.x = x;
	dst.y = y;
	dst.w = surface->w;
	dst.h = surface->h;
	return SDL_BlitSurface(surface, NULL, ms_surface, &dst);
}

void MScreen::Update() {
	SDL_UpdateRect(ms_surface, 0, 0, 0, 0);
}

void MScreen::Reset() {
	svideo.Quit();
	svideo.Init();
	ms_surface = NULL;	
} 

void MScreen::Destroy() {
	svideo.Quit();
	ms_surface = NULL;	
} 

bool MScreen::WasSet() {
	if (ms_surface == NULL) {
		return false;		
	}
	return true;	
}

void MScreen::PrintScreenInfo() {
	fprintf(stdout, "Screen BPP  : %d\n", SDL_GetVideoSurface()->format->BitsPerPixel);
	fprintf(stdout, "Screen Size : %dx%d\n", SDL_GetVideoSurface()->w, SDL_GetVideoSurface()->h);
	if (SDL_GetVideoSurface()->flags & SDL_FULLSCREEN) {
		fprintf(stdout, "Screen Mode : Full Screen\n");
    } else {
		fprintf(stdout, "Screen Mode : Window\n");		
	}
}

// OpenGLp
#ifdef HAVE_OPENGL
int MScreen::SetOpenGL(int bpp) {
	switch (bpp) {
		case 8:
			emes("MScreen::SetOpenGL -> This program can't work on 8 bit mode.");	 		
			return SDL_FAILURE;		
		break; 

		case 16:
		case 24:
			if (SDL_GL_SetAttribute(SDL_GL_RED_SIZE,  REQUIRED16_RED_SIZE) == SDL_FAILURE) {
				emes("MScreen::SetOpenGL -> Set SDL_GL_RED_SIZE is failred.");	 		
				rmes();
				return SDL_FAILURE;
			}
	
			if (SDL_GL_SetAttribute(SDL_GL_GREEN_SIZE, REQUIRED16_GREEN_SIZE) == SDL_FAILURE) {
				emes("MScreen::SetOpenGL -> Set SDL_GL_GREEN_SIZE is failred.");	 		
				rmes();
				return SDL_FAILURE;
			}
	
			if (SDL_GL_SetAttribute(SDL_GL_BLUE_SIZE, REQUIRED16_BLUE_SIZE) == SDL_FAILURE) {
				emes("MScreen::SetOpenGL -> Set SDL_GL_BLUE_SIZE is failred.");	 		
				rmes();
				return SDL_FAILURE;
			}

			if (SDL_GL_SetAttribute(SDL_GL_ALPHA_SIZE, REQUIRED16_ALPHA_SIZE) == SDL_FAILURE) {
				emes("MScreen::SetOpenGL -> Set SDL_GL_ALPHA_SIZE is failred.");	 		
				rmes();
				return SDL_FAILURE;
			}
		break;

		default:
			if (SDL_GL_SetAttribute(SDL_GL_RED_SIZE,  REQUIRED32_RED_SIZE) == SDL_FAILURE) {
				emes("MScreen::SetOpenGL -> Set SDL_GL_RED_SIZE is failred.");	 		
				rmes();
				return SDL_FAILURE;
			}
	
			if (SDL_GL_SetAttribute(SDL_GL_GREEN_SIZE, REQUIRED32_GREEN_SIZE) == SDL_FAILURE) {
				emes("MScreen::SetOpenGL -> Set SDL_GL_GREEN_SIZE is failred.");	 		
				rmes();
				return SDL_FAILURE;
			}
	
			if (SDL_GL_SetAttribute(SDL_GL_BLUE_SIZE, REQUIRED32_BLUE_SIZE) == SDL_FAILURE) {
				emes("MScreen::SetOpenGL -> Set SDL_GL_BLUE_SIZE is failred.");	 		
				rmes();
				return SDL_FAILURE;
			}

			if (SDL_GL_SetAttribute(SDL_GL_ALPHA_SIZE, REQUIRED32_ALPHA_SIZE) == SDL_FAILURE) {
				emes("MScreen::SetOpenGL -> Set SDL_GL_ALPHA_SIZE is failred.");	 		
				rmes();
				return SDL_FAILURE;
			}
		break;
	}


	if (SDL_GL_SetAttribute(SDL_GL_DEPTH_SIZE, REQUIRED_DEPTH_SIZE) == SDL_FAILURE) {
		emes("MScreen::SetOpenGL -> Set SDL_GL_DEPTH_SIZE is failred.");	 		
		rmes();
		return SDL_FAILURE;
	}

	if (SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, REQUIRED_DOUBLEBUFFER) == SDL_FAILURE) {
		emes("MScreen::SetOpenGL -> Set SDL_GL_BOUBLEBUFFER is failred.");	 		
		rmes();
		return SDL_FAILURE;
	}       
	return SDL_SUCCESS;
}

int MScreen::CheckOpenGL(int bpp) {
	int value;

	switch (bpp) {
		case 8:
			emes("MScreen::CheckOpenGL -> This program can't work on 8 bit mode.");	 		
			return SDL_FAILURE;		
		break; 

		case 16:
		case 24:
			if (SDL_GL_GetAttribute(SDL_GL_RED_SIZE, &value) == SDL_FAILURE) {
				emes("MScreen::CheckOpenGL -> Check SDL_GL_RED_SIZE is failed.");
				rmes();	 		
				return SDL_FAILURE;
			} else if (value !=  REQUIRED16_RED_SIZE) {
				wmes("MScreen::CheckOpenGL -> Check SDL_GL_RED_SIZE is different.");	 				
				wmes2(REQUIRED16_RED_SIZE, value);	 				
			}

			if (SDL_GL_GetAttribute(SDL_GL_GREEN_SIZE, &value) == SDL_FAILURE) {
				emes("MScreen::CheckOpenGL -> Check SDL_GL_GREEN_SIZE is failed.");
				rmes();	 		
				return SDL_FAILURE;
			} else if (value != REQUIRED16_GREEN_SIZE) {
				wmes("MScreen::CheckOpenGL -> Check SDL_GL_GREEDN_SIZE is different.");	 				
				wmes2(REQUIRED16_GREEN_SIZE, value);	 				
			}
	
			if (SDL_GL_GetAttribute(SDL_GL_BLUE_SIZE, &value) == SDL_FAILURE) {
				emes("MScreen::CheckOpenGL -> Check SDL_GL_BLUE_SIZE is failed.");	 		
				rmes();
				return SDL_FAILURE;
			} else if (value != REQUIRED16_BLUE_SIZE) {
				wmes("MScreen::CheckOpenGL -> Check SDL_GL_BLUE_SIZE is different.");	 				
				wmes2(REQUIRED16_BLUE_SIZE, value);	 				
			}

			if (SDL_GL_GetAttribute(SDL_GL_ALPHA_SIZE, &value) == SDL_FAILURE) {
				emes("MScreen::CheckOpenGL -> Check SDL_GL_ALPHA_SIZE is failed.");
				rmes();	 		
				return SDL_FAILURE;
			} else if (value != REQUIRED16_ALPHA_SIZE) {
				wmes("MScreen::CheckOpenGL -> Check SDL_GL_ALPHA_SIZE is different.");	 				
				wmes2(REQUIRED16_ALPHA_SIZE, value);	 				
			}
		break;

		default:
			if (SDL_GL_GetAttribute(SDL_GL_RED_SIZE, &value) == SDL_FAILURE) {
				emes("MScreen::CheckOpenGL -> Check SDL_GL_RED_SIZE is failed.");
				rmes();	 		
				return SDL_FAILURE;
			} else if (value !=  REQUIRED32_RED_SIZE) {
				wmes("MScreen::CheckOpenGL -> Check SDL_GL_RED_SIZE is different.");	 				
				wmes2(REQUIRED32_RED_SIZE, value);	 				
			}

			if (SDL_GL_GetAttribute(SDL_GL_GREEN_SIZE, &value) == SDL_FAILURE) {
				emes("MScreen::CheckOpenGL -> Check SDL_GL_GREEN_SIZE is failed.");
				rmes();	 		
				return SDL_FAILURE;
			} else if (value != REQUIRED32_GREEN_SIZE) {
				wmes("MScreen::CheckOpenGL -> Check SDL_GL_GREEN_SIZE is different.");	 				
				wmes2(REQUIRED32_GREEN_SIZE, value);	 				
			}
	
			if (SDL_GL_GetAttribute(SDL_GL_BLUE_SIZE, &value) == SDL_FAILURE) {
				emes("MScreen::CheckOpenGL -> Check SDL_GL_BLUE_SIZE is failed.");	 		
				rmes();
				return SDL_FAILURE;
			} else if (value != REQUIRED32_BLUE_SIZE) {
				wmes("MScreen::CheckOpenGL -> Check SDL_GL_BLUE_SIZE is different.");	 				
				wmes2(REQUIRED32_BLUE_SIZE, value);	 				
			}

			if (SDL_GL_GetAttribute(SDL_GL_ALPHA_SIZE, &value) == SDL_FAILURE) {
				emes("MScreen::CheckOpenGL -> Check SDL_GL_ALPHA_SIZE is failed.");
				rmes();	 		
				return SDL_FAILURE;
			} else if (value != REQUIRED32_ALPHA_SIZE) {
				wmes("MScreen::CheckOpenGL -> Check SDL_GL_ALPHA_SIZE is different.");	 				
				wmes2(REQUIRED32_ALPHA_SIZE, value);	 				
			}
		break;
	}

	if (SDL_GL_GetAttribute(SDL_GL_DEPTH_SIZE, &value) == SDL_FAILURE) {
		emes("MScreen::CheckOpenGL -> Check SDL_GL_DEPTH_SIZE is failed.");
		rmes();	 		
		return SDL_FAILURE;
	} else if (value < REQUIRED_DEPTH_SIZE) {
		wmes("MScreen::CheckOpenGL -> Check SDL_GL_DEPTH_SIZE is different.");	 				
		wmes2(REQUIRED_DEPTH_SIZE, value);	 				
	}

	if (SDL_GL_GetAttribute(SDL_GL_DOUBLEBUFFER, &value)== SDL_FAILURE) {
		emes("MScreen::CheckOpenGL -> Check SDL_GL_DOUBLEBUFFER is failed.");	 		
		rmes();
		return SDL_FAILURE;
	} else if (value != 1) {
		wmes("MScreen::CheckOpenGL -> Can't use SDL_GL_DOUBLEBUFFER.");	 				
	}
	
	return SDL_SUCCESS;
}

void MScreen::PrintGLInfo() {
	fprintf(stdout, "GL Vendor   : %s\n", glGetString(GL_VENDOR));
	fprintf(stdout, "GL Renderer : %s\n", glGetString(GL_RENDERER));
	fprintf(stdout, "GL Version  : %s\n", glGetString(GL_VERSION));
//	fprintf(stdout, "Extensions : %s\n", glGetString(GL_EXTENSIONS));
}

void MScreen::GLInit() {
	glEnable(GL_DEPTH_TEST);

	glCullFace(GL_BACK);
    glFrontFace(GL_CCW);
    glEnable(GL_CULL_FACE);
	
    glEnable(GL_LIGHTING);
	glEnable(GL_NORMALIZE);
	glShadeModel(GL_SMOOTH);

	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
    glClearColor(0, 0, 0, 0);

	GLmes();	
}

void MScreen::GLSetPerspective(int width, int height) {
	float ratio = 1.0;

	if (height > 0) {
		glViewport(0, 0, width, height);
		ratio = (float) width / (float) height;
	}
 
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
	gluPerspective(60.0, ratio, 0.05, 20.0);
	
	GLmes();
}

void MScreen::GLEnter2D() {
	SDL_Surface *screen = SDL_GetVideoSurface();

	/* Note, there may be other things you need to change,
	   depending on how you have your OpenGL state set up.
	*/
	glPushAttrib(GL_ENABLE_BIT);
	glDisable(GL_DEPTH_TEST);
	glDisable(GL_CULL_FACE);
	glEnable(GL_TEXTURE_2D);

	/* This allows alpha blending of 2D textures with the scene */
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	glViewport(0, 0, screen->w, screen->h);

	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();

	glOrtho(0.0, (GLdouble)screen->w, (GLdouble)screen->h, 0.0, 0.0, 1.0);

	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();

//	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	GLfloat color[] = {1.0, 1.0, 1.0, 1.0};
	glTexEnvfv(GL_TEXTURE_ENV, GL_TEXTURE_ENV_COLOR, color);
}

void MScreen::GLLeave2D() {
	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();

	glMatrixMode(GL_PROJECTION);
	glPopMatrix();

	glPopAttrib();
}

#endif

