#ifndef MSCREEN_H
#define MSCREEN_H

#include "csdl.h"
#include <SDL_syswm.h>

class MScreen {
public:
	MScreen();
	~MScreen();
	int SetVideoMode(int width, int height, int bpp, Uint32 flags);
	void SetCaption(const char *title, const char *icon);
	void GetCaption(char **title, char **icon);
	void SetIcon(SDL_Surface *icon, Uint8 *mask);
	int IconifyWindow();
	int	ToggleFullScreen();
	SDL_GrabMode GrabInput(SDL_GrabMode mode);

	int BlitSurface(SDL_Surface *surface, int x, int y);
	void Update();
	void Cls();
	void PrintScreenInfo();

	void Reset();
	void Destroy();
	bool WasSet();

#ifdef HAVE_OPENGL
	int SetOpenGL(int bpp);
	int CheckOpenGL(int bpp);
	void PrintGLInfo();
	void GLInit();
	void GLSetPerspective(int width, int height);
	void GLEnter2D();
	void GLLeave2D();
#endif

private:
	SDL_Surface *ms_surface;
 	SVideo svideo;
};

#endif // MSCREEN_H

