#include "random.h"

/***********************************************************
 F搶́wbɂŐVASYTx]p
	http://oku.edu.mie-u.ac.jp/~okumura/algo/
	normal.c -- Kz
***********************************************************/

#define PI  3.14159265358979323846264

double p_nor(double z) { /* Kz̉m */
	int i;
	double z2, prev, p, t;

	z2 = z * z;
	t = p = z * exp(-0.5 * z2) / sqrt(2 * PI);
	for (i = 3; i < 200; i += 2) {
		prev = p;  t *= z2 / i;  p += t;
		if (p == prev) return 0.5 + p;
	}
	return (z > 0);
}

double q_nor(double z) { /* Kz̏㑤m */
	return 1 - p_nor(z);
}
/*------------------- ܂ -------------------*/ 

Random::Random() {
	seed = (unsigned int)time(NULL);
	srand(seed);
}

int Random::Rand(int min_value, int max_value) const {
	return rand() % (max_value - min_value + 1) + min_value;
}	

int Random::RandN(int value, float omega) {
	int i;
	float f;

	f = RandF();
	if (f > p_nor(omega * (double)(value+1)/(double)value)) {
		return Rand(1, value);	
	}   
	for (i = value; i > 0; i--) {
//		fprintf(stderr, "i = %d %f %f\n", i ,f, p_nor(2.0 * (double)i/(double)value));
		if (f <= p_nor(omega * (double)(i+1)/(double)value) &&
			f >  p_nor(omega * (double)i/(double)value)) {
			return i;		
		} 	
	}   
	return i;
}	

int  Random::RandSN(int value, float omega) {
	if (Rand() % 2) {
		return RandN(value, omega);
	} else {
		return -RandN(value, omega);	
	}

}

void Random::SetSeed(Uint32 cseed) {
	seed = cseed;
	srand(seed);	
}

void Random::Test1() {
	int i;
	int sum[50];
	for (i = 0; i < 50; i++) {
		sum[i]=0;	
	}
	for (i = 0; i < 10000; i++) {
		sum[Rand(1, 7)]++;
	}	
	for (i = 0; i < 50; i++) {
		fprintf(stderr, "i = %d sun %f \n", i, sum[i]/100.0);		
	}
}

void Random::Test2() {
}
