#ifndef REPLAYINFO_H
#define REPLAYINFO_H

#include "motionhandler.h"

class Boxer;
class BoxerHandler;

class MotionInfo {
public:
	MotionInfo(){};
	~MotionInfo() {Free();}
	bool Init(MotionHandler &motion);
	void Free();	
	bool WasInit() {return hmotion.WasInit();}

	void GetInfo(MotionHandler &motion);
	void SetInfo(MotionHandler &motion);
	void SaveInfo(SDL_RWops *rwops);
	void LoadInfo(SDL_RWops *rwops);
private:
	int current_rhythm;
	HandleMotion hmotion;
};

class BoxerInfo {
public:
	void GetInfo(Boxer &Boxer);
	void SetInfo(Boxer &Boxer);
	void SaveInfo(SDL_RWops *rwops);
	void LoadInfo(SDL_RWops *rwops);
private:
	float x[24], y[24], z[24];
};

class HandlerInfo {
public:
	void GetInfo(BoxerHandler &handler);
	void SetInfo(BoxerHandler &handler);
	void SaveInfo(SDL_RWops *rwops);
	void LoadInfo(SDL_RWops *rwops);
private:
	float finfo[21];
	int iinfo[20];
};

class ReplayInfo {
public:
	ReplayInfo() {has_info = false;}
	~ReplayInfo() {Free();}
	bool Init(MotionHandler &motion);
	void Free();
	bool WasInit() {return minfo.WasInit();}

	bool HasInfo() const {return has_info;}
	void GetInfo(BoxerHandler &handler, Boxer &boxer, MotionHandler &motion);
	void SetInfo(BoxerHandler &handler, Boxer &boxer, MotionHandler &motion);
	void SaveInfo(SDL_RWops *rwops);
	void LoadInfo(SDL_RWops *rwops);
private:
	bool has_info;
	HandlerInfo hinfo;
	BoxerInfo binfo;
	MotionInfo minfo;
};

#endif // REPLAY_INFO_H
