#include "roundinfo.h"
#include "replayinfo.h"
#include "boxerhandler.h"
#include "motionhandler.h"
#include "matchhandler.h"

bool RoundInfo::Init(MatchHandler &match, MotionHandler &motion) {
	int i;
	if (WasInit()) {
		Free();		
	}
	max_save_key = (match.RoundTime() + 10*50);
	save_key = new Uint8[max_save_key];
	for (i = 0; i < max_save_key; i++) {
		save_key[i] = INVALID_KEY;
	}

	max_replay = (match.RoundTime() + 10*50)/match.ReplayRate();
	max_replay += 3;
	replay = new ReplayInfo[max_replay];	
	for (i = 0; i < max_replay; i++) {
		replay[i].Init(motion);
	}
	return WasInit();
}

void RoundInfo::Free() {
	if(WasInit()) {
		delete [] save_key;
		delete [] replay;
		save_key = NULL;
		replay = NULL;
	}	
}

bool RoundInfo::WasInit() {
	if (save_key == NULL) {
		return false;
	}	
	return true;
}

void RoundInfo::SaveInfo(SDL_RWops *rwops) {
	int i;
	SDL_RWwrite(rwops, &swing, sizeof(int), 1);
	SDL_RWwrite(rwops, &down, sizeof(int), 1);
	SDL_RWwrite(rwops, &hit, sizeof(int), 1);
	SDL_RWwrite(rwops, &critical, sizeof(int), 1);
	SDL_RWwrite(rwops, &round_damage, sizeof(int), 1);
	SDL_RWwrite(rwops, &score, sizeof(int), 1);
	SDL_RWwrite(rwops, judge, sizeof(int), 3);

	SDL_RWwrite(rwops, save_key, sizeof(Uint8), max_save_key);
	for (i = 0; i < max_replay; i++) {
		replay[i].SaveInfo(rwops);
	}
}

void RoundInfo::LoadInfo(SDL_RWops *rwops) {
	int i;
	SDL_RWread(rwops, &swing, sizeof(int), 1);
	SDL_RWread(rwops, &down, sizeof(int), 1);
	SDL_RWread(rwops, &hit, sizeof(int), 1);
	SDL_RWread(rwops, &critical, sizeof(int), 1);
	SDL_RWread(rwops, &round_damage, sizeof(int), 1);
	SDL_RWread(rwops, &score, sizeof(int), 1);
	SDL_RWread(rwops, judge, sizeof(int), 3);

	SDL_RWread(rwops, save_key, sizeof(Uint8), max_save_key);
	for (i = 0; i < max_replay; i++) {
		replay[i].LoadInfo(rwops);
	}
}
