#ifndef ROUNDINFO_H
#define ROUNDINFO_H

#include "csdl.h"

class MatchHandler;
class MotionHandler;
class ReplayInfo;

class RoundInfo {
public:
	RoundInfo() {
		save_key = NULL;	
		replay = NULL;
	}
	~RoundInfo() {
		Free();		
	}
	bool Init(MatchHandler &match, MotionHandler &motion);
	void SaveInfo(SDL_RWops *rwops);
	void LoadInfo(SDL_RWops *rwops);
	void Free();
	bool WasInit();
private:
	
	int swing;
	int down;
	int hit;
	int critical;
	int round_damage;
	int score;
	int judge[3];
	Uint8 *save_key;
	ReplayInfo *replay;
	int max_replay;
	int max_save_key;
	friend class BoxerHandler;
};

#endif // ROUNDINFO_H
