#ifndef SMIXER_H
#define SMIXER_H

#include "csdl.h"
#include <SDL_mixer.h>

class MMusic {
public:
	MMusic();
	~MMusic();
	int Load(const char * file);
	void Free();
	void Play();
	void Stop();
	bool WasLoad();
private:
	Mix_Music *music;
};

class MMusics {
public:
	MMusics();
	~MMusics();
	int Init(int number);
	void Free();
	void Choice(int number);
	int Load(const char * file);
	void Play();
	void Stop();
	bool WasLoad();
	bool WasInit();
private:
	MMusic *musics;
	int mnumber;
	int cnumber;
};

/* Mix_Chunk */
class MChunk {
public:
	MChunk();
	~MChunk();
	int Load(const char * file);
	void Free();
	void Play();
	void Stop();
	bool WasLoad();
private:
	Mix_Chunk *chunk;
};

class MChunks {
public:
	MChunks();
	~MChunks();
	int Init(int number);
	void Free();
	void Choice(int number);
	int Load(const char * file);
	void Play();
	void Stop();
	bool WasLoad();
	bool WasInit();
private:
	MChunk *chunks;
	int mnumber;
	int cnumber;
};

/* ~LT[ */
class SMixer {
public:
	SMixer();
	~SMixer();
	int Open(int frequency, Uint16 format, int channels, int chunksize);
	void Close();
	int InitMusic(int number);
	int InitChunk(int number);
	int LoadMusic(int number, const char *file);
	int LoadChunk(int number, const char *file);
	int LoadMusic(const char *file);
	int LoadChunk(const char *file);
	void PlayMusic(int number);
	void PlayChunk(int number);
	void StopMusic();
	void StopChunk();
	void ChoiceMusic(int number);
	void ChoiceChunk(int number);
	void PlayMusic();
	void PlayChunk();
	int IsPlayingMusic() {return Mix_PlayingMusic();}
	void SetMusicVolume(int volume) {
		current_music_volume = volume;
		if (volume > 0) {
			Mix_VolumeMusic(volume);
		}
	}
	void SetChunkVolume(int volume) {
		current_chunk_volume = volume;
		if (volume > 0) {
			Mix_Volume(-1, volume);
		}
	}
	void GetCurrentVolume() {
		current_music_volume = Mix_VolumeMusic(-1);
		current_chunk_volume = Mix_Volume(-1, -1);
	}
	void PrintCurrentVolume() {
		fprintf(stdout, "Music Volume : %d\n", current_music_volume);
		fprintf(stdout, "Chunk Volume : %d\n", current_chunk_volume);
	}
	void SetCurrentVolume() {
		SetMusicVolume(current_music_volume);
		SetChunkVolume(current_chunk_volume);
	}
	bool MusicWasLoad();
	bool MusicWasLoad(int number);
	bool ChunkWasLoad();
	bool ChunkWasLoad(int number);
	bool WasOpen();
private:
	MMusics musics;
	MChunks chunks;
	bool was_open;
	SAudio saudio;
	int current_music_volume;
	int current_chunk_volume;
};    

#endif // SMIXER_H
