#include "ssurface.h"

/* T[tFCX */
SSurface::SSurface() {
	surface = NULL;	
}

SSurface::~SSurface() {
	Free();
}

int SSurface::Load(const char *file) {
	if (WasCreate()) {
		Free();
	}
	surface = IMG_Load(file);
	if (!WasCreate()) {
		emes("SSurface::Load");	
		efile(file);	
		return SDL_FAILURE;	
	}
	smes("SSurface::Load");	
	sfile(file);	
	return SDL_SUCCESS;
}

void SSurface::Free() {
	if (WasCreate()) {
		SDL_FreeSurface(surface);
		surface = NULL;
		smes("SSurface::Free");	
	} else {
		wmes("SSurface::Free");
	}
}

SDL_Surface* SSurface::Get() {
	return surface;
}

void SSurface::Set(SDL_Surface* set_surf) {
	surface = set_surf;
}

void SSurface::Cls() {
	SDL_FillRect(surface, NULL, SDL_MapRGBA(surface->format, 0, 0, 0, 0));
}

int SSurface::Blit(SDL_Surface* blit_surf, int x, int y) {
	SDL_Rect dst;
	dst.x = x;
	dst.y = y;
	dst.w = surface->w;
	dst.h = surface->h;
	SDL_SetAlpha(blit_surf, 0, 0);
	return SDL_BlitSurface(blit_surf, NULL, surface, &dst);
}

int SSurface::Blit(SSurface blit_surf, int x, int y) {
	return Blit(blit_surf.Get(), x, y);
}

bool SSurface::WasCreate() {
	if (surface == NULL) {
		return false;
	}
	return true;
}

/* T[tFCV[Y(`) */
SSurfaces::SSurfaces() {
	surfaces = NULL;
}

int SSurfaces::Init(int number) {
	if(WasInit()) {
		Free();
	}
	surfaces = new SSurface[number];
	cnumber = 0;
	mnumber = number;
	if(!WasInit()) {
		smes("SSurfaces::Init");
		return SDL_FAILURE;	
	}
	smes("SSurfaces::Init");
	return SDL_SUCCESS;
}

SSurfaces::~SSurfaces() {
	Free();
}

void SSurfaces::Free() {
	if (WasInit()) {
		delete [] surfaces;
		surfaces = NULL;
		smes("SSurfaces::Free");	
	} else {
		wmes("SSurfaces::Free");
	}
}

void SSurfaces::Choice(int number) {
	if (number >= 0 && number < mnumber) {
		cnumber = number;
	}
}

SDL_Surface* SSurfaces::Get(int number) {
	Choice(number);
	return Get();
}

SDL_Surface* SSurfaces::Get() {
	return surfaces[cnumber].Get();
}

void SSurfaces::Set(SDL_Surface* set_surf) {
	surfaces[cnumber].Set(set_surf);
}

void SSurfaces::Set(int number, SDL_Surface* set_surf) {
	Choice(number);
	Set(set_surf);
}

int SSurfaces::Load(const char * file) {
	if (WasInit()) {
		return surfaces[cnumber].Load(file);
	}
	return SDL_FAILURE;
}

int SSurfaces::Load(int number, const char * file) {
	Choice(number);
	return Load(file);
}

bool SSurfaces::WasCreate() {
	return surfaces[cnumber].WasCreate();
}

bool SSurfaces::WasCreate(int number) {
	Choice(number);
	return WasCreate();
}

void SSurfaces::operator[](int number) {
	Choice(number);
}

bool SSurfaces::WasInit() {
	if (surfaces == NULL) {
		return false;
	}
	return true;	
}

