#include "storyboxer.h"

StoryBoxer::StoryBoxer() {
}

void StoryBoxer::Init() {
	rank = OUT_OF_RANK;
	region_rank = OUT_OF_REGION;
	area = ASIA_OCEANIA;
	nation = JAPAN;
	
	nickname = 0;
	familyname = 0;

	body = 4;
 	reach = 4;
	is_southpaw = 0;
	motion = 1;
	combination = 1;
	think = 1;

	gloves_shoes = 1;
	trunks = 1;
	skin = 3;
	hair_color = 10;

	hair_style = 1;
	eyebrow = 1;
	eye = 1;
	nose = 1;
	mouth = 1;
	
//	age = 0;
	career = 0;
	match = 0;
	win = 0;
	loss = 0;
	draw = 0;
	ko = 0;
	traum = 0;	

	title = 0x0000;
	recent = 0x0000;
	state = 0;

//	punch = 0;
//	speed = 0;
//	stamina = 0;
	
//	damage_restore = 0;
//	max_damage = 0;
//	cyanosis_restore = 0;
//	max_cyanosis = 0;
	
//	block_absorb = 0;
//	body_strength = 0;
//	liver_strength = 0;
//	face_strength = 0;
//	jaw_strength = 0;
}

void StoryBoxer::CreateRandom(Random &random, int c_nation) {
	SetNation(c_nation);
	SetArea();
	
	nickname = random.Rand(1, 718 + 34);
	if (nation == JAPAN) {
		familyname = random.Rand(1, 128);
    } else {
		familyname = random.Rand(1, 450 + 29);	
	}

 	body = 4 + random.RandSN(3, 2.0);
 	reach = 4 + random.RandSN(3, 2.0);
	if (random.Rand(10) == 0) {
		is_southpaw = 1;
	} else {
		is_southpaw = 0;	
	}
	motion = random.Rand(1, 7);
	combination = random.Rand(1, 20);
	think = random.Rand(1, 3);
	if (think == 3) {
		think = random.Rand(3, 16);	
	}
	
	gloves_shoes = random.Rand(1, 8);
	trunks = random.Rand(1, 64);
	switch (area) {
		case ASIA_OCEANIA :
			skin = 3 + random.RandSN(7, 2.0);
			if (skin < 1) {
				skin += 10;			
			}
		break;	
		case AFRICA :
			skin = 10 - random.RandN(9, 2.0);		
		break;
		case EUROPE :
			skin = 1 + random.RandN(9, 2.0);
		break;
		case NORTH_AMERICA :
		case SOUTH_AMERICA :
		default :		
			skin = random.Rand(1, 10);
		break;	
	}

	switch (area) {
		case ASIA_OCEANIA :
			hair_color = 10 - random.RandN(9, 2.0);		
		break;
		default:		
			hair_color = random.Rand(1, 10);
		break;	
	}
	hair_style = 1 + random.RandN(9, 2.0);
	eyebrow = random.Rand(1, 25);
	eye = 1 + random.RandN(21, 2.0);
	nose = 1 + random.RandN(14, 2.0);
	mouth = random.Rand(1, 6);

	age = 17 + random.RandN(10, 2.0);
	career = 0;
	match = 0;
	win = 0;
	loss = 0;
	draw = 0;
	ko = 0;
	traum = 0;	
	state = 0;
	title = 0x0000;
	recent = 0x0000;

	punch = random.RandSN(50, 2.0);
	speed = random.RandSN(50, 2.0);
	stamina = random.RandSN(50, 2.0);
	
	damage_restore = random.RandSN(50, 2.0);
	max_damage = random.RandSN(50, 2.0);
	cyanosis_restore = random.RandSN(50, 2.0);
	max_cyanosis = random.RandSN(50, 2.0);
	
	block_absorb = random.RandSN(50, 2.0);
	body_strength = random.RandSN(50, 2.0);
	liver_strength = random.RandSN(50, 2.0);
	face_strength = random.RandSN(50, 2.0);
	jaw_strength = random.RandSN(50, 2.0);

	point = 700 + Total();
}

void StoryBoxer::SetDefaultFace() {
	hair_color = 10;
	hair_style = 1;
	eyebrow = 1;
	eye = 1;
	nose = 1;
	mouth = 1;
}

void StoryBoxer::Inherit(Random &random) {
	nickname = 0;
	familyname = 0;

	age = 17 + random.RandN(10, 2.0);
	career = 0;
	match = 0;
	win = 0;
	loss = 0;
	draw = 0;
	ko = 0;
	traum = 0;	
	state = 0;
	title = 0x0000;
	recent = 0x0000;

	punch = random.RandSN(50, 2.0);
	speed = random.RandSN(50, 2.0);
	stamina = random.RandSN(50, 2.0);
	
	damage_restore = random.RandSN(50, 2.0);
	max_damage = random.RandSN(50, 2.0);
	cyanosis_restore = random.RandSN(50, 2.0);
	max_cyanosis = random.RandSN(50, 2.0);
	
	block_absorb = random.RandSN(50, 2.0);
	body_strength = random.RandSN(50, 2.0);
	liver_strength = random.RandSN(50, 2.0);
	face_strength = random.RandSN(50, 2.0);
	jaw_strength = random.RandSN(50, 2.0);

	point = 700 + Total();
}

void StoryBoxer::SetNation(Uint8 c_nation) {
	nation = c_nation;
}

void StoryBoxer::SetArea() {
	switch (nation) {
		case JAPAN :
		case KOREA :
		case THAI :
		case PHILIPPINE :
		case AUSTRALIA :
		case ASIAN_COUNTRIES :
			area = ASIA_OCEANIA;
		break;
		case SOUTH_AFRICA :
		case NIGERIA :
		case KENYA :
		case GHANA :
		case CAMEROON :
		case AFRICAN_COUNTRIES :
			area = AFRICA;
		break;
		case UK :
		case FRANCE :
		case GERMANY :
		case ROSSIA :
		case ITALIA :
		case SPAIN :
		case EUROPEAN_COUNTRIES :
			area = EUROPE;
		break;
		case USA_EAST :
		case USA_WEST :
		case CANADA :
		case MEXICO :
		case PANAMA :
		case CUBA :
		case NA_COUNTRIES :
			area = NORTH_AMERICA;
		break;
		case VENEZUELA :
		case COLOMBIA :
		case BRAZIL :
		case ARGENTINA :
		case ECUADOR :
		case SA_COUNTRIES :
			area = SOUTH_AMERICA;
		break;
	}
}

int StoryBoxer::WinRate() {
	if (Match() > 0) {
		return Win() * 100 / Match();
	} else {
		return 0;	
	}
}

int StoryBoxer::KORate() {
	if (Win() > 0) {
		return KO() * 100 / Win();
	} else {
		return 0;	
	}
}

void StoryBoxer::SetData(int i) {
	switch(i) {
		case SORT_RANK : 
			data = Rank();
			return;
		break;
		case SORT_REGIONRANK : 
			data = RegionRank();
			return;
		break;
		case SORT_AGE : 
			data = -Age();
		break;
		case SORT_CAREER : 
			data = -Career();
		break;
		case SORT_MATCH : 
			data = -Match();
		break;
		case SORT_WIN : 
			data = -Win();
		break;
		case SORT_LOSS : 
			data = -Loss();
		break;
		case SORT_DRAW : 
			data = -Draw();
		break;
		case SORT_KO : 
			data = -KO();
		break;
		case SORT_KO_RATE : 
			data = -KORate();
		break;
		case SORT_WIN_RATE : 
			data = -WinRate();
		break;
		case SORT_TRAUM : 
			data = Traum();
		break;
		case SORT_HEIGHT : 
			data = Height();
		break;
		case SORT_REACH : 
			data = Reach();
		break;
		case SORT_STYLE : 
			data = Style();
		break;
		case SORT_STANCE : 
			data = Stance();
		break;
		case SORT_COMB : 
			data = Comb();
		break;
		case SORT_THOUGHT : 
			data = Thought();
		break;
		case SORT_GLOVES : 
			data = Gloves();
		break;
		case SORT_TRUNKS : 
			data = Trunks();
		break;
		case SORT_SKIN : 
			data = Skin();
		break;
		case SORT_NATION : 
			data = Nation();
		break;
		case SORT_AREA : 
			data = Area();
		break;
		case SORT_PUNCH : 
			data = -Punch();
		break;
		case SORT_SPEED : 
 			data = -Speed();
		break;
		case SORT_STAMINA : 
 			data = -Stamina();
		break;
		case SORT_DAMAGE_RESTORE : 
			data = -DamageRestore();
		break;
		case SORT_MAX_DAMAGE : 
 			data = -MaxDamage();
		break;
		case SORT_CYANOSIS_RESOTRE : 
		 	data = -CyanosisRestore();
		break;
		case SORT_MAX_CYANOSIS : 
 			data = -MaxCyanosis();
		break;
		case SORT_BLOCK_ABSORB : 
			data = -BlockAbsorb();
		break;
		case SORT_BODY_STRENGTH : 
 			data = -BodyStrength();
		break;
		case SORT_LIVER_STRENGTH : 
 			data = -LiverStrength();
		break;
		case SORT_FACE_STRENGTH : 
 			data = -FaceStrength();
		break;
		case SORT_JAW_STRENGTH : 
 			data = -JawStrength();
		break;
		case SORT_TOTAL :
			data = -Total();
		break;
		case SORT_POINT : 
			data = -point;
			return;
		break;
		default :
			data = Rank();
		break;
	}

	if (region_rank == OUT_OF_REGION) {
		data = OUT_OF_REGION;	
	}
}

void StoryBoxer::PowerUp(StoryBoxer &boxer) {
	if (CareerYear() > 10) {
		return;
	}

	if (boxer.punch > punch) {
		if (++punch > 50) {
			punch = 50;			
		} 		
	}
	if (boxer.speed > speed) {
		if (++speed > 50) {
			speed = 50;			
		} 		
	}
	if (boxer.stamina > stamina) {
		if (++stamina > 50) {
			stamina = 50;			
		} 		
	}

	if (boxer.damage_restore > damage_restore) {
		if (++damage_restore > 50) {
			damage_restore = 50;			
		} 		
	}
	if (boxer.max_damage > max_damage) {
		if (++max_damage > 50) {
			max_damage = 50;			
		} 		
	}

	if (boxer.cyanosis_restore > cyanosis_restore) {
		if (++cyanosis_restore > 50) {
			cyanosis_restore = 50;			
		} 		
	}
	if (boxer.max_cyanosis > max_cyanosis) {
		if (++max_cyanosis > 50) {
			max_cyanosis = 50;			
		} 		
	}

	if (boxer.block_absorb > block_absorb) {
		if (++block_absorb > 50) {
			block_absorb = 50;			
		} 		
	}
	if (boxer.body_strength > body_strength) {
		if (++body_strength > 50) {
			body_strength = 50;			
		} 		
	}
	if (boxer.liver_strength > liver_strength) {
		if (++liver_strength > 50) {
			liver_strength = 50;			
		} 		
	}
	if (boxer.face_strength > face_strength) {
		if (++face_strength > 50) {
			face_strength = 50;			
		} 		
	}
	if (boxer.jaw_strength > jaw_strength) {
		if (++jaw_strength > 50) {
			jaw_strength = 50;			
		} 		
	}
}

void StoryBoxer::PowerDown() {
	int down_rate;
	down_rate = (age - 30) / 2 + 1;

	punch -= down_rate;
	if (punch < -50) {
		punch = -50;			
	} 		
	speed -= down_rate;
	if (speed < -50) {
		speed = -50;			
	} 		
	stamina -= down_rate; 
	if (stamina < -50) {
		stamina = -50;			
	} 		
	damage_restore -= down_rate;
	if (damage_restore < -50) {
		damage_restore = -50;			
	} 		
	max_damage -= down_rate;
	if (max_damage < -50) {
		max_damage = -50;			
	} 		
	cyanosis_restore -= down_rate;
	if (cyanosis_restore < -50) {
		cyanosis_restore = -50;			
	} 		
	max_cyanosis -= down_rate;
	if (max_cyanosis < -50) {
		max_cyanosis = -50;			
	} 		
	block_absorb -= down_rate;
	if (block_absorb < -50) {
		block_absorb = -50;			
	} 		
	body_strength -= down_rate;
	if (body_strength < -50) {
		body_strength = -50;			
	} 		
	liver_strength -= down_rate;
	if (liver_strength < -50) {
		liver_strength = -50;			
	} 		
	face_strength -= down_rate;
	if (face_strength < -50) {
		face_strength = -50;			
	} 		
	jaw_strength -= down_rate;
	if (jaw_strength < -50) {
		jaw_strength = -50;			
	} 		
}

int StoryBoxer::WhichTitle() {
	if (HaveTitle(WORLD_TITLE)) {
		return WORLD;
	}
	if (HaveTitle(AREA_TITLE)) {
		return Area();
	}
	if (HaveTitle(NATION_TITLE)) {
		return Nation();
	}
	return OUT_OF_REGION;
}

int StoryBoxer::WhichTournament() {
	if (state >= RANKER_T0 && state <= RANKER_T15) {
		return RANKER;
	}
	return ROOKIE;
}

int StoryBoxer::DefeatSeries() {
	static int i, result;
	for (i = 0; i < 10; i++) {
		result = (int)(recent >> (3*i) & 0x0007);
		if (result != 5 && result != 6) {
			return i;		
		}
	}
	return 10; 
}

void StoryBoxer::HeightP() {
	body++;	
	if (body > 7) {
		body = 7;		
	}
}

void StoryBoxer::HeightM() {
	body--;	
	if (body < 1) {
		body = 1;		
	}
}


void StoryBoxer::ReachP() {
	reach++;	
	if (reach > 7) {
		reach = 7;		
	}
}

void StoryBoxer::ReachM() {
	reach--;	
	if (reach < 1) {
		reach = 1;		
	}
}

void StoryBoxer::StyleP() {
	motion++;	
	if (motion > 7) {
		motion = 1;		
	}
}

void StoryBoxer::StyleM() {
	motion--;	
	if (motion < 1) {
		motion = 7;		
	}
}

void StoryBoxer::StanceP() {
	if (!is_southpaw) {
		is_southpaw = 1;	
	}
}

void StoryBoxer::StanceM() {
	if (is_southpaw) {
		is_southpaw = 0;	
	}
}

void StoryBoxer::CombP() {
	combination++;	
	if (combination > 20) {
		combination = 1;		
	}
}

void StoryBoxer::CombM() {
	combination--;	
	if (combination < 1) {
		combination = 20;		
	}
}

void StoryBoxer::ThoughtP() {
	if (think == 1) {
		think = 2;	
	} else {
		think = 1;		
	}
}

void StoryBoxer::ThoughtM() {
	if (think == 2) {
		think = 1;	
	} else {
		think = 2;		
	}
}

void StoryBoxer::GlovesP() {
	gloves_shoes++;	
	if (gloves_shoes > 8) {
		gloves_shoes = 1;		
	}
}

void StoryBoxer::GlovesM() {
	gloves_shoes--;	
	if (gloves_shoes < 1) {
		gloves_shoes = 8;		
	}
}

void StoryBoxer::TrunksP() {
	trunks++;	
	if (trunks > 64) {
		trunks = 1;		
	}
}

void StoryBoxer::TrunksM() {
	trunks--;	
	if (trunks < 1) {
		trunks = 64;		
	}
}

void StoryBoxer::SkinP() {
	skin++;	
	if (skin > 10) {
		skin = 1;		
	}
}

void StoryBoxer::SkinM() {
	skin--;	
	if (skin < 1) {
		skin = 10;		
	}
}

void StoryBoxer::NationP() {
	nation++;	
	if (nation > 31) {
		nation = 0;		
	}
}

void StoryBoxer::NationM() {
	if (nation > 0) {
		nation--;	
	} else {
		nation = 31;			
	}
}

