#ifndef STTF_H
#define STTF_H

#include "csdl.h"
#include <SDL_ttf.h>

/* TTF */
class TTF {
public:
	TTF();
	~TTF();			
	int Open(const char *fontname, int fontsize);
	void SetStyle(int style);
	void Close();
	TTF_Font* Font();
	bool WasOpen();
private:
	TTF_Font* ttf;
};

class TTFs {
public:
	TTFs();
	~TTFs();
	int Init(int number);
	void Choice(int number);
	int Open(const char *fontname, int fontsize);
	void SetStyle(int style);
//	void SetRender(int rendertype);
//	void SetCode(int codetype);
	TTF_Font* Font();
	void Free();
	bool WasInit();
	SDL_Surface* RenderSolid(const char* text);
	SDL_Surface* RenderShaded(const char* text);
	SDL_Surface* RenderBlended(const char* text);
private:
	int mnumber;
	int cnumber;
	TTF *ttfs;
#ifdef USE_SJIS2UNI
	Uint16 buf[255];
#endif
};

typedef enum {
	RENDER_SOLID,
	RENDER_SHADED,
	RENDER_BLENDED
} RenderType;

class STTF {
public:
	STTF();
	~STTF();
	int Init();
	int Init(int number);
	void Quit();
	int Open(const char* text, int fontsize);
	int Open(int number, const char* text, int fontsize);
	void Choice(int number);
	void SetStyle(int style);
	void SetRender(RenderType setrendertype);
	SDL_Surface* Render(const char* text);
	SDL_Surface* Render(int number, const char* text);
	void operator[](int number);
	bool WasInit();	
	RenderType rendertype;
private:
	TTFs ttfs;
	bool wasinit;
};

#endif // STTF_H
